(function(define) {
define(function(require, exports, module) {
//the Ceylon language module
var $$METAMODEL$$={"ceylon.language.impl":{"rethrow":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Exception"},"$mt":"prm","$nm":"x"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Rethrows an exception without declaring it. This is used as a cheap replacement for\nUnsafe.throwException() in our Java Util class, used by the metamodel."],"by":["Stephane Epardaud"]},"$nm":"rethrow"}},"$mod-name":"ceylon.language","ceylon.language.meta.declaration":{"Import":{"satisfies":[{"$pk":"ceylon.language","$nm":"Identifiable"},{"$pk":"ceylon.language","$nm":"Annotated"}],"$mt":"ifc","$an":{"shared":[],"doc":["Model of an `import` declaration \nwithin a module declaration."]},"$at":{"shared":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if this imported module is shared."]},"$nm":"shared"},"container":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"Module"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The containing module."]},"$nm":"container"},"optional":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if this imported module is optional."]},"$nm":"optional"},"name":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The name of the imported module."]},"$nm":"name"},"version":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The compile-time version of the imported module."]},"$nm":"version"}},"$nm":"Import"},"Variance":{"of":[{"$pk":"ceylon.language.meta.declaration","$nm":"invariant"},{"$pk":"ceylon.language.meta.declaration","$nm":"covariant"},{"$pk":"ceylon.language.meta.declaration","$nm":"contravariant"}],"$mt":"ifc","$an":{"shared":[],"doc":["Variance information."]},"$nm":"Variance"},"AnnotatedDeclaration":{"of":[{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"Module"},{"$pk":"ceylon.language.meta.declaration","$nm":"Package"}],"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"Declaration"},{"$pk":"ceylon.language","$nm":"Annotated"}],"$mt":"ifc","$an":{"shared":[],"doc":["Declaration which can be annotated, such as:\n\n- [[NestableDeclaration]]\n- [[Module]]\n- [[Package]]\n\nYou can query annotations that are placed on a given annotated declaration with:\n\n"]},"$m":{"annotations":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Annotation"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Annotation"}],"variance":"out","$nm":"Annotation"}],"$an":{"shared":[],"formal":[],"doc":["The annotation instances of the given \nannotation type on this declaration.\n\nFor example, you can list all the [[See|ceylon.language::See]] \nannotations on [[List|ceylon.language::List]]\nwith the following code:\n\n    for(annot in `interface List`.annotations<See>()){\n        for(elems in annot.programElements){\n            print(\"See: ``elems``\");\n        }\n    }\n\nAlternatively, you can use the [[ceylon.language.meta::annotations]] \nfunction.\n"]},"$nm":"annotations"}},"$nm":"AnnotatedDeclaration"},"OpenTypeVariable":{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"OpenType"}],"$mt":"ifc","$an":{"shared":[],"doc":["An open type variable."]},"$at":{"declaration":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"TypeParameter"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This type variable's type parameter declaration."]},"$nm":"declaration"}},"$nm":"OpenTypeVariable"},"OpenIntersection":{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"OpenType"}],"$mt":"ifc","$an":{"shared":[],"doc":["An open intersection type."]},"$at":{"satisfiedTypes":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"OpenType"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This intersection's list of satisfied open types."]},"$nm":"satisfiedTypes"}},"$nm":"OpenIntersection"},"OpenType":{"of":[{"$pk":"ceylon.language.meta.declaration","$nm":"nothingType"},{"$pk":"ceylon.language.meta.declaration","$nm":"OpenClassOrInterfaceType"},{"$pk":"ceylon.language.meta.declaration","$nm":"OpenTypeVariable"},{"$pk":"ceylon.language.meta.declaration","$nm":"OpenUnion"},{"$pk":"ceylon.language.meta.declaration","$nm":"OpenIntersection"}],"$mt":"ifc","$an":{"shared":[],"doc":["An open type.\n\nAn open type is a type which may contain unbound type variables, such as `List<T>`."]},"$nm":"OpenType"},"SetterDeclaration":{"satisfies":[{"$pk":"ceylon.language","$nm":"Annotated"}],"$mt":"ifc","$an":{"shared":[],"doc":["A setter declaration for a variable `ValueDeclaration`."]},"$at":{"variable":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"ValueDeclaration"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The variable value this setter is for."]},"$nm":"variable"}},"$nm":"SetterDeclaration"},"InterfaceDeclaration":{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"ClassOrInterfaceDeclaration"}],"$mt":"ifc","$an":{"shared":[],"doc":["An interface declaration.\n\n<a name=\"toplevel-sample\"><\/a>\n### Usage sample for toplevel interfaces\n\nBecause some interfaces have type parameters, getting a model requires applying type arguments to the\ninterface declaration with [[interfaceApply]] in order to be able to get a closed type. For example, here is how you would\nobtain an interface model from a toplevel interface declaration:\n\n    interface Foo<T> satisfies List<T> {\n    }\n    \n    void test(){\n        \/\/ We need to apply the Integer closed type to the Foo declaration in order to get the Foo<Integer> closed type\n        Interface<Foo<Integer>> interfaceModel = `interface Foo`.interfaceApply<Foo<Integer>>(`Integer`);\n        \/\/ This will print: ceylon.language::List<ceylon.language::Integer>\n        for(satisfiedType in interfaceModel.satisfiedTypes){\n            print(satisfiedType);\n        }\n    }\n\n<a name=\"member-sample\"><\/a>\n### Usage sample for member interfaces\n\nFor member interfaces it is a bit longer, because member interfaces need to be applied not only their type arguments but also\nthe containing type, so you should use [[memberInterfaceApply]] and start by giving the containing closed type:\n\n    class Outer(){\n        shared interface Inner<T> satisfies List<T> {\n        }\n    }\n\n    void test(){\n        \/\/ apply the containing closed type `Outer` to the member class declaration `Outer.Inner`\n        MemberInterface<Outer,Outer.Inner<Integer>> memberInterfaceModel = `interface Outer.Inner`.memberInterfaceApply<Outer,Outer.Inner<Integer>>(`Outer`, `Integer`);\n        \/\/ This will print: ceylon.language::List<ceylon.language::Integer>\n        for(satisfiedType in memberInterfaceModel.satisfiedTypes){\n            print(satisfiedType);\n        }\n    }\n"]},"$m":{"interfaceApply":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"Interface"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"typeArguments"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Type"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed type argument values are not compatible with the actual result's type parameters."],"doc":["Applies the given closed type arguments to this toplevel interface declaration in order to obtain an interface model. \nSee [this code sample](#toplevel-sample) for an example on how to use this."]},"$nm":"interfaceApply"},"memberInterfaceApply":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"MemberInterface"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Container"}],"$pk":"ceylon.language.meta.model","$nm":"Type"},"$mt":"prm","$nm":"containerType"},{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"typeArguments"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language.meta.declaration","$nm":"Nothing"},"$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Type"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed container type or type argument values are not compatible with the actual result's container type or type parameters."],"doc":["Applies the given closed container type and type arguments to this member interface declaration in order to obtain a member interface model. \nSee [this code sample](#member-sample) for an example on how to use this."]},"$nm":"memberInterfaceApply"}},"$nm":"InterfaceDeclaration"},"Module":{"satisfies":[{"$pk":"ceylon.language","$nm":"Identifiable"},{"$pk":"ceylon.language.meta.declaration","$nm":"AnnotatedDeclaration"}],"$mt":"ifc","$an":{"shared":[],"doc":["A `module` declaration\nfrom a `module.ceylon` compilation unit"]},"$m":{"findImportedPackage":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language.meta.declaration","$nm":"Package"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Finds a package by name in this module or in its dependencies. Note that all transitive `shared`\ndependencies are searched. Returns `null` if not found."]},"$nm":"findImportedPackage"},"findPackage":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language.meta.declaration","$nm":"Package"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Finds a package by name. Returns `null` if not found."]},"$nm":"findPackage"}},"$at":{"dependencies":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"Import"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The modules this module depends on."]},"$nm":"dependencies"},"members":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"Package"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The package members of the module."]},"$nm":"members"},"version":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The module version."]},"$nm":"version"}},"$nm":"Module"},"TypeParameter":{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"Declaration"}],"$mt":"ifc","$an":{"shared":[],"doc":["A type parameter declaration."]},"$at":{"caseTypes":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"OpenType"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The `of` enumerated bounds for this type parameter."]},"$nm":"caseTypes"},"defaultTypeArgument":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language.meta.declaration","$nm":"OpenType"}]},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This type parameter's default type argument, if it has one."]},"$nm":"defaultTypeArgument"},"container":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The declaration that declared this type parameter. This is either a [[ClassOrInterfaceDeclaration]] or a\n[[FunctionDeclaration]]."]},"$nm":"container"},"variance":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"Variance"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This type parameter's variance, as defined by `in` or `out` keywords."]},"$nm":"variance"},"satisfiedTypes":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"OpenType"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The `satisfies` upper bounds for this type parameter."]},"$nm":"satisfiedTypes"},"defaulted":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if this type parameter has a default type argument and can be omitted."]},"$nm":"defaulted"}},"$nm":"TypeParameter"},"FunctionalDeclaration":{"$mt":"ifc","$an":{"shared":[],"doc":["Declaration which can be invoked, and may have parameters. Classes\nand functions are functional declarations.\n\nNote that multiple-parameter lists are not reified at runtime, so if you\nhave a function declaration like this:\n\n    Integer add(Integer a)(Integer b) => a + b;\n\nIt will only have a single parameter list at runtime (the first), and its return\ntype will be `Callable<Integer,[Integer]>`.\n"]},"$m":{"getParameterDeclaration":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language.meta.declaration","$nm":"FunctionOrValueDeclaration"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Gets a parameter declaration by name. Returns `null` if no such parameter exists."]},"$nm":"getParameterDeclaration"}},"$at":{"annotation":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if the current declaration is an annotation class or function."]},"$nm":"annotation"},"parameterDeclarations":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"FunctionOrValueDeclaration"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The list of parameter declarations for this functional declaration."]},"$nm":"parameterDeclarations"}},"$nm":"FunctionalDeclaration"},"$pkg-shared":"1","GenericDeclaration":{"$mt":"ifc","$an":{"shared":[],"doc":["A declaration that can have type parameters."]},"$m":{"getTypeParameterDeclaration":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language.meta.declaration","$nm":"TypeParameter"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Finds a type parameter by name. Returns `null` if not found."]},"$nm":"getTypeParameterDeclaration"}},"$at":{"typeParameterDeclarations":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"TypeParameter"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The list of type parameters declared on this generic declaration."]},"$nm":"typeParameterDeclarations"}},"$nm":"GenericDeclaration"},"invariant":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"Variance"}],"$mt":"obj","$an":{"shared":[],"doc":["Invariant means that neither subtype nor supertype can be accepted, the\ntype has to be exactly that which is declared."]},"$at":{"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"string"}},"$nm":"invariant"},"OpenInterfaceType":{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"OpenClassOrInterfaceType"}],"$mt":"ifc","$an":{"shared":[],"doc":["An open interface type."]},"$at":{"declaration":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"InterfaceDeclaration"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This declaration's package container."],"actual":[]},"$nm":"declaration"}},"$nm":"OpenInterfaceType"},"Package":{"satisfies":[{"$pk":"ceylon.language","$nm":"Identifiable"},{"$pk":"ceylon.language.meta.declaration","$nm":"AnnotatedDeclaration"}],"$mt":"ifc","$an":{"shared":[],"doc":["Model of a `package` declaration \nfrom a `package.ceylon` compilation unit"]},"$m":{"getValue":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language.meta.declaration","$nm":"ValueDeclaration"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["The value with the given name. Returns `null` if not found."]},"$nm":"getValue"},"getAlias":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language.meta.declaration","$nm":"AliasDeclaration"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["The type alias with the given name. Returns `null` if not found."]},"$nm":"getAlias"},"getMember":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Kind"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"}],"$nm":"Kind"}],"$an":{"shared":[],"formal":[],"doc":["Looks up a member declaration by name, provided it satisfies the given `Kind` type\nargument. Returns `null` if no such member matches."]},"$nm":"getMember"},"getFunction":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language.meta.declaration","$nm":"FunctionDeclaration"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["The function with the given name. Returns `null` if not found."]},"$nm":"getFunction"},"annotatedMembers":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Kind"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"}],"$nm":"Kind"},{"$nm":"Annotation"}],"$an":{"shared":[],"formal":[],"doc":["Returns the list of member declarations that satisfy the given `Kind` type argument and\nthat are annotated with the given `Annotation` type argument"]},"$nm":"annotatedMembers"},"getClassOrInterface":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language.meta.declaration","$nm":"ClassOrInterfaceDeclaration"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["The class or interface with the given name. Returns `null` if not found."]},"$nm":"getClassOrInterface"},"members":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Kind"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"}],"$nm":"Kind"}],"$an":{"shared":[],"formal":[],"doc":["Returns the list of member declarations that satisfy the given `Kind` type argument."]},"$nm":"members"}},"$at":{"shared":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if this package is shared."]},"$nm":"shared"},"container":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"Module"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The module this package belongs to."]},"$nm":"container"}},"$nm":"Package"},"OpenClassType":{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"OpenClassOrInterfaceType"}],"$mt":"ifc","$an":{"shared":[],"doc":["An open class type."]},"$at":{"declaration":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"ClassDeclaration"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This class declaration."],"actual":[]},"$nm":"declaration"}},"$nm":"OpenClassType"},"TypedDeclaration":{"$mt":"ifc","$an":{"shared":[],"doc":["Declaration which has an open type."]},"$at":{"openType":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"OpenType"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The open type for this declaration. For example, the open type for `List<T> f<T>()` is `List<T>`."]},"$nm":"openType"}},"$nm":"TypedDeclaration"},"OpenUnion":{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"OpenType"}],"$mt":"ifc","$an":{"shared":[],"doc":["An open union type."]},"$at":{"caseTypes":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"OpenType"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The list of case types for this open union type."]},"$nm":"caseTypes"}},"$nm":"OpenUnion"},"FunctionDeclaration":{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"FunctionOrValueDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"GenericDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"FunctionalDeclaration"}],"$mt":"ifc","$an":{"shared":[],"doc":["A function declaration.\n\n<a name=\"toplevel-sample\"><\/a>\n### Usage sample for toplevel function\n\nBecause some functions have type parameters, getting a model requires applying type arguments to the\nfunction declaration with [[apply]] in order to be able to invoke that function. For example, here is how you would\nobtain a function model that you can invoke from a toplevel function declaration:\n\n    String foo<T>(){\n        return \"Hello, our T is: ``typeLiteral<T>()``\";\n    }\n    \n    void test(){\n        \/\/ We need to apply the Integer closed type to the foo declaration in order to get the foo<Integer> function model\n        Function<String,[]> functionModel = `function foo`.apply<String,[]>(`Integer`);\n        \/\/ This will print: Hello, our T is: ceylon.language::Integer\n        print(functionModel());\n    }\n\n<a name=\"member-sample\"><\/a>\n### Usage sample for methods\n\nFor methods it is a bit longer, because methods need to be applied not only their type arguments but also\nthe containing type, so you should use [[memberApply]] and start by giving the containing closed type:\n\n    class Outer(){\n        shared String hello() => \"Hello\";\n    }\n\n    void test(){\n        \/\/ apply the containing closed type `Outer` to the method declaration `Outer.hello`\n        Method<Outer,String,[]> methodModel = `function Outer.hello`.memberApply<Outer,String,[]>(`Outer`);\n        \/\/ We now have a Method, which needs to be applied to a containing instance in order to become an\n        \/\/ invokable function:\n        Function<String,[]> boundMethodModel = methodModel(Outer());\n        \/\/ This will print: Hello\n        print(boundMethodModel());\n    }\n"]},"$m":{"apply":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Return"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"Function"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"typeArguments"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Return"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$def":{"$pk":"ceylon.language.meta.declaration","$nm":"Nothing"},"$nm":"Arguments"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed type argument values are not compatible with the actual result's type parameters."],"doc":["Applies the given closed type arguments to this function declaration in order to obtain a function model. \nSee [this code sample](#toplevel-sample) for an example on how to use this."]},"$nm":"apply"},"memberInvoke":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"container"},{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","$def":"1","$nm":"typeArguments"},{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"arguments"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"throws":["IncompatibleTypeException","If the specified container, type or value arguments are not compatible with this method."],"doc":["Invokes the underlying method, by applying the specified type arguments and value arguments."]},"$nm":"memberInvoke"},"invoke":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","$def":"1","$nm":"typeArguments"},{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"arguments"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"throws":["IncompatibleTypeException","If the specified type or value arguments are not compatible with this toplevel function."],"doc":["Invokes the underlying toplevel function, by applying the specified type arguments and value arguments."]},"$nm":"invoke"},"memberApply":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$nm":"Return"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"Method"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Container"}],"$pk":"ceylon.language.meta.model","$nm":"Type"},"$mt":"prm","$nm":"containerType"},{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"typeArguments"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language.meta.declaration","$nm":"Nothing"},"$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Return"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$def":{"$pk":"ceylon.language.meta.declaration","$nm":"Nothing"},"$nm":"Arguments"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed container type or type argument values are not compatible with the actual result's container type or type parameters."],"doc":["Applies the given closed container type and type arguments to this method declaration in order to obtain a method model. \nSee [this code sample](#member-sample) for an example on how to use this."]},"$nm":"memberApply"}},"$nm":"FunctionDeclaration"},"NestableDeclaration":{"of":[{"$pk":"ceylon.language.meta.declaration","$nm":"FunctionOrValueDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"ClassOrInterfaceDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"AliasDeclaration"}],"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"AnnotatedDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"TypedDeclaration"}],"$mt":"ifc","$an":{"shared":[],"doc":["A declaration which can be contained in a [[Package]] or in another [[NestableDeclaration]].\n\nFunctions, values, classes, interfaes and aliases are such declarations."]},"$at":{"shared":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if this declaration is annotated with [[shared|ceylon.language::shared]]."]},"$nm":"shared"},"containingModule":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"Module"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This declaration's module container."]},"$nm":"containingModule"},"toplevel":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if this declaration is a toplevel declaration."]},"$nm":"toplevel"},"formal":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if this declaration is annotated with [[formal|ceylon.language::formal]]."]},"$nm":"formal"},"default":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if this declaration is annotated with [[default|ceylon.language::default]]."]},"$nm":"default"},"container":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"Package"}]},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This declaration's immediate container, which can be either a [[NestableDeclaration]]\nor a [[Package]]."]},"$nm":"container"},"containingPackage":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"Package"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This declaration's package container."]},"$nm":"containingPackage"},"actual":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if this declaration is annotated with [[actual|ceylon.language::actual]]."]},"$nm":"actual"}},"$nm":"NestableDeclaration"},"Declaration":{"of":[{"$pk":"ceylon.language.meta.declaration","$nm":"AnnotatedDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"TypeParameter"}],"$mt":"ifc","$an":{"shared":[],"doc":["A declaration.\n\nThere are only two types of declarations:\n\n- [[AnnotatedDeclaration]]s such as modules, packages, classes or functions, and\n- [[TypeParameter]] declarations."]},"$at":{"qualifiedName":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The qualified name of this declaration. This includes the container qualified name. For\nexample, the [[Declaration]] class' qualified name is \"ceylon.language.meta.declaration::Declaration\"."]},"$nm":"qualifiedName"},"name":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The name of this declaration. For example, the [[Declaration]] class is named \"Declaration\"."]},"$nm":"name"}},"$nm":"Declaration"},"ClassOrInterfaceDeclaration":{"of":[{"$pk":"ceylon.language.meta.declaration","$nm":"ClassDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"InterfaceDeclaration"}],"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"GenericDeclaration"}],"$mt":"ifc","$an":{"shared":[],"doc":["A class or interface declaration.\n\n<a name=\"toplevel-sample\"><\/a>\n### Usage sample for toplevel classes\n\nBecause some classes have type parameters, getting a model requires applying type arguments to the\nclass declaration with [[apply]] in order to be able to instantiate that class. For example, here is how you would\nobtain a class or interface model that you can instantiate from a toplevel class declaration:\n\n    class Foo<T>() {\n        string => \"Hello, our T is: ``typeLiteral<T>()``\";\n    }\n    \n    void test(){\n        \/\/ We need to apply the Integer closed type to the Foo declaration in order to get the Foo<Integer> closed type\n        ClassOrInterface<Foo<Integer>> classOrInterfaceModel = `class Foo`.apply<Foo<Integer>>(`Integer`);\n        assert(is Class<Foo<Integer>,[]> classOrInterfaceModel);\n        \/\/ This will print: Hello, our T is: ceylon.language::Integer\n        print(classOrInterfaceModel());\n    }\n\nNote that there are more specialised versions of [[apply]] in [[ClassDeclaration.classApply]] and \n[[InterfaceDeclaration.interfaceApply]].\n\n<a name=\"member-sample\"><\/a>\n### Usage sample for member classes\n\nFor member classes or interfaces it is a bit longer, because member types need to be applied not only their type arguments but also\nthe containing type, so you should use [[memberApply]] and start by giving the containing closed type:\n\n    class Outer(){\n        shared class Inner(){\n            string => \"Hello\";\n        }\n    }\n\n    void test(){\n        \/\/ apply the containing closed type `Outer` to the member class declaration `Outer.Inner`\n        value memberClassModel = `class Outer.Inner`.memberApply<Outer,Outer.Inner>(`Outer`);\n        assert(is MemberClass<Outer,Outer.Inner,[]> memberClassModel);\n        \/\/ We now have a MemberClass, which needs to be applied to a containing instance in order to become an\n        \/\/ invokable class model:\n        Class<Outer.Inner,[]> boundMemberClassModel = memberClassModel(Outer());\n        \/\/ This will print: Hello\n        print(boundMemberClassModel());\n    }\n\nNote that there are more specialised versions of [[memberApply]] in [[ClassDeclaration.memberClassApply]] and \n[[InterfaceDeclaration.memberInterfaceApply]].\n"]},"$m":{"memberDeclarations":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Kind"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"}],"$nm":"Kind"}],"$an":{"shared":[],"formal":[],"doc":["Returns the list of member declarations that satisfy the given `Kind` type argument."]},"$nm":"memberDeclarations"},"apply":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"ClassOrInterface"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"typeArguments"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Type"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed type argument values are not compatible with the actual result's type parameters."],"doc":["Applies the given closed type arguments to this toplevel class or interface declaration in order to obtain a class or interface model. \nSee [this code sample](#toplevel-sample) for an example on how to use this."]},"$nm":"apply"},"getDeclaredMemberDeclaration":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Kind"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"}],"$nm":"Kind"}],"$an":{"shared":[],"formal":[],"doc":["Looks up a member declaration by name, provided it satisfies the given `Kind` type\nargument. Returns `null` if no such member matches."]},"$nm":"getDeclaredMemberDeclaration"},"memberApply":{"$t":{"comp":"i","$ts":[{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"ClassOrInterface"}],"$pk":"ceylon.language.meta.model","$nm":"Member"},{"$tp":[{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"ClassOrInterface"}]},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Container"}],"$pk":"ceylon.language.meta.model","$nm":"Type"},"$mt":"prm","$nm":"containerType"},{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"typeArguments"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language.meta.declaration","$nm":"Nothing"},"$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Type"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed container type or type argument values are not compatible with the actual result's container type or type parameters."],"doc":["Applies the given closed container type and type arguments to this member class or interface declaration in order to obtain a \nmember class or interface model. See [this code sample](#member-sample) for an example on how to use this."]},"$nm":"memberApply"},"annotatedDeclaredMemberDeclarations":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Kind"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"}],"$nm":"Kind"},{"$nm":"Annotation"}],"$an":{"shared":[],"formal":[],"doc":["Returns the list of member declarations that satisfy the given `Kind` type argument and\nthat are annotated with the given `Annotation` type argument"]},"$nm":"annotatedDeclaredMemberDeclarations"},"annotatedMemberDeclarations":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Kind"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"}],"$nm":"Kind"},{"$nm":"Annotation"}],"$an":{"shared":[],"formal":[],"doc":["Returns the list of member declarations that satisfy the given `Kind` type argument and\nthat are annotated with the given `Annotation` type argument"]},"$nm":"annotatedMemberDeclarations"},"getMemberDeclaration":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Kind"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"}],"$nm":"Kind"}],"$an":{"shared":[],"formal":[],"doc":["Looks up a member declaration by name, provided it satisfies the given `Kind` type\nargument. Returns `null` if no such member matches."]},"$nm":"getMemberDeclaration"},"declaredMemberDeclarations":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Kind"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"}],"$nm":"Kind"}],"$an":{"shared":[],"formal":[],"doc":["Returns the list of member declarations that satisfy the given `Kind` type argument."]},"$nm":"declaredMemberDeclarations"}},"$at":{"extendedType":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language.meta.declaration","$nm":"OpenClassType"}]},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This type's extended type, unless this is the class for [[Anything|ceylon.language::Anything]], which\nis the root of the type hierarchy and thus does not have any extended type."]},"$nm":"extendedType"},"caseTypes":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"OpenType"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["If this type has an `of` clause, this is the list of case types for the current type."]},"$nm":"caseTypes"},"satisfiedTypes":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"OpenInterfaceType"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The list of types satisfied by this type."]},"$nm":"satisfiedTypes"},"isAlias":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if this type is an alias type, in which case the [[extendedType]] will \ncontain the substituted type."]},"$nm":"isAlias"}},"$nm":"ClassOrInterfaceDeclaration"},"OpenClassOrInterfaceType":{"of":[{"$pk":"ceylon.language.meta.declaration","$nm":"OpenClassType"},{"$pk":"ceylon.language.meta.declaration","$nm":"OpenInterfaceType"}],"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"OpenType"}],"$mt":"ifc","$an":{"shared":[],"doc":["An open class or interface, with open type arguments.\n\nFor example, `List<T>` is an open interface type, with a type argument which is the\n[[OpenTypeVariable]] `T`."]},"$at":{"extendedType":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language.meta.declaration","$nm":"OpenClassType"}]},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The extended type of this open type."]},"$nm":"extendedType"},"declaration":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"ClassOrInterfaceDeclaration"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The class or interface declaration for this open type."]},"$nm":"declaration"},"typeArguments":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"TypeParameter"},{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"OpenType"}],"$pk":"ceylon.language","$nm":"Map"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The set of open type arguments."]},"$nm":"typeArguments"},"satisfiedTypes":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"OpenInterfaceType"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The satisfied types of this open type."]},"$nm":"satisfiedTypes"}},"$nm":"OpenClassOrInterfaceType"},"covariant":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"Variance"}],"$mt":"obj","$an":{"shared":[],"doc":["Covariant means that subtypes of the given type may be returned."]},"$at":{"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"string"}},"$nm":"covariant"},"nothingType":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"OpenType"}],"$mt":"obj","$an":{"shared":[],"doc":["The singleton open type for [[Nothing|ceylon.language::nothing]]."]},"$at":{"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"string"}},"$nm":"nothingType"},"ValueDeclaration":{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"FunctionOrValueDeclaration"}],"$mt":"ifc","$an":{"shared":[],"doc":["A value declaration.\n\n<a name=\"toplevel-sample\"><\/a>\n### Usage sample for toplevel value\n\nGetting a model requires applying type arguments to the\nvalue declaration with [[apply]] in order to be able to read that value. For example, here is how you would\nobtain a value model that you can read from a toplevel attribute declaration:\n\n    String foo = \"Hello\";\n    \n    void test(){\n        \/\/ We need to apply the the foo declaration in order to get the foo value model\n        Value<String> valueModel = `value foo`.apply<String>();\n        \/\/ This will print: Hello\n        print(valueModel.get());\n    }\n\n<a name=\"member-sample\"><\/a>\n### Usage sample for attributes\n\nFor attributes it is a bit longer, because attributes need to be applied the containing type, so you should \nuse [[memberApply]] and start by giving the containing closed type:\n\n    class Outer(){\n        shared String foo => \"Hello\";\n    }\n\n    void test(){\n        \/\/ Apply the containing closed type `Outer` to the attribute declaration `Outer.foo`\n        Attribute<Outer,String> valueModel = `value Outer.foo`.memberApply<Outer,String>(`Outer`);\n        \/\/ We now have an Attribute, which needs to be applied to a containing instance in order to become a\n        \/\/ readable value:\n        Value<String> boundValueModel = valueModel(Outer());\n        \/\/ This will print: Hello\n        print(boundValueModel.get());\n    }\n"]},"$m":{"apply":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Get"},{"$mt":"tpm","$nm":"Set"}],"$pk":"ceylon.language.meta.model","$nm":"Value"},"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Get"},{"$def":{"$pk":"ceylon.language.meta.declaration","$nm":"Nothing"},"$nm":"Set"}],"$an":{"shared":[],"formal":[],"throws":["IncompatibleTypeException","If the specified `Get` or `Set` type arguments are not compatible with the actual result."],"doc":["Applies this value declaration in order to obtain a value model. \nSee [this code sample](#toplevel-sample) for an example on how to use this."]},"$nm":"apply"},"get":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Reads the current value of this toplevel value."]},"$nm":"get"},"memberSet":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"container"},{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"prm","$nm":"newValue"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"throws":["IncompatibleTypeException","If the specified container or new value type is not compatible with this attribute."],"doc":["Sets the current value of this attribute on the given container instance."]},"$nm":"memberSet"},"set":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"prm","$nm":"newValue"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Sets the current value of this toplevel value."]},"$nm":"set"},"memberApply":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$nm":"Get"},{"$mt":"tpm","$nm":"Set"}],"$pk":"ceylon.language.meta.model","$nm":"Attribute"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Container"}],"$pk":"ceylon.language.meta.model","$nm":"Type"},"$mt":"prm","$nm":"containerType"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language.meta.declaration","$nm":"Nothing"},"$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Get"},{"$def":{"$pk":"ceylon.language.meta.declaration","$nm":"Nothing"},"$nm":"Set"}],"$an":{"shared":[],"formal":[],"throws":["IncompatibleTypeException","If the specified `Container`, `Get` or `Set` type arguments are not compatible with the actual result."],"doc":["Applies the given closed container type to this attribute declaration in order to obtain an attribute model. \nSee [this code sample](#member-sample) for an example on how to use this."]},"$nm":"memberApply"},"memberGet":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"container"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"throws":["IncompatibleTypeException","If the specified container is not compatible with this attribute."],"doc":["Reads the current value of this attribute on the given container instance."]},"$nm":"memberGet"}},"$at":{"setter":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"SetterDeclaration"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["Returns the setter declaration for this variable.\n\nFor modelling purposes `variable` reference \nvalues have a SetterDeclaration even though there is no \nsuch setter explicit in the source code."]},"$nm":"setter"},"variable":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if this declaration is annotated with [[variable|ceylon.language::variable]]."]},"$nm":"variable"}},"$nm":"ValueDeclaration"},"ClassDeclaration":{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"ClassOrInterfaceDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"FunctionalDeclaration"}],"$mt":"ifc","$an":{"shared":[],"doc":["Class declaration.\n\n<a name=\"toplevel-sample\"><\/a>\n### Usage sample for toplevel classes\n\nBecause some classes have type parameters, getting a model requires applying type arguments to the\nclass declaration with [[classApply]] in order to be able to instantiate that class. For example, here is how you would\nobtain a class model that you can instantiate from a toplevel class declaration:\n\n    class Foo<T>(){\n        string => \"Hello, our T is: ``typeLiteral<T>()``\";\n    }\n    \n    void test(){\n        \/\/ We need to apply the Integer closed type to the Foo declaration in order to get the Foo<Integer> closed type\n        Class<Foo<Integer>,[]> classModel = `class Foo`.classApply<Foo<Integer>,[]>(`Integer`);\n        \/\/ This will print: Hello, our T is: ceylon.language::Integer\n        print(classModel());\n    }\n\n<a name=\"member-sample\"><\/a>\n### Usage sample for member classes\n\nFor member classes it is a bit longer, because member classes need to be applied not only their type arguments but also\nthe containing type, so you should use [[memberClassApply]] and start by giving the containing closed type:\n\n    class Outer(){\n        shared class Inner(){\n            string => \"Hello\";\n        }\n    }\n\n    void test(){\n        \/\/ apply the containing closed type `Outer` to the member class declaration `Outer.Inner`\n        MemberClass<Outer,Outer.Inner,[]> memberClassModel = `class Outer.Inner`.memberClassApply<Outer,Outer.Inner,[]>(`Outer`);\n        \/\/ We now have a MemberClass, which needs to be applied to a containing instance in order to become an\n        \/\/ invokable class model:\n        Class<Outer.Inner,[]> boundMemberClassModel = memberClassModel(Outer());\n        \/\/ This will print: Hello\n        print(boundMemberClassModel());\n    }\n"]},"$m":{"instantiate":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","$def":"1","$nm":"typeArguments"},{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"arguments"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"throws":["IncompatibleTypeException","If the specified type or value arguments are not compatible with this toplevel class."],"doc":["Creates a new instance of this toplevel class, by applying the specified type arguments and value arguments."]},"$nm":"instantiate"},"memberInstantiate":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"container"},{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","$def":"1","$nm":"typeArguments"},{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"arguments"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"throws":["IncompatibleTypeException","If the specified container, type or value arguments are not compatible with this method."],"doc":["Creates a new instance of this member class, by applying the specified type arguments and value arguments."]},"$nm":"memberInstantiate"},"memberClassApply":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"MemberClass"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Container"}],"$pk":"ceylon.language.meta.model","$nm":"Type"},"$mt":"prm","$nm":"containerType"},{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"typeArguments"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language.meta.declaration","$nm":"Nothing"},"$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Type"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$def":{"$pk":"ceylon.language.meta.declaration","$nm":"Nothing"},"$nm":"Arguments"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed container type or type argument values are not compatible with the actual result's container type or type parameters."],"doc":["Applies the given closed container type and type arguments to this member class declaration in order to obtain a member class model. \nSee [this code sample](#member-sample) for an example on how to use this."]},"$nm":"memberClassApply"},"classApply":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"Class"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"typeArguments"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Type"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$def":{"$pk":"ceylon.language.meta.declaration","$nm":"Nothing"},"$nm":"Arguments"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed type argument values are not compatible with the actual result's type parameters."],"doc":["Applies the given closed type arguments to this toplevel class declaration in order to obtain a class model. \nSee [this code sample](#toplevel-sample) for an example on how to use this."]},"$nm":"classApply"}},"$at":{"anonymous":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if the class is an object class."]},"$nm":"anonymous"},"abstract":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if the class has an [[abstract|ceylon.language::abstract]] annotation."]},"$nm":"abstract"},"final":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if the class has a [[final|ceylon.language::final]] annotation."]},"$nm":"final"}},"$nm":"ClassDeclaration"},"contravariant":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"Variance"}],"$mt":"obj","$an":{"shared":[],"doc":["Contravariant means that supertypes of the given type may be accepted."]},"$at":{"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"string"}},"$nm":"contravariant"},"FunctionOrValueDeclaration":{"of":[{"$pk":"ceylon.language.meta.declaration","$nm":"FunctionDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"ValueDeclaration"}],"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"}],"$mt":"ifc","$an":{"shared":[],"doc":["A function or value declaration."]},"$at":{"parameter":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if this function or value is a parameter to a [[FunctionalDeclaration]]."]},"$nm":"parameter"},"variadic":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if this function or value is a parameter and is variadic (accepts a list of values)."]},"$nm":"variadic"},"defaulted":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["True if this function or value is a parameter and has a default value."]},"$nm":"defaulted"}},"$nm":"FunctionOrValueDeclaration"},"AliasDeclaration":{"satisfies":[{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"GenericDeclaration"}],"$mt":"ifc","$an":{"shared":[],"doc":["Type alias declaration. While type aliases are erased (substituted for what they alias is a better term) from every \ndeclaration that uses them during compile-time, the declaration of the type alias is still visible at run-time."]},"$at":{"extendedType":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"OpenType"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The open type that is substituted by this type alias."]},"$nm":"extendedType"}},"$nm":"AliasDeclaration"}},"$mod-version":"1.0.0","ceylon.language.meta":{"$pkg-shared":"1","sequencedAnnotations":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Value"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Value"},{"$mt":"tpm","$nm":"ProgramElement"}],"$pk":"ceylon.language","$nm":"SequencedAnnotation"},{"$mt":"tpm","$pk":"ceylon.language.meta.model","$nm":"Nothing"}],"$pk":"ceylon.language.meta.model","$nm":"Class"},"$mt":"prm","$nm":"annotationType"},{"$t":{"$nm":"ProgramElement"},"$mt":"prm","$nm":"programElement"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Value"},{"$mt":"tpm","$nm":"ProgramElement"}],"$pk":"ceylon.language","$nm":"SequencedAnnotation"}],"$nm":"Value"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Annotated"}],"variance":"in","$nm":"ProgramElement"}],"$an":{"shared":[],"doc":["The values of given sequenced annotation type on the given program element, \nor empty if the program element was not annotated with that annotation type.\nFor example:\n\n    \/\/ Does the sum declaration have any ThrownException annotations?\n    value throwsSomething = sequencedAnnotation(`ThrownException`, `function sum`) nonempty;\n\nThe annotations may be returned in any order.\n"]},"$nm":"sequencedAnnotations"},"optionalAnnotation":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Value"}]},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Value"},{"$mt":"tpm","$nm":"ProgramElement"}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"},{"$mt":"tpm","$pk":"ceylon.language.meta.model","$nm":"Nothing"}],"$pk":"ceylon.language.meta.model","$nm":"Class"},"$mt":"prm","$nm":"annotationType"},{"$t":{"$nm":"ProgramElement"},"$mt":"prm","$nm":"programElement"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Value"},{"$mt":"tpm","$nm":"ProgramElement"}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$nm":"Value"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Annotated"}],"variance":"in","$nm":"ProgramElement"}],"$an":{"shared":[],"doc":["The value of given optional annotation type on the given program element, \nor null if the program element was not annotated with that annotation type.\nFor example:\n\n    \/\/ Does the process declaration have the Shared annotation?\n    value isShared = optionalAnnotation(`Shared`, `value process`) exists;\n"]},"$nm":"optionalAnnotation"},"typeLiteral":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"Type"},"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Anything"}],"variance":"out","$nm":"Type"}],"$an":{"shared":[],"native":[],"doc":["Functional equivalent to type literals. Allows you to get a closed type instance\nfor a given type argument.\n\nFor example:\n\n    assert(is Interface<List<Integer>> listOfIntegers = typeLiteral<List<Integer>>());\n"]},"$nm":"typeLiteral"},"annotations":{"$t":{"$nm":"Values"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Value"},{"$mt":"tpm","$nm":"Values"},{"$mt":"tpm","$nm":"ProgramElement"}],"$pk":"ceylon.language","$nm":"ConstrainedAnnotation"},{"$mt":"tpm","$pk":"ceylon.language.meta.model","$nm":"Nothing"}],"$pk":"ceylon.language.meta.model","$nm":"Class"},"$mt":"prm","$nm":"annotationType"},{"$t":{"$nm":"ProgramElement"},"$mt":"prm","$nm":"programElement"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Value"},{"$mt":"tpm","$nm":"Values"},{"$mt":"tpm","$nm":"ProgramElement"}],"$pk":"ceylon.language","$nm":"ConstrainedAnnotation"}],"$nm":"Value"},{"$nm":"Values"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Annotated"}],"variance":"in","$nm":"ProgramElement"}],"$an":{"shared":[],"native":[],"doc":["The annotations of the given type on the given program element. For example:\n\n    \/\/ Does the process declaration have the Shared annotation?\n    value isShared = annotations(`Shared`, `value process`) exists;\n\nThe annotations may be returned in any order.\n"]},"$nm":"annotations"},"modules":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$mt":"obj","$an":{"shared":[],"native":[],"doc":["Represents the list of Ceylon modules currently loaded at runtime.\n\nNote that this contains all loaded modules, including those that are\nnot imported by your module.\n\nSince Ceylon supports module isolation at runtime, it is possible that\nthere are more than one version of a given module loaded at the same time.\n\n### Usage example\n\nHere's how you would iterate all the loaded modules and print their name and version:\n\n    import ceylon.language.meta { modules }\n\n    for(mod in modules.list){\n        print(\"Module: ``mod.name``\/``mod.version``\");\n    }\n"]},"$m":{"find":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language.meta.declaration","$nm":"Module"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"},{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"version"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Finds a module by name and version, returns `null` if not found."]},"$nm":"find"}},"$at":{"default":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language.meta.declaration","$nm":"Module"}]},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Returns the default module, if there is one. This is only the case when\nyou are running the default module."]},"$nm":"default"},"list":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"Module"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Returns the list of all currently loaded modules. This may include modules that\nwere not imported directly but your module, and multiple versions of the same\nmodule."]},"$nm":"list"}},"$nm":"modules"},"type":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$pk":"ceylon.language.meta","$nm":"Nothing"}],"$pk":"ceylon.language.meta.model","$nm":"ClassModel"},"$ps":[[{"$t":{"$nm":"Type"},"$mt":"prm","$nm":"instance"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Anything"}],"variance":"out","$nm":"Type"}],"$an":{"shared":[],"native":[],"doc":["Returns the closed type and model of a given instance. Since only classes\ncan be instantiated, this will always be a [[ClassModel]] model."]},"$nm":"type"}},"ceylon.language.meta.model":{"Member":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Kind"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Empty"}],"$pk":"ceylon.language","$nm":"Tuple"}],"$pk":"ceylon.language","$nm":"Callable"}],"$mt":"ifc","$tp":[{"variance":"in","$nm":"Container"},{"satisfies":[{"$pk":"ceylon.language.meta.model","$nm":"Model"}],"variance":"out","$nm":"Kind"}],"$an":{"shared":[],"doc":["Model for members that can be bound to a containing instance to turn them into toplevel models.\n\nYou can bind a member to an instance by invoking that member with the instance as parameter:\n\n    shared class Outer(String name){\n        shared class Inner(){\n            shared String hello => \"Hello \"+name;\n        }\n    }\n    \n    void test(){\n        Member<Outer,Class<Outer.Inner,[]>> memberClass = `Outer.Inner`;\n        Class<Outer.Inner,[]> c = memberClass(Outer(\"Stef\"));\n        \/\/ This will print: Hello Stef\n        print(c().hello);\n    }\n"]},"$m":{"bind":{"$t":{"$pk":"ceylon.language.meta.model","$nm":"Model"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"container"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"throws":["IncompatibleTypeException","If the container is not assignable to this member's container"],"doc":["Type-unsafe container binding, to be used when the container type is unknown until runtime.\n\nThis has the same behaviour as invoking this `Member` directly, but exchanges compile-time type\nsafety with runtime checks."]},"$nm":"bind"}},"$at":{"declaringType":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The declaring closed type. This is the type that declared this member."]},"$nm":"declaringType"}},"$nm":"Member"},"Model":{"of":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"ClassOrInterface"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"},{"$mt":"tpm","$pk":"ceylon.language.meta.model","$nm":"Nothing"}],"$pk":"ceylon.language.meta.model","$nm":"FunctionModel"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"},{"$mt":"tpm","$pk":"ceylon.language.meta.model","$nm":"Nothing"}],"$pk":"ceylon.language.meta.model","$nm":"ValueModel"}],"$mt":"ifc","$an":{"shared":[],"doc":["The root of all models. There are several types of models:\n\n- [[ClassOrInterface]]\n- [[FunctionModel]]\n- [[ValueModel]]\n"]},"$at":{"declaration":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"NestableDeclaration"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The declaration for this model."]},"$nm":"declaration"},"container":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}]},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The container type of this model, or `null` if this is a toplevel model."]},"$nm":"container"}},"$nm":"Model"},"InterfaceModel":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"ClassOrInterface"}],"$mt":"ifc","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Type"}],"$an":{"shared":[],"doc":["An interface model represents the model of a Ceylon interface that you can inspect.\n\nAn interface model can be either a toplevel [[Interface]] or a member [[MemberInterface]].\n"]},"$at":{"declaration":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"InterfaceDeclaration"},"$mt":"attr","$an":{"shared":[],"formal":[],"actual":[]},"$nm":"declaration"}},"$nm":"InterfaceModel"},"Method":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"FunctionModel"},{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"Function"}],"$pk":"ceylon.language.meta.model","$nm":"Member"}],"$mt":"ifc","$tp":[{"variance":"in","$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Type"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"variance":"in","$nm":"Arguments"}],"$an":{"shared":[],"doc":["A function model represents the model of a Ceylon function that you can invoke and inspect.\n\nA method is a member function: it is declared on classes or interfaces.\n\nThis is both a [[FunctionModel]] and a [[Member]]: you can invoke it with an instance value\nto bind it to that instance and obtain a [[Function]]:\n\n    class Outer(){\n        shared String foo(String name) => \"Hello \"+name;\n    }\n    \n    void test(){\n        Method<Outer,String,[String]> method = `Outer.foo`;\n        \/\/ Bind it to an instance value\n        Function<String,[String]> f = method(Outer());\n        \/\/ This will print: Hello Stef\n        print(f(\"Stef\"));\n    }\n"]},"$m":{"bind":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"Function"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"container"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"actual":[]},"$nm":"bind"}},"$nm":"Method"},"Type":{"$mt":"ifc","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Type"}],"$an":{"shared":[],"doc":["A closed type.\n\nA closed type is a type which is fully resolved and bound and contains no open type variables.\nAll instance types are closed at runtime.\n\nYou have only four sorts of types:\n\n- [[ClassOrInterface]]\n- [[UnionType]]\n- [[IntersectionType]]\n- [[nothingType]]"]},"$m":{"exactly":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"},"$mt":"prm","$nm":"type"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["True if the given type is a exactly this type."]},"$nm":"exactly"},"subtypeOf":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"},"$mt":"prm","$nm":"type"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["True if the given type is a subtype of this type."]},"$nm":"subtypeOf"},"typeOf":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"prm","$nm":"instance"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["True if the given instance is of this type, or is of a subtype of this type."]},"$nm":"typeOf"},"supertypeOf":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"},"$mt":"prm","$nm":"type"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["True if the given type is a supertype of this type."]},"$nm":"supertypeOf"}},"$nm":"Type"},"IntersectionType":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Intersection"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$mt":"ifc","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Intersection"}],"$an":{"shared":[],"doc":["A closed intersection type."]},"$at":{"satisfiedTypes":{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The list of closed satisfied types of this intersection."]},"$nm":"satisfiedTypes"}},"$nm":"IntersectionType"},"UnionType":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Union"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$mt":"ifc","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Union"}],"$an":{"shared":[],"doc":["A closed union type."]},"$at":{"caseTypes":{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Union"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The list of closed case types of this union."]},"$nm":"caseTypes"}},"$nm":"UnionType"},"$pkg-shared":"1","FunctionModel":{"satisfies":[{"$pk":"ceylon.language.meta.model","$nm":"Model"},{"$pk":"ceylon.language.meta.model","$nm":"Generic"}],"$mt":"ifc","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Type"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"variance":"in","$nm":"Arguments"}],"$an":{"shared":[],"doc":["A function model represents the model of a Ceylon function that you can inspect.\n\nA function model can be either a toplevel [[Function]] or a member [[Method]].\n"]},"$at":{"declaration":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"FunctionDeclaration"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This function's declaration."],"actual":[]},"$nm":"declaration"},"type":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"Type"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This function's return closed type."]},"$nm":"type"},"parameterTypes":{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This function's parameter closed types"]},"$nm":"parameterTypes"}},"$nm":"FunctionModel"},"ValueModel":{"satisfies":[{"$pk":"ceylon.language.meta.model","$nm":"Model"}],"$mt":"ifc","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Get"},{"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"variance":"in","$nm":"Set"}],"$an":{"shared":[],"doc":["A value model represents the model of a Ceylon value that you can inspect.\n\nA value model can be either a toplevel [[Value]] or a member [[Attribute]].\n"]},"$at":{"declaration":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"ValueDeclaration"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This value's declaration."],"actual":[]},"$nm":"declaration"},"type":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Get"}],"$pk":"ceylon.language.meta.model","$nm":"Type"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This value's closed type."]},"$nm":"type"}},"$nm":"ValueModel"},"ClassModel":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"ClassOrInterface"}],"$mt":"ifc","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Type"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"variance":"in","$nm":"Arguments"}],"$an":{"shared":[],"doc":["A class model represents the model of a Ceylon class that you can inspect.\n\nA class model can be either a toplevel [[Class]] or a member [[MemberClass]].\n"]},"$at":{"declaration":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"ClassDeclaration"},"$mt":"attr","$an":{"shared":[],"formal":[],"actual":[]},"$nm":"declaration"},"parameterTypes":{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["This function's parameter closed types"]},"$nm":"parameterTypes"}},"$nm":"ClassModel"},"Attribute":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Get"},{"$mt":"tpm","$nm":"Set"}],"$pk":"ceylon.language.meta.model","$nm":"ValueModel"},{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Get"},{"$mt":"tpm","$nm":"Set"}],"$pk":"ceylon.language.meta.model","$nm":"Value"}],"$pk":"ceylon.language.meta.model","$nm":"Member"}],"$mt":"ifc","$tp":[{"variance":"in","$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Get"},{"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"variance":"in","$nm":"Set"}],"$an":{"shared":[],"doc":["An attribute model represents the model of a Ceylon attribute that you can read and inspect.\n\nAn attribute is a member value: it is declared on classes or interfaces.\n\nThis is both a [[ValueModel]] and a [[Member]]: you can invoke it with an instance value\nto bind it to that instance and obtain a [[Value]]:\n\n    class Outer(){\n        shared String foo = \"Hello\";\n    }\n    \n    void test(){\n        Attribute<Outer,String> attribute = `Outer.foo`;\n        Value<String> boundAttribute = attribute(Outer());\n        \/\/ This will print: Hello\n        print(boundAttribute.get());\n    }\n"]},"$m":{"bind":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Get"},{"$mt":"tpm","$nm":"Set"}],"$pk":"ceylon.language.meta.model","$nm":"Value"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"container"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"actual":[]},"$nm":"bind"}},"$nm":"Attribute"},"Value":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Get"},{"$mt":"tpm","$nm":"Set"}],"$pk":"ceylon.language.meta.model","$nm":"ValueModel"}],"$mt":"ifc","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Get"},{"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"variance":"in","$nm":"Set"}],"$an":{"shared":[],"doc":["A value model represents the model of a Ceylon value that you can read and inspect.\n\nA value is a toplevel binding, declared on a package.\n\nThis is a [[ValueModel]] that you can query for a value declaration's current value:\n\n    shared String foo = \"Hello\";\n    \n    void test(){\n        Value<String> val = `foo`;\n        \/\/ This will print: Hello\n        print(val.get());\n    }\n"]},"$m":{"get":{"$t":{"$nm":"Get"},"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Reads the current value for this value binding. Note that in the case of getter\nvalues, this can throw if the getter throws."]},"$nm":"get"},"set":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$nm":"Set"},"$mt":"prm","$nm":"newValue"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Changes this variable's value to the given new value. Note that in the case of\nsetter attributes, this can throw if the setter throws."]},"$nm":"set"},"setIfAssignable":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"prm","$nm":"newValue"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"throws":["MutationException","If this value is not variable"],"doc":["Non type-safe equivalent to [[Value.set]], to be used when you don't know the \nvariable type at compile-time. This only works if the underlying value is \nvariable. Note that if the underlying variable is a setter, this can throw \nexceptions thrown in the setter block."]},"$nm":"setIfAssignable"}},"$nm":"Value"},"InvocationException":{"super":{"$pk":"ceylon.language","$nm":"Exception"},"$ps":[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"message"}],"$mt":"cls","$an":{"shared":[],"doc":["Thrown when attempting to invoke something which can't be invoked, like abstract class\ninitialisers."]},"$at":{"message":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$nm":"message"}},"$nm":"InvocationException"},"Function":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"FunctionModel"},{"$tp":[{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language","$nm":"Callable"}],"$mt":"ifc","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Type"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"variance":"in","$nm":"Arguments"}],"$an":{"shared":[],"doc":["A function model represents the model of a Ceylon function that you can invoke and inspect.\n\nA function is a toplevel binding, declared on a package.\n\nThis is a [[FunctionModel]] that you can also invoke:\n\n    shared String foo(String name) => \"Hello \"+name;\n    \n    void test(){\n        Function<String,[String]> f = `foo`;\n        \/\/ This will print: Hello Stef\n        print(f(\"Stef\"));\n    }\n"]},"$m":{"apply":{"$t":{"$nm":"Type"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"arguments"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"throws":["InvocationException","If there are not enough or too many provided arguments"],"doc":["Type-unsafe function application, to be used when the argument types are unknown until runtime.\n\nThis has the same behaviour as invoking this `Function` directly, but exchanges compile-time type\nsafety with runtime checks."]},"$nm":"apply"}},"$nm":"Function"},"TypeApplicationException":{"super":{"$pk":"ceylon.language","$nm":"Exception"},"$ps":[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"message"}],"$mt":"cls","$an":{"shared":[],"doc":["Thrown when declarations are applied with invalid or incompatible type arguments.\n\nFor example if you try to apply `Foo` with `String`, hoping to get a `Foo<String>`\nbut the type parameter for `Foo` only accepts types that satisfy `Numeric`.\n"]},"$at":{"message":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$nm":"message"}},"$nm":"TypeApplicationException"},"MemberClass":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"ClassModel"},{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"Class"}],"$pk":"ceylon.language.meta.model","$nm":"Member"}],"$mt":"ifc","$tp":[{"variance":"in","$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Type"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"variance":"in","$nm":"Arguments"}],"$an":{"shared":[],"doc":["A class model represents the model of a Ceylon class that you can instantiate and inspect.\n\nA member class is is declared on classes or interfaces.\n\nThis is both a [[ClassModel]] and a [[Member]]: you can invoke it with an instance value\nto bind it to that instance and obtain a [[Class]]:\n\n    shared class Outer(String name){\n        shared class Inner(){\n            shared String hello => \"Hello \"+name;\n        }\n    }\n    \n    void test(){\n        MemberClass<Outer,Outer.Inner,[]> memberClass = `Outer.Inner`;\n        Class<Outer.Inner,[]> c = memberClass(Outer(\"Stef\"));\n        \/\/ This will print: Hello Stef\n        print(c().hello);\n    }\n"]},"$m":{"bind":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"Class"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"container"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"actual":[]},"$nm":"bind"}},"$nm":"MemberClass"},"MutationException":{"super":{"$pk":"ceylon.language","$nm":"Exception"},"$ps":[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"message"}],"$mt":"cls","$an":{"shared":[],"doc":["Thrown when you try to change the value of a non-variable value"]},"$at":{"message":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$nm":"message"}},"$nm":"MutationException"},"Interface":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"InterfaceModel"}],"$mt":"ifc","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Type"}],"$an":{"shared":[],"doc":["An interface model that you can inspect."]},"$nm":"Interface"},"nothingType":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.model","$nm":"Nothing"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$mt":"obj","$an":{"shared":[],"doc":["The singleton closed type for [[Nothing|ceylon.language::nothing]]."]},"$m":{"exactly":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"},"$mt":"prm","$nm":"type"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"exactly"},"subtypeOf":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"},"$mt":"prm","$nm":"type"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"subtypeOf"},"typeOf":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"prm","$nm":"instance"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"typeOf"},"supertypeOf":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"},"$mt":"prm","$nm":"type"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"supertypeOf"}},"$at":{"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"string"}},"$nm":"nothingType"},"Class":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"ClassModel"},{"$tp":[{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language","$nm":"Callable"}],"$mt":"ifc","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Type"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"variance":"in","$nm":"Arguments"}],"$an":{"shared":[],"doc":["A class model represents the model of a Ceylon class that you can instantiate and inspect.\n\nA class is a toplevel type, declared on a package.\n\nThis is a [[ClassModel]] that you can also invoke to instantiate new instances of the class:\n\n    shared class Foo(String name){\n        shared String hello => \"Hello \"+name;\n    }\n    \n    void test(){\n        Class<Foo,[String]> c = `Foo`;\n        \/\/ This will print: Hello Stef\n        print(c(\"Stef\").hello);\n    }\n"]},"$m":{"apply":{"$t":{"$nm":"Type"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"arguments"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"throws":["InvocationException","If there are not enough or too many provided arguments"],"doc":["Type-unsafe initialiser application, to be used when the argument types are unknown until runtime.\n\nThis has the same behaviour as invoking this `Class` directly, but exchanges compile-time type\nsafety with runtime checks."]},"$nm":"apply"}},"$nm":"Class"},"ClassOrInterface":{"of":[{"$tp":[{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$pk":"ceylon.language.meta.model","$nm":"Nothing"}],"$pk":"ceylon.language.meta.model","$nm":"ClassModel"},{"$tp":[{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"InterfaceModel"}],"satisfies":[{"$pk":"ceylon.language.meta.model","$nm":"Model"},{"$pk":"ceylon.language.meta.model","$nm":"Generic"},{"$tp":[{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$mt":"ifc","$tp":[{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Type"}],"$an":{"shared":[],"doc":["Model of a class or interface that you can inspect.\n\nThe models of classes and interfaces are also closed types."]},"$m":{"getClass":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"MemberClass"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"},{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"types"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Type"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Arguments"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed type argument values are not compatible with the actual result's type parameters."],"doc":["Gets a member class by name. Returns `null` if not found."]},"$nm":"getClass"},"getDeclaredClassOrInterface":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$nm":"Kind"}],"$pk":"ceylon.language.meta.model","$nm":"Member"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"},{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"types"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Container"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"ClassOrInterface"}],"$def":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"ClassOrInterface"},"$nm":"Kind"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed type argument values are not compatible with the actual result's type parameters."],"doc":["Gets a member class or interface by name. Returns `null` if not found."]},"$nm":"getDeclaredClassOrInterface"},"getDeclaredInterface":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"MemberInterface"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"},{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"types"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Type"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed type argument values are not compatible with the actual result's type parameters."],"doc":["Gets a member interface by name. Returns `null` if not found."]},"$nm":"getDeclaredInterface"},"getMethod":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"Method"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"},{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"types"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Type"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Arguments"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed type argument values are not compatible with the actual result's type parameters."],"doc":["Gets a method by name. Returns `null` if not found."]},"$nm":"getMethod"},"getDeclaredMethod":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"Method"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"},{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"types"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Type"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Arguments"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed type argument values are not compatible with the actual result's type parameters."],"doc":["Gets a method by name. Returns `null` if not found."]},"$nm":"getDeclaredMethod"},"getInterface":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"MemberInterface"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"},{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"types"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Type"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed type argument values are not compatible with the actual result's type parameters."],"doc":["Gets a member interface by name. Returns `null` if not found."]},"$nm":"getInterface"},"getDeclaredAttribute":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$nm":"Get"},{"$mt":"tpm","$nm":"Set"}],"$pk":"ceylon.language.meta.model","$nm":"Attribute"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Get"},{"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Set"}],"$an":{"shared":[],"formal":[],"throws":["IncompatibleTypeException","If the specified `Container`, `Get` or `Set` type arguments are not compatible with the actual result."],"doc":["Gets an attribute by name. Returns `null` if not found."]},"$nm":"getDeclaredAttribute"},"getAttribute":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$nm":"Get"},{"$mt":"tpm","$nm":"Set"}],"$pk":"ceylon.language.meta.model","$nm":"Attribute"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Get"},{"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Set"}],"$an":{"shared":[],"formal":[],"throws":["IncompatibleTypeException","If the specified `Container`, `Get` or `Set` type arguments are not compatible with the actual result."],"doc":["Gets an attribute by name. Returns `null` if not found."]},"$nm":"getAttribute"},"getClassOrInterface":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$nm":"Kind"}],"$pk":"ceylon.language.meta.model","$nm":"Member"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"},{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"types"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Container"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"ClassOrInterface"}],"$def":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"ClassOrInterface"},"$nm":"Kind"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed type argument values are not compatible with the actual result's type parameters."],"doc":["Gets a member class or interface by name. Returns `null` if not found."]},"$nm":"getClassOrInterface"},"getDeclaredClass":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$nm":"Type"},{"$mt":"tpm","$nm":"Arguments"}],"$pk":"ceylon.language.meta.model","$nm":"MemberClass"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"},{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$nm":"types"}]],"$mt":"mthd","$tp":[{"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"$nm":"Type"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$def":{"$pk":"ceylon.language.meta.model","$nm":"Nothing"},"$nm":"Arguments"}],"$an":{"shared":[],"formal":[],"throws":["TypeApplicationException","If the specified closed type argument values are not compatible with the actual result's type parameters."],"doc":["Gets a member class by name. Returns `null` if not found."]},"$nm":"getDeclaredClass"}},"$at":{"extendedType":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"},{"$mt":"tpm","$pk":"ceylon.language.meta.model","$nm":"Nothing"}],"$pk":"ceylon.language.meta.model","$nm":"ClassModel"}]},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The extended closed type for this class or interface. Note that the [[Anything|ceylon.language::Anything]] type\nhas no extended type since it is the top of the type hierarchy."]},"$nm":"extendedType"},"declaration":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"ClassOrInterfaceDeclaration"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The declaration for this class or interface."],"actual":[]},"$nm":"declaration"},"satisfiedTypes":{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"InterfaceModel"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The list of closed types that this class or interface satisfies."]},"$nm":"satisfiedTypes"}},"$nm":"ClassOrInterface"},"Generic":{"$mt":"ifc","$an":{"shared":[],"doc":["A generic model which has closed type arguments."]},"$at":{"typeArguments":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"TypeParameter"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language.meta.model","$nm":"Type"}],"$pk":"ceylon.language","$nm":"Map"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The map of type parameter declaration to type arguments for this generic model."]},"$nm":"typeArguments"}},"$nm":"Generic"},"IncompatibleTypeException":{"super":{"$pk":"ceylon.language","$nm":"Exception"},"$ps":[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"message"}],"$mt":"cls","$an":{"shared":[],"doc":["Thrown when you invoke metamodel methods with invalid or incompatible type arguments.\n\nFor example if you try to get an attribute from a class and expect an attribute of `String`\ntype but it is an attribute of `Integer` type.\n"]},"$at":{"message":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$nm":"message"}},"$nm":"IncompatibleTypeException"},"MemberInterface":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"InterfaceModel"},{"$tp":[{"$mt":"tpm","$nm":"Container"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"Interface"}],"$pk":"ceylon.language.meta.model","$nm":"Member"}],"$mt":"ifc","$tp":[{"variance":"in","$nm":"Container"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Type"}],"$an":{"shared":[],"doc":["A member interface model that you can inspect."]},"$m":{"bind":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Type"}],"$pk":"ceylon.language.meta.model","$nm":"Interface"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"container"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"actual":[]},"$nm":"bind"}},"$nm":"MemberInterface"}},"ceylon.language":{"Iterator":{"$mt":"ifc","$tp":[{"variance":"out","$nm":"Element"}],"$an":{"shared":[],"see":["Iterable"],"doc":["Produces elements of an `Iterable` object. Classes that \nimplement this interface should be immutable."],"by":["Gavin"]},"$m":{"next":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["The next element, or `finished` if there are no \nmore elements to be iterated."]},"$nm":"next"}},"$nm":"Iterator"},"LateAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"LateAnnotation"},{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"ValueDeclaration"}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[late]]."]},"$annot":"1","$nm":"LateAnnotation"},"Callable":{"$mt":"ifc","$tp":[{"variance":"out","$nm":"Return"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"variance":"in","$nm":"Arguments"}],"$an":{"shared":[],"see":["Tuple"],"doc":["A reference to a function. The type arguments encode \nthe function return type and parameter types. The \nparameter types are typically represented as a tuple\ntype. For example, the type of the function reference \n`plus<Float>` is:\n\n    Callable<Float,[Float,Float]>\n\nwhich we usually abbreviate `Float(Float,Float)`. Any\ninstance of `Callable` may be _invoked_ by supplying a \npositional argument list:\n\n    Float(Float,Float) add = plus<Float>;\n    value four = add(2.0, 2.0);\n\nor by supplying a tuple containing the arguments:\n\n    Float(Float,Float) add = plus<Float>;\n    [Float,Float] twoAndTwo = [2.0, 2.0];\n    value four = add(*twoAndTwo);\n\nThis interface may not be implemented by user code."]},"$nm":"Callable"},"ThrownExceptionAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$ps":[{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"Declaration"},"$mt":"prm","$an":{"shared":[],"doc":["The [[Exception]] type that this thrown."]},"$nm":"type"},{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$an":{"shared":[],"doc":["A description, in Markdown syntax, of the circumstances that \ncause this exception to be thrown."]},"$nm":"when"}],"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"ThrownExceptionAnnotation"},{"comp":"u","$mt":"tpm","$ts":[{"$pk":"ceylon.language.meta.declaration","$nm":"ValueDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"FunctionDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"ClassDeclaration"}]}],"$pk":"ceylon.language","$nm":"SequencedAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[throws]]."]},"$annot":"1","$at":{"when":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"doc":["A description, in Markdown syntax, of the circumstances that \ncause this exception to be thrown."]},"$nm":"when"},"type":{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"Declaration"},"$mt":"attr","$an":{"shared":[],"doc":["The [[Exception]] type that this thrown."]},"$nm":"type"}},"$nm":"ThrownExceptionAnnotation"},"Array":{"super":{"$pk":"ceylon.language","$nm":"Object"},"$ps":[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"elements"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Array"}],"$pk":"ceylon.language","$nm":"Cloneable"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Array"}],"$pk":"ceylon.language","$nm":"Ranged"}],"$mt":"cls","$tp":[{"$nm":"Element"}],"$an":{"shared":[],"final":[],"native":[],"doc":["A fixed-size array of elements. An array may have zero\nsize (an empty array). Arrays are mutable. Any element\nof an array may be set to a new value.\n\nThis class is provided primarily to support interoperation \nwith Java, and for some performance-critical low-level \nprogramming tasks."]},"$m":{"copyTo":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Array"},"$mt":"prm","$an":{"doc":["The array into which to copy the elements."]},"$nm":"other"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$def":"1","$an":{"doc":["The index of the first element in this array to copy."]},"$nm":"sourcePosition"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$def":"1","$an":{"doc":["The index in the given array into which to \ncopy the first element."]},"$nm":"destinationPosition"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$def":"1","$an":{"doc":["The number of elements to copy."]},"$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Efficiently copy the elements in the segment \n`sourcePosition:length` of this array to the segment \n`destinationPosition:length` of the given array."]},"$nm":"copyTo"},"set":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$an":{"doc":["The index of the element to replace."]},"$nm":"index"},{"$t":{"$nm":"Element"},"$mt":"prm","$an":{"doc":["The new element."]},"$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Replace the existing element at the specified index \nwith the given element. Does nothing if the specified \nindex is negative or larger than the index of the \nlast element in the array."]},"$nm":"set"}},"$at":{"rest":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Array"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The rest of the array, without the first element."],"actual":[]},"$nm":"rest"},"reversed":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Array"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Reverse this array, returning a new array."],"actual":[]},"$nm":"reversed"},"elements":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"attr","$nm":"elements"}},"$nm":"Array"},"ArraySequence":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$ps":[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"elements"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequence"}],"$mt":"cls","$tp":[{"variance":"out","$nm":"Element"}],"$an":{"shared":[],"final":[],"native":[],"see":["SequenceBuilder","SequenceAppender"],"doc":["An immutable `Sequence` implemented using the platform's \nnative array type. Where possible copying of the underlying \narray is avoided. Direct use of this type is discouraged."]},"$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"native":[],"actual":[]},"$nm":"iterator"},"defines":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"key"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"actual":[]},"$nm":"defines"},"get":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"actual":[]},"$nm":"get"},"count":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Boolean"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Empty"}],"$pk":"ceylon.language","$nm":"Tuple"}],"$pk":"ceylon.language","$nm":"Callable"},"$mt":"prm","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"actual":[]},"$nm":"count"},"spanTo":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"to"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"actual":[]},"$nm":"spanTo"},"equals":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"equals"},"segment":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"actual":[]},"$nm":"segment"},"contains":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"actual":[]},"$nm":"contains"},"spanFrom":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"actual":[]},"$nm":"spanFrom"},"span":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"to"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"actual":[]},"$nm":"span"}},"$at":{"lastIndex":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"actual":[]},"$nm":"lastIndex"},"clone":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"ArraySequence"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"clone"},"last":{"$t":{"$nm":"Element"},"$mt":"attr","$an":{"shared":[],"native":[],"actual":[]},"$nm":"last"},"hash":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"hash"},"reversed":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"ArraySequence"},"$mt":"attr","$an":{"shared":[],"native":[],"actual":[]},"$nm":"reversed"},"rest":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"native":[],"actual":[]},"$nm":"rest"},"first":{"$t":{"$nm":"Element"},"$mt":"attr","$an":{"shared":[],"native":[],"actual":[]},"$nm":"first"},"elements":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"attr","$nm":"elements"},"size":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"actual":[]},"$nm":"size"}},"$nm":"ArraySequence"},"Singleton":{"super":{"$pk":"ceylon.language","$nm":"Object"},"$ps":[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequence"}],"$mt":"cls","$tp":[{"variance":"out","$nm":"Element"}],"$an":{"shared":[],"doc":["A sequence with exactly one element, which may be null."]},"$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"default":[],"actual":[]},"$c":{"SingletonIterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"cls","$m":{"next":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$at":{"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"string"},"done":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"var":"1","$mt":"attr","$an":{"shared":[],"actual":[],"variable":[]},"$nm":"done"}},"$nm":"SingletonIterator"}},"$nm":"iterator"},"sort":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Singleton"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Comparison"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"a"},{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"b"}]],"$mt":"prm","$pt":"f","$nm":"comparing"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"sort"},"get":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Returns the contained element, if the specified \nindex is `0`."],"actual":[]},"$nm":"get"},"count":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Returns `1` if this `Singleton`'s element\nsatisfies the predicate, or `0` otherwise."],"actual":[]},"$nm":"count"},"equals":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"that"}]],"$mt":"mthd","$an":{"shared":[],"doc":["A `Singleton` can be equal to another `List` if \nthat `List` has only one element which is equal to \nthis `Singleton`'s element."],"actual":[]},"$nm":"equals"},"segment":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Empty"},{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Singleton"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Returns a `Singleton` if the given starting index \nis `0` and the given `length` is greater than `0`.\nOtherwise, returns an instance of `Empty`."],"actual":[]},"$nm":"segment"},"contains":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Returns `true` if the specified element is this \n`Singleton`'s element."],"actual":[]},"$nm":"contains"},"every":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"e"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"every"},"fold":{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Result"},"$mt":"prm","$nm":"initial"},{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Result"},"$mt":"prm","$nm":"partial"},{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"e"}]],"$mt":"prm","$pt":"f","$nm":"accumulating"}]],"$mt":"mthd","$tp":[{"$nm":"Result"}],"$an":{"shared":[],"actual":[]},"$nm":"fold"},"taking":{"$t":{"comp":"u","$ts":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Singleton"},{"$pk":"ceylon.language","$nm":"Empty"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"take"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"taking"},"spanTo":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Empty"},{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Singleton"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"to"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"spanTo"},"any":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"e"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"any"},"map":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Result"}],"$pk":"ceylon.language","$nm":"Sequence"},"$ps":[[{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"e"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$tp":[{"$nm":"Result"}],"$an":{"shared":[],"actual":[]},"$nm":"map"},"findLast":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"actual":[]},"$nm":"findLast"},"spanFrom":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Empty"},{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Singleton"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"spanFrom"},"skipping":{"$t":{"comp":"u","$ts":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Singleton"},{"$pk":"ceylon.language","$nm":"Empty"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"skip"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"skipping"},"find":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"e"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$m":{"selecting":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"e"}]],"$mt":"mthd","$nm":"selecting"}},"$nm":"find"},"filter":{"$t":{"comp":"u","$ts":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Singleton"},{"$pk":"ceylon.language","$nm":"Empty"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"e"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"filter"},"span":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Empty"},{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Singleton"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"to"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Returns a `Singleton` if the given starting index \nis `0`. Otherwise, returns an instance of `Empty`."],"actual":[]},"$nm":"span"}},"$at":{"lastIndex":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns `0`."],"actual":[]},"$nm":"lastIndex"},"clone":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Singleton"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns a `Singleton` with the same element."],"actual":[]},"$nm":"clone"},"element":{"$t":{"$nm":"Element"},"$mt":"attr","$nm":"element"},"last":{"$t":{"$nm":"Element"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns the element contained in this `Singleton`."],"actual":[]},"$nm":"last"},"hash":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"hash"},"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"string"},"coalesced":{"$t":{"$tp":[{"comp":"i","$mt":"tpm","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Object"}]},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns the Singleton itself, or empty"],"actual":[]},"$nm":"coalesced"},"reversed":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Singleton"},"$mt":"gttr","$an":{"shared":[],"doc":["Return this singleton."],"actual":[]},"$nm":"reversed"},"rest":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns `Empty`."],"actual":[]},"$nm":"rest"},"first":{"$t":{"$nm":"Element"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns the element contained in this `Singleton`."],"actual":[]},"$nm":"first"},"size":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns `1`."],"actual":[]},"$nm":"size"}},"$nm":"Singleton"},"byKey":{"$t":{"$pk":"ceylon.language","$nm":"Comparison"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Comparison"},"$ps":[[{"$t":{"$nm":"Key"},"$mt":"prm","$nm":"x"},{"$t":{"$nm":"Key"},"$mt":"prm","$nm":"y"}]],"$mt":"prm","$pt":"f","$nm":"comparing"}],[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"}],"$pk":"ceylon.language","$nm":"Entry"},"$mt":"prm","$nm":"x"},{"$t":{"$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"}],"$pk":"ceylon.language","$nm":"Entry"},"$mt":"prm","$nm":"y"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Key"}],"$an":{"shared":[],"see":["byItem"],"doc":["A comparator for `Entry`s which compares their keys \naccording to the given `comparing()` function."]},"$nm":"byKey"},"Comparable":{"of":[{"$nm":"Other"}],"$mt":"ifc","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Comparable"}],"variance":"in","$nm":"Other"}],"$an":{"shared":[],"doc":["The general contract for values whose magnitude can be \ncompared. `Comparable` imposes a total ordering upon\ninstances of any type that satisfies the interface.\nIf a type `T` satisfies `Comparable<T>`, then instances\nof `T` may be compared using the comparison operators\n`<`, `>`, `<=`, `>=`, and `<=>`.\n\nThe total order of a type must be consistent with the \ndefinition of equality for the type. That is, there\nare three mutually exclusive possibilities:\n\n- `x<y`,\n- `x>y`, or\n- `x==y`"],"by":["Gavin"]},"$m":{"compare":{"$t":{"$pk":"ceylon.language","$nm":"Comparison"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"see":["equals"],"doc":["Compares this value with the given value. \nImplementations must respect the constraints that: \n\n- `x==y` if and only if `x<=>y == equal` \n   (consistency with `equals()`), \n- if `x>y` then `y<x` (symmetry), and \n- if `x>y` and `y>z` then `x>z` (transitivity)."]},"$nm":"compare"}},"$nm":"Comparable","$st":"Other"},"AbstractAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"AbstractAnnotation"},{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"ClassDeclaration"}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[abstract]]."]},"$annot":"1","$nm":"AbstractAnnotation"},"Comparison":{"abstract":"1","super":{"$pk":"ceylon.language","$nm":"Basic"},"of":[{"$pk":"ceylon.language","$nm":"larger"},{"$pk":"ceylon.language","$nm":"smaller"},{"$pk":"ceylon.language","$nm":"equal"}],"$ps":[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$an":{"shared":[],"actual":[]},"$nm":"string"}],"$mt":"cls","$an":{"abstract":[],"shared":[],"see":["Comparable"],"doc":["The result of a comparison between two `Comparable` \nobjects."],"by":["Gavin"]},"$m":{"largerThan":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"mthd","$an":{"shared":[],"deprecated":[]},"$nm":"largerThan"},"equal":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"mthd","$an":{"shared":[],"deprecated":[]},"$nm":"equal"},"asSmallAs":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"mthd","$an":{"shared":[],"deprecated":[]},"$nm":"asSmallAs"},"asLargeAs":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"mthd","$an":{"shared":[],"deprecated":[]},"$nm":"asLargeAs"},"smallerThan":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"mthd","$an":{"shared":[],"deprecated":[]},"$nm":"smallerThan"},"unequal":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"mthd","$an":{"shared":[],"deprecated":[]},"$nm":"unequal"}},"$at":{"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"string"}},"$nm":"Comparison"},"Empty":{"of":[{"$pk":"ceylon.language","$nm":"empty"}],"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Sequential"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Empty"}],"$pk":"ceylon.language","$nm":"Ranged"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Empty"}],"$pk":"ceylon.language","$nm":"Cloneable"}],"$mt":"ifc","$an":{"shared":[],"see":["Sequence"],"doc":["A sequence with no elements. The type `Empty` may be\nabbreviated `[]`, and an instance is produced by the \nexpression `[]`. That is, in the following expression,\n`e` has type `[]` and refers to the value `[]`:\n\n    [] none = [];\n\n(Whether the syntax `[]` refers to the type or the \nvalue depends upon how it occurs grammatically.)"]},"$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"doc":["Returns an iterator that is already exhausted."],"actual":[]},"$nm":"iterator"},"sort":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Comparison"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"a"},{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"b"}]],"$mt":"prm","$pt":"f","$nm":"comparing"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"sort"},"get":{"$t":{"$pk":"ceylon.language","$nm":"Null"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Returns `null` for any given index."],"actual":[]},"$nm":"get"},"count":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Returns 0 for any given predicate."],"actual":[]},"$nm":"count"},"select":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"select"},"segment":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Returns an `Empty` for any given segment."],"actual":[]},"$nm":"segment"},"by":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"step"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"by"},"contains":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Returns `false` for any given element."],"actual":[]},"$nm":"contains"},"every":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"every"},"fold":{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Result"},"$mt":"prm","$nm":"initial"},{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Result"},"$mt":"prm","$nm":"partial"},{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"accumulating"}]],"$mt":"mthd","$tp":[{"$nm":"Result"}],"$an":{"shared":[],"actual":[]},"$nm":"fold"},"taking":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"take"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"taking"},"following":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$nm":"head"}]],"$mt":"mthd","$tp":[{"$nm":"Other"}],"$an":{"shared":[],"actual":[]},"$nm":"following"},"withTrailing":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Empty"}],"$pk":"ceylon.language","$nm":"Tuple"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$tp":[{"$nm":"Element"}],"$an":{"shared":[],"actual":[]},"$nm":"withTrailing"},"defines":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"defines"},"spanTo":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"to"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Returns an `Empty` for any given span."],"actual":[]},"$nm":"spanTo"},"chain":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"},{"$mt":"tpm","$nm":"OtherAbsent"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"},{"$mt":"tpm","$nm":"OtherAbsent"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$tp":[{"$nm":"Other"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Null"}],"$nm":"OtherAbsent"}],"$an":{"shared":[],"doc":["Returns `other`."],"actual":[]},"$nm":"chain"},"any":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"any"},"map":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"collecting"}]],"$mt":"mthd","$tp":[{"$nm":"Result"}],"$an":{"shared":[],"actual":[]},"$nm":"map"},"withLeading":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Empty"}],"$pk":"ceylon.language","$nm":"Tuple"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$tp":[{"$nm":"Element"}],"$an":{"shared":[],"actual":[]},"$nm":"withLeading"},"spanFrom":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Returns an `Empty` for any given span."],"actual":[]},"$nm":"spanFrom"},"skipping":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"skip"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"skipping"},"find":{"$t":{"$pk":"ceylon.language","$nm":"Null"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"find"},"filter":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"filter"},"collect":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"collecting"}]],"$mt":"mthd","$tp":[{"$nm":"Result"}],"$an":{"shared":[],"actual":[]},"$nm":"collect"},"span":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"to"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Returns an `Empty` for any given span."],"actual":[]},"$nm":"span"}},"$at":{"lastIndex":{"$t":{"$pk":"ceylon.language","$nm":"Null"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns `null`."],"actual":[]},"$nm":"lastIndex"},"clone":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns an `Empty`."],"actual":[]},"$nm":"clone"},"last":{"$t":{"$pk":"ceylon.language","$nm":"Null"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns `null`."],"actual":[]},"$nm":"last"},"indexed":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns an `Empty`."],"actual":[]},"$nm":"indexed"},"sequence":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns an `Empty`."],"actual":[]},"$nm":"sequence"},"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns a string description of the empty sequence: \n`{}`."],"actual":[]},"$nm":"string"},"coalesced":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns an `Empty`."],"actual":[]},"$nm":"coalesced"},"empty":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns `true`."],"actual":[]},"$nm":"empty"},"rest":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns an `Empty`."],"actual":[]},"$nm":"rest"},"reversed":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns an `Empty`."],"actual":[]},"$nm":"reversed"},"first":{"$t":{"$pk":"ceylon.language","$nm":"Null"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns `null`."],"actual":[]},"$nm":"first"},"size":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns 0."],"actual":[]},"$nm":"size"}},"$nm":"Empty"},"annotation":{"$t":{"$pk":"ceylon.language","$nm":"AnnotationAnnotation"},"$mt":"mthd","$an":{"annotation":[],"shared":[],"see":["Annotation"],"doc":["Annotation to mark a class as an *annotation class*, or a \ntop-level function as an *annotation constructor*."]},"$annot":"1","$nm":"annotation"},"ActualAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"ActualAnnotation"},{"comp":"u","$mt":"tpm","$ts":[{"$pk":"ceylon.language.meta.declaration","$nm":"ValueDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"FunctionDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"ClassOrInterfaceDeclaration"}]}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[actual]]."]},"$annot":"1","$nm":"ActualAnnotation"},"SeeAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$ps":[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"Declaration"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$an":{"shared":[],"doc":["The program elements being referred to."]},"$nm":"programElements"}],"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"SeeAnnotation"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Annotated"}],"$pk":"ceylon.language","$nm":"SequencedAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[see]]."]},"$annot":"1","$at":{"programElements":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"Declaration"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"doc":["The program elements being referred to."]},"$nm":"programElements"}},"$nm":"SeeAnnotation"},"Enumerable":{"of":[{"$nm":"Other"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Ordinal"}],"$mt":"ifc","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Enumerable"}],"variance":"out","$nm":"Other"}],"$an":{"shared":[],"doc":["Abstraction of ordinal types whose instances can be \nmapped to the integers or to a range of integers."]},"$at":{"integerValue":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The corresponding integer. The implementation must\nsatisfy these constraints:\n\n    (x.successor).integerValue = x.integerValue+1\n    (x.predecessor).integerValue = x.integerValue-1\n\nfor every instance `x` of the enumerable type."]},"$nm":"integerValue"}},"$nm":"Enumerable","$st":"Other"},"empty":{"super":{"$pk":"ceylon.language","$nm":"Object"},"satisfies":[{"$pk":"ceylon.language","$nm":"Empty"}],"$mt":"obj","$an":{"shared":[],"doc":["A sequence with no elements, abbreviated `[]`. The \nunique instance of the type `[]`."]},"$nm":"empty"},"false":{"super":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"obj","$an":{"shared":[],"doc":["A value representing falsity in Boolean logic."]},"$at":{"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"string"}},"$nm":"false"},"DeprecationAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$ps":[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$an":{"shared":[],"doc":["A description, in Markdown syntax, of why the element is deprecated, \nand what replacements are available."]},"$nm":"description"}],"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"DeprecationAnnotation"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Annotated"}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[deprecated]]."]},"$annot":"1","$at":{"reason":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"String"}]},"$mt":"gttr","$an":{"shared":[],"doc":["A description, in Markdown syntax, of why the element is deprecated, \nand what replacements are available, or null."]},"$nm":"reason"},"description":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"doc":["A description, in Markdown syntax, of why the element is deprecated, \nand what replacements are available."]},"$nm":"description"}},"$nm":"DeprecationAnnotation"},"compose":{"$t":{"$tp":[{"$mt":"tpm","$nm":"X"},{"$mt":"tpm","$nm":"Args"}],"$pk":"ceylon.language","$nm":"Callable"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"X"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Y"},{"$mt":"tpm","$nm":"Y"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Empty"}],"$pk":"ceylon.language","$nm":"Tuple"}],"$pk":"ceylon.language","$nm":"Callable"},"$mt":"prm","$nm":"x"},{"$t":{"$tp":[{"$mt":"tpm","$nm":"Y"},{"$mt":"tpm","$nm":"Args"}],"$pk":"ceylon.language","$nm":"Callable"},"$mt":"prm","$nm":"y"}]],"$mt":"mthd","$tp":[{"$nm":"X"},{"$nm":"Y"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$nm":"Args"}],"$an":{"shared":[],"see":["curry","uncurry"],"doc":["Given a function with return type `Y`, and a second \nfunction with a single parameter also of type `Y`, \nreturn the composition of the two functions. The\nfirst function may have any number of parameters.\n\nFor any such functions `f()` and `g()`,\n\n    compose(g,f)(*args)==g(f(*args))\n\nfor every possible argument tuple `args` of `f()`."]},"$nm":"compose"},"Sequential":{"of":[{"$pk":"ceylon.language","$nm":"Empty"},{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequence"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$pk":"ceylon.language","$nm":"Ranged"},{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$pk":"ceylon.language","$nm":"Cloneable"}],"$mt":"ifc","$tp":[{"variance":"out","$nm":"Element"}],"$an":{"shared":[],"see":["Tuple"],"doc":["A possibly-empty, immutable sequence of values. The \ntype `Sequential<Element>` may be abbreviated \n`[Element*]` or `Element[]`. \n\n`Sequential` has two enumerated subtypes:\n\n- `Empty`, abbreviated `[]`, represents an empty \n   sequence, and\n- `Sequence<Element>`, abbreviated `[Element+]` \n   represents a non-empty sequence, and has the very\n   important subclass `Tuple`."]},"$m":{"terminal":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Select the last elements of the sequence, returning a \nsequence no longer than the given length. If this \nsequence is shorter than the given length, return this \nsequence. Otherwise return a sequence of the given \nlength."],"actual":[]},"$nm":"terminal"},"trimTrailing":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$nm":"trimming"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Trim the elements satisfying the given predicate\nfunction from the end of this sequence, returning \na sequence no longer than this sequence."],"actual":[]},"$nm":"trimTrailing"},"initial":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Select the first elements of this sequence, returning \na sequence no longer than the given length. If this \nsequence is shorter than the given length, return this \nsequence. Otherwise return a sequence of the given \nlength."],"actual":[]},"$nm":"initial"},"trimLeading":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$nm":"trimming"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Trim the elements satisfying the given predicate\nfunction from the start of this sequence, returning \na sequence no longer than this sequence."],"actual":[]},"$nm":"trimLeading"},"repeat":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"times"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Returns a sequence formed by repeating the elements of \nthis sequence the given number of times, or an empty \nsequence if `times<=0`."],"actual":[]},"$nm":"repeat"},"trim":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$nm":"trimming"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Trim the elements satisfying the given predicate\nfunction from the start and end of this sequence, \nreturning a sequence no longer than this sequence."],"actual":[]},"$nm":"trim"}},"$at":{"clone":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["This sequence."],"actual":[]},"$nm":"clone"},"sequence":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["This sequence."],"actual":[]},"$nm":"sequence"},"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["A string of form `\"[ x, y, z ]\"` where `x`, `y`, \nand `z` are the `string` representations of the \nelements of this collection, as produced by the\niterator of the collection, or the string `\"{}\"` \nif this collection is empty. If the collection \niterator produces the value `null`, the string\nrepresentation contains the string `\"null\"`."],"actual":[]},"$nm":"string"},"rest":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The rest of the sequence, without the first \nelement."],"actual":[]},"$nm":"rest"},"reversed":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["Reverse this sequence, returning a new sequence."],"actual":[]},"$nm":"reversed"}},"$nm":"Sequential"},"Finished":{"abstract":"1","super":{"$pk":"ceylon.language","$nm":"Basic"},"of":[{"$pk":"ceylon.language","$nm":"finished"}],"$mt":"cls","$an":{"abstract":[],"shared":[],"see":["Iterator"],"doc":["The type of the value that indicates that \nan `Iterator` is exhausted and has no more \nvalues to return."]},"$nm":"Finished"},"coalesce":{"$t":{"$tp":[{"comp":"i","$mt":"tpm","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Object"}]},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$an":{"doc":["The values, some of which may be null."]},"$nm":"values"}]],"$mt":"mthd","$tp":[{"$nm":"Element"}],"$an":{"shared":[],"doc":["Return a sequence containing the given values which are\nnot null. If there are no values which are not null,\nreturn an empty sequence."]},"$nm":"coalesce"},"plus":{"$t":{"$nm":"Value"},"$ps":[[{"$t":{"$nm":"Value"},"$mt":"prm","$nm":"x"},{"$t":{"$nm":"Value"},"$mt":"prm","$nm":"y"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Value"}],"$pk":"ceylon.language","$nm":"Summable"}],"$nm":"Value"}],"$an":{"shared":[],"see":["times","sum"],"doc":["Add the given `Summable` values."]},"$nm":"plus"},"final":{"$t":{"$pk":"ceylon.language","$nm":"FinalAnnotation"},"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to mark a class as final. A `final` class may \nnot be extended. Marking a class as final affects disjoint\ntype analysis."]},"$annot":"1","$nm":"final"},"Entry":{"super":{"$pk":"ceylon.language","$nm":"Object"},"$ps":[{"$t":{"$nm":"Key"},"$hdn":"1","$mt":"prm","$an":{"shared":[],"doc":["The key used to access the entry."]},"$nm":"key"},{"$t":{"$nm":"Item"},"$hdn":"1","$mt":"prm","$an":{"shared":[],"doc":["The value associated with the key."]},"$nm":"item"}],"$mt":"cls","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"variance":"out","$nm":"Key"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"variance":"out","$nm":"Item"}],"$an":{"shared":[],"final":[],"doc":["A pair containing a _key_ and an associated value called \nthe _item_. Used primarily to represent the elements of \na `Map`. The type `Entry<Key,Item>` may be abbreviated \n`Key->Item`. An instance of `Entry` may be constructed \nusing the `->` operator:\n\n    String->Person entry = person.name->person;\n"],"by":["Gavin"]},"$m":{"equals":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"that"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Determines if this entry is equal to the given entry. \nTwo entries are equal if they have the same key and \nthe same value."],"actual":[]},"$nm":"equals"}},"$at":{"hash":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"hash"},"pair":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Key"},{"$nm":"Item"}]},{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Item"},{"$mt":"tpm","$nm":"Item"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Empty"}],"$pk":"ceylon.language","$nm":"Tuple"}],"$pk":"ceylon.language","$nm":"Tuple"},"$mt":"gttr","$an":{"shared":[],"doc":["A pair (2 element tuple) with the key and\nitem of this entry."]},"$nm":"pair"},"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns a description of the entry in the form \n`key->item`."],"actual":[]},"$nm":"string"},"item":{"$t":{"$nm":"Item"},"$mt":"attr","$an":{"shared":[],"doc":["The value associated with the key."]},"$nm":"item"},"key":{"$t":{"$nm":"Key"},"$mt":"attr","$an":{"shared":[],"doc":["The key used to access the entry."]},"$nm":"key"}},"$nm":"Entry"},"aInt":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$nm":"aInt"},"Cloneable":{"of":[{"$nm":"Clone"}],"$mt":"ifc","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Clone"}],"$pk":"ceylon.language","$nm":"Cloneable"}],"variance":"out","$nm":"Clone"}],"$an":{"shared":[],"doc":["Abstract supertype of objects whose value can be \ncloned."]},"$at":{"clone":{"$t":{"$nm":"Clone"},"$mt":"gttr","$an":{"shared":[],"formal":[],"doc":["Obtain a clone of this object. For a mutable \nobject, this should return a copy of the object. \nFor an immutable object, it is acceptable to return\nthe object itself."]},"$nm":"clone"}},"$nm":"Cloneable","$st":"Clone"},"Invertable":{"of":[{"$nm":"Inverse"}],"$mt":"ifc","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Inverse"}],"$pk":"ceylon.language","$nm":"Invertable"}],"variance":"out","$nm":"Inverse"}],"$an":{"shared":[],"see":["Integer","Float"],"doc":["Abstraction of types which support a unary additive \ninversion operation `-x`. For a [[numeric type|Numeric]], \nthis should return the negative of the argument value.\n\nImplementations which also satisfy [[Summable]] should \nrespect the following constraint:\n\n- `x + -x == 0`"],"by":["Gavin"]},"$at":{"positiveValue":{"$t":{"$nm":"Inverse"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The value itself, expressed as an instance of the\nwider type."]},"$nm":"positiveValue"},"negativeValue":{"$t":{"$nm":"Inverse"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The additive inverse of the value, which may be expressed\nas an instance of a wider type."]},"$nm":"negativeValue"}},"$nm":"Invertable","$st":"Inverse"},"Ordinal":{"of":[{"$nm":"Other"}],"$mt":"ifc","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Ordinal"}],"variance":"out","$nm":"Other"}],"$an":{"shared":[],"see":["Character","Integer","Integral","Range"],"doc":["Abstraction of ordinal types, that is, types with \nsuccessor and predecessor operations, including\n`Integer` and other `Integral` numeric types.\n`Character` is also considered an ordinal type. \n`Ordinal` types may be used to generate a `Range`."],"by":["Gavin"]},"$at":{"predecessor":{"$t":{"$nm":"Other"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The predecessor of this value."]},"$nm":"predecessor"},"successor":{"$t":{"$nm":"Other"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The successor of this value."]},"$nm":"successor"}},"$nm":"Ordinal","$st":"Other"},"largest":{"$t":{"$nm":"Element"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"x"},{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"y"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Comparable"}],"$nm":"Element"}],"$an":{"shared":[],"see":["Comparable","smallest","max"],"doc":["Given two `Comparable` values, return largest of the\ntwo."]},"$nm":"largest"},"zipPairs":{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"First"},{"$nm":"Second"}]},{"$mt":"tpm","$nm":"First"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Second"},{"$mt":"tpm","$nm":"Second"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Empty"}],"$pk":"ceylon.language","$nm":"Tuple"}],"$pk":"ceylon.language","$nm":"Tuple"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"First"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"firstElements"},{"$t":{"$tp":[{"$mt":"tpm","$nm":"Second"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"secondElements"}]],"$mt":"mthd","$tp":[{"$nm":"First"},{"$nm":"Second"}],"$an":{"shared":[],"doc":["Given two streams, form a new stream consisting of\nall pairs where, for any given index in the resulting\nstream, the first element of the pair is the element \noccurring at the same index in the first stream, and \nthe second element of the pair is the element occurring \nat the same index in the second stream. The length of \nthe resulting stream is the length of the shorter of the \ntwo given streams.\n\nThus:\n\n    zipPairs(xs,ys)[i]==[xs[i],ys[i]]\n\nfor every `0<=i<min({xs.size,ys.size})`."]},"$nm":"zipPairs"},"system":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$mt":"obj","$an":{"shared":[],"native":[],"doc":["Represents the system on which the current process is running.\n\nHolds information about system time and locale."]},"$at":{"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"string"},"locale":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Returns the IETF language tag representing the default locale for this system."]},"$nm":"locale"},"nanoseconds":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The elapsed time in nanoseconds since an arbitrary starting point."]},"$nm":"nanoseconds"},"timezoneOffset":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Returns the offset from UTC, in milliseconds, of the default timezone for this system."]},"$nm":"timezoneOffset"},"milliseconds":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The elapsed time in milliseconds since midnight, 1 January 1970."]},"$nm":"milliseconds"}},"$nm":"system"},"native":{"$t":{"$pk":"ceylon.language","$nm":"NativeAnnotation"},"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to mark a member whose implementation is defined \nin platform-native code."]},"$annot":"1","$nm":"native"},"unflatten":{"$t":{"$nm":"Return"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Return"},{"$mt":"tpm","$nm":"Args"}],"$pk":"ceylon.language","$nm":"Callable"},"$mt":"prm","$nm":"flatFunction"}],[{"$t":{"$nm":"Args"},"$mt":"prm","$nm":"args"}]],"$mt":"mthd","$tp":[{"$nm":"Return"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$nm":"Args"}],"$an":{"shared":[],"native":[],"see":["flatten"],"doc":["Given a function with parameter types \n`P1`, `P2`, ..., `Pn`, return a function with a single\nparameter of tuple type `[P1, P2, ..., Pn]`.\n\nThat is, if `fun` has type `W(X,Y,Z)` then \n`unflatten(fun)` has type `W([X,Y,Z])`."]},"$nm":"unflatten"},"formatInteger":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"integer"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$def":"1","$nm":"radix"}]],"$mt":"mthd","$an":{"shared":[],"throws":["AssertionException","if `radix` is not between `minRadix` and `maxRadix`"],"doc":["The string representation of `integer` in the `radix` base.\n`radix` must be between `minRadix` and `maxRadix` included.\n\nIf `integer` is negative, returned string will start by character `-`"]},"$nm":"formatInteger"},"greaterThan":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"val"}],[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Comparable"}],"$nm":"Element"}],"$an":{"shared":[],"doc":["Returns a partial function that will compare an element\nto any other element and returns true if the compared\nelement is greater than its element.\nThis is useful in conjunction with methods that receive\na predicate function."]},"$nm":"greaterThan"},"Identifiable":{"$mt":"ifc","$an":{"shared":[],"doc":["The abstract supertype of all types with a well-defined\nnotion of identity. Values of type `Identifiable` may \nbe compared using the `===` operator to determine if \nthey are references to the same object instance. For\nthe sake of convenience, this interface defines a\ndefault implementation of value equality equivalent\nto identity. Of course, subtypes are encouraged to\nrefine this implementation."],"by":["Gavin"]},"$m":{"equals":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"that"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Identity equality comparing the identity of the two \nvalues. May be refined by subtypes for which value \nequality is more appropriate. Implementations must\nrespect the constraint that if `x===y` then `x==y` \n(equality is consistent with identity)."],"actual":[]},"$nm":"equals"}},"$at":{"hash":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"default":[],"see":["identityHash"],"doc":["The system-defined identity hash value of the \ninstance. Subtypes which refine `equals()` must \nalso refine `hash`, according to the general \ncontract defined by `Object`."],"actual":[]},"$nm":"hash"}},"$nm":"Identifiable"},"language":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$mt":"obj","$an":{"shared":[],"native":[],"doc":["Contains information about the language"]},"$at":{"majorVersion":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The Ceylon language major version."]},"$nm":"majorVersion"},"majorVersionBinary":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The major version of the code generated for the underlying runtime."]},"$nm":"majorVersionBinary"},"minorVersion":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The Ceylon language minor version."]},"$nm":"minorVersion"},"versionName":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The Ceylon language release name."]},"$nm":"versionName"},"releaseVersion":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The Ceylon language release version."]},"$nm":"releaseVersion"},"minorVersionBinary":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The minor version of the code generated for the underlying runtime."]},"$nm":"minorVersionBinary"},"version":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The Ceylon language version."]},"$nm":"version"}},"$nm":"language"},"emptySet":{"super":{"$pk":"ceylon.language","$nm":"Object"},"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Set"}],"$mt":"obj","$an":{"shared":[],"doc":["A [[Set]] with no elements."]},"$m":{"intersection":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"set"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Other"}],"$an":{"shared":[],"actual":[]},"$nm":"intersection"},"iterator":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator"},"containsAny":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"elements"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"containsAny"},"superset":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"set"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"superset"},"count":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"count"},"select":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"select"},"by":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"step"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"by"},"contains":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"contains"},"every":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"every"},"fold":{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Result"},"$mt":"prm","$nm":"initial"},{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Result"},"$mt":"prm","$nm":"partial"},{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"accumulating"}]],"$mt":"mthd","$tp":[{"$nm":"Result"}],"$an":{"shared":[],"actual":[]},"$nm":"fold"},"taking":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"take"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"taking"},"complement":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"set"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Other"}],"$an":{"shared":[],"actual":[]},"$nm":"complement"},"subset":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"set"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"subset"},"exclusiveUnion":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"set"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Other"}],"$an":{"shared":[],"actual":[]},"$nm":"exclusiveUnion"},"any":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"any"},"union":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"set"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Other"}],"$an":{"shared":[],"actual":[]},"$nm":"union"},"map":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"collecting"}]],"$mt":"mthd","$tp":[{"$nm":"Result"}],"$an":{"shared":[],"actual":[]},"$nm":"map"},"skipping":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"skip"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"skipping"},"find":{"$t":{"$pk":"ceylon.language","$nm":"Null"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"find"},"filter":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"filter"},"collect":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"collecting"}]],"$mt":"mthd","$tp":[{"$nm":"Result"}],"$an":{"shared":[],"actual":[]},"$nm":"collect"},"containsEvery":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"elements"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"containsEvery"}},"$at":{"clone":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"clone"},"empty":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"empty"},"size":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"size"}},"$nm":"emptySet"},"Null":{"abstract":"1","super":{"$pk":"ceylon.language","$nm":"Anything"},"of":[{"$pk":"ceylon.language","$nm":"null"}],"$mt":"cls","$an":{"abstract":[],"shared":[],"see":["null"],"doc":["The type of the `null` value. Any union type of form \n`Null|T` is considered an _optional_ type, whose values\ninclude `null`. Any type of this form may be written as\n`T?` for convenience.\n\nThe `if (exists ... )` construct, or, alternatively,\nthe `assert (exists ...)` construct, may be used to\nnarrow an optional type to a _definite_ type, that is,\na subtype of `Object`:\n\n    String? firstArg = process.arguments.first;\n    if (exists firstArg) {\n        print(\"hello \" + firstArg);\n    }\n\nThe `else` operator evaluates its second operand if \nand only if its first operand is `null`:\n\n    String name = process.arguments.first else \"world\";\n\nThe `then` operator evaluates its second operand when\nits first operand evaluates to `true`, and to `null` \notherwise:\n\n    Float? diff = x>=y then x-y;"],"by":["Gavin"]},"$nm":"Null"},"stringify":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"prm","$nm":"val"}]],"$mt":"mthd","$nm":"stringify"},"sort":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"elements"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Comparable"}],"$nm":"Element"}],"$an":{"shared":[],"see":["Comparable"],"doc":["Sort the given elements, returning a new sequence."]},"$nm":"sort"},"equalTo":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"val"}],[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Element"}],"$an":{"shared":[],"doc":["Returns a partial function that will compare an element\nto any other element and returns true if they're equal.\nThis is useful in conjunction with methods that receive\na predicate function."]},"$nm":"equalTo"},"AssertionException":{"super":{"$pk":"ceylon.language","$nm":"Exception"},"$ps":[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"message"}],"$mt":"cls","$an":{"shared":[],"doc":["An exception that occurs when an assertion fails, that\nis, when a condition in an `assert` statement evaluates\nto false at runtime."]},"$at":{"message":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$nm":"message"}},"$nm":"AssertionException"},"suppressedExceptions":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Exception"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Exception"},"$mt":"prm","$nm":"exception"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Returns the exceptions that were suppressed (if any) during the handling of the given exception."]},"$nm":"suppressedExceptions"},"arrayOfSize":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Array"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$an":{"doc":["The size of the resulting array. If the size\nis non-positive, an empty array will be \ncreated."]},"$nm":"size"},{"$t":{"$nm":"Element"},"$mt":"prm","$an":{"doc":["The element value with which to populate the\narray. All elements of the resulting array \nwill have the same value."]},"$nm":"element"}]],"$mt":"mthd","$tp":[{"$nm":"Element"}],"$an":{"shared":[],"native":[],"doc":["Create an array of the specified size, populating every \nindex with the given element. If the specified size is\nsmaller than `1`, return an empty array of the given\nelement type."]},"$nm":"arrayOfSize"},"Ranged":{"of":[{"$nm":"Span"}],"$mt":"ifc","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Index"}],"$pk":"ceylon.language","$nm":"Comparable"}],"variance":"in","$nm":"Index"},{"variance":"out","$nm":"Span"}],"$an":{"shared":[],"see":["List","Sequence","String"],"doc":["Abstract supertype of ranged objects which map a range\nof `Comparable` keys to ranges of values. The type\nparameter `Span` abstracts the type of the resulting\nrange.\n\nA span may be obtained from an instance of `Ranged`\nusing the span operator:\n\n    print(\"hello world\"[0..5])\n"]},"$m":{"spanTo":{"$t":{"$nm":"Span"},"$ps":[[{"$t":{"$nm":"Index"},"$mt":"prm","$nm":"to"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Obtain a span containing the mapped values between\nthe start of the receiver and the end index."]},"$nm":"spanTo"},"segment":{"$t":{"$nm":"Span"},"$ps":[[{"$t":{"$nm":"Index"},"$mt":"prm","$nm":"from"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Obtain a segment containing the mapped values\nstarting from the given index, with the given \nlength."]},"$nm":"segment"},"spanFrom":{"$t":{"$nm":"Span"},"$ps":[[{"$t":{"$nm":"Index"},"$mt":"prm","$nm":"from"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Obtain a span containing the mapped values between\nthe starting index and the end of the receiver."]},"$nm":"spanFrom"},"span":{"$t":{"$nm":"Span"},"$ps":[[{"$t":{"$nm":"Index"},"$mt":"prm","$nm":"from"},{"$t":{"$nm":"Index"},"$mt":"prm","$nm":"to"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Obtain a span containing the mapped values between \nthe two given indices."]},"$nm":"span"}},"$nm":"Ranged","$st":"Span"},"OptionalImportAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"OptionalImportAnnotation"},{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"Import"}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[optional]]."]},"$annot":"1","$nm":"OptionalImportAnnotation"},"times":{"$t":{"$nm":"Value"},"$ps":[[{"$t":{"$nm":"Value"},"$mt":"prm","$nm":"x"},{"$t":{"$nm":"Value"},"$mt":"prm","$nm":"y"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Value"}],"$pk":"ceylon.language","$nm":"Numeric"}],"$nm":"Value"}],"$an":{"shared":[],"see":["plus","product"],"doc":["Multiply the given `Numeric` values."]},"$nm":"times"},"entries":{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"comp":"i","$mt":"tpm","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Object"}]}],"$pk":"ceylon.language","$nm":"Entry"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"elements"}]],"$mt":"mthd","$tp":[{"$nm":"Element"}],"$an":{"shared":[],"see":["Iterable.indexed"],"doc":["Given a stream of items, produce a stream of entries. \nFor each non-null item produced by the given stream \nof items, the resulting stream contains an `Entry` \nof form `key->item` where `key` is the index at which\nthe item occurs in the stream of items."]},"$nm":"entries"},"FormalAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"FormalAnnotation"},{"comp":"u","$mt":"tpm","$ts":[{"$pk":"ceylon.language.meta.declaration","$nm":"ValueDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"FunctionDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"ClassOrInterfaceDeclaration"}]}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[formal]]."]},"$annot":"1","$nm":"FormalAnnotation"},"license":{"$t":{"$pk":"ceylon.language","$nm":"LicenseAnnotation"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$an":{"doc":["The name, text, or URL of the license."]},"$nm":"description"}]],"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to specify the URL of the license of a module or \npackage."]},"$annot":"1","$nm":"license"},"null":{"super":{"$pk":"ceylon.language","$nm":"Null"},"$mt":"obj","$an":{"shared":[],"doc":["The null value."],"by":["Gavin"]},"$nm":"null"},"Object":{"abstract":"1","super":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"cls","$an":{"abstract":[],"shared":[],"see":["Basic","Null"],"doc":["The abstract supertype of all types representing \ndefinite values. Any two `Object`s may be compared\nfor value equality using the `==` and `!=` operators:\n\n    true==false\n    1==\"hello world\"\n    \"hello\"+\" \"+\"world\"==\"hello world\"\n    Singleton(\"hello world\")=={ \"hello world\" }\n\nHowever, since `Null` is not a subtype of `Object`, the\nvalue `null` cannot be compared to any other value\nusing `==`. Thus, value equality is not defined for\noptional types. This neatly voids the problem of\ndeciding the value of the expression `null==null`,\nwhich is simply illegal."],"by":["Gavin"]},"$m":{"equals":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"that"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Determine if two values are equal. Implementations\nshould respect the constraints that:\n\n- if `x===y` then `x==y` (reflexivity), \n- if `x==y` then `y==x` (symmetry), \n- if `x==y` and `y==z` then `x==z` (transitivity).\n\nFurthermore it is recommended that implementations\nensure that if `x==y` then `x` and `y` have the\nsame concrete class."]},"$nm":"equals"}},"$at":{"hash":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"formal":[],"doc":["The hash value of the value, which allows the value\nto be an element of a hash-based set or key of a\nhash-based map. Implementations must respect the\nconstraint that if `x==y` then `x.hash==y.hash`."]},"$nm":"hash"},"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["A developer-friendly string representing the \ninstance. Concatenates the name of the concrete \nclass of the instance with the `hash` of the \ninstance. Subclasses are encouraged to refine this \nimplementation to produce a more meaningful \nrepresentation."]},"$nm":"string"}},"$nm":"Object"},"LicenseAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$ps":[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$an":{"shared":[],"doc":["The name, text, or URL of the license."]},"$nm":"description"}],"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"LicenseAnnotation"},{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"Module"}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[license]]."]},"$annot":"1","$at":{"description":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"doc":["The name, text, or URL of the license."]},"$nm":"description"}},"$nm":"LicenseAnnotation"},"Float":{"super":{"$pk":"ceylon.language","$nm":"Object"},"$ps":[{"$t":{"$pk":"ceylon.language","$nm":"Float"},"$mt":"prm","$nm":"float"}],"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Float"}],"$pk":"ceylon.language","$nm":"Scalar"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Float"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Float"}],"$pk":"ceylon.language","$nm":"Exponentiable"}],"$mt":"cls","$an":{"shared":[],"final":[],"native":[],"doc":["An IEEE 754 64-bit [floating point number][]. A `Float` \nis capable of approximately representing numeric values \nbetween 2<sup>-1022<\/sup> and \n(2-2<sup>-52<\/sup>)×2<sup>1023<\/sup>, along with \nthe special values `infinity` and `-infinity`, and \nundefined values (Not a Number). Zero is represented by \ndistinct instances `+0`, `-0`, but these instances are \nequal. An undefined value is not equal to any other\nvalue, not even to itself.\n\n[floating point number]: http:\/\/www.validlab.com\/goldberg\/paper.pdf"]},"$at":{"strictlyNegative":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Determines if this value is a negative number, `-0`, \nor `-infinity`. Produces `false` for a positive \nnumber, `+0`, or undefined."]},"$nm":"strictlyNegative"},"sign":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The sign of this value. Produces `1` for a positive \nnumber or `infinity`. Produces `-1` for a negative\nnumber or `-infinity`. Produces `0` for `+0`, `-0`, \nor undefined."],"actual":[]},"$nm":"sign"},"infinite":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"gttr","$an":{"shared":[],"see":["infinity","finite"],"doc":["Determines whether this value is infinite in \nmagnitude. Produces `true` for `infinity` and \n`-infinity`. Produces `false` for a finite number, \n`+0`, `-0`, or undefined."]},"$nm":"infinite"},"undefined":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"gttr","$an":{"shared":[],"doc":["Determines whether this value is undefined (that is, \nNot a Number or NaN). The undefined value has the \nproperty that it is not equal (`==`) to itself, as \na consequence the undefined value cannot sensibly \nbe used in most collections."]},"$nm":"undefined"},"strictlyPositive":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Determines if this value is a positive number, `+0`, \nor `infinity`. Produces `false` for a negative \nnumber, `-0`, or undefined."]},"$nm":"strictlyPositive"},"negative":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Determines if this value is a negative number or\n`-infinity`. Produces `false` for a positive number, \n`+0`, `-0`, or undefined."],"actual":[]},"$nm":"negative"},"positive":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Determines if this value is a positive number or\n`infinity`. Produces `false` for a negative number, \n`+0`, `-0`, or undefined."],"actual":[]},"$nm":"positive"},"float":{"$t":{"$pk":"ceylon.language","$nm":"Float"},"$mt":"attr","$nm":"float"},"finite":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"gttr","$an":{"shared":[],"see":["infinite","infinity"],"doc":["Determines whether this value is finite. Produces\n`false` for `infinity`, `-infinity`, and undefined."]},"$nm":"finite"}},"$nm":"Float"},"LazySet":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$ps":[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"elems"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Set"}],"$mt":"cls","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"variance":"out","$nm":"Element"}],"$an":{"shared":[],"doc":["An implementation of `Set` that wraps an `Iterable` of\nelements. All operations on this `Set` are performed\non the `Iterable`."],"by":["Enrique Zamudio"]},"$m":{"complement":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"set"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Other"}],"$an":{"shared":[],"actual":[]},"$nm":"complement"},"intersection":{"$t":{"$tp":[{"comp":"i","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"set"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Other"}],"$an":{"shared":[],"actual":[]},"$nm":"intersection"},"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator","$o":{"iterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"obj","$m":{"next":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$at":{"sorted":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"attr","$nm":"sorted"},"ready":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Finished"}]},"var":"1","$mt":"attr","$an":{"shared":[],"actual":[],"variable":[]},"$nm":"ready"}},"$nm":"iterator"}}},"exclusiveUnion":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Other"}],"$an":{"shared":[],"actual":[]},"$nm":"exclusiveUnion"},"equals":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"that"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"actual":[]},"$nm":"equals"},"union":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"set"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Other"}],"$an":{"shared":[],"actual":[]},"$nm":"union"}},"$at":{"clone":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"LazySet"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"clone"},"hash":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"default":[],"actual":[]},"$nm":"hash"},"elems":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"attr","$nm":"elems"},"size":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"size"}},"$nm":"LazySet"},"min":{"$t":{"comp":"u","$ts":[{"$nm":"Absent"},{"$nm":"Value"}]},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Value"},{"$mt":"tpm","$nm":"Absent"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"values"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Value"}],"$pk":"ceylon.language","$nm":"Comparable"}],"$nm":"Value"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Null"}],"$nm":"Absent"}],"$an":{"shared":[],"see":["Comparable","max","smallest"],"doc":["Given a nonempty stream of `Comparable` values, \nreturn the smallest value in the stream."]},"$nm":"min"},"Collection":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Collection"}],"$pk":"ceylon.language","$nm":"Cloneable"}],"$mt":"ifc","$tp":[{"variance":"out","$nm":"Element"}],"$an":{"shared":[],"see":["List","Map","Set"],"doc":["Represents an iterable collection of elements of finite \nsize. `Collection` is the abstract supertype of `List`,\n`Map`, and `Set`.\n\nA `Collection` forms a `Category` of its elements.\n\nAll `Collection`s are `Cloneable`. If a collection is\nimmutable, it is acceptable that `clone` produce a\nreference to the collection itself. If a collection is\nmutable, `clone` should produce an immutable collection\ncontaining references to the same elements, with the\nsame structure as the original collection&mdash;that \nis, it should produce an immutable shallow copy of the\ncollection."]},"$m":{"contains":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Return `true` if the given object is an element of\nthis collection. In this default implementation,\nand in most refining implementations, return `false`\notherwise. An acceptable refining implementation\nmay return `true` for objects which are not \nelements of the collection, but this is not \nrecommended. (For example, the `contains()` method \nof `String` returns `true` for any substring of the\nstring.)"],"actual":[]},"$nm":"contains"}},"$at":{"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["A string of form `\"{ x, y, z }\"` where `x`, `y`, \nand `z` are the `string` representations of the \nelements of this collection, as produced by the\niterator of the collection, or the string `\"{}\"` \nif this collection is empty. If the collection \niterator produces the value `null`, the string\nrepresentation contains the string `\"null\"`."],"actual":[]},"$nm":"string"},"empty":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["Determine if the collection is empty, that is, if \nit has no elements."],"actual":[]},"$nm":"empty"}},"$nm":"Collection"},"deprecated":{"$t":{"$pk":"ceylon.language","$nm":"DeprecationAnnotation"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$def":"1","$an":{"doc":["A description, in Markdown syntax, of why the element is deprecated, \nand what replacements are available."]},"$nm":"reason"}]],"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to mark program elements which should not be \nused anymore."]},"$annot":"1","$nm":"deprecated"},"Range":{"super":{"$pk":"ceylon.language","$nm":"Object"},"$ps":[{"$t":{"$nm":"Element"},"$hdn":"1","$mt":"prm","$an":{"shared":[],"doc":["The start of the range."],"actual":[]},"$nm":"first"},{"$t":{"$nm":"Element"},"$hdn":"1","$mt":"prm","$an":{"shared":[],"doc":["The end of the range."],"actual":[]},"$nm":"last"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequence"},{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Range"}],"$pk":"ceylon.language","$nm":"Cloneable"}],"$mt":"cls","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Ordinal"},{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Comparable"}],"$nm":"Element"}],"$an":{"shared":[],"final":[],"doc":["Represents the range of totally ordered, ordinal values \ngenerated by two endpoints of type `Ordinal` and \n`Comparable`. If the first value is smaller than the\nlast value, the range is increasing. If the first value\nis larger than the last value, the range is decreasing.\nIf the two values are equal, the range contains exactly\none element. The range is always nonempty, containing \nat least one value.\n\nA range may be produced using the `..` operator:\n\n    for (i in min..max) { ... }\n    if (char in 'A'..'Z') { ... }\n"],"by":["Gavin"]},"$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"doc":["An iterator for the elements of the range."],"actual":[]},"$c":{"RangeIterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"cls","$m":{"next":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$at":{"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"string"},"current":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Finished"}]},"var":"1","$mt":"attr","$an":{"shared":[],"actual":[],"variable":[]},"$nm":"current"}},"$nm":"RangeIterator"}},"$nm":"iterator"},"get":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"n"}]],"$mt":"mthd","$an":{"shared":[],"doc":["The element of the range that occurs `n` values after\nthe start of the range. Note that this operation \nis inefficient for large ranges."],"actual":[]},"$nm":"get"},"count":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$m":{"selecting":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$nm":"selecting"}},"$nm":"count"},"equals":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"that"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Determines if two ranges are the same by comparing\ntheir endpoints."],"actual":[]},"$nm":"equals"},"segment":{"$t":{"comp":"u","$ts":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Range"},{"$pk":"ceylon.language","$nm":"Empty"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"segment"},"next":{"$t":{"$nm":"Element"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"x"}]],"$mt":"mthd","$nm":"next"},"includesRange":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Range"},"$mt":"prm","$nm":"sublist"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Determines if this range includes the given range."]},"$nm":"includesRange"},"by":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"step"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"by"},"contains":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Determines if this range includes the given object."],"actual":[]},"$nm":"contains"},"includes":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"prm","$nm":"sublist"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"includes"},"taking":{"$t":{"comp":"u","$ts":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Range"},{"$pk":"ceylon.language","$nm":"Empty"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"take"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"taking"},"occurs":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Determines if this range includes the given value."],"actual":[]},"$nm":"occurs"},"spanTo":{"$t":{"comp":"u","$ts":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Range"},{"$pk":"ceylon.language","$nm":"Empty"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"to"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"spanTo"},"containsElement":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"x"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Determines if the range includes the given value."]},"$nm":"containsElement"},"spanFrom":{"$t":{"comp":"u","$ts":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Range"},{"$pk":"ceylon.language","$nm":"Empty"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"spanFrom"},"skipping":{"$t":{"comp":"u","$ts":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Range"},{"$pk":"ceylon.language","$nm":"Empty"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"skip"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"skipping"},"span":{"$t":{"comp":"u","$ts":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Range"},{"$pk":"ceylon.language","$nm":"Empty"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"to"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"span"}},"$at":{"lastIndex":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"doc":["The index of the end of the range."],"actual":[]},"$nm":"lastIndex"},"clone":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Range"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns the range itself, since ranges are \nimmutable."],"actual":[]},"$nm":"clone"},"decreasing":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"gttr","$an":{"shared":[],"doc":["Determines if the range is decreasing."]},"$nm":"decreasing"},"last":{"$t":{"$nm":"Element"},"$mt":"attr","$an":{"shared":[],"doc":["The end of the range."],"actual":[]},"$nm":"last"},"sequence":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Range"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns this range."],"actual":[]},"$nm":"sequence"},"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"string"},"coalesced":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Range"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns the range itself, since a Range cannot\ncontain nulls."],"actual":[]},"$nm":"coalesced"},"reversed":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Range"},"$mt":"gttr","$an":{"shared":[],"doc":["Reverse this range, returning a new range."],"actual":[]},"$nm":"reversed"},"rest":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"gttr","$an":{"shared":[],"doc":["The rest of the range, without the start of the\nrange."],"actual":[]},"$nm":"rest"},"first":{"$t":{"$nm":"Element"},"$mt":"attr","$an":{"shared":[],"doc":["The start of the range."],"actual":[]},"$nm":"first"},"size":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"doc":["The nonzero number of elements in the range."],"actual":[]},"$nm":"size"}},"$nm":"Range"},"max":{"$t":{"comp":"u","$ts":[{"$nm":"Absent"},{"$nm":"Value"}]},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Value"},{"$mt":"tpm","$nm":"Absent"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"values"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Value"}],"$pk":"ceylon.language","$nm":"Comparable"}],"$nm":"Value"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Null"}],"$nm":"Absent"}],"$an":{"shared":[],"see":["Comparable","min","largest"],"doc":["Given a nonempty stream of `Comparable` values, \nreturn the largest value in the stream."]},"$nm":"max"},"Integral":{"of":[{"$nm":"Other"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Numeric"},{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Enumerable"}],"$mt":"ifc","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Integral"}],"$nm":"Other"}],"$an":{"shared":[],"see":["Integer"],"doc":["Abstraction of integral numeric types. That is, types \nwith no fractional part, including `Integer`. The \ndivision operation for integral numeric types results \nin a remainder. Therefore, integral numeric types have \nan operation to determine the remainder of any division \noperation."],"by":["Gavin"]},"$m":{"remainder":{"$t":{"$nm":"Other"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"see":["Numeric.divided"],"doc":["The remainder, after dividing this number by the \ngiven number."]},"$nm":"remainder"},"divides":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Determine if this number is a factor of the given \nnumber."]},"$nm":"divides"}},"$at":{"unit":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["Determine if the number is one."]},"$nm":"unit"},"zero":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["Determine if the number is zero."]},"$nm":"zero"}},"$nm":"Integral","$st":"Other"},"SequenceAppender":{"super":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"SequenceBuilder"},"$ps":[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequence"},"$mt":"prm","$nm":"elements"}],"$mt":"cls","$tp":[{"$nm":"Element"}],"$an":{"shared":[],"native":[],"see":["SequenceBuilder"],"doc":["This class is used for constructing a new nonempty \nsequence by incrementally appending elements to an\nexisting nonempty sequence. The existing sequence is\nnot modified, since `Sequence`s are immutable. This \nclass is mutable but threadsafe."]},"$at":{"sequence":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequence"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The resulting nonempty sequence. If no elements \nhave been appended, the original nonempty \nsequence."],"actual":[]},"$nm":"sequence"},"elements":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequence"},"$mt":"attr","$nm":"elements"}},"$nm":"SequenceAppender"},"NativeAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"NativeAnnotation"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Annotated"}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[native]]."]},"$annot":"1","$nm":"NativeAnnotation"},"byIncreasing":{"$t":{"$pk":"ceylon.language","$nm":"Comparison"},"$ps":[[{"$t":{"$nm":"Value"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"e"}]],"$mt":"prm","$pt":"f","$nm":"comparable"}],[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"x"},{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"y"}]],"$mt":"mthd","$tp":[{"$nm":"Element"},{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Value"}],"$pk":"ceylon.language","$nm":"Comparable"}],"$nm":"Value"}],"$an":{"shared":[],"see":["byDecreasing"],"doc":["A comparator which orders elements in increasing order \naccording to the `Comparable` returned by the given \n`comparable()` function."]},"$nm":"byIncreasing"},"smallest":{"$t":{"$nm":"Element"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"x"},{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"y"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Comparable"}],"$nm":"Element"}],"$an":{"shared":[],"see":["Comparable","largest","min"],"doc":["Given two `Comparable` values, return smallest of the\ntwo."]},"$nm":"smallest"},"larger":{"super":{"$pk":"ceylon.language","$nm":"Comparison"},"$mt":"obj","$an":{"shared":[],"doc":["The value is larger than the given value."]},"$nm":"larger"},"true":{"super":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"obj","$an":{"shared":[],"doc":["A value representing truth in Boolean logic."]},"$at":{"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"string"}},"$nm":"true"},"Exponentiable":{"of":[{"$nm":"This"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"This"}],"$pk":"ceylon.language","$nm":"Numeric"}],"$mt":"ifc","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"This"},{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Exponentiable"}],"$nm":"This"},{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Numeric"}],"$nm":"Other"}],"$an":{"shared":[],"see":["Integer","Float"],"doc":["Abstraction of [[numeric types|Numeric]] that may be \nraised to a power `x^p`. Note that the type of the \nexponent may be different to the numeric type which \nmay be exponentiated."]},"$m":{"power":{"$t":{"$nm":"This"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["The result of raising this number to the given\npower."]},"$nm":"power"}},"$nm":"Exponentiable","$st":"This"},"Character":{"super":{"$pk":"ceylon.language","$nm":"Object"},"$ps":[{"$t":{"$pk":"ceylon.language","$nm":"Character"},"$mt":"prm","$nm":"character"}],"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Character"}],"$pk":"ceylon.language","$nm":"Comparable"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Character"}],"$pk":"ceylon.language","$nm":"Enumerable"}],"$mt":"cls","$an":{"shared":[],"final":[],"native":[],"see":["String"],"doc":["A 32-bit Unicode character."],"by":["Gavin"]},"$at":{"control":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Determine if this character is an ISO control \ncharacter."]},"$nm":"control"},"integer":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The code point of the character."]},"$nm":"integer"},"lowercased":{"$t":{"$pk":"ceylon.language","$nm":"Character"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The lowercase representation of this character."]},"$nm":"lowercased"},"letter":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Determine if this character is a letter. That is,\nif its Unicode general category is *Lu*, *Ll*, \n*Lt*, *Lm*, or *Lo*."]},"$nm":"letter"},"uppercased":{"$t":{"$pk":"ceylon.language","$nm":"Character"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The uppercase representation of this character."]},"$nm":"uppercased"},"whitespace":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Determine if this character is a whitespace character. \nThe following characters are whitespace characters:\n\n* *LINE FEED*, `\\n` or `\\{#000A}`,\n* *FORM FEED*, `\\f` or `\\{#000C}`,\n* *CARRIAGE RETURN*, `\\r` or `\\{#000D}`,\n* *HORIZONTAL TABULATION*, `\\t` or `\\{#0009}`,\n* *VERTICAL TABULATION*, `\\{#000B}`,\n* *FILE SEPARATOR*, `\\{#001C}`,\n* *GROUP SEPARATOR*, `\\{#001D}`,\n* *RECORD SEPARATOR*, `\\{#001E}`,\n* *UNIT SEPARATOR*, `\\{#001F}`, and\n* any Unicode character in the general category \n  *Zs*, *Zl*, or *Zp* that is not a non-breaking \n  space."]},"$nm":"whitespace"},"titlecased":{"$t":{"$pk":"ceylon.language","$nm":"Character"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The title case representation of this character."]},"$nm":"titlecased"},"character":{"$t":{"$pk":"ceylon.language","$nm":"Character"},"$mt":"attr","$nm":"character"},"uppercase":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Determine if this is an uppercase representation of\nthe character. That is, if its Unicode general \ncategory is *Lu*."]},"$nm":"uppercase"},"digit":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Determine if this character is a numeric digit.\nThat is, if its Unicode general category is *Nd*."]},"$nm":"digit"},"lowercase":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Determine if this is a lowercase representation of\nthe character. That is, if its Unicode general \ncategory is *Ll*."]},"$nm":"lowercase"},"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["A string containg just this character."],"actual":[]},"$nm":"string"},"titlecase":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Determine if this is a title case representation of\nthe character. That is, if its Unicode general \ncategory is *Lt*."]},"$nm":"titlecase"}},"$nm":"Character"},"Keys":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$ps":[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Correspondence"},"$mt":"prm","$nm":"correspondence"}],"satisfies":[{"$pk":"ceylon.language","$nm":"Category"}],"$mt":"cls","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"variance":"in","$nm":"Key"},{"variance":"out","$nm":"Item"}],"$m":{"contains":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"key"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"contains"}},"$at":{"correspondence":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Correspondence"},"$mt":"attr","$nm":"correspondence"}},"$nm":"Keys"},"forKey":{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Key"},"$mt":"prm","$nm":"key"}]],"$mt":"prm","$pt":"f","$nm":"resulting"}],[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"}],"$pk":"ceylon.language","$nm":"Entry"},"$mt":"prm","$nm":"entry"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Key"},{"$nm":"Result"}],"$an":{"shared":[],"see":["forItem"],"doc":["A function that returns the result of the given `resulting()` function \non the key of a given `Entry`."]},"$nm":"forKey"},"curry":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Return"},{"$mt":"tpm","$nm":"Rest"}],"$pk":"ceylon.language","$nm":"Callable"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Return"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Argument"},{"$mt":"tpm","$nm":"First"},{"$mt":"tpm","$nm":"Rest"}],"$pk":"ceylon.language","$nm":"Tuple"}],"$pk":"ceylon.language","$nm":"Callable"},"$mt":"prm","$nm":"f"}],[{"$t":{"$nm":"First"},"$mt":"prm","$nm":"first"}]],"$mt":"mthd","$tp":[{"$nm":"Return"},{"$nm":"Argument"},{"satisfies":[{"$nm":"Argument"}],"$nm":"First"},{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Argument"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$nm":"Rest"}],"$an":{"shared":[],"see":["uncurry","compose"],"doc":["Curries a function, returning a function with two \nparameter lists, given a function with at least\none parameter. The first parameter list of the \nreturned function has just the first parameter\nof the original function, and the second parameter\nlist has the remaining parameters.\n\nThat is, if `fun` has type `W(X,Y,Z)` then \n`curry(fun)` has type `W(Y,Z)(X)`."]},"$nm":"curry"},"product":{"$t":{"$nm":"Value"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Value"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"values"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Value"}],"$pk":"ceylon.language","$nm":"Numeric"}],"$nm":"Value"}],"$an":{"shared":[],"see":["sum"],"doc":["Given a nonempty stream of `Numeric` values, return \nthe product of the values."]},"$nm":"product"},"process":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$mt":"obj","$an":{"shared":[],"native":[],"doc":["Represents the current process (instance of the virtual\nmachine)."],"by":["Gavin","Tako"]},"$m":{"flushError":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Flush the standard error of the \nvirtual machine process."]},"$nm":"flushError"},"flush":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Flush the standard output of the \nvirtual machine process."]},"$nm":"flush"},"readLine":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Read a line of input text from the standard input \nof the virtual machine process."]},"$nm":"readLine"},"writeErrorLine":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$def":"1","$nm":"line"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Print a line to the standard error of the \nvirtual machine process."]},"$nm":"writeErrorLine"},"writeError":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"string"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Print a string to the standard error of the \nvirtual machine process."]},"$nm":"writeError"},"propertyValue":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"String"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["The value of the given system property of the virtual\nmachine, if any."]},"$nm":"propertyValue"},"namedArgumentValue":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"String"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["The value of the first argument of form `-name=value`, \n`--name=value`, or `-name value` specified among the \ncommand line arguments to the virtual machine, if\nany."]},"$nm":"namedArgumentValue"},"write":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"string"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Print a string to the standard output of the \nvirtual machine process."]},"$nm":"write"},"namedArgumentPresent":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"name"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Determine if an argument of form `-name` or `--name` \nwas specified among the command line arguments to \nthe virtual machine."]},"$nm":"namedArgumentPresent"},"writeLine":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$def":"1","$nm":"line"}]],"$mt":"mthd","$an":{"shared":[],"see":["print"],"doc":["Print a line to the standard output of the \nvirtual machine process."]},"$nm":"writeLine"},"exit":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"code"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Force the virtual machine to terminate with \nthe given exit code."]},"$nm":"exit"}},"$at":{"arguments":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"String"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The command line arguments to the virtual machine."]},"$nm":"arguments"},"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"string"}},"$nm":"process"},"forItem":{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Item"},"$mt":"prm","$nm":"item"}]],"$mt":"prm","$pt":"f","$nm":"resulting"}],[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Entry"},"$mt":"prm","$nm":"entry"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Item"},{"$nm":"Result"}],"$an":{"shared":[],"see":["forKey"],"doc":["A function that returns the result of the given `resulting()` function \non the item of a given `Entry`."]},"$nm":"forItem"},"shuffle":{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Result"},{"$mt":"tpm","$nm":"FirstArgs"}],"$pk":"ceylon.language","$nm":"Callable"},{"$mt":"tpm","$nm":"SecondArgs"}],"$pk":"ceylon.language","$nm":"Callable"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Result"},{"$mt":"tpm","$nm":"SecondArgs"}],"$pk":"ceylon.language","$nm":"Callable"},{"$mt":"tpm","$nm":"FirstArgs"}],"$pk":"ceylon.language","$nm":"Callable"},"$mt":"prm","$nm":"f"}]],"$mt":"mthd","$tp":[{"$nm":"Result"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$nm":"FirstArgs"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$nm":"SecondArgs"}],"$an":{"shared":[],"see":["curry"],"doc":["Given a function with two parameter lists, return\na function with the order of the argument lists \nreversed. The parameter lists may have any number\nof parameters.\n\nThat is, if `fun` has type `W(A,B)(X,Y,Z)` then \n`shuffle(fun)` has type `W(X,Y,Z)(A,B)`.\n\nThis function is often used in conjunction with\n`curry()`."]},"$nm":"shuffle"},"Annotation":{"of":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Annotation"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"ConstrainedAnnotation"}],"$mt":"ifc","$an":{"shared":[],"see":["OptionalAnnotation","SequencedAnnotation","annotations","optionalAnnotation","sequencedAnnotations"],"doc":["The supertype of all *annotation classes*. \n\n### Annotation classes\n\nAn *annotation class* must satisfy `Annotation`,\n[[OptionalAnnotation]],  or [[SequencedAnnotation]] and must be \nannotated `final annotation`. For example:\n\n    \"An annotation class.\"\n    final annotation class Example(shared String description) \n          satisfies Annotation {}\n\nAnnotation classes which satisfy `Annotation` directly may be applied \nto any program element that supports annotations (see [[Annotated]]). \nIn practice, annotation classes often satisfy [[OptionalAnnotation]] \nor [[SequencedAnnotation]] in order to prevent annotations being \napplied to inappropriate program elements.\n\nEach initializer parameter of an annotation class must have one of the \nfollowing types:\n\n* `Integer`, `Float`, `Character`, or `String`,\n* an enumerated type whose cases are all anonymous classes, \n  such as `Boolean`,\n* a subtype of [[ceylon.language.meta.declaration::Declaration]]\n* an annotation class,\n* `{T*}` or `[T*]` where `T` is a legal annotation parameter type, or\n* any tuple type whose element types are legal annotation parameter types.\n\nAn initializer parameter of an annotation class may be variadic \nor defaulted.\n\n### Annotation constructors\n\nAn *annotation constructor* is simply a top level function, annotated with \n`annotation` whose return type is an annotation class type. For example:\n\n    \"An annotation constructor.\"\n    annotation Example example(String description=\"\") \n        => Example(description);\n\nEach parameter of an annotation constructor must have one of the \nfollowing types:\n\n* `Integer`, `Float`, `Character`, or `String`,\n* an enumerated type whose cases are all anonymous classes, \n  such as `Boolean`,\n* a subtype of [[ceylon.language.meta.declaration::Declaration]],\n* an annotation type,\n* `{T*}` or `[T*]` where `T` is a legal annotation constructor parameter \n  type, or\n* any tuple type whose element types are legal annotation constructor \n  parameter types.\n\nA parameter of an annotation constructor may be variadic or defaulted.\n\nThe constructor must simply instantiate and return the annotation class, \nand there are strict rules about the arguments to the instantiation.\n\nAn annotation class can have multiple annotation constructors.\n"]},"$nm":"Annotation"},"ConstrainedAnnotation":{"of":[{"$nm":"Value"}],"satisfies":[{"$pk":"ceylon.language","$nm":"Annotation"}],"$mt":"ifc","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Annotation"}],"$def":{"$pk":"ceylon.language","$nm":"Annotation"},"variance":"out","$nm":"Value"},{"$def":{"$pk":"ceylon.language","$nm":"Anything"},"variance":"out","$nm":"Values"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Annotated"}],"$def":{"$pk":"ceylon.language","$nm":"Nothing"},"variance":"in","$nm":"ProgramElement"}],"$an":{"shared":[],"see":["Annotation"],"doc":["An annotation constrained to appear only on certain \nprogram elements, and only with certain values. \n\nThis interface should not be satisfied directly. \nInstead either [[OptionalAnnotation]] or [[SequencedAnnotation]] \nshould be satisfied."]},"$m":{"occurs":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Annotated"},"$mt":"prm","$nm":"programElement"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Can this annotation can occur on the given program \nelement?"]},"$nm":"occurs"}},"$nm":"ConstrainedAnnotation","$st":"Value"},"doc":{"$t":{"$pk":"ceylon.language","$nm":"DocAnnotation"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$an":{"doc":["Documentation, in Markdown syntax, about the annotated element"]},"$nm":"description"}]],"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to specify API documentation of a program\nelement."]},"$annot":"1","$nm":"doc"},"nothing":{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"gttr","$an":{"shared":[],"doc":["A value that is assignable to any type, but that \nresults in an exception when evaluated. This is most \nuseful for generating members in an IDE."]},"$nm":"nothing"},"emptyMap":{"super":{"$pk":"ceylon.language","$nm":"Object"},"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Map"}],"$mt":"obj","$an":{"shared":[],"doc":["A [[Map]] with no entries."]},"$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator"},"containsAny":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"elements"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"containsAny"},"get":{"$t":{"$pk":"ceylon.language","$nm":"Null"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"key"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"get"},"count":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Entry"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"count"},"select":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Entry"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"select"},"by":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Map"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"step"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"by"},"contains":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"contains"},"every":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Entry"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"every"},"mapItems":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Map"},"$ps":[[{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"key"},{"$t":{"$pk":"ceylon.language","$nm":"Nothing"},"$mt":"prm","$nm":"item"}]],"$mt":"prm","$pt":"f","$nm":"mapping"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Result"}],"$an":{"shared":[],"actual":[]},"$nm":"mapItems"},"fold":{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Result"},"$mt":"prm","$nm":"initial"},{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Result"},"$mt":"prm","$nm":"partial"},{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Entry"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"accumulating"}]],"$mt":"mthd","$tp":[{"$nm":"Result"}],"$an":{"shared":[],"actual":[]},"$nm":"fold"},"taking":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Map"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"take"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"taking"},"defines":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"index"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"defines"},"any":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Entry"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"any"},"map":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Entry"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"collecting"}]],"$mt":"mthd","$tp":[{"$nm":"Result"}],"$an":{"shared":[],"actual":[]},"$nm":"map"},"skipping":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Map"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"skip"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"skipping"},"filter":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Map"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Entry"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"filter"},"find":{"$t":{"$pk":"ceylon.language","$nm":"Null"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Entry"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"find"},"collect":{"$t":{"$pk":"ceylon.language","$nm":"Empty"},"$ps":[[{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Entry"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$nm":"collecting"}]],"$mt":"mthd","$tp":[{"$nm":"Result"}],"$an":{"shared":[],"actual":[]},"$nm":"collect"},"containsEvery":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"elements"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"containsEvery"}},"$at":{"clone":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Map"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"clone"},"values":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Collection"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"values"},"inverse":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Map"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"inverse"},"keys":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"keys"},"empty":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"empty"},"size":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"size"}},"$nm":"emptyMap"},"Scalar":{"of":[{"$nm":"Other"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Numeric"},{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Comparable"},{"$pk":"ceylon.language","$nm":"Number"}],"$mt":"ifc","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Scalar"}],"$nm":"Other"}],"$an":{"shared":[],"see":["Integer","Float"],"doc":["Abstraction of [[numeric|Numeric]] types representing \nscalar values with a [[total order|Comparable]], \nincluding the built-in numeric types [[Integer]] and \n[[Float]]."],"by":["Gavin"]},"$at":{"magnitude":{"$t":{"$nm":"Other"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The magnitude of this number."],"actual":[]},"$nm":"magnitude"},"wholePart":{"$t":{"$nm":"Other"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The integral value of the number after truncation \nof the fractional part. For integral numeric types,\nthe integral value of a number is the number \nitself."],"actual":[]},"$nm":"wholePart"},"fractionalPart":{"$t":{"$nm":"Other"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The fractional part of the number, after truncation \nof the integral part. For integral numeric types,\nthe fractional part is always zero."],"actual":[]},"$nm":"fractionalPart"}},"$nm":"Scalar","$st":"Other"},"AuthorsAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$ps":[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"String"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$an":{"shared":[],"doc":["The authors, in Markdown syntax, of the annotated element"]},"$nm":"authors"}],"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"AuthorsAnnotation"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Annotated"}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[by]]."]},"$annot":"1","$at":{"authors":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"String"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"doc":["The authors, in Markdown syntax, of the annotated element"]},"$nm":"authors"}},"$nm":"AuthorsAnnotation"},"ifExists":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"val"}]],"$mt":"prm","$pt":"f","$nm":"predicate"}],[{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"prm","$nm":"val"}]],"$mt":"mthd","$m":{"predicate":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"val"}]],"$mt":"mthd","$nm":"predicate"}},"$nm":"ifExists"},"SequenceBuilder":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$mt":"cls","$tp":[{"$nm":"Element"}],"$an":{"shared":[],"native":[],"see":["SequenceAppender","concatenate","Singleton"],"doc":["Since sequences are immutable, this class is used for\nconstructing a new sequence by incrementally appending \nelements to the empty sequence. This class is mutable\nbut threadsafe."]},"$m":{"append":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"SequenceBuilder"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Append an element to the sequence and return this \n`SequenceBuilder`"]},"$nm":"append"},"appendAll":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"SequenceBuilder"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"elements"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Append multiple elements to the sequence and return \nthis `SequenceBuilder`"]},"$nm":"appendAll"}},"$at":{"sequence":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"default":[],"native":[],"doc":["The resulting sequence. If no elements have been\nappended, the empty sequence."]},"$nm":"sequence"},"empty":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"gttr","$an":{"shared":[],"doc":["Determine if the resulting sequence is empty."]},"$nm":"empty"},"size":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"doc":["The size of the resulting sequence."]},"$nm":"size"}},"$nm":"SequenceBuilder"},"tagged":{"$t":{"$pk":"ceylon.language","$nm":"TagsAnnotation"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"String"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$an":{"doc":["The tags, in plain text."]},"$nm":"tags"}]],"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to categorize the API by tag."]},"$annot":"1","$nm":"tagged"},"printAll":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"values"},{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$def":"1","$an":{"doc":["A character sequence to use to separate the values"]},"$nm":"separator"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Print multiple values to the standard output of the virtual \nmachine process as a single line of text, separated by a\ngiven character sequence."],"by":["Gavin"]},"$nm":"printAll"},"variable":{"$t":{"$pk":"ceylon.language","$nm":"VariableAnnotation"},"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to mark an value as variable. A `variable` value \nmay be assigned multiple times."]},"$annot":"1","$nm":"variable"},"Correspondence":{"$mt":"ifc","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"variance":"in","$nm":"Key"},{"variance":"out","$nm":"Item"}],"$an":{"shared":[],"see":["Map","List","Category"],"doc":["Abstract supertype of objects which associate values \nwith keys. `Correspondence` does not satisfy `Category`,\nsince in some cases&mdash;`List`, for example&mdash;it is \nconvenient to consider the subtype a `Category` of its\nvalues, and in other cases&mdash;`Map`, for example&mdash;it \nis convenient to treat the subtype as a `Category` of its\nentries.\n\nThe item corresponding to a given key may be obtained \nfrom a `Correspondence` using the item operator:\n\n    value bg = settings[\"backgroundColor\"] else white;\n\nThe `get()` operation and item operator result in an\noptional type, to reflect the possibility that there is\nno item for the given key."],"by":["Gavin"]},"$m":{"definesAny":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"keys"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["Correspondence.defines"],"doc":["Determines if this `Correspondence` defines a value\nfor any one of the given keys."]},"$nm":"definesAny"},"defines":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Key"},"$mt":"prm","$nm":"key"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["Correspondence.definesAny","Correspondence.definesEvery","Correspondence.keys"],"doc":["Determines if there is a value defined for the \ngiven key."]},"$nm":"defines"},"get":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Item"}]},"$ps":[[{"$t":{"$nm":"Key"},"$mt":"prm","$nm":"key"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"see":["Correspondence.items"],"doc":["Returns the value defined for the given key, or \n`null` if there is no value defined for the given \nkey."]},"$nm":"get"},"items":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Item"}]}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"keys"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["Correspondence.get"],"doc":["Returns the items defined for the given keys, in\nthe same order as the corresponding keys."]},"$nm":"items"},"definesEvery":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"keys"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["Correspondence.defines"],"doc":["Determines if this `Correspondence` defines a value\nfor every one of the given keys."]},"$nm":"definesEvery"}},"$at":{"keys":{"$t":{"$pk":"ceylon.language","$nm":"Category"},"$mt":"gttr","$an":{"shared":[],"default":[],"see":["Correspondence.defines"],"doc":["The `Category` of all keys for which a value is \ndefined by this `Correspondence`."]},"$nm":"keys"}},"$nm":"Correspondence"},"apply":{"$t":{"$nm":"Return"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Return"},{"$mt":"tpm","$nm":"Args"}],"$pk":"ceylon.language","$nm":"Callable"},"$mt":"prm","$nm":"f"},{"$t":{"$nm":"Args"},"$mt":"prm","$nm":"args"}]],"$mt":"mthd","$tp":[{"$nm":"Return"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$nm":"Args"}],"$an":{"shared":[],"see":["unflatten"],"doc":["Applies an arbitrary `Callable` to the specified arguments. The arguments\nare taken packaged in a tuple whose type is compatible with the `Callable`\narguments tuple.\n\nIn practice, this behaves as if the `Callable` were called with the elements\nof the tuple used as its arguments."]},"$nm":"apply"},"count":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Boolean"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"values"}]],"$mt":"mthd","$an":{"shared":[],"doc":["A count of the number of `true` items in the given values."]},"$nm":"count"},"byItem":{"$t":{"$pk":"ceylon.language","$nm":"Comparison"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Comparison"},"$ps":[[{"$t":{"$nm":"Item"},"$mt":"prm","$nm":"x"},{"$t":{"$nm":"Item"},"$mt":"prm","$nm":"y"}]],"$mt":"prm","$pt":"f","$nm":"comparing"}],[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Entry"},"$mt":"prm","$nm":"x"},{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Entry"},"$mt":"prm","$nm":"y"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Item"}],"$an":{"shared":[],"see":["byKey"],"doc":["A comparator for `Entry`s which compares their items \naccording to the given `comparing()` function."]},"$nm":"byItem"},"FinalAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"FinalAnnotation"},{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"ClassDeclaration"}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[final]]."]},"$annot":"1","$nm":"FinalAnnotation"},"by":{"$t":{"$pk":"ceylon.language","$nm":"AuthorsAnnotation"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"String"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$an":{"doc":["The authors, in Markdown syntax, of the annotated element"]},"$nm":"authors"}]],"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to specify API authors."]},"$annot":"1","$nm":"by"},"every":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Boolean"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"values"}]],"$mt":"mthd","$an":{"shared":[],"see":["any"],"doc":["Determines if every one of the given boolean values \n(usually a comprehension) is `true`."]},"$nm":"every"},"concatenate":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$an":{"doc":["The iterable objects to concatenate."]},"$nm":"iterables"}]],"$mt":"mthd","$tp":[{"$nm":"Element"}],"$an":{"shared":[],"see":["SequenceBuilder"],"doc":["Given a list of iterable objects, return a new sequence \nof all elements of the all given objects. If there are\nno arguments, or if none of the arguments contains any\nelements, return the empty sequence."]},"$nm":"concatenate"},"$pkg-shared":"1","Tuple":{"super":{"$pk":"ceylon.language","$nm":"Object"},"$ps":[{"$t":{"$nm":"First"},"$hdn":"1","$mt":"prm","$an":{"shared":[],"doc":["The first element of this tuple."],"actual":[]},"$nm":"first"},{"$t":{"$nm":"Rest"},"$hdn":"1","$mt":"prm","$an":{"shared":[],"doc":["A tuple with the elements of this tuple, except\nfor the first element."],"actual":[]},"$nm":"rest"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequence"},{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$nm":"First"},{"$mt":"tpm","$nm":"Rest"}],"$pk":"ceylon.language","$nm":"Tuple"}],"$pk":"ceylon.language","$nm":"Cloneable"}],"$mt":"cls","$tp":[{"variance":"out","$nm":"Element"},{"satisfies":[{"$nm":"Element"}],"variance":"out","$nm":"First"},{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$def":{"$pk":"ceylon.language","$nm":"Empty"},"variance":"out","$nm":"Rest"}],"$an":{"shared":[],"final":[],"doc":["A _tuple_ is a typed linked list. Each instance of \n`Tuple` represents the value and type of a single link.\nThe attributes `first` and `rest` allow us to retrieve\na value form the list without losing its static type \ninformation.\n\n    value point = Tuple(0.0, Tuple(0.0, Tuple(\"origin\")));\n    Float x = point.first;\n    Float y = point.rest.first;\n    String label = point.rest.rest.first;\n\nUsually, we abbreviate code involving tuples.\n\n    [Float,Float,String] point = [0.0, 0.0, \"origin\"];\n    Float x = point[0];\n    Float y = point[1];\n    String label = point[2];\n\nA list of types enclosed in brackets is an abbreviated \ntuple type. An instance of `Tuple` may be constructed \nby surrounding a value list in brackets:\n\n    [String,String] words = [\"hello\", \"world\"];\n\nThe index operator with a literal integer argument is a \nshortcut for a chain of evaluations of `rest` and \n`first`. For example, `point[1]` means `point.rest.first`.\n\nA _terminated_ tuple type is a tuple where the type of\nthe last link in the chain is `Empty`. An _unterminated_ \ntuple type is a tuple where the type of the last link\nin the chain is `Sequence` or `Sequential`. Thus, a \nterminated tuple type has a length that is known\nstatically. For an unterminated tuple type only a lower\nbound on its length is known statically.\n\nHere, `point` is an unterminated tuple:\n\n    String[] labels = ... ;\n    [Float,Float,String*] point = [0.0, 0.0, *labels];\n    Float x = point[0];\n    Float y = point[1];\n    String? firstLabel = point[2];\n    String[] allLabels = point[2...];"],"by":["Gavin"]},"$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator","$o":{"iterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"obj","$m":{"next":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$at":{"current":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"var":"1","$mt":"attr","$an":{"shared":[],"actual":[],"variable":[]},"$nm":"current"}},"$nm":"iterator"}}},"get":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"get"},"spanTo":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"to"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"spanTo"},"segment":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"segment"},"contains":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"contains"},"withLeading":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]},{"$mt":"tpm","$nm":"Other"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$nm":"First"},{"$mt":"tpm","$nm":"Rest"}],"$pk":"ceylon.language","$nm":"Tuple"}],"$pk":"ceylon.language","$nm":"Tuple"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$an":{"doc":["The first element of the resulting tuple."]},"$nm":"element"}]],"$mt":"mthd","$tp":[{"$nm":"Other"}],"$an":{"shared":[],"doc":["Returns a new tuple that starts with the specified\nelement, followed by the elements of this tuple."],"actual":[]},"$nm":"withLeading"},"spanFrom":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"spanFrom"},"span":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"end"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"span"}},"$at":{"lastIndex":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"lastIndex"},"clone":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$nm":"First"},{"$mt":"tpm","$nm":"Rest"}],"$pk":"ceylon.language","$nm":"Tuple"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"clone"},"last":{"$t":{"$nm":"Element"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"last"},"reversed":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequence"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"reversed"},"rest":{"$t":{"$nm":"Rest"},"$mt":"attr","$an":{"shared":[],"doc":["A tuple with the elements of this tuple, except\nfor the first element."],"actual":[]},"$nm":"rest"},"first":{"$t":{"$nm":"First"},"$mt":"attr","$an":{"shared":[],"doc":["The first element of this tuple."],"actual":[]},"$nm":"first"},"size":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"size"}},"$nm":"Tuple"},"lessThan":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"val"}],[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Comparable"}],"$nm":"Element"}],"$an":{"shared":[],"doc":["Returns a partial function that will compare an element\nto any other element and returns true if the compared\nelement is less than its element.\nThis is useful in conjunction with methods that receive\na predicate function."]},"$nm":"lessThan"},"identityHash":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Identifiable"},"$mt":"prm","$nm":"x"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"see":["identical"],"doc":["Return the system-defined identity hash value of the \ngiven value. This hash value is consistent with \nidentity equality."]},"$nm":"identityHash"},"maxRadix":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$nm":"maxRadix"},"uncurry":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Return"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Argument"},{"$mt":"tpm","$nm":"First"},{"$mt":"tpm","$nm":"Rest"}],"$pk":"ceylon.language","$nm":"Tuple"}],"$pk":"ceylon.language","$nm":"Callable"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Return"},{"$mt":"tpm","$nm":"Rest"}],"$pk":"ceylon.language","$nm":"Callable"},"$ps":[[{"$t":{"$nm":"First"},"$mt":"prm","$nm":"first"}]],"$mt":"prm","$pt":"f","$nm":"f"}]],"$mt":"mthd","$tp":[{"$nm":"Return"},{"$nm":"Argument"},{"satisfies":[{"$nm":"Argument"}],"$nm":"First"},{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Argument"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$nm":"Rest"}],"$an":{"shared":[],"see":["curry","compose"],"doc":["Uncurries a function, returning a function with \none parameter list, given a function with two\nparameter lists, where the first parameter list\nhas exactly one parameter. The parameter list\nof the returned function has the parameter of\nthe first parameter list of the original\nfunction, followed by all parameters of the\nsecond parameter list.\n\nThat is, if `fun` has type `W(Y,Z)(X)` then \n`uncurry(fun)` has type `W(X,Y,Z)`."]},"$nm":"uncurry"},"optional":{"$t":{"$pk":"ceylon.language","$nm":"OptionalImportAnnotation"},"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to specify that a module can be executed even if \nthe annotated dependency is not available."]},"$annot":"1","$nm":"optional"},"any":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Boolean"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"values"}]],"$mt":"mthd","$an":{"shared":[],"see":["every"],"doc":["Determines if any one of the given boolean values \n(usually a comprehension) is `true`."]},"$nm":"any"},"Summable":{"of":[{"$nm":"Other"}],"$mt":"ifc","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Summable"}],"$nm":"Other"}],"$an":{"shared":[],"see":["String","Numeric"],"doc":["Abstraction of types which support a binary addition\noperator `x + y`. For [[numeric types|Numeric]], this \nis just familiar numeric addition. For [[String]], it \nis string concatenation.\n\nIn general, the addition operation should be a \nbinary associative operation."],"by":["Gavin"]},"$m":{"plus":{"$t":{"$nm":"Other"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["The result of adding the given value to this value. \nThis operation should never perform any kind of \nmutation upon either the receiving value or the \nargument value."]},"$nm":"plus"}},"$nm":"Summable","$st":"Other"},"Set":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Collection"},{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Set"}],"$pk":"ceylon.language","$nm":"Cloneable"}],"$mt":"ifc","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"variance":"out","$nm":"Element"}],"$an":{"shared":[],"doc":["A collection of unique elements.\n\nA `Set` is a `Collection` of its elements.\n\nSets may be the subject of the binary union, \nintersection, and complement operators `|`, `&`, and \n`~`."]},"$m":{"complement":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"set"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Other"}],"$an":{"shared":[],"formal":[],"doc":["Returns a new `Set` containing all the elements in \nthis `Set` that are not contained in the given\n`Set`."]},"$nm":"complement"},"subset":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"set"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Determines if this `Set` is a subset of the given \n`Set`, that is, if the given set contains all of \nthe elements in this set."]},"$nm":"subset"},"intersection":{"$t":{"$tp":[{"comp":"i","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"set"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Other"}],"$an":{"shared":[],"formal":[],"doc":["Returns a new `Set` containing only the elements \nthat are present in both this `Set` and the given \n`Set`."]},"$nm":"intersection"},"exclusiveUnion":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"set"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Other"}],"$an":{"shared":[],"formal":[],"doc":["Returns a new `Set` containing only the elements \ncontained in either this `Set` or the given `Set`, \nbut no element contained in both sets."]},"$nm":"exclusiveUnion"},"superset":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"set"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Determines if this `Set` is a superset of the \nspecified Set, that is, if this `Set` contains all \nof the elements in the specified `Set`."]},"$nm":"superset"},"equals":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"that"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Two `Set`s are considered equal if they have the \nsame size and if every element of the first set is\nalso an element of the second set, as determined\nby `contains()`."],"actual":[]},"$nm":"equals"},"union":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]}],"$pk":"ceylon.language","$nm":"Set"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"prm","$nm":"set"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Other"}],"$an":{"shared":[],"formal":[],"doc":["Returns a new `Set` containing all the elements of \nthis `Set` and all the elements of the given `Set`."]},"$nm":"union"}},"$at":{"hash":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"default":[],"actual":[]},"$nm":"hash"}},"$nm":"Set"},"Sequence":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Iterable"},{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequence"}],"$pk":"ceylon.language","$nm":"Cloneable"}],"$mt":"ifc","$tp":[{"variance":"out","$nm":"Element"}],"$an":{"shared":[],"see":["Empty"],"doc":["A nonempty, immutable sequence of values. The type \n`Sequence<Element>`, may be abbreviated `[Element+]`.\n\nGiven a possibly-empty sequence of type `[Element*]`, \nthe `if (nonempty ...)` construct, or, alternatively,\nthe `assert (nonempty ...)` construct, may be used to \nnarrow to a nonempty sequence type:\n\n    [Integer*] nums = ... ;\n    if (nonempty nums) {\n        Integer first = nums.first;\n        Integer max = max(nums);\n        [Integer+] squares = nums.collect((Integer i) => i**2));\n        [Integer+] sorted = nums.sort(byIncreasing((Integer i) => i));\n    }\n\nOperations like `first`, `max()`, `collect()`, and \n`sort()`, which polymorphically produce a nonempty or \nnon-null output when given a nonempty input are called \n_emptiness-preserving_."],"by":["Gavin"]},"$m":{"sort":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequence"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Comparison"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"x"},{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"y"}]],"$mt":"prm","$pt":"f","$an":{"doc":["The function comparing pairs of elements."]},"$nm":"comparing"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["A nonempty sequence containing the elements of this\ncontainer, sorted according to a function \nimposing a partial order upon the elements."],"actual":[]},"$m":{"comparing":{"$t":{"$pk":"ceylon.language","$nm":"Comparison"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"x"},{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"y"}]],"$mt":"mthd","$an":{"doc":["The function comparing pairs of elements."]},"$nm":"comparing"}},"$nm":"sort"},"shorterThan":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"actual":[]},"$nm":"shorterThan"},"longerThan":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"actual":[]},"$nm":"longerThan"},"repeat":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"times"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"actual":[]},"$nm":"repeat"},"findLast":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"actual":[]},"$nm":"findLast"},"collect":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Result"}],"$pk":"ceylon.language","$nm":"Sequence"},"$ps":[[{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$an":{"doc":["The transformation applied to the elements."]},"$nm":"collecting"}]],"$mt":"mthd","$tp":[{"$nm":"Result"}],"$an":{"shared":[],"default":[],"doc":["A nonempty sequence containing the results of \napplying the given mapping to the elements of this\nsequence."],"actual":[]},"$m":{"collecting":{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"doc":["The transformation applied to the elements."]},"$nm":"collecting"}},"$nm":"collect"}},"$at":{"lastIndex":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"formal":[],"see":["Sequence.size"],"doc":["The index of the last element of the sequence."],"actual":[]},"$nm":"lastIndex"},"clone":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequence"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["This nonempty sequence."],"actual":[]},"$nm":"clone"},"last":{"$t":{"$nm":"Element"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The last element of the sequence, that is, the\nelement with index `sequence.lastIndex`."],"actual":[]},"$nm":"last"},"sequence":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequence"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["This nonempty sequence."],"actual":[]},"$nm":"sequence"},"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"default":[],"actual":[]},"$nm":"string"},"empty":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns `false`, since every `Sequence` contains at\nleast one element."],"actual":[]},"$nm":"empty"},"rest":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The rest of the sequence, without the first \nelement."],"actual":[]},"$nm":"rest"},"reversed":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequence"},"$mt":"gttr","$an":{"shared":[],"formal":[],"doc":["Reverse this sequence, returning a new nonempty\nsequence."],"actual":[]},"$nm":"reversed"},"first":{"$t":{"$nm":"Element"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The first element of the sequence, that is, the\nelement with index `0`."],"actual":[]},"$nm":"first"}},"$nm":"Sequence"},"Scalable":{"of":[{"$nm":"Value"}],"$mt":"ifc","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Scale"}],"$pk":"ceylon.language","$nm":"Numeric"}],"variance":"in","$nm":"Scale"},{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Scale"},{"$mt":"tpm","$nm":"Value"}],"$pk":"ceylon.language","$nm":"Scalable"}],"variance":"out","$nm":"Value"}],"$an":{"shared":[],"doc":["Abstract supertype of types that support scaling by\na numeric factor `s ** x`. Examples of such types\ninclude vectors and matrices.\n\nImplementations should generally respect the \nfollowing constraints, where relevant:\n\n- `x == 1**x`\n\nImplementations of `Scalable` are encouraged to also\nsatisfy [[Invertable]], in which case, the following\nidentity should be respected:\n\n- `-x == -1**x`\n\nImplementations of `Scalable` usually also satisfy \n[[Summable]], in which case, the following identity \nshould be respected:\n\n- `x+x == 2**x`"],"by":["Gavin"]},"$m":{"scale":{"$t":{"$nm":"Value"},"$ps":[[{"$t":{"$nm":"Scale"},"$mt":"prm","$nm":"scalar"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Scale this value by the given scale factor."]},"$nm":"scale"}},"$nm":"Scalable","$st":"Value"},"Annotated":{"$mt":"ifc","$an":{"shared":[],"see":["Annotation"],"doc":["A program element that can\nbe annotated."]},"$nm":"Annotated"},"InitializationException":{"super":{"$pk":"ceylon.language","$nm":"Exception"},"$ps":[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"description"}],"$mt":"cls","$an":{"shared":[],"see":["late"],"doc":["Thrown when a problem was detected with value initialization.\n\nPossible problems include:\n\n* when a value could not be initialized due to recursive access during initialization, \n* an attempt to use a `late` value before it was initialized, \n* an attempt to assign to a `late` but non-`variable` value after it was initialized."]},"$at":{"description":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$nm":"description"}},"$nm":"InitializationException"},"StringBuilder":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$mt":"cls","$an":{"shared":[],"native":[],"doc":["Since strings are immutable, this class is used for\nconstructing a string by incrementally appending \ncharacters to the empty string. This class is mutable \nbut threadsafe."]},"$m":{"append":{"$t":{"$pk":"ceylon.language","$nm":"StringBuilder"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"string"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Append the characters in the given string."]},"$nm":"append"},"appendSpace":{"$t":{"$pk":"ceylon.language","$nm":"StringBuilder"},"$mt":"mthd","$an":{"shared":[],"doc":["Append a space character."]},"$nm":"appendSpace"},"delete":{"$t":{"$pk":"ceylon.language","$nm":"StringBuilder"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Deletes the specified number of characters from the\ncurrent content, starting at the specified position.\nIf the position is beyond the end of the current \ncontent, nothing is deleted. If the number of \ncharacters to delete is greater than the available \ncharacters from the given position, the content is \ntruncated at the given position."]},"$nm":"delete"},"reset":{"$t":{"$pk":"ceylon.language","$nm":"StringBuilder"},"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Remove all content and return to initial state."]},"$nm":"reset"},"insertCharacter":{"$t":{"$pk":"ceylon.language","$nm":"StringBuilder"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"},{"$t":{"$pk":"ceylon.language","$nm":"Character"},"$mt":"prm","$nm":"character"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Insert a `Character` at the specified position. If \nthe position is beyond the end of the current string, \nthe new content is simply appended to the current \ncontent. If the position is a negative number, the \nnew content is inserted at index 0."]},"$nm":"insertCharacter"},"appendAll":{"$t":{"$pk":"ceylon.language","$nm":"StringBuilder"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"String"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"strings"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Append the characters in the given strings."]},"$nm":"appendAll"},"insert":{"$t":{"$pk":"ceylon.language","$nm":"StringBuilder"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"},{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"string"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Insert a `String` at the specified position. If the \nposition is beyond the end of the current string, \n    the new content is simply appended to the current \n    content. If the position is a negative number, the \n    new content is inserted at index 0."]},"$nm":"insert"},"appendNewline":{"$t":{"$pk":"ceylon.language","$nm":"StringBuilder"},"$mt":"mthd","$an":{"shared":[],"doc":["Append a newline character."]},"$nm":"appendNewline"},"appendCharacter":{"$t":{"$pk":"ceylon.language","$nm":"StringBuilder"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Character"},"$mt":"prm","$nm":"character"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Append the given character."]},"$nm":"appendCharacter"}},"$at":{"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The resulting string. If no characters have been\nappended, the empty string."],"actual":[]},"$nm":"string"},"size":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Returns the size of the current content."]},"$nm":"size"}},"$nm":"StringBuilder"},"emptyOrSingleton":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Element"}],"$an":{"shared":[],"see":["Singleton","Empty"],"doc":["A `Singleton` if the given element is non-null, otherwise `Empty`."]},"$nm":"emptyOrSingleton"},"shared":{"$t":{"$pk":"ceylon.language","$nm":"SharedAnnotation"},"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to mark a type or member as shared. A `shared` \nmember is visible outside the block of code in which it is \ndeclared."]},"$annot":"1","$nm":"shared"},"TagsAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$ps":[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"String"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$an":{"shared":[],"doc":["The tags, in plain text."]},"$nm":"tags"}],"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"TagsAnnotation"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Annotated"}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[tagged]]."]},"$annot":"1","$at":{"tags":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"String"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"attr","$an":{"shared":[],"doc":["The tags, in plain text."]},"$nm":"tags"}},"$nm":"TagsAnnotation"},"Binary":{"of":[{"$nm":"Other"}],"$mt":"ifc","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Binary"}],"$nm":"Other"}],"$an":{"shared":[],"see":["Integer"],"doc":["Abstraction of numeric types like `Integer` that may be \nrepresented as a sequence of bits, and may be the subject\nof bitwise operations."],"by":["Stef"]},"$m":{"clear":{"$t":{"$nm":"Other"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Returns a new number with the given bit set to 0.\nBits are indexed from right to left."]},"$nm":"clear"},"xor":{"$t":{"$nm":"Other"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Performs a logical exclusive OR operation."]},"$nm":"xor"},"get":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Retrieves a given bit from this bit sequence. Bits are indexed from\nright to left."]},"$nm":"get"},"leftLogicalShift":{"$t":{"$nm":"Other"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"shift"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Performs a left logical shift. Sign is not preserved. Padded with zeros."]},"$nm":"leftLogicalShift"},"set":{"$t":{"$nm":"Other"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"},{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"prm","$def":"1","$nm":"bit"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Returns a new number with the given bit set to the given value.\nBits are indexed from right to left."]},"$nm":"set"},"or":{"$t":{"$nm":"Other"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Performs a logical inclusive OR operation."]},"$nm":"or"},"rightArithmeticShift":{"$t":{"$nm":"Other"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"shift"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Performs a right arithmetic shift. Sign is preserved. Padded with zeros."]},"$nm":"rightArithmeticShift"},"rightLogicalShift":{"$t":{"$nm":"Other"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"shift"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Performs a right logical shift. Sign is not preserved. Padded with zeros."]},"$nm":"rightLogicalShift"},"flip":{"$t":{"$nm":"Other"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Returns a new number with the given bit flipped to its opposite value.\nBits are indexed from right to left."]},"$nm":"flip"},"and":{"$t":{"$nm":"Other"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Performs a logical AND operation."]},"$nm":"and"}},"$at":{"not":{"$t":{"$nm":"Other"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The binary complement of this sequence of bits."]},"$nm":"not"},"size":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The number of bits (0 or 1) that this sequence of bits can hold."]},"$nm":"size"}},"$nm":"Binary","$st":"Other"},"commaList":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"elements"}]],"$mt":"mthd","$nm":"commaList"},"LazyMap":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$ps":[{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Entry"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"entries"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Map"}],"$mt":"cls","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"variance":"out","$nm":"Key"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"variance":"out","$nm":"Item"}],"$an":{"shared":[],"doc":["A `Map` implementation that wraps an `Iterable` of \nentries. All operations, such as lookups, size, etc. \nare performed on the `Iterable`."],"by":["Enrique Zamudio"]},"$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Entry"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator"},"get":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Item"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"key"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"get"},"equals":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"that"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"actual":[]},"$nm":"equals"}},"$at":{"clone":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"LazyMap"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"clone"},"last":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Entry"}]},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"last"},"hash":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"default":[],"actual":[]},"$nm":"hash"},"entries":{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Entry"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"attr","$nm":"entries"},"first":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Entry"}]},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"first"},"size":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"size"}},"$nm":"LazyMap"},"Map":{"satisfies":[{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Entry"}],"$pk":"ceylon.language","$nm":"Collection"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Correspondence"},{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Map"}],"$pk":"ceylon.language","$nm":"Cloneable"}],"$mt":"ifc","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"variance":"out","$nm":"Key"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"variance":"out","$nm":"Item"}],"$an":{"shared":[],"see":["Entry","forKey","forItem","byItem","byKey"],"doc":["Represents a collection which maps _keys_ to _items_,\nwhere a key can map to at most one item. Each such \nmapping may be represented by an `Entry`.\n\nA `Map` is a `Collection` of its `Entry`s, and a \n`Correspondence` from keys to items.\n\nThe presence of an entry in a map may be tested\nusing the `in` operator:\n\n    if (\"lang\"->\"en_AU\" in settings) { ... }\n\nThe entries of the map may be iterated using `for`:\n\n    for (key->item in settings) { ... }\n\nThe item for a key may be obtained using the item\noperator:\n\n    String lang = settings[\"lang\"] else \"en_US\";"]},"$m":{"equals":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"that"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Two `Map`s are considered equal iff they have the \nsame _entry sets_. The entry set of a `Map` is the\nset of `Entry`s belonging to the map. Therefore, the\nmaps are equal iff they have same set of `keys`, and \nfor every key in the key set, the maps have equal\nitems."],"actual":[]},"$nm":"equals"},"mapItems":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$nm":"Result"}],"$pk":"ceylon.language","$nm":"Map"},"$ps":[[{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Key"},"$mt":"prm","$nm":"key"},{"$t":{"$nm":"Item"},"$mt":"prm","$nm":"item"}]],"$mt":"prm","$pt":"f","$an":{"doc":["The function that transforms a key\/item\npair, producing the item of the resulting\nmap."]},"$nm":"mapping"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Result"}],"$an":{"shared":[],"default":[],"doc":["Returns a `Map` with the same keys as this map. For\nevery key, the item is the result of applying the\ngiven transformation function."]},"$nm":"mapItems"}},"$at":{"values":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Collection"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["Returns all the values stored in this `Map`. An \nelement can be stored under more than one key in \nthe map, and so it can be contained more than once \nin the resulting collection."]},"$nm":"values"},"inverse":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Item"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Key"}],"$pk":"ceylon.language","$nm":"Set"}],"$pk":"ceylon.language","$nm":"Map"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["Returns a `Map` in which every key is an `Item` in \nthis map, and every value is the set of keys that \nstored the `Item` in this map."]},"$nm":"inverse"},"keys":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Key"}],"$pk":"ceylon.language","$nm":"Set"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["Returns the set of keys contained in this `Map`."],"actual":[]},"$nm":"keys"},"hash":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"default":[],"actual":[]},"$nm":"hash"}},"$nm":"Map"},"Number":{"$mt":"ifc","$an":{"shared":[],"see":["Numeric","Scalar"],"doc":["Abstraction of numbers. Binary numeric operations are \ndefined the interface [[Numeric]]. This type defines \noperations which can be expressed without reference to \nthe self type `Other` of `Numeric`."],"by":["Gavin"]},"$at":{"sign":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The sign of this number. Returns `1` if the number \nis positive, `-1` if it is negative, or `0` if it \nis zero."]},"$nm":"sign"},"integer":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"formal":[],"throws":["OverflowException","if the number is too large to be represented \nas an `Integer`"],"doc":["The number, represented as an `Integer`, after \ntruncation of any fractional part."]},"$nm":"integer"},"magnitude":{"$t":{"$pk":"ceylon.language","$nm":"Number"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The magnitude of the number."]},"$nm":"magnitude"},"wholePart":{"$t":{"$pk":"ceylon.language","$nm":"Number"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The integral value of the number after truncation \nof the fractional part."]},"$nm":"wholePart"},"negative":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["Determine if the number is negative."]},"$nm":"negative"},"positive":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["Determine if the number is positive."]},"$nm":"positive"},"fractionalPart":{"$t":{"$pk":"ceylon.language","$nm":"Number"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The fractional part of the number, after truncation \nof the integral part."]},"$nm":"fractionalPart"},"float":{"$t":{"$pk":"ceylon.language","$nm":"Float"},"$mt":"attr","$an":{"shared":[],"formal":[],"throws":["OverflowException","if the number is too large to be represented \nas a `Float`"],"doc":["The number, represented as a `Float`."]},"$nm":"float"}},"$nm":"Number"},"Numeric":{"of":[{"$nm":"Other"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Summable"},{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Invertable"}],"$mt":"ifc","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Other"}],"$pk":"ceylon.language","$nm":"Numeric"}],"$nm":"Other"}],"$an":{"shared":[],"see":["Scalar"],"doc":["Abstraction of numeric types with addition, \n`x + y`, subtraction, `x - y`, multiplication, \n`x * y`, and division, `x \/ y`, along with \nadditive inverse `-x`.\n\nIn general, a numeric type need not define a\n[[total order|Comparable]]. For example, complex \nnumbers do not have a total order. Numeric types \nwith a total order also satisfy [[Scalar]]."],"by":["Gavin"]},"$m":{"minus":{"$t":{"$nm":"Other"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["The difference between this number and the given \nnumber."]},"$nm":"minus"},"times":{"$t":{"$nm":"Other"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["The product of this number and the given number."]},"$nm":"times"},"divided":{"$t":{"$nm":"Other"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"see":["Integral"],"doc":["The quotient obtained by dividing this number by \nthe given number. For integral numeric types, this \noperation results in a remainder."]},"$nm":"divided"}},"$nm":"Numeric","$st":"Other"},"throws":{"$t":{"$pk":"ceylon.language","$nm":"ThrownExceptionAnnotation"},"$ps":[[{"$t":{"$pk":"ceylon.language.meta.declaration","$nm":"Declaration"},"$mt":"prm","$an":{"doc":["The [[Exception]] type that this thrown."]},"$nm":"type"},{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$def":"1","$an":{"doc":["A description, in Markdown syntax, of the circumstances that \ncause this exception to be thrown."]},"$nm":"when"}]],"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to mark a program element that throws an \nexception."]},"$annot":"1","$nm":"throws"},"Closeable":{"$mt":"ifc","$an":{"shared":[],"doc":["Abstract supertype of types which may appear\nas the expression type of a resource expression\nin a `try` statement."]},"$m":{"open":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Called before entry to a `try` block."]},"$nm":"open"},"close":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Exception"}]},"$mt":"prm","$nm":"exception"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Called after completion of a `try` block."]},"$nm":"close"}},"$nm":"Closeable"},"parseDigit":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Integer"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Character"},"$mt":"prm","$nm":"digit"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"radix"}]],"$mt":"mthd","$nm":"parseDigit"},"formal":{"$t":{"$pk":"ceylon.language","$nm":"FormalAnnotation"},"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to mark a member whose implementation must be \nprovided by subtypes."]},"$annot":"1","$nm":"formal"},"byDecreasing":{"$t":{"$pk":"ceylon.language","$nm":"Comparison"},"$ps":[[{"$t":{"$nm":"Value"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"e"}]],"$mt":"prm","$pt":"f","$nm":"comparable"}],[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"x"},{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"y"}]],"$mt":"mthd","$tp":[{"$nm":"Element"},{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Value"}],"$pk":"ceylon.language","$nm":"Comparable"}],"$nm":"Value"}],"$an":{"shared":[],"see":["byIncreasing"],"doc":["A comparator which orders elements in decreasing order \naccording to the `Comparable` returned by the given \n`comparable()` function."]},"$nm":"byDecreasing"},"default":{"$t":{"$pk":"ceylon.language","$nm":"DefaultAnnotation"},"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to mark a member whose implementation may be \nrefined by subtypes. Non-`default` declarations may not be \nrefined."]},"$annot":"1","$nm":"default"},"unzipEntries":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},{"$tp":[{"$mt":"tpm","$nm":"Item"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"}]},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Item"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Item"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Empty"}],"$pk":"ceylon.language","$nm":"Tuple"}],"$pk":"ceylon.language","$nm":"Tuple"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Entry"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"entries"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Key"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Item"}],"$an":{"shared":[],"doc":["Given a stream of entries, return two streams. The\nfirst stream produces the keys of the given entries, \nand the second stream produces the items of the given \nentries.\n\nThus:\n\n    unzipEntries(entries)[i]==[entries[i].key,entries[i].item]"]},"$nm":"unzipEntries"},"SequencedAnnotation":{"of":[{"$nm":"Value"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Value"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Value"}],"$pk":"ceylon.language","$nm":"Sequential"},{"$mt":"tpm","$nm":"ProgramElement"}],"$pk":"ceylon.language","$nm":"ConstrainedAnnotation"}],"$mt":"ifc","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Value"},{"$mt":"tpm","$nm":"ProgramElement"}],"$pk":"ceylon.language","$nm":"SequencedAnnotation"}],"variance":"out","$nm":"Value"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Annotated"}],"$def":{"$pk":"ceylon.language","$nm":"Annotated"},"variance":"in","$nm":"ProgramElement"}],"$an":{"shared":[],"see":["Annotation"],"doc":["An annotation that may occur multiple times at a single program element, \nand only on certain program elemenets.\n\nA sequenced annotation is declared simply by having the annotation class\nsatisfy SequencedAnnotation instead of [[Annotation]]. For example \nthe following would only be allowed on `class` declarations, \nfunctions or methods:\n\n    alias ExecutableDeclaration \n           => ClassOrInterfaceDeclaration|FunctionDeclaration\n    \"Documents a pattern that the annotated element is particpating in\"\n    final annotation class Pattern(String name) \n            satisfies SequencedAnnotation<Pattern, ExecutableDeclaration> {\n    }\n\nAt runtime a [[ceylon.language.meta.declaration::Declaration]] instance \ncan be queried for its `SequencedAnnotation`s of a certain type using \n[[ceylon.language.meta::annotations]] or [[ceylon.language.meta::sequencedAnnotations]].\n"]},"$nm":"SequencedAnnotation","$st":"Value"},"AnnotationAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"AnnotationAnnotation"},{"comp":"u","$mt":"tpm","$ts":[{"$pk":"ceylon.language.meta.declaration","$nm":"ClassDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"FunctionDeclaration"}]}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[annotation]]."]},"$annot":"1","$nm":"AnnotationAnnotation"},"minRadix":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$nm":"minRadix"},"String":{"super":{"$pk":"ceylon.language","$nm":"Object"},"$ps":[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Character"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$hdn":"1","$mt":"prm","$an":{"shared":[],"doc":["The characters that form this string."]},"$nm":"characters"}],"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Character"}],"$pk":"ceylon.language","$nm":"List"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"String"}],"$pk":"ceylon.language","$nm":"Comparable"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"String"}],"$pk":"ceylon.language","$nm":"Summable"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"String"}],"$pk":"ceylon.language","$nm":"Ranged"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"String"}],"$pk":"ceylon.language","$nm":"Cloneable"}],"$mt":"cls","$an":{"shared":[],"final":[],"native":[],"doc":["A string of characters. Each character in the string is\na 32-bit Unicode character. The internal UTF-16 encoding \nis hidden from clients.\n\nA string is a `Category` of its `Character`s, and of its \nsubstrings:\n\n    'w' in greeting \n    \"hello\" in greeting\n\nStrings are summable:\n\n    String greeting = \"hello\" + \" \" + \"world\";\n\nThey are efficiently iterable:\n\n    for (char in \"hello world\") { ... }\n\nThey are `List`s of `Character`s:\n\n    value char = \"hello world\"[5];\n\nThey are ranged:\n\n    String who = \"hello world\"[6...];\n\nNote that since `string[index]` evaluates to the\noptional type `Character?`, it is often more convenient\nto write `string[index..index]`, which evaluates to a\n`String` containing a single character, or to the empty\nstring `\"\"` if `index` refers to a position outside the\nstring.\n\nIt is easy to use comprehensions to transform strings:\n\n    String { for (s in \"hello world\") if (s.letter) s.uppercased }\n\nSince a `String` has an underlying UTF-16 encoding, \ncertain operations are expensive, requiring iteration of \nthe characters of the string. In particular, `size`\nrequires iteration of the whole string, and `get()`,\n`span()`, and `segment()` require iteration from the \nbeginning of the string to the given index."],"by":["Gavin"]},"$m":{"plus":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Returns the concatenation of this string with the\ngiven string."],"actual":[]},"$nm":"plus"},"iterator":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Character"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["An iterator for the characters of the string."],"actual":[]},"$nm":"iterator"},"get":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Character"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Returns the character at the given index in the \nstring, or `null` if the index is past the end of\nstring. The first character in the string occurs at\nindex zero. The last character in the string occurs\nat index `string.size-1`."],"actual":[]},"$nm":"get"},"equals":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"that"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Determines if the given object is a string, and if\nso, if this string has the same length, and the \nsame characters, in the same order, as the given \nstring."],"actual":[]},"$nm":"equals"},"segment":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Select the characters of this string beginning at \nthe given index, returning a string no longer than \nthe given length. If the portion of this string\nstarting at the given index is shorter than \nthe given length, return the portion of this string\nfrom the given index until the end of this string. \nOtherwise return a string of the given length. If \nthe start index is larger than the last index of the \nstring, return the empty string."],"actual":[]},"$nm":"segment"},"compare":{"$t":{"$pk":"ceylon.language","$nm":"Comparison"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Compare this string with the given string \nlexicographically, according to the Unicode values\nof the characters."],"actual":[]},"$nm":"compare"},"longerThan":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"see":["size"],"doc":["Determines if this string is longer than the given\nlength. This is a more efficient operation than\n`string.size>length`."],"actual":[]},"$nm":"longerThan"},"contains":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Determines if the given object is a `String` and, \nif so, if it occurs as a substring of this string,\nor if the object is a `Character` that occurs in\nthis string. That is to say, a string is considered \na `Category` of its substrings and of its \ncharacters."],"actual":[]},"$nm":"contains"},"trimLeading":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Character"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$nm":"trimming"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["This string, after discarding the given \ncharacters from the beginning of the string"],"actual":[]},"$nm":"trimLeading"},"repeat":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"times"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Returns a string formed by repeating this string\nthe given number of times, or the empty string if\n`times<=0`."],"actual":[]},"$nm":"repeat"},"join":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"String"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"strings"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Join the given strings, using this string as a \nseparator."]},"$nm":"join"},"replace":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"substring"},{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"replacement"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Returns a string formed by replacing every \noccurrence in this string of the given substring\nwith the given replacement string, working from \nthe start of this string to the end."]},"$nm":"replace"},"terminal":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Select the last characters of the string, \nreturning a string no longer than the given \nlength. If this string is shorter than the given\nlength, return this string. Otherwise return a\nstring of the given length."],"actual":[]},"$nm":"terminal"},"shorterThan":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"see":["size"],"doc":["Determines if this string is shorter than the given\nlength. This is a more efficient operation than\n`string.size>length`."],"actual":[]},"$nm":"shorterThan"},"spanTo":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"to"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"spanTo"},"trimTrailing":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Character"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$nm":"trimming"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["This string, after discarding the given \ncharacters from the end of the string"],"actual":[]},"$nm":"trimTrailing"},"initial":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Select the first characters of this string, \nreturning a string no longer than the given \nlength. If this string is shorter than the given\nlength, return this string. Otherwise return a\nstring of the given length."],"actual":[]},"$nm":"initial"},"split":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"String"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Character"},"$mt":"prm","$nm":"ch"}]],"$mt":"prm","$pt":"f","$def":"1","$an":{"doc":["A predicate that determines if a character\nis a separator characters at which to split.\nDefault to split at any \n[[whitespace|Character.whitespace]] character."]},"$nm":"splitting"},{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"prm","$def":"1","$an":{"doc":["Specifies that the separator characters\noccurring in the string should be discarded.\nIf `false`, they will be included in the\nresulting iterator."]},"$nm":"discardSeparators"},{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"prm","$def":"1","$an":{"doc":["Specifies that the separator tokens should \nbe grouped eagerly and not be treated as \nsingle-character tokens. If `false` each \nseparator token will be of size `1`."]},"$nm":"groupSeparators"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Split the string into tokens, using the given\npredicate to determine which characters are \nseparator characters."]},"$nm":"split"},"trim":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Character"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$nm":"trimming"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["This string, after discarding the given \ncharacters from the beginning and end \nof the string"],"actual":[]},"$nm":"trim"},"spanFrom":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"spanFrom"},"span":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"to"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Select the characters between the given indexes.\nIf the start index is the same as the end index,\nreturn a string with a single character.\nIf the start index is larger than the end index, \nreturn the characters in the reverse order from\nthe order in which they appear in this string.\nIf both the start index and the end index are \nlarger than the last index in the string, return \nthe empty string. Otherwise, if the last index is \nlarger than the last index in the sequence, return\nall characters from the start index to last \ncharacter of the string."],"actual":[]},"$nm":"span"}},"$at":{"normalized":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["This string, after collapsing strings of \n[[whitespace|Character.whitespace]]\ninto single space characters and discarding whitespace \nfrom the beginning and end of the string."]},"$nm":"normalized"},"lowercased":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["This string, with all characters in lowercase."]},"$nm":"lowercased"},"hash":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"actual":[]},"$nm":"hash"},"uppercased":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["This string, with all characters in uppercase."]},"$nm":"uppercased"},"coalesced":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns this string."],"actual":[]},"$nm":"coalesced"},"size":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"see":["longerThan","shorterThan"],"doc":["The length of the string (the number of characters\nit contains). In the case of the empty string, the\nstring has length zero. Note that this operation is\npotentially costly for long strings, since the\nunderlying representation of the characters uses a\nUTF-16 encoding."],"actual":[]},"$nm":"size"},"lastIndex":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Integer"}]},"$mt":"gttr","$an":{"shared":[],"doc":["The index of the last character in the string, or\n`null` if the string has no characters. Note that \nthis operation is potentially costly for long \nstrings, since the underlying representation of the \ncharacters uses a UTF-16 encoding."],"actual":[]},"$nm":"lastIndex"},"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns the string itself."],"actual":[]},"$nm":"string"},"empty":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"attr","$an":{"shared":[],"native":[],"see":["size"],"doc":["Determines if this string has no characters, that\nis, if it has zero `size`. This is a more efficient \noperation than `string.size==0`."],"actual":[]},"$nm":"empty"},"lines":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"String"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"gttr","$an":{"shared":[],"native":[],"doc":["Split the string into lines of text."]},"$nm":"lines"},"rest":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The rest of the string, without the first element."],"actual":[]},"$nm":"rest"},"trimmed":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"native":[],"doc":["This string, after discarding \n[[whitespace|Character.whitespace]] from the \nbeginning and end of the string."]},"$nm":"trimmed"},"reversed":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["This string, with the characters in reverse order."],"actual":[]},"$nm":"reversed"},"characters":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Character"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"attr","$an":{"shared":[],"doc":["The characters that form this string."]},"$nm":"characters"}},"$nm":"String"},"parseBoolean":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Boolean"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"string"}]],"$mt":"mthd","$an":{"shared":[],"doc":["The `Boolean` value of the given string representation of a boolean value,\nor `null` if the string does not represent a boolean value.\n\nRecognized values are \"true\", \"false\"."]},"$nm":"parseBoolean"},"identical":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Identifiable"},"$mt":"prm","$an":{"doc":["An object with well-defined identity."]},"$nm":"x"},{"$t":{"$pk":"ceylon.language","$nm":"Identifiable"},"$mt":"prm","$an":{"doc":["A second object with well-defined identity."]},"$nm":"y"}]],"$mt":"mthd","$an":{"shared":[],"see":["identityHash"],"doc":["Determine if the arguments are identical. Equivalent to\n`x===y`. Only instances of `Identifiable` have \nwell-defined identity."]},"$nm":"identical"},"late":{"$t":{"$pk":"ceylon.language","$nm":"LateAnnotation"},"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to disable definite initialization analysis for \na reference."]},"$annot":"1","$nm":"late"},"integerRangeByIterable":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Range"},"$mt":"prm","$nm":"range"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"step"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Ordinal"},{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Comparable"}],"$nm":"Element"}],"$an":{"native":[],"doc":["Provides an optimized implementation of `Range<Integer>.iterator`. \nThis is necessary because we need reified generics in order to write \nthe optimized version in pure Ceylon."]},"$nm":"integerRangeByIterable"},"emptyIterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"obj","$an":{"shared":[],"doc":["An iterator that returns no elements."]},"$m":{"next":{"$t":{"$pk":"ceylon.language","$nm":"Finished"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$nm":"emptyIterator"},"printStackTrace":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Exception"},"$mt":"prm","$nm":"exception"},{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"string"}]],"$mt":"prm","$pt":"f","$def":"1","$an":{"doc":["A function that prints the given string.\nDefaults to `process.writeError()`."]},"$nm":"write"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Print the stack trace of the given exception using \nthe given function, or to standard error if no\nfunction is specified."]},"$nm":"printStackTrace"},"parseFloat":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Float"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"string"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["The `Float` value of the given string representation of \na decimal number or `null` if the string does not \nrepresent a decimal number.\n\nThe syntax accepted by this method is the same as the \nsyntax for a `Float` literal in the Ceylon language \nexcept that it may optionally begin with a sign \ncharacter (`+` or `-`)."]},"$nm":"parseFloat"},"VariableAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"VariableAnnotation"},{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"ValueDeclaration"}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[variable]]."]},"$annot":"1","$nm":"VariableAnnotation"},"Anything":{"abstract":"1","of":[{"$pk":"ceylon.language","$nm":"Object"},{"$pk":"ceylon.language","$nm":"Null"}],"$mt":"cls","$an":{"abstract":[],"shared":[],"doc":["The abstract supertype of all types. A value of type \n`Anything` may be a definite value of type `Object`, or \nit may be the `null` value. A method declared `void` is \nconsidered to have the return type `Anything`.\n\nNote that the type `Nothing`, representing the \nintersection of all types, is a subtype of all types."],"by":["Gavin"]},"$nm":"Anything"},"Exception":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$ps":[{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"String"}]},"$hdn":"1","$mt":"prm","$def":"1","$an":{"doc":["A description of the problem."]},"$nm":"description"},{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Exception"}]},"$hdn":"1","$mt":"prm","$def":"1","$an":{"shared":[],"doc":["The underlying cause of this exception."]},"$nm":"cause"}],"$mt":"cls","$an":{"shared":[],"native":[],"doc":["The supertype of all exceptions. A subclass represents\na more specific kind of problem, and may define \nadditional attributes which propagate information about\nproblems of that kind."],"by":["Gavin","Tom"]},"$m":{"printStackTrace":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"mthd","$an":{"shared":[],"see":["printTrace"],"doc":["Print the stack trace to the standard error of\nthe virtual machine process."]},"$nm":"printStackTrace"}},"$at":{"message":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"default":[],"see":["cause"],"doc":["A message describing the problem. This default \nimplementation returns the description, if any, or \notherwise the message of the cause, if any."]},"$nm":"message"},"cause":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Exception"}]},"$mt":"attr","$an":{"shared":[],"doc":["The underlying cause of this exception."]},"$nm":"cause"},"description":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"String"}]},"$mt":"attr","$an":{"doc":["A description of the problem."]},"$nm":"description"},"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"default":[],"actual":[]},"$nm":"string"}},"$nm":"Exception"},"operatingSystem":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$mt":"obj","$an":{"shared":[],"native":[],"doc":["Operating System on which the current process is running."]},"$at":{"newline":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The line ending character sequence on this platform."]},"$nm":"newline"},"fileSeparator":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The character used on this platform to separate the folder\/file elements of a path."]},"$nm":"fileSeparator"},"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"string"},"name":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Returns the name of the operating system this process is running on."]},"$nm":"name"},"pathSeparator":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The character used on this platform to use as a separator between several paths in a list of paths."]},"$nm":"pathSeparator"},"version":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Returns the version of the operating system this process is running on."]},"$nm":"version"}},"$nm":"operatingSystem"},"internalSort":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Comparison"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"x"},{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"y"}]],"$mt":"prm","$pt":"f","$nm":"comparing"},{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"elements"}]],"$mt":"mthd","$tp":[{"$nm":"Element"}],"$an":{"native":[]},"$nm":"internalSort"},"OverflowException":{"super":{"$pk":"ceylon.language","$nm":"Exception"},"$mt":"cls","$an":{"shared":[],"doc":["Thrown when a mathematical operation caused a number to \noverflow from its bounds."]},"$nm":"OverflowException"},"parseInteger":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Integer"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"string"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$def":"1","$nm":"radix"}]],"$mt":"mthd","$an":{"shared":[],"throws":["AssertionException","if `radix` is not between `minRadix` and `maxRadix`"],"doc":["The `Integer` value of the given string representation \nof an integer, or `null` if the string does not represent \nan integer or if the mathematical integer it represents \nis too large in magnitude to be represented by an \n`Integer`.\n\nThe syntax accepted by this function is the same as the \nsyntax for an `Integer` literal in the Ceylon language \nexcept that it may optionally begin with a sign \ncharacter (`+` or `-`).\n\nA radix can be given in input to specify what is the base\nto take in consideration for the parsing. radix has to be\nbetween `minRadix` and `maxRadix` included.\nThe list of available digits starts from `0` to `9` followed\nby `a` to `z`.\nWhen parsing in a specific base, the first `radix` digits\nfrom the available digits list can be used.\nThis function is not case sensitive; `a` and `A` both\ncorrespond to the `a` digit which decimal value is `10`.\n \n`_` character can be used to separate groups of digits\nfor bases 2, 10 and 16 as for `Integer` literal in the\nCeylon language. For any other bases, no grouping is\nsupported."]},"$nm":"parseInteger"},"unzip":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$tp":[{"$mt":"tpm","$nm":"Head"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},{"$tp":[{"$mt":"tpm","$nm":"Tail"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"}]},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Head"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Tail"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Tail"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Empty"}],"$pk":"ceylon.language","$nm":"Tuple"}],"$pk":"ceylon.language","$nm":"Tuple"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Head"}]},{"$mt":"tpm","$nm":"Head"},{"$mt":"tpm","$nm":"Tail"}],"$pk":"ceylon.language","$nm":"Tuple"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"tuples"}]],"$mt":"mthd","$tp":[{"$nm":"Element"},{"$nm":"Head"},{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$nm":"Tail"}],"$an":{"shared":[],"doc":["Given a stream of tuples, return two streams. The\nfirst stream produces the first elements of the\ngiven tuples, and the second stream produces the\nremaining elements of the given tuples.\n\nThus:\n\n    unzip(tuples)[i]==[tuples[i].first,*tuples[i].rest]"]},"$nm":"unzip"},"runtime":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$mt":"obj","$an":{"shared":[],"native":[],"doc":["Machine (Virtual or not) on which the current process is running.\n\nHolds information about runtime name, version and about inherent limitations\nlike minimum\/maximum values that can be represented by the runtime."]},"$at":{"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"actual":[]},"$nm":"string"},"name":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Returns the name of the runtime \/ virtual machine this process is running on."]},"$nm":"name"},"integerSize":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The number of bits used to represent the value of an `Integer`."]},"$nm":"integerSize"},"maxIntegerValue":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The maximum `Integer` value that can be represented by the runtime.\n\nIt is the maximum `Integer` that can be distinguished from its predecessor\nusing below formula:\n\n`Integer(n+1) = Integer(n) + 1` with `Integer(0) = 0`"]},"$nm":"maxIntegerValue"},"minIntegerValue":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The minimum `Integer` value that can be represented by the runtime.\n\nIt is the minimum `Integer` that can be distinguished from its successor\nusing below formula:\n\n`Integer(n-1) = Integer(n) - 1` with `Integer(0) = 0`"]},"$nm":"minIntegerValue"},"version":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["Returns the version of the runtime \/ virtual machine this process is running on."]},"$nm":"version"}},"$nm":"runtime"},"sum":{"$t":{"$nm":"Value"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Value"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"values"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Value"}],"$pk":"ceylon.language","$nm":"Summable"}],"$nm":"Value"}],"$an":{"shared":[],"see":["product"],"doc":["Given a nonempty stream of `Summable` values, return \nthe sum of the values."]},"$nm":"sum"},"infinity":{"$t":{"$pk":"ceylon.language","$nm":"Float"},"$mt":"attr","$an":{"shared":[],"doc":["An instance of `Float` representing positive infinity \n∞."]},"$nm":"infinity"},"smaller":{"super":{"$pk":"ceylon.language","$nm":"Comparison"},"$mt":"obj","$an":{"shared":[],"doc":["The value is smaller than the given value."]},"$nm":"smaller"},"computeDigitGroupingSize":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Integer"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"radix"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"digitIndex"},{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$nm":"string"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"ii"}]],"$mt":"mthd","$nm":"computeDigitGroupingSize"},"DefaultAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"DefaultAnnotation"},{"comp":"u","$mt":"tpm","$ts":[{"$pk":"ceylon.language.meta.declaration","$nm":"ValueDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"FunctionDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"ClassOrInterfaceDeclaration"}]}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[default]]."]},"$annot":"1","$nm":"DefaultAnnotation"},"Iterable":{"satisfies":[{"$pk":"ceylon.language","$nm":"Category"}],"$mt":"ifc","$tp":[{"variance":"out","$nm":"Element"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Null"}],"$def":{"$pk":"ceylon.language","$nm":"Null"},"variance":"out","$nm":"Absent"}],"$an":{"shared":[],"see":["Collection"],"doc":["Abstract supertype of categories whose elements may be \niterated. An iterable category need not be finite, but\nits elements must at least be countable. There may not\nbe a well-defined iteration order, and so the order of\niterated elements may not be stable.\n\nThe type `Iterable<Element,Null>`, usually abbreviated\n`{Element*}` represents a possibly-empty iterable \ncontainer. The type `Iterable<Element,Nothing>`, \nusually abbreviated `{Element+}` represents a nonempty \niterable container.\n\nAn instance of `Iterable` may be constructed by \nsurrounding a value list in braces:\n\n    {String+} words = { \"hello\", \"world\" };\n\nAn instance of `Iterable` may be iterated using a `for`\nloop:\n\n    for (c in \"hello world\") { ... }\n\n`Iterable` and its subtypes define various operations\nthat return other iterable objects. Such operations \ncome in two flavors:\n\n- _Lazy_ operations return a *view* of the receiving\n  iterable object. If the underlying iterable object is\n  mutable, then changes to the underlying object will\n  be reflected in the resulting view. Lazy operations\n  are usually efficient, avoiding memory allocation or\n  iteration of the receiving iterable object.\n- _Eager_ operations return an immutable object. If the\n  receiving iterable object is mutable, changes to this\n  object will not be reflected in the resulting \n  immutable object. Eager operations are often \n  expensive, involving memory allocation and iteration\n  of the receiving iterable object.\n\nLazy operations are preferred, because they can be \nefficiently chained. For example:\n\n    string.filter((Character c) => c.letter)\n          .map((Character c) => c.uppercased)\n\nis much less expensive than:\n\n    string.select((Character c) => c.letter)\n          .collect((Character c) => c.uppercased)\n\nFurthermore, it is always easy to produce a new \nimmutable iterable object given the view produced by a\nlazy operation. For example:\n\n    [ *string.filter((Character c) => c.letter)\n          .map((Character c) => c.uppercased) ]\n\nLazy operations normally return an instance of \n`Iterable` or `Map`.\n\nHowever, there are certain scenarios where an eager \noperation is more useful, more convenient, or no more \nexpensive than a lazy operation, including:\n\n- sorting operations, which are eager by nature,\n- operations which preserve emptiness\/nonemptiness of\n  the receiving iterable object.\n\nEager operations normally return a sequence."],"by":["Gavin"]},"$m":{"cycle":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$nm":"Absent"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"times"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["cycled","repeat"],"doc":["A finite iterable object that produces the elements of \nthis iterable object, repeatedly, the given number of\ntimes."]},"$nm":"cycle","$o":{"iterable":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$nm":"Absent"}],"$pk":"ceylon.language","$nm":"Iterable"}],"$mt":"obj","$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator","$o":{"iterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"obj","$m":{"next":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$at":{"count":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"var":"1","$mt":"attr","$an":{"variable":[]},"$nm":"count"},"iter":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"var":"1","$mt":"attr","$an":{"shared":[],"actual":[],"variable":[]},"$nm":"iter"}},"$nm":"iterator"}}}},"$at":{"orig":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$nm":"Absent"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"gttr","$nm":"orig"}},"$nm":"iterable"}}},"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["An iterator for the elements belonging to this \ncontainer."]},"$nm":"iterator"},"sort":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Comparison"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"x"},{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"y"}]],"$mt":"prm","$pt":"f","$an":{"doc":["The function comparing pairs of elements."]},"$nm":"comparing"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["byIncreasing","byDecreasing"],"doc":["A sequence containing the elements of this\ncontainer, sorted according to a function \nimposing a partial order upon the elements.\n\nFor convenience, the functions `byIncreasing()` \nand `byDecreasing()` produce a suitable \ncomparison function:\n\n    \"Hello World!\".sort(byIncreasing((Character c) => c.lowercased))\n\nThis operation is eager by nature."]},"$nm":"sort"},"count":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$an":{"doc":["The predicate satisfied by the elements to\nbe counted."]},"$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Return the number of elements in this `Iterable` \nthat satisfy the predicate function."]},"$m":{"selecting":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"doc":["The predicate satisfied by the elements to\nbe counted."]},"$nm":"selecting"}},"$nm":"count"},"takingWhile":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$nm":"take"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Produce an `Iterable` containing the leading elements \nof this iterable object until the given predicate \nfunction returns `false`."]},"$m":{"take":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"mthd","$nm":"take"}},"$nm":"takingWhile","$o":{"iterable":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"}],"$mt":"obj","$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator","$o":{"iterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"obj","$m":{"next":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$at":{"alive":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"var":"1","$mt":"attr","$an":{"shared":[],"actual":[],"variable":[]},"$nm":"alive"}},"$nm":"iterator"}}}},"$nm":"iterable"}}},"select":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$an":{"doc":["The predicate the elements must satisfy."]},"$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["filter"],"doc":["A sequence containing the elements of this \ncontainer that satisfy the given predicate. An \neager counterpart to `filter()`."]},"$nm":"select"},"longerThan":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["size"],"doc":["Determines if this iterable object has more elements\nthan the given length. This is an efficient operation \nfor iterable objects with many elements."]},"$nm":"longerThan"},"by":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$nm":"Absent"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"step"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"throws":["AssertionException","if the given step size is nonpositive, \ni.e. `step<1`"],"doc":["Produce an `Iterable` containing every `step`th \nelement of this iterable object. If the step size \nis `1`, the `Iterable` contains the same elements \nas this iterable object. The step size must be \ngreater than zero. The expression\n\n    (0..10).by(3)\n\nresults in an iterable object with the elements\n`0`, `3`, `6`, and `9` in that order."]},"$nm":"by","$o":{"iterable":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$nm":"Absent"}],"$pk":"ceylon.language","$nm":"Iterable"}],"$mt":"obj","$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator","$o":{"iterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"obj","$m":{"next":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$nm":"iterator"}}}},"$nm":"iterable"}}},"contains":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"actual":[]},"$nm":"contains"},"repeat":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"times"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["cycle"],"doc":["Returns a list formed by repeating the elements of this\niterable object the given number of times, or an empty \nlist if `times<=0`. An eager counterpart to `cycle()`."]},"$nm":"repeat"},"every":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"e"}]],"$mt":"prm","$pt":"f","$an":{"doc":["The predicate that all elements must \nsatisfy."]},"$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Return `true` if all elements satisfy the predicate\nfunction."]},"$m":{"selecting":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"e"}]],"$mt":"mthd","$an":{"doc":["The predicate that all elements must \nsatisfy."]},"$nm":"selecting"}},"$nm":"every"},"fold":{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Result"},"$mt":"prm","$nm":"initial"},{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Result"},"$mt":"prm","$nm":"partial"},{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$an":{"doc":["The accumulating function that accepts an\nintermediate result, and the next element."]},"$nm":"accumulating"}]],"$mt":"mthd","$tp":[{"$nm":"Result"}],"$an":{"shared":[],"default":[],"doc":["The result of applying the accumulating function to \neach element of this container in turn."]},"$m":{"accumulating":{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Result"},"$mt":"prm","$nm":"partial"},{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"mthd","$an":{"doc":["The accumulating function that accepts an\nintermediate result, and the next element."]},"$nm":"accumulating"}},"$nm":"fold"},"defaultNullElements":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"comp":"i","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Object"}]},{"$nm":"Default"}]},{"$mt":"tpm","$nm":"Absent"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$nm":"Default"},"$mt":"prm","$an":{"doc":["A default value that replaces `null` elements."]},"$nm":"defaultValue"}]],"$mt":"mthd","$tp":[{"$nm":"Default"}],"$an":{"shared":[],"default":[],"doc":["An `Iterable` that produces the elements of this \niterable object, replacing every `null` element \nwith the given default value. The resulting iterable\nobject does not produce the value `null`."]},"$nm":"defaultNullElements"},"taking":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"take"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Produce an `Iterable` containing the first `take`\nelements of this iterable object. If the specified \nnumber of elements is larger than the number of \nelements of this iterable object, the `Iterable` \ncontains the same elements as this iterable object."]},"$nm":"taking","$o":{"iterable":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"}],"$mt":"obj","$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator","$o":{"iterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"obj","$m":{"next":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$at":{"i":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"var":"1","$mt":"attr","$an":{"variable":[]},"$nm":"i"}},"$nm":"iterator"}}}},"$at":{"first":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"first"}},"$nm":"iterable"}}},"following":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$nm":"head"}]],"$mt":"mthd","$tp":[{"$nm":"Other"}],"$an":{"shared":[],"default":[],"doc":["An `Iterable` with the given inital element followed \nby the elements of this iterable object."]},"$nm":"following","$o":{"cons":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Nothing"}],"$pk":"ceylon.language","$nm":"Iterable"}],"$mt":"obj","$m":{"iterator":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator","$o":{"iterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"obj","$m":{"next":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$nm":"Other"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$at":{"first":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"var":"1","$mt":"attr","$an":{"shared":[],"actual":[],"variable":[]},"$nm":"first"}},"$nm":"iterator"}}}},"$nm":"cons"}}},"chain":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]},{"comp":"i","$mt":"tpm","$ts":[{"$nm":"Absent"},{"$nm":"OtherAbsent"}]}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"},{"$mt":"tpm","$nm":"OtherAbsent"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"other"}]],"$mt":"mthd","$tp":[{"$nm":"Other"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Null"}],"$nm":"OtherAbsent"}],"$an":{"shared":[],"default":[],"doc":["The elements of this iterable object, in their\noriginal order, followed by the elements of the \ngiven iterable object also in their original order."]},"$nm":"chain","$o":{"chained":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]},{"comp":"i","$mt":"tpm","$ts":[{"$nm":"Absent"},{"$nm":"OtherAbsent"}]}],"$pk":"ceylon.language","$nm":"Iterable"}],"$mt":"obj","$m":{"iterator":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator"}},"$nm":"chained"}}},"shorterThan":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["size"],"doc":["Determines if this iterable object has fewer elements\nthan the given length. This is an efficient operation \nfor iterable objects with many elements."]},"$nm":"shorterThan"},"skippingWhile":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$nm":"skip"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Produce an `Iterable` containing the elements of\nthis iterable object, after skipping the leading \nelements until the given predicate function returns\n`false`."]},"$m":{"skip":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"mthd","$nm":"skip"}},"$nm":"skippingWhile","$o":{"iterable":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"}],"$mt":"obj","$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator","$o":{"iterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"obj","$m":{"next":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$at":{"first":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"var":"1","$mt":"attr","$an":{"shared":[],"actual":[],"variable":[]},"$nm":"first"}},"$nm":"iterator"}}}},"$nm":"iterable"}}},"any":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"e"}]],"$mt":"prm","$pt":"f","$an":{"doc":["The predicate that at least one element \nmust satisfy."]},"$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Return `true` if at least one element satisfies the\npredicate function."]},"$m":{"selecting":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"e"}]],"$mt":"mthd","$an":{"doc":["The predicate that at least one element \nmust satisfy."]},"$nm":"selecting"}},"$nm":"any"},"map":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Result"},{"$mt":"tpm","$nm":"Absent"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$an":{"doc":["The mapping to apply to the elements."]},"$nm":"collecting"}]],"$mt":"mthd","$tp":[{"$nm":"Result"}],"$an":{"shared":[],"default":[],"see":["collect"],"doc":["An `Iterable` containing the results of applying\nthe given mapping to the elements of to this \ncontainer."]},"$nm":"map"},"findLast":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$an":{"doc":["The predicate the element must satisfy."]},"$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["The last element which satisfies the given\npredicate, if any, or `null` otherwise."]},"$m":{"selecting":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"mthd","$an":{"doc":["The predicate the element must satisfy."]},"$nm":"selecting"}},"$nm":"findLast"},"skipping":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"skip"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Produce an `Iterable` containing the elements of\nthis iterable object, after skipping the first \n`skip` elements. If this iterable object does not \ncontain more elements than the specified number of \nelements, the `Iterable` contains no elements."]},"$nm":"skipping","$o":{"iterable":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"}],"$mt":"obj","$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator"}},"$nm":"iterable"}}},"filter":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$an":{"doc":["The predicate the elements must satisfy."]},"$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["select"],"doc":["An `Iterable` containing the elements of this \ncontainer that satisfy the given predicate."]},"$nm":"filter"},"find":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$an":{"doc":["The predicate the element must satisfy."]},"$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["The first element which satisfies the given \npredicate, if any, or `null` otherwise."]},"$m":{"selecting":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"mthd","$an":{"doc":["The predicate the element must satisfy."]},"$nm":"selecting"}},"$nm":"find"},"collect":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Result"}],"$pk":"ceylon.language","$nm":"Sequential"},"$ps":[[{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$an":{"doc":["The transformation applied to the elements."]},"$nm":"collecting"}]],"$mt":"mthd","$tp":[{"$nm":"Result"}],"$an":{"shared":[],"default":[],"see":["map"],"doc":["A sequence containing the results of applying the\ngiven mapping to the elements of this container. An \neager counterpart to `map()`."]},"$nm":"collect"}},"$at":{"cycled":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$nm":"Absent"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"gttr","$an":{"shared":[],"default":[],"see":["cycle"],"doc":["A non-finite iterable object that produces the elements \nof this iterable object, repeatedly."]},"$nm":"cycled","$o":{"iterable":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$nm":"Absent"}],"$pk":"ceylon.language","$nm":"Iterable"}],"$mt":"obj","$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator","$o":{"iterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"obj","$m":{"next":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$at":{"iter":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"var":"1","$mt":"attr","$an":{"shared":[],"actual":[],"variable":[]},"$nm":"iter"}},"$nm":"iterator"}}}},"$at":{"orig":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$nm":"Absent"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"gttr","$nm":"orig"}},"$nm":"iterable"}}},"last":{"$t":{"comp":"u","$ts":[{"$nm":"Absent"},{"$nm":"Element"}]},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["The last element returned by the iterator, if any,\nof `null` if the iterable object is empty. Iterable\nobjects are potentially infinite, so calling this\nmight never return; also, this implementation will\niterate through all the elements, which might be\nvery time-consuming."]},"$nm":"last"},"indexed":{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"comp":"i","$mt":"tpm","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Object"}]}],"$pk":"ceylon.language","$nm":"Entry"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["All entries of form `index->element` where `index` \nis the position at which `element` occurs, for every\nnon-null element of this `Iterable`, ordered by\nincreasing `index`. For a null element at a given\nposition in the original `Iterable`, there is no \nentry with the corresponding index in the resulting \niterable object. The expression \n\n    { \"hello\", null, \"world\" }.indexed\n    \nresults in an iterable object with the entries\n`0->\"hello\"` and `2->\"world\"`."]},"$nm":"indexed","$o":{"indexes":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"comp":"i","$mt":"tpm","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Object"}]}],"$pk":"ceylon.language","$nm":"Entry"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"}],"$mt":"obj","$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"comp":"i","$mt":"tpm","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Object"}]}],"$pk":"ceylon.language","$nm":"Entry"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator","$o":{"iterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"comp":"i","$mt":"tpm","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Object"}]}],"$pk":"ceylon.language","$nm":"Entry"}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"obj","$m":{"next":{"$t":{"comp":"u","$ts":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"comp":"i","$mt":"tpm","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Object"}]}],"$pk":"ceylon.language","$nm":"Entry"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$at":{"iter":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"attr","$nm":"iter"},"i":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"var":"1","$mt":"attr","$an":{"variable":[]},"$nm":"i"}},"$nm":"iterator"}}}},"$at":{"orig":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$nm":"Absent"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"gttr","$nm":"orig"}},"$nm":"indexes"}}},"sequence":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["A sequence containing the elements returned by the\niterator."]},"$nm":"sequence"},"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["A string of form `\"{ x, y, z }\"` where `x`, `y`, \nand `z` are the `string` representations of the \nelements of this collection, as produced by the\niterator of the collection, or the string `\"{}\"` \nif this iterable is empty. If the number of items\nis very large only a certain amount of them might\nbe shown followed by \"...\"."],"actual":[]},"$nm":"string"},"coalesced":{"$t":{"$tp":[{"comp":"i","$mt":"tpm","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Object"}]},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["The non-null elements of this `Iterable`, in their\noriginal order. For null elements of the original \n`Iterable`, there is no entry in the resulting \niterable object."]},"$nm":"coalesced"},"empty":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["Determines if the iterable object is empty, that is\nto say, if the iterator returns no elements."]},"$nm":"empty"},"rest":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["Returns an iterable object containing all but the \nfirst element of this container."]},"$nm":"rest"},"first":{"$t":{"comp":"u","$ts":[{"$nm":"Absent"},{"$nm":"Element"}]},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["The first element returned by the iterator, if any,\nof `null` if the iterable object is empty."]},"$nm":"first"},"size":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["The number of elements returned by the iterator of\nthis iterable object, if the iterator terminates.\nIn the case of an iterable whose elements are not\ncountable, this operation never terminates."]},"$nm":"size"}},"$nm":"Iterable"},"flatten":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Return"},{"$mt":"tpm","$nm":"Args"}],"$pk":"ceylon.language","$nm":"Callable"},"$ps":[[{"$t":{"$nm":"Return"},"$ps":[[{"$t":{"$nm":"Args"},"$mt":"prm","$nm":"tuple"}]],"$mt":"prm","$pt":"f","$nm":"tupleFunction"}]],"$mt":"mthd","$tp":[{"$nm":"Return"},{"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$nm":"Args"}],"$an":{"shared":[],"native":[],"see":["unflatten"],"doc":["Given a function with a single parameter of tuple type \n`[P1, P2, ..., Pn]`, return a function with multiple \nparameters of type `P1`, `P2`, ..., `Pn`.\n\nThat is, if `fun` has type `W([X,Y,Z])` then \n`flatten(fun)` has type `W(X,Y,Z)`."]},"$nm":"flatten"},"mapPairs":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Result"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"FirstArgument"},"$mt":"prm","$nm":"firstArg"},{"$t":{"$nm":"SecondArgument"},"$mt":"prm","$nm":"secondArg"}]],"$mt":"prm","$pt":"f","$nm":"collecting"},{"$t":{"$tp":[{"$mt":"tpm","$nm":"FirstArgument"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"firstArguments"},{"$t":{"$tp":[{"$mt":"tpm","$nm":"SecondArgument"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"secondArguments"}]],"$mt":"mthd","$tp":[{"$nm":"Result"},{"$nm":"FirstArgument"},{"$nm":"SecondArgument"}],"$an":{"shared":[],"doc":["Given two streams, form a new stream by applying a \nfunction to the arguments in the given streams. The \nlength of the resulting stream is the length of \nthe shorter of the two given streams.\n\nThus:\n\n    mapPairs(xs,ys,fun)[i]==fun(xs[i],ys[i])\n\nfor every `0<=i<min({xs.size,ys.size})`."]},"$m":{"collecting":{"$t":{"$nm":"Result"},"$ps":[[{"$t":{"$nm":"FirstArgument"},"$mt":"prm","$nm":"firstArg"},{"$t":{"$nm":"SecondArgument"},"$mt":"prm","$nm":"secondArg"}]],"$mt":"mthd","$nm":"collecting"}},"$nm":"mapPairs","$o":{"iterable":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Result"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"}],"$mt":"obj","$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Result"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator","$o":{"iterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Result"}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"obj","$m":{"next":{"$t":{"comp":"u","$ts":[{"$nm":"Result"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$nm":"iterator"}}}},"$nm":"iterable"}}},"OptionalAnnotation":{"of":[{"$nm":"Value"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Value"},{"comp":"u","$mt":"tpm","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Value"}]},{"$mt":"tpm","$nm":"ProgramElement"}],"$pk":"ceylon.language","$nm":"ConstrainedAnnotation"}],"$mt":"ifc","$tp":[{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Value"},{"$mt":"tpm","$nm":"ProgramElement"}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"variance":"out","$nm":"Value"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Annotated"}],"$def":{"$pk":"ceylon.language","$nm":"Annotated"},"variance":"in","$nm":"ProgramElement"}],"$an":{"shared":[],"see":["Annotation"],"doc":["An annotation that may occur at most once at a single program element and \nonly on certain program elements.\n\nAn optional annotation is declared simply by having the annotation class\nsatisfy OptionalAnnotation instead of [[Annotation]]. For example \nthe following would only be allowed on `class` declarations:\n\n    final annotation class ExampleClass() \n            satisfies OptionalAnnotation<Example, ClassDeclaration> {}\n\nAt runtime a [[ceylon.language.meta.declaration::Declaration]] instance \ncan be queried for its `OptionalAnnotation`s of a certain type using \n[[ceylon.language.meta::annotations]] or [[ceylon.language.meta::optionalAnnotation]].\n"]},"$nm":"OptionalAnnotation","$st":"Value"},"LazyList":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$ps":[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"elems"}],"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"}],"$mt":"cls","$tp":[{"variance":"out","$nm":"Element"}],"$an":{"shared":[],"doc":["An implementation of `List` that wraps an `Iterable` of\nelements. All operations on this `List` are performed on \nthe `Iterable`."],"by":["Enrique Zamudio"]},"$m":{"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"iterator"},"get":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"get"},"equals":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"that"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"actual":[]},"$nm":"equals"},"spanTo":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"to"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"spanTo"},"segment":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"segment"},"findLast":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"actual":[]},"$nm":"findLast"},"spanFrom":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"spanFrom"},"span":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"from"},{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"to"}]],"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"span"}},"$at":{"lastIndex":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Integer"}]},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"lastIndex"},"clone":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"clone"},"last":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$mt":"gttr","$an":{"shared":[],"default":[],"actual":[]},"$nm":"last"},"hash":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"default":[],"actual":[]},"$nm":"hash"},"reversed":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"gttr","$an":{"shared":[],"doc":["Returns a `List` with the elements of this `List` \nin reverse order. This operation will create copy \nthe elements to a new `List`, so changes to the \noriginal `Iterable` will no longer be reflected in \nthe new `List`."],"actual":[]},"$nm":"reversed"},"rest":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"rest"},"elems":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"attr","$nm":"elems"},"first":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$mt":"gttr","$an":{"shared":[],"default":[],"actual":[]},"$nm":"first"}},"$nm":"LazyList"},"className":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"obj"}]],"$mt":"mthd","$an":{"shared":[],"native":[],"doc":["Return the name of the concrete class of the given \nobject, in a format native to the virtual machine."]},"$nm":"className"},"List":{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Collection"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Correspondence"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"}],"$pk":"ceylon.language","$nm":"Ranged"},{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"}],"$pk":"ceylon.language","$nm":"Cloneable"}],"$mt":"ifc","$tp":[{"variance":"out","$nm":"Element"}],"$an":{"shared":[],"see":["Sequence","Empty","Array"],"doc":["Represents a collection in which every element has a \nunique non-negative integer index.\n\nA `List` is a `Collection` of its elements, and a \n`Correspondence` from indices to elements.\n\nDirect access to a list element by index produces a\nvalue of optional type. The following idiom may be\nused instead of upfront bounds-checking, as long as \nthe list element type is a non-`null` type:\n\n    value char = \"hello world\"[index];\n    if (exists char) { \/*do something*\/ }\n    else { \/*out of bounds*\/ }\n\nTo iterate the indexes of a `List`, use the following\nidiom:\n\n    for (i->char in \"hello world\".indexed) { ... }"]},"$m":{"longerThan":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"actual":[]},"$nm":"longerThan"},"trimLeading":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$nm":"trimming"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Trim the elements satisfying the given predicate\nfunction from the start of this list, returning \na list no longer than this list."]},"$m":{"trimming":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"mthd","$nm":"trimming"}},"$nm":"trimLeading"},"contains":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["occurs"],"doc":["Determines if this list contains the given \nvalue. Equivalent to `occurs()`."],"actual":[]},"$nm":"contains"},"includes":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"prm","$nm":"sublist"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Determine if the given list occurs at some index in \nthis list."]},"$nm":"includes"},"firstInclusion":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Integer"}]},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"prm","$nm":"sublist"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["The first index in this list at which the given list \noccurs."]},"$nm":"firstInclusion"},"occurs":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Determines if the given value occurs as an \nelement in this list."]},"$nm":"occurs"},"withTrailing":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]}],"$pk":"ceylon.language","$nm":"Sequence"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$an":{"doc":["The last element of the resulting sequence."]},"$nm":"element"}]],"$mt":"mthd","$tp":[{"$nm":"Other"}],"$an":{"shared":[],"default":[],"doc":["Returns a new `List` that contains the specified\nelement appended to the end of the elements of this \n`List`."]},"$nm":"withTrailing"},"firstOccurrence":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Integer"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["The first index in this list at which the given element \noccurs."]},"$nm":"firstOccurrence"},"terminal":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["List.initial"],"doc":["Select the last elements of the list, returning a list \nno longer than the given length. If this list is \nshorter than the given length, return this list. \nOtherwise return a list of the given length."]},"$nm":"terminal"},"initial":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["List.terminal"],"doc":["Select the first elements of this list, returning a \nlist no longer than the given length. If this list is \nshorter than the given length, return this list. \nOtherwise return a list of the given length."]},"$nm":"initial"},"inclusions":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"prm","$nm":"sublist"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["The indexes in this list at which the given list \noccurs."]},"$nm":"inclusions"},"occurrences":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["The indexes in this list at which the given element \noccurs."]},"$nm":"occurrences"},"trim":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$nm":"trimming"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Trim the elements satisfying the given predicate\nfunction from the start and end of this list, \nreturning a list no longer than this list."]},"$m":{"trimming":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"mthd","$nm":"trimming"}},"$nm":"trim"},"startsWith":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"prm","$nm":"sublist"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Determine if the given list occurs at the start of this \nlist."]},"$nm":"startsWith"},"iterator":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"},"$mt":"mthd","$an":{"shared":[],"default":[],"actual":[]},"$nm":"iterator","$o":{"listIterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"obj","$m":{"next":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$at":{"index":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"var":"1","$mt":"attr","$an":{"variable":[]},"$nm":"index"}},"$nm":"listIterator"}}},"get":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"doc":["Returns the element of this sequence with the given\n    index, or `null` if the given index is past the end\n    of the sequence, that is, if\n    `index>sequence.lastIndex`. The first element of\n    the sequence has index `0`."],"actual":[]},"$nm":"get"},"equals":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"that"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Two `List`s are considered equal iff they have the \nsame `size` and _entry sets_. The entry set of a \nlist `l` is the set of elements of `l.indexed`. \nThis definition is equivalent to the more intuitive \nnotion that two lists are equal iff they have the \nsame `size` and for every index either:\n\n- the lists both have the element `null`, or\n- the lists both have a non-null element, and the\n  two elements are equal."],"actual":[]},"$nm":"equals"},"indexes":{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"element"}]],"$mt":"prm","$pt":"f","$an":{"doc":["The predicate the indexed elements must satisfy"]},"$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["The indexes in this list for which the element \nsatisfies the given predicate."]},"$nm":"indexes"},"occursAt":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"},{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Determines if the given value occurs at the \ngiven index in this list."]},"$nm":"occursAt"},"defines":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"index"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Determines if the given index refers to an element\n    of this sequence, that is, if\n    `index<=sequence.lastIndex`."],"actual":[]},"$nm":"defines"},"shorterThan":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"length"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"actual":[]},"$nm":"shorterThan"},"lastInclusion":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Integer"}]},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"prm","$nm":"sublist"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["The last index in this list at which the given list \noccurs."]},"$nm":"lastInclusion"},"trimTrailing":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$nm":"trimming"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Trim the elements satisfying the given predicate\nfunction from the end of this list, returning a \nlist no longer than this list."]},"$m":{"trimming":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"mthd","$nm":"trimming"}},"$nm":"trimTrailing"},"includesAt":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$an":{"doc":["The index at which this list might occur"]},"$nm":"index"},{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"prm","$nm":"sublist"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Determine if the given list occurs at the given index \nof this list."]},"$nm":"includesAt"},"lastOccurrence":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Integer"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["The last index in this list at which the given element \noccurs."]},"$nm":"lastOccurrence"},"endsWith":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Anything"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"prm","$nm":"sublist"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"doc":["Determine if the given list occurs at the end of this\nlist."]},"$nm":"endsWith"},"findLast":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"prm","$pt":"f","$nm":"selecting"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"actual":[]},"$m":{"selecting":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$nm":"Element"},"$mt":"prm","$nm":"elem"}]],"$mt":"mthd","$nm":"selecting"}},"$nm":"findLast"},"withLeading":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]}],"$pk":"ceylon.language","$nm":"Sequence"},"$ps":[[{"$t":{"$nm":"Other"},"$mt":"prm","$an":{"doc":["The first element of the resulting sequence."]},"$nm":"element"}]],"$mt":"mthd","$tp":[{"$nm":"Other"}],"$an":{"shared":[],"default":[],"see":["following"],"doc":["Returns a new `List` that starts with the specified\nelement, followed by the elements of this `List`."]},"$nm":"withLeading"}},"$at":{"lastIndex":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Integer"}]},"$mt":"attr","$an":{"shared":[],"formal":[],"see":["List.size"],"doc":["The index of the last element of the list, or\nnull if the list is empty."]},"$nm":"lastIndex"},"last":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["Returns the last element of this `List`, if any."],"actual":[]},"$nm":"last"},"hash":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"default":[],"actual":[]},"$nm":"hash"},"reversed":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["Reverse this list, returning a new list."]},"$nm":"reversed"},"rest":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"List"},"$mt":"attr","$an":{"shared":[],"formal":[],"doc":["The rest of the list, without the first element."],"actual":[]},"$nm":"rest"},"first":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$nm":"Element"}]},"$mt":"gttr","$an":{"shared":[],"default":[],"doc":["Returns the first element of this `List`, if any."],"actual":[]},"$nm":"first"},"size":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"gttr","$an":{"shared":[],"default":[],"see":["List.lastIndex"],"doc":["The number of elements in this sequence, always\n`sequence.lastIndex+1`."],"actual":[]},"$nm":"size"}},"$nm":"List"},"abstract":{"$t":{"$pk":"ceylon.language","$nm":"AbstractAnnotation"},"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to mark a class as abstract. An `abstract` class \nmay not be directly instantiated. An `abstract` class may \nhave enumerated cases."]},"$annot":"1","$nm":"abstract"},"zip":{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Head"}]},{"$mt":"tpm","$nm":"Head"},{"$mt":"tpm","$nm":"Tail"}],"$pk":"ceylon.language","$nm":"Tuple"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Head"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"heads"},{"$t":{"$tp":[{"$mt":"tpm","$nm":"Tail"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"tails"}]],"$mt":"mthd","$tp":[{"$nm":"Element"},{"$nm":"Head"},{"satisfies":[{"$tp":[{"$mt":"tpm","$nm":"Element"}],"$pk":"ceylon.language","$nm":"Sequential"}],"$nm":"Tail"}],"$an":{"shared":[],"doc":["Given a stream of values, and a stream of tuples, produce\na new stream of tuples formed by prepending the values in\nthe first stream to the tuples in the second stream. The \nlength of the resulting stream is the length of the shorter \nof the two given streams.\n\nThus:\n\n    zip(heads, tails)[i]==[heads[i],*tails[i]]\n\nfor every `0<=i<min({heads.size,tails.size})`."]},"$nm":"zip"},"zipEntries":{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$nm":"Item"}],"$pk":"ceylon.language","$nm":"Entry"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Key"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"keys"},{"$t":{"$tp":[{"$mt":"tpm","$nm":"Item"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"items"}]],"$mt":"mthd","$tp":[{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Key"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Object"}],"$nm":"Item"}],"$an":{"shared":[],"doc":["Given two streams, form a new stream consisting of\nall entries where, for any given index in the resulting\nstream, the key of the entry is the element occurring \nat the same index in the first stream, and the item is \nthe element occurring at the same index in the second \nstream. The length of the resulting stream is the \nlength of the shorter of the two given streams.\n\nThus:\n\n    zipEntries(keys,items)[i]==keys[i]->items[i]\n\nfor every `0<=i<min({keys.size,items.size})`."]},"$nm":"zipEntries"},"finished":{"super":{"$pk":"ceylon.language","$nm":"Finished"},"$mt":"obj","$an":{"shared":[],"see":["Iterator"],"doc":["A value that indicates that an `Iterator`\nis exhausted and has no more values to \nreturn."]},"$at":{"string":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"gttr","$an":{"shared":[],"actual":[]},"$nm":"string"}},"$nm":"finished"},"equal":{"super":{"$pk":"ceylon.language","$nm":"Comparison"},"$mt":"obj","$an":{"shared":[],"doc":["The value is exactly equal to the given value."]},"$nm":"equal"},"Boolean":{"abstract":"1","super":{"$pk":"ceylon.language","$nm":"Basic"},"of":[{"$pk":"ceylon.language","$nm":"true"},{"$pk":"ceylon.language","$nm":"false"}],"$mt":"cls","$an":{"abstract":[],"shared":[],"doc":["A type capable of representing the values true and\nfalse of Boolean logic."],"by":["Gavin"]},"$nm":"Boolean"},"print":{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Anything"},"$mt":"prm","$nm":"val"}]],"$mt":"mthd","$an":{"shared":[],"doc":["Print a line to the standard output of the virtual machine \nprocess, printing the given value's `string`, or `<null>` \nif the value is `null`.\n\nThis method is a shortcut for:\n\n    process.writeLine(line?.string else \"<null>\")\n\nand is intended mainly for debugging purposes."],"by":["Gavin"]},"$nm":"print"},"unzipPairs":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$tp":[{"$mt":"tpm","$nm":"First"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},{"$tp":[{"$mt":"tpm","$nm":"Second"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"}]},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"First"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Second"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Second"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Empty"}],"$pk":"ceylon.language","$nm":"Tuple"}],"$pk":"ceylon.language","$nm":"Tuple"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"First"},{"$nm":"Second"}]},{"$mt":"tpm","$nm":"First"},{"$mt":"tpm","$tp":[{"$mt":"tpm","$nm":"Second"},{"$mt":"tpm","$nm":"Second"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Empty"}],"$pk":"ceylon.language","$nm":"Tuple"}],"$pk":"ceylon.language","$nm":"Tuple"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"pairs"}]],"$mt":"mthd","$tp":[{"$nm":"First"},{"$nm":"Second"}],"$an":{"shared":[],"doc":["Given a stream of pairs, return two streams. The\nfirst stream produces the first elements of the\ngiven pairs, and the second stream produces the\nsecond elements of the given pairs.\n\nThus:\n\n    unzipPairs(pairs)[i]==[pairs[i][0],pairs[i][1]]"]},"$nm":"unzipPairs"},"ChainedIterator":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$ps":[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"first"},{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"second"}],"satisfies":[{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]}],"$pk":"ceylon.language","$nm":"Iterator"}],"$mt":"cls","$tp":[{"variance":"out","$nm":"Element"},{"variance":"out","$nm":"Other"}],"$an":{"see":["Iterable.chain"],"doc":["An `Iterator` that returns the elements of two\n`Iterable`s, as if they were chained together."],"by":["Enrique Zamudio"]},"$m":{"next":{"$t":{"comp":"u","$ts":[{"$nm":"Element"},{"$nm":"Other"},{"$pk":"ceylon.language","$nm":"Finished"}]},"$mt":"mthd","$an":{"shared":[],"actual":[]},"$nm":"next"}},"$at":{"more":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"var":"1","$mt":"attr","$an":{"shared":[],"actual":[],"variable":[]},"$nm":"more"},"second":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Other"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"attr","$nm":"second"},"iter":{"$t":{"$tp":[{"comp":"u","$mt":"tpm","$ts":[{"$nm":"Element"},{"$nm":"Other"}]}],"$pk":"ceylon.language","$nm":"Iterator"},"var":"1","$mt":"attr","$an":{"shared":[],"actual":[],"variable":[]},"$nm":"iter"},"first":{"$t":{"$tp":[{"$mt":"tpm","$nm":"Element"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"attr","$nm":"first"}},"$nm":"ChainedIterator"},"Basic":{"abstract":"1","super":{"$pk":"ceylon.language","$nm":"Object"},"satisfies":[{"$pk":"ceylon.language","$nm":"Identifiable"}],"$mt":"cls","$an":{"abstract":[],"shared":[],"doc":["The default superclass when no superclass is explicitly\nspecified using `extends`. For the sake of convenience, \nthis class inherits a default definition of value\nequality from `Identifiable`."],"by":["Gavin"]},"$nm":"Basic"},"DocAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"$ps":[{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"prm","$an":{"shared":[],"doc":["Documentation, in Markdown syntax, about the annotated element"]},"$nm":"description"}],"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"DocAnnotation"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Annotated"}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for the [[doc]] annotation."]},"$annot":"1","$at":{"description":{"$t":{"$pk":"ceylon.language","$nm":"String"},"$mt":"attr","$an":{"shared":[],"doc":["Documentation, in Markdown syntax, about the annotated element"]},"$nm":"description"}},"$nm":"DocAnnotation"},"Category":{"$mt":"ifc","$an":{"shared":[],"doc":["Abstract supertype of objects that contain other \nvalues, called *elements*, where it is possible to \nefficiently determine if a given value is an element. \n`Category` does not satisfy `Container`, because it is \nconceptually possible to have a `Category` whose \nemptiness cannot be computed.\n\nThe `in` operator may be used to determine if a value\nbelongs to a `Category`:\n\n    if (\"hello\" in \"hello world\") { ... }\n    if (69 in 0..100) { ... }\n    if (key->value in { for (n in 0..100) n.string->n**2 }) { ... }\n\nOrdinarily, `x==y` implies that `x in cat == y in cat`.\nBut this contract is not required since it is possible\nto form a meaningful `Category` using a different\nequivalence relation. For example, an `IdentitySet` is\na meaningful `Category`."],"by":["Gavin"]},"$m":{"containsAny":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"elements"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["contains"],"doc":["Determines if any one of the given values belongs \nto this `Category`"]},"$nm":"containsAny"},"contains":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Object"},"$mt":"prm","$nm":"element"}]],"$mt":"mthd","$an":{"shared":[],"formal":[],"see":["containsEvery","containsAny"],"doc":["Determines if the given value belongs to this\n`Category`, that is, if it is an element of this\n`Category`.\n\nFor most `Category`s, if `x==y`, then \n`category.contains(x)` evaluates to the same\nvalue as `category.contains(y)`. However, it is\npossible to form a `Category` consistent with some \nother equivalence relation, for example `===`. \nTherefore implementations of `contains()` which do \nnot satisfy this relationship are tolerated."]},"$nm":"contains"},"containsEvery":{"$t":{"$pk":"ceylon.language","$nm":"Boolean"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Object"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Null"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"elements"}]],"$mt":"mthd","$an":{"shared":[],"default":[],"see":["contains"],"doc":["Determines if every one of the given values belongs\nto this `Category`."]},"$nm":"containsEvery"}},"$nm":"Category"},"see":{"$t":{"$pk":"ceylon.language","$nm":"SeeAnnotation"},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$pk":"ceylon.language.meta.declaration","$nm":"Declaration"}],"$pk":"ceylon.language","$nm":"Sequential"},"$mt":"prm","seq":"1","$an":{"doc":["The program elements being referred to."]},"$nm":"programElements"}]],"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to specify API references to other related \nprogram elements."]},"$annot":"1","$nm":"see"},"computeMagnitude":{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Integer"}]},"$ps":[[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"radix"},{"$t":{"comp":"u","$ts":[{"$pk":"ceylon.language","$nm":"Null"},{"$pk":"ceylon.language","$nm":"Character"}]},"$mt":"prm","$nm":"char"}]],"$mt":"mthd","$nm":"computeMagnitude"},"NegativeNumberException":{"super":{"$pk":"ceylon.language","$nm":"Exception"},"$mt":"cls","$an":{"shared":[],"doc":["Thrown when a negative number is not allowed."]},"$nm":"NegativeNumberException"},"actual":{"$t":{"$pk":"ceylon.language","$nm":"ActualAnnotation"},"$mt":"mthd","$an":{"annotation":[],"shared":[],"doc":["Annotation to mark a member of a type as refining a member \nof a supertype."]},"$annot":"1","$nm":"actual"},"SharedAnnotation":{"super":{"$pk":"ceylon.language","$nm":"Basic"},"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"SharedAnnotation"},{"comp":"u","$mt":"tpm","$ts":[{"$pk":"ceylon.language.meta.declaration","$nm":"ValueDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"FunctionDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"ClassOrInterfaceDeclaration"},{"$pk":"ceylon.language.meta.declaration","$nm":"Package"},{"$pk":"ceylon.language.meta.declaration","$nm":"Import"}]}],"$pk":"ceylon.language","$nm":"OptionalAnnotation"}],"$mt":"cls","$an":{"annotation":[],"shared":[],"final":[],"doc":["The annotation class for [[shared]]."]},"$annot":"1","$nm":"SharedAnnotation"},"Integer":{"super":{"$pk":"ceylon.language","$nm":"Object"},"$ps":[{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"prm","$nm":"integer"}],"satisfies":[{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"}],"$pk":"ceylon.language","$nm":"Scalar"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"}],"$pk":"ceylon.language","$nm":"Integral"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"}],"$pk":"ceylon.language","$nm":"Binary"},{"$tp":[{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"},{"$mt":"tpm","$pk":"ceylon.language","$nm":"Integer"}],"$pk":"ceylon.language","$nm":"Exponentiable"}],"$mt":"cls","$an":{"shared":[],"final":[],"native":[],"doc":["A 64-bit integer, or the closest approximation to a \n64-bit integer provided by the underlying platform.\n\n- For the JVM runtime, integer values between\n  -2<sup>63<\/sup> and 2<sup>63<\/sup>-1 may be \n  represented without overflow.\n- For the JavaScript runtime, integer values with a\n  magnitude no greater than 2<sup>53<\/sup> may be\n  represented without loss of precision.\n\nOverflow or loss of precision occurs silently (with\nno exception raised)."]},"$at":{"integer":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$nm":"integer"},"character":{"$t":{"$pk":"ceylon.language","$nm":"Character"},"$mt":"attr","$an":{"shared":[],"native":[],"doc":["The UTF-32 character with this UCS code point."]},"$nm":"character"}},"$nm":"Integer"},"first":{"$t":{"comp":"u","$ts":[{"$nm":"Absent"},{"$nm":"Value"}]},"$ps":[[{"$t":{"$tp":[{"$mt":"tpm","$nm":"Value"},{"$mt":"tpm","$nm":"Absent"}],"$pk":"ceylon.language","$nm":"Iterable"},"$mt":"prm","$nm":"values"}]],"$mt":"mthd","$tp":[{"$nm":"Value"},{"satisfies":[{"$pk":"ceylon.language","$nm":"Null"}],"$nm":"Absent"}],"$an":{"shared":[],"doc":["The first of the given values (usually a comprehension),\nif any."]},"$nm":"first"},"zeroInt":{"$t":{"$pk":"ceylon.language","$nm":"Integer"},"$mt":"attr","$nm":"zeroInt"}},"$mod-bin":"6.0"};
exports.$$METAMODEL$$=function(){return $$METAMODEL$$;};
function getT$name() {return this.constructor.T$name;}
function getT$all() {return this.constructor.T$all;}
function initType(type, typeName) {
var cons = function() {}
type.$$ = cons;
cons.T$name = typeName;
cons.T$all = {}
cons.T$all[typeName] = type;
for (var i=2; i<arguments.length; ++i) {
var superTypes = arguments[i].$$.T$all;
for (var $ in superTypes) {cons.T$all[$] = superTypes[$]}
}
cons.prototype.getT$name = getT$name;
cons.prototype.getT$all = getT$all;
}
function initTypeProto(type, typeName) {
initType.apply(this, arguments);
var args = [].slice.call(arguments, 2);
args.unshift(type);
inheritProto.apply(this, args);
}
function initTypeProtoI(type, typeName) {
initType.apply(this, arguments);
var args = [].slice.call(arguments, 2);
if (type.$$.T$all['ceylon.language::Object']===undefined) {
type.$$.T$all['ceylon.language::Object']=Object$;
//args.unshift(Object$);
}
args.unshift(type);
inheritProto.apply(this, args);
}
function initExistingType(type, cons, typeName) {
type.$$ = cons;
cons.T$name = typeName;
cons.T$all = {}
cons.T$all[typeName] = type;
for (var i=3; i<arguments.length; ++i) {
var superTypes = arguments[i].$$.T$all;
for (var $ in superTypes) {cons.T$all[$] = superTypes[$]}
}
var proto = cons.prototype;
if (proto !== undefined) {
try {
proto.getT$name = getT$name;
proto.getT$all = getT$all;
} catch (exc) {
// browser probably prevented access to the prototype
}
}
}
function initExistingTypeProto(type, cons, typeName) {
var args = [].slice.call(arguments, 0);
args.push($init$Basic());
initExistingType.apply(this, args);
var proto = cons.prototype;
if ((proto !== undefined) && (proto.getHash === undefined)) {
var origToString = proto.toString;
try {
inheritProto(type, Basic);
proto.toString = origToString;
} catch (exc) {
// browser probably prevented access to the prototype
}
}
}
function inheritProto(type) {
var proto = type.$$.prototype;
for (var i=1; i<arguments.length; ++i) {
var superProto = arguments[i].$$.prototype;
var names = Object.getOwnPropertyNames(superProto);
for (var j=0; j<names.length; ++j) {
var name = names[j];
var desc = Object.getOwnPropertyDescriptor(superProto, name);
// only copy own, enumerable properties
if (desc && desc.enumerable) {
if (desc.get) {
// defined through getter/setter, so copy the definition
Object.defineProperty(proto, name, desc);
} else if (proto[name]===undefined || desc.value.$fml===undefined) {
proto[name] = desc.value;
}
}
}
}
}
// Define a property on the given object (which may be a prototype).
// "get" and "set" are getter/setter functions, and the latter is optional.
function defineAttr(obj, name, get, set, metamodel,setterAnns) {
Object.defineProperty(obj, name, {get: get, set: set, configurable: true, enumerable: true});
if (name[0]==='$')name=name.substring(1);//names matching reserved words are prefixed with $
obj['$prop$get'+name[0].toUpperCase()+name.substring(1)] = {get:get, set:set, $$metamodel$$:metamodel};
if (setterAnns)set.setter$anns=setterAnns;
}
// Create a copy of the given property. The name of the copied property is name+suffix.
// This is used in closure mode to provide access to inherited attribute implementations.
function copySuperAttr(obj, name, suffix) {
var desc;
var o = obj;
// It may be an inherited property, so check the prototype chain.
do {
if ((desc = Object.getOwnPropertyDescriptor(o, name))) {break;}
o = o.__proto__;
} while (o);
if (desc) {
Object.defineProperty(obj, name+suffix, desc);
}
}
// read/writeAttrib return the getter/setter for the given property as defined in the
// given type. This is used in prototype mode to access inherited attribute implementations.
function attrGetter(type, name) {
return Object.getOwnPropertyDescriptor(type.$$.prototype, name).get;
}
function attrSetter(type, name, value) {
return Object.getOwnPropertyDescriptor(type.$$.prototype, name).set;
}
exports.initType=initType;
exports.initTypeProto=initTypeProto;
exports.initTypeProtoI=initTypeProtoI;
exports.initExistingType=initExistingType;
exports.initExistingTypeProto=initExistingTypeProto;
exports.inheritProto=inheritProto;
exports.defineAttr=defineAttr;
exports.copySuperAttr=copySuperAttr;
exports.attrGetter=attrGetter;
exports.attrSetter=attrSetter;
function Anything(wat) {
return wat;
}
initType(Anything, 'ceylon.language::Anything');
Anything.$$metamodel$$=function(){return{$an:function(){return[shared(),abstract()]},mod:$$METAMODEL$$,d:['ceylon.language','Anything']};}
function Null(wat) {
return null;
}
initType(Null, 'ceylon.language::Null', Anything);
Null.$$metamodel$$=function(){return{'super':{t:Anything},$an:function(){return[shared(),abstract()]},mod:$$METAMODEL$$,d:['ceylon.language','Null']};}
function Nothing(wat) {
throw "Nothing";
}
initType(Nothing, 'ceylon.language::Nothing');
//This is quite a special case, since Nothing is not in the model, we need to insert it there
$$METAMODEL$$['ceylon.language']["Nothing"]={"$mt":"cls","$an":{"shared":[]},"$nm":"Nothing"};
Nothing.$$metamodel$$=function(){return{$ps:[],$an:function(){return[shared()]},mod:$$METAMODEL$$,d:['ceylon.language','Nothing']};}
function Object$(wat) {
return wat;
}
initTypeProto(Object$, 'ceylon.language::Object', Anything);
Object$.$$metamodel$$=function(){return{'super':{t:Anything},$an:function(){return[shared(),abstract()]},mod:$$METAMODEL$$,d:['ceylon.language','Object']};}
var Object$proto = Object$.$$.prototype;
defineAttr(Object$proto, 'string', function(){
return String$(className(this) + "@" + this.hash);
},undefined,{$an:function(){return[shared(),$default()]},$t:{t:String$},mod:$$METAMODEL$$,$cont:Object$,d:['ceylon.language','Object','$at','string']});
Object$proto.$prop$getHash={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$cont:Object$,d:['ceylon.language','Object','$at','hash'],$t:{t:Integer}};}};
Object$proto.toString=function() { return this.string.valueOf(); }
Object$proto.equals={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$cont:Object$,d:['ceylon.language','Object','$m','equals'],$t:{t:Boolean$},
$ps:[{$nm:'other',$mt:'prm',$t:{t:Object$}}]};}};
function $init$Object$() { return Object$; }
function $init$Object() { return Object$; }
var BasicID=1;
function $identityHash(x) {
var hash = x.BasicID;
return (hash !== undefined)
? hash : (x.BasicID = BasicID++);
}
$identityHash.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$ps:[{$nm:'x',$t:{t:Identifiable},$mt:'prm'}],d:['ceylon.language','identityHash']};}
function Identifiable(obj) {}
initType(Identifiable, "ceylon.language::Identifiable", Object$);
Identifiable.$$metamodel$$=function(){return{$an:function(){return[shared()]},mod:$$METAMODEL$$,d:['ceylon.language','Identifiable']};}
function $init$Identifiable() { return Identifiable; }
var Identifiable$proto = Identifiable.$$.prototype;
Identifiable$proto.equals = function(that) {
return isOfType(that, {t:Identifiable}) && (that===this);
}
defineAttr(Identifiable$proto, 'hash', function(){ return $identityHash(this); },
undefined,function(){return{$an:function(){return[shared(),$default()]},$cont:Identifiable,mod:$$METAMODEL$$,d:['ceylon.language','Identifiable','$at','hash']};});
//INTERFACES
//Compiled from Ceylon sources
function Callable(wat) {
    return wat;
}
Callable.$$metamodel$$={mod:$$METAMODEL$$,$an:function(){return[shared()];},$tp:{Arguments:{'var':'out'},Return:{'var':'out'}},d:['ceylon.language','Callable']};
exports.Callable=Callable;
function $init$Callable() {
    if (Callable.$$===undefined) {
        initType(Callable, 'ceylon.language::Callable');
    }
    return Callable;
}
exports.$init$Callable=$init$Callable;
$init$Callable();

function $JsCallable(callable,parms,targs) {
    if (callable.getT$all === undefined) {
        callable.getT$all=Callable.getT$all;
    }
    var set_meta = callable.$$metamodel$$ === undefined;
    if (set_meta) {
        callable.$$metamodel$$={$ps:[],mod:$$METAMODEL$$,d:['ceylon.language','Callable']};
        if (parms !== undefined) {
            callable.$$metamodel$$['$ps']=parms;
        }
    }
    if (targs !== undefined && callable.$$targs$$ === undefined) {
        callable.$$targs$$=targs;
        if (set_meta) {
            callable.$$metamodel$$['$t']=targs['Return'];
        }
    }
    return callable;
}
initExistingTypeProto($JsCallable, Function, 'ceylon.language::JsCallable', Callable);

function noop() { return null; }

//This is used for plain method references
function JsCallable(o,f) {
    Callable(o);
    if (o === null) return noop;
    var f2 = function() { return f.apply(o, arguments); };
    f2.$$metamodel$$=f.$$metamodel$$===undefined?Callable.$$metamodel$$:f.$$metamodel$$;
    return f2;
}
JsCallable.$$metamodel$$={$tp:{Return:{'var':'out'}, Arguments:{'var':'in'}},$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','Callable']};

//This is used for spread method references
function JsCallableList(value) {
    return function() {
        var rval = Array(value.length);
        for (var i = 0; i < value.length; i++) {
            var c = value[i];
            rval[i] = c.f.apply(c.o, arguments);
        }
        return ArraySequence(rval);
    };
}
JsCallableList.$$metamodel$$={$tp:{Return:{'var':'out'}, Arguments:{'var':'in'}},$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','Callable']};

exports.JsCallableList=JsCallableList;
exports.JsCallable=JsCallable;
exports.$JsCallable=$JsCallable;
function Comprehension(makeNextFunc, $$targs$$, compr) {
    $init$Comprehension();
    if (compr===undefined) {compr = new Comprehension.$$;}
    Basic(compr);
    compr.makeNextFunc = makeNextFunc;
    compr.$$targs$$=$$targs$$;
    return compr;
}
Comprehension.$$metamodel$$={$nm:'Comprehension',$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','Iterable']};
function $init$Comprehension() {
    if (Comprehension.$$===undefined) {
        initTypeProto(Comprehension, 'ceylon.language::Comprehension', $init$Basic(), $init$Iterable());
    }
    return Comprehension;
}
$init$Comprehension();
var Comprehension$proto = Comprehension.$$.prototype;
Comprehension$proto.iterator = function() {
    return ComprehensionIterator(this.makeNextFunc(), this.$$targs$$);
}
defineAttr(Comprehension$proto, 'sequence', function() {
    var sb = SequenceBuilder(this.$$targs$$);
    sb.appendAll(this);
    return sb.sequence;
},undefined,{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','Iterable','$at','sequence']});
exports.Comprehension=Comprehension;

function ComprehensionIterator(nextFunc, $$targs$$, it) {
    $init$ComprehensionIterator();
    if (it===undefined) {it = new ComprehensionIterator.$$;}
    it.$$targs$$=$$targs$$;
    Basic(it);
    it.next = nextFunc;
    return it;
}
ComprehensionIterator.$$metamodel$$={$nm:'ComprehensionIterator',$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','Iterator']};
function $init$ComprehensionIterator() {
    if (ComprehensionIterator.$$===undefined) {
        initTypeProto(ComprehensionIterator, 'ceylon.language::ComprehensionIterator',
                $init$Basic(), $init$Iterator());
    }
    return ComprehensionIterator;
}
$init$ComprehensionIterator();
function Basic($$basic){
    $init$Basic();
    if ($$basic===undefined)throwexc(InvocationException$meta$model(String$("Cannot instantiate abstract class")),'?','?')
    Object$($$basic);
    Identifiable($$basic);
    return $$basic;
}
Basic.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Object$},$ps:[],satisfies:[{t:Identifiable}],$an:function(){return[doc(String$("The default superclass when no superclass is explicitly\nspecified using `extends`. For the sake of convenience, \nthis class inherits a default definition of value\nequality from `Identifiable`.",192)),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared(),abstract()];},d:['ceylon.language','Basic']};};
exports.Basic=Basic;
function $init$Basic(){
    if (Basic.$$===undefined){
        initTypeProto(Basic,'ceylon.language::Basic',$init$Object$(),$init$Identifiable());
    }
    return Basic;
}
exports.$init$Basic=$init$Basic;
$init$Basic();
function Exception(description$1, cause, $$exception){
    $init$Exception();
    if ($$exception===undefined)$$exception=new Exception.$$;
    if(description$1===undefined){description$1=null;}
    $$exception.description$1_=description$1;
    if(cause===undefined){cause=null;}
    $$exception.cause_=cause;
    if (typeof($init$native$Exception$before)==='function')$init$native$Exception$before($$exception);
    $$exception.$prop$getCause={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Exception}]},$cont:Exception,$an:function(){return[doc(String$("The underlying cause of this exception.",39)),shared()];},d:['ceylon.language','Exception','$at','cause']};}};
    $$exception.$prop$getCause.get=function(){return cause};
    $$exception.$prop$getDescription$1={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:String$}]},$cont:Exception,$an:function(){return[doc(String$("A description of the problem.",29))];},d:['ceylon.language','Exception','$at','description']};}};
    $$exception.$prop$getDescription$1.get=function(){return description$1};
    $$exception.$prop$getMessage={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Exception,$an:function(){return[doc(String$("A message describing the problem. This default \nimplementation returns the description, if any, or \notherwise the message of the cause, if any.",143)),see([$init$OpenValue()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Exception().$$.prototype.$prop$getCause)].reifyCeylonType({Absent:{t:Null},Element:{t:ValueDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Exception','$at','message']};}};
    $$exception.$prop$getMessage.get=function(){return message};
    $$exception.$prop$getString={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Exception,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','Exception','$at','string']};}};
    $$exception.$prop$getString.get=function(){return string};
    if (typeof($init$native$Exception$after)==='function')$init$native$Exception$after($$exception);
    return $$exception;
}
Exception.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[{$nm:'description',$mt:'prm',$def:1,$t:{t:'u', l:[{t:Null},{t:String$}]},$an:function(){return[doc("A description of the problem.")];}},{$nm:'cause',$mt:'prm',$def:1,$t:{t:'u', l:[{t:Null},{t:Exception}]},$an:function(){return[doc("The underlying cause of this exception."),shared()];}}],$an:function(){return[doc(String$("The supertype of all exceptions. A subclass represents\na more specific kind of problem, and may define \nadditional attributes which propagate information about\nproblems of that kind.",182)),by([String$("Gavin",5),String$("Tom",3)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared(),$native()];},d:['ceylon.language','Exception']};};
exports.Exception=Exception;
function $init$Exception(){
    if (Exception.$$===undefined){
        initTypeProto(Exception,'ceylon.language::Exception',Basic);
        (function($$exception){
            defineAttr($$exception,'cause',function(){return this.cause_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Exception}]},$cont:Exception,$an:function(){return[doc(String$("The underlying cause of this exception.",39)),shared()];},d:['ceylon.language','Exception','$at','cause']};});
            defineAttr($$exception,'description$1',function(){return this.description$1_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:String$}]},$cont:Exception,$an:function(){return[doc(String$("A description of the problem.",29))];},d:['ceylon.language','Exception','$at','description']};});
            defineAttr($$exception,'message',function(){
                var $$exception=this;
                return (opt$2=(opt$3=$$exception.description$1,opt$3!==null?opt$3:(opt$4=$$exception.cause,opt$4!==null?opt$4.message:null)),opt$2!==null?opt$2:String$("",0));
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Exception,$an:function(){return[doc(String$("A message describing the problem. This default \nimplementation returns the description, if any, or \notherwise the message of the cause, if any.",143)),see([$init$OpenValue()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Exception().$$.prototype.$prop$getCause)].reifyCeylonType({Absent:{t:Null},Element:{t:ValueDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Exception','$at','message']};});
            defineAttr($$exception,'string',function(){
                var $$exception=this;
                return className($$exception).plus(StringBuilder().appendAll([String$(" \"",2),$$exception.message.string,String$("\"",1)]).string);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Exception,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','Exception','$at','string']};});
            $$exception.printStackTrace=function (){
                var $$exception=this;
                return printStackTrace($$exception);
            };
            $$exception.printStackTrace.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[],$cont:Exception,$an:function(){return[doc(String$("Print the stack trace to the standard error of\nthe virtual machine process.",75)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),printStackTrace)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','Exception','$m','printStackTrace']};};
        })(Exception.$$.prototype);
    }
    return Exception;
}
exports.$init$Exception=$init$Exception;
$init$Exception();
var opt$2,opt$3,opt$4;
function $init$native$Exception$before(exc) {
  var _caller=arguments.callee.caller.caller;
  exc.stack_trace=[];
  while(_caller) {
    exc.stack_trace.push(_caller);
    _caller = _caller.caller;
  }
}
function printStackTrace(exc, _write) {
  if (_write===undefined)_write=getProcess().writeError;
  var _c = className(exc);
  if (exc.message.size > 0) {
    _c += ' "' + exc.message + '"';
  }
  _write(_c);_write(getOperatingSystem().newline);
  for (var i=0; i<exc.stack_trace.length; i++) {
    var f = exc.stack_trace[i];
    var mm = f.$$metamodel$$;
    if (typeof(mm)==='function') {
      mm = mm();
      f.$$metamodel$$=mm;
    }
    if (mm) {
      var _src = '';
      if (i==0) {
        if (exc.$loc && exc.$file) _src = ' (' + exc.$file + " " + exc.$loc + ')';
      }
      _write("    at " + mm.d[0] + "::" + mm.d[mm.d.length-1] + _src);_write(getOperatingSystem().newline);
    }
  }
}
printStackTrace.$$metamodel$$=function(){
  return{mod:$$METAMODEL$$,d:['ceylon.language','printStackTrace'],$t:{t:Anything},$ps:[
    {$nm:'exception',$t:{t:Exception},$mt:'prm'},{$nm:'write',$t:{t:Callable,a:{Return:{t:Anything},Arguments:{t:'T',l:[{t:String$}]}}},$mt:'prm','$def':1}
  ]};};
exports.printStackTrace=printStackTrace;
function Iterable($$targs$$,$$iterable){
    Category($$iterable);
    set_type_args($$iterable,$$targs$$);
    $$iterable.$prop$getEmpty={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Iterable,$an:function(){return[doc(String$("Determines if the iterable object is empty, that is\nto say, if the iterator returns no elements.",96)),shared(),$default()];},d:['ceylon.language','Iterable','$at','empty']};}};
    $$iterable.$prop$getEmpty.get=function(){return empty};
    $$iterable.$prop$getSize={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Iterable,$an:function(){return[doc(String$("The number of elements returned by the iterator of\nthis iterable object, if the iterator terminates.\nIn the case of an iterable whose elements are not\ncountable, this operation never terminates.",194)),shared(),$default()];},d:['ceylon.language','Iterable','$at','size']};}};
    $$iterable.$prop$getSize.get=function(){return size};
    $$iterable.$prop$getFirst={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Absent','Element']},$cont:Iterable,$an:function(){return[doc(String$("The first element returned by the iterator, if any,\nof `null` if the iterable object is empty.",94)),shared(),$default()];},d:['ceylon.language','Iterable','$at','first']};}};
    $$iterable.$prop$getFirst.get=function(){return first};
    $$iterable.$prop$getRest={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$cont:Iterable,$an:function(){return[doc(String$("Returns an iterable object containing all but the \nfirst element of this container.",83)),shared(),$default()];},d:['ceylon.language','Iterable','$at','rest']};}};
    $$iterable.$prop$getRest.get=function(){return rest};
    $$iterable.$prop$getSequence={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$cont:Iterable,$an:function(){return[doc(String$("A sequence containing the elements returned by the\niterator.",60)),shared(),$default()];},d:['ceylon.language','Iterable','$at','sequence']};}};
    $$iterable.$prop$getSequence.get=function(){return sequence};
    $$iterable.$prop$getCoalesced={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:'i', l:['Element',{t:Object$}]}}},$cont:Iterable,$an:function(){return[doc(String$("The non-null elements of this `Iterable`, in their\noriginal order. For null elements of the original \n`Iterable`, there is no entry in the resulting \niterable object.",166)),shared(),$default()];},d:['ceylon.language','Iterable','$at','coalesced']};}};
    $$iterable.$prop$getCoalesced.get=function(){return coalesced};
}
Iterable.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Element:{'var':'out'},Absent:{'var':'out','satisfies':[{t:Null}],'def':{t:Null}}},satisfies:[{t:Category}],$an:function(){return[doc(String$("Abstract supertype of categories whose elements may be \niterated. An iterable category need not be finite, but\nits elements must at least be countable. There may not\nbe a well-defined iteration order, and so the order of\niterated elements may not be stable.\n\nThe type `Iterable<Element,Null>`, usually abbreviated\n`{Element*}` represents a possibly-empty iterable \ncontainer. The type `Iterable<Element,Nothing>`, \nusually abbreviated `{Element+}` represents a nonempty \niterable container.\n\nAn instance of `Iterable` may be constructed by \nsurrounding a value list in braces:\n\n    {String+} words = { \"hello\", \"world\" };\n\nAn instance of `Iterable` may be iterated using a `for`\nloop:\n\n    for (c in \"hello world\") { ... }\n\n`Iterable` and its subtypes define various operations\nthat return other iterable objects. Such operations \ncome in two flavors:\n\n- _Lazy_ operations return a *view* of the receiving\n  iterable object. If the underlying iterable object is\n  mutable, then changes to the underlying object will\n  be reflected in the resulting view. Lazy operations\n  are usually efficient, avoiding memory allocation or\n  iteration of the receiving iterable object.\n- _Eager_ operations return an immutable object. If the\n  receiving iterable object is mutable, changes to this\n  object will not be reflected in the resulting \n  immutable object. Eager operations are often \n  expensive, involving memory allocation and iteration\n  of the receiving iterable object.\n\nLazy operations are preferred, because they can be \nefficiently chained. For example:\n\n    string.filter((Character c) => c.letter)\n          .map((Character c) => c.uppercased)\n\nis much less expensive than:\n\n    string.select((Character c) => c.letter)\n          .collect((Character c) => c.uppercased)\n\nFurthermore, it is always easy to produce a new \nimmutable iterable object given the view produced by a\nlazy operation. For example:\n\n    [ *string.filter((Character c) => c.letter)\n          .map((Character c) => c.uppercased) ]\n\nLazy operations normally return an instance of \n`Iterable` or `Map`.\n\nHowever, there are certain scenarios where an eager \noperation is more useful, more convenient, or no more \nexpensive than a lazy operation, including:\n\n- sorting operations, which are eager by nature,\n- operations which preserve emptiness/nonemptiness of\n  the receiving iterable object.\n\nEager operations normally return a sequence.",2412)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Collection)].reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceDeclaration$meta$declaration}})),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','Iterable']};};
exports.Iterable=Iterable;
function $init$Iterable(){
    if (Iterable.$$===undefined){
        initTypeProtoI(Iterable,'ceylon.language::Iterable',$init$Category());
        (function($$iterable){
            $$iterable.iterator={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$ps:[],$cont:Iterable,$an:function(){return[doc("An iterator for the elements belonging to this \ncontainer."),shared(),formal()];},d:['ceylon.language','Iterable','$m','iterator']};}};defineAttr($$iterable,'empty',function(){
                var $$iterable=this;
                return isOfType($$iterable.iterator().next(),{t:Finished});
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Iterable,$an:function(){return[doc(String$("Determines if the iterable object is empty, that is\nto say, if the iterator returns no elements.",96)),shared(),$default()];},d:['ceylon.language','Iterable','$at','empty']};});
            defineAttr($$iterable,'size',function(){
                var $$iterable=this;
                return $$iterable.count($JsCallable((function (e$5){
                    var $$iterable=this;
                    return true;
                }),[{$nm:'e',$mt:'prm',$t:'Element',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$iterable.$$targs$$.Element]},Return:{t:Boolean$}}));
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Iterable,$an:function(){return[doc(String$("The number of elements returned by the iterator of\nthis iterable object, if the iterator terminates.\nIn the case of an iterable whose elements are not\ncountable, this operation never terminates.",194)),shared(),$default()];},d:['ceylon.language','Iterable','$at','size']};});
            $$iterable.longerThan=function longerThan(length$6){
                var $$iterable=this;
                if(length$6.compare((0)).equals(getSmaller())){
                    return true;
                }
                var count$7=(0);
                function setCount$7(count$8){return count$7=count$8;};
                var it$9 = $$iterable.iterator();
                var element$10;while ((element$10=it$9.next())!==getFinished()){
                    if((oldcount$11=count$7,count$7=oldcount$11.successor,oldcount$11).equals(length$6)){
                        return true;
                    }
                    var oldcount$11;
                }
                return false;
            };$$iterable.longerThan.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Iterable,$an:function(){return[doc(String$("Determines if this iterable object has more elements\nthan the given length. This is an efficient operation \nfor iterable objects with many elements.",148)),see([$init$OpenValue()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Iterable().$$.prototype.$prop$getSize)].reifyCeylonType({Absent:{t:Null},Element:{t:ValueDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Iterable','$m','longerThan']};};
            $$iterable.shorterThan=function shorterThan(length$12){
                var $$iterable=this;
                if((length$12.compare((0))!==getLarger())){
                    return false;
                }
                var count$13=(0);
                function setCount$13(count$14){return count$13=count$14;};
                var it$15 = $$iterable.iterator();
                var element$16;while ((element$16=it$15.next())!==getFinished()){
                    if((count$13=count$13.successor).equals(length$12)){
                        return false;
                    }
                }
                return true;
            };$$iterable.shorterThan.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Iterable,$an:function(){return[doc(String$("Determines if this iterable object has fewer elements\nthan the given length. This is an efficient operation \nfor iterable objects with many elements.",149)),see([$init$OpenValue()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Iterable().$$.prototype.$prop$getSize)].reifyCeylonType({Absent:{t:Null},Element:{t:ValueDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Iterable','$m','shorterThan']};};
            $$iterable.contains=function (element$17){
                var $$iterable=this;
                return $$iterable.any($JsCallable(ifExists($JsCallable((opt$18=element$17,JsCallable(opt$18,opt$18!==null?opt$18.equals:null)),[{$nm:'that',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],{Arguments:{t:'T', l:[{t:Object$}]},Return:{t:Boolean$}})),[{$nm:'p2',$mt:'prm',$t:{t:Anything}}],{Arguments:{t:'T', l:[{t:Anything}]},Return:{t:Boolean$}}));
            };
            $$iterable.contains.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'element',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Iterable,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','Iterable','$m','contains']};};
            defineAttr($$iterable,'first',function(){
                var $$iterable=this;
                return first($$iterable,{Value:$$iterable.$$targs$$.Element,Absent:$$iterable.$$targs$$.Absent});
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Absent','Element']},$cont:Iterable,$an:function(){return[doc(String$("The first element returned by the iterator, if any,\nof `null` if the iterable object is empty.",94)),shared(),$default()];},d:['ceylon.language','Iterable','$at','first']};});
            defineAttr($$iterable,'last',function(){
                var $$iterable=this;
                var e$19=$$iterable.first;
                function setE$19(e$20){return e$19=e$20;};
                $prop$getE$19={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Absent','Element']},$an:function(){return[variable()];},d:['ceylon.language','Iterable','$at','last','$at','e']};}};
                $prop$getE$19.get=function(){return e$19};
                $prop$getE$19.set=setE$19;
                if (setE$19.$$metamodel$$===undefined)setE$19.$$metamodel$$=$prop$getE$19.$$metamodel$$;
                var it$21 = $$iterable.iterator();
                var x$22;while ((x$22=it$21.next())!==getFinished()){
                    e$19=x$22;
                }
                return e$19;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Absent','Element']},$cont:Iterable,$an:function(){return[doc(String$("The last element returned by the iterator, if any,\nof `null` if the iterable object is empty. Iterable\nobjects are potentially infinite, so calling this\nmight never return; also, this implementation will\niterate through all the elements, which might be\nvery time-consuming.",273)),shared(),$default()];},d:['ceylon.language','Iterable','$at','last']};});defineAttr($$iterable,'rest',function(){
                var $$iterable=this;
                return $$iterable.skipping((1));
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$cont:Iterable,$an:function(){return[doc(String$("Returns an iterable object containing all but the \nfirst element of this container.",83)),shared(),$default()];},d:['ceylon.language','Iterable','$at','rest']};});
            defineAttr($$iterable,'sequence',function(){
                var $$iterable=this;
                return Comprehension(function(){
                    var it$23=$$iterable.iterator();
                    var x$24=getFinished();
                    var next$x$24=function(){return x$24=it$23.next();}
                    next$x$24();
                    return function(){
                        if(x$24!==getFinished()){
                            var x$24$25=x$24;
                            var tmpvar$26=x$24$25;
                            next$x$24();
                            return tmpvar$26;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:$$iterable.$$targs$$.Element}).sequence;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$cont:Iterable,$an:function(){return[doc(String$("A sequence containing the elements returned by the\niterator.",60)),shared(),$default()];},d:['ceylon.language','Iterable','$at','sequence']};});
            $$iterable.$map=function (collecting$27,$$$mptypes){
                var $$iterable=this;
                return Comprehension(function(){
                    var it$28=$$iterable.iterator();
                    var elem$29=getFinished();
                    var next$elem$29=function(){return elem$29=it$28.next();}
                    next$elem$29();
                    return function(){
                        if(elem$29!==getFinished()){
                            var elem$29$30=elem$29;
                            var tmpvar$31=collecting$27(elem$29$30);
                            next$elem$29();
                            return tmpvar$31;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:$$$mptypes.Result});
            };
            $$iterable.$map.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:'Absent',Element:'Result'}},$ps:[{$nm:'collecting',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[doc("The mapping to apply to the elements.")];}}],$cont:Iterable,$tp:{Result:{}},$an:function(){return[doc(String$("An `Iterable` containing the results of applying\nthe given mapping to the elements of to this \ncontainer.",105)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Iterable().$$.prototype.collect)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Iterable','$m','map']};};
            $$iterable.$filter=function (selecting$32){
                var $$iterable=this;
                return Comprehension(function(){
                    var it$33=$$iterable.iterator();
                    var elem$34=getFinished();
                    var next$elem$34=function(){
                        while((elem$34=it$33.next())!==getFinished()){
                            if(selecting$32(elem$34)){
                                return elem$34;
                            }
                        }
                        return getFinished();
                    }
                    next$elem$34();
                    return function(){
                        if(elem$34!==getFinished()){
                            var elem$34$35=elem$34;
                            var tmpvar$36=elem$34$35;
                            next$elem$34();
                            return tmpvar$36;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:$$iterable.$$targs$$.Element});
            };
            $$iterable.$filter.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[doc("The predicate the elements must satisfy.")];}}],$cont:Iterable,$an:function(){return[doc(String$("An `Iterable` containing the elements of this \ncontainer that satisfy the given predicate.",90)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Iterable().$$.prototype.select)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Iterable','$m','filter']};};
            $$iterable.fold=function fold(initial$37,accumulating$38,$$$mptypes){
                var $$iterable=this;
                var r$39=initial$37;
                function setR$39(r$40){return r$39=r$40;};
                var it$41 = $$iterable.iterator();
                var e$42;while ((e$42=it$41.next())!==getFinished()){
                    r$39=accumulating$38(r$39,e$42);
                }
                return r$39;
            };$$iterable.fold.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Result',$ps:[{$nm:'initial',$mt:'prm',$t:'Result',$an:function(){return[];}},{$nm:'accumulating',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[doc("The accumulating function that accepts an\nintermediate result, and the next element.")];}}],$cont:Iterable,$tp:{Result:{}},$an:function(){return[doc(String$("The result of applying the accumulating function to \neach element of this container in turn.",92)),shared(),$default()];},d:['ceylon.language','Iterable','$m','fold']};};
            $$iterable.find=function find(selecting$43){
                var $$iterable=this;
                var it$44 = $$iterable.iterator();
                var e$45;while ((e$45=it$44.next())!==getFinished()){
                    if(selecting$43(e$45)){
                        return e$45;
                    }
                }
                return null;
            };$$iterable.find.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[doc("The predicate the element must satisfy.")];}}],$cont:Iterable,$an:function(){return[doc(String$("The first element which satisfies the given \npredicate, if any, or `null` otherwise.",84)),shared(),$default()];},d:['ceylon.language','Iterable','$m','find']};};
            $$iterable.findLast=function findLast(selecting$46){
                var $$iterable=this;
                var last$47=null;
                function setLast$47(last$48){return last$47=last$48;};
                var it$49 = $$iterable.iterator();
                var e$50;while ((e$50=it$49.next())!==getFinished()){
                    if(selecting$46(e$50)){
                        last$47=e$50;
                    }
                }
                return last$47;
            };$$iterable.findLast.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[doc("The predicate the element must satisfy.")];}}],$cont:Iterable,$an:function(){return[doc(String$("The last element which satisfies the given\npredicate, if any, or `null` otherwise.",82)),shared(),$default()];},d:['ceylon.language','Iterable','$m','findLast']};};
            $$iterable.$sort=function (comparing$51){
                var $$iterable=this;
                return internalSort($JsCallable(comparing$51,[{$nm:'x',$mt:'prm',$t:'Element',$an:function(){return[];}},{$nm:'y',$mt:'prm',$t:'Element',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$iterable.$$targs$$.Element,$$iterable.$$targs$$.Element]},Return:{t:Comparison}}),$$iterable,{Element:$$iterable.$$targs$$.Element});
            };
            $$iterable.$sort.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$ps:[{$nm:'comparing',$mt:'prm',$pt:'f',$t:{t:Comparison},$an:function(){return[doc("The function comparing pairs of elements.")];}}],$cont:Iterable,$an:function(){return[doc(String$("A sequence containing the elements of this\ncontainer, sorted according to a function \nimposing a partial order upon the elements.\n\nFor convenience, the functions `byIncreasing()` \nand `byDecreasing()` produce a suitable \ncomparison function:\n\n    \"Hello World!\".sort(byIncreasing((Character c) => c.lowercased))\n\nThis operation is eager by nature.",347)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),byIncreasing),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),byDecreasing)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Iterable','$m','sort']};};
            $$iterable.collect=function (collecting$52,$$$mptypes){
                var $$iterable=this;
                return $$iterable.$map($JsCallable(collecting$52,[{$nm:'element',$mt:'prm',$t:'Element',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$iterable.$$targs$$.Element]},Return:$$$mptypes.Result}),{Result:$$$mptypes.Result}).sequence;
            };
            $$iterable.collect.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Result'}},$ps:[{$nm:'collecting',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[doc("The transformation applied to the elements.")];}}],$cont:Iterable,$tp:{Result:{}},$an:function(){return[doc(String$("A sequence containing the results of applying the\ngiven mapping to the elements of this container. An \neager counterpart to `map()`.",132)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Iterable().$$.prototype.$map)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Iterable','$m','collect']};};
            $$iterable.select=function (selecting$53){
                var $$iterable=this;
                return $$iterable.$filter($JsCallable(selecting$53,[{$nm:'element',$mt:'prm',$t:'Element',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$iterable.$$targs$$.Element]},Return:{t:Boolean$}})).sequence;
            };
            $$iterable.select.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[doc("The predicate the elements must satisfy.")];}}],$cont:Iterable,$an:function(){return[doc(String$("A sequence containing the elements of this \ncontainer that satisfy the given predicate. An \neager counterpart to `filter()`.",124)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Iterable().$$.prototype.$filter)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Iterable','$m','select']};};
            $$iterable.any=function any(selecting$54){
                var $$iterable=this;
                var it$55 = $$iterable.iterator();
                var e$56;while ((e$56=it$55.next())!==getFinished()){
                    if(selecting$54(e$56)){
                        return true;
                    }
                }
                return false;
            };$$iterable.any.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[doc("The predicate that at least one element \nmust satisfy.")];}}],$cont:Iterable,$an:function(){return[doc(String$("Return `true` if at least one element satisfies the\npredicate function.",71)),shared(),$default()];},d:['ceylon.language','Iterable','$m','any']};};
            $$iterable.$every=function $every(selecting$57){
                var $$iterable=this;
                var it$58 = $$iterable.iterator();
                var e$59;while ((e$59=it$58.next())!==getFinished()){
                    if((!selecting$57(e$59))){
                        return false;
                    }
                }
                return true;
            };$$iterable.$every.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[doc("The predicate that all elements must \nsatisfy.")];}}],$cont:Iterable,$an:function(){return[doc(String$("Return `true` if all elements satisfy the predicate\nfunction.",61)),shared(),$default()];},d:['ceylon.language','Iterable','$m','every']};};
            $$iterable.skipping=function skipping(skip$60){
                var $$iterable=this;
                if((skip$60.compare((0))!==getLarger())){
                    return $$iterable;
                }else {
                    var cntvar$61=false;
                    var brkvar$63=false;
                    var retvar$62=(function(){
                        function iterable$64($$targs$$){
                            var $$iterable$64=new iterable$64.$$;
                            $$iterable$64.$$targs$$=$$targs$$;
                            Iterable({Absent:{t:Null},Element:$$iterable.$$targs$$.Element},$$iterable$64);
                            add_type_arg($$iterable$64,'Absent',{t:Null});
                            return $$iterable$64;
                        };iterable$64.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterable,a:{Absent:{t:Null},Element:'Element'}}],d:['ceylon.language','Iterable','$m','skipping','$o','iterable']};};
                        function $init$iterable$64(){
                            if (iterable$64.$$===undefined){
                                initTypeProto(iterable$64,'ceylon.language::Iterable.skipping.iterable',Basic,$init$Iterable());
                                (function($$iterable$64){
                                    $$iterable$64.iterator=function iterator(){
                                        var $$iterable$64=this;
                                        var iter$65=$$iterable.iterator();
                                        var i$66=(0);
                                        function setI$66(i$67){return i$66=i$67;};
                                        while(((oldi$68=i$66,i$66=oldi$68.successor,oldi$68).compare(skip$60).equals(getSmaller())&&(!isOfType(iter$65.next(),{t:Finished})))){}
                                        var oldi$68;
                                        return iter$65;
                                    };$$iterable$64.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$ps:[],$cont:iterable$64,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$m','skipping','$o','iterable','$m','iterator']};};
                                })(iterable$64.$$.prototype);
                            }
                            return iterable$64;
                        }
                        $init$iterable$64();
                        var iterable$69;
                        function getIterable$69(){
                            if (iterable$69===undefined){iterable$69=$init$iterable$64()({Absent:{t:Null},Element:$$iterable.$$targs$$.Element});iterable$69.$$metamodel$$=getIterable$69.$$metamodel$$;}
                            return iterable$69;
                        }
                        getIterable$69.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterable$64},d:['ceylon.language','Iterable','$m','skipping','$o','iterable']};};
                        $prop$getIterable$69={get:getIterable$69,$$metamodel$$:getIterable$69.$$metamodel$$};
                        return getIterable$69();
                    }());if(retvar$62!==undefined){return retvar$62;}
                }
            };$$iterable.skipping.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$ps:[{$nm:'skip',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Iterable,$an:function(){return[doc(String$("Produce an `Iterable` containing the elements of\nthis iterable object, after skipping the first \n`skip` elements. If this iterable object does not \ncontain more elements than the specified number of \nelements, the `Iterable` contains no elements.",246)),shared(),$default()];},d:['ceylon.language','Iterable','$m','skipping']};};
            $$iterable.taking=function taking(take$70){
                var $$iterable=this;
                if((take$70.compare((0))!==getLarger())){
                    return getEmpty();
                }else {
                    var cntvar$71=false;
                    var brkvar$73=false;
                    var retvar$72=(function(){
                        function iterable$74($$targs$$){
                            var $$iterable$74=new iterable$74.$$;
                            $$iterable$74.$$targs$$=$$targs$$;
                            Iterable({Absent:{t:Null},Element:$$iterable.$$targs$$.Element},$$iterable$74);
                            add_type_arg($$iterable$74,'Absent',{t:Null});
                            $$iterable$74.$prop$getFirst.get=function(){return first};
                            return $$iterable$74;
                        };iterable$74.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterable,a:{Absent:{t:Null},Element:'Element'}}],d:['ceylon.language','Iterable','$m','taking','$o','iterable']};};
                        function $init$iterable$74(){
                            if (iterable$74.$$===undefined){
                                initTypeProto(iterable$74,'ceylon.language::Iterable.taking.iterable',Basic,$init$Iterable());
                                (function($$iterable$74){
                                    $$iterable$74.iterator=function iterator(){
                                        var $$iterable$74=this;
                                        var iter$75=$$iterable.iterator();
                                        function iterator$76($$targs$$){
                                            var $$iterator$76=new iterator$76.$$;
                                            $$iterator$76.$$targs$$=$$targs$$;
                                            Iterator({Element:$$iterable.$$targs$$.Element},$$iterator$76);
                                            $$iterator$76.i$77_=(0);
                                            $$iterator$76.$prop$getI$77={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:iterator$76,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$m','taking','$o','iterable','$m','iterator','$o','iterator','$at','i']};}};
                                            $$iterator$76.$prop$getI$77.get=function(){return i$77};
                                            return $$iterator$76;
                                        };iterator$76.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterator,a:{Element:'Element'}}],d:['ceylon.language','Iterable','$m','taking','$o','iterable','$m','iterator','$o','iterator']};};
                                        function $init$iterator$76(){
                                            if (iterator$76.$$===undefined){
                                                initTypeProto(iterator$76,'ceylon.language::Iterable.taking.iterable.iterator.iterator',Basic,$init$Iterator());
                                                (function($$iterator$76){
                                                    defineAttr($$iterator$76,'i$77',function(){return this.i$77_;},function(i$78){return this.i$77_=i$78;},function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:iterator$76,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$m','taking','$o','iterable','$m','iterator','$o','iterator','$at','i']};});
                                                    $$iterator$76.next=function next(){
                                                        var $$iterator$76=this;
                                                        return (opt$79=(($$iterator$76.i$77=$$iterator$76.i$77.successor).compare(take$70).equals(getLarger())?getFinished():null),opt$79!==null?opt$79:iter$75.next());
                                                        var opt$79;
                                                    };$$iterator$76.next.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$ps:[],$cont:iterator$76,$an:function(){return[actual(),shared()];},d:['ceylon.language','Iterable','$m','taking','$o','iterable','$m','iterator','$o','iterator','$m','next']};};
                                                })(iterator$76.$$.prototype);
                                            }
                                            return iterator$76;
                                        }
                                        $init$iterator$76();
                                        var iterator$80;
                                        function getIterator$80(){
                                            if (iterator$80===undefined){iterator$80=$init$iterator$76()({Element:$$iterable.$$targs$$.Element});iterator$80.$$metamodel$$=getIterator$80.$$metamodel$$;}
                                            return iterator$80;
                                        }
                                        getIterator$80.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterator$76},d:['ceylon.language','Iterable','$m','taking','$o','iterable','$m','iterator','$o','iterator']};};
                                        $prop$getIterator$80={get:getIterator$80,$$metamodel$$:getIterator$80.$$metamodel$$};
                                        return getIterator$80();
                                    };$$iterable$74.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$ps:[],$cont:iterable$74,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$m','taking','$o','iterable','$m','iterator']};};
                                    defineAttr($$iterable$74,'first',function(){
                                        var $$iterable$74=this;
                                        return $$iterable.first;
                                    },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$cont:iterable$74,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$m','taking','$o','iterable','$at','first']};});
                                })(iterable$74.$$.prototype);
                            }
                            return iterable$74;
                        }
                        $init$iterable$74();
                        var iterable$81;
                        function getIterable$81(){
                            if (iterable$81===undefined){iterable$81=$init$iterable$74()({Absent:{t:Null},Element:$$iterable.$$targs$$.Element});iterable$81.$$metamodel$$=getIterable$81.$$metamodel$$;}
                            return iterable$81;
                        }
                        getIterable$81.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterable$74},d:['ceylon.language','Iterable','$m','taking','$o','iterable']};};
                        $prop$getIterable$81={get:getIterable$81,$$metamodel$$:getIterable$81.$$metamodel$$};
                        return getIterable$81();
                    }());if(retvar$72!==undefined){return retvar$72;}
                }
            };$$iterable.taking.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$ps:[{$nm:'take',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Iterable,$an:function(){return[doc(String$("Produce an `Iterable` containing the first `take`\nelements of this iterable object. If the specified \nnumber of elements is larger than the number of \nelements of this iterable object, the `Iterable` \ncontains the same elements as this iterable object.",252)),shared(),$default()];},d:['ceylon.language','Iterable','$m','taking']};};
            $$iterable.skippingWhile=function skippingWhile(skip$82){
                var $$iterable=this;
                function iterable$83($$targs$$){
                    var $$iterable$83=new iterable$83.$$;
                    $$iterable$83.$$targs$$=$$targs$$;
                    Iterable({Absent:{t:Null},Element:$$iterable.$$targs$$.Element},$$iterable$83);
                    add_type_arg($$iterable$83,'Absent',{t:Null});
                    return $$iterable$83;
                };iterable$83.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterable,a:{Absent:{t:Null},Element:'Element'}}],d:['ceylon.language','Iterable','$m','skippingWhile','$o','iterable']};};
                function $init$iterable$83(){
                    if (iterable$83.$$===undefined){
                        initTypeProto(iterable$83,'ceylon.language::Iterable.skippingWhile.iterable',Basic,$init$Iterable());
                        (function($$iterable$83){
                            $$iterable$83.iterator=function iterator(){
                                var $$iterable$83=this;
                                var iter$84=$$iterable.iterator();
                                var elem$85;
                                while(!isOfType((elem$85=iter$84.next()),{t:Finished})){
                                    if((!skip$82(elem$85))){
                                        var cntvar$86=false;
                                        var brkvar$88=false;
                                        var retvar$87=(function(){
                                            function iterator$89($$targs$$){
                                                var $$iterator$89=new iterator$89.$$;
                                                $$iterator$89.$$targs$$=$$targs$$;
                                                Iterator({Element:$$iterable.$$targs$$.Element},$$iterator$89);
                                                $$iterator$89.first$90_=true;
                                                $$iterator$89.$prop$getFirst$90={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:iterator$89,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$m','skippingWhile','$o','iterable','$m','iterator','$o','iterator','$at','first']};}};
                                                $$iterator$89.$prop$getFirst$90.get=function(){return first$90};
                                                return $$iterator$89;
                                            };iterator$89.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterator,a:{Element:'Element'}}],d:['ceylon.language','Iterable','$m','skippingWhile','$o','iterable','$m','iterator','$o','iterator']};};
                                            function $init$iterator$89(){
                                                if (iterator$89.$$===undefined){
                                                    initTypeProto(iterator$89,'ceylon.language::Iterable.skippingWhile.iterable.iterator.iterator',Basic,$init$Iterator());
                                                    (function($$iterator$89){
                                                        defineAttr($$iterator$89,'first$90',function(){return this.first$90_;},function(first$91){return this.first$90_=first$91;},function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:iterator$89,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$m','skippingWhile','$o','iterable','$m','iterator','$o','iterator','$at','first']};});
                                                        $$iterator$89.next=function next(){
                                                            var $$iterator$89=this;
                                                            if($$iterator$89.first$90){
                                                                $$iterator$89.first$90=false;
                                                                return elem$85;
                                                            }else {
                                                                return iter$84.next();
                                                            }
                                                        };$$iterator$89.next.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$ps:[],$cont:iterator$89,$an:function(){return[actual(),shared()];},d:['ceylon.language','Iterable','$m','skippingWhile','$o','iterable','$m','iterator','$o','iterator','$m','next']};};
                                                    })(iterator$89.$$.prototype);
                                                }
                                                return iterator$89;
                                            }
                                            $init$iterator$89();
                                            var iterator$92;
                                            function getIterator$92(){
                                                if (iterator$92===undefined){iterator$92=$init$iterator$89()({Element:$$iterable.$$targs$$.Element});iterator$92.$$metamodel$$=getIterator$92.$$metamodel$$;}
                                                return iterator$92;
                                            }
                                            getIterator$92.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterator$89},d:['ceylon.language','Iterable','$m','skippingWhile','$o','iterable','$m','iterator','$o','iterator']};};
                                            $prop$getIterator$92={get:getIterator$92,$$metamodel$$:getIterator$92.$$metamodel$$};
                                            return getIterator$92();
                                        }());if(retvar$87!==undefined){return retvar$87;}
                                    }
                                }
                                return getEmptyIterator();
                            };$$iterable$83.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$ps:[],$cont:iterable$83,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$m','skippingWhile','$o','iterable','$m','iterator']};};
                        })(iterable$83.$$.prototype);
                    }
                    return iterable$83;
                }
                $init$iterable$83();
                var iterable$93;
                function getIterable$93(){
                    if (iterable$93===undefined){iterable$93=$init$iterable$83()({Absent:{t:Null},Element:$$iterable.$$targs$$.Element});iterable$93.$$metamodel$$=getIterable$93.$$metamodel$$;}
                    return iterable$93;
                }
                getIterable$93.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterable$83},d:['ceylon.language','Iterable','$m','skippingWhile','$o','iterable']};};
                $prop$getIterable$93={get:getIterable$93,$$metamodel$$:getIterable$93.$$metamodel$$};
                return getIterable$93();
            };$$iterable.skippingWhile.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$ps:[{$nm:'skip',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Iterable,$an:function(){return[doc(String$("Produce an `Iterable` containing the elements of\nthis iterable object, after skipping the leading \nelements until the given predicate function returns\n`false`.",159)),shared(),$default()];},d:['ceylon.language','Iterable','$m','skippingWhile']};};
            $$iterable.takingWhile=function takingWhile(take$94){
                var $$iterable=this;
                function iterable$95($$targs$$){
                    var $$iterable$95=new iterable$95.$$;
                    $$iterable$95.$$targs$$=$$targs$$;
                    Iterable({Absent:{t:Null},Element:$$iterable.$$targs$$.Element},$$iterable$95);
                    add_type_arg($$iterable$95,'Absent',{t:Null});
                    return $$iterable$95;
                };iterable$95.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterable,a:{Absent:{t:Null},Element:'Element'}}],d:['ceylon.language','Iterable','$m','takingWhile','$o','iterable']};};
                function $init$iterable$95(){
                    if (iterable$95.$$===undefined){
                        initTypeProto(iterable$95,'ceylon.language::Iterable.takingWhile.iterable',Basic,$init$Iterable());
                        (function($$iterable$95){
                            $$iterable$95.iterator=function iterator(){
                                var $$iterable$95=this;
                                var iter$96=$$iterable.iterator();
                                function iterator$97($$targs$$){
                                    var $$iterator$97=new iterator$97.$$;
                                    $$iterator$97.$$targs$$=$$targs$$;
                                    Iterator({Element:$$iterable.$$targs$$.Element},$$iterator$97);
                                    $$iterator$97.alive$98_=true;
                                    $$iterator$97.$prop$getAlive$98={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:iterator$97,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$m','takingWhile','$o','iterable','$m','iterator','$o','iterator','$at','alive']};}};
                                    $$iterator$97.$prop$getAlive$98.get=function(){return alive$98};
                                    return $$iterator$97;
                                };iterator$97.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterator,a:{Element:'Element'}}],d:['ceylon.language','Iterable','$m','takingWhile','$o','iterable','$m','iterator','$o','iterator']};};
                                function $init$iterator$97(){
                                    if (iterator$97.$$===undefined){
                                        initTypeProto(iterator$97,'ceylon.language::Iterable.takingWhile.iterable.iterator.iterator',Basic,$init$Iterator());
                                        (function($$iterator$97){
                                            defineAttr($$iterator$97,'alive$98',function(){return this.alive$98_;},function(alive$99){return this.alive$98_=alive$99;},function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:iterator$97,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$m','takingWhile','$o','iterable','$m','iterator','$o','iterator','$at','alive']};});
                                            $$iterator$97.next=function next(){
                                                var $$iterator$97=this;
                                                var next$100;
                                                if($$iterator$97.alive$98&&!isOfType((next$100=iter$96.next()),{t:Finished})){
                                                    if(take$94(next$100)){
                                                        return next$100;
                                                    }else {
                                                        $$iterator$97.alive$98=false;
                                                    }
                                                }
                                                return getFinished();
                                            };$$iterator$97.next.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$ps:[],$cont:iterator$97,$an:function(){return[actual(),shared()];},d:['ceylon.language','Iterable','$m','takingWhile','$o','iterable','$m','iterator','$o','iterator','$m','next']};};
                                        })(iterator$97.$$.prototype);
                                    }
                                    return iterator$97;
                                }
                                $init$iterator$97();
                                var iterator$101;
                                function getIterator$101(){
                                    if (iterator$101===undefined){iterator$101=$init$iterator$97()({Element:$$iterable.$$targs$$.Element});iterator$101.$$metamodel$$=getIterator$101.$$metamodel$$;}
                                    return iterator$101;
                                }
                                getIterator$101.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterator$97},d:['ceylon.language','Iterable','$m','takingWhile','$o','iterable','$m','iterator','$o','iterator']};};
                                $prop$getIterator$101={get:getIterator$101,$$metamodel$$:getIterator$101.$$metamodel$$};
                                return getIterator$101();
                            };$$iterable$95.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$ps:[],$cont:iterable$95,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$m','takingWhile','$o','iterable','$m','iterator']};};
                        })(iterable$95.$$.prototype);
                    }
                    return iterable$95;
                }
                $init$iterable$95();
                var iterable$102;
                function getIterable$102(){
                    if (iterable$102===undefined){iterable$102=$init$iterable$95()({Absent:{t:Null},Element:$$iterable.$$targs$$.Element});iterable$102.$$metamodel$$=getIterable$102.$$metamodel$$;}
                    return iterable$102;
                }
                getIterable$102.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterable$95},d:['ceylon.language','Iterable','$m','takingWhile','$o','iterable']};};
                $prop$getIterable$102={get:getIterable$102,$$metamodel$$:getIterable$102.$$metamodel$$};
                return getIterable$102();
            };$$iterable.takingWhile.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$ps:[{$nm:'take',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Iterable,$an:function(){return[doc(String$("Produce an `Iterable` containing the leading elements \nof this iterable object until the given predicate \nfunction returns `false`.",131)),shared(),$default()];},d:['ceylon.language','Iterable','$m','takingWhile']};};
            $$iterable.by=function by(step$103){
                var $$iterable=this;
                //assert at Iterable.ceylon (406:8-407:25)
                if (!(step$103.compare((0)).equals(getLarger()))) {throw wrapexc(AssertionException("step size must be greater than zero: \'step > 0\' at Iterable.ceylon (407:15-407:24)"),'406:8-407:25','Iterable.ceylon'); }
                if(step$103.equals((1))){
                    return $$iterable;
                }else {
                    var cntvar$104=false;
                    var brkvar$106=false;
                    var retvar$105=(function(){
                        function iterable$107($$targs$$){
                            var $$iterable$107=new iterable$107.$$;
                            $$iterable$107.$$targs$$=$$targs$$;
                            Iterable({Absent:$$iterable.$$targs$$.Absent,Element:$$iterable.$$targs$$.Element},$$iterable$107);
                            return $$iterable$107;
                        };iterable$107.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterable,a:{Absent:'Absent',Element:'Element'}}],d:['ceylon.language','Iterable','$m','by','$o','iterable']};};
                        function $init$iterable$107(){
                            if (iterable$107.$$===undefined){
                                initTypeProto(iterable$107,'ceylon.language::Iterable.by.iterable',Basic,$init$Iterable());
                                (function($$iterable$107){
                                    $$iterable$107.iterator=function iterator(){
                                        var $$iterable$107=this;
                                        var iter$108=$$iterable.iterator();
                                        function iterator$109($$targs$$){
                                            var $$iterator$109=new iterator$109.$$;
                                            $$iterator$109.$$targs$$=$$targs$$;
                                            Iterator({Element:$$iterable.$$targs$$.Element},$$iterator$109);
                                            return $$iterator$109;
                                        };iterator$109.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterator,a:{Element:'Element'}}],d:['ceylon.language','Iterable','$m','by','$o','iterable','$m','iterator','$o','iterator']};};
                                        function $init$iterator$109(){
                                            if (iterator$109.$$===undefined){
                                                initTypeProto(iterator$109,'ceylon.language::Iterable.by.iterable.iterator.iterator',Basic,$init$Iterator());
                                                (function($$iterator$109){
                                                    $$iterator$109.next=function next(){
                                                        var $$iterator$109=this;
                                                        var next$110=iter$108.next();
                                                        var i$111=(0);
                                                        function setI$111(i$112){return i$111=i$112;};
                                                        while(((i$111=i$111.successor).compare(step$103).equals(getSmaller())&&(!isOfType(iter$108.next(),{t:Finished})))){}
                                                        return next$110;
                                                    };$$iterator$109.next.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$ps:[],$cont:iterator$109,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$m','by','$o','iterable','$m','iterator','$o','iterator','$m','next']};};
                                                })(iterator$109.$$.prototype);
                                            }
                                            return iterator$109;
                                        }
                                        $init$iterator$109();
                                        var iterator$113;
                                        function getIterator$113(){
                                            if (iterator$113===undefined){iterator$113=$init$iterator$109()({Element:$$iterable.$$targs$$.Element});iterator$113.$$metamodel$$=getIterator$113.$$metamodel$$;}
                                            return iterator$113;
                                        }
                                        getIterator$113.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterator$109},d:['ceylon.language','Iterable','$m','by','$o','iterable','$m','iterator','$o','iterator']};};
                                        $prop$getIterator$113={get:getIterator$113,$$metamodel$$:getIterator$113.$$metamodel$$};
                                        return getIterator$113();
                                    };$$iterable$107.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$ps:[],$cont:iterable$107,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$m','by','$o','iterable','$m','iterator']};};
                                })(iterable$107.$$.prototype);
                            }
                            return iterable$107;
                        }
                        $init$iterable$107();
                        var iterable$114;
                        function getIterable$114(){
                            if (iterable$114===undefined){iterable$114=$init$iterable$107()({Absent:$$iterable.$$targs$$.Absent,Element:$$iterable.$$targs$$.Element});iterable$114.$$metamodel$$=getIterable$114.$$metamodel$$;}
                            return iterable$114;
                        }
                        getIterable$114.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterable$107},d:['ceylon.language','Iterable','$m','by','$o','iterable']};};
                        $prop$getIterable$114={get:getIterable$114,$$metamodel$$:getIterable$114.$$metamodel$$};
                        return getIterable$114();
                    }());if(retvar$105!==undefined){return retvar$105;}
                }
            };$$iterable.by.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:'Absent',Element:'Element'}},$ps:[{$nm:'step',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Iterable,$an:function(){return[doc(String$("Produce an `Iterable` containing every `step`th \nelement of this iterable object. If the step size \nis `1`, the `Iterable` contains the same elements \nas this iterable object. The step size must be \ngreater than zero. The expression\n\n    (0..10).by(3)\n\nresults in an iterable object with the elements\n`0`, `3`, `6`, and `9` in that order.",338)),$throws($init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),AssertionException),String$("if the given step size is nonpositive, \ni.e. `step<1`",53)),shared(),$default()];},d:['ceylon.language','Iterable','$m','by']};};
            $$iterable.count=function count(selecting$115){
                var $$iterable=this;
                var count$116=(0);
                function setCount$116(count$117){return count$116=count$117;};
                var it$118 = $$iterable.iterator();
                var elem$119;while ((elem$119=it$118.next())!==getFinished()){
                    var elem$120;
                    if((elem$120=elem$119)!==null&&selecting$115(elem$120)){
                        (oldcount$121=count$116,count$116=oldcount$121.successor,oldcount$121);
                        var oldcount$121;
                    }
                }
                return count$116;
            };$$iterable.count.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[doc("The predicate satisfied by the elements to\nbe counted.")];}}],$cont:Iterable,$an:function(){return[doc(String$("Return the number of elements in this `Iterable` \nthat satisfy the predicate function.",86)),shared(),$default()];},d:['ceylon.language','Iterable','$m','count']};};
            defineAttr($$iterable,'coalesced',function(){
                var $$iterable=this;
                return Comprehension(function(){
                    var e$124;
                    var it$122=$$iterable.iterator();
                    var e$123=getFinished();
                    var e$124;
                    var next$e$123=function(){
                        while((e$123=it$122.next())!==getFinished()){
                            if((e$124=e$123)!==null){
                                return e$123;
                            }
                        }
                        return getFinished();
                    }
                    next$e$123();
                    return function(){
                        if(e$123!==getFinished()){
                            var e$123$125=e$123;
                            var tmpvar$126=e$124;
                            next$e$123();
                            return tmpvar$126;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:{t:'i', l:[$$iterable.$$targs$$.Element,{t:Object$}]}});
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:'i', l:['Element',{t:Object$}]}}},$cont:Iterable,$an:function(){return[doc(String$("The non-null elements of this `Iterable`, in their\noriginal order. For null elements of the original \n`Iterable`, there is no entry in the resulting \niterable object.",166)),shared(),$default()];},d:['ceylon.language','Iterable','$at','coalesced']};});
            defineAttr($$iterable,'indexed',function(){
                var $$iterable=this;
                function indexes$127($$targs$$){
                    var $$indexes$127=new indexes$127.$$;
                    $$indexes$127.$$targs$$=$$targs$$;
                    Iterable({Absent:{t:Null},Element:{t:Entry,a:{Key:{t:Integer},Item:{t:'i', l:[$$iterable.$$targs$$.Element,{t:Object$}]}}}},$$indexes$127);
                    add_type_arg($$indexes$127,'Absent',{t:Null});
                    add_type_arg($$indexes$127,'Element',{t:Entry,a:{Key:{t:Integer},Item:{t:'i', l:[$$iterable.$$targs$$.Element,{t:Object$}]}}});
                    $$indexes$127.$prop$getOrig$128={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:'Absent',Element:'Element'}},$cont:indexes$127,d:['ceylon.language','Iterable','$at','indexed','$o','indexes','$at','orig']};}};
                    $$indexes$127.$prop$getOrig$128.get=function(){return orig$128};
                    return $$indexes$127;
                };indexes$127.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterable,a:{Absent:{t:Null},Element:{t:Entry,a:{Key:{t:Integer},Item:{t:'i', l:['Element',{t:Object$}]}}}}}],d:['ceylon.language','Iterable','$at','indexed','$o','indexes']};};
                function $init$indexes$127(){
                    if (indexes$127.$$===undefined){
                        initTypeProto(indexes$127,'ceylon.language::Iterable.indexed.indexes',Basic,$init$Iterable());
                        (function($$indexes$127){
                            defineAttr($$indexes$127,'orig$128',function(){
                                var $$indexes$127=this;
                                return $$iterable;
                            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:'Absent',Element:'Element'}},$cont:indexes$127,d:['ceylon.language','Iterable','$at','indexed','$o','indexes','$at','orig']};});
                            $$indexes$127.iterator=function iterator(){
                                var $$indexes$127=this;
                                function iterator$129($$targs$$){
                                    var $$iterator$129=new iterator$129.$$;
                                    $$iterator$129.$$targs$$=$$targs$$;
                                    Iterator({Element:{t:Entry,a:{Key:{t:Integer},Item:{t:'i', l:[$$iterable.$$targs$$.Element,{t:Object$}]}}}},$$iterator$129);
                                    add_type_arg($$iterator$129,'Element',{t:Entry,a:{Key:{t:Integer},Item:{t:'i', l:[$$iterable.$$targs$$.Element,{t:Object$}]}}});
                                    $$iterator$129.iter$130_=$$indexes$127.orig$128.iterator();
                                    $$iterator$129.$prop$getIter$130={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$cont:iterator$129,d:['ceylon.language','Iterable','$at','indexed','$o','indexes','$m','iterator','$o','iterator','$at','iter']};}};
                                    $$iterator$129.$prop$getIter$130.get=function(){return iter$130};
                                    $$iterator$129.i$131_=(0);
                                    $$iterator$129.$prop$getI$131={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:iterator$129,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$at','indexed','$o','indexes','$m','iterator','$o','iterator','$at','i']};}};
                                    $$iterator$129.$prop$getI$131.get=function(){return i$131};
                                    return $$iterator$129;
                                };iterator$129.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterator,a:{Element:{t:Entry,a:{Key:{t:Integer},Item:{t:'i', l:['Element',{t:Object$}]}}}}}],d:['ceylon.language','Iterable','$at','indexed','$o','indexes','$m','iterator','$o','iterator']};};
                                function $init$iterator$129(){
                                    if (iterator$129.$$===undefined){
                                        initTypeProto(iterator$129,'ceylon.language::Iterable.indexed.indexes.iterator.iterator',Basic,$init$Iterator());
                                        (function($$iterator$129){
                                            defineAttr($$iterator$129,'iter$130',function(){return this.iter$130_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$cont:iterator$129,d:['ceylon.language','Iterable','$at','indexed','$o','indexes','$m','iterator','$o','iterator','$at','iter']};});
                                            defineAttr($$iterator$129,'i$131',function(){return this.i$131_;},function(i$132){return this.i$131_=i$132;},function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:iterator$129,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$at','indexed','$o','indexes','$m','iterator','$o','iterator','$at','i']};});
                                            $$iterator$129.next=function next(){
                                                var $$iterator$129=this;
                                                var next$133=$$iterator$129.iter$130.next();
                                                function setNext$133(next$134){return next$133=next$134;};
                                                while((!exists(next$133))){
                                                    (oldi$135=$$iterator$129.i$131,$$iterator$129.i$131=oldi$135.successor,oldi$135);
                                                    var oldi$135;
                                                    next$133=$$iterator$129.iter$130.next();
                                                }
                                                //assert at Iterable.ceylon (480:24-480:48)
                                                var n$136;
                                                if (!((n$136=next$133)!==null)) {throw wrapexc(AssertionException("Assertion failed: \'exists n = next\' at Iterable.ceylon (480:31-480:47)"),'480:24-480:48','Iterable.ceylon'); }
                                                var n$137;
                                                if(!isOfType((n$137=n$136),{t:Finished})){
                                                    return Entry((oldi$138=$$iterator$129.i$131,$$iterator$129.i$131=oldi$138.successor,oldi$138),n$137,{Key:{t:Integer},Item:{t:'i', l:[$$iterable.$$targs$$.Element,{t:Object$}]}});
                                                    var oldi$138;
                                                }else {
                                                    return getFinished();
                                                }
                                            };$$iterator$129.next.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Entry,a:{Key:{t:Integer},Item:{t:'i', l:['Element',{t:Object$}]}}},{t:Finished}]},$ps:[],$cont:iterator$129,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$at','indexed','$o','indexes','$m','iterator','$o','iterator','$m','next']};};
                                        })(iterator$129.$$.prototype);
                                    }
                                    return iterator$129;
                                }
                                $init$iterator$129();
                                var iterator$139;
                                function getIterator$139(){
                                    if (iterator$139===undefined){iterator$139=$init$iterator$129()({Element:{t:Entry,a:{Key:{t:Integer},Item:{t:'i', l:[$$iterable.$$targs$$.Element,{t:Object$}]}}}});iterator$139.$$metamodel$$=getIterator$139.$$metamodel$$;}
                                    return iterator$139;
                                }
                                getIterator$139.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterator$129},d:['ceylon.language','Iterable','$at','indexed','$o','indexes','$m','iterator','$o','iterator']};};
                                $prop$getIterator$139={get:getIterator$139,$$metamodel$$:getIterator$139.$$metamodel$$};
                                return getIterator$139();
                            };$$indexes$127.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:{t:Entry,a:{Key:{t:Integer},Item:{t:'i', l:['Element',{t:Object$}]}}}}},$ps:[],$cont:indexes$127,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$at','indexed','$o','indexes','$m','iterator']};};
                        })(indexes$127.$$.prototype);
                    }
                    return indexes$127;
                }
                $init$indexes$127();
                var indexes$140;
                function getIndexes$140(){
                    if (indexes$140===undefined){indexes$140=$init$indexes$127()({Absent:{t:Null},Element:{t:Entry,a:{Key:{t:Integer},Item:{t:'i', l:[$$iterable.$$targs$$.Element,{t:Object$}]}}}});indexes$140.$$metamodel$$=getIndexes$140.$$metamodel$$;}
                    return indexes$140;
                }
                getIndexes$140.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:indexes$127},d:['ceylon.language','Iterable','$at','indexed','$o','indexes']};};
                $prop$getIndexes$140={get:getIndexes$140,$$metamodel$$:getIndexes$140.$$metamodel$$};
                return getIndexes$140();
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Entry,a:{Key:{t:Integer},Item:{t:'i', l:['Element',{t:Object$}]}}}}},$cont:Iterable,$an:function(){return[doc(String$("All entries of form `index->element` where `index` \nis the position at which `element` occurs, for every\nnon-null element of this `Iterable`, ordered by\nincreasing `index`. For a null element at a given\nposition in the original `Iterable`, there is no \nentry with the corresponding index in the resulting \niterable object. The expression \n\n    { \"hello\", null, \"world\" }.indexed\n    \nresults in an iterable object with the entries\n`0->\"hello\"` and `2->\"world\"`.",461)),shared(),$default()];},d:['ceylon.language','Iterable','$at','indexed']};});$$iterable.following=function following(head$141,$$$mptypes){
                var $$iterable=this;
                function cons$142($$targs$$){
                    var $$cons$142=new cons$142.$$;
                    $$cons$142.$$targs$$=$$targs$$;
                    Iterable({Absent:{t:Nothing},Element:{t:'u', l:[$$iterable.$$targs$$.Element,$$$mptypes.Other]}},$$cons$142);
                    return $$cons$142;
                };cons$142.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterable,a:{Absent:{t:Nothing},Element:{t:'u', l:['Element','Other']}}}],d:['ceylon.language','Iterable','$m','following','$o','cons']};};
                function $init$cons$142(){
                    if (cons$142.$$===undefined){
                        initTypeProto(cons$142,'ceylon.language::Iterable.following.cons',Basic,$init$Iterable());
                        (function($$cons$142){
                            $$cons$142.iterator=function iterator(){
                                var $$cons$142=this;
                                var iter$143=$$iterable.iterator();
                                function iterator$144($$targs$$){
                                    var $$iterator$144=new iterator$144.$$;
                                    $$iterator$144.$$targs$$=$$targs$$;
                                    Iterator({Element:{t:'u', l:[$$iterable.$$targs$$.Element,$$$mptypes.Other]}},$$iterator$144);
                                    $$iterator$144.first$145_=true;
                                    $$iterator$144.$prop$getFirst$145={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:iterator$144,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$m','following','$o','cons','$m','iterator','$o','iterator','$at','first']};}};
                                    $$iterator$144.$prop$getFirst$145.get=function(){return first$145};
                                    return $$iterator$144;
                                };iterator$144.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterator,a:{Element:{t:'u', l:['Element','Other']}}}],d:['ceylon.language','Iterable','$m','following','$o','cons','$m','iterator','$o','iterator']};};
                                function $init$iterator$144(){
                                    if (iterator$144.$$===undefined){
                                        initTypeProto(iterator$144,'ceylon.language::Iterable.following.cons.iterator.iterator',Basic,$init$Iterator());
                                        (function($$iterator$144){
                                            defineAttr($$iterator$144,'first$145',function(){return this.first$145_;},function(first$146){return this.first$145_=first$146;},function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:iterator$144,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$m','following','$o','cons','$m','iterator','$o','iterator','$at','first']};});
                                            $$iterator$144.next=function next(){
                                                var $$iterator$144=this;
                                                if($$iterator$144.first$145){
                                                    $$iterator$144.first$145=false;
                                                    return head$141;
                                                }else {
                                                    return iter$143.next();
                                                }
                                            };$$iterator$144.next.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element','Other',{t:Finished}]},$ps:[],$cont:iterator$144,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$m','following','$o','cons','$m','iterator','$o','iterator','$m','next']};};
                                        })(iterator$144.$$.prototype);
                                    }
                                    return iterator$144;
                                }
                                $init$iterator$144();
                                var iterator$147;
                                function getIterator$147(){
                                    if (iterator$147===undefined){iterator$147=$init$iterator$144()({Element:{t:'u', l:[$$iterable.$$targs$$.Element,$$$mptypes.Other]}});iterator$147.$$metamodel$$=getIterator$147.$$metamodel$$;}
                                    return iterator$147;
                                }
                                getIterator$147.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterator$144},d:['ceylon.language','Iterable','$m','following','$o','cons','$m','iterator','$o','iterator']};};
                                $prop$getIterator$147={get:getIterator$147,$$metamodel$$:getIterator$147.$$metamodel$$};
                                return getIterator$147();
                            };$$cons$142.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:{t:'u', l:['Element','Other']}}},$ps:[],$cont:cons$142,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$m','following','$o','cons','$m','iterator']};};
                        })(cons$142.$$.prototype);
                    }
                    return cons$142;
                }
                $init$cons$142();
                var cons$148;
                function getCons$148(){
                    if (cons$148===undefined){cons$148=$init$cons$142()({Absent:{t:Nothing},Element:{t:'u', l:[$$iterable.$$targs$$.Element,$$$mptypes.Other]}});cons$148.$$metamodel$$=getCons$148.$$metamodel$$;}
                    return cons$148;
                }
                getCons$148.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:cons$142},d:['ceylon.language','Iterable','$m','following','$o','cons']};};
                $prop$getCons$148={get:getCons$148,$$metamodel$$:getCons$148.$$metamodel$$};
                return getCons$148();
            };$$iterable.following.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Nothing},Element:{t:'u', l:['Element','Other']}}},$ps:[{$nm:'head',$mt:'prm',$t:'Other',$an:function(){return[];}}],$cont:Iterable,$tp:{Other:{}},$an:function(){return[doc(String$("An `Iterable` with the given inital element followed \nby the elements of this iterable object.",94)),shared(),$default()];},d:['ceylon.language','Iterable','$m','following']};};
            $$iterable.chain=function chain(other$149,$$$mptypes){
                var $$iterable=this;
                function chained$150($$targs$$){
                    var $$chained$150=new chained$150.$$;
                    $$chained$150.$$targs$$=$$targs$$;
                    Iterable({Absent:{t:'i', l:[$$iterable.$$targs$$.Absent,$$$mptypes.OtherAbsent]},Element:{t:'u', l:[$$iterable.$$targs$$.Element,$$$mptypes.Other]}},$$chained$150);
                    return $$chained$150;
                };chained$150.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterable,a:{Absent:{t:'i', l:['Absent','OtherAbsent']},Element:{t:'u', l:['Element','Other']}}}],d:['ceylon.language','Iterable','$m','chain','$o','chained']};};
                function $init$chained$150(){
                    if (chained$150.$$===undefined){
                        initTypeProto(chained$150,'ceylon.language::Iterable.chain.chained',Basic,$init$Iterable());
                        (function($$chained$150){
                            $$chained$150.iterator=function (){
                                var $$chained$150=this;
                                return ChainedIterator($$iterable,other$149,{Other:$$$mptypes.Other,Element:$$iterable.$$targs$$.Element});
                            };
                            $$chained$150.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:{t:'u', l:['Element','Other']}}},$ps:[],$cont:chained$150,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$m','chain','$o','chained','$m','iterator']};};
                        })(chained$150.$$.prototype);
                    }
                    return chained$150;
                }
                $init$chained$150();
                var chained$151;
                function getChained$151(){
                    if (chained$151===undefined){chained$151=$init$chained$150()({Absent:{t:'i', l:[$$iterable.$$targs$$.Absent,$$$mptypes.OtherAbsent]},Element:{t:'u', l:[$$iterable.$$targs$$.Element,$$$mptypes.Other]}});chained$151.$$metamodel$$=getChained$151.$$metamodel$$;}
                    return chained$151;
                }
                getChained$151.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:chained$150},d:['ceylon.language','Iterable','$m','chain','$o','chained']};};
                $prop$getChained$151={get:getChained$151,$$metamodel$$:getChained$151.$$metamodel$$};
                return getChained$151();
            };$$iterable.chain.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:'i', l:['Absent','OtherAbsent']},Element:{t:'u', l:['Element','Other']}}},$ps:[{$nm:'other',$mt:'prm',$t:{t:Iterable,a:{Absent:'OtherAbsent',Element:'Other'}},$an:function(){return[];}}],$cont:Iterable,$tp:{Other:{},OtherAbsent:{'satisfies':[{t:Null}]}},$an:function(){return[doc(String$("The elements of this iterable object, in their\noriginal order, followed by the elements of the \ngiven iterable object also in their original order.",147)),shared(),$default()];},d:['ceylon.language','Iterable','$m','chain']};};
            $$iterable.defaultNullElements=function (defaultValue$152,$$$mptypes){
                var $$iterable=this;
                return Comprehension(function(){
                    var it$153=$$iterable.iterator();
                    var elem$154=getFinished();
                    var next$elem$154=function(){return elem$154=it$153.next();}
                    next$elem$154();
                    return function(){
                        if(elem$154!==getFinished()){
                            var elem$154$155=elem$154;
                            var tmpvar$156=(opt$157=elem$154$155,opt$157!==null?opt$157:defaultValue$152);
                            next$elem$154();
                            return tmpvar$156;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:{t:'u', l:[$$$mptypes.Default,{t:'i', l:[$$iterable.$$targs$$.Element,{t:Object$}]}]}});
            };
            $$iterable.defaultNullElements.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:'Absent',Element:{t:'u', l:[{t:'i', l:['Element',{t:Object$}]},'Default']}}},$ps:[{$nm:'defaultValue',$mt:'prm',$t:'Default',$an:function(){return[doc("A default value that replaces `null` elements.")];}}],$cont:Iterable,$tp:{Default:{}},$an:function(){return[doc(String$("An `Iterable` that produces the elements of this \niterable object, replacing every `null` element \nwith the given default value. The resulting iterable\nobject does not produce the value `null`.",193)),shared(),$default()];},d:['ceylon.language','Iterable','$m','defaultNullElements']};};
            defineAttr($$iterable,'string',function(){
                var $$iterable=this;
                if($$iterable.empty){
                    return String$("{}",2);
                }else {
                    var list$158=commaList($$iterable.taking((30)));
                    $prop$getList$158={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Iterable','$at','string','$at','list']};}};
                    $prop$getList$158.get=function(){return list$158};
                    return StringBuilder().appendAll([String$("{ ",2),(opt$159=($$iterable.longerThan((30))?list$158.plus(String$(", ...",5)):null),opt$159!==null?opt$159:list$158).string,String$(" }",2)]).string;
                    var opt$159;
                }
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Iterable,$an:function(){return[doc(String$("A string of form `\"{ x, y, z }\"` where `x`, `y`, \nand `z` are the `string` representations of the \nelements of this collection, as produced by the\niterator of the collection, or the string `\"{}\"` \nif this iterable is empty. If the number of items\nis very large only a certain amount of them might\nbe shown followed by \"...\".",324)),shared(),actual(),$default()];},d:['ceylon.language','Iterable','$at','string']};});defineAttr($$iterable,'cycled',function(){
                var $$iterable=this;
                function iterable$160($$targs$$){
                    var $$iterable$160=new iterable$160.$$;
                    $$iterable$160.$$targs$$=$$targs$$;
                    Iterable({Absent:$$iterable.$$targs$$.Absent,Element:$$iterable.$$targs$$.Element},$$iterable$160);
                    $$iterable$160.$prop$getOrig$161={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:'Absent',Element:'Element'}},$cont:iterable$160,d:['ceylon.language','Iterable','$at','cycled','$o','iterable','$at','orig']};}};
                    $$iterable$160.$prop$getOrig$161.get=function(){return orig$161};
                    return $$iterable$160;
                };iterable$160.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterable,a:{Absent:'Absent',Element:'Element'}}],d:['ceylon.language','Iterable','$at','cycled','$o','iterable']};};
                function $init$iterable$160(){
                    if (iterable$160.$$===undefined){
                        initTypeProto(iterable$160,'ceylon.language::Iterable.cycled.iterable',Basic,$init$Iterable());
                        (function($$iterable$160){
                            defineAttr($$iterable$160,'orig$161',function(){
                                var $$iterable$160=this;
                                return $$iterable;
                            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:'Absent',Element:'Element'}},$cont:iterable$160,d:['ceylon.language','Iterable','$at','cycled','$o','iterable','$at','orig']};});
                            $$iterable$160.iterator=function iterator(){
                                var $$iterable$160=this;
                                function iterator$162($$targs$$){
                                    var $$iterator$162=new iterator$162.$$;
                                    $$iterator$162.$$targs$$=$$targs$$;
                                    Iterator({Element:$$iterable.$$targs$$.Element},$$iterator$162);
                                    $$iterator$162.iter$163_=getEmptyIterator();
                                    $$iterator$162.$prop$getIter$163={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$cont:iterator$162,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$at','cycled','$o','iterable','$m','iterator','$o','iterator','$at','iter']};}};
                                    $$iterator$162.$prop$getIter$163.get=function(){return iter$163};
                                    return $$iterator$162;
                                };iterator$162.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterator,a:{Element:'Element'}}],d:['ceylon.language','Iterable','$at','cycled','$o','iterable','$m','iterator','$o','iterator']};};
                                function $init$iterator$162(){
                                    if (iterator$162.$$===undefined){
                                        initTypeProto(iterator$162,'ceylon.language::Iterable.cycled.iterable.iterator.iterator',Basic,$init$Iterator());
                                        (function($$iterator$162){
                                            defineAttr($$iterator$162,'iter$163',function(){return this.iter$163_;},function(iter$164){return this.iter$163_=iter$164;},function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$cont:iterator$162,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$at','cycled','$o','iterable','$m','iterator','$o','iterator','$at','iter']};});
                                            $$iterator$162.next=function next(){
                                                var $$iterator$162=this;
                                                var next$165;
                                                if(!isOfType((next$165=$$iterator$162.iter$163.next()),{t:Finished})){
                                                    return next$165;
                                                }else {
                                                    $$iterator$162.iter$163=$$iterable$160.orig$161.iterator();
                                                    return $$iterator$162.iter$163.next();
                                                }
                                            };$$iterator$162.next.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$ps:[],$cont:iterator$162,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$at','cycled','$o','iterable','$m','iterator','$o','iterator','$m','next']};};
                                        })(iterator$162.$$.prototype);
                                    }
                                    return iterator$162;
                                }
                                $init$iterator$162();
                                var iterator$166;
                                function getIterator$166(){
                                    if (iterator$166===undefined){iterator$166=$init$iterator$162()({Element:$$iterable.$$targs$$.Element});iterator$166.$$metamodel$$=getIterator$166.$$metamodel$$;}
                                    return iterator$166;
                                }
                                getIterator$166.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterator$162},d:['ceylon.language','Iterable','$at','cycled','$o','iterable','$m','iterator','$o','iterator']};};
                                $prop$getIterator$166={get:getIterator$166,$$metamodel$$:getIterator$166.$$metamodel$$};
                                return getIterator$166();
                            };$$iterable$160.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$ps:[],$cont:iterable$160,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$at','cycled','$o','iterable','$m','iterator']};};
                        })(iterable$160.$$.prototype);
                    }
                    return iterable$160;
                }
                $init$iterable$160();
                var iterable$167;
                function getIterable$167(){
                    if (iterable$167===undefined){iterable$167=$init$iterable$160()({Absent:$$iterable.$$targs$$.Absent,Element:$$iterable.$$targs$$.Element});iterable$167.$$metamodel$$=getIterable$167.$$metamodel$$;}
                    return iterable$167;
                }
                getIterable$167.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterable$160},d:['ceylon.language','Iterable','$at','cycled','$o','iterable']};};
                $prop$getIterable$167={get:getIterable$167,$$metamodel$$:getIterable$167.$$metamodel$$};
                return getIterable$167();
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:'Absent',Element:'Element'}},$cont:Iterable,$an:function(){return[doc(String$("A non-finite iterable object that produces the elements \nof this iterable object, repeatedly.",93)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Iterable().$$.prototype.cycle)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Iterable','$at','cycled']};});$$iterable.cycle=function cycle(times$168){
                var $$iterable=this;
                function iterable$169($$targs$$){
                    var $$iterable$169=new iterable$169.$$;
                    $$iterable$169.$$targs$$=$$targs$$;
                    Iterable({Absent:$$iterable.$$targs$$.Absent,Element:$$iterable.$$targs$$.Element},$$iterable$169);
                    $$iterable$169.$prop$getOrig$170={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:'Absent',Element:'Element'}},$cont:iterable$169,d:['ceylon.language','Iterable','$m','cycle','$o','iterable','$at','orig']};}};
                    $$iterable$169.$prop$getOrig$170.get=function(){return orig$170};
                    return $$iterable$169;
                };iterable$169.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterable,a:{Absent:'Absent',Element:'Element'}}],d:['ceylon.language','Iterable','$m','cycle','$o','iterable']};};
                function $init$iterable$169(){
                    if (iterable$169.$$===undefined){
                        initTypeProto(iterable$169,'ceylon.language::Iterable.cycle.iterable',Basic,$init$Iterable());
                        (function($$iterable$169){
                            defineAttr($$iterable$169,'orig$170',function(){
                                var $$iterable$169=this;
                                return $$iterable;
                            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:'Absent',Element:'Element'}},$cont:iterable$169,d:['ceylon.language','Iterable','$m','cycle','$o','iterable','$at','orig']};});
                            $$iterable$169.iterator=function iterator(){
                                var $$iterable$169=this;
                                function iterator$171($$targs$$){
                                    var $$iterator$171=new iterator$171.$$;
                                    $$iterator$171.$$targs$$=$$targs$$;
                                    Iterator({Element:$$iterable.$$targs$$.Element},$$iterator$171);
                                    $$iterator$171.iter$172_=getEmptyIterator();
                                    $$iterator$171.$prop$getIter$172={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$cont:iterator$171,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$m','cycle','$o','iterable','$m','iterator','$o','iterator','$at','iter']};}};
                                    $$iterator$171.$prop$getIter$172.get=function(){return iter$172};
                                    $$iterator$171.count$173_=(0);
                                    $$iterator$171.$prop$getCount$173={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:iterator$171,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$m','cycle','$o','iterable','$m','iterator','$o','iterator','$at','count']};}};
                                    $$iterator$171.$prop$getCount$173.get=function(){return count$173};
                                    return $$iterator$171;
                                };iterator$171.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterator,a:{Element:'Element'}}],d:['ceylon.language','Iterable','$m','cycle','$o','iterable','$m','iterator','$o','iterator']};};
                                function $init$iterator$171(){
                                    if (iterator$171.$$===undefined){
                                        initTypeProto(iterator$171,'ceylon.language::Iterable.cycle.iterable.iterator.iterator',Basic,$init$Iterator());
                                        (function($$iterator$171){
                                            defineAttr($$iterator$171,'iter$172',function(){return this.iter$172_;},function(iter$174){return this.iter$172_=iter$174;},function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$cont:iterator$171,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$m','cycle','$o','iterable','$m','iterator','$o','iterator','$at','iter']};});
                                            defineAttr($$iterator$171,'count$173',function(){return this.count$173_;},function(count$175){return this.count$173_=count$175;},function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:iterator$171,$an:function(){return[variable()];},d:['ceylon.language','Iterable','$m','cycle','$o','iterable','$m','iterator','$o','iterator','$at','count']};});
                                            $$iterator$171.next=function next(){
                                                var $$iterator$171=this;
                                                var next$176;
                                                if(!isOfType((next$176=$$iterator$171.iter$172.next()),{t:Finished})){
                                                    return next$176;
                                                }else {
                                                    if($$iterator$171.count$173.compare(times$168).equals(getSmaller())){
                                                        (oldcount$177=$$iterator$171.count$173,$$iterator$171.count$173=oldcount$177.successor,oldcount$177);
                                                        var oldcount$177;
                                                        $$iterator$171.iter$172=$$iterable$169.orig$170.iterator();
                                                    }else {
                                                        $$iterator$171.iter$172=getEmptyIterator();
                                                    }
                                                    return $$iterator$171.iter$172.next();
                                                }
                                            };$$iterator$171.next.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$ps:[],$cont:iterator$171,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$m','cycle','$o','iterable','$m','iterator','$o','iterator','$m','next']};};
                                        })(iterator$171.$$.prototype);
                                    }
                                    return iterator$171;
                                }
                                $init$iterator$171();
                                var iterator$178;
                                function getIterator$178(){
                                    if (iterator$178===undefined){iterator$178=$init$iterator$171()({Element:$$iterable.$$targs$$.Element});iterator$178.$$metamodel$$=getIterator$178.$$metamodel$$;}
                                    return iterator$178;
                                }
                                getIterator$178.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterator$171},d:['ceylon.language','Iterable','$m','cycle','$o','iterable','$m','iterator','$o','iterator']};};
                                $prop$getIterator$178={get:getIterator$178,$$metamodel$$:getIterator$178.$$metamodel$$};
                                return getIterator$178();
                            };$$iterable$169.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$ps:[],$cont:iterable$169,$an:function(){return[shared(),actual()];},d:['ceylon.language','Iterable','$m','cycle','$o','iterable','$m','iterator']};};
                        })(iterable$169.$$.prototype);
                    }
                    return iterable$169;
                }
                $init$iterable$169();
                var iterable$179;
                function getIterable$179(){
                    if (iterable$179===undefined){iterable$179=$init$iterable$169()({Absent:$$iterable.$$targs$$.Absent,Element:$$iterable.$$targs$$.Element});iterable$179.$$metamodel$$=getIterable$179.$$metamodel$$;}
                    return iterable$179;
                }
                getIterable$179.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterable$169},d:['ceylon.language','Iterable','$m','cycle','$o','iterable']};};
                $prop$getIterable$179={get:getIterable$179,$$metamodel$$:getIterable$179.$$metamodel$$};
                return getIterable$179();
            };$$iterable.cycle.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:'Absent',Element:'Element'}},$ps:[{$nm:'times',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Iterable,$an:function(){return[doc(String$("A finite iterable object that produces the elements of \nthis iterable object, repeatedly, the given number of\ntimes.",116)),see([$init$OpenValue()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Iterable().$$.prototype.$prop$getCycled),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Iterable().$$.prototype.repeat)].reifyCeylonType({Absent:{t:Null},Element:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration}]}})),shared(),$default()];},d:['ceylon.language','Iterable','$m','cycle']};};
            $$iterable.repeat=function repeat(times$180){
                var $$iterable=this;
                var sb$181=SequenceBuilder({Element:$$iterable.$$targs$$.Element});
                var count$182=(0);
                function setCount$182(count$183){return count$182=count$183;};
                while((oldcount$184=count$182,count$182=oldcount$184.successor,oldcount$184).compare(times$180).equals(getSmaller())){
                    sb$181.appendAll($$iterable);
                }
                var oldcount$184;
                return sb$181.sequence;
            };$$iterable.repeat.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$ps:[{$nm:'times',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Iterable,$an:function(){return[doc(String$("Returns a list formed by repeating the elements of this\niterable object the given number of times, or an empty \nlist if `times<=0`. An eager counterpart to `cycle()`.",166)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Iterable().$$.prototype.cycle)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Iterable','$m','repeat']};};
        })(Iterable.$$.prototype);
    }
    return Iterable;
}
exports.$init$Iterable=$init$Iterable;
$init$Iterable();
var opt$18,opt$157;
var commaList=function (elements$185){
    return (strings$186=Comprehension(function(){
        var it$187=elements$185.iterator();
        var element$188=getFinished();
        var next$element$188=function(){return element$188=it$187.next();}
        next$element$188();
        return function(){
            if(element$188!==getFinished()){
                var element$188$189=element$188;
                var tmpvar$190=(opt$191=(opt$192=element$188$189,opt$192!==null?opt$192.string:null),opt$191!==null?opt$191:String$("null",4));
                next$element$188();
                return tmpvar$190;
            }
            return getFinished();
        }
    },{Absent:{t:Null},Element:{t:String$}}),(opt$193=String$(", ",2),JsCallable(opt$193,opt$193!==null?opt$193.join:null))(strings$186));
};
commaList.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:String$},$ps:[{$nm:'elements',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Anything}}},$an:function(){return[];}}],d:['ceylon.language','commaList']};};
var strings$186,opt$191,opt$192,opt$193;
function ifExists(predicate$194){
    return function(val$195){
        var val$196;
        if((val$196=val$195)!==null){
            return predicate$194(val$196);
        }else {
            return false;
        }
    }
};ifExists.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'predicate',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],d:['ceylon.language','ifExists']};};
function Sequential($$targs$$,$$sequential){
    List($$sequential.$$targs$$===undefined?$$targs$$:{Element:$$sequential.$$targs$$.Element},$$sequential);
    Ranged($$sequential.$$targs$$===undefined?$$targs$$:{Index:{t:Integer},Span:{t:Sequential,a:{Element:$$sequential.$$targs$$.Element}}},$$sequential);
    add_type_arg($$sequential,'Index',{t:Integer});
    add_type_arg($$sequential,'Span',{t:Sequential,a:{Element:$$sequential.$$targs$$.Element}});
    Cloneable($$sequential.$$targs$$===undefined?$$targs$$:{Clone:{t:Sequential,a:{Element:$$sequential.$$targs$$.Element}}},$$sequential);
    add_type_arg($$sequential,'Clone',{t:Sequential,a:{Element:$$sequential.$$targs$$.Element}});
    set_type_args($$sequential,$$targs$$);
    $$sequential.$prop$getSequence={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$cont:Sequential,$an:function(){return[doc(String$("This sequence.",14)),shared(),actual(),$default()];},d:['ceylon.language','Sequential','$at','sequence']};}};
    $$sequential.$prop$getSequence.get=function(){return sequence};
    $$sequential.$prop$getClone={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$cont:Sequential,$an:function(){return[doc(String$("This sequence.",14)),shared(),actual(),$default()];},d:['ceylon.language','Sequential','$at','clone']};}};
    $$sequential.$prop$getClone.get=function(){return clone};
    $$sequential.$prop$getString={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Sequential,$an:function(){return[doc(String$("A string of form `\"[ x, y, z ]\"` where `x`, `y`, \nand `z` are the `string` representations of the \nelements of this collection, as produced by the\niterator of the collection, or the string `\"{}\"` \nif this collection is empty. If the collection \niterator produces the value `null`, the string\nrepresentation contains the string `\"null\"`.",336)),shared(),actual(),$default()];},d:['ceylon.language','Sequential','$at','string']};}};
    $$sequential.$prop$getString.get=function(){return string};
}
Sequential.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Element:{'var':'out'}},satisfies:[{t:List,a:{Element:'Element'}},{t:Ranged,a:{Index:{t:Integer},Span:{t:Sequential,a:{Element:'Element'}}}},{t:Cloneable,a:{Clone:{t:Sequential,a:{Element:'Element'}}}}],of:[{t:Empty},{t:Sequence,a:{Element:'Element'}}],$an:function(){return[doc(String$("A possibly-empty, immutable sequence of values. The \ntype `Sequential<Element>` may be abbreviated \n`[Element*]` or `Element[]`. \n\n`Sequential` has two enumerated subtypes:\n\n- `Empty`, abbreviated `[]`, represents an empty \n   sequence, and\n- `Sequence<Element>`, abbreviated `[Element+]` \n   represents a non-empty sequence, and has the very\n   important subclass `Tuple`.",373)),see([$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Tuple)].reifyCeylonType({Absent:{t:Null},Element:{t:ClassDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','Sequential']};};
exports.Sequential=Sequential;
function $init$Sequential(){
    if (Sequential.$$===undefined){
        initTypeProtoI(Sequential,'ceylon.language::Sequential',$init$List(),$init$Ranged(),$init$Cloneable());
        (function($$sequential){
            $$sequential.$prop$getReversed={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$cont:Sequential,$an:function(){return[doc(String$("Reverse this sequence, returning a new sequence.",48)),shared(),actual(),formal()];},d:['ceylon.language','Sequential','$at','reversed']};}};
            defineAttr($$sequential,'sequence',function(){
                var $$sequential=this;
                return $$sequential;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$cont:Sequential,$an:function(){return[doc(String$("This sequence.",14)),shared(),actual(),$default()];},d:['ceylon.language','Sequential','$at','sequence']};});
            $$sequential.$prop$getRest={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$cont:Sequential,$an:function(){return[doc(String$("The rest of the sequence, without the first \nelement.",53)),shared(),actual(),formal()];},d:['ceylon.language','Sequential','$at','rest']};}};
            $$sequential.repeat=function (times$197){
                var $$sequential=this;
                return $$sequential.cycle(times$197).sequence;
            };
            $$sequential.repeat.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$ps:[{$nm:'times',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Sequential,$an:function(){return[doc(String$("Returns a sequence formed by repeating the elements of \nthis sequence the given number of times, or an empty \nsequence if `times<=0`.",133)),shared(),actual(),$default()];},d:['ceylon.language','Sequential','$m','repeat']};};
            $$sequential.initial=function (length$198){
                var $$sequential=this;
                return $$sequential.segment((0),length$198);
            };
            $$sequential.initial.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$ps:[{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Sequential,$an:function(){return[doc(String$("Select the first elements of this sequence, returning \na sequence no longer than the given length. If this \nsequence is shorter than the given length, return this \nsequence. Otherwise return a sequence of the given \nlength.",223)),shared(),actual(),$default()];},d:['ceylon.language','Sequential','$m','initial']};};
            $$sequential.terminal=function terminal(length$199){
                var $$sequential=this;
                var l$200;
                if((l$200=$$sequential.lastIndex)!==null&&length$199.compare((0)).equals(getLarger())){
                    return $$sequential.span(l$200.minus(length$199).plus((1)),l$200);
                }else {
                    return getEmpty();
                }
            };$$sequential.terminal.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$ps:[{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Sequential,$an:function(){return[doc(String$("Select the last elements of the sequence, returning a \nsequence no longer than the given length. If this \nsequence is shorter than the given length, return this \nsequence. Otherwise return a sequence of the given \nlength.",221)),shared(),actual(),$default()];},d:['ceylon.language','Sequential','$m','terminal']};};
            $$sequential.trim=function (trimming$201){
                var $$sequential=this;
                return $$sequential.getT$all()['ceylon.language::List'].$$.prototype.trim.call(this,$JsCallable(trimming$201,[{$nm:'elem',$mt:'prm',$t:'Element',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$sequential.$$targs$$.Element]},Return:{t:Boolean$}})).sequence;
            };
            $$sequential.trim.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$ps:[{$nm:'trimming',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Sequential,$an:function(){return[doc(String$("Trim the elements satisfying the given predicate\nfunction from the start and end of this sequence, \nreturning a sequence no longer than this sequence.",150)),shared(),actual(),$default()];},d:['ceylon.language','Sequential','$m','trim']};};
            $$sequential.trimLeading=function (trimming$202){
                var $$sequential=this;
                return $$sequential.getT$all()['ceylon.language::List'].$$.prototype.trimLeading.call(this,$JsCallable(trimming$202,[{$nm:'elem',$mt:'prm',$t:'Element',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$sequential.$$targs$$.Element]},Return:{t:Boolean$}})).sequence;
            };
            $$sequential.trimLeading.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$ps:[{$nm:'trimming',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Sequential,$an:function(){return[doc(String$("Trim the elements satisfying the given predicate\nfunction from the start of this sequence, returning \na sequence no longer than this sequence.",142)),shared(),actual(),$default()];},d:['ceylon.language','Sequential','$m','trimLeading']};};
            $$sequential.trimTrailing=function (trimming$203){
                var $$sequential=this;
                return $$sequential.getT$all()['ceylon.language::List'].$$.prototype.trimTrailing.call(this,$JsCallable(trimming$203,[{$nm:'elem',$mt:'prm',$t:'Element',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$sequential.$$targs$$.Element]},Return:{t:Boolean$}})).sequence;
            };
            $$sequential.trimTrailing.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$ps:[{$nm:'trimming',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Sequential,$an:function(){return[doc(String$("Trim the elements satisfying the given predicate\nfunction from the end of this sequence, returning \na sequence no longer than this sequence.",140)),shared(),actual(),$default()];},d:['ceylon.language','Sequential','$m','trimTrailing']};};
            defineAttr($$sequential,'clone',function(){
                var $$sequential=this;
                return $$sequential;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$cont:Sequential,$an:function(){return[doc(String$("This sequence.",14)),shared(),actual(),$default()];},d:['ceylon.language','Sequential','$at','clone']};});
            defineAttr($$sequential,'string',function(){
                var $$sequential=this;
                return (opt$204=($$sequential.empty?String$("[]",2):null),opt$204!==null?opt$204:StringBuilder().appendAll([String$("[",1),commaList($$sequential).string,String$("]",1)]).string);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Sequential,$an:function(){return[doc(String$("A string of form `\"[ x, y, z ]\"` where `x`, `y`, \nand `z` are the `string` representations of the \nelements of this collection, as produced by the\niterator of the collection, or the string `\"{}\"` \nif this collection is empty. If the collection \niterator produces the value `null`, the string\nrepresentation contains the string `\"null\"`.",336)),shared(),actual(),$default()];},d:['ceylon.language','Sequential','$at','string']};});
        })(Sequential.$$.prototype);
    }
    return Sequential;
}
exports.$init$Sequential=$init$Sequential;
$init$Sequential();
var opt$204;
function Sequence($$targs$$,$$sequence){
    Sequential($$sequence.$$targs$$===undefined?$$targs$$:{Element:$$sequence.$$targs$$.Element},$$sequence);
    Iterable($$sequence.$$targs$$===undefined?$$targs$$:{Absent:{t:Nothing},Element:$$sequence.$$targs$$.Element},$$sequence);
    Cloneable($$sequence.$$targs$$===undefined?$$targs$$:{Clone:{t:Sequence,a:{Element:$$sequence.$$targs$$.Element}}},$$sequence);
    add_type_arg($$sequence,'Clone',{t:Sequence,a:{Element:$$sequence.$$targs$$.Element}});
    set_type_args($$sequence,$$targs$$);
    $$sequence.$prop$getEmpty={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Sequence,$an:function(){return[doc(String$("Returns `false`, since every `Sequence` contains at\nleast one element.",70)),shared(),actual()];},d:['ceylon.language','Sequence','$at','empty']};}};
    $$sequence.$prop$getEmpty.get=function(){return empty};
    $$sequence.$prop$getSequence={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequence,a:{Element:'Element'}},$cont:Sequence,$an:function(){return[doc(String$("This nonempty sequence.",23)),shared(),$default(),actual()];},d:['ceylon.language','Sequence','$at','sequence']};}};
    $$sequence.$prop$getSequence.get=function(){return sequence};
    $$sequence.$prop$getClone={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequence,a:{Element:'Element'}},$cont:Sequence,$an:function(){return[doc(String$("This nonempty sequence.",23)),shared(),actual(),$default()];},d:['ceylon.language','Sequence','$at','clone']};}};
    $$sequence.$prop$getClone.get=function(){return clone};
    $$sequence.$prop$getString={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Sequence,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','Sequence','$at','string']};}};
    $$sequence.$prop$getString.get=function(){return string};
}
Sequence.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Element:{'var':'out'}},satisfies:[{t:Sequential,a:{Element:'Element'}},{t:Iterable,a:{Absent:{t:Nothing},Element:'Element'}},{t:Cloneable,a:{Clone:{t:Sequence,a:{Element:'Element'}}}}],$an:function(){return[doc(String$("A nonempty, immutable sequence of values. The type \n`Sequence<Element>`, may be abbreviated `[Element+]`.\n\nGiven a possibly-empty sequence of type `[Element*]`, \nthe `if (nonempty ...)` construct, or, alternatively,\nthe `assert (nonempty ...)` construct, may be used to \nnarrow to a nonempty sequence type:\n\n    [Integer*] nums = ... ;\n    if (nonempty nums) {\n        Integer first = nums.first;\n        Integer max = max(nums);\n        [Integer+] squares = nums.collect((Integer i) => i**2));\n        [Integer+] sorted = nums.sort(byIncreasing((Integer i) => i));\n    }\n\nOperations like `first`, `max()`, `collect()`, and \n`sort()`, which polymorphically produce a nonempty or \nnon-null output when given a nonempty input are called \n_emptiness-preserving_.",759)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Empty)].reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceDeclaration$meta$declaration}})),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','Sequence']};};
exports.Sequence=Sequence;
function $init$Sequence(){
    if (Sequence.$$===undefined){
        initTypeProtoI(Sequence,'ceylon.language::Sequence',$init$Sequential(),$init$Iterable(),$init$Cloneable());
        (function($$sequence){
            $$sequence.$prop$getLastIndex={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Sequence,$an:function(){return[doc(String$("The index of the last element of the sequence.",46)),see([$init$OpenValue()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Iterable().$$.prototype.$prop$getSize)].reifyCeylonType({Absent:{t:Null},Element:{t:ValueDeclaration$meta$declaration}})),shared(),actual(),formal()];},d:['ceylon.language','Sequence','$at','lastIndex']};}};
            $$sequence.$prop$getFirst={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Element',$cont:Sequence,$an:function(){return[doc(String$("The first element of the sequence, that is, the\nelement with index `0`.",71)),shared(),actual(),formal()];},d:['ceylon.language','Sequence','$at','first']};}};
            $$sequence.$prop$getLast={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Element',$cont:Sequence,$an:function(){return[doc(String$("The last element of the sequence, that is, the\nelement with index `sequence.lastIndex`.",87)),shared(),actual(),formal()];},d:['ceylon.language','Sequence','$at','last']};}};
            defineAttr($$sequence,'empty',function(){
                var $$sequence=this;
                return false;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Sequence,$an:function(){return[doc(String$("Returns `false`, since every `Sequence` contains at\nleast one element.",70)),shared(),actual()];},d:['ceylon.language','Sequence','$at','empty']};});
            $$sequence.$prop$getReversed={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequence,a:{Element:'Element'}},$cont:Sequence,$an:function(){return[doc(String$("Reverse this sequence, returning a new nonempty\nsequence.",57)),shared(),actual(),formal()];},d:['ceylon.language','Sequence','$at','reversed']};}};
            defineAttr($$sequence,'sequence',function(){
                var $$sequence=this;
                return $$sequence;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequence,a:{Element:'Element'}},$cont:Sequence,$an:function(){return[doc(String$("This nonempty sequence.",23)),shared(),$default(),actual()];},d:['ceylon.language','Sequence','$at','sequence']};});
            $$sequence.$prop$getRest={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$cont:Sequence,$an:function(){return[doc(String$("The rest of the sequence, without the first \nelement.",53)),shared(),actual(),formal()];},d:['ceylon.language','Sequence','$at','rest']};}};
            $$sequence.$sort=function $sort(comparing$205){
                var $$sequence=this;
                var s$206=internalSort($JsCallable(comparing$205,[{$nm:'x',$mt:'prm',$t:'Element',$an:function(){return[];}},{$nm:'y',$mt:'prm',$t:'Element',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$sequence.$$targs$$.Element,$$sequence.$$targs$$.Element]},Return:{t:Comparison}}),$$sequence,{Element:$$sequence.$$targs$$.Element});
                //assert at Sequence.ceylon (63:8-63:27)
                var s$207;
                if (!(nonempty((s$207=s$206)))) {throw wrapexc(AssertionException("Assertion failed: \'nonempty s\' at Sequence.ceylon (63:15-63:26)"),'63:8-63:27','Sequence.ceylon'); }
                return s$207;
            };$$sequence.$sort.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequence,a:{Element:'Element'}},$ps:[{$nm:'comparing',$mt:'prm',$pt:'f',$t:{t:Comparison},$an:function(){return[doc("The function comparing pairs of elements.")];}}],$cont:Sequence,$an:function(){return[doc(String$("A nonempty sequence containing the elements of this\ncontainer, sorted according to a function \nimposing a partial order upon the elements.",138)),shared(),$default(),actual()];},d:['ceylon.language','Sequence','$m','sort']};};
            $$sequence.collect=function collect(collecting$208,$$$mptypes){
                var $$sequence=this;
                var s$209=$$sequence.$map($JsCallable(collecting$208,[{$nm:'element',$mt:'prm',$t:'Element',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$sequence.$$targs$$.Element]},Return:$$$mptypes.Result}),{Result:$$$mptypes.Result}).sequence;
                //assert at Sequence.ceylon (74:8-74:27)
                var s$210;
                if (!(nonempty((s$210=s$209)))) {throw wrapexc(AssertionException("Assertion failed: \'nonempty s\' at Sequence.ceylon (74:15-74:26)"),'74:8-74:27','Sequence.ceylon'); }
                return s$210;
            };$$sequence.collect.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequence,a:{Element:'Result'}},$ps:[{$nm:'collecting',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[doc("The transformation applied to the elements.")];}}],$cont:Sequence,$tp:{Result:{}},$an:function(){return[doc(String$("A nonempty sequence containing the results of \napplying the given mapping to the elements of this\nsequence.",107)),shared(),$default(),actual()];},d:['ceylon.language','Sequence','$m','collect']};};
            defineAttr($$sequence,'clone',function(){
                var $$sequence=this;
                return $$sequence;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequence,a:{Element:'Element'}},$cont:Sequence,$an:function(){return[doc(String$("This nonempty sequence.",23)),shared(),actual(),$default()];},d:['ceylon.language','Sequence','$at','clone']};});
            defineAttr($$sequence,'string',function(){
                var $$sequence=this;
                return attrGetter($$sequence.getT$all()['ceylon.language::Sequential'],'string').call(this);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Sequence,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','Sequence','$at','string']};});
            $$sequence.shorterThan=function (length$211){
                var $$sequence=this;
                return $$sequence.getT$all()['ceylon.language::List'].$$.prototype.shorterThan.call(this,length$211);
            };
            $$sequence.shorterThan.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Sequence,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','Sequence','$m','shorterThan']};};
            $$sequence.longerThan=function (length$212){
                var $$sequence=this;
                return $$sequence.getT$all()['ceylon.language::List'].$$.prototype.longerThan.call(this,length$212);
            };
            $$sequence.longerThan.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Sequence,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','Sequence','$m','longerThan']};};
            $$sequence.findLast=function (selecting$213){
                var $$sequence=this;
                return $$sequence.getT$all()['ceylon.language::List'].$$.prototype.findLast.call(this,$JsCallable(selecting$213,[{$nm:'elem',$mt:'prm',$t:'Element',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$sequence.$$targs$$.Element]},Return:{t:Boolean$}}));
            };
            $$sequence.findLast.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Sequence,$an:function(){return[shared(),$default(),actual()];},d:['ceylon.language','Sequence','$m','findLast']};};
            $$sequence.repeat=function (times$214){
                var $$sequence=this;
                return $$sequence.getT$all()['ceylon.language::Sequential'].$$.prototype.repeat.call(this,times$214);
            };
            $$sequence.repeat.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$ps:[{$nm:'times',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Sequence,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','Sequence','$m','repeat']};};
        })(Sequence.$$.prototype);
    }
    return Sequence;
}
exports.$init$Sequence=$init$Sequence;
$init$Sequence();
function Empty($$empty){
    Sequential({Element:{t:Nothing}},$$empty);
    Ranged({Index:{t:Integer},Span:{t:Empty}},$$empty);
    add_type_arg($$empty,'Index',{t:Integer});
    add_type_arg($$empty,'Span',{t:Empty});
    Cloneable({Clone:{t:Empty}},$$empty);
    add_type_arg($$empty,'Clone',{t:Empty});
    $$empty.$prop$getEmpty={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Empty,$an:function(){return[doc(String$("Returns `true`.",15)),shared(),actual()];},d:['ceylon.language','Empty','$at','empty']};}};
    $$empty.$prop$getEmpty.get=function(){return empty};
    $$empty.$prop$getSize={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Empty,$an:function(){return[doc(String$("Returns 0.",10)),shared(),actual()];},d:['ceylon.language','Empty','$at','size']};}};
    $$empty.$prop$getSize.get=function(){return size};
    $$empty.$prop$getReversed={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty`.",19)),shared(),actual()];},d:['ceylon.language','Empty','$at','reversed']};}};
    $$empty.$prop$getReversed.get=function(){return reversed};
    $$empty.$prop$getSequence={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty`.",19)),shared(),actual()];},d:['ceylon.language','Empty','$at','sequence']};}};
    $$empty.$prop$getSequence.get=function(){return sequence};
    $$empty.$prop$getString={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Empty,$an:function(){return[doc(String$("Returns a string description of the empty sequence: \n`{}`.",58)),shared(),actual()];},d:['ceylon.language','Empty','$at','string']};}};
    $$empty.$prop$getString.get=function(){return string};
    $$empty.$prop$getLastIndex={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Null},$cont:Empty,$an:function(){return[doc(String$("Returns `null`.",15)),shared(),actual()];},d:['ceylon.language','Empty','$at','lastIndex']};}};
    $$empty.$prop$getLastIndex.get=function(){return lastIndex};
    $$empty.$prop$getFirst={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Null},$cont:Empty,$an:function(){return[doc(String$("Returns `null`.",15)),shared(),actual()];},d:['ceylon.language','Empty','$at','first']};}};
    $$empty.$prop$getFirst.get=function(){return first};
    $$empty.$prop$getLast={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Null},$cont:Empty,$an:function(){return[doc(String$("Returns `null`.",15)),shared(),actual()];},d:['ceylon.language','Empty','$at','last']};}};
    $$empty.$prop$getLast.get=function(){return last};
    $$empty.$prop$getRest={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty`.",19)),shared(),actual()];},d:['ceylon.language','Empty','$at','rest']};}};
    $$empty.$prop$getRest.get=function(){return rest};
    $$empty.$prop$getClone={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty`.",19)),shared(),actual()];},d:['ceylon.language','Empty','$at','clone']};}};
    $$empty.$prop$getClone.get=function(){return clone};
    $$empty.$prop$getCoalesced={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty`.",19)),shared(),actual()];},d:['ceylon.language','Empty','$at','coalesced']};}};
    $$empty.$prop$getCoalesced.get=function(){return coalesced};
    $$empty.$prop$getIndexed={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty`.",19)),shared(),actual()];},d:['ceylon.language','Empty','$at','indexed']};}};
    $$empty.$prop$getIndexed.get=function(){return indexed};
}
Empty.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:Sequential,a:{Element:{t:Nothing}}},{t:Ranged,a:{Index:{t:Integer},Span:{t:Empty}}},{t:Cloneable,a:{Clone:{t:Empty}}}],of:[{t:empty$215}],$an:function(){return[doc(String$("A sequence with no elements. The type `Empty` may be\nabbreviated `[]`, and an instance is produced by the \nexpression `[]`. That is, in the following expression,\n`e` has type `[]` and refers to the value `[]`:\n\n    [] none = [];\n\n(Whether the syntax `[]` refers to the type or the \nvalue depends upon how it occurs grammatically.)",330)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Sequence)].reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','Empty']};};
exports.Empty=Empty;
function $init$Empty(){
    if (Empty.$$===undefined){
        initTypeProtoI(Empty,'ceylon.language::Empty',$init$Sequential(),$init$Ranged(),$init$Cloneable());
        (function($$empty){
            $$empty.iterator=function (){
                var $$empty=this;
                return getEmptyIterator();
            };
            $$empty.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:{t:Nothing}}},$ps:[],$cont:Empty,$an:function(){return[doc(String$("Returns an iterator that is already exhausted.",46)),shared(),actual()];},d:['ceylon.language','Empty','$m','iterator']};};
            $$empty.$get=function (index$216){
                var $$empty=this;
                return null;
            };
            $$empty.$get.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Null},$ps:[{$nm:'index',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Empty,$an:function(){return[doc(String$("Returns `null` for any given index.",35)),shared(),actual()];},d:['ceylon.language','Empty','$m','get']};};
            $$empty.segment=function (from$217,length$218){
                var $$empty=this;
                return $$empty;
            };
            $$empty.segment.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'from',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty` for any given segment.",41)),shared(),actual()];},d:['ceylon.language','Empty','$m','segment']};};
            $$empty.span=function (from$219,to$220){
                var $$empty=this;
                return $$empty;
            };
            $$empty.span.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'from',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'to',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty` for any given span.",38)),shared(),actual()];},d:['ceylon.language','Empty','$m','span']};};
            $$empty.spanTo=function (to$221){
                var $$empty=this;
                return $$empty;
            };
            $$empty.spanTo.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'to',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty` for any given span.",38)),shared(),actual()];},d:['ceylon.language','Empty','$m','spanTo']};};
            $$empty.spanFrom=function (from$222){
                var $$empty=this;
                return $$empty;
            };
            $$empty.spanFrom.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'from',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty` for any given span.",38)),shared(),actual()];},d:['ceylon.language','Empty','$m','spanFrom']};};
            defineAttr($$empty,'empty',function(){
                var $$empty=this;
                return true;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Empty,$an:function(){return[doc(String$("Returns `true`.",15)),shared(),actual()];},d:['ceylon.language','Empty','$at','empty']};});
            defineAttr($$empty,'size',function(){
                var $$empty=this;
                return (0);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Empty,$an:function(){return[doc(String$("Returns 0.",10)),shared(),actual()];},d:['ceylon.language','Empty','$at','size']};});
            defineAttr($$empty,'reversed',function(){
                var $$empty=this;
                return $$empty;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty`.",19)),shared(),actual()];},d:['ceylon.language','Empty','$at','reversed']};});
            defineAttr($$empty,'sequence',function(){
                var $$empty=this;
                return $$empty;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty`.",19)),shared(),actual()];},d:['ceylon.language','Empty','$at','sequence']};});
            defineAttr($$empty,'string',function(){
                var $$empty=this;
                return String$("{}",2);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Empty,$an:function(){return[doc(String$("Returns a string description of the empty sequence: \n`{}`.",58)),shared(),actual()];},d:['ceylon.language','Empty','$at','string']};});
            defineAttr($$empty,'lastIndex',function(){
                var $$empty=this;
                return null;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Null},$cont:Empty,$an:function(){return[doc(String$("Returns `null`.",15)),shared(),actual()];},d:['ceylon.language','Empty','$at','lastIndex']};});
            defineAttr($$empty,'first',function(){
                var $$empty=this;
                return null;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Null},$cont:Empty,$an:function(){return[doc(String$("Returns `null`.",15)),shared(),actual()];},d:['ceylon.language','Empty','$at','first']};});
            defineAttr($$empty,'last',function(){
                var $$empty=this;
                return null;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Null},$cont:Empty,$an:function(){return[doc(String$("Returns `null`.",15)),shared(),actual()];},d:['ceylon.language','Empty','$at','last']};});
            defineAttr($$empty,'rest',function(){
                var $$empty=this;
                return $$empty;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty`.",19)),shared(),actual()];},d:['ceylon.language','Empty','$at','rest']};});
            defineAttr($$empty,'clone',function(){
                var $$empty=this;
                return $$empty;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty`.",19)),shared(),actual()];},d:['ceylon.language','Empty','$at','clone']};});
            defineAttr($$empty,'coalesced',function(){
                var $$empty=this;
                return $$empty;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty`.",19)),shared(),actual()];},d:['ceylon.language','Empty','$at','coalesced']};});
            defineAttr($$empty,'indexed',function(){
                var $$empty=this;
                return $$empty;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$cont:Empty,$an:function(){return[doc(String$("Returns an `Empty`.",19)),shared(),actual()];},d:['ceylon.language','Empty','$at','indexed']};});
            $$empty.chain=function (other$223,$$$mptypes){
                var $$empty=this;
                return other$223;
            };
            $$empty.chain.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:'OtherAbsent',Element:'Other'}},$ps:[{$nm:'other',$mt:'prm',$t:{t:Iterable,a:{Absent:'OtherAbsent',Element:'Other'}},$an:function(){return[];}}],$cont:Empty,$tp:{Other:{},OtherAbsent:{'satisfies':[{t:Null}]}},$an:function(){return[doc(String$("Returns `other`.",16)),shared(),actual()];},d:['ceylon.language','Empty','$m','chain']};};
            $$empty.contains=function (element$224){
                var $$empty=this;
                return false;
            };
            $$empty.contains.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'element',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Empty,$an:function(){return[doc(String$("Returns `false` for any given element.",38)),shared(),actual()];},d:['ceylon.language','Empty','$m','contains']};};
            $$empty.count=function (selecting$225){
                var $$empty=this;
                return (0);
            };
            $$empty.count.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Empty,$an:function(){return[doc(String$("Returns 0 for any given predicate.",34)),shared(),actual()];},d:['ceylon.language','Empty','$m','count']};};
            $$empty.defines=function (index$226){
                var $$empty=this;
                return false;
            };
            $$empty.defines.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'index',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Empty,$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','defines']};};
            $$empty.$map=function (collecting$227,$$$mptypes){
                var $$empty=this;
                return $$empty;
            };
            $$empty.$map.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'collecting',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[];}}],$cont:Empty,$tp:{Result:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','map']};};
            $$empty.$filter=function (selecting$228){
                var $$empty=this;
                return $$empty;
            };
            $$empty.$filter.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Empty,$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','filter']};};
            $$empty.fold=function (initial$229,accumulating$230,$$$mptypes){
                var $$empty=this;
                return initial$229;
            };
            $$empty.fold.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Result',$ps:[{$nm:'initial',$mt:'prm',$t:'Result',$an:function(){return[];}},{$nm:'accumulating',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[];}}],$cont:Empty,$tp:{Result:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','fold']};};
            $$empty.find=function (selecting$231){
                var $$empty=this;
                return null;
            };
            $$empty.find.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Null},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Empty,$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','find']};};
            $$empty.$sort=function (comparing$232){
                var $$empty=this;
                return $$empty;
            };
            $$empty.$sort.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'comparing',$mt:'prm',$pt:'f',$t:{t:Comparison},$an:function(){return[];}}],$cont:Empty,$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','sort']};};
            $$empty.collect=function (collecting$233,$$$mptypes){
                var $$empty=this;
                return $$empty;
            };
            $$empty.collect.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'collecting',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[];}}],$cont:Empty,$tp:{Result:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','collect']};};
            $$empty.select=function (selecting$234){
                var $$empty=this;
                return $$empty;
            };
            $$empty.select.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Empty,$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','select']};};
            $$empty.any=function (selecting$235){
                var $$empty=this;
                return false;
            };
            $$empty.any.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Empty,$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','any']};};
            $$empty.$every=function (selecting$236){
                var $$empty=this;
                return false;
            };
            $$empty.$every.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Empty,$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','every']};};
            $$empty.skipping=function (skip$237){
                var $$empty=this;
                return $$empty;
            };
            $$empty.skipping.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'skip',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Empty,$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','skipping']};};
            $$empty.taking=function (take$238){
                var $$empty=this;
                return $$empty;
            };
            $$empty.taking.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'take',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Empty,$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','taking']};};
            $$empty.by=function (step$239){
                var $$empty=this;
                return $$empty;
            };
            $$empty.by.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'step',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Empty,$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','by']};};
            $$empty.withLeading=function (element$240,$$$mptypes){
                var $$empty=this;
                return Tuple(element$240,getEmpty(),{Rest:{t:Empty},First:$$$mptypes.Element,Element:$$$mptypes.Element});
            };
            $$empty.withLeading.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'T',l:[{$t:'Element'}]},$ps:[{$nm:'element',$mt:'prm',$t:'Element',$an:function(){return[];}}],$cont:Empty,$tp:{Element:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','withLeading']};};
            $$empty.withTrailing=function (element$241,$$$mptypes){
                var $$empty=this;
                return Tuple(element$241,getEmpty(),{Rest:{t:Empty},First:$$$mptypes.Element,Element:$$$mptypes.Element});
            };
            $$empty.withTrailing.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'T',l:[{$t:'Element'}]},$ps:[{$nm:'element',$mt:'prm',$t:'Element',$an:function(){return[];}}],$cont:Empty,$tp:{Element:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','withTrailing']};};
            $$empty.following=function (head$242,$$$mptypes){
                var $$empty=this;
                return Singleton(head$242,{Element:$$$mptypes.Other});
            };
            $$empty.following.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Nothing},Element:'Other'}},$ps:[{$nm:'head',$mt:'prm',$t:'Other',$an:function(){return[];}}],$cont:Empty,$tp:{Other:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language','Empty','$m','following']};};
        })(Empty.$$.prototype);
    }
    return Empty;
}
exports.$init$Empty=$init$Empty;
$init$Empty();
function empty$215(){
    var $$empty=new empty$215.$$;
    Object$($$empty);
    Empty($$empty);
    return $$empty;
};empty$215.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Object$},satisfies:[{t:Empty}],$an:function(){return[doc("A sequence with no elements, abbreviated `[]`. The \nunique instance of the type `[]`."),shared()];},d:['ceylon.language','empty']};};
function $init$empty$215(){
    if (empty$215.$$===undefined){
        initTypeProto(empty$215,'ceylon.language::empty',$init$Object$(),$init$Empty());
    }
    return empty$215;
}
exports.$init$empty$215=$init$empty$215;
$init$empty$215();
var empty$243;
function getEmpty(){
    if (empty$243===undefined){empty$243=$init$empty$215()();empty$243.$$metamodel$$=getEmpty.$$metamodel$$;}
    return empty$243;
}
exports.getEmpty=getEmpty;
getEmpty.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:empty$215},$an:function(){return[doc(String$("A sequence with no elements, abbreviated `[]`. The \nunique instance of the type `[]`.",85)),shared()];},d:['ceylon.language','empty']};};
$prop$getEmpty={get:getEmpty,$$metamodel$$:getEmpty.$$metamodel$$};
exports.$prop$getEmpty=$prop$getEmpty;
function emptyIterator$244($$targs$$){
    var $$emptyIterator=new emptyIterator$244.$$;
    $$emptyIterator.$$targs$$=$$targs$$;
    Iterator({Element:{t:Nothing}},$$emptyIterator);
    return $$emptyIterator;
};emptyIterator$244.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterator,a:{Element:{t:Nothing}}}],$an:function(){return[doc("An iterator that returns no elements."),shared()];},d:['ceylon.language','emptyIterator']};};
function $init$emptyIterator$244(){
    if (emptyIterator$244.$$===undefined){
        initTypeProto(emptyIterator$244,'ceylon.language::emptyIterator',Basic,$init$Iterator());
        (function($$emptyIterator){
            $$emptyIterator.next=function (){
                var $$emptyIterator=this;
                return getFinished();
            };
        })(emptyIterator$244.$$.prototype);
    }
    return emptyIterator$244;
}
exports.$init$emptyIterator$244=$init$emptyIterator$244;
$init$emptyIterator$244();
var emptyIterator$245;
function getEmptyIterator(){
    if (emptyIterator$245===undefined){emptyIterator$245=$init$emptyIterator$244()({Element:{t:Nothing}});emptyIterator$245.$$metamodel$$=getEmptyIterator.$$metamodel$$;}
    return emptyIterator$245;
}
exports.getEmptyIterator=getEmptyIterator;
getEmptyIterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:emptyIterator$244},$an:function(){return[doc(String$("An iterator that returns no elements.",37)),shared()];},d:['ceylon.language','emptyIterator']};};
$prop$getEmptyIterator={get:getEmptyIterator,$$metamodel$$:getEmptyIterator.$$metamodel$$};
exports.$prop$getEmptyIterator=$prop$getEmptyIterator;
function Keys(correspondence$246, $$targs$$,$$keys){
    $init$Keys();
    if ($$keys===undefined)$$keys=new Keys.$$;
    set_type_args($$keys,$$targs$$);
    $$keys.correspondence$246_=correspondence$246;
    Category($$keys);
    return $$keys;
}
Keys.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[{$nm:'correspondence',$mt:'prm',$t:{t:Correspondence,a:{Key:'Key',Item:'Item'}},$an:function(){return[];}}],$tp:{Key:{'var':'in','satisfies':[{t:Object$}]},Item:{'var':'out'}},satisfies:[{t:Category}],d:['ceylon.language','Keys']};};
function $init$Keys(){
    if (Keys.$$===undefined){
        initTypeProto(Keys,'ceylon.language::Keys',Basic,$init$Category());
        (function($$keys){
            $$keys.contains=function contains(key$247){
                var $$keys=this;
                var key$248;
                if(isOfType((key$248=key$247),$$keys.$$targs$$.Key)){
                    return $$keys.correspondence$246.defines(key$248);
                }else {
                    return false;
                }
            };$$keys.contains.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'key',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Keys,$an:function(){return[shared(),actual()];},d:['ceylon.language','Keys','$m','contains']};};
            defineAttr($$keys,'correspondence$246',function(){return this.correspondence$246_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Correspondence,a:{Key:'Key',Item:'Item'}},$cont:Keys,d:['ceylon.language','Keys','$at','correspondence']};});
        })(Keys.$$.prototype);
    }
    return Keys;
}
exports.$init$Keys=$init$Keys;
$init$Keys();
function Correspondence($$targs$$,$$correspondence){
    set_type_args($$correspondence,$$targs$$);
    $$correspondence.$prop$getKeys={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Category},$cont:Correspondence,$an:function(){return[doc(String$("The `Category` of all keys for which a value is \ndefined by this `Correspondence`.",82)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Correspondence().$$.prototype.defines)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Correspondence','$at','keys']};}};
    $$correspondence.$prop$getKeys.get=function(){return keys};
}
Correspondence.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Key:{'var':'in','satisfies':[{t:Object$}]},Item:{'var':'out'}},$an:function(){return[doc(String$("Abstract supertype of objects which associate values \nwith keys. `Correspondence` does not satisfy `Category`,\nsince in some cases&mdash;`List`, for example&mdash;it is \nconvenient to consider the subtype a `Category` of its\nvalues, and in other cases&mdash;`Map`, for example&mdash;it \nis convenient to treat the subtype as a `Category` of its\nentries.\n\nThe item corresponding to a given key may be obtained \nfrom a `Correspondence` using the item operator:\n\n    value bg = settings[\"backgroundColor\"] else white;\n\nThe `get()` operation and item operator result in an\noptional type, to reflect the possibility that there is\nno item for the given key.",651)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Map),$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),List),$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Category)].reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceDeclaration$meta$declaration}})),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','Correspondence']};};
exports.Correspondence=Correspondence;
function $init$Correspondence(){
    if (Correspondence.$$===undefined){
        initTypeProtoI(Correspondence,'ceylon.language::Correspondence');
        (function($$correspondence){
            $$correspondence.$get={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Item']},$ps:[{$nm:'key',$mt:'prm',$t:'Key',$an:function(){return[];}}],$cont:Correspondence,$an:function(){return[doc("Returns the value defined for the given key, or \n`null` if there is no value defined for the given \nkey."),see("Correspondence.items"),shared(),formal()];},d:['ceylon.language','Correspondence','$m','get']};}};$$correspondence.defines=function (key$249){
                var $$correspondence=this;
                return exists($$correspondence.$get(key$249));
            };
            $$correspondence.defines.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'key',$mt:'prm',$t:'Key',$an:function(){return[];}}],$cont:Correspondence,$an:function(){return[doc(String$("Determines if there is a value defined for the \ngiven key.",58)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Correspondence().$$.prototype.definesAny),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Correspondence().$$.prototype.definesEvery),$init$OpenValue()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Correspondence().$$.prototype.$prop$getKeys)].reifyCeylonType({Absent:{t:Null},Element:{t:'u', l:[{t:FunctionDeclaration$meta$declaration},{t:ValueDeclaration$meta$declaration}]}})),shared(),$default()];},d:['ceylon.language','Correspondence','$m','defines']};};
            defineAttr($$correspondence,'keys',function(){
                var $$correspondence=this;
                return Keys($$correspondence,{Key:$$correspondence.$$targs$$.Key,Item:$$correspondence.$$targs$$.Item});
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Category},$cont:Correspondence,$an:function(){return[doc(String$("The `Category` of all keys for which a value is \ndefined by this `Correspondence`.",82)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Correspondence().$$.prototype.defines)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Correspondence','$at','keys']};});
            $$correspondence.definesEvery=function definesEvery(keys$250){
                var $$correspondence=this;
                var it$251 = keys$250.iterator();
                var key$252;while ((key$252=it$251.next())!==getFinished()){
                    if((!$$correspondence.defines(key$252))){
                        return false;
                    }
                }
                if (getFinished() === key$252){
                    return true;
                }
            };$$correspondence.definesEvery.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'keys',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Key'}},$an:function(){return[];}}],$cont:Correspondence,$an:function(){return[doc(String$("Determines if this `Correspondence` defines a value\nfor every one of the given keys.",84)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Correspondence().$$.prototype.defines)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Correspondence','$m','definesEvery']};};
            $$correspondence.definesAny=function definesAny(keys$253){
                var $$correspondence=this;
                var it$254 = keys$253.iterator();
                var key$255;while ((key$255=it$254.next())!==getFinished()){
                    if($$correspondence.defines(key$255)){
                        return true;
                    }
                }
                if (getFinished() === key$255){
                    return false;
                }
            };$$correspondence.definesAny.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'keys',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Key'}},$an:function(){return[];}}],$cont:Correspondence,$an:function(){return[doc(String$("Determines if this `Correspondence` defines a value\nfor any one of the given keys.",82)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Correspondence().$$.prototype.defines)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Correspondence','$m','definesAny']};};
            $$correspondence.items=function (keys$256){
                var $$correspondence=this;
                return Comprehension(function(){
                    var it$257=keys$256.iterator();
                    var key$258=getFinished();
                    var next$key$258=function(){return key$258=it$257.next();}
                    next$key$258();
                    return function(){
                        if(key$258!==getFinished()){
                            var key$258$259=key$258;
                            var tmpvar$260=$$correspondence.$get(key$258$259);
                            next$key$258();
                            return tmpvar$260;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:{t:'u', l:[{t:Null},$$correspondence.$$targs$$.Item]}}).sequence;
            };
            $$correspondence.items.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:'u', l:[{t:Null},'Item']}}},$ps:[{$nm:'keys',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Key'}},$an:function(){return[];}}],$cont:Correspondence,$an:function(){return[doc(String$("Returns the items defined for the given keys, in\nthe same order as the corresponding keys.",90)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Correspondence().$$.prototype.$get)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Correspondence','$m','items']};};
        })(Correspondence.$$.prototype);
    }
    return Correspondence;
}
exports.$init$Correspondence=$init$Correspondence;
$init$Correspondence();
function Finished($$finished){
    $init$Finished();
    if ($$finished===undefined)throwexc(InvocationException$meta$model(String$("Cannot instantiate abstract class")),'?','?')
    return $$finished;
}
Finished.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],of:[{t:finished$261}],$an:function(){return[doc(String$("The type of the value that indicates that \nan `Iterator` is exhausted and has no more \nvalues to return.",104)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Iterator)].reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceDeclaration$meta$declaration}})),shared(),abstract()];},d:['ceylon.language','Finished']};};
exports.Finished=Finished;
function $init$Finished(){
    if (Finished.$$===undefined){
        initTypeProto(Finished,'ceylon.language::Finished',Basic);
    }
    return Finished;
}
exports.$init$Finished=$init$Finished;
$init$Finished();
function finished$261(){
    var $$finished=new finished$261.$$;
    Finished($$finished);
    $$finished.$prop$getString={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:finished$261,$an:function(){return[shared(),actual()];},d:['ceylon.language','finished','$at','string']};}};
    $$finished.$prop$getString.get=function(){return string};
    return $$finished;
};finished$261.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Finished},$an:function(){return[doc("A value that indicates that an `Iterator`\nis exhausted and has no more values to \nreturn."),see("Iterator"),shared()];},d:['ceylon.language','finished']};};
function $init$finished$261(){
    if (finished$261.$$===undefined){
        initTypeProto(finished$261,'ceylon.language::finished',$init$Finished());
        (function($$finished){
            defineAttr($$finished,'string',function(){
                var $$finished=this;
                return String$("finished",8);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:finished$261,$an:function(){return[shared(),actual()];},d:['ceylon.language','finished','$at','string']};});
        })(finished$261.$$.prototype);
    }
    return finished$261;
}
exports.$init$finished$261=$init$finished$261;
$init$finished$261();
var finished$262;
function getFinished(){
    if (finished$262===undefined){finished$262=$init$finished$261()();finished$262.$$metamodel$$=getFinished.$$metamodel$$;}
    return finished$262;
}
exports.getFinished=getFinished;
getFinished.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:finished$261},$an:function(){return[doc(String$("A value that indicates that an `Iterator`\nis exhausted and has no more values to \nreturn.",89)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Iterator)].reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','finished']};};
$prop$getFinished={get:getFinished,$$metamodel$$:getFinished.$$metamodel$$};
exports.$prop$getFinished=$prop$getFinished;
function Binary($$targs$$,$$binary){
    set_type_args($$binary,$$targs$$);
    $$binary.set$defs$bit=function(index$263,bit$264){return true;};
}
Binary.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Other:{'satisfies':[{t:Binary,a:{Other:'Other'}}]}},of:['Other'],$an:function(){return[doc(String$("Abstraction of numeric types like `Integer` that may be \nrepresented as a sequence of bits, and may be the subject\nof bitwise operations.",137)),see([$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Integer)].reifyCeylonType({Absent:{t:Null},Element:{t:ClassDeclaration$meta$declaration}})),by([String$("Stef",4)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','Binary']};};
exports.Binary=Binary;
function $init$Binary(){
    if (Binary.$$===undefined){
        initTypeProtoI(Binary,'ceylon.language::Binary');
        (function($$binary){
            $$binary.$prop$getNot={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$cont:Binary,$an:function(){return[doc(String$("The binary complement of this sequence of bits.",47)),shared(),formal()];},d:['ceylon.language','Binary','$at','not']};}};
            $$binary.$prop$getSize={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Binary,$an:function(){return[doc(String$("The number of bits (0 or 1) that this sequence of bits can hold.",64)),shared(),formal()];},d:['ceylon.language','Binary','$at','size']};}};
            $$binary.leftLogicalShift={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$ps:[{$nm:'shift',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Binary,$an:function(){return[doc("Performs a left logical shift. Sign is not preserved. Padded with zeros."),shared(),formal()];},d:['ceylon.language','Binary','$m','leftLogicalShift']};}};$$binary.rightLogicalShift={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$ps:[{$nm:'shift',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Binary,$an:function(){return[doc("Performs a right logical shift. Sign is not preserved. Padded with zeros."),shared(),formal()];},d:['ceylon.language','Binary','$m','rightLogicalShift']};}};$$binary.rightArithmeticShift={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$ps:[{$nm:'shift',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Binary,$an:function(){return[doc("Performs a right arithmetic shift. Sign is preserved. Padded with zeros."),shared(),formal()];},d:['ceylon.language','Binary','$m','rightArithmeticShift']};}};$$binary.and={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$ps:[{$nm:'other',$mt:'prm',$t:'Other',$an:function(){return[];}}],$cont:Binary,$an:function(){return[doc("Performs a logical AND operation."),shared(),formal()];},d:['ceylon.language','Binary','$m','and']};}};$$binary.or={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$ps:[{$nm:'other',$mt:'prm',$t:'Other',$an:function(){return[];}}],$cont:Binary,$an:function(){return[doc("Performs a logical inclusive OR operation."),shared(),formal()];},d:['ceylon.language','Binary','$m','or']};}};$$binary.xor={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$ps:[{$nm:'other',$mt:'prm',$t:'Other',$an:function(){return[];}}],$cont:Binary,$an:function(){return[doc("Performs a logical exclusive OR operation."),shared(),formal()];},d:['ceylon.language','Binary','$m','xor']};}};$$binary.$get={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'index',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Binary,$an:function(){return[doc("Retrieves a given bit from this bit sequence. Bits are indexed from\nright to left."),shared(),formal()];},d:['ceylon.language','Binary','$m','get']};}};$$binary.set={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$ps:[{$nm:'index',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'bit',$mt:'prm',$def:1,$t:{t:Boolean$},$an:function(){return[];}}],$cont:Binary,$an:function(){return[doc("Returns a new number with the given bit set to the given value.\nBits are indexed from right to left."),shared(),formal()];},d:['ceylon.language','Binary','$m','set']};}};$$binary.clear=function clear(index$265){
                var $$binary=this;
                return $$binary.set(index$265,false);
            };$$binary.clear.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Other',$ps:[{$nm:'index',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Binary,$an:function(){return[doc(String$("Returns a new number with the given bit set to 0.\nBits are indexed from right to left.",86)),shared(),$default()];},d:['ceylon.language','Binary','$m','clear']};};
            $$binary.flip={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$ps:[{$nm:'index',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Binary,$an:function(){return[doc("Returns a new number with the given bit flipped to its opposite value.\nBits are indexed from right to left."),shared(),formal()];},d:['ceylon.language','Binary','$m','flip']};}};
        })(Binary.$$.prototype);
    }
    return Binary;
}
exports.$init$Binary=$init$Binary;
$init$Binary();
function Cloneable($$targs$$,$$cloneable){
    set_type_args($$cloneable,$$targs$$);
}
Cloneable.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Clone:{'var':'out','satisfies':[{t:Cloneable,a:{Clone:'Clone'}}]}},of:['Clone'],$an:function(){return[doc(String$("Abstract supertype of objects whose value can be \ncloned.",57)),shared()];},d:['ceylon.language','Cloneable']};};
exports.Cloneable=Cloneable;
function $init$Cloneable(){
    if (Cloneable.$$===undefined){
        initTypeProtoI(Cloneable,'ceylon.language::Cloneable');
        (function($$cloneable){
            $$cloneable.$prop$getClone={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Clone',$cont:Cloneable,$an:function(){return[doc(String$("Obtain a clone of this object. For a mutable \nobject, this should return a copy of the object. \nFor an immutable object, it is acceptable to return\nthe object itself.",166)),shared(),formal()];},d:['ceylon.language','Cloneable','$at','clone']};}};
        })(Cloneable.$$.prototype);
    }
    return Cloneable;
}
exports.$init$Cloneable=$init$Cloneable;
$init$Cloneable();
function Closeable($$closeable){
}
Closeable.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$an:function(){return[doc(String$("Abstract supertype of types which may appear\nas the expression type of a resource expression\nin a `try` statement.",114)),shared()];},d:['ceylon.language','Closeable']};};
exports.Closeable=Closeable;
function $init$Closeable(){
    if (Closeable.$$===undefined){
        initTypeProtoI(Closeable,'ceylon.language::Closeable');
        (function($$closeable){
            $$closeable.open={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[],$cont:Closeable,$an:function(){return[doc("Called before entry to a `try` block."),shared(),formal()];},d:['ceylon.language','Closeable','$m','open']};}};$$closeable.close={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[{$nm:'exception',$mt:'prm',$t:{t:'u', l:[{t:Null},{t:Exception}]},$an:function(){return[];}}],$cont:Closeable,$an:function(){return[doc("Called after completion of a `try` block."),shared(),formal()];},d:['ceylon.language','Closeable','$m','close']};}};
        })(Closeable.$$.prototype);
    }
    return Closeable;
}
exports.$init$Closeable=$init$Closeable;
$init$Closeable();
function Ranged($$targs$$,$$ranged){
    set_type_args($$ranged,$$targs$$);
}
Ranged.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Index:{'var':'in','satisfies':[{t:Comparable,a:{Other:'Index'}}]},Span:{'var':'out'}},of:['Span'],$an:function(){return[doc(String$("Abstract supertype of ranged objects which map a range\nof `Comparable` keys to ranges of values. The type\nparameter `Span` abstracts the type of the resulting\nrange.\n\nA span may be obtained from an instance of `Ranged`\nusing the span operator:\n\n    print(\"hello world\"[0..5])\n",276)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),List),$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Sequence),$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),String)].reifyCeylonType({Absent:{t:Null},Element:{t:'u', l:[{t:InterfaceDeclaration$meta$declaration},{t:ClassDeclaration$meta$declaration}]}})),shared()];},d:['ceylon.language','Ranged']};};
exports.Ranged=Ranged;
function $init$Ranged(){
    if (Ranged.$$===undefined){
        initTypeProtoI(Ranged,'ceylon.language::Ranged');
        (function($$ranged){
            $$ranged.span={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Span',$ps:[{$nm:'from',$mt:'prm',$t:'Index',$an:function(){return[];}},{$nm:'to',$mt:'prm',$t:'Index',$an:function(){return[];}}],$cont:Ranged,$an:function(){return[doc("Obtain a span containing the mapped values between \nthe two given indices."),shared(),formal()];},d:['ceylon.language','Ranged','$m','span']};}};$$ranged.spanFrom={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Span',$ps:[{$nm:'from',$mt:'prm',$t:'Index',$an:function(){return[];}}],$cont:Ranged,$an:function(){return[doc("Obtain a span containing the mapped values between\nthe starting index and the end of the receiver."),shared(),formal()];},d:['ceylon.language','Ranged','$m','spanFrom']};}};$$ranged.spanTo={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Span',$ps:[{$nm:'to',$mt:'prm',$t:'Index',$an:function(){return[];}}],$cont:Ranged,$an:function(){return[doc("Obtain a span containing the mapped values between\nthe start of the receiver and the end index."),shared(),formal()];},d:['ceylon.language','Ranged','$m','spanTo']};}};$$ranged.segment={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Span',$ps:[{$nm:'from',$mt:'prm',$t:'Index',$an:function(){return[];}},{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Ranged,$an:function(){return[doc("Obtain a segment containing the mapped values\nstarting from the given index, with the given \nlength."),shared(),formal()];},d:['ceylon.language','Ranged','$m','segment']};}};
        })(Ranged.$$.prototype);
    }
    return Ranged;
}
exports.$init$Ranged=$init$Ranged;
$init$Ranged();
function Iterator($$targs$$,$$iterator){
    set_type_args($$iterator,$$targs$$);
}
Iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Element:{'var':'out'}},$an:function(){return[doc(String$("Produces elements of an `Iterable` object. Classes that \nimplement this interface should be immutable.",102)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Iterable)].reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceDeclaration$meta$declaration}})),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','Iterator']};};
exports.Iterator=Iterator;
function $init$Iterator(){
    if (Iterator.$$===undefined){
        initTypeProtoI(Iterator,'ceylon.language::Iterator');
        (function($$iterator){
            $$iterator.next={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$ps:[],$cont:Iterator,$an:function(){return[doc("The next element, or `finished` if there are no \nmore elements to be iterated."),shared(),formal()];},d:['ceylon.language','Iterator','$m','next']};}};
        })(Iterator.$$.prototype);
    }
    return Iterator;
}
exports.$init$Iterator=$init$Iterator;
$init$Iterator();
function Collection($$targs$$,$$collection){
    Iterable($$collection.$$targs$$===undefined?$$targs$$:{Absent:{t:Null},Element:$$collection.$$targs$$.Element},$$collection);
    add_type_arg($$collection,'Absent',{t:Null});
    Cloneable($$collection.$$targs$$===undefined?$$targs$$:{Clone:{t:Collection,a:{Element:$$collection.$$targs$$.Element}}},$$collection);
    add_type_arg($$collection,'Clone',{t:Collection,a:{Element:$$collection.$$targs$$.Element}});
    set_type_args($$collection,$$targs$$);
    $$collection.$prop$getEmpty={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Collection,$an:function(){return[doc(String$("Determine if the collection is empty, that is, if \nit has no elements.",70)),shared(),actual(),$default()];},d:['ceylon.language','Collection','$at','empty']};}};
    $$collection.$prop$getEmpty.get=function(){return empty};
    $$collection.$prop$getString={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Collection,$an:function(){return[doc(String$("A string of form `\"{ x, y, z }\"` where `x`, `y`, \nand `z` are the `string` representations of the \nelements of this collection, as produced by the\niterator of the collection, or the string `\"{}\"` \nif this collection is empty. If the collection \niterator produces the value `null`, the string\nrepresentation contains the string `\"null\"`.",336)),shared(),actual(),$default()];},d:['ceylon.language','Collection','$at','string']};}};
    $$collection.$prop$getString.get=function(){return string};
}
Collection.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Element:{'var':'out'}},satisfies:[{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},{t:Cloneable,a:{Clone:{t:Collection,a:{Element:'Element'}}}}],$an:function(){return[doc(String$("Represents an iterable collection of elements of finite \nsize. `Collection` is the abstract supertype of `List`,\n`Map`, and `Set`.\n\nA `Collection` forms a `Category` of its elements.\n\nAll `Collection`s are `Cloneable`. If a collection is\nimmutable, it is acceptable that `clone` produce a\nreference to the collection itself. If a collection is\nmutable, `clone` should produce an immutable collection\ncontaining references to the same elements, with the\nsame structure as the original collection&mdash;that \nis, it should produce an immutable shallow copy of the\ncollection.",573)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),List),$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Map),$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Set)].reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','Collection']};};
exports.Collection=Collection;
function $init$Collection(){
    if (Collection.$$===undefined){
        initTypeProtoI(Collection,'ceylon.language::Collection',$init$Iterable(),$init$Cloneable());
        (function($$collection){
            defineAttr($$collection,'empty',function(){
                var $$collection=this;
                return $$collection.size.equals((0));
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Collection,$an:function(){return[doc(String$("Determine if the collection is empty, that is, if \nit has no elements.",70)),shared(),actual(),$default()];},d:['ceylon.language','Collection','$at','empty']};});
            $$collection.contains=function contains(element$266){
                var $$collection=this;
                var it$267 = $$collection.iterator();
                var elem$268;while ((elem$268=it$267.next())!==getFinished()){
                    var elem$269;
                    if((elem$269=elem$268)!==null&&elem$269.equals(element$266)){
                        return true;
                    }
                }
                if (getFinished() === elem$268){
                    return false;
                }
            };$$collection.contains.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'element',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Collection,$an:function(){return[doc(String$("Return `true` if the given object is an element of\nthis collection. In this default implementation,\nand in most refining implementations, return `false`\notherwise. An acceptable refining implementation\nmay return `true` for objects which are not \nelements of the collection, but this is not \nrecommended. (For example, the `contains()` method \nof `String` returns `true` for any substring of the\nstring.)",404)),shared(),actual(),$default()];},d:['ceylon.language','Collection','$m','contains']};};
            defineAttr($$collection,'string',function(){
                var $$collection=this;
                return (opt$270=($$collection.empty?String$("{}",2):null),opt$270!==null?opt$270:StringBuilder().appendAll([String$("{ ",2),commaList($$collection).string,String$(" }",2)]).string);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Collection,$an:function(){return[doc(String$("A string of form `\"{ x, y, z }\"` where `x`, `y`, \nand `z` are the `string` representations of the \nelements of this collection, as produced by the\niterator of the collection, or the string `\"{}\"` \nif this collection is empty. If the collection \niterator produces the value `null`, the string\nrepresentation contains the string `\"null\"`.",336)),shared(),actual(),$default()];},d:['ceylon.language','Collection','$at','string']};});
        })(Collection.$$.prototype);
    }
    return Collection;
}
exports.$init$Collection=$init$Collection;
$init$Collection();
var opt$270;
function Category($$category){
}
Category.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$an:function(){return[doc(String$("Abstract supertype of objects that contain other \nvalues, called *elements*, where it is possible to \nefficiently determine if a given value is an element. \n`Category` does not satisfy `Container`, because it is \nconceptually possible to have a `Category` whose \nemptiness cannot be computed.\n\nThe `in` operator may be used to determine if a value\nbelongs to a `Category`:\n\n    if (\"hello\" in \"hello world\") { ... }\n    if (69 in 0..100) { ... }\n    if (key->value in { for (n in 0..100) n.string->n**2 }) { ... }\n\nOrdinarily, `x==y` implies that `x in cat == y in cat`.\nBut this contract is not required since it is possible\nto form a meaningful `Category` using a different\nequivalence relation. For example, an `IdentitySet` is\na meaningful `Category`.",755)),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','Category']};};
exports.Category=Category;
function $init$Category(){
    if (Category.$$===undefined){
        initTypeProtoI(Category,'ceylon.language::Category');
        (function($$category){
            $$category.contains={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'element',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Category,$an:function(){return[doc("Determines if the given value belongs to this\n`Category`, that is, if it is an element of this\n`Category`.\n\nFor most `Category`s, if `x==y`, then \n`category.contains(x)` evaluates to the same\nvalue as `category.contains(y)`. However, it is\npossible to form a `Category` consistent with some \nother equivalence relation, for example `===`. \nTherefore implementations of `contains()` which do \nnot satisfy this relationship are tolerated."),see("containsEvery","containsAny"),shared(),formal()];},d:['ceylon.language','Category','$m','contains']};}};$$category.containsEvery=function containsEvery(elements$271){
                var $$category=this;
                var it$272 = elements$271.iterator();
                var element$273;while ((element$273=it$272.next())!==getFinished()){
                    if((!$$category.contains(element$273))){
                        return false;
                    }
                }
                if (getFinished() === element$273){
                    return true;
                }
            };$$category.containsEvery.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'elements',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Object$}}},$an:function(){return[];}}],$cont:Category,$an:function(){return[doc(String$("Determines if every one of the given values belongs\nto this `Category`.",71)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Category().$$.prototype.contains)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Category','$m','containsEvery']};};
            $$category.containsAny=function containsAny(elements$274){
                var $$category=this;
                var it$275 = elements$274.iterator();
                var element$276;while ((element$276=it$275.next())!==getFinished()){
                    if($$category.contains(element$276)){
                        return true;
                    }
                }
                if (getFinished() === element$276){
                    return false;
                }
            };$$category.containsAny.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'elements',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Object$}}},$an:function(){return[];}}],$cont:Category,$an:function(){return[doc(String$("Determines if any one of the given values belongs \nto this `Category`",69)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Category().$$.prototype.contains)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','Category','$m','containsAny']};};
        })(Category.$$.prototype);
    }
    return Category;
}
exports.$init$Category=$init$Category;
$init$Category();
function List($$targs$$,$$list){
    Collection($$list.$$targs$$===undefined?$$targs$$:{Element:$$list.$$targs$$.Element},$$list);
    Correspondence($$list.$$targs$$===undefined?$$targs$$:{Key:{t:Integer},Item:$$list.$$targs$$.Element},$$list);
    add_type_arg($$list,'Key',{t:Integer});
    Ranged($$list.$$targs$$===undefined?$$targs$$:{Index:{t:Integer},Span:{t:List,a:{Element:$$list.$$targs$$.Element}}},$$list);
    add_type_arg($$list,'Index',{t:Integer});
    add_type_arg($$list,'Span',{t:List,a:{Element:$$list.$$targs$$.Element}});
    Cloneable($$list.$$targs$$===undefined?$$targs$$:{Clone:{t:List,a:{Element:$$list.$$targs$$.Element}}},$$list);
    add_type_arg($$list,'Clone',{t:List,a:{Element:$$list.$$targs$$.Element}});
    set_type_args($$list,$$targs$$);
    $$list.$prop$getSize={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:List,$an:function(){return[doc(String$("The number of elements in this sequence, always\n`sequence.lastIndex+1`.",71)),see([$init$OpenValue()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$List().$$.prototype.$prop$getLastIndex)].reifyCeylonType({Absent:{t:Null},Element:{t:ValueDeclaration$meta$declaration}})),shared(),actual(),$default()];},d:['ceylon.language','List','$at','size']};}};
    $$list.$prop$getSize.get=function(){return size};
    $$list.$prop$getFirst={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$cont:List,$an:function(){return[doc(String$("Returns the first element of this `List`, if any.",49)),shared(),actual(),$default()];},d:['ceylon.language','List','$at','first']};}};
    $$list.$prop$getFirst.get=function(){return first};
}
List.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Element:{'var':'out'}},satisfies:[{t:Collection,a:{Element:'Element'}},{t:Correspondence,a:{Key:{t:Integer},Item:'Element'}},{t:Ranged,a:{Index:{t:Integer},Span:{t:List,a:{Element:'Element'}}}},{t:Cloneable,a:{Clone:{t:List,a:{Element:'Element'}}}}],$an:function(){return[doc(String$("Represents a collection in which every element has a \nunique non-negative integer index.\n\nA `List` is a `Collection` of its elements, and a \n`Correspondence` from indices to elements.\n\nDirect access to a list element by index produces a\nvalue of optional type. The following idiom may be\nused instead of upfront bounds-checking, as long as \nthe list element type is a non-`null` type:\n\n    value char = \"hello world\"[index];\n    if (exists char) { /*do something*/ }\n    else { /*out of bounds*/ }\n\nTo iterate the indexes of a `List`, use the following\nidiom:\n\n    for (i->char in \"hello world\".indexed) { ... }",611)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Sequence),$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Empty),$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Array)].reifyCeylonType({Absent:{t:Null},Element:{t:'u', l:[{t:InterfaceDeclaration$meta$declaration},{t:ClassDeclaration$meta$declaration}]}})),shared()];},d:['ceylon.language','List']};};
exports.List=List;
function $init$List(){
    if (List.$$===undefined){
        initTypeProtoI(List,'ceylon.language::List',$init$Collection(),$init$Correspondence(),$init$Ranged(),$init$Cloneable());
        (function($$list){
            $$list.$prop$getLastIndex={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Integer}]},$cont:List,$an:function(){return[doc(String$("The index of the last element of the list, or\nnull if the list is empty.",72)),see([$init$OpenValue()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$List().$$.prototype.$prop$getSize)].reifyCeylonType({Absent:{t:Null},Element:{t:ValueDeclaration$meta$declaration}})),shared(),formal()];},d:['ceylon.language','List','$at','lastIndex']};}};
            defineAttr($$list,'size',function(){
                var $$list=this;
                return (opt$277=$$list.lastIndex,opt$277!==null?opt$277:(-(1))).plus((1));
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:List,$an:function(){return[doc(String$("The number of elements in this sequence, always\n`sequence.lastIndex+1`.",71)),see([$init$OpenValue()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$List().$$.prototype.$prop$getLastIndex)].reifyCeylonType({Absent:{t:Null},Element:{t:ValueDeclaration$meta$declaration}})),shared(),actual(),$default()];},d:['ceylon.language','List','$at','size']};});
            $$list.shorterThan=function (length$278){
                var $$list=this;
                return $$list.size.compare(length$278).equals(getSmaller());
            };
            $$list.shorterThan.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:List,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','List','$m','shorterThan']};};
            $$list.longerThan=function (length$279){
                var $$list=this;
                return $$list.size.compare(length$279).equals(getLarger());
            };
            $$list.longerThan.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:List,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','List','$m','longerThan']};};
            $$list.$prop$getRest={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$cont:List,$an:function(){return[doc(String$("The rest of the list, without the first element.",48)),shared(),actual(),formal()];},d:['ceylon.language','List','$at','rest']};}};
            $$list.defines=function (index$280){
                var $$list=this;
                return (index$280.compare((opt$281=$$list.lastIndex,opt$281!==null?opt$281:(-(1))))!==getLarger());
            };
            $$list.defines.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'index',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("Determines if the given index refers to an element\n    of this sequence, that is, if\n    `index<=sequence.lastIndex`.",117)),shared(),actual(),$default()];},d:['ceylon.language','List','$m','defines']};};
            $$list.$get={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$ps:[{$nm:'index',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:List,$an:function(){return[doc("Returns the element of this sequence with the given\n    index, or `null` if the given index is past the end\n    of the sequence, that is, if\n    `index>sequence.lastIndex`. The first element of\n    the sequence has index `0`."),shared(),actual(),formal()];},d:['ceylon.language','List','$m','get']};}};$$list.iterator=function iterator(){
                var $$list=this;
                function listIterator$282($$targs$$){
                    var $$listIterator$282=new listIterator$282.$$;
                    $$listIterator$282.$$targs$$=$$targs$$;
                    Iterator({Element:$$list.$$targs$$.Element},$$listIterator$282);
                    $$listIterator$282.index$283_=(0);
                    $$listIterator$282.$prop$getIndex$283={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:listIterator$282,$an:function(){return[variable()];},d:['ceylon.language','List','$m','iterator','$o','listIterator','$at','index']};}};
                    $$listIterator$282.$prop$getIndex$283.get=function(){return index$283};
                    return $$listIterator$282;
                };listIterator$282.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterator,a:{Element:'Element'}}],d:['ceylon.language','List','$m','iterator','$o','listIterator']};};
                function $init$listIterator$282(){
                    if (listIterator$282.$$===undefined){
                        initTypeProto(listIterator$282,'ceylon.language::List.iterator.listIterator',Basic,$init$Iterator());
                        (function($$listIterator$282){
                            defineAttr($$listIterator$282,'index$283',function(){return this.index$283_;},function(index$284){return this.index$283_=index$284;},function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:listIterator$282,$an:function(){return[variable()];},d:['ceylon.language','List','$m','iterator','$o','listIterator','$at','index']};});
                            $$listIterator$282.next=function next(){
                                var $$listIterator$282=this;
                                if(($$listIterator$282.index$283.compare((opt$285=$$list.lastIndex,opt$285!==null?opt$285:(-(1))))!==getLarger())){
                                    //assert at List.ceylon (67:20-67:65)
                                    var elem$286;
                                    if (!(isOfType((elem$286=$$list.$get((oldindex$287=$$listIterator$282.index$283,$$listIterator$282.index$283=oldindex$287.successor,oldindex$287))),$$list.$$targs$$.Element))) {throw wrapexc(AssertionException("Assertion failed: \'is Element elem = outer.get(index++)\' at List.ceylon (67:27-67:64)"),'67:20-67:65','List.ceylon'); }
                                    var oldindex$287;
                                    return elem$286;
                                }else {
                                    return getFinished();
                                }
                                var opt$285;
                            };$$listIterator$282.next.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$ps:[],$cont:listIterator$282,$an:function(){return[shared(),actual()];},d:['ceylon.language','List','$m','iterator','$o','listIterator','$m','next']};};
                        })(listIterator$282.$$.prototype);
                    }
                    return listIterator$282;
                }
                $init$listIterator$282();
                var listIterator$288;
                function getListIterator$288(){
                    if (listIterator$288===undefined){listIterator$288=$init$listIterator$282()({Element:$$list.$$targs$$.Element});listIterator$288.$$metamodel$$=getListIterator$288.$$metamodel$$;}
                    return listIterator$288;
                }
                getListIterator$288.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:listIterator$282},d:['ceylon.language','List','$m','iterator','$o','listIterator']};};
                $prop$getListIterator$288={get:getListIterator$288,$$metamodel$$:getListIterator$288.$$metamodel$$};
                return getListIterator$288();
            };$$list.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$ps:[],$cont:List,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','List','$m','iterator']};};
            $$list.$prop$getReversed={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$cont:List,$an:function(){return[doc(String$("Reverse this list, returning a new list.",40)),shared(),formal()];},d:['ceylon.language','List','$at','reversed']};}};
            $$list.equals=function equals(that$289){
                var $$list=this;
                var that$290;
                if(isOfType((that$290=that$289),{t:List,a:{Element:{t:Anything}}})){
                    if(that$290.size.equals($$list.size)){
                        var it$291 = Range((0),$$list.size.minus((1)),{Element:{t:Integer}}).iterator();
                        var i$292;while ((i$292=it$291.next())!==getFinished()){
                            var x$293=$$list.$get(i$292);
                            $prop$getX$293={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},d:['ceylon.language','List','$m','equals','$at','x']};}};
                            $prop$getX$293.get=function(){return x$293};
                            var y$294=that$290.$get(i$292);
                            $prop$getY$294={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Anything},d:['ceylon.language','List','$m','equals','$at','y']};}};
                            $prop$getY$294.get=function(){return y$294};
                            var x$295;
                            if((x$295=x$293)!==null){
                                var y$296;
                                if((y$296=y$294)!==null){
                                    if((!x$295.equals(y$296))){
                                        return false;
                                    }
                                }else {
                                    return false;
                                }
                            }else {
                                var y$297;
                                if((y$297=y$294)!==null){
                                    return false;
                                }
                            }
                        }
                        if (getFinished() === i$292){
                            return true;
                        }
                    }
                }
                return false;
            };$$list.equals.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'that',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("Two `List`s are considered equal iff they have the \nsame `size` and _entry sets_. The entry set of a \nlist `l` is the set of elements of `l.indexed`. \nThis definition is equivalent to the more intuitive \nnotion that two lists are equal iff they have the \nsame `size` and for every index either:\n\n- the lists both have the element `null`, or\n- the lists both have a non-null element, and the\n  two elements are equal.",416)),shared(),actual(),$default()];},d:['ceylon.language','List','$m','equals']};};
            defineAttr($$list,'hash',function(){
                var $$list=this;
                var hash$298=(1);
                function setHash$298(hash$299){return hash$298=hash$299;};
                $prop$getHash$298={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','List','$at','hash','$at','hash']};}};
                $prop$getHash$298.get=function(){return hash$298};
                $prop$getHash$298.set=setHash$298;
                if (setHash$298.$$metamodel$$===undefined)setHash$298.$$metamodel$$=$prop$getHash$298.$$metamodel$$;
                var it$300 = $$list.iterator();
                var elem$301;while ((elem$301=it$300.next())!==getFinished()){
                    (hash$298=hash$298.times((31)));
                    var elem$302;
                    if((elem$302=elem$301)!==null){
                        (hash$298=hash$298.plus(elem$302.hash));
                    }
                }
                return hash$298;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:List,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','List','$at','hash']};});$$list.findLast=function findLast(selecting$303){
                var $$list=this;
                var l$304;
                if((l$304=$$list.lastIndex)!==null){
                    var index$305=l$304;
                    function setIndex$305(index$306){return index$305=index$306;};
                    $prop$getIndex$305={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','List','$m','findLast','$at','index']};}};
                    $prop$getIndex$305.get=function(){return index$305};
                    $prop$getIndex$305.set=setIndex$305;
                    if (setIndex$305.$$metamodel$$===undefined)setIndex$305.$$metamodel$$=$prop$getIndex$305.$$metamodel$$;
                    while((index$305.compare((0))!==getSmaller())){
                        var elem$307;
                        if((elem$307=$$list.$get((oldindex$308=index$305,index$305=oldindex$308.predecessor,oldindex$308)))!==null){
                            if(selecting$303(elem$307)){
                                return elem$307;
                            }
                        }
                        var oldindex$308;
                    }
                }
                return null;
            };$$list.findLast.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:List,$an:function(){return[shared(),$default(),actual()];},d:['ceylon.language','List','$m','findLast']};};
            defineAttr($$list,'first',function(){
                var $$list=this;
                return $$list.$get((0));
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$cont:List,$an:function(){return[doc(String$("Returns the first element of this `List`, if any.",49)),shared(),actual(),$default()];},d:['ceylon.language','List','$at','first']};});
            defineAttr($$list,'last',function(){
                var $$list=this;
                var i$309;
                if((i$309=$$list.lastIndex)!==null){
                    return $$list.$get(i$309);
                }else {
                    return null;
                }
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$cont:List,$an:function(){return[doc(String$("Returns the last element of this `List`, if any.",48)),shared(),actual(),$default()];},d:['ceylon.language','List','$at','last']};});$$list.withLeading=function withLeading(element$310,$$$mptypes){
                var $$list=this;
                var sb$311=SequenceBuilder({Element:{t:'u', l:[$$list.$$targs$$.Element,$$$mptypes.Other]}});
                sb$311.append(element$310);
                if((!$$list.empty)){
                    sb$311.appendAll($$list);
                }
                //assert at List.ceylon (169:8-169:41)
                var seq$312;
                if (!(nonempty((seq$312=sb$311.sequence)))) {throw wrapexc(AssertionException("Assertion failed: \'nonempty seq=sb.sequence\' at List.ceylon (169:15-169:40)"),'169:8-169:41','List.ceylon'); }
                return seq$312;
            };$$list.withLeading.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequence,a:{Element:{t:'u', l:['Element','Other']}}},$ps:[{$nm:'element',$mt:'prm',$t:'Other',$an:function(){return[doc("The first element of the resulting sequence.")];}}],$cont:List,$tp:{Other:{}},$an:function(){return[doc(String$("Returns a new `List` that starts with the specified\nelement, followed by the elements of this `List`.",101)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Iterable().$$.prototype.following)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','List','$m','withLeading']};};
            $$list.withTrailing=function withTrailing(element$313,$$$mptypes){
                var $$list=this;
                var sb$314=SequenceBuilder({Element:{t:'u', l:[$$list.$$targs$$.Element,$$$mptypes.Other]}});
                if((!$$list.empty)){
                    sb$314.appendAll($$list);
                }
                sb$314.append(element$313);
                //assert at List.ceylon (184:8-184:41)
                var seq$315;
                if (!(nonempty((seq$315=sb$314.sequence)))) {throw wrapexc(AssertionException("Assertion failed: \'nonempty seq=sb.sequence\' at List.ceylon (184:15-184:40)"),'184:8-184:41','List.ceylon'); }
                return seq$315;
            };$$list.withTrailing.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequence,a:{Element:{t:'u', l:['Element','Other']}}},$ps:[{$nm:'element',$mt:'prm',$t:'Other',$an:function(){return[doc("The last element of the resulting sequence.")];}}],$cont:List,$tp:{Other:{}},$an:function(){return[doc(String$("Returns a new `List` that contains the specified\nelement appended to the end of the elements of this \n`List`.",109)),shared(),$default()];},d:['ceylon.language','List','$m','withTrailing']};};
            $$list.startsWith=function (sublist$316){
                var $$list=this;
                return $$list.includesAt((0),sublist$316);
            };
            $$list.startsWith.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'sublist',$mt:'prm',$t:{t:List,a:{Element:{t:Anything}}},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("Determine if the given list occurs at the start of this \nlist.",62)),shared(),$default()];},d:['ceylon.language','List','$m','startsWith']};};
            $$list.endsWith=function (sublist$317){
                var $$list=this;
                return $$list.includesAt($$list.size.minus(sublist$317.size),sublist$317);
            };
            $$list.endsWith.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'sublist',$mt:'prm',$t:{t:List,a:{Element:{t:Anything}}},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("Determine if the given list occurs at the end of this\nlist.",59)),shared(),$default()];},d:['ceylon.language','List','$m','endsWith']};};
            $$list.includesAt=function includesAt(index$318,sublist$319){
                var $$list=this;
                var it$320 = (function(){var tmpvar$322=sublist$319.size;
                if (tmpvar$322>0){
                var tmpvar$323=(0);
                var tmpvar$324=tmpvar$323;
                for (var i=1; i<tmpvar$322; i++){tmpvar$324=tmpvar$324.successor;}
                return Range(tmpvar$323,tmpvar$324,{Element:{t:Integer}})
                }else return getEmpty();}()).iterator();
                var i$321;while ((i$321=it$320.next())!==getFinished()){
                    var x$325=$$list.$get(index$318.plus(i$321));
                    $prop$getX$325={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},d:['ceylon.language','List','$m','includesAt','$at','x']};}};
                    $prop$getX$325.get=function(){return x$325};
                    var y$326=sublist$319.$get(i$321);
                    $prop$getY$326={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Anything},d:['ceylon.language','List','$m','includesAt','$at','y']};}};
                    $prop$getY$326.get=function(){return y$326};
                    var x$327;
                    if((x$327=x$325)!==null){
                        var y$328;
                        if((y$328=y$326)!==null){
                            if((!x$327.equals(y$328))){
                                return false;
                            }
                        }else {
                            return false;
                        }
                    }else {
                        var y$329;
                        if((y$329=y$326)!==null){
                            return false;
                        }
                    }
                }
                if (getFinished() === i$321){
                    return true;
                }
            };$$list.includesAt.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'index',$mt:'prm',$t:{t:Integer},$an:function(){return[doc("The index at which this list might occur")];}},{$nm:'sublist',$mt:'prm',$t:{t:List,a:{Element:{t:Anything}}},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("Determine if the given list occurs at the given index \nof this list.",68)),shared(),$default()];},d:['ceylon.language','List','$m','includesAt']};};
            $$list.includes=function includes(sublist$330){
                var $$list=this;
                var it$331 = (function(){var tmpvar$333=$$list.size;
                if (tmpvar$333>0){
                var tmpvar$334=(0);
                var tmpvar$335=tmpvar$334;
                for (var i=1; i<tmpvar$333; i++){tmpvar$335=tmpvar$335.successor;}
                return Range(tmpvar$334,tmpvar$335,{Element:{t:Integer}})
                }else return getEmpty();}()).iterator();
                var index$332;while ((index$332=it$331.next())!==getFinished()){
                    if($$list.includesAt(index$332,sublist$330)){
                        return true;
                    }
                }
                return false;
            };$$list.includes.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'sublist',$mt:'prm',$t:{t:List,a:{Element:{t:Anything}}},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("Determine if the given list occurs at some index in \nthis list.",63)),shared(),$default()];},d:['ceylon.language','List','$m','includes']};};
            $$list.inclusions=function (sublist$336){
                var $$list=this;
                return Comprehension(function(){
                    var it$337=(function(){var tmpvar$339=$$list.size;
                    if (tmpvar$339>0){
                    var tmpvar$340=(0);
                    var tmpvar$341=tmpvar$340;
                    for (var i=1; i<tmpvar$339; i++){tmpvar$341=tmpvar$341.successor;}
                    return Range(tmpvar$340,tmpvar$341,{Element:{t:Integer}})
                    }else return getEmpty();}()).iterator();
                    var index$338=getFinished();
                    var next$index$338=function(){
                        while((index$338=it$337.next())!==getFinished()){
                            if($$list.includesAt(index$338,sublist$336)){
                                return index$338;
                            }
                        }
                        return getFinished();
                    }
                    next$index$338();
                    return function(){
                        if(index$338!==getFinished()){
                            var index$338$342=index$338;
                            var tmpvar$343=index$338$342;
                            next$index$338();
                            return tmpvar$343;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:{t:Integer}});
            };
            $$list.inclusions.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Integer}}},$ps:[{$nm:'sublist',$mt:'prm',$t:{t:List,a:{Element:{t:Anything}}},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("The indexes in this list at which the given list \noccurs.",57)),shared(),$default()];},d:['ceylon.language','List','$m','inclusions']};};
            $$list.firstInclusion=function firstInclusion(sublist$344){
                var $$list=this;
                var it$345 = (function(){var tmpvar$347=$$list.size;
                if (tmpvar$347>0){
                var tmpvar$348=(0);
                var tmpvar$349=tmpvar$348;
                for (var i=1; i<tmpvar$347; i++){tmpvar$349=tmpvar$349.successor;}
                return Range(tmpvar$348,tmpvar$349,{Element:{t:Integer}})
                }else return getEmpty();}()).iterator();
                var index$346;while ((index$346=it$345.next())!==getFinished()){
                    if($$list.includesAt(index$346,sublist$344)){
                        return index$346;
                    }
                }
                if (getFinished() === index$346){
                    return null;
                }
            };$$list.firstInclusion.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Integer}]},$ps:[{$nm:'sublist',$mt:'prm',$t:{t:List,a:{Element:{t:Anything}}},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("The first index in this list at which the given list \noccurs.",61)),shared(),$default()];},d:['ceylon.language','List','$m','firstInclusion']};};
            $$list.lastInclusion=function lastInclusion(sublist$350){
                var $$list=this;
                var it$351 = (function(){var tmpvar$353=$$list.size;
                if (tmpvar$353>0){
                var tmpvar$354=(0);
                var tmpvar$355=tmpvar$354;
                for (var i=1; i<tmpvar$353; i++){tmpvar$355=tmpvar$355.successor;}
                return Range(tmpvar$354,tmpvar$355,{Element:{t:Integer}})
                }else return getEmpty();}()).reversed.iterator();
                var index$352;while ((index$352=it$351.next())!==getFinished()){
                    if($$list.includesAt(index$352,sublist$350)){
                        return index$352;
                    }
                }
                if (getFinished() === index$352){
                    return null;
                }
            };$$list.lastInclusion.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Integer}]},$ps:[{$nm:'sublist',$mt:'prm',$t:{t:List,a:{Element:{t:Anything}}},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("The last index in this list at which the given list \noccurs.",60)),shared(),$default()];},d:['ceylon.language','List','$m','lastInclusion']};};
            $$list.occursAt=function occursAt(index$356,element$357){
                var $$list=this;
                var elem$358=$$list.$get(index$356);
                var element$359;
                if((element$359=element$357)!==null){
                    var elem$360;
                    if((elem$360=elem$358)!==null){
                        return elem$360.equals(element$359);
                    }else {
                        return false;
                    }
                }else {
                    return (!exists(elem$358));
                }
            };$$list.occursAt.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'index',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'element',$mt:'prm',$t:{t:Anything},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("Determines if the given value occurs at the \ngiven index in this list.",70)),shared(),$default()];},d:['ceylon.language','List','$m','occursAt']};};
            $$list.occurs=function occurs(element$361){
                var $$list=this;
                var it$362 = (function(){var tmpvar$364=$$list.size;
                if (tmpvar$364>0){
                var tmpvar$365=(0);
                var tmpvar$366=tmpvar$365;
                for (var i=1; i<tmpvar$364; i++){tmpvar$366=tmpvar$366.successor;}
                return Range(tmpvar$365,tmpvar$366,{Element:{t:Integer}})
                }else return getEmpty();}()).iterator();
                var index$363;while ((index$363=it$362.next())!==getFinished()){
                    if($$list.occursAt(index$363,element$361)){
                        return true;
                    }
                }
                return false;
            };$$list.occurs.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'element',$mt:'prm',$t:{t:Anything},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("Determines if the given value occurs as an \nelement in this list.",65)),shared(),$default()];},d:['ceylon.language','List','$m','occurs']};};
            $$list.contains=function (element$367){
                var $$list=this;
                return $$list.occurs(element$367);
            };
            $$list.contains.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'element',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("Determines if this list contains the given \nvalue. Equivalent to `occurs()`.",76)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$List().$$.prototype.occurs)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),actual(),$default()];},d:['ceylon.language','List','$m','contains']};};
            $$list.occurrences=function (element$368){
                var $$list=this;
                return Comprehension(function(){
                    var it$369=(function(){var tmpvar$371=$$list.size;
                    if (tmpvar$371>0){
                    var tmpvar$372=(0);
                    var tmpvar$373=tmpvar$372;
                    for (var i=1; i<tmpvar$371; i++){tmpvar$373=tmpvar$373.successor;}
                    return Range(tmpvar$372,tmpvar$373,{Element:{t:Integer}})
                    }else return getEmpty();}()).iterator();
                    var index$370=getFinished();
                    var next$index$370=function(){
                        while((index$370=it$369.next())!==getFinished()){
                            if($$list.occursAt(index$370,element$368)){
                                return index$370;
                            }
                        }
                        return getFinished();
                    }
                    next$index$370();
                    return function(){
                        if(index$370!==getFinished()){
                            var index$370$374=index$370;
                            var tmpvar$375=index$370$374;
                            next$index$370();
                            return tmpvar$375;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:{t:Integer}});
            };
            $$list.occurrences.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Integer}}},$ps:[{$nm:'element',$mt:'prm',$t:{t:Anything},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("The indexes in this list at which the given element \noccurs.",60)),shared(),$default()];},d:['ceylon.language','List','$m','occurrences']};};
            $$list.firstOccurrence=function firstOccurrence(element$376){
                var $$list=this;
                var it$377 = (function(){var tmpvar$379=$$list.size;
                if (tmpvar$379>0){
                var tmpvar$380=(0);
                var tmpvar$381=tmpvar$380;
                for (var i=1; i<tmpvar$379; i++){tmpvar$381=tmpvar$381.successor;}
                return Range(tmpvar$380,tmpvar$381,{Element:{t:Integer}})
                }else return getEmpty();}()).iterator();
                var index$378;while ((index$378=it$377.next())!==getFinished()){
                    if($$list.occursAt(index$378,element$376)){
                        return index$378;
                    }
                }
                if (getFinished() === index$378){
                    return null;
                }
            };$$list.firstOccurrence.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Integer}]},$ps:[{$nm:'element',$mt:'prm',$t:{t:Anything},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("The first index in this list at which the given element \noccurs.",64)),shared(),$default()];},d:['ceylon.language','List','$m','firstOccurrence']};};
            $$list.lastOccurrence=function lastOccurrence(element$382){
                var $$list=this;
                var it$383 = (function(){var tmpvar$385=$$list.size;
                if (tmpvar$385>0){
                var tmpvar$386=(0);
                var tmpvar$387=tmpvar$386;
                for (var i=1; i<tmpvar$385; i++){tmpvar$387=tmpvar$387.successor;}
                return Range(tmpvar$386,tmpvar$387,{Element:{t:Integer}})
                }else return getEmpty();}()).reversed.iterator();
                var index$384;while ((index$384=it$383.next())!==getFinished()){
                    if($$list.occursAt(index$384,element$382)){
                        return index$384;
                    }
                }
                if (getFinished() === index$384){
                    return null;
                }
            };$$list.lastOccurrence.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Integer}]},$ps:[{$nm:'element',$mt:'prm',$t:{t:Anything},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("The last index in this list at which the given element \noccurs.",63)),shared(),$default()];},d:['ceylon.language','List','$m','lastOccurrence']};};
            $$list.indexes=function (selecting$388){
                var $$list=this;
                return Comprehension(function(){
                    var it$389=(function(){var tmpvar$391=$$list.size;
                    if (tmpvar$391>0){
                    var tmpvar$392=(0);
                    var tmpvar$393=tmpvar$392;
                    for (var i=1; i<tmpvar$391; i++){tmpvar$393=tmpvar$393.successor;}
                    return Range(tmpvar$392,tmpvar$393,{Element:{t:Integer}})
                    }else return getEmpty();}()).iterator();
                    var index$390=getFinished();
                    var next$index$390=function(){
                        while((index$390=it$389.next())!==getFinished()){
                            if(selecting$388((opt$394=$$list.$get(index$390),opt$394!==null?opt$394:getNothing()))){
                                return index$390;
                            }
                        }
                        return getFinished();
                    }
                    next$index$390();
                    return function(){
                        if(index$390!==getFinished()){
                            var index$390$395=index$390;
                            var tmpvar$396=index$390$395;
                            next$index$390();
                            return tmpvar$396;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:{t:Integer}});
            };
            $$list.indexes.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Integer}}},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[doc("The predicate the indexed elements must satisfy")];}}],$cont:List,$an:function(){return[doc(String$("The indexes in this list for which the element \nsatisfies the given predicate.",78)),shared(),$default()];},d:['ceylon.language','List','$m','indexes']};};
            $$list.trim=function trim(trimming$397){
                var $$list=this;
                var l$398;
                if((l$398=$$list.lastIndex)!==null){
                    var from$399=(-(1));
                    function setFrom$399(from$400){return from$399=from$400;};
                    $prop$getFrom$399={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','List','$m','trim','$at','from']};}};
                    $prop$getFrom$399.get=function(){return from$399};
                    $prop$getFrom$399.set=setFrom$399;
                    if (setFrom$399.$$metamodel$$===undefined)setFrom$399.$$metamodel$$=$prop$getFrom$399.$$metamodel$$;
                    var to$401=(-(1));
                    function setTo$401(to$402){return to$401=to$402;};
                    $prop$getTo$401={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','List','$m','trim','$at','to']};}};
                    $prop$getTo$401.get=function(){return to$401};
                    $prop$getTo$401.set=setTo$401;
                    if (setTo$401.$$metamodel$$===undefined)setTo$401.$$metamodel$$=$prop$getTo$401.$$metamodel$$;
                    var it$403 = Range((0),l$398,{Element:{t:Integer}}).iterator();
                    var index$404;while ((index$404=it$403.next())!==getFinished()){
                        if((!trimming$397((opt$405=$$list.$get(index$404),opt$405!==null?opt$405:getNothing())))){
                            from$399=index$404;
                            break;
                        }
                        var opt$405;
                    }
                    if (getFinished() === index$404){
                        return getEmpty();
                    }
                    var it$406 = Range(l$398,(0),{Element:{t:Integer}}).iterator();
                    var index$407;while ((index$407=it$406.next())!==getFinished()){
                        if((!trimming$397((opt$408=$$list.$get(index$407),opt$408!==null?opt$408:getNothing())))){
                            to$401=index$407;
                            break;
                        }
                        var opt$408;
                    }
                    if (getFinished() === index$407){
                        return getEmpty();
                    }
                    return $$list.span(from$399,to$401);
                }else {
                    return getEmpty();
                }
            };$$list.trim.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$ps:[{$nm:'trimming',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("Trim the elements satisfying the given predicate\nfunction from the start and end of this list, \nreturning a list no longer than this list.",138)),shared(),$default()];},d:['ceylon.language','List','$m','trim']};};
            $$list.trimLeading=function trimLeading(trimming$409){
                var $$list=this;
                var l$410;
                if((l$410=$$list.lastIndex)!==null){
                    var it$411 = Range((0),l$410,{Element:{t:Integer}}).iterator();
                    var index$412;while ((index$412=it$411.next())!==getFinished()){
                        if((!trimming$409((opt$413=$$list.$get(index$412),opt$413!==null?opt$413:getNothing())))){
                            return $$list.span(index$412,l$410);
                        }
                        var opt$413;
                    }
                }
                return getEmpty();
            };$$list.trimLeading.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$ps:[{$nm:'trimming',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("Trim the elements satisfying the given predicate\nfunction from the start of this list, returning \na list no longer than this list.",130)),shared(),$default()];},d:['ceylon.language','List','$m','trimLeading']};};
            $$list.trimTrailing=function trimTrailing(trimming$414){
                var $$list=this;
                var l$415;
                if((l$415=$$list.lastIndex)!==null){
                    var it$416 = Range(l$415,(0),{Element:{t:Integer}}).iterator();
                    var index$417;while ((index$417=it$416.next())!==getFinished()){
                        if((!trimming$414((opt$418=$$list.$get(index$417),opt$418!==null?opt$418:getNothing())))){
                            return $$list.span((0),index$417);
                        }
                        var opt$418;
                    }
                }
                return getEmpty();
            };$$list.trimTrailing.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$ps:[{$nm:'trimming',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("Trim the elements satisfying the given predicate\nfunction from the end of this list, returning a \nlist no longer than this list.",128)),shared(),$default()];},d:['ceylon.language','List','$m','trimTrailing']};};
            $$list.initial=function (length$419){
                var $$list=this;
                return $$list.segment((0),length$419);
            };
            $$list.initial.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$ps:[{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("Select the first elements of this list, returning a \nlist no longer than the given length. If this list is \nshorter than the given length, return this list. \nOtherwise return a list of the given length.",202)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$List().$$.prototype.terminal)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','List','$m','initial']};};
            $$list.terminal=function terminal(length$420){
                var $$list=this;
                var l$421;
                if((l$421=$$list.lastIndex)!==null&&length$420.compare((0)).equals(getLarger())){
                    return $$list.span(l$421.minus(length$420).plus((1)),l$421);
                }else {
                    return getEmpty();
                }
            };$$list.terminal.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$ps:[{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:List,$an:function(){return[doc(String$("Select the last elements of the list, returning a list \nno longer than the given length. If this list is \nshorter than the given length, return this list. \nOtherwise return a list of the given length.",200)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$List().$$.prototype.initial)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared(),$default()];},d:['ceylon.language','List','$m','terminal']};};
        })(List.$$.prototype);
    }
    return List;
}
exports.$init$List=$init$List;
$init$List();
var opt$277,opt$281,opt$394;
function Tuple(first, rest, $$targs$$,$$tuple){
    $init$Tuple();
    if ($$tuple===undefined)$$tuple=new Tuple.$$;
    set_type_args($$tuple,$$targs$$);
    $$tuple.first_=first;
    $$tuple.rest_=rest;
    Object$($$tuple);
    Sequence($$tuple.$$targs$$===undefined?$$targs$$:{Element:$$tuple.$$targs$$.Element},$$tuple);
    Cloneable($$tuple.$$targs$$===undefined?$$targs$$:{Clone:{t:'T', l:[$$tuple.$$targs$$.First]}},$$tuple);
    add_type_arg($$tuple,'Clone',{t:'T', l:[$$tuple.$$targs$$.First]});
    $$tuple.$prop$getFirst={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'First',$cont:Tuple,$an:function(){return[doc(String$("The first element of this tuple.",32)),shared(),actual()];},d:['ceylon.language','Tuple','$at','first']};}};
    $$tuple.$prop$getFirst.get=function(){return first};
    $$tuple.$prop$getRest={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Rest',$cont:Tuple,$an:function(){return[doc(String$("A tuple with the elements of this tuple, except\nfor the first element.",70)),shared(),actual()];},d:['ceylon.language','Tuple','$at','rest']};}};
    $$tuple.$prop$getRest.get=function(){return rest};
    return $$tuple;
}
Tuple.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Object$},$ps:[{$nm:'first',$mt:'prm',$t:'First',$an:function(){return[doc("The first element of this tuple."),shared(),actual()];}},{$nm:'rest',$mt:'prm',$t:'Rest',$an:function(){return[doc("A tuple with the elements of this tuple, except\nfor the first element."),shared(),actual()];}}],$tp:{Element:{'var':'out'},First:{'var':'out','satisfies':['Element']},Rest:{'var':'out','satisfies':[{t:Sequential,a:{Element:'Element'}}],'def':{t:Empty}}},satisfies:[{t:Sequence,a:{Element:'Element'}},{t:Cloneable,a:{Clone:{t:'T',l:[{$t:'First'}]}}}],$an:function(){return[doc(String$("A _tuple_ is a typed linked list. Each instance of \n`Tuple` represents the value and type of a single link.\nThe attributes `first` and `rest` allow us to retrieve\na value form the list without losing its static type \ninformation.\n\n    value point = Tuple(0.0, Tuple(0.0, Tuple(\"origin\")));\n    Float x = point.first;\n    Float y = point.rest.first;\n    String label = point.rest.rest.first;\n\nUsually, we abbreviate code involving tuples.\n\n    [Float,Float,String] point = [0.0, 0.0, \"origin\"];\n    Float x = point[0];\n    Float y = point[1];\n    String label = point[2];\n\nA list of types enclosed in brackets is an abbreviated \ntuple type. An instance of `Tuple` may be constructed \nby surrounding a value list in brackets:\n\n    [String,String] words = [\"hello\", \"world\"];\n\nThe index operator with a literal integer argument is a \nshortcut for a chain of evaluations of `rest` and \n`first`. For example, `point[1]` means `point.rest.first`.\n\nA _terminated_ tuple type is a tuple where the type of\nthe last link in the chain is `Empty`. An _unterminated_ \ntuple type is a tuple where the type of the last link\nin the chain is `Sequence` or `Sequential`. Thus, a \nterminated tuple type has a length that is known\nstatically. For an unterminated tuple type only a lower\nbound on its length is known statically.\n\nHere, `point` is an unterminated tuple:\n\n    String[] labels = ... ;\n    [Float,Float,String*] point = [0.0, 0.0, *labels];\n    Float x = point[0];\n    Float y = point[1];\n    String? firstLabel = point[2];\n    String[] allLabels = point[2...];",1553)),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared(),$final()];},d:['ceylon.language','Tuple']};};
exports.Tuple=Tuple;
function $init$Tuple(){
    if (Tuple.$$===undefined){
        initTypeProto(Tuple,'ceylon.language::Tuple',$init$Object$(),$init$Sequence(),$init$Cloneable());
        (function($$tuple){
            defineAttr($$tuple,'first',function(){return this.first_;},undefined,function(){return{mod:$$METAMODEL$$,$t:'First',$cont:Tuple,$an:function(){return[doc(String$("The first element of this tuple.",32)),shared(),actual()];},d:['ceylon.language','Tuple','$at','first']};});
            defineAttr($$tuple,'rest',function(){return this.rest_;},undefined,function(){return{mod:$$METAMODEL$$,$t:'Rest',$cont:Tuple,$an:function(){return[doc(String$("A tuple with the elements of this tuple, except\nfor the first element.",70)),shared(),actual()];},d:['ceylon.language','Tuple','$at','rest']};});
            defineAttr($$tuple,'size',function(){
                var $$tuple=this;
                return (1).plus($$tuple.rest.size);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Tuple,$an:function(){return[shared(),actual()];},d:['ceylon.language','Tuple','$at','size']};});
            $$tuple.$get=function $get(index$422){
                var $$tuple=this;
                
                var case$423=index$422.compare((0));
                if (case$423===getSmaller()) {
                    return null;
                }else if (case$423===getEqual()) {
                    return $$tuple.first;
                }else if (case$423===getLarger()) {
                    return $$tuple.rest.$get(index$422.minus((1)));
                }
            };$$tuple.$get.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$ps:[{$nm:'index',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Tuple,$an:function(){return[shared(),actual()];},d:['ceylon.language','Tuple','$m','get']};};
            defineAttr($$tuple,'lastIndex',function(){
                var $$tuple=this;
                var restLastIndex$424;
                if((restLastIndex$424=$$tuple.rest.lastIndex)!==null){
                    return restLastIndex$424.plus((1));
                }else {
                    return (0);
                }
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Tuple,$an:function(){return[shared(),actual()];},d:['ceylon.language','Tuple','$at','lastIndex']};});defineAttr($$tuple,'last',function(){
                var $$tuple=this;
                var rest$425;
                if(nonempty((rest$425=$$tuple.rest))){
                    return rest$425.last;
                }else {
                    return $$tuple.first;
                }
            },undefined,function(){return{mod:$$METAMODEL$$,$t:'Element',$cont:Tuple,$an:function(){return[shared(),actual()];},d:['ceylon.language','Tuple','$at','last']};});$$tuple.segment=function segment(from$426,length$427){
                var $$tuple=this;
                if((length$427.compare((0))!==getLarger())){
                    return getEmpty();
                }
                var realFrom$428=(opt$429=(from$426.compare((0)).equals(getSmaller())?(0):null),opt$429!==null?opt$429:from$426);
                var opt$429;
                if(realFrom$428.equals((0))){
                    return (opt$430=(length$427.equals((1))?Tuple($$tuple.first,getEmpty(),{Rest:{t:Empty},First:$$tuple.$$targs$$.First,Element:$$tuple.$$targs$$.First}):null),opt$430!==null?opt$430:$$tuple.rest.segment((0),length$427.plus(realFrom$428).minus((1))).withLeading($$tuple.first,{Other:$$tuple.$$targs$$.First}));
                    var opt$430;
                }
                return $$tuple.rest.segment(realFrom$428.minus((1)),length$427);
            };$$tuple.segment.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$ps:[{$nm:'from',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Tuple,$an:function(){return[shared(),actual()];},d:['ceylon.language','Tuple','$m','segment']};};
            $$tuple.span=function span(from$431,end$432){
                var $$tuple=this;
                if((from$431.compare((0)).equals(getSmaller())&&end$432.compare((0)).equals(getSmaller()))){
                    return getEmpty();
                }
                var realFrom$433=(opt$434=(from$431.compare((0)).equals(getSmaller())?(0):null),opt$434!==null?opt$434:from$431);
                var opt$434;
                var realEnd$435=(opt$436=(end$432.compare((0)).equals(getSmaller())?(0):null),opt$436!==null?opt$436:end$432);
                var opt$436;
                return (opt$437=((realFrom$433.compare(realEnd$435)!==getLarger())?$$tuple.segment(from$431,realEnd$435.minus(realFrom$433).plus((1))):null),opt$437!==null?opt$437:$$tuple.segment(realEnd$435,realFrom$433.minus(realEnd$435).plus((1))).reversed.sequence);
                var opt$437;
            };$$tuple.span.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$ps:[{$nm:'from',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'end',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Tuple,$an:function(){return[shared(),actual()];},d:['ceylon.language','Tuple','$m','span']};};
            $$tuple.spanTo=function (to$438){
                var $$tuple=this;
                return (opt$439=(to$438.compare((0)).equals(getSmaller())?getEmpty():null),opt$439!==null?opt$439:$$tuple.span((0),to$438));
            };$$tuple.spanFrom=function (from$440){
                var $$tuple=this;
                return $$tuple.span(from$440,$$tuple.size);
            };defineAttr($$tuple,'clone',function(){
                var $$tuple=this;
                return $$tuple;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'T',l:[{$t:'First'}]},$cont:Tuple,$an:function(){return[shared(),actual()];},d:['ceylon.language','Tuple','$at','clone']};});
            defineAttr($$tuple,'reversed',function(){
                var $$tuple=this;
                return $$tuple.rest.reversed.withTrailing($$tuple.first,{Other:$$tuple.$$targs$$.First});
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequence,a:{Element:'Element'}},$cont:Tuple,$an:function(){return[shared(),actual()];},d:['ceylon.language','Tuple','$at','reversed']};});
            $$tuple.iterator=function iterator(){
                var $$tuple=this;
                function iterator$441($$targs$$){
                    var $$iterator$441=new iterator$441.$$;
                    $$iterator$441.$$targs$$=$$targs$$;
                    Iterator({Element:$$tuple.$$targs$$.Element},$$iterator$441);
                    $$iterator$441.current$442_=$$tuple;
                    $$iterator$441.$prop$getCurrent$442={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$cont:iterator$441,$an:function(){return[variable()];},d:['ceylon.language','Tuple','$m','iterator','$o','iterator','$at','current']};}};
                    $$iterator$441.$prop$getCurrent$442.get=function(){return current$442};
                    return $$iterator$441;
                };iterator$441.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterator,a:{Element:'Element'}}],d:['ceylon.language','Tuple','$m','iterator','$o','iterator']};};
                function $init$iterator$441(){
                    if (iterator$441.$$===undefined){
                        initTypeProto(iterator$441,'ceylon.language::Tuple.iterator.iterator',Basic,$init$Iterator());
                        (function($$iterator$441){
                            defineAttr($$iterator$441,'current$442',function(){return this.current$442_;},function(current$443){return this.current$442_=current$443;},function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$cont:iterator$441,$an:function(){return[variable()];},d:['ceylon.language','Tuple','$m','iterator','$o','iterator','$at','current']};});
                            $$iterator$441.next=function next(){
                                var $$iterator$441=this;
                                var c$444;
                                if(nonempty((c$444=$$iterator$441.current$442))){
                                    $$iterator$441.current$442=c$444.rest;
                                    return c$444.first;
                                }else {
                                    return getFinished();
                                }
                            };$$iterator$441.next.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$ps:[],$cont:iterator$441,$an:function(){return[shared(),actual()];},d:['ceylon.language','Tuple','$m','iterator','$o','iterator','$m','next']};};
                        })(iterator$441.$$.prototype);
                    }
                    return iterator$441;
                }
                $init$iterator$441();
                var iterator$445;
                function getIterator$445(){
                    if (iterator$445===undefined){iterator$445=$init$iterator$441()({Element:$$tuple.$$targs$$.Element});iterator$445.$$metamodel$$=getIterator$445.$$metamodel$$;}
                    return iterator$445;
                }
                getIterator$445.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterator$441},d:['ceylon.language','Tuple','$m','iterator','$o','iterator']};};
                $prop$getIterator$445={get:getIterator$445,$$metamodel$$:getIterator$445.$$metamodel$$};
                return getIterator$445();
            };$$tuple.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$ps:[],$cont:Tuple,$an:function(){return[shared(),actual()];},d:['ceylon.language','Tuple','$m','iterator']};};
            $$tuple.contains=function contains(element$446){
                var $$tuple=this;
                var first$447;
                if((first$447=$$tuple.first)!==null&&first$447.equals(element$446)){
                    return true;
                }else {
                    return $$tuple.rest.contains(element$446);
                }
            };$$tuple.contains.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'element',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Tuple,$an:function(){return[shared(),actual()];},d:['ceylon.language','Tuple','$m','contains']};};
            $$tuple.withLeading=function (element$448,$$$mptypes){
                var $$tuple=this;
                return Tuple(element$448,$$tuple,{Rest:{t:'T', l:[$$tuple.$$targs$$.First]},First:$$$mptypes.Other,Element:{t:'u', l:[$$$mptypes.Other,$$tuple.$$targs$$.Element]}});
            };
            $$tuple.withLeading.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'T',l:[{$t:'Other'},{$t:'First'}]},$ps:[{$nm:'element',$mt:'prm',$t:'Other',$an:function(){return[doc("The first element of the resulting tuple.")];}}],$cont:Tuple,$tp:{Other:{}},$an:function(){return[doc(String$("Returns a new tuple that starts with the specified\nelement, followed by the elements of this tuple.",99)),shared(),actual()];},d:['ceylon.language','Tuple','$m','withLeading']};};
        })(Tuple.$$.prototype);
    }
    return Tuple;
}
exports.$init$Tuple=$init$Tuple;
$init$Tuple();
var opt$439;
function ChainedIterator(first$449, second$450, $$targs$$,$$chainedIterator){
    $init$ChainedIterator();
    if ($$chainedIterator===undefined)$$chainedIterator=new ChainedIterator.$$;
    set_type_args($$chainedIterator,$$targs$$);
    $$chainedIterator.first$449_=first$449;
    $$chainedIterator.second$450_=second$450;
    Iterator($$chainedIterator.$$targs$$===undefined?$$targs$$:{Element:{t:'u', l:[$$chainedIterator.$$targs$$.Element,$$chainedIterator.$$targs$$.Other]}},$$chainedIterator);
    $$chainedIterator.iter$451_=$$chainedIterator.first$449.iterator();
    $$chainedIterator.$prop$getIter$451={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:{t:'u', l:['Element','Other']}}},$cont:ChainedIterator,$an:function(){return[variable()];},d:['ceylon.language','ChainedIterator','$at','iter']};}};
    $$chainedIterator.$prop$getIter$451.get=function(){return iter$451};
    $$chainedIterator.more$452_=true;
    $$chainedIterator.$prop$getMore$452={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ChainedIterator,$an:function(){return[variable()];},d:['ceylon.language','ChainedIterator','$at','more']};}};
    $$chainedIterator.$prop$getMore$452.get=function(){return more$452};
    return $$chainedIterator;
}
ChainedIterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[{$nm:'first',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$an:function(){return[];}},{$nm:'second',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Other'}},$an:function(){return[];}}],$tp:{Element:{'var':'out'},Other:{'var':'out'}},satisfies:[{t:Iterator,a:{Element:{t:'u', l:['Element','Other']}}}],$an:function(){return[doc(String$("An `Iterator` that returns the elements of two\n`Iterable`s, as if they were chained together.",93)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Iterable().$$.prototype.chain)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),by([String$("Enrique Zamudio",15)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}}))];},d:['ceylon.language','ChainedIterator']};};
function $init$ChainedIterator(){
    if (ChainedIterator.$$===undefined){
        initTypeProto(ChainedIterator,'ceylon.language::ChainedIterator',Basic,$init$Iterator());
        (function($$chainedIterator){
            defineAttr($$chainedIterator,'iter$451',function(){return this.iter$451_;},function(iter$453){return this.iter$451_=iter$453;},function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:{t:'u', l:['Element','Other']}}},$cont:ChainedIterator,$an:function(){return[variable()];},d:['ceylon.language','ChainedIterator','$at','iter']};});
            defineAttr($$chainedIterator,'more$452',function(){return this.more$452_;},function(more$454){return this.more$452_=more$454;},function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ChainedIterator,$an:function(){return[variable()];},d:['ceylon.language','ChainedIterator','$at','more']};});
            $$chainedIterator.next=function next(){
                var $$chainedIterator=this;
                var e$455=$$chainedIterator.iter$451.next();
                function setE$455(e$456){return e$455=e$456;};
                var f$457;
                if(isOfType((f$457=e$455),{t:Finished})){
                    if($$chainedIterator.more$452){
                        $$chainedIterator.iter$451=$$chainedIterator.second$450.iterator();
                        $$chainedIterator.more$452=false;
                        e$455=$$chainedIterator.iter$451.next();
                    }
                }
                return e$455;
            };$$chainedIterator.next.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element','Other',{t:Finished}]},$ps:[],$cont:ChainedIterator,$an:function(){return[shared(),actual()];},d:['ceylon.language','ChainedIterator','$m','next']};};
            defineAttr($$chainedIterator,'first$449',function(){return this.first$449_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$cont:ChainedIterator,d:['ceylon.language','ChainedIterator','$at','first']};});
            defineAttr($$chainedIterator,'second$450',function(){return this.second$450_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:'Other'}},$cont:ChainedIterator,d:['ceylon.language','ChainedIterator','$at','second']};});
        })(ChainedIterator.$$.prototype);
    }
    return ChainedIterator;
}
exports.$init$ChainedIterator=$init$ChainedIterator;
$init$ChainedIterator();
function Entry(key, item, $$targs$$,$$entry){
    $init$Entry();
    if ($$entry===undefined)$$entry=new Entry.$$;
    set_type_args($$entry,$$targs$$);
    $$entry.key_=key;
    $$entry.item_=item;
    Object$($$entry);
    $$entry.$prop$getKey={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Key',$cont:Entry,$an:function(){return[doc(String$("The key used to access the entry.",33)),shared()];},d:['ceylon.language','Entry','$at','key']};}};
    $$entry.$prop$getKey.get=function(){return key};
    $$entry.$prop$getItem={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Item',$cont:Entry,$an:function(){return[doc(String$("The value associated with the key.",34)),shared()];},d:['ceylon.language','Entry','$at','item']};}};
    $$entry.$prop$getItem.get=function(){return item};
    $$entry.$prop$getPair={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'T',l:[{$t:'Key'},{$t:'Item'}]},$cont:Entry,$an:function(){return[doc(String$("A pair (2 element tuple) with the key and\nitem of this entry.",61)),shared()];},d:['ceylon.language','Entry','$at','pair']};}};
    $$entry.$prop$getPair.get=function(){return pair};
    $$entry.$prop$getString={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Entry,$an:function(){return[doc(String$("Returns a description of the entry in the form \n`key->item`.",60)),shared(),actual()];},d:['ceylon.language','Entry','$at','string']};}};
    $$entry.$prop$getString.get=function(){return string};
    return $$entry;
}
Entry.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Object$},$ps:[{$nm:'key',$mt:'prm',$t:'Key',$an:function(){return[doc("The key used to access the entry."),shared()];}},{$nm:'item',$mt:'prm',$t:'Item',$an:function(){return[doc("The value associated with the key."),shared()];}}],$tp:{Key:{'var':'out','satisfies':[{t:Object$}]},Item:{'var':'out','satisfies':[{t:Object$}]}},$an:function(){return[doc(String$("A pair containing a _key_ and an associated value called \nthe _item_. Used primarily to represent the elements of \na `Map`. The type `Entry<Key,Item>` may be abbreviated \n`Key->Item`. An instance of `Entry` may be constructed \nusing the `->` operator:\n\n    String->Person entry = person.name->person;\n",301)),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared(),$final()];},d:['ceylon.language','Entry']};};
exports.Entry=Entry;
function $init$Entry(){
    if (Entry.$$===undefined){
        initTypeProto(Entry,'ceylon.language::Entry',$init$Object$());
        (function($$entry){
            defineAttr($$entry,'key',function(){return this.key_;},undefined,function(){return{mod:$$METAMODEL$$,$t:'Key',$cont:Entry,$an:function(){return[doc(String$("The key used to access the entry.",33)),shared()];},d:['ceylon.language','Entry','$at','key']};});
            defineAttr($$entry,'item',function(){return this.item_;},undefined,function(){return{mod:$$METAMODEL$$,$t:'Item',$cont:Entry,$an:function(){return[doc(String$("The value associated with the key.",34)),shared()];},d:['ceylon.language','Entry','$at','item']};});
            defineAttr($$entry,'pair',function(){
                var $$entry=this;
                return Tuple($$entry.key,Tuple($$entry.item,getEmpty(),{Rest:{t:Empty},First:$$entry.$$targs$$.Item,Element:$$entry.$$targs$$.Item}),{Rest:{t:'T', l:[$$entry.$$targs$$.Item]},First:$$entry.$$targs$$.Key,Element:{t:'u', l:[$$entry.$$targs$$.Key,$$entry.$$targs$$.Item]}});
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'T',l:[{$t:'Key'},{$t:'Item'}]},$cont:Entry,$an:function(){return[doc(String$("A pair (2 element tuple) with the key and\nitem of this entry.",61)),shared()];},d:['ceylon.language','Entry','$at','pair']};});
            $$entry.equals=function equals(that$458){
                var $$entry=this;
                var that$459;
                if(isOfType((that$459=that$458),{t:Entry,a:{Key:{t:Object$},Item:{t:Object$}}})){
                    return ($$entry.key.equals(that$459.key)&&$$entry.item.equals(that$459.item));
                }else {
                    return false;
                }
            };$$entry.equals.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'that',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Entry,$an:function(){return[doc(String$("Determines if this entry is equal to the given entry. \nTwo entries are equal if they have the same key and \nthe same value.",123)),shared(),actual()];},d:['ceylon.language','Entry','$m','equals']};};
            defineAttr($$entry,'hash',function(){
                var $$entry=this;
                return (31).plus($$entry.key.hash).times((31)).plus($$entry.item.hash);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Entry,$an:function(){return[shared(),actual()];},d:['ceylon.language','Entry','$at','hash']};});
            defineAttr($$entry,'string',function(){
                var $$entry=this;
                return StringBuilder().appendAll([$$entry.key.string,String$("->",2),$$entry.item.string]).string;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Entry,$an:function(){return[doc(String$("Returns a description of the entry in the form \n`key->item`.",60)),shared(),actual()];},d:['ceylon.language','Entry','$at','string']};});
        })(Entry.$$.prototype);
    }
    return Entry;
}
exports.$init$Entry=$init$Entry;
$init$Entry();
function Comparable($$targs$$,$$comparable){
    set_type_args($$comparable,$$targs$$);
}
Comparable.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Other:{'var':'in','satisfies':[{t:Comparable,a:{Other:'Other'}}]}},of:['Other'],$an:function(){return[doc(String$("The general contract for values whose magnitude can be \ncompared. `Comparable` imposes a total ordering upon\ninstances of any type that satisfies the interface.\nIf a type `T` satisfies `Comparable<T>`, then instances\nof `T` may be compared using the comparison operators\n`<`, `>`, `<=`, `>=`, and `<=>`.\n\nThe total order of a type must be consistent with the \ndefinition of equality for the type. That is, there\nare three mutually exclusive possibilities:\n\n- `x<y`,\n- `x>y`, or\n- `x==y`",486)),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','Comparable']};};
exports.Comparable=Comparable;
function $init$Comparable(){
    if (Comparable.$$===undefined){
        initTypeProtoI(Comparable,'ceylon.language::Comparable');
        (function($$comparable){
            $$comparable.compare={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Comparison},$ps:[{$nm:'other',$mt:'prm',$t:'Other',$an:function(){return[];}}],$cont:Comparable,$an:function(){return[doc("Compares this value with the given value. \nImplementations must respect the constraints that: \n\n- `x==y` if and only if `x<=>y == equal` \n   (consistency with `equals()`), \n- if `x>y` then `y<x` (symmetry), and \n- if `x>y` and `y>z` then `x>z` (transitivity)."),see("equals"),shared(),formal()];},d:['ceylon.language','Comparable','$m','compare']};}};
        })(Comparable.$$.prototype);
    }
    return Comparable;
}
exports.$init$Comparable=$init$Comparable;
$init$Comparable();
function Invertable($$targs$$,$$invertable){
    set_type_args($$invertable,$$targs$$);
}
Invertable.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Inverse:{'var':'out','satisfies':[{t:Invertable,a:{Inverse:'Inverse'}}]}},of:['Inverse'],$an:function(){return[doc(String$("Abstraction of types which support a unary additive \ninversion operation `-x`. For a [[numeric type|Numeric]], \nthis should return the negative of the argument value.\n\nImplementations which also satisfy [[Summable]] should \nrespect the following constraint:\n\n- `x + -x == 0`",274)),see([$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Integer),$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Float)].reifyCeylonType({Absent:{t:Null},Element:{t:ClassDeclaration$meta$declaration}})),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','Invertable']};};
exports.Invertable=Invertable;
function $init$Invertable(){
    if (Invertable.$$===undefined){
        initTypeProtoI(Invertable,'ceylon.language::Invertable');
        (function($$invertable){
            $$invertable.$prop$getNegativeValue={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Inverse',$cont:Invertable,$an:function(){return[doc(String$("The additive inverse of the value, which may be expressed\nas an instance of a wider type.",89)),shared(),formal()];},d:['ceylon.language','Invertable','$at','negativeValue']};}};
            $$invertable.$prop$getPositiveValue={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Inverse',$cont:Invertable,$an:function(){return[doc(String$("The value itself, expressed as an instance of the\nwider type.",61)),shared(),formal()];},d:['ceylon.language','Invertable','$at','positiveValue']};}};
        })(Invertable.$$.prototype);
    }
    return Invertable;
}
exports.$init$Invertable=$init$Invertable;
$init$Invertable();
function Summable($$targs$$,$$summable){
    set_type_args($$summable,$$targs$$);
}
Summable.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Other:{'satisfies':[{t:Summable,a:{Other:'Other'}}]}},of:['Other'],$an:function(){return[doc(String$("Abstraction of types which support a binary addition\noperator `x + y`. For [[numeric types|Numeric]], this \nis just familiar numeric addition. For [[String]], it \nis string concatenation.\n\nIn general, the addition operation should be a \nbinary associative operation.",266)),see([$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),String),$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Numeric)].reifyCeylonType({Absent:{t:Null},Element:{t:'u', l:[{t:ClassDeclaration$meta$declaration},{t:InterfaceDeclaration$meta$declaration}]}})),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','Summable']};};
exports.Summable=Summable;
function $init$Summable(){
    if (Summable.$$===undefined){
        initTypeProtoI(Summable,'ceylon.language::Summable');
        (function($$summable){
            $$summable.plus={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$ps:[{$nm:'other',$mt:'prm',$t:'Other',$an:function(){return[];}}],$cont:Summable,$an:function(){return[doc("The result of adding the given value to this value. \nThis operation should never perform any kind of \nmutation upon either the receiving value or the \nargument value."),shared(),formal()];},d:['ceylon.language','Summable','$m','plus']};}};
        })(Summable.$$.prototype);
    }
    return Summable;
}
exports.$init$Summable=$init$Summable;
$init$Summable();
function Ordinal($$targs$$,$$ordinal){
    set_type_args($$ordinal,$$targs$$);
}
Ordinal.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Other:{'var':'out','satisfies':[{t:Ordinal,a:{Other:'Other'}}]}},of:['Other'],$an:function(){return[doc(String$("Abstraction of ordinal types, that is, types with \nsuccessor and predecessor operations, including\n`Integer` and other `Integral` numeric types.\n`Character` is also considered an ordinal type. \n`Ordinal` types may be used to generate a `Range`.",244)),see([$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Character),$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Integer),$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Integral),$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Range)].reifyCeylonType({Absent:{t:Null},Element:{t:'u', l:[{t:ClassDeclaration$meta$declaration},{t:InterfaceDeclaration$meta$declaration}]}})),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','Ordinal']};};
exports.Ordinal=Ordinal;
function $init$Ordinal(){
    if (Ordinal.$$===undefined){
        initTypeProtoI(Ordinal,'ceylon.language::Ordinal');
        (function($$ordinal){
            $$ordinal.$prop$getSuccessor={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$cont:Ordinal,$an:function(){return[doc(String$("The successor of this value.",28)),shared(),formal()];},d:['ceylon.language','Ordinal','$at','successor']};}};
            $$ordinal.$prop$getPredecessor={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$cont:Ordinal,$an:function(){return[doc(String$("The predecessor of this value.",30)),shared(),formal()];},d:['ceylon.language','Ordinal','$at','predecessor']};}};
        })(Ordinal.$$.prototype);
    }
    return Ordinal;
}
exports.$init$Ordinal=$init$Ordinal;
$init$Ordinal();
function Enumerable($$targs$$,$$enumerable){
    Ordinal($$enumerable.$$targs$$===undefined?$$targs$$:{Other:$$enumerable.$$targs$$.Other},$$enumerable);
    set_type_args($$enumerable,$$targs$$);
}
Enumerable.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Other:{'var':'out','satisfies':[{t:Enumerable,a:{Other:'Other'}}]}},satisfies:[{t:Ordinal,a:{Other:'Other'}}],of:['Other'],$an:function(){return[doc(String$("Abstraction of ordinal types whose instances can be \nmapped to the integers or to a range of integers.",102)),shared()];},d:['ceylon.language','Enumerable']};};
exports.Enumerable=Enumerable;
function $init$Enumerable(){
    if (Enumerable.$$===undefined){
        initTypeProtoI(Enumerable,'ceylon.language::Enumerable',$init$Ordinal());
        (function($$enumerable){
            $$enumerable.$prop$getIntegerValue={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Enumerable,$an:function(){return[doc(String$("The corresponding integer. The implementation must\nsatisfy these constraints:\n\n    (x.successor).integerValue = x.integerValue+1\n    (x.predecessor).integerValue = x.integerValue-1\n\nfor every instance `x` of the enumerable type.",228)),shared(),formal()];},d:['ceylon.language','Enumerable','$at','integerValue']};}};
        })(Enumerable.$$.prototype);
    }
    return Enumerable;
}
exports.$init$Enumerable=$init$Enumerable;
$init$Enumerable();
function Numeric($$targs$$,$$numeric){
    Summable($$numeric.$$targs$$===undefined?$$targs$$:{Other:$$numeric.$$targs$$.Other},$$numeric);
    Invertable($$numeric.$$targs$$===undefined?$$targs$$:{Inverse:$$numeric.$$targs$$.Other},$$numeric);
    set_type_args($$numeric,$$targs$$);
}
Numeric.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Other:{'satisfies':[{t:Numeric,a:{Other:'Other'}}]}},satisfies:[{t:Summable,a:{Other:'Other'}},{t:Invertable,a:{Inverse:'Other'}}],of:['Other'],$an:function(){return[doc(String$("Abstraction of numeric types with addition, \n`x + y`, subtraction, `x - y`, multiplication, \n`x * y`, and division, `x / y`, along with \nadditive inverse `-x`.\n\nIn general, a numeric type need not define a\n[[total order|Comparable]]. For example, complex \nnumbers do not have a total order. Numeric types \nwith a total order also satisfy [[Scalar]].",349)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Scalar)].reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceDeclaration$meta$declaration}})),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','Numeric']};};
exports.Numeric=Numeric;
function $init$Numeric(){
    if (Numeric.$$===undefined){
        initTypeProtoI(Numeric,'ceylon.language::Numeric',$init$Summable(),$init$Invertable());
        (function($$numeric){
            $$numeric.minus={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$ps:[{$nm:'other',$mt:'prm',$t:'Other',$an:function(){return[];}}],$cont:Numeric,$an:function(){return[doc("The difference between this number and the given \nnumber."),shared(),formal()];},d:['ceylon.language','Numeric','$m','minus']};}};$$numeric.times={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$ps:[{$nm:'other',$mt:'prm',$t:'Other',$an:function(){return[];}}],$cont:Numeric,$an:function(){return[doc("The product of this number and the given number."),shared(),formal()];},d:['ceylon.language','Numeric','$m','times']};}};$$numeric.divided={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$ps:[{$nm:'other',$mt:'prm',$t:'Other',$an:function(){return[];}}],$cont:Numeric,$an:function(){return[doc("The quotient obtained by dividing this number by \nthe given number. For integral numeric types, this \noperation results in a remainder."),see("Integral"),shared(),formal()];},d:['ceylon.language','Numeric','$m','divided']};}};
        })(Numeric.$$.prototype);
    }
    return Numeric;
}
exports.$init$Numeric=$init$Numeric;
$init$Numeric();
function Scalar($$targs$$,$$scalar){
    Numeric($$scalar.$$targs$$===undefined?$$targs$$:{Other:$$scalar.$$targs$$.Other},$$scalar);
    Comparable($$scalar.$$targs$$===undefined?$$targs$$:{Other:$$scalar.$$targs$$.Other},$$scalar);
    Number($$scalar);
    set_type_args($$scalar,$$targs$$);
}
Scalar.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Other:{'satisfies':[{t:Scalar,a:{Other:'Other'}}]}},satisfies:[{t:Numeric,a:{Other:'Other'}},{t:Comparable,a:{Other:'Other'}},{t:Number$}],of:['Other'],$an:function(){return[doc(String$("Abstraction of [[numeric|Numeric]] types representing \nscalar values with a [[total order|Comparable]], \nincluding the built-in numeric types [[Integer]] and \n[[Float]].",169)),see([$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Integer),$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Float)].reifyCeylonType({Absent:{t:Null},Element:{t:ClassDeclaration$meta$declaration}})),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','Scalar']};};
exports.Scalar=Scalar;
function $init$Scalar(){
    if (Scalar.$$===undefined){
        initTypeProtoI(Scalar,'ceylon.language::Scalar',$init$Numeric(),$init$Comparable(),$init$Number$());
        (function($$scalar){
            $$scalar.$prop$getMagnitude={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$cont:Scalar,$an:function(){return[doc(String$("The magnitude of this number.",29)),shared(),actual(),formal()];},d:['ceylon.language','Scalar','$at','magnitude']};}};
            $$scalar.$prop$getFractionalPart={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$cont:Scalar,$an:function(){return[doc(String$("The fractional part of the number, after truncation \nof the integral part. For integral numeric types,\nthe fractional part is always zero.",138)),shared(),actual(),formal()];},d:['ceylon.language','Scalar','$at','fractionalPart']};}};
            $$scalar.$prop$getWholePart={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$cont:Scalar,$an:function(){return[doc(String$("The integral value of the number after truncation \nof the fractional part. For integral numeric types,\nthe integral value of a number is the number \nitself.",156)),shared(),actual(),formal()];},d:['ceylon.language','Scalar','$at','wholePart']};}};
        })(Scalar.$$.prototype);
    }
    return Scalar;
}
exports.$init$Scalar=$init$Scalar;
$init$Scalar();
function Exponentiable($$targs$$,$$exponentiable){
    Numeric($$exponentiable.$$targs$$===undefined?$$targs$$:{Other:$$exponentiable.$$targs$$.This},$$exponentiable);
    set_type_args($$exponentiable,$$targs$$);
}
Exponentiable.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{This:{'satisfies':[{t:Exponentiable,a:{Other:'Other',This:'This'}}]},Other:{'satisfies':[{t:Numeric,a:{Other:'Other'}}]}},satisfies:[{t:Numeric,a:{Other:'This'}}],of:['This'],$an:function(){return[doc(String$("Abstraction of [[numeric types|Numeric]] that may be \nraised to a power `x^p`. Note that the type of the \nexponent may be different to the numeric type which \nmay be exponentiated.",180)),see([$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Integer),$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Float)].reifyCeylonType({Absent:{t:Null},Element:{t:ClassDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','Exponentiable']};};
exports.Exponentiable=Exponentiable;
function $init$Exponentiable(){
    if (Exponentiable.$$===undefined){
        initTypeProtoI(Exponentiable,'ceylon.language::Exponentiable',$init$Numeric());
        (function($$exponentiable){
            $$exponentiable.power={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'This',$ps:[{$nm:'other',$mt:'prm',$t:'Other',$an:function(){return[];}}],$cont:Exponentiable,$an:function(){return[doc("The result of raising this number to the given\npower."),shared(),formal()];},d:['ceylon.language','Exponentiable','$m','power']};}};
        })(Exponentiable.$$.prototype);
    }
    return Exponentiable;
}
exports.$init$Exponentiable=$init$Exponentiable;
$init$Exponentiable();
function Integral($$targs$$,$$integral){
    Numeric($$integral.$$targs$$===undefined?$$targs$$:{Other:$$integral.$$targs$$.Other},$$integral);
    Enumerable($$integral.$$targs$$===undefined?$$targs$$:{Other:$$integral.$$targs$$.Other},$$integral);
    set_type_args($$integral,$$targs$$);
}
Integral.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Other:{'satisfies':[{t:Integral,a:{Other:'Other'}}]}},satisfies:[{t:Numeric,a:{Other:'Other'}},{t:Enumerable,a:{Other:'Other'}}],of:['Other'],$an:function(){return[doc(String$("Abstraction of integral numeric types. That is, types \nwith no fractional part, including `Integer`. The \ndivision operation for integral numeric types results \nin a remainder. Therefore, integral numeric types have \nan operation to determine the remainder of any division \noperation.",284)),see([$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Integer)].reifyCeylonType({Absent:{t:Null},Element:{t:ClassDeclaration$meta$declaration}})),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','Integral']};};
exports.Integral=Integral;
function $init$Integral(){
    if (Integral.$$===undefined){
        initTypeProtoI(Integral,'ceylon.language::Integral',$init$Numeric(),$init$Enumerable());
        (function($$integral){
            $$integral.remainder={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Other',$ps:[{$nm:'other',$mt:'prm',$t:'Other',$an:function(){return[];}}],$cont:Integral,$an:function(){return[doc("The remainder, after dividing this number by the \ngiven number."),see("Numeric.divided"),shared(),formal()];},d:['ceylon.language','Integral','$m','remainder']};}};$$integral.$prop$getZero={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Integral,$an:function(){return[doc(String$("Determine if the number is zero.",32)),shared(),formal()];},d:['ceylon.language','Integral','$at','zero']};}};
            $$integral.$prop$getUnit={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Integral,$an:function(){return[doc(String$("Determine if the number is one.",31)),shared(),formal()];},d:['ceylon.language','Integral','$at','unit']};}};
            $$integral.divides=function (other$460){
                var $$integral=this;
                return other$460.remainder($$integral).zero;
            };
            $$integral.divides.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'other',$mt:'prm',$t:'Other',$an:function(){return[];}}],$cont:Integral,$an:function(){return[doc(String$("Determine if this number is a factor of the given \nnumber.",58)),shared()];},d:['ceylon.language','Integral','$m','divides']};};
        })(Integral.$$.prototype);
    }
    return Integral;
}
exports.$init$Integral=$init$Integral;
$init$Integral();
function Scalable($$targs$$,$$scalable){
    set_type_args($$scalable,$$targs$$);
}
Scalable.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Scale:{'var':'in','satisfies':[{t:Numeric,a:{Other:'Scale'}}]},Value:{'var':'out','satisfies':[{t:Scalable,a:{Value:'Value',Scale:'Scale'}}]}},of:['Value'],$an:function(){return[doc(String$("Abstract supertype of types that support scaling by\na numeric factor `s ** x`. Examples of such types\ninclude vectors and matrices.\n\nImplementations should generally respect the \nfollowing constraints, where relevant:\n\n- `x == 1**x`\n\nImplementations of `Scalable` are encouraged to also\nsatisfy [[Invertable]], in which case, the following\nidentity should be respected:\n\n- `-x == -1**x`\n\nImplementations of `Scalable` usually also satisfy \n[[Summable]], in which case, the following identity \nshould be respected:\n\n- `x+x == 2**x`",530)),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','Scalable']};};
exports.Scalable=Scalable;
function $init$Scalable(){
    if (Scalable.$$===undefined){
        initTypeProtoI(Scalable,'ceylon.language::Scalable');
        (function($$scalable){
            $$scalable.scale={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Value',$ps:[{$nm:'scalar',$mt:'prm',$t:'Scale',$an:function(){return[];}}],$cont:Scalable,$an:function(){return[doc("Scale this value by the given scale factor."),shared(),formal()];},d:['ceylon.language','Scalable','$m','scale']};}};
        })(Scalable.$$.prototype);
    }
    return Scalable;
}
exports.$init$Scalable=$init$Scalable;
$init$Scalable();
function NegativeNumberException($$negativeNumberException){
    $init$NegativeNumberException();
    if ($$negativeNumberException===undefined)$$negativeNumberException=new NegativeNumberException.$$;
    Exception(String$("Negative number",15),null,$$negativeNumberException);
    return $$negativeNumberException;
}
NegativeNumberException.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Exception},$ps:[],$an:function(){return[doc(String$("Thrown when a negative number is not allowed.",45)),shared()];},d:['ceylon.language','NegativeNumberException']};};
exports.NegativeNumberException=NegativeNumberException;
function $init$NegativeNumberException(){
    if (NegativeNumberException.$$===undefined){
        initTypeProto(NegativeNumberException,'ceylon.language::NegativeNumberException',$init$Exception());
    }
    return NegativeNumberException;
}
exports.$init$NegativeNumberException=$init$NegativeNumberException;
$init$NegativeNumberException();
function OverflowException($$overflowException){
    $init$OverflowException();
    if ($$overflowException===undefined)$$overflowException=new OverflowException.$$;
    Exception(String$("Numeric overflow",16),null,$$overflowException);
    return $$overflowException;
}
OverflowException.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Exception},$ps:[],$an:function(){return[doc(String$("Thrown when a mathematical operation caused a number to \noverflow from its bounds.",82)),shared()];},d:['ceylon.language','OverflowException']};};
exports.OverflowException=OverflowException;
function $init$OverflowException(){
    if (OverflowException.$$===undefined){
        initTypeProto(OverflowException,'ceylon.language::OverflowException',$init$Exception());
    }
    return OverflowException;
}
exports.$init$OverflowException=$init$OverflowException;
$init$OverflowException();
function InitializationException(description$461, $$initializationException){
    $init$InitializationException();
    if ($$initializationException===undefined)$$initializationException=new InitializationException.$$;
    $$initializationException.description$461_=description$461;
    Exception($$initializationException.description$461,null,$$initializationException);
    return $$initializationException;
}
InitializationException.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Exception},$ps:[{$nm:'description',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$an:function(){return[doc(String$("Thrown when a problem was detected with value initialization.\n\nPossible problems include:\n\n* when a value could not be initialized due to recursive access during initialization, \n* an attempt to use a `late` value before it was initialized, \n* an attempt to assign to a `late` but non-`variable` value after it was initialized.",327)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),late)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','InitializationException']};};
exports.InitializationException=InitializationException;
function $init$InitializationException(){
    if (InitializationException.$$===undefined){
        initTypeProto(InitializationException,'ceylon.language::InitializationException',$init$Exception());
        (function($$initializationException){
            defineAttr($$initializationException,'description$461',function(){return this.description$461_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:InitializationException,d:['ceylon.language','InitializationException','$at','description']};});
        })(InitializationException.$$.prototype);
    }
    return InitializationException;
}
exports.$init$InitializationException=$init$InitializationException;
$init$InitializationException();
function Set($$targs$$,$$set){
    Collection($$set.$$targs$$===undefined?$$targs$$:{Element:$$set.$$targs$$.Element},$$set);
    Cloneable($$set.$$targs$$===undefined?$$targs$$:{Clone:{t:Set,a:{Element:$$set.$$targs$$.Element}}},$$set);
    add_type_arg($$set,'Clone',{t:Set,a:{Element:$$set.$$targs$$.Element}});
    set_type_args($$set,$$targs$$);
}
Set.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Element:{'var':'out','satisfies':[{t:Object$}]}},satisfies:[{t:Collection,a:{Element:'Element'}},{t:Cloneable,a:{Clone:{t:Set,a:{Element:'Element'}}}}],$an:function(){return[doc(String$("A collection of unique elements.\n\nA `Set` is a `Collection` of its elements.\n\nSets may be the subject of the binary union, \nintersection, and complement operators `|`, `&`, and \n`~`.",182)),shared()];},d:['ceylon.language','Set']};};
exports.Set=Set;
function $init$Set(){
    if (Set.$$===undefined){
        initTypeProtoI(Set,'ceylon.language::Set',$init$Collection(),$init$Cloneable());
        (function($$set){
            $$set.superset=function superset(set$462){
                var $$set=this;
                var it$463 = set$462.iterator();
                var element$464;while ((element$464=it$463.next())!==getFinished()){
                    if((!$$set.contains(element$464))){
                        return false;
                    }
                }
                if (getFinished() === element$464){
                    return true;
                }
            };$$set.superset.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'set',$mt:'prm',$t:{t:Set,a:{Element:{t:Object$}}},$an:function(){return[];}}],$cont:Set,$an:function(){return[doc(String$("Determines if this `Set` is a superset of the \nspecified Set, that is, if this `Set` contains all \nof the elements in the specified `Set`.",138)),shared(),$default()];},d:['ceylon.language','Set','$m','superset']};};
            $$set.subset=function subset(set$465){
                var $$set=this;
                var it$466 = $$set.iterator();
                var element$467;while ((element$467=it$466.next())!==getFinished()){
                    if((!set$465.contains(element$467))){
                        return false;
                    }
                }
                if (getFinished() === element$467){
                    return true;
                }
            };$$set.subset.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'set',$mt:'prm',$t:{t:Set,a:{Element:{t:Object$}}},$an:function(){return[];}}],$cont:Set,$an:function(){return[doc(String$("Determines if this `Set` is a subset of the given \n`Set`, that is, if the given set contains all of \nthe elements in this set.",126)),shared(),$default()];},d:['ceylon.language','Set','$m','subset']};};
            $$set.equals=function equals(that$468){
                var $$set=this;
                var that$469;
                if(isOfType((that$469=that$468),{t:Set,a:{Element:{t:Object$}}})&&that$469.size.equals($$set.size)){
                    var it$470 = $$set.iterator();
                    var element$471;while ((element$471=it$470.next())!==getFinished()){
                        if((!that$469.contains(element$471))){
                            return false;
                        }
                    }
                    if (getFinished() === element$471){
                        return true;
                    }
                }
                return false;
            };$$set.equals.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'that',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Set,$an:function(){return[doc(String$("Two `Set`s are considered equal if they have the \nsame size and if every element of the first set is\nalso an element of the second set, as determined\nby `contains()`.",166)),shared(),actual(),$default()];},d:['ceylon.language','Set','$m','equals']};};
            defineAttr($$set,'hash',function(){
                var $$set=this;
                var hashCode$472=(1);
                function setHashCode$472(hashCode$473){return hashCode$472=hashCode$473;};
                $prop$getHashCode$472={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','Set','$at','hash','$at','hashCode']};}};
                $prop$getHashCode$472.get=function(){return hashCode$472};
                $prop$getHashCode$472.set=setHashCode$472;
                if (setHashCode$472.$$metamodel$$===undefined)setHashCode$472.$$metamodel$$=$prop$getHashCode$472.$$metamodel$$;
                var it$474 = $$set.iterator();
                var elem$475;while ((elem$475=it$474.next())!==getFinished()){
                    (hashCode$472=hashCode$472.times((31)));
                    (hashCode$472=hashCode$472.plus(elem$475.hash));
                }
                return hashCode$472;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Set,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','Set','$at','hash']};});$$set.union={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:'u', l:['Element','Other']}}},$ps:[{$nm:'set',$mt:'prm',$t:{t:Set,a:{Element:'Other'}},$an:function(){return[];}}],$cont:Set,$tp:{Other:{'satisfies':[{t:Object$}]}},$an:function(){return[doc("Returns a new `Set` containing all the elements of \nthis `Set` and all the elements of the given `Set`."),shared(),formal()];},d:['ceylon.language','Set','$m','union']};}};$$set.intersection={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:'i', l:['Element','Other']}}},$ps:[{$nm:'set',$mt:'prm',$t:{t:Set,a:{Element:'Other'}},$an:function(){return[];}}],$cont:Set,$tp:{Other:{'satisfies':[{t:Object$}]}},$an:function(){return[doc("Returns a new `Set` containing only the elements \nthat are present in both this `Set` and the given \n`Set`."),shared(),formal()];},d:['ceylon.language','Set','$m','intersection']};}};$$set.exclusiveUnion={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:'u', l:['Element','Other']}}},$ps:[{$nm:'set',$mt:'prm',$t:{t:Set,a:{Element:'Other'}},$an:function(){return[];}}],$cont:Set,$tp:{Other:{'satisfies':[{t:Object$}]}},$an:function(){return[doc("Returns a new `Set` containing only the elements \ncontained in either this `Set` or the given `Set`, \nbut no element contained in both sets."),shared(),formal()];},d:['ceylon.language','Set','$m','exclusiveUnion']};}};$$set.complement={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:'Element'}},$ps:[{$nm:'set',$mt:'prm',$t:{t:Set,a:{Element:'Other'}},$an:function(){return[];}}],$cont:Set,$tp:{Other:{'satisfies':[{t:Object$}]}},$an:function(){return[doc("Returns a new `Set` containing all the elements in \nthis `Set` that are not contained in the given\n`Set`."),shared(),formal()];},d:['ceylon.language','Set','$m','complement']};}};
        })(Set.$$.prototype);
    }
    return Set;
}
exports.$init$Set=$init$Set;
$init$Set();
function emptySet$476($$targs$$){
    var $$emptySet=new emptySet$476.$$;
    $$emptySet.$$targs$$=$$targs$$;
    Object$($$emptySet);
    Set({Element:{t:Nothing}},$$emptySet);
    $$emptySet.$prop$getClone={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:Nothing}}},$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$at','clone']};}};
    $$emptySet.$prop$getClone.get=function(){return clone};
    $$emptySet.size$477_=(0);
    $$emptySet.$prop$getSize={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$at','size']};}};
    $$emptySet.$prop$getSize.get=function(){return size};
    $$emptySet.empty$478_=true;
    $$emptySet.$prop$getEmpty={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$at','empty']};}};
    $$emptySet.$prop$getEmpty.get=function(){return empty};
    return $$emptySet;
};emptySet$476.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Object$},satisfies:[{t:Set,a:{Element:{t:Nothing}}}],$an:function(){return[doc("A [[Set]] with no elements."),shared()];},d:['ceylon.language','emptySet']};};
function $init$emptySet$476(){
    if (emptySet$476.$$===undefined){
        initTypeProto(emptySet$476,'ceylon.language::emptySet',$init$Object$(),$init$Set());
        (function($$emptySet){
            $$emptySet.union=function (set$479,$$$mptypes){
                var $$emptySet=this;
                return set$479;
            };
            $$emptySet.union.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:'Other'}},$ps:[{$nm:'set',$mt:'prm',$t:{t:Set,a:{Element:'Other'}},$an:function(){return[];}}],$cont:emptySet$476,$tp:{Other:{'satisfies':[{t:Object$}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','union']};};
            $$emptySet.intersection=function (set$480,$$$mptypes){
                var $$emptySet=this;
                return getEmptySet();
            };
            $$emptySet.intersection.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:Nothing}}},$ps:[{$nm:'set',$mt:'prm',$t:{t:Set,a:{Element:'Other'}},$an:function(){return[];}}],$cont:emptySet$476,$tp:{Other:{'satisfies':[{t:Object$}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','intersection']};};
            $$emptySet.exclusiveUnion=function (set$481,$$$mptypes){
                var $$emptySet=this;
                return set$481;
            };
            $$emptySet.exclusiveUnion.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:'Other'}},$ps:[{$nm:'set',$mt:'prm',$t:{t:Set,a:{Element:'Other'}},$an:function(){return[];}}],$cont:emptySet$476,$tp:{Other:{'satisfies':[{t:Object$}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','exclusiveUnion']};};
            $$emptySet.complement=function (set$482,$$$mptypes){
                var $$emptySet=this;
                return getEmptySet();
            };
            $$emptySet.complement.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:Nothing}}},$ps:[{$nm:'set',$mt:'prm',$t:{t:Set,a:{Element:'Other'}},$an:function(){return[];}}],$cont:emptySet$476,$tp:{Other:{'satisfies':[{t:Object$}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','complement']};};
            defineAttr($$emptySet,'clone',function(){
                var $$emptySet=this;
                return getEmptySet();
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:Nothing}}},$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$at','clone']};});
            $$emptySet.iterator=function (){
                var $$emptySet=this;
                return getEmptyIterator();
            };
            $$emptySet.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:{t:Nothing}}},$ps:[],$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','iterator']};};
            $$emptySet.subset=function (set$483){
                var $$emptySet=this;
                return true;
            };
            $$emptySet.subset.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'set',$mt:'prm',$t:{t:Set,a:{Element:{t:Object$}}},$an:function(){return[];}}],$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','subset']};};
            $$emptySet.superset=function (set$484){
                var $$emptySet=this;
                return set$484.empty;
            };
            $$emptySet.superset.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'set',$mt:'prm',$t:{t:Set,a:{Element:{t:Object$}}},$an:function(){return[];}}],$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','superset']};};
            defineAttr($$emptySet,'size',function(){return this.size$477_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$at','size']};});
            defineAttr($$emptySet,'empty',function(){return this.empty$478_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$at','empty']};});
            $$emptySet.contains=function (element$485){
                var $$emptySet=this;
                return false;
            };
            $$emptySet.contains.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'element',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','contains']};};
            $$emptySet.containsAny=function (elements$486){
                var $$emptySet=this;
                return false;
            };
            $$emptySet.containsAny.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'elements',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Object$}}},$an:function(){return[];}}],$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','containsAny']};};
            $$emptySet.containsEvery=function (elements$487){
                var $$emptySet=this;
                return false;
            };
            $$emptySet.containsEvery.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'elements',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Object$}}},$an:function(){return[];}}],$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','containsEvery']};};
            $$emptySet.count=function (selecting$488){
                var $$emptySet=this;
                return (0);
            };
            $$emptySet.count.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','count']};};
            $$emptySet.$map=function (collecting$489,$$$mptypes){
                var $$emptySet=this;
                return getEmptySet();
            };
            $$emptySet.$map.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:Nothing}}},$ps:[{$nm:'collecting',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[];}}],$cont:emptySet$476,$tp:{Result:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','map']};};
            $$emptySet.$filter=function (selecting$490){
                var $$emptySet=this;
                return getEmptySet();
            };
            $$emptySet.$filter.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:Nothing}}},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','filter']};};
            $$emptySet.fold=function (initial$491,accumulating$492,$$$mptypes){
                var $$emptySet=this;
                return initial$491;
            };
            $$emptySet.fold.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Result',$ps:[{$nm:'initial',$mt:'prm',$t:'Result',$an:function(){return[];}},{$nm:'accumulating',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[];}}],$cont:emptySet$476,$tp:{Result:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','fold']};};
            $$emptySet.find=function (selecting$493){
                var $$emptySet=this;
                return null;
            };
            $$emptySet.find.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Null},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','find']};};
            $$emptySet.collect=function (collecting$494,$$$mptypes){
                var $$emptySet=this;
                return getEmpty();
            };
            $$emptySet.collect.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'collecting',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[];}}],$cont:emptySet$476,$tp:{Result:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','collect']};};
            $$emptySet.select=function (selecting$495){
                var $$emptySet=this;
                return getEmpty();
            };
            $$emptySet.select.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','select']};};
            $$emptySet.any=function (selecting$496){
                var $$emptySet=this;
                return false;
            };
            $$emptySet.any.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','any']};};
            $$emptySet.$every=function (selecting$497){
                var $$emptySet=this;
                return false;
            };
            $$emptySet.$every.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','every']};};
            $$emptySet.skipping=function (skip$498){
                var $$emptySet=this;
                return getEmptySet();
            };
            $$emptySet.skipping.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:Nothing}}},$ps:[{$nm:'skip',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','skipping']};};
            $$emptySet.taking=function (take$499){
                var $$emptySet=this;
                return getEmptySet();
            };
            $$emptySet.taking.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:Nothing}}},$ps:[{$nm:'take',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','taking']};};
            $$emptySet.by=function (step$500){
                var $$emptySet=this;
                return getEmptySet();
            };
            $$emptySet.by.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:Nothing}}},$ps:[{$nm:'step',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:emptySet$476,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptySet','$m','by']};};
        })(emptySet$476.$$.prototype);
    }
    return emptySet$476;
}
exports.$init$emptySet$476=$init$emptySet$476;
$init$emptySet$476();
var emptySet$501;
function getEmptySet(){
    if (emptySet$501===undefined){emptySet$501=$init$emptySet$476()({Element:{t:Nothing}});emptySet$501.$$metamodel$$=getEmptySet.$$metamodel$$;}
    return emptySet$501;
}
exports.getEmptySet=getEmptySet;
getEmptySet.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:emptySet$476},$an:function(){return[doc(String$("A [[Set]] with no elements.",27)),shared()];},d:['ceylon.language','emptySet']};};
$prop$getEmptySet={get:getEmptySet,$$metamodel$$:getEmptySet.$$metamodel$$};
exports.$prop$getEmptySet=$prop$getEmptySet;
function Range(first, last, $$targs$$,$$range){
    $init$Range();
    if ($$range===undefined)$$range=new Range.$$;
    set_type_args($$range,$$targs$$);
    $$range.first_=first;
    $$range.last_=last;
    Object$($$range);
    Sequence($$range.$$targs$$===undefined?$$targs$$:{Element:$$range.$$targs$$.Element},$$range);
    Cloneable($$range.$$targs$$===undefined?$$targs$$:{Clone:{t:Range,a:{Element:$$range.$$targs$$.Element}}},$$range);
    add_type_arg($$range,'Clone',{t:Range,a:{Element:$$range.$$targs$$.Element}});
    $$range.$prop$getFirst={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Element',$cont:Range,$an:function(){return[doc(String$("The start of the range.",23)),shared(),actual()];},d:['ceylon.language','Range','$at','first']};}};
    $$range.$prop$getFirst.get=function(){return first};
    $$range.$prop$getLast={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Element',$cont:Range,$an:function(){return[doc(String$("The end of the range.",21)),shared(),actual()];},d:['ceylon.language','Range','$at','last']};}};
    $$range.$prop$getLast.get=function(){return last};
    $$range.$prop$getString={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Range,$an:function(){return[shared(),actual()];},d:['ceylon.language','Range','$at','string']};}};
    $$range.$prop$getString.get=function(){return string};
    $$range.$prop$getDecreasing={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Range,$an:function(){return[doc(String$("Determines if the range is decreasing.",38)),shared()];},d:['ceylon.language','Range','$at','decreasing']};}};
    $$range.$prop$getDecreasing.get=function(){return decreasing};
    $$range.$prop$getLastIndex={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Range,$an:function(){return[doc(String$("The index of the end of the range.",34)),shared(),actual()];},d:['ceylon.language','Range','$at','lastIndex']};}};
    $$range.$prop$getLastIndex.get=function(){return lastIndex};
    $$range.$prop$getClone={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Range,a:{Element:'Element'}},$cont:Range,$an:function(){return[doc(String$("Returns the range itself, since ranges are \nimmutable.",54)),shared(),actual()];},d:['ceylon.language','Range','$at','clone']};}};
    $$range.$prop$getClone.get=function(){return clone};
    $$range.$prop$getReversed={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Range,a:{Element:'Element'}},$cont:Range,$an:function(){return[doc(String$("Reverse this range, returning a new range.",42)),shared(),actual()];},d:['ceylon.language','Range','$at','reversed']};}};
    $$range.$prop$getReversed.get=function(){return reversed};
    $$range.$prop$getCoalesced={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Range,a:{Element:'Element'}},$cont:Range,$an:function(){return[doc(String$("Returns the range itself, since a Range cannot\ncontain nulls.",61)),shared(),actual()];},d:['ceylon.language','Range','$at','coalesced']};}};
    $$range.$prop$getCoalesced.get=function(){return coalesced};
    $$range.$prop$getSequence={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Range,a:{Element:'Element'}},$cont:Range,$an:function(){return[doc(String$("Returns this range.",19)),shared(),actual()];},d:['ceylon.language','Range','$at','sequence']};}};
    $$range.$prop$getSequence.get=function(){return sequence};
    return $$range;
}
Range.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Object$},$ps:[{$nm:'first',$mt:'prm',$t:'Element',$an:function(){return[doc("The start of the range."),shared(),actual()];}},{$nm:'last',$mt:'prm',$t:'Element',$an:function(){return[doc("The end of the range."),shared(),actual()];}}],$tp:{Element:{'satisfies':[{t:Ordinal,a:{Other:'Element'}},{t:Comparable,a:{Other:'Element'}}]}},satisfies:[{t:Sequence,a:{Element:'Element'}},{t:Cloneable,a:{Clone:{t:Range,a:{Element:'Element'}}}}],$an:function(){return[doc(String$("Represents the range of totally ordered, ordinal values \ngenerated by two endpoints of type `Ordinal` and \n`Comparable`. If the first value is smaller than the\nlast value, the range is increasing. If the first value\nis larger than the last value, the range is decreasing.\nIf the two values are equal, the range contains exactly\none element. The range is always nonempty, containing \nat least one value.\n\nA range may be produced using the `..` operator:\n\n    for (i in min..max) { ... }\n    if (char in \'A\'..\'Z\') { ... }\n",520)),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared(),$final()];},d:['ceylon.language','Range']};};
exports.Range=Range;
function $init$Range(){
    if (Range.$$===undefined){
        initTypeProto(Range,'ceylon.language::Range',$init$Object$(),$init$Sequence(),$init$Cloneable());
        (function($$range){
            defineAttr($$range,'first',function(){return this.first_;},undefined,function(){return{mod:$$METAMODEL$$,$t:'Element',$cont:Range,$an:function(){return[doc(String$("The start of the range.",23)),shared(),actual()];},d:['ceylon.language','Range','$at','first']};});
            defineAttr($$range,'last',function(){return this.last_;},undefined,function(){return{mod:$$METAMODEL$$,$t:'Element',$cont:Range,$an:function(){return[doc(String$("The end of the range.",21)),shared(),actual()];},d:['ceylon.language','Range','$at','last']};});
            defineAttr($$range,'string',function(){
                var $$range=this;
                return $$range.first.string.plus(String$("..",2)).plus($$range.last.string);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Range,$an:function(){return[shared(),actual()];},d:['ceylon.language','Range','$at','string']};});
            defineAttr($$range,'decreasing',function(){
                var $$range=this;
                return $$range.last.compare($$range.first).equals(getSmaller());
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Range,$an:function(){return[doc(String$("Determines if the range is decreasing.",38)),shared()];},d:['ceylon.language','Range','$at','decreasing']};});
            $$range.next$502=function (x$503){
                var $$range=this;
                return (opt$504=($$range.decreasing?x$503.predecessor:null),opt$504!==null?opt$504:x$503.successor);
            };
            $$range.next$502.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Element',$ps:[{$nm:'x',$mt:'prm',$t:'Element',$an:function(){return[];}}],$cont:Range,d:['ceylon.language','Range','$m','next']};};
            defineAttr($$range,'size',function(){
                var $$range=this;
                var last$505;
                var first$506;
                if(isOfType((last$505=$$range.last),{t:Enumerable,a:{Other:{t:Anything}}})&&isOfType((first$506=$$range.first),{t:Enumerable,a:{Other:{t:Anything}}})){
                    return last$505.integerValue.minus(first$506.integerValue).magnitude.plus((1));
                }else {
                    var size$507=(1);
                    function setSize$507(size$508){return size$507=size$508;};
                    $prop$getSize$507={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','Range','$at','size','$at','size']};}};
                    $prop$getSize$507.get=function(){return size$507};
                    $prop$getSize$507.set=setSize$507;
                    if (setSize$507.$$metamodel$$===undefined)setSize$507.$$metamodel$$=$prop$getSize$507.$$metamodel$$;
                    var current$509=$$range.first;
                    function setCurrent$509(current$510){return current$509=current$510;};
                    $prop$getCurrent$509={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Element',$an:function(){return[variable()];},d:['ceylon.language','Range','$at','size','$at','current']};}};
                    $prop$getCurrent$509.get=function(){return current$509};
                    $prop$getCurrent$509.set=setCurrent$509;
                    if (setCurrent$509.$$metamodel$$===undefined)setCurrent$509.$$metamodel$$=$prop$getCurrent$509.$$metamodel$$;
                    while((!current$509.equals($$range.last))){
                        (oldsize$511=size$507,size$507=oldsize$511.successor,oldsize$511);
                        var oldsize$511;
                        current$509=$$range.next$502(current$509);
                    }
                    return size$507;
                }
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Range,$an:function(){return[doc(String$("The nonzero number of elements in the range.",44)),shared(),actual()];},d:['ceylon.language','Range','$at','size']};});defineAttr($$range,'lastIndex',function(){
                var $$range=this;
                return $$range.size.minus((1));
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Range,$an:function(){return[doc(String$("The index of the end of the range.",34)),shared(),actual()];},d:['ceylon.language','Range','$at','lastIndex']};});
            defineAttr($$range,'rest',function(){
                var $$range=this;
                if($$range.size.equals((1))){
                    return getEmpty();
                }
                var n$512=$$range.next$502($$range.first);
                $prop$getN$512={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Element',d:['ceylon.language','Range','$at','rest','$at','n']};}};
                $prop$getN$512.get=function(){return n$512};
                return (opt$513=(n$512.equals($$range.last)?getEmpty():null),opt$513!==null?opt$513:Range(n$512,$$range.last,{Element:$$range.$$targs$$.Element}));
                var opt$513;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$cont:Range,$an:function(){return[doc(String$("The rest of the range, without the start of the\nrange.",54)),shared(),actual()];},d:['ceylon.language','Range','$at','rest']};});$$range.$get=function $get(n$514){
                var $$range=this;
                var index$515=(0);
                function setIndex$515(index$516){return index$515=index$516;};
                var x$517=$$range.first;
                function setX$517(x$518){return x$517=x$518;};
                while(index$515.compare(n$514).equals(getSmaller())){
                    if(x$517.equals($$range.last)){
                        return null;
                    }else {
                        (index$515=index$515.successor);
                        x$517=$$range.next$502(x$517);
                    }
                }
                return x$517;
            };$$range.$get.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$ps:[{$nm:'n',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Range,$an:function(){return[doc(String$("The element of the range that occurs `n` values after\nthe start of the range. Note that this operation \nis inefficient for large ranges.",136)),shared(),actual()];},d:['ceylon.language','Range','$m','get']};};
            $$range.iterator=function iterator(){
                var $$range=this;
                function RangeIterator$519($$rangeIterator$519){
                    $init$RangeIterator$519();
                    if ($$rangeIterator$519===undefined)$$rangeIterator$519=new RangeIterator$519.$$;
                    $$rangeIterator$519.$$targs$$={Element:$$range.$$targs$$.Element};
                    Iterator({Element:$$range.$$targs$$.Element},$$rangeIterator$519);
                    $$rangeIterator$519.current$520_=$$range.first;
                    $$rangeIterator$519.$prop$getCurrent$520={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$cont:RangeIterator$519,$an:function(){return[variable()];},d:['ceylon.language','Range','$m','iterator','$c','RangeIterator','$at','current']};}};
                    $$rangeIterator$519.$prop$getCurrent$520.get=function(){return current$520};
                    return $$rangeIterator$519;
                }
                RangeIterator$519.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],satisfies:[{t:Iterator,a:{Element:'Element'}}],d:['ceylon.language','Range','$m','iterator','$c','RangeIterator']};};
                function $init$RangeIterator$519(){
                    if (RangeIterator$519.$$===undefined){
                        initTypeProto(RangeIterator$519,'ceylon.language::Range.iterator.RangeIterator',Basic,$init$Iterator());
                        (function($$rangeIterator$519){
                            defineAttr($$rangeIterator$519,'current$520',function(){return this.current$520_;},function(current$521){return this.current$520_=current$521;},function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$cont:RangeIterator$519,$an:function(){return[variable()];},d:['ceylon.language','Range','$m','iterator','$c','RangeIterator','$at','current']};});
                            $$rangeIterator$519.next=function next(){
                                var $$rangeIterator$519=this;
                                var result$522=$$rangeIterator$519.current$520;
                                var curr$523;
                                if(!isOfType((curr$523=$$rangeIterator$519.current$520),{t:Finished})){
                                    if((opt$524=($$range.decreasing?(curr$523.compare($$range.last)!==getLarger()):null),opt$524!==null?opt$524:(curr$523.compare($$range.last)!==getSmaller()))){
                                        $$rangeIterator$519.current$520=getFinished();
                                    }else {
                                        $$rangeIterator$519.current$520=$$range.next$502(curr$523);
                                    }
                                    var opt$524;
                                }
                                return result$522;
                            };$$rangeIterator$519.next.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$ps:[],$cont:RangeIterator$519,$an:function(){return[shared(),actual()];},d:['ceylon.language','Range','$m','iterator','$c','RangeIterator','$m','next']};};
                            defineAttr($$rangeIterator$519,'string',function(){
                                var $$rangeIterator$519=this;
                                return String$("RangeIterator",13);
                            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:RangeIterator$519,$an:function(){return[shared(),actual()];},d:['ceylon.language','Range','$m','iterator','$c','RangeIterator','$at','string']};});
                        })(RangeIterator$519.$$.prototype);
                    }
                    return RangeIterator$519;
                }
                $init$RangeIterator$519();
                return RangeIterator$519();
            };$$range.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$ps:[],$cont:Range,$an:function(){return[doc(String$("An iterator for the elements of the range.",42)),shared(),actual()];},d:['ceylon.language','Range','$m','iterator']};};
            $$range.by=function by(step$525){
                var $$range=this;
                //assert at Range.ceylon (113:8-114:25)
                if (!(step$525.compare((0)).equals(getLarger()))) {throw wrapexc(AssertionException("step size must be greater than zero: \'step > 0\' at Range.ceylon (114:15-114:24)"),'113:8-114:25','Range.ceylon'); }
                if(step$525.equals((1))){
                    return $$range;
                }
                var first$526;
                var last$527;
                if(isOfType((first$526=$$range.first),{t:Integer})&&isOfType((last$527=$$range.last),{t:Integer})){
                    return integerRangeByIterable($$range,step$525,{Element:$$range.$$targs$$.Element});
                }
                return $$range.getT$all()['ceylon.language::Iterable'].$$.prototype.by.call(this,step$525);
            };$$range.by.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Nothing},Element:'Element'}},$ps:[{$nm:'step',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Range,$an:function(){return[shared(),actual()];},d:['ceylon.language','Range','$m','by']};};
            $$range.count=function count(selecting$528){
                var $$range=this;
                var e$529=$$range.first;
                function setE$529(e$530){return e$529=e$530;};
                var c$531=(0);
                function setC$531(c$532){return c$531=c$532;};
                while($$range.containsElement(e$529)){
                    if(selecting$528(e$529)){
                        (oldc$533=c$531,c$531=oldc$533.successor,oldc$533);
                        var oldc$533;
                    }
                    e$529=$$range.next$502(e$529);
                }
                return c$531;
            };$$range.count.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Range,$an:function(){return[shared(),actual()];},d:['ceylon.language','Range','$m','count']};};
            $$range.contains=function contains(element$534){
                var $$range=this;
                var element$535;
                if(isOfType((element$535=element$534),$$range.$$targs$$.Element)){
                    return $$range.containsElement(element$535);
                }else {
                    return false;
                }
            };$$range.contains.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'element',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Range,$an:function(){return[doc(String$("Determines if this range includes the given object.",51)),shared(),actual()];},d:['ceylon.language','Range','$m','contains']};};
            $$range.occurs=function occurs(element$536){
                var $$range=this;
                var element$537;
                if(isOfType((element$537=element$536),$$range.$$targs$$.Element)){
                    return $$range.containsElement(element$537);
                }else {
                    return false;
                }
            };$$range.occurs.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'element',$mt:'prm',$t:{t:Anything},$an:function(){return[];}}],$cont:Range,$an:function(){return[doc(String$("Determines if this range includes the given value.",50)),shared(),actual()];},d:['ceylon.language','Range','$m','occurs']};};
            $$range.containsElement=function (x$538){
                var $$range=this;
                return (opt$539=($$range.decreasing?((x$538.compare($$range.first)!==getLarger())&&(x$538.compare($$range.last)!==getSmaller())):null),opt$539!==null?opt$539:((x$538.compare($$range.first)!==getSmaller())&&(x$538.compare($$range.last)!==getLarger())));
            };
            $$range.containsElement.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'x',$mt:'prm',$t:'Element',$an:function(){return[];}}],$cont:Range,$an:function(){return[doc(String$("Determines if the range includes the given value.",49)),shared()];},d:['ceylon.language','Range','$m','containsElement']};};
            $$range.includes=function includes(sublist$540){
                var $$range=this;
                var sublist$541;
                if(isOfType((sublist$541=sublist$540),{t:Range,a:{Element:$$range.$$targs$$.Element}})){
                    return $$range.includesRange(sublist$541);
                }else {
                    return $$range.getT$all()['ceylon.language::List'].$$.prototype.includes.call(this,sublist$540);
                }
            };$$range.includes.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'sublist',$mt:'prm',$t:{t:List,a:{Element:{t:Anything}}},$an:function(){return[];}}],$cont:Range,$an:function(){return[shared(),actual()];},d:['ceylon.language','Range','$m','includes']};};
            $$range.includesRange=function includesRange(sublist$542){
                var $$range=this;
                return ((tmpvar$543=sublist$542.first,tmpvar$543.compare($$range.first)!==getSmaller()&&tmpvar$543.compare($$range.last)!==getLarger())&&(tmpvar$544=sublist$542.last,tmpvar$544.compare($$range.first)!==getSmaller()&&tmpvar$544.compare($$range.last)!==getLarger()));
            };$$range.includesRange.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'sublist',$mt:'prm',$t:{t:Range,a:{Element:'Element'}},$an:function(){return[];}}],$cont:Range,$an:function(){return[doc(String$("Determines if this range includes the given range.",50)),shared()];},d:['ceylon.language','Range','$m','includesRange']};};
            $$range.equals=function equals(that$545){
                var $$range=this;
                var that$546;
                if(isOfType((that$546=that$545),{t:Range,a:{Element:{t:Object$}}})){
                    return (that$546.first.equals($$range.first)&&that$546.last.equals($$range.last));
                }else {
                    return $$range.getT$all()['ceylon.language::List'].$$.prototype.equals.call(this,that$545);
                }
            };$$range.equals.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'that',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Range,$an:function(){return[doc(String$("Determines if two ranges are the same by comparing\ntheir endpoints.",67)),shared(),actual()];},d:['ceylon.language','Range','$m','equals']};};
            defineAttr($$range,'clone',function(){
                var $$range=this;
                return $$range;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Range,a:{Element:'Element'}},$cont:Range,$an:function(){return[doc(String$("Returns the range itself, since ranges are \nimmutable.",54)),shared(),actual()];},d:['ceylon.language','Range','$at','clone']};});
            $$range.segment=function segment(from$547,length$548){
                var $$range=this;
                if(((length$548.compare((0))!==getLarger())||from$547.compare($$range.lastIndex).equals(getLarger()))){
                    return getEmpty();
                }
                var x$549=$$range.first;
                function setX$549(x$550){return x$549=x$550;};
                var i$551=(0);
                function setI$551(i$552){return i$551=i$552;};
                while((oldi$553=i$551,i$551=oldi$553.successor,oldi$553).compare(from$547).equals(getSmaller())){
                    x$549=$$range.next$502(x$549);
                }
                var oldi$553;
                var y$554=x$549;
                function setY$554(y$555){return y$554=y$555;};
                var j$556=(1);
                function setJ$556(j$557){return j$556=j$557;};
                while(((oldj$558=j$556,j$556=oldj$558.successor,oldj$558).compare(length$548).equals(getSmaller())&&y$554.compare($$range.last).equals(getSmaller()))){
                    y$554=$$range.next$502(y$554);
                }
                var oldj$558;
                return Range(x$549,y$554,{Element:$$range.$$targs$$.Element});
            };$$range.segment.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Range,a:{Element:'Element'}},{t:Empty}]},$ps:[{$nm:'from',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Range,$an:function(){return[shared(),actual()];},d:['ceylon.language','Range','$m','segment']};};
            $$range.span=function span(from$559,to$560){
                var $$range=this;
                var toIndex$561=to$560;
                function setToIndex$561(toIndex$562){return toIndex$561=toIndex$562;};
                var fromIndex$563=from$559;
                function setFromIndex$563(fromIndex$564){return fromIndex$563=fromIndex$564;};
                if(toIndex$561.compare((0)).equals(getSmaller())){
                    if(fromIndex$563.compare((0)).equals(getSmaller())){
                        return getEmpty();
                    }
                    toIndex$561=(0);
                }else {
                    if(toIndex$561.compare($$range.lastIndex).equals(getLarger())){
                        if(fromIndex$563.compare($$range.lastIndex).equals(getLarger())){
                            return getEmpty();
                        }
                        toIndex$561=$$range.lastIndex;
                    }
                }
                if(fromIndex$563.compare((0)).equals(getSmaller())){
                    fromIndex$563=(0);
                }else {
                    if(fromIndex$563.compare($$range.lastIndex).equals(getLarger())){
                        fromIndex$563=$$range.lastIndex;
                    }
                }
                var x$565=$$range.first;
                function setX$565(x$566){return x$565=x$566;};
                var i$567=(0);
                function setI$567(i$568){return i$567=i$568;};
                while((oldi$569=i$567,i$567=oldi$569.successor,oldi$569).compare(fromIndex$563).equals(getSmaller())){
                    x$565=$$range.next$502(x$565);
                }
                var oldi$569;
                var y$570=$$range.first;
                function setY$570(y$571){return y$570=y$571;};
                var j$572=(0);
                function setJ$572(j$573){return j$572=j$573;};
                while((oldj$574=j$572,j$572=oldj$574.successor,oldj$574).compare(toIndex$561).equals(getSmaller())){
                    y$570=$$range.next$502(y$570);
                }
                var oldj$574;
                return Range(x$565,y$570,{Element:$$range.$$targs$$.Element});
            };$$range.span.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Range,a:{Element:'Element'}},{t:Empty}]},$ps:[{$nm:'from',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'to',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Range,$an:function(){return[shared(),actual()];},d:['ceylon.language','Range','$m','span']};};
            $$range.spanTo=function spanTo(to$575){
                var $$range=this;
                return (opt$576=(to$575.compare((0)).equals(getSmaller())?getEmpty():null),opt$576!==null?opt$576:$$range.span((0),to$575));
                var opt$576;
            };$$range.spanTo.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Range,a:{Element:'Element'}},{t:Empty}]},$ps:[{$nm:'to',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Range,$an:function(){return[shared(),actual()];},d:['ceylon.language','Range','$m','spanTo']};};
            $$range.spanFrom=function spanFrom(from$577){
                var $$range=this;
                return $$range.span(from$577,$$range.size);
            };$$range.spanFrom.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Range,a:{Element:'Element'}},{t:Empty}]},$ps:[{$nm:'from',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Range,$an:function(){return[shared(),actual()];},d:['ceylon.language','Range','$m','spanFrom']};};
            defineAttr($$range,'reversed',function(){
                var $$range=this;
                return Range($$range.last,$$range.first,{Element:$$range.$$targs$$.Element});
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Range,a:{Element:'Element'}},$cont:Range,$an:function(){return[doc(String$("Reverse this range, returning a new range.",42)),shared(),actual()];},d:['ceylon.language','Range','$at','reversed']};});
            $$range.skipping=function skipping(skip$578){
                var $$range=this;
                var x$579=(0);
                function setX$579(x$580){return x$579=x$580;};
                var e$581=$$range.first;
                function setE$581(e$582){return e$581=e$582;};
                while((oldx$583=x$579,x$579=oldx$583.successor,oldx$583).compare(skip$578).equals(getSmaller())){
                    e$581=$$range.next$502(e$581);
                }
                var oldx$583;
                return (opt$584=($$range.containsElement(e$581)?Range(e$581,$$range.last,{Element:$$range.$$targs$$.Element}):null),opt$584!==null?opt$584:getEmpty());
                var opt$584;
            };$$range.skipping.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Range,a:{Element:'Element'}},{t:Empty}]},$ps:[{$nm:'skip',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Range,$an:function(){return[shared(),actual()];},d:['ceylon.language','Range','$m','skipping']};};
            $$range.taking=function taking(take$585){
                var $$range=this;
                if(take$585.equals((0))){
                    return getEmpty();
                }
                var x$586=(0);
                function setX$586(x$587){return x$586=x$587;};
                var e$588=$$range.first;
                function setE$588(e$589){return e$588=e$589;};
                while((x$586=x$586.successor).compare(take$585).equals(getSmaller())){
                    e$588=$$range.next$502(e$588);
                }
                return (opt$590=($$range.containsElement(e$588)?Range($$range.first,e$588,{Element:$$range.$$targs$$.Element}):null),opt$590!==null?opt$590:$$range);
                var opt$590;
            };$$range.taking.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Range,a:{Element:'Element'}},{t:Empty}]},$ps:[{$nm:'take',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Range,$an:function(){return[shared(),actual()];},d:['ceylon.language','Range','$m','taking']};};
            defineAttr($$range,'coalesced',function(){
                var $$range=this;
                return $$range;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Range,a:{Element:'Element'}},$cont:Range,$an:function(){return[doc(String$("Returns the range itself, since a Range cannot\ncontain nulls.",61)),shared(),actual()];},d:['ceylon.language','Range','$at','coalesced']};});
            defineAttr($$range,'sequence',function(){
                var $$range=this;
                return $$range;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Range,a:{Element:'Element'}},$cont:Range,$an:function(){return[doc(String$("Returns this range.",19)),shared(),actual()];},d:['ceylon.language','Range','$at','sequence']};});
        })(Range.$$.prototype);
    }
    return Range;
}
exports.$init$Range=$init$Range;
$init$Range();
var opt$504,opt$539;
function Singleton(element$591, $$targs$$,$$singleton){
    $init$Singleton();
    if ($$singleton===undefined)$$singleton=new Singleton.$$;
    set_type_args($$singleton,$$targs$$);
    $$singleton.element$591_=element$591;
    Object$($$singleton);
    Sequence($$singleton.$$targs$$===undefined?$$targs$$:{Element:$$singleton.$$targs$$.Element},$$singleton);
    $$singleton.$prop$getLastIndex={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Singleton,$an:function(){return[doc(String$("Returns `0`.",12)),shared(),actual()];},d:['ceylon.language','Singleton','$at','lastIndex']};}};
    $$singleton.$prop$getLastIndex.get=function(){return lastIndex};
    $$singleton.$prop$getSize={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Singleton,$an:function(){return[doc(String$("Returns `1`.",12)),shared(),actual()];},d:['ceylon.language','Singleton','$at','size']};}};
    $$singleton.$prop$getSize.get=function(){return size};
    $$singleton.$prop$getFirst={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Element',$cont:Singleton,$an:function(){return[doc(String$("Returns the element contained in this `Singleton`.",50)),shared(),actual()];},d:['ceylon.language','Singleton','$at','first']};}};
    $$singleton.$prop$getFirst.get=function(){return first};
    $$singleton.$prop$getLast={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Element',$cont:Singleton,$an:function(){return[doc(String$("Returns the element contained in this `Singleton`.",50)),shared(),actual()];},d:['ceylon.language','Singleton','$at','last']};}};
    $$singleton.$prop$getLast.get=function(){return last};
    $$singleton.$prop$getRest={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$cont:Singleton,$an:function(){return[doc(String$("Returns `Empty`.",16)),shared(),actual()];},d:['ceylon.language','Singleton','$at','rest']};}};
    $$singleton.$prop$getRest.get=function(){return rest};
    $$singleton.$prop$getClone={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Singleton,a:{Element:'Element'}},$cont:Singleton,$an:function(){return[doc(String$("Returns a `Singleton` with the same element.",44)),shared(),actual()];},d:['ceylon.language','Singleton','$at','clone']};}};
    $$singleton.$prop$getClone.get=function(){return clone};
    $$singleton.$prop$getString={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Singleton,$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$at','string']};}};
    $$singleton.$prop$getString.get=function(){return string};
    $$singleton.$prop$getReversed={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Singleton,a:{Element:'Element'}},$cont:Singleton,$an:function(){return[doc(String$("Return this singleton.",22)),shared(),actual()];},d:['ceylon.language','Singleton','$at','reversed']};}};
    $$singleton.$prop$getReversed.get=function(){return reversed};
    $$singleton.$prop$getHash={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Singleton,$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$at','hash']};}};
    $$singleton.$prop$getHash.get=function(){return hash};
    return $$singleton;
}
Singleton.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Object$},$ps:[{$nm:'element',$mt:'prm',$t:'Element',$an:function(){return[];}}],$tp:{Element:{'var':'out'}},satisfies:[{t:Sequence,a:{Element:'Element'}}],$an:function(){return[doc(String$("A sequence with exactly one element, which may be null.",55)),shared()];},d:['ceylon.language','Singleton']};};
exports.Singleton=Singleton;
function $init$Singleton(){
    if (Singleton.$$===undefined){
        initTypeProto(Singleton,'ceylon.language::Singleton',$init$Object$(),$init$Sequence());
        (function($$singleton){
            defineAttr($$singleton,'lastIndex',function(){
                var $$singleton=this;
                return (0);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Singleton,$an:function(){return[doc(String$("Returns `0`.",12)),shared(),actual()];},d:['ceylon.language','Singleton','$at','lastIndex']};});
            defineAttr($$singleton,'size',function(){
                var $$singleton=this;
                return (1);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Singleton,$an:function(){return[doc(String$("Returns `1`.",12)),shared(),actual()];},d:['ceylon.language','Singleton','$at','size']};});
            defineAttr($$singleton,'first',function(){
                var $$singleton=this;
                return $$singleton.element$591;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:'Element',$cont:Singleton,$an:function(){return[doc(String$("Returns the element contained in this `Singleton`.",50)),shared(),actual()];},d:['ceylon.language','Singleton','$at','first']};});
            defineAttr($$singleton,'last',function(){
                var $$singleton=this;
                return $$singleton.element$591;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:'Element',$cont:Singleton,$an:function(){return[doc(String$("Returns the element contained in this `Singleton`.",50)),shared(),actual()];},d:['ceylon.language','Singleton','$at','last']};});
            defineAttr($$singleton,'rest',function(){
                var $$singleton=this;
                return getEmpty();
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$cont:Singleton,$an:function(){return[doc(String$("Returns `Empty`.",16)),shared(),actual()];},d:['ceylon.language','Singleton','$at','rest']};});
            $$singleton.$get=function $get(index$592){
                var $$singleton=this;
                if(index$592.equals((0))){
                    return $$singleton.element$591;
                }else {
                    return null;
                }
            };$$singleton.$get.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$ps:[{$nm:'index',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[doc(String$("Returns the contained element, if the specified \nindex is `0`.",62)),shared(),actual()];},d:['ceylon.language','Singleton','$m','get']};};
            defineAttr($$singleton,'clone',function(){
                var $$singleton=this;
                return $$singleton;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Singleton,a:{Element:'Element'}},$cont:Singleton,$an:function(){return[doc(String$("Returns a `Singleton` with the same element.",44)),shared(),actual()];},d:['ceylon.language','Singleton','$at','clone']};});
            $$singleton.iterator=function iterator(){
                var $$singleton=this;
                function SingletonIterator$593($$singletonIterator$593){
                    $init$SingletonIterator$593();
                    if ($$singletonIterator$593===undefined)$$singletonIterator$593=new SingletonIterator$593.$$;
                    $$singletonIterator$593.$$targs$$={Element:$$singleton.$$targs$$.Element};
                    Iterator({Element:$$singleton.$$targs$$.Element},$$singletonIterator$593);
                    $$singletonIterator$593.done$594_=false;
                    $$singletonIterator$593.$prop$getDone$594={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:SingletonIterator$593,$an:function(){return[variable()];},d:['ceylon.language','Singleton','$m','iterator','$c','SingletonIterator','$at','done']};}};
                    $$singletonIterator$593.$prop$getDone$594.get=function(){return done$594};
                    return $$singletonIterator$593;
                }
                SingletonIterator$593.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],satisfies:[{t:Iterator,a:{Element:'Element'}}],d:['ceylon.language','Singleton','$m','iterator','$c','SingletonIterator']};};
                function $init$SingletonIterator$593(){
                    if (SingletonIterator$593.$$===undefined){
                        initTypeProto(SingletonIterator$593,'ceylon.language::Singleton.iterator.SingletonIterator',Basic,$init$Iterator());
                        (function($$singletonIterator$593){
                            defineAttr($$singletonIterator$593,'done$594',function(){return this.done$594_;},function(done$595){return this.done$594_=done$595;},function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:SingletonIterator$593,$an:function(){return[variable()];},d:['ceylon.language','Singleton','$m','iterator','$c','SingletonIterator','$at','done']};});
                            $$singletonIterator$593.next=function next(){
                                var $$singletonIterator$593=this;
                                if($$singletonIterator$593.done$594){
                                    return getFinished();
                                }else {
                                    $$singletonIterator$593.done$594=true;
                                    return $$singleton.element$591;
                                }
                            };$$singletonIterator$593.next.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$ps:[],$cont:SingletonIterator$593,$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$m','iterator','$c','SingletonIterator','$m','next']};};
                            defineAttr($$singletonIterator$593,'string',function(){
                                var $$singletonIterator$593=this;
                                return String$("SingletonIterator",17);
                            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:SingletonIterator$593,$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$m','iterator','$c','SingletonIterator','$at','string']};});
                        })(SingletonIterator$593.$$.prototype);
                    }
                    return SingletonIterator$593;
                }
                $init$SingletonIterator$593();
                return SingletonIterator$593();
            };$$singleton.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$ps:[],$cont:Singleton,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','Singleton','$m','iterator']};};
            defineAttr($$singleton,'string',function(){
                var $$singleton=this;
                return StringBuilder().appendAll([String$("[",1),(opt$596=(opt$597=$$singleton.element$591,opt$597!==null?opt$597.string:null),opt$596!==null?opt$596:String$("null",4)).string,String$("]",1)]).string;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Singleton,$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$at','string']};});
            $$singleton.segment=function (from$598,length$599){
                var $$singleton=this;
                return (opt$600=(((from$598.compare((0))!==getLarger())&&from$598.plus(length$599).compare((0)).equals(getLarger()))?$$singleton:null),opt$600!==null?opt$600:getEmpty());
            };
            $$singleton.segment.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Empty},{t:Singleton,a:{Element:'Element'}}]},$ps:[{$nm:'from',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[doc(String$("Returns a `Singleton` if the given starting index \nis `0` and the given `length` is greater than `0`.\nOtherwise, returns an instance of `Empty`.",144)),shared(),actual()];},d:['ceylon.language','Singleton','$m','segment']};};
            $$singleton.span=function (from$601,to$602){
                var $$singleton=this;
                return (opt$603=((((from$601.compare((0))!==getLarger())&&(to$602.compare((0))!==getSmaller()))||((from$601.compare((0))!==getSmaller())&&(to$602.compare((0))!==getLarger())))?$$singleton:null),opt$603!==null?opt$603:getEmpty());
            };
            $$singleton.span.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Empty},{t:Singleton,a:{Element:'Element'}}]},$ps:[{$nm:'from',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'to',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[doc(String$("Returns a `Singleton` if the given starting index \nis `0`. Otherwise, returns an instance of `Empty`.",101)),shared(),actual()];},d:['ceylon.language','Singleton','$m','span']};};
            $$singleton.spanTo=function (to$604){
                var $$singleton=this;
                return (opt$605=(to$604.compare((0)).equals(getSmaller())?getEmpty():null),opt$605!==null?opt$605:$$singleton);
            };
            $$singleton.spanTo.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Empty},{t:Singleton,a:{Element:'Element'}}]},$ps:[{$nm:'to',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$m','spanTo']};};
            $$singleton.spanFrom=function (from$606){
                var $$singleton=this;
                return (opt$607=(from$606.compare((0)).equals(getLarger())?getEmpty():null),opt$607!==null?opt$607:$$singleton);
            };
            $$singleton.spanFrom.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Empty},{t:Singleton,a:{Element:'Element'}}]},$ps:[{$nm:'from',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$m','spanFrom']};};
            defineAttr($$singleton,'reversed',function(){
                var $$singleton=this;
                return $$singleton;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Singleton,a:{Element:'Element'}},$cont:Singleton,$an:function(){return[doc(String$("Return this singleton.",22)),shared(),actual()];},d:['ceylon.language','Singleton','$at','reversed']};});
            $$singleton.equals=function equals(that$608){
                var $$singleton=this;
                var element$609;
                if((element$609=$$singleton.element$591)!==null){
                    var that$610;
                    if(isOfType((that$610=that$608),{t:List,a:{Element:{t:Anything}}})){
                        if(that$610.size.equals((1))){
                            var elem$611;
                            if((elem$611=that$610.first)!==null){
                                return elem$611.equals(element$609);
                            }
                        }
                    }
                    return false;
                }
                return false;
            };$$singleton.equals.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'that',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[doc(String$("A `Singleton` can be equal to another `List` if \nthat `List` has only one element which is equal to \nthis `Singleton`\'s element.",128)),shared(),actual()];},d:['ceylon.language','Singleton','$m','equals']};};
            defineAttr($$singleton,'hash',function(){
                var $$singleton=this;
                return (31).plus((opt$612=(opt$613=$$singleton.element$591,opt$613!==null?opt$613.hash:null),opt$612!==null?opt$612:(0)));
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Singleton,$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$at','hash']};});
            $$singleton.contains=function contains(element$614){
                var $$singleton=this;
                var e$615;
                if((e$615=$$singleton.element$591)!==null){
                    return e$615.equals(element$614);
                }
                return false;
            };$$singleton.contains.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'element',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[doc(String$("Returns `true` if the specified element is this \n`Singleton`\'s element.",71)),shared(),actual()];},d:['ceylon.language','Singleton','$m','contains']};};
            $$singleton.count=function (selecting$616){
                var $$singleton=this;
                return (opt$617=(selecting$616($$singleton.element$591)?(1):null),opt$617!==null?opt$617:(0));
            };
            $$singleton.count.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[doc(String$("Returns `1` if this `Singleton`\'s element\nsatisfies the predicate, or `0` otherwise.",84)),shared(),actual()];},d:['ceylon.language','Singleton','$m','count']};};
            $$singleton.$map=function (selecting$618,$$$mptypes){
                var $$singleton=this;
                return Tuple(selecting$618($$singleton.element$591),getEmpty(),{Rest:{t:Empty},First:$$$mptypes.Result,Element:$$$mptypes.Result});
            };
            $$singleton.$map.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequence,a:{Element:'Result'}},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[];}}],$cont:Singleton,$tp:{Result:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$m','map']};};
            $$singleton.$filter=function (selecting$619){
                var $$singleton=this;
                return (opt$620=(selecting$619($$singleton.element$591)?$$singleton:null),opt$620!==null?opt$620:getEmpty());
            };
            $$singleton.$filter.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Singleton,a:{Element:'Element'}},{t:Empty}]},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$m','filter']};};
            $$singleton.fold=function (initial$621,accumulating$622,$$$mptypes){
                var $$singleton=this;
                return accumulating$622(initial$621,$$singleton.element$591);
            };
            $$singleton.fold.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Result',$ps:[{$nm:'initial',$mt:'prm',$t:'Result',$an:function(){return[];}},{$nm:'accumulating',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[];}}],$cont:Singleton,$tp:{Result:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$m','fold']};};
            $$singleton.find=function find(selecting$623){
                var $$singleton=this;
                if(selecting$623($$singleton.element$591)){
                    return $$singleton.element$591;
                }
                return null;
            };$$singleton.find.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$m','find']};};
            $$singleton.findLast=function (selecting$624){
                var $$singleton=this;
                return $$singleton.find($JsCallable(selecting$624,[{$nm:'elem',$mt:'prm',$t:'Element',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$singleton.$$targs$$.Element]},Return:{t:Boolean$}}));
            };
            $$singleton.findLast.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','Singleton','$m','findLast']};};
            $$singleton.$sort=function (comparing$625){
                var $$singleton=this;
                return $$singleton;
            };
            $$singleton.$sort.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Singleton,a:{Element:'Element'}},$ps:[{$nm:'comparing',$mt:'prm',$pt:'f',$t:{t:Comparison},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$m','sort']};};
            $$singleton.any=function (selecting$626){
                var $$singleton=this;
                return selecting$626($$singleton.element$591);
            };
            $$singleton.any.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$m','any']};};
            $$singleton.$every=function (selecting$627){
                var $$singleton=this;
                return selecting$627($$singleton.element$591);
            };
            $$singleton.$every.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$m','every']};};
            $$singleton.skipping=function (skip$628){
                var $$singleton=this;
                return (opt$629=(skip$628.compare((1)).equals(getSmaller())?$$singleton:null),opt$629!==null?opt$629:getEmpty());
            };
            $$singleton.skipping.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Singleton,a:{Element:'Element'}},{t:Empty}]},$ps:[{$nm:'skip',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$m','skipping']};};
            $$singleton.taking=function (take$630){
                var $$singleton=this;
                return (opt$631=(take$630.compare((0)).equals(getLarger())?$$singleton:null),opt$631!==null?opt$631:getEmpty());
            };
            $$singleton.taking.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Singleton,a:{Element:'Element'}},{t:Empty}]},$ps:[{$nm:'take',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:Singleton,$an:function(){return[shared(),actual()];},d:['ceylon.language','Singleton','$m','taking']};};
            defineAttr($$singleton,'coalesced',function(){
                var $$singleton=this;
                var self$632;
                if(isOfType((self$632=$$singleton),{t:Singleton,a:{Element:{t:Object$}}})){
                    return self$632;
                }
                return getEmpty();
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:'i', l:['Element',{t:Object$}]}}},$cont:Singleton,$an:function(){return[doc(String$("Returns the Singleton itself, or empty",38)),shared(),actual()];},d:['ceylon.language','Singleton','$at','coalesced']};});defineAttr($$singleton,'element$591',function(){return this.element$591_;},undefined,function(){return{mod:$$METAMODEL$$,$t:'Element',$cont:Singleton,d:['ceylon.language','Singleton','$at','element']};});
        })(Singleton.$$.prototype);
    }
    return Singleton;
}
exports.$init$Singleton=$init$Singleton;
$init$Singleton();
var opt$596,opt$597,opt$600,opt$603,opt$605,opt$607,opt$612,opt$613,opt$617,opt$620,opt$629,opt$631;
function AssertionException(message$633, $$assertionException){
    $init$AssertionException();
    if ($$assertionException===undefined)$$assertionException=new AssertionException.$$;
    $$assertionException.message$633_=message$633;
    Exception($$assertionException.message$633,undefined,$$assertionException);
    return $$assertionException;
}
AssertionException.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Exception},$ps:[{$nm:'message',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$an:function(){return[doc(String$("An exception that occurs when an assertion fails, that\nis, when a condition in an `assert` statement evaluates\nto false at runtime.",131)),shared()];},d:['ceylon.language','AssertionException']};};
exports.AssertionException=AssertionException;
function $init$AssertionException(){
    if (AssertionException.$$===undefined){
        initTypeProto(AssertionException,'ceylon.language::AssertionException',$init$Exception());
        (function($$assertionException){
            defineAttr($$assertionException,'message$633',function(){return this.message$633_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:AssertionException,d:['ceylon.language','AssertionException','$at','message']};});
        })(AssertionException.$$.prototype);
    }
    return AssertionException;
}
exports.$init$AssertionException=$init$AssertionException;
$init$AssertionException();
function Map($$targs$$,$$map){
    Collection($$map.$$targs$$===undefined?$$targs$$:{Element:{t:Entry,a:{Key:$$map.$$targs$$.Key,Item:$$map.$$targs$$.Item}}},$$map);
    add_type_arg($$map,'Element',{t:Entry,a:{Key:$$map.$$targs$$.Key,Item:$$map.$$targs$$.Item}});
    Correspondence($$map.$$targs$$===undefined?$$targs$$:{Key:{t:Object$},Item:$$map.$$targs$$.Item},$$map);
    add_type_arg($$map,'Key',{t:Object$});
    Cloneable($$map.$$targs$$===undefined?$$targs$$:{Clone:{t:Map,a:{Key:$$map.$$targs$$.Key,Item:$$map.$$targs$$.Item}}},$$map);
    add_type_arg($$map,'Clone',{t:Map,a:{Key:$$map.$$targs$$.Key,Item:$$map.$$targs$$.Item}});
    set_type_args($$map,$$targs$$);
    $$map.$prop$getKeys={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:'Key'}},$cont:Map,$an:function(){return[doc(String$("Returns the set of keys contained in this `Map`.",48)),actual(),shared(),$default()];},d:['ceylon.language','Map','$at','keys']};}};
    $$map.$prop$getKeys.get=function(){return keys};
    $$map.$prop$getValues={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Collection,a:{Element:'Item'}},$cont:Map,$an:function(){return[doc(String$("Returns all the values stored in this `Map`. An \nelement can be stored under more than one key in \nthe map, and so it can be contained more than once \nin the resulting collection.",179)),shared(),$default()];},d:['ceylon.language','Map','$at','values']};}};
    $$map.$prop$getValues.get=function(){return values};
    $$map.$prop$getInverse={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:'Item',Item:{t:Set,a:{Element:'Key'}}}},$cont:Map,$an:function(){return[doc(String$("Returns a `Map` in which every key is an `Item` in \nthis map, and every value is the set of keys that \nstored the `Item` in this map.",133)),shared(),$default()];},d:['ceylon.language','Map','$at','inverse']};}};
    $$map.$prop$getInverse.get=function(){return inverse};
}
Map.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Key:{'var':'out','satisfies':[{t:Object$}]},Item:{'var':'out','satisfies':[{t:Object$}]}},satisfies:[{t:Collection,a:{Element:{t:Entry,a:{Key:'Key',Item:'Item'}}}},{t:Correspondence,a:{Key:{t:Object$},Item:'Item'}},{t:Cloneable,a:{Clone:{t:Map,a:{Key:'Key',Item:'Item'}}}}],$an:function(){return[doc(String$("Represents a collection which maps _keys_ to _items_,\nwhere a key can map to at most one item. Each such \nmapping may be represented by an `Entry`.\n\nA `Map` is a `Collection` of its `Entry`s, and a \n`Correspondence` from keys to items.\n\nThe presence of an entry in a map may be tested\nusing the `in` operator:\n\n    if (\"lang\"->\"en_AU\" in settings) { ... }\n\nThe entries of the map may be iterated using `for`:\n\n    for (key->item in settings) { ... }\n\nThe item for a key may be obtained using the item\noperator:\n\n    String lang = settings[\"lang\"] else \"en_US\";",560)),see([$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Entry),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),forKey),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),forItem),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),byItem),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),byKey)].reifyCeylonType({Absent:{t:Null},Element:{t:'u', l:[{t:ClassDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration}]}})),shared()];},d:['ceylon.language','Map']};};
exports.Map=Map;
function $init$Map(){
    if (Map.$$===undefined){
        initTypeProtoI(Map,'ceylon.language::Map',$init$Collection(),$init$Correspondence(),$init$Cloneable());
        (function($$map){
            $$map.equals=function equals(that$634){
                var $$map=this;
                var that$635;
                if(isOfType((that$635=that$634),{t:Map,a:{Key:{t:Object$},Item:{t:Object$}}})&&that$635.size.equals($$map.size)){
                    var it$636 = $$map.iterator();
                    var entry$637;while ((entry$637=it$636.next())!==getFinished()){
                        var item$638;
                        if((item$638=that$635.$get(entry$637.key))!==null&&item$638.equals(entry$637.item)){
                            continue;
                        }else {
                            return false;
                        }
                    }
                    if (getFinished() === entry$637){
                        return true;
                    }
                }else {
                    return false;
                }
            };$$map.equals.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'that',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Map,$an:function(){return[doc(String$("Two `Map`s are considered equal iff they have the \nsame _entry sets_. The entry set of a `Map` is the\nset of `Entry`s belonging to the map. Therefore, the\nmaps are equal iff they have same set of `keys`, and \nfor every key in the key set, the maps have equal\nitems.",265)),shared(),actual(),$default()];},d:['ceylon.language','Map','$m','equals']};};
            defineAttr($$map,'hash',function(){
                var $$map=this;
                var hashCode$639=(1);
                function setHashCode$639(hashCode$640){return hashCode$639=hashCode$640;};
                $prop$getHashCode$639={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','Map','$at','hash','$at','hashCode']};}};
                $prop$getHashCode$639.get=function(){return hashCode$639};
                $prop$getHashCode$639.set=setHashCode$639;
                if (setHashCode$639.$$metamodel$$===undefined)setHashCode$639.$$metamodel$$=$prop$getHashCode$639.$$metamodel$$;
                var it$641 = $$map.iterator();
                var elem$642;while ((elem$642=it$641.next())!==getFinished()){
                    (hashCode$639=hashCode$639.times((31)));
                    (hashCode$639=hashCode$639.plus(elem$642.hash));
                }
                return hashCode$639;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:Map,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','Map','$at','hash']};});defineAttr($$map,'keys',function(){
                var $$map=this;
                return LazySet(Comprehension(function(){
                    var it$643=$$map.iterator();
                    var k$644,v$645;
                    var next$v$645=function(){
                        var entry$646;
                        if((entry$646=it$643.next())!==getFinished()){
                            k$644=entry$646.key;
                            v$645=entry$646.item;
                            return entry$646;
                        }
                        v$645=undefined;
                        return getFinished();
                    }
                    next$v$645();
                    return function(){
                        if(v$645!==undefined){
                            var k$644$647=k$644;
                            var v$645$648=v$645;
                            var tmpvar$649=k$644$647;
                            next$v$645();
                            return tmpvar$649;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:$$map.$$targs$$.Key}),{Element:$$map.$$targs$$.Key});
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:'Key'}},$cont:Map,$an:function(){return[doc(String$("Returns the set of keys contained in this `Map`.",48)),actual(),shared(),$default()];},d:['ceylon.language','Map','$at','keys']};});
            defineAttr($$map,'values',function(){
                var $$map=this;
                return LazyList(Comprehension(function(){
                    var it$650=$$map.iterator();
                    var k$651,v$652;
                    var next$v$652=function(){
                        var entry$653;
                        if((entry$653=it$650.next())!==getFinished()){
                            k$651=entry$653.key;
                            v$652=entry$653.item;
                            return entry$653;
                        }
                        v$652=undefined;
                        return getFinished();
                    }
                    next$v$652();
                    return function(){
                        if(v$652!==undefined){
                            var k$651$654=k$651;
                            var v$652$655=v$652;
                            var tmpvar$656=v$652$655;
                            next$v$652();
                            return tmpvar$656;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:$$map.$$targs$$.Item}),{Element:$$map.$$targs$$.Item});
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Collection,a:{Element:'Item'}},$cont:Map,$an:function(){return[doc(String$("Returns all the values stored in this `Map`. An \nelement can be stored under more than one key in \nthe map, and so it can be contained more than once \nin the resulting collection.",179)),shared(),$default()];},d:['ceylon.language','Map','$at','values']};});
            defineAttr($$map,'inverse',function(){
                var $$map=this;
                return LazyMap(Comprehension(function(){
                    var it$657=$$map.iterator();
                    var key$658,item$659;
                    var next$item$659=function(){
                        var entry$660;
                        if((entry$660=it$657.next())!==getFinished()){
                            key$658=entry$660.key;
                            item$659=entry$660.item;
                            return entry$660;
                        }
                        item$659=undefined;
                        return getFinished();
                    }
                    next$item$659();
                    return function(){
                        if(item$659!==undefined){
                            var key$658$661=key$658;
                            var item$659$662=item$659;
                            var tmpvar$663=Entry(item$659$662,LazySet(Comprehension(function(){
                                var it$664=$$map.iterator();
                                var k$665,i$666;
                                var next$i$666=function(){
                                    var entry$667;
                                    while((entry$667=it$664.next())!==getFinished()){
                                        k$665=entry$667.key;
                                        i$666=entry$667.item;
                                        if(i$666.equals(item$659$662)){
                                            return entry$667;
                                        }
                                    }
                                    i$666=undefined;
                                    return getFinished();
                                }
                                next$i$666();
                                return function(){
                                    if(i$666!==undefined){
                                        var k$665$668=k$665;
                                        var i$666$669=i$666;
                                        var tmpvar$670=k$665$668;
                                        next$i$666();
                                        return tmpvar$670;
                                    }
                                    return getFinished();
                                }
                            },{Absent:{t:Null},Element:$$map.$$targs$$.Key}),{Element:$$map.$$targs$$.Key}),{Key:$$map.$$targs$$.Item,Item:{t:LazySet,a:{Element:$$map.$$targs$$.Key}}});
                            next$item$659();
                            return tmpvar$663;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:{t:Entry,a:{Key:$$map.$$targs$$.Item,Item:{t:LazySet,a:{Element:$$map.$$targs$$.Key}}}}}),{Key:$$map.$$targs$$.Item,Item:{t:LazySet,a:{Element:$$map.$$targs$$.Key}}});
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:'Item',Item:{t:Set,a:{Element:'Key'}}}},$cont:Map,$an:function(){return[doc(String$("Returns a `Map` in which every key is an `Item` in \nthis map, and every value is the set of keys that \nstored the `Item` in this map.",133)),shared(),$default()];},d:['ceylon.language','Map','$at','inverse']};});
            $$map.mapItems=function (mapping$671,$$$mptypes){
                var $$map=this;
                return LazyMap(Comprehension(function(){
                    var it$672=$$map.iterator();
                    var key$673,item$674;
                    var next$item$674=function(){
                        var entry$675;
                        if((entry$675=it$672.next())!==getFinished()){
                            key$673=entry$675.key;
                            item$674=entry$675.item;
                            return entry$675;
                        }
                        item$674=undefined;
                        return getFinished();
                    }
                    next$item$674();
                    return function(){
                        if(item$674!==undefined){
                            var key$673$676=key$673;
                            var item$674$677=item$674;
                            var tmpvar$678=Entry(key$673$676,mapping$671(key$673$676,item$674$677),{Key:$$map.$$targs$$.Key,Item:$$$mptypes.Result});
                            next$item$674();
                            return tmpvar$678;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:{t:Entry,a:{Key:$$map.$$targs$$.Key,Item:$$$mptypes.Result}}}),{Key:$$map.$$targs$$.Key,Item:$$$mptypes.Result});
            };
            $$map.mapItems.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:'Key',Item:'Result'}},$ps:[{$nm:'mapping',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[doc("The function that transforms a key/item\npair, producing the item of the resulting\nmap.")];}}],$cont:Map,$tp:{Result:{'satisfies':[{t:Object$}]}},$an:function(){return[doc(String$("Returns a `Map` with the same keys as this map. For\nevery key, the item is the result of applying the\ngiven transformation function.",132)),shared(),$default()];},d:['ceylon.language','Map','$m','mapItems']};};
        })(Map.$$.prototype);
    }
    return Map;
}
exports.$init$Map=$init$Map;
$init$Map();
function emptyMap$679($$targs$$){
    var $$emptyMap=new emptyMap$679.$$;
    $$emptyMap.$$targs$$=$$targs$$;
    Object$($$emptyMap);
    Map({Key:{t:Nothing},Item:{t:Nothing}},$$emptyMap);
    $$emptyMap.$prop$getClone={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:{t:Nothing},Item:{t:Nothing}}},$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$at','clone']};}};
    $$emptyMap.$prop$getClone.get=function(){return clone};
    $$emptyMap.$prop$getKeys.get=function(){return keys};
    $$emptyMap.$prop$getInverse.get=function(){return inverse};
    $$emptyMap.$prop$getValues.get=function(){return values};
    $$emptyMap.size$680_=(0);
    $$emptyMap.$prop$getSize={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$at','size']};}};
    $$emptyMap.$prop$getSize.get=function(){return size};
    $$emptyMap.empty$681_=true;
    $$emptyMap.$prop$getEmpty={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$at','empty']};}};
    $$emptyMap.$prop$getEmpty.get=function(){return empty};
    return $$emptyMap;
};emptyMap$679.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Object$},satisfies:[{t:Map,a:{Key:{t:Nothing},Item:{t:Nothing}}}],$an:function(){return[doc("A [[Map]] with no entries."),shared()];},d:['ceylon.language','emptyMap']};};
function $init$emptyMap$679(){
    if (emptyMap$679.$$===undefined){
        initTypeProto(emptyMap$679,'ceylon.language::emptyMap',$init$Object$(),$init$Map());
        (function($$emptyMap){
            defineAttr($$emptyMap,'clone',function(){
                var $$emptyMap=this;
                return getEmptyMap();
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:{t:Nothing},Item:{t:Nothing}}},$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$at','clone']};});
            $$emptyMap.iterator=function (){
                var $$emptyMap=this;
                return getEmptyIterator();
            };
            $$emptyMap.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:{t:Nothing}}},$ps:[],$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','iterator']};};
            $$emptyMap.$get=function (key$682){
                var $$emptyMap=this;
                return null;
            };
            $$emptyMap.$get.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Null},$ps:[{$nm:'key',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','get']};};
            defineAttr($$emptyMap,'keys',function(){
                var $$emptyMap=this;
                return getEmptySet();
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:Nothing}}},$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$at','keys']};});
            $$emptyMap.mapItems=function (mapping$683,$$$mptypes){
                var $$emptyMap=this;
                return getEmptyMap();
            };
            $$emptyMap.mapItems.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:{t:Nothing},Item:{t:Nothing}}},$ps:[{$nm:'mapping',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[];}}],$cont:emptyMap$679,$tp:{Result:{'satisfies':[{t:Object$}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','mapItems']};};
            defineAttr($$emptyMap,'inverse',function(){
                var $$emptyMap=this;
                return getEmptyMap();
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:{t:Nothing},Item:{t:Nothing}}},$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$at','inverse']};});
            defineAttr($$emptyMap,'values',function(){
                var $$emptyMap=this;
                return getEmpty();
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Collection,a:{Element:{t:Nothing}}},$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$at','values']};});
            defineAttr($$emptyMap,'size',function(){return this.size$680_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$at','size']};});
            defineAttr($$emptyMap,'empty',function(){return this.empty$681_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$at','empty']};});
            $$emptyMap.contains=function (element$684){
                var $$emptyMap=this;
                return false;
            };
            $$emptyMap.contains.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'element',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','contains']};};
            $$emptyMap.containsAny=function (elements$685){
                var $$emptyMap=this;
                return false;
            };
            $$emptyMap.containsAny.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'elements',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Object$}}},$an:function(){return[];}}],$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','containsAny']};};
            $$emptyMap.containsEvery=function (elements$686){
                var $$emptyMap=this;
                return false;
            };
            $$emptyMap.containsEvery.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'elements',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Object$}}},$an:function(){return[];}}],$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','containsEvery']};};
            $$emptyMap.count=function (selecting$687){
                var $$emptyMap=this;
                return (0);
            };
            $$emptyMap.count.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','count']};};
            $$emptyMap.defines=function (index$688){
                var $$emptyMap=this;
                return false;
            };
            $$emptyMap.defines.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'index',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','defines']};};
            $$emptyMap.$map=function (collecting$689,$$$mptypes){
                var $$emptyMap=this;
                return getEmpty();
            };
            $$emptyMap.$map.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'collecting',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[];}}],$cont:emptyMap$679,$tp:{Result:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','map']};};
            $$emptyMap.$filter=function (selecting$690){
                var $$emptyMap=this;
                return getEmptyMap();
            };
            $$emptyMap.$filter.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:{t:Nothing},Item:{t:Nothing}}},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','filter']};};
            $$emptyMap.fold=function (initial$691,accumulating$692,$$$mptypes){
                var $$emptyMap=this;
                return initial$691;
            };
            $$emptyMap.fold.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Result',$ps:[{$nm:'initial',$mt:'prm',$t:'Result',$an:function(){return[];}},{$nm:'accumulating',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[];}}],$cont:emptyMap$679,$tp:{Result:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','fold']};};
            $$emptyMap.find=function (selecting$693){
                var $$emptyMap=this;
                return null;
            };
            $$emptyMap.find.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Null},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','find']};};
            $$emptyMap.collect=function (collecting$694,$$$mptypes){
                var $$emptyMap=this;
                return getEmpty();
            };
            $$emptyMap.collect.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'collecting',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[];}}],$cont:emptyMap$679,$tp:{Result:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','collect']};};
            $$emptyMap.select=function (selecting$695){
                var $$emptyMap=this;
                return getEmpty();
            };
            $$emptyMap.select.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Empty},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','select']};};
            $$emptyMap.any=function (selecting$696){
                var $$emptyMap=this;
                return false;
            };
            $$emptyMap.any.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','any']};};
            $$emptyMap.$every=function (selecting$697){
                var $$emptyMap=this;
                return false;
            };
            $$emptyMap.$every.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','every']};};
            $$emptyMap.skipping=function (skip$698){
                var $$emptyMap=this;
                return getEmptyMap();
            };
            $$emptyMap.skipping.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:{t:Nothing},Item:{t:Nothing}}},$ps:[{$nm:'skip',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','skipping']};};
            $$emptyMap.taking=function (take$699){
                var $$emptyMap=this;
                return getEmptyMap();
            };
            $$emptyMap.taking.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:{t:Nothing},Item:{t:Nothing}}},$ps:[{$nm:'take',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','taking']};};
            $$emptyMap.by=function (step$700){
                var $$emptyMap=this;
                return getEmptyMap();
            };
            $$emptyMap.by.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:{t:Nothing},Item:{t:Nothing}}},$ps:[{$nm:'step',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:emptyMap$679,$an:function(){return[shared(),actual()];},d:['ceylon.language','emptyMap','$m','by']};};
        })(emptyMap$679.$$.prototype);
    }
    return emptyMap$679;
}
exports.$init$emptyMap$679=$init$emptyMap$679;
$init$emptyMap$679();
var emptyMap$701;
function getEmptyMap(){
    if (emptyMap$701===undefined){emptyMap$701=$init$emptyMap$679()({Key:{t:Nothing},Item:{t:Nothing}});emptyMap$701.$$metamodel$$=getEmptyMap.$$metamodel$$;}
    return emptyMap$701;
}
exports.getEmptyMap=getEmptyMap;
getEmptyMap.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:emptyMap$679},$an:function(){return[doc(String$("A [[Map]] with no entries.",26)),shared()];},d:['ceylon.language','emptyMap']};};
$prop$getEmptyMap={get:getEmptyMap,$$metamodel$$:getEmptyMap.$$metamodel$$};
exports.$prop$getEmptyMap=$prop$getEmptyMap;
function LazyMap(entries$702, $$targs$$,$$lazyMap){
    $init$LazyMap();
    if ($$lazyMap===undefined)$$lazyMap=new LazyMap.$$;
    set_type_args($$lazyMap,$$targs$$);
    $$lazyMap.entries$702_=entries$702;
    Map($$lazyMap.$$targs$$===undefined?$$targs$$:{Key:$$lazyMap.$$targs$$.Key,Item:$$lazyMap.$$targs$$.Item},$$lazyMap);
    $$lazyMap.$prop$getFirst={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Entry,a:{Key:'Key',Item:'Item'}}]},$cont:LazyMap,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyMap','$at','first']};}};
    $$lazyMap.$prop$getFirst.get=function(){return first};
    $$lazyMap.$prop$getLast={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Entry,a:{Key:'Key',Item:'Item'}}]},$cont:LazyMap,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyMap','$at','last']};}};
    $$lazyMap.$prop$getLast.get=function(){return last};
    $$lazyMap.$prop$getClone={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:LazyMap,a:{Key:'Key',Item:'Item'}},$cont:LazyMap,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyMap','$at','clone']};}};
    $$lazyMap.$prop$getClone.get=function(){return clone};
    $$lazyMap.$prop$getSize={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:LazyMap,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyMap','$at','size']};}};
    $$lazyMap.$prop$getSize.get=function(){return size};
    return $$lazyMap;
}
LazyMap.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[{$nm:'entries',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Entry,a:{Key:'Key',Item:'Item'}}}},$an:function(){return[];}}],$tp:{Key:{'var':'out','satisfies':[{t:Object$}]},Item:{'var':'out','satisfies':[{t:Object$}]}},satisfies:[{t:Map,a:{Key:'Key',Item:'Item'}}],$an:function(){return[doc(String$("A `Map` implementation that wraps an `Iterable` of \nentries. All operations, such as lookups, size, etc. \nare performed on the `Iterable`.",138)),by([String$("Enrique Zamudio",15)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','LazyMap']};};
exports.LazyMap=LazyMap;
function $init$LazyMap(){
    if (LazyMap.$$===undefined){
        initTypeProto(LazyMap,'ceylon.language::LazyMap',Basic,$init$Map());
        (function($$lazyMap){
            defineAttr($$lazyMap,'first',function(){
                var $$lazyMap=this;
                return $$lazyMap.entries$702.first;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Entry,a:{Key:'Key',Item:'Item'}}]},$cont:LazyMap,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyMap','$at','first']};});
            defineAttr($$lazyMap,'last',function(){
                var $$lazyMap=this;
                return $$lazyMap.entries$702.last;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Entry,a:{Key:'Key',Item:'Item'}}]},$cont:LazyMap,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyMap','$at','last']};});
            defineAttr($$lazyMap,'clone',function(){
                var $$lazyMap=this;
                return $$lazyMap;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:LazyMap,a:{Key:'Key',Item:'Item'}},$cont:LazyMap,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyMap','$at','clone']};});
            defineAttr($$lazyMap,'size',function(){
                var $$lazyMap=this;
                return $$lazyMap.entries$702.size;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:LazyMap,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyMap','$at','size']};});
            $$lazyMap.$get=function (key$703){
                var $$lazyMap=this;
                return (opt$704=$$lazyMap.entries$702.find($JsCallable((function (e$705){
                    return e$705.key.equals(key$703);
                }),[{$nm:'e',$mt:'prm',$t:{t:Entry,a:{Key:'Key',Item:'Item'}},$an:function(){return[];}}],{Arguments:{t:'T', l:[{t:Entry,a:{Key:$$lazyMap.$$targs$$.Key,Item:$$lazyMap.$$targs$$.Item}}]},Return:{t:Boolean$}})),opt$704!==null?opt$704.item:null);
            };
            $$lazyMap.$get.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Item']},$ps:[{$nm:'key',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:LazyMap,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyMap','$m','get']};};
            $$lazyMap.iterator=function (){
                var $$lazyMap=this;
                return $$lazyMap.entries$702.iterator();
            };
            $$lazyMap.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:{t:Entry,a:{Key:'Key',Item:'Item'}}}},$ps:[],$cont:LazyMap,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyMap','$m','iterator']};};
            $$lazyMap.equals=function equals(that$706){
                var $$lazyMap=this;
                var that$707;
                if(isOfType((that$707=that$706),{t:Map,a:{Key:{t:Object$},Item:{t:Object$}}})){
                    if(that$707.size.equals($$lazyMap.size)){
                        var it$708 = $$lazyMap.iterator();
                        var entry$709;while ((entry$709=it$708.next())!==getFinished()){
                            var item$710;
                            if((item$710=that$707.$get(entry$709.key))!==null){
                                if(item$710.equals(entry$709.item)){
                                    continue;
                                }
                            }
                            return false;
                        }
                        if (getFinished() === entry$709){
                            return true;
                        }
                    }
                }
                return false;
            };$$lazyMap.equals.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'that',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:LazyMap,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','LazyMap','$m','equals']};};
            defineAttr($$lazyMap,'hash',function(){
                var $$lazyMap=this;
                var hashCode$711=(1);
                function setHashCode$711(hashCode$712){return hashCode$711=hashCode$712;};
                $prop$getHashCode$711={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','LazyMap','$at','hash','$at','hashCode']};}};
                $prop$getHashCode$711.get=function(){return hashCode$711};
                $prop$getHashCode$711.set=setHashCode$711;
                if (setHashCode$711.$$metamodel$$===undefined)setHashCode$711.$$metamodel$$=$prop$getHashCode$711.$$metamodel$$;
                var it$713 = $$lazyMap.entries$702.iterator();
                var elem$714;while ((elem$714=it$713.next())!==getFinished()){
                    (hashCode$711=hashCode$711.times((31)));
                    (hashCode$711=hashCode$711.plus(elem$714.hash));
                }
                return hashCode$711;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:LazyMap,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','LazyMap','$at','hash']};});defineAttr($$lazyMap,'entries$702',function(){return this.entries$702_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Entry,a:{Key:'Key',Item:'Item'}}}},$cont:LazyMap,d:['ceylon.language','LazyMap','$at','entries']};});
        })(LazyMap.$$.prototype);
    }
    return LazyMap;
}
exports.$init$LazyMap=$init$LazyMap;
$init$LazyMap();
var opt$704;
function LazyList(elems$715, $$targs$$,$$lazyList){
    $init$LazyList();
    if ($$lazyList===undefined)$$lazyList=new LazyList.$$;
    set_type_args($$lazyList,$$targs$$);
    $$lazyList.elems$715_=elems$715;
    List($$lazyList.$$targs$$===undefined?$$targs$$:{Element:$$lazyList.$$targs$$.Element},$$lazyList);
    $$lazyList.$prop$getRest={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$cont:LazyList,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyList','$at','rest']};}};
    $$lazyList.$prop$getRest.get=function(){return rest};
    $$lazyList.$prop$getReversed={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$cont:LazyList,$an:function(){return[doc(String$("Returns a `List` with the elements of this `List` \nin reverse order. This operation will create copy \nthe elements to a new `List`, so changes to the \noriginal `Iterable` will no longer be reflected in \nthe new `List`.",218)),shared(),actual()];},d:['ceylon.language','LazyList','$at','reversed']};}};
    $$lazyList.$prop$getReversed.get=function(){return reversed};
    $$lazyList.$prop$getClone={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$cont:LazyList,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyList','$at','clone']};}};
    $$lazyList.$prop$getClone.get=function(){return clone};
    $$lazyList.$prop$getFirst={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$cont:LazyList,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','LazyList','$at','first']};}};
    $$lazyList.$prop$getFirst.get=function(){return first};
    $$lazyList.$prop$getLast={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$cont:LazyList,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','LazyList','$at','last']};}};
    $$lazyList.$prop$getLast.get=function(){return last};
    return $$lazyList;
}
LazyList.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[{$nm:'elems',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$an:function(){return[];}}],$tp:{Element:{'var':'out'}},satisfies:[{t:List,a:{Element:'Element'}}],$an:function(){return[doc(String$("An implementation of `List` that wraps an `Iterable` of\nelements. All operations on this `List` are performed on \nthe `Iterable`.",129)),by([String$("Enrique Zamudio",15)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','LazyList']};};
exports.LazyList=LazyList;
function $init$LazyList(){
    if (LazyList.$$===undefined){
        initTypeProto(LazyList,'ceylon.language::LazyList',Basic,$init$List());
        (function($$lazyList){
            defineAttr($$lazyList,'lastIndex',function(){
                var $$lazyList=this;
                var size$716=$$lazyList.elems$715.size;
                $prop$getSize$716={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','LazyList','$at','lastIndex','$at','size']};}};
                $prop$getSize$716.get=function(){return size$716};
                return (opt$717=(size$716.compare((0)).equals(getLarger())?size$716.minus((1)):null),opt$717!==null?opt$717:null);
                var opt$717;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Integer}]},$cont:LazyList,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyList','$at','lastIndex']};});$$lazyList.$get=function $get(index$718){
                var $$lazyList=this;
                if(index$718.equals((0))){
                    return $$lazyList.elems$715.first;
                }else {
                    return $$lazyList.elems$715.skipping(index$718).first;
                }
            };$$lazyList.$get.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$ps:[{$nm:'index',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:LazyList,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyList','$m','get']};};
            defineAttr($$lazyList,'rest',function(){
                var $$lazyList=this;
                return LazyList($$lazyList.elems$715.rest,{Element:$$lazyList.$$targs$$.Element});
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$cont:LazyList,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyList','$at','rest']};});
            $$lazyList.iterator=function (){
                var $$lazyList=this;
                return $$lazyList.elems$715.iterator();
            };
            $$lazyList.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$ps:[],$cont:LazyList,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyList','$m','iterator']};};
            defineAttr($$lazyList,'reversed',function(){
                var $$lazyList=this;
                return $$lazyList.elems$715.sequence.reversed;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$cont:LazyList,$an:function(){return[doc(String$("Returns a `List` with the elements of this `List` \nin reverse order. This operation will create copy \nthe elements to a new `List`, so changes to the \noriginal `Iterable` will no longer be reflected in \nthe new `List`.",218)),shared(),actual()];},d:['ceylon.language','LazyList','$at','reversed']};});
            defineAttr($$lazyList,'clone',function(){
                var $$lazyList=this;
                return $$lazyList;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$cont:LazyList,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyList','$at','clone']};});
            $$lazyList.span=function span(from$719,to$720){
                var $$lazyList=this;
                if((to$720.compare((0)).equals(getSmaller())&&from$719.compare((0)).equals(getSmaller()))){
                    return getEmpty();
                }
                var toIndex$721=largest(to$720,(0),{Element:{t:Integer}});
                var fromIndex$722=largest(from$719,(0),{Element:{t:Integer}});
                if((toIndex$721.compare(fromIndex$722)!==getSmaller())){
                    var els$723=(opt$724=(fromIndex$722.compare((0)).equals(getLarger())?$$lazyList.elems$715.skipping(fromIndex$722):null),opt$724!==null?opt$724:$$lazyList.elems$715);
                    $prop$getEls$723={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},d:['ceylon.language','LazyList','$m','span','$at','els']};}};
                    $prop$getEls$723.get=function(){return els$723};
                    var opt$724;
                    return LazyList(els$723.taking(toIndex$721.minus(fromIndex$722).plus((1))),{Element:$$lazyList.$$targs$$.Element});
                }else {
                    var seq$725=(opt$726=(toIndex$721.compare((0)).equals(getLarger())?$$lazyList.elems$715.skipping(toIndex$721):null),opt$726!==null?opt$726:$$lazyList.elems$715);
                    $prop$getSeq$725={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},d:['ceylon.language','LazyList','$m','span','$at','seq']};}};
                    $prop$getSeq$725.get=function(){return seq$725};
                    var opt$726;
                    return seq$725.taking(fromIndex$722.minus(toIndex$721).plus((1))).sequence.reversed;
                }
            };$$lazyList.span.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$ps:[{$nm:'from',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'to',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:LazyList,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyList','$m','span']};};
            $$lazyList.spanTo=function (to$727){
                var $$lazyList=this;
                return (opt$728=(to$727.compare((0)).equals(getSmaller())?getEmpty():null),opt$728!==null?opt$728:LazyList($$lazyList.elems$715.taking(to$727.plus((1))),{Element:$$lazyList.$$targs$$.Element}));
            };
            $$lazyList.spanTo.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$ps:[{$nm:'to',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:LazyList,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyList','$m','spanTo']};};
            $$lazyList.spanFrom=function (from$729){
                var $$lazyList=this;
                return (opt$730=(from$729.compare((0)).equals(getLarger())?LazyList($$lazyList.elems$715.skipping(from$729),{Element:$$lazyList.$$targs$$.Element}):null),opt$730!==null?opt$730:$$lazyList);
            };
            $$lazyList.spanFrom.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$ps:[{$nm:'from',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:LazyList,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyList','$m','spanFrom']};};
            $$lazyList.segment=function segment(from$731,length$732){
                var $$lazyList=this;
                if(length$732.compare((0)).equals(getLarger())){
                    var els$733=(opt$734=(from$731.compare((0)).equals(getLarger())?$$lazyList.elems$715.skipping(from$731):null),opt$734!==null?opt$734:$$lazyList.elems$715);
                    $prop$getEls$733={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},d:['ceylon.language','LazyList','$m','segment','$at','els']};}};
                    $prop$getEls$733.get=function(){return els$733};
                    var opt$734;
                    return LazyList(els$733.taking(length$732),{Element:$$lazyList.$$targs$$.Element});
                }else {
                    return getEmpty();
                }
            };$$lazyList.segment.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:'Element'}},$ps:[{$nm:'from',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'length',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],$cont:LazyList,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazyList','$m','segment']};};
            $$lazyList.equals=function equals(that$735){
                var $$lazyList=this;
                var that$736;
                if(isOfType((that$736=that$735),{t:List,a:{Element:{t:Anything}}})){
                    var size$737=$$lazyList.elems$715.size;
                    $prop$getSize$737={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','LazyList','$m','equals','$at','size']};}};
                    $prop$getSize$737.get=function(){return size$737};
                    if(that$736.size.equals(size$737)){
                        var it$738 = Range((0),size$737.minus((1)),{Element:{t:Integer}}).iterator();
                        var i$739;while ((i$739=it$738.next())!==getFinished()){
                            var x$740=$$lazyList.$get(i$739);
                            $prop$getX$740={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},d:['ceylon.language','LazyList','$m','equals','$at','x']};}};
                            $prop$getX$740.get=function(){return x$740};
                            var y$741=that$736.$get(i$739);
                            $prop$getY$741={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Anything},d:['ceylon.language','LazyList','$m','equals','$at','y']};}};
                            $prop$getY$741.get=function(){return y$741};
                            var x$742;
                            if((x$742=x$740)!==null){
                                var y$743;
                                if((y$743=y$741)!==null){
                                    if((!x$742.equals(y$743))){
                                        return false;
                                    }
                                }else {
                                    return false;
                                }
                            }else {
                                var y$744;
                                if((y$744=y$741)!==null){
                                    return false;
                                }
                            }
                        }
                        if (getFinished() === i$739){
                            return true;
                        }
                    }
                }
                return false;
            };$$lazyList.equals.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'that',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:LazyList,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','LazyList','$m','equals']};};
            defineAttr($$lazyList,'hash',function(){
                var $$lazyList=this;
                var hash$745=(1);
                function setHash$745(hash$746){return hash$745=hash$746;};
                $prop$getHash$745={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','LazyList','$at','hash','$at','hash']};}};
                $prop$getHash$745.get=function(){return hash$745};
                $prop$getHash$745.set=setHash$745;
                if (setHash$745.$$metamodel$$===undefined)setHash$745.$$metamodel$$=$prop$getHash$745.$$metamodel$$;
                var it$747 = $$lazyList.elems$715.iterator();
                var elem$748;while ((elem$748=it$747.next())!==getFinished()){
                    (hash$745=hash$745.times((31)));
                    var elem$749;
                    if((elem$749=elem$748)!==null){
                        (hash$745=hash$745.plus(elem$749.hash));
                    }
                }
                return hash$745;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:LazyList,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','LazyList','$at','hash']};});$$lazyList.findLast=function (selecting$750){
                var $$lazyList=this;
                return $$lazyList.elems$715.findLast($JsCallable(selecting$750,[{$nm:'elem',$mt:'prm',$t:'Element',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$lazyList.$$targs$$.Element]},Return:{t:Boolean$}}));
            };
            $$lazyList.findLast.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$ps:[{$nm:'selecting',$mt:'prm',$pt:'f',$t:{t:Boolean$},$an:function(){return[];}}],$cont:LazyList,$an:function(){return[shared(),$default(),actual()];},d:['ceylon.language','LazyList','$m','findLast']};};
            defineAttr($$lazyList,'first',function(){
                var $$lazyList=this;
                return $$lazyList.elems$715.first;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$cont:LazyList,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','LazyList','$at','first']};});
            defineAttr($$lazyList,'last',function(){
                var $$lazyList=this;
                return $$lazyList.elems$715.last;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Element']},$cont:LazyList,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','LazyList','$at','last']};});
            defineAttr($$lazyList,'elems$715',function(){return this.elems$715_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$cont:LazyList,d:['ceylon.language','LazyList','$at','elems']};});
        })(LazyList.$$.prototype);
    }
    return LazyList;
}
exports.$init$LazyList=$init$LazyList;
$init$LazyList();
var opt$728,opt$730;
function LazySet(elems$751, $$targs$$,$$lazySet){
    $init$LazySet();
    if ($$lazySet===undefined)$$lazySet=new LazySet.$$;
    set_type_args($$lazySet,$$targs$$);
    $$lazySet.elems$751_=elems$751;
    Set($$lazySet.$$targs$$===undefined?$$targs$$:{Element:$$lazySet.$$targs$$.Element},$$lazySet);
    $$lazySet.$prop$getClone={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:LazySet,a:{Element:'Element'}},$cont:LazySet,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazySet','$at','clone']};}};
    $$lazySet.$prop$getClone.get=function(){return clone};
    return $$lazySet;
}
LazySet.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[{$nm:'elems',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$an:function(){return[];}}],$tp:{Element:{'var':'out','satisfies':[{t:Object$}]}},satisfies:[{t:Set,a:{Element:'Element'}}],$an:function(){return[doc(String$("An implementation of `Set` that wraps an `Iterable` of\nelements. All operations on this `Set` are performed\non the `Iterable`.",126)),by([String$("Enrique Zamudio",15)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','LazySet']};};
exports.LazySet=LazySet;
function $init$LazySet(){
    if (LazySet.$$===undefined){
        initTypeProto(LazySet,'ceylon.language::LazySet',Basic,$init$Set());
        (function($$lazySet){
            defineAttr($$lazySet,'clone',function(){
                var $$lazySet=this;
                return $$lazySet;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:LazySet,a:{Element:'Element'}},$cont:LazySet,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazySet','$at','clone']};});
            defineAttr($$lazySet,'size',function(){
                var $$lazySet=this;
                var c$752=(0);
                function setC$752(c$753){return c$752=c$753;};
                $prop$getC$752={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','LazySet','$at','size','$at','c']};}};
                $prop$getC$752.get=function(){return c$752};
                $prop$getC$752.set=setC$752;
                if (setC$752.$$metamodel$$===undefined)setC$752.$$metamodel$$=$prop$getC$752.$$metamodel$$;
                var sorted$754=$$lazySet.elems$751.$sort($JsCallable(byIncreasing($JsCallable((function (e$755){
                    return e$755.hash;
                }),[{$nm:'e',$mt:'prm',$t:'Element',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$lazySet.$$targs$$.Element]},Return:{t:Integer}}),{Value:{t:Integer},Element:$$lazySet.$$targs$$.Element}),[{$nm:'p2',$mt:'prm',$t:'Element'},{$nm:'p3',$mt:'prm',$t:'Element'}],{Arguments:{t:'T', l:[$$lazySet.$$targs$$.Element,$$lazySet.$$targs$$.Element]},Return:{t:Comparison}}));
                $prop$getSorted$754={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},d:['ceylon.language','LazySet','$at','size','$at','sorted']};}};
                $prop$getSorted$754.get=function(){return sorted$754};
                var l$756;
                if((l$756=sorted$754.first)!==null){
                    c$752=(1);
                    var last$757=l$756;
                    function setLast$757(last$758){return last$757=last$758;};
                    $prop$getLast$757={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Element',$an:function(){return[variable()];},d:['ceylon.language','LazySet','$at','size','$at','last']};}};
                    $prop$getLast$757.get=function(){return last$757};
                    $prop$getLast$757.set=setLast$757;
                    if (setLast$757.$$metamodel$$===undefined)setLast$757.$$metamodel$$=$prop$getLast$757.$$metamodel$$;
                    var it$759 = sorted$754.rest.iterator();
                    var e$760;while ((e$760=it$759.next())!==getFinished()){
                        if((!e$760.equals(last$757))){
                            (oldc$761=c$752,c$752=oldc$761.successor,oldc$761);
                            var oldc$761;
                            last$757=e$760;
                        }
                    }
                }
                return c$752;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:LazySet,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazySet','$at','size']};});$$lazySet.iterator=function iterator(){
                var $$lazySet=this;
                function iterator$762($$targs$$){
                    var $$iterator$762=new iterator$762.$$;
                    $$iterator$762.$$targs$$=$$targs$$;
                    Iterator({Element:$$lazySet.$$targs$$.Element},$$iterator$762);
                    $$iterator$762.sorted$763_=$$lazySet.elems$751.$sort($JsCallable(byIncreasing($JsCallable((function (e$764){
                        return e$764.hash;
                    }),[{$nm:'e',$mt:'prm',$t:'Element',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$lazySet.$$targs$$.Element]},Return:{t:Integer}}),{Value:{t:Integer},Element:$$lazySet.$$targs$$.Element}),[{$nm:'p2',$mt:'prm',$t:'Element'},{$nm:'p3',$mt:'prm',$t:'Element'}],{Arguments:{t:'T', l:[$$lazySet.$$targs$$.Element,$$lazySet.$$targs$$.Element]},Return:{t:Comparison}})).iterator();
                    $$iterator$762.$prop$getSorted$763={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$cont:iterator$762,d:['ceylon.language','LazySet','$m','iterator','$o','iterator','$at','sorted']};}};
                    $$iterator$762.$prop$getSorted$763.get=function(){return sorted$763};
                    $$iterator$762.ready$765_=$$iterator$762.sorted$763.next();
                    $$iterator$762.$prop$getReady$765={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$cont:iterator$762,$an:function(){return[variable()];},d:['ceylon.language','LazySet','$m','iterator','$o','iterator','$at','ready']};}};
                    $$iterator$762.$prop$getReady$765.get=function(){return ready$765};
                    return $$iterator$762;
                };iterator$762.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterator,a:{Element:'Element'}}],d:['ceylon.language','LazySet','$m','iterator','$o','iterator']};};
                function $init$iterator$762(){
                    if (iterator$762.$$===undefined){
                        initTypeProto(iterator$762,'ceylon.language::LazySet.iterator.iterator',Basic,$init$Iterator());
                        (function($$iterator$762){
                            defineAttr($$iterator$762,'sorted$763',function(){return this.sorted$763_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$cont:iterator$762,d:['ceylon.language','LazySet','$m','iterator','$o','iterator','$at','sorted']};});
                            defineAttr($$iterator$762,'ready$765',function(){return this.ready$765_;},function(ready$766){return this.ready$765_=ready$766;},function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$cont:iterator$762,$an:function(){return[variable()];},d:['ceylon.language','LazySet','$m','iterator','$o','iterator','$at','ready']};});
                            $$iterator$762.next=function next(){
                                var $$iterator$762=this;
                                var next$767=$$iterator$762.ready$765;
                                var next$768;
                                if(!isOfType((next$768=next$767),{t:Finished})){
                                    while(next$768.equals($$iterator$762.ready$765)){
                                        $$iterator$762.ready$765=$$iterator$762.sorted$763.next();
                                    }
                                }
                                return next$767;
                            };$$iterator$762.next.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Element',{t:Finished}]},$ps:[],$cont:iterator$762,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazySet','$m','iterator','$o','iterator','$m','next']};};
                        })(iterator$762.$$.prototype);
                    }
                    return iterator$762;
                }
                $init$iterator$762();
                var iterator$769;
                function getIterator$769(){
                    if (iterator$769===undefined){iterator$769=$init$iterator$762()({Element:$$lazySet.$$targs$$.Element});iterator$769.$$metamodel$$=getIterator$769.$$metamodel$$;}
                    return iterator$769;
                }
                getIterator$769.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterator$762},d:['ceylon.language','LazySet','$m','iterator','$o','iterator']};};
                $prop$getIterator$769={get:getIterator$769,$$metamodel$$:getIterator$769.$$metamodel$$};
                return getIterator$769();
            };$$lazySet.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Element'}},$ps:[],$cont:LazySet,$an:function(){return[shared(),actual()];},d:['ceylon.language','LazySet','$m','iterator']};};
            $$lazySet.union=function (set$770,$$$mptypes){
                var $$lazySet=this;
                return LazySet($$lazySet.elems$751.chain(set$770,{Other:$$$mptypes.Other,OtherAbsent:{t:Null}}),{Element:{t:'u', l:[$$lazySet.$$targs$$.Element,$$$mptypes.Other]}});
            };
            $$lazySet.union.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:'u', l:['Element','Other']}}},$ps:[{$nm:'set',$mt:'prm',$t:{t:Set,a:{Element:'Other'}},$an:function(){return[];}}],$cont:LazySet,$tp:{Other:{'satisfies':[{t:Object$}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language','LazySet','$m','union']};};
            $$lazySet.intersection=function (set$771,$$$mptypes){
                var $$lazySet=this;
                return LazySet(Comprehension(function(){
                    var e$774;
                    var it$772=set$771.iterator();
                    var e$773=getFinished();
                    var e$774;
                    var next$e$773=function(){
                        while((e$773=it$772.next())!==getFinished()){
                            if(isOfType((e$774=e$773),$$lazySet.$$targs$$.Element)&&$$lazySet.contains(e$774)){
                                return e$773;
                            }
                        }
                        return getFinished();
                    }
                    next$e$773();
                    return function(){
                        if(e$773!==getFinished()){
                            var e$773$775=e$773;
                            var tmpvar$776=e$774;
                            next$e$773();
                            return tmpvar$776;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:{t:'i', l:[$$$mptypes.Other,$$lazySet.$$targs$$.Element]}}),{Element:{t:'i', l:[$$$mptypes.Other,$$lazySet.$$targs$$.Element]}});
            };
            $$lazySet.intersection.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:'i', l:['Element','Other']}}},$ps:[{$nm:'set',$mt:'prm',$t:{t:Set,a:{Element:'Other'}},$an:function(){return[];}}],$cont:LazySet,$tp:{Other:{'satisfies':[{t:Object$}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language','LazySet','$m','intersection']};};
            $$lazySet.exclusiveUnion=function exclusiveUnion(other$777,$$$mptypes){
                var $$lazySet=this;
                var hereNotThere$778=Comprehension(function(){
                    var it$779=$$lazySet.elems$751.iterator();
                    var e$780=getFinished();
                    var next$e$780=function(){
                        while((e$780=it$779.next())!==getFinished()){
                            if((!other$777.contains(e$780))){
                                return e$780;
                            }
                        }
                        return getFinished();
                    }
                    next$e$780();
                    return function(){
                        if(e$780!==getFinished()){
                            var e$780$781=e$780;
                            var tmpvar$782=e$780$781;
                            next$e$780();
                            return tmpvar$782;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:$$lazySet.$$targs$$.Element});
                var thereNotHere$783=Comprehension(function(){
                    var it$784=other$777.iterator();
                    var e$785=getFinished();
                    var next$e$785=function(){
                        while((e$785=it$784.next())!==getFinished()){
                            if((!$$lazySet.contains(e$785))){
                                return e$785;
                            }
                        }
                        return getFinished();
                    }
                    next$e$785();
                    return function(){
                        if(e$785!==getFinished()){
                            var e$785$786=e$785;
                            var tmpvar$787=e$785$786;
                            next$e$785();
                            return tmpvar$787;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:$$$mptypes.Other});
                return LazySet(hereNotThere$778.chain(thereNotHere$783,{Other:$$$mptypes.Other,OtherAbsent:{t:Null}}),{Element:{t:'u', l:[$$lazySet.$$targs$$.Element,$$$mptypes.Other]}});
            };$$lazySet.exclusiveUnion.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:{t:'u', l:['Element','Other']}}},$ps:[{$nm:'other',$mt:'prm',$t:{t:Set,a:{Element:'Other'}},$an:function(){return[];}}],$cont:LazySet,$tp:{Other:{'satisfies':[{t:Object$}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language','LazySet','$m','exclusiveUnion']};};
            $$lazySet.complement=function (set$788,$$$mptypes){
                var $$lazySet=this;
                return LazySet(Comprehension(function(){
                    var it$789=$$lazySet.iterator();
                    var e$790=getFinished();
                    var next$e$790=function(){
                        while((e$790=it$789.next())!==getFinished()){
                            if((!set$788.contains(e$790))){
                                return e$790;
                            }
                        }
                        return getFinished();
                    }
                    next$e$790();
                    return function(){
                        if(e$790!==getFinished()){
                            var e$790$791=e$790;
                            var tmpvar$792=e$790$791;
                            next$e$790();
                            return tmpvar$792;
                        }
                        return getFinished();
                    }
                },{Absent:{t:Null},Element:$$lazySet.$$targs$$.Element}),{Element:$$lazySet.$$targs$$.Element});
            };
            $$lazySet.complement.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Set,a:{Element:'Element'}},$ps:[{$nm:'set',$mt:'prm',$t:{t:Set,a:{Element:'Other'}},$an:function(){return[];}}],$cont:LazySet,$tp:{Other:{'satisfies':[{t:Object$}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language','LazySet','$m','complement']};};
            $$lazySet.equals=function equals(that$793){
                var $$lazySet=this;
                var that$794;
                if(isOfType((that$794=that$793),{t:Set,a:{Element:{t:Object$}}})){
                    if(that$794.size.equals($$lazySet.size)){
                        var it$795 = $$lazySet.elems$751.iterator();
                        var element$796;while ((element$796=it$795.next())!==getFinished()){
                            if((!that$794.contains(element$796))){
                                return false;
                            }
                        }
                        if (getFinished() === element$796){
                            return true;
                        }
                    }
                }
                return false;
            };$$lazySet.equals.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'that',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:LazySet,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','LazySet','$m','equals']};};
            defineAttr($$lazySet,'hash',function(){
                var $$lazySet=this;
                var hashCode$797=(1);
                function setHashCode$797(hashCode$798){return hashCode$797=hashCode$798;};
                $prop$getHashCode$797={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','LazySet','$at','hash','$at','hashCode']};}};
                $prop$getHashCode$797.get=function(){return hashCode$797};
                $prop$getHashCode$797.set=setHashCode$797;
                if (setHashCode$797.$$metamodel$$===undefined)setHashCode$797.$$metamodel$$=$prop$getHashCode$797.$$metamodel$$;
                var it$799 = $$lazySet.elems$751.iterator();
                var elem$800;while ((elem$800=it$799.next())!==getFinished()){
                    (hashCode$797=hashCode$797.times((31)));
                    (hashCode$797=hashCode$797.plus(elem$800.hash));
                }
                return hashCode$797;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$cont:LazySet,$an:function(){return[shared(),actual(),$default()];},d:['ceylon.language','LazySet','$at','hash']};});defineAttr($$lazySet,'elems$751',function(){return this.elems$751_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$cont:LazySet,d:['ceylon.language','LazySet','$at','elems']};});
        })(LazySet.$$.prototype);
    }
    return LazySet;
}
exports.$init$LazySet=$init$LazySet;
$init$LazySet();
function any(values$801){
    var it$802 = values$801.iterator();
    var val$803;while ((val$803=it$802.next())!==getFinished()){
        if(val$803){
            return true;
        }
    }
    return false;
}
exports.any=any;
any.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'values',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Boolean$}}},$an:function(){return[];}}],$an:function(){return[doc(String$("Determines if any one of the given boolean values \n(usually a comprehension) is `true`.",87)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),every)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','any']};};
var byDecreasing=function (comparable$804,$$$mptypes){
    return function(x$805,y$806){{
        return comparable$804(y$806).compare(comparable$804(x$805));
    }
}
}
;
byDecreasing.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Comparison},$ps:[{$nm:'comparable',$mt:'prm',$pt:'f',$t:'Value',$an:function(){return[];}}],$tp:{Element:{},Value:{'satisfies':[{t:Comparable,a:{Other:'Value'}}]}},$an:function(){return[doc(String$("A comparator which orders elements in decreasing order \naccording to the `Comparable` returned by the given \n`comparable()` function.",133)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),byIncreasing)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','byDecreasing']};};
exports.byDecreasing=byDecreasing;
var byIncreasing=function (comparable$807,$$$mptypes){
    return function(x$808,y$809){{
        return comparable$807(x$808).compare(comparable$807(y$809));
    }
}
}
;
byIncreasing.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Comparison},$ps:[{$nm:'comparable',$mt:'prm',$pt:'f',$t:'Value',$an:function(){return[];}}],$tp:{Element:{},Value:{'satisfies':[{t:Comparable,a:{Other:'Value'}}]}},$an:function(){return[doc(String$("A comparator which orders elements in increasing order \naccording to the `Comparable` returned by the given \n`comparable()` function.",133)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),byDecreasing)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','byIncreasing']};};
exports.byIncreasing=byIncreasing;
var byItem=function (comparing$810,$$$mptypes){
    return function(x$811,y$812){{
        return comparing$810(x$811.item,y$812.item);
    }
}
}
;
byItem.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Comparison},$ps:[{$nm:'comparing',$mt:'prm',$pt:'f',$t:{t:Comparison},$an:function(){return[];}}],$tp:{Item:{'satisfies':[{t:Object$}]}},$an:function(){return[doc(String$("A comparator for `Entry`s which compares their items \naccording to the given `comparing()` function.",100)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),byKey)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','byItem']};};
exports.byItem=byItem;
var byKey=function (comparing$813,$$$mptypes){
    return function(x$814,y$815){{
        return comparing$813(x$814.key,y$815.key);
    }
}
}
;
byKey.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Comparison},$ps:[{$nm:'comparing',$mt:'prm',$pt:'f',$t:{t:Comparison},$an:function(){return[];}}],$tp:{Key:{'satisfies':[{t:Object$}]}},$an:function(){return[doc(String$("A comparator for `Entry`s which compares their keys \naccording to the given `comparing()` function.",99)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),byItem)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','byKey']};};
exports.byKey=byKey;
var coalesce=function (values$816,$$$mptypes){
    return values$816.coalesced;
};
coalesce.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:'i', l:['Element',{t:Object$}]}}},$ps:[{$nm:'values',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$an:function(){return[doc("The values, some of which may be null.")];}}],$tp:{Element:{}},$an:function(){return[doc(String$("Return a sequence containing the given values which are\nnot null. If there are no values which are not null,\nreturn an empty sequence.",134)),shared()];},d:['ceylon.language','coalesce']};};
exports.coalesce=coalesce;
function count(values$817){
    var count$818=(0);
    function setCount$818(count$819){return count$818=count$819;};
    var it$820 = values$817.iterator();
    var val$821;while ((val$821=it$820.next())!==getFinished()){
        if(val$821){
            (oldcount$822=count$818,count$818=oldcount$822.successor,oldcount$822);
            var oldcount$822;
        }
    }
    return count$818;
}
exports.count=count;
count.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$ps:[{$nm:'values',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Boolean$}}},$an:function(){return[];}}],$an:function(){return[doc(String$("A count of the number of `true` items in the given values.",58)),shared()];},d:['ceylon.language','count']};};
function emptyOrSingleton(element$823,$$$mptypes){
    var element$824;
    if((element$824=element$823)!==null){
        return Singleton(element$824,{Element:$$$mptypes.Element});
    }else {
        return getEmpty();
    }
}
exports.emptyOrSingleton=emptyOrSingleton;
emptyOrSingleton.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$ps:[{$nm:'element',$mt:'prm',$t:{t:'u', l:[{t:Null},'Element']},$an:function(){return[];}}],$tp:{Element:{'satisfies':[{t:Object$}]}},$an:function(){return[doc(String$("A `Singleton` if the given element is non-null, otherwise `Empty`.",66)),see([$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Singleton),$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Empty)].reifyCeylonType({Absent:{t:Null},Element:{t:'u', l:[{t:ClassDeclaration$meta$declaration},{t:InterfaceDeclaration$meta$declaration}]}})),shared()];},d:['ceylon.language','emptyOrSingleton']};};
var curry=function (f$825,$$$mptypes){
    return function(first$826){{
        return flatten($JsCallable((function (args$827){
            return unflatten($JsCallable(f$825,[],{Arguments:{t:'T', l:[$$$mptypes.First]},Return:$$$mptypes.Return}),{Args:{t:'T', l:[$$$mptypes.First]},Return:$$$mptypes.Return})(Tuple(first$826,args$827,{Rest:$$$mptypes.Rest,First:$$$mptypes.First,Element:$$$mptypes.Argument}),{Args:{t:'T', l:[$$$mptypes.First]},Return:$$$mptypes.Return});
        }),[{$nm:'args',$mt:'prm',$t:'Rest',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$$mptypes.Rest]},Return:$$$mptypes.Return}),{Args:$$$mptypes.Rest,Return:$$$mptypes.Return});
    }
}
}
;
curry.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Callable,a:{Arguments:'Rest',Return:'Return'}},$ps:[{$nm:'f',$mt:'prm',$t:{t:Callable,a:{Arguments:{t:'T',l:[{$t:'First'}]},Return:'Return'}},$an:function(){return[];}}],$tp:{Return:{},Argument:{},First:{'satisfies':['Argument']},Rest:{'satisfies':[{t:Sequential,a:{Element:'Argument'}}]}},$an:function(){return[doc(String$("Curries a function, returning a function with two \nparameter lists, given a function with at least\none parameter. The first parameter list of the \nreturned function has just the first parameter\nof the original function, and the second parameter\nlist has the remaining parameters.\n\nThat is, if `fun` has type `W(X,Y,Z)` then \n`curry(fun)` has type `W(Y,Z)(X)`.",359)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),uncurry),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),compose)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','curry']};};
exports.curry=curry;
var uncurry=function (f$828,$$$mptypes){
return flatten($JsCallable((function (args$829){
    return unflatten($JsCallable(f$828(args$829.first),[],{Arguments:$$$mptypes.Rest,Return:$$$mptypes.Return}),{Args:$$$mptypes.Rest,Return:$$$mptypes.Return})(args$829.rest,{Args:$$$mptypes.Rest,Return:$$$mptypes.Return});
}),[{$nm:'args',$mt:'prm',$t:{t:'T',l:[{$t:'First'}]},$an:function(){return[];}}],{Arguments:{t:'T', l:[{t:'T', l:[$$$mptypes.First]}]},Return:$$$mptypes.Return}),{Args:{t:'T', l:[$$$mptypes.First]},Return:$$$mptypes.Return});
};
uncurry.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Callable,a:{Arguments:{t:'T',l:[{$t:'First'}]},Return:'Return'}},$ps:[{$nm:'f',$mt:'prm',$pt:'f',$t:{t:Callable,a:{Arguments:'Rest',Return:'Return'}},$an:function(){return[];}}],$tp:{Return:{},Argument:{},First:{'satisfies':['Argument']},Rest:{'satisfies':[{t:Sequential,a:{Element:'Argument'}}]}},$an:function(){return[doc(String$("Uncurries a function, returning a function with \none parameter list, given a function with two\nparameter lists, where the first parameter list\nhas exactly one parameter. The parameter list\nof the returned function has the parameter of\nthe first parameter list of the original\nfunction, followed by all parameters of the\nsecond parameter list.\n\nThat is, if `fun` has type `W(Y,Z)(X)` then \n`uncurry(fun)` has type `W(X,Y,Z)`.",424)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),curry),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),compose)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','uncurry']};};
exports.uncurry=uncurry;
var entries=function (elements$830,$$$mptypes){
    return elements$830.indexed;
};
entries.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Entry,a:{Key:{t:Integer},Item:{t:'i', l:['Element',{t:Object$}]}}}}},$ps:[{$nm:'elements',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$an:function(){return[];}}],$tp:{Element:{}},$an:function(){return[doc(String$("Given a stream of items, produce a stream of entries. \nFor each non-null item produced by the given stream \nof items, the resulting stream contains an `Entry` \nof form `key->item` where `key` is the index at which\nthe item occurs in the stream of items.",253)),see([$init$OpenValue()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),$init$Iterable().$$.prototype.$prop$getIndexed)].reifyCeylonType({Absent:{t:Null},Element:{t:ValueDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','entries']};};
exports.entries=entries;
var equalTo=function (val$831,$$$mptypes){
    return function(element$832){{
        return element$832.equals(val$831);
    }
}
}
;
equalTo.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'val',$mt:'prm',$t:'Element',$an:function(){return[];}}],$tp:{Element:{'satisfies':[{t:Object$}]}},$an:function(){return[doc(String$("Returns a partial function that will compare an element\nto any other element and returns true if they\'re equal.\nThis is useful in conjunction with methods that receive\na predicate function.",189)),shared()];},d:['ceylon.language','equalTo']};};
exports.equalTo=equalTo;
var $apply=function (f$833,args$834,$$$mptypes){
    return unflatten($JsCallable(f$833,[],{Arguments:$$$mptypes.Args,Return:$$$mptypes.Return}),{Args:$$$mptypes.Args,Return:$$$mptypes.Return})(args$834,{Args:$$$mptypes.Args,Return:$$$mptypes.Return});
};
$apply.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Return',$ps:[{$nm:'f',$mt:'prm',$t:{t:Callable,a:{Arguments:'Args',Return:'Return'}},$an:function(){return[];}},{$nm:'args',$mt:'prm',$t:'Args',$an:function(){return[];}}],$tp:{Return:{},Args:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}]}},$an:function(){return[doc(String$("Applies an arbitrary `Callable` to the specified arguments. The arguments\nare taken packaged in a tuple whose type is compatible with the `Callable`\narguments tuple.\n\nIn practice, this behaves as if the `Callable` were called with the elements\nof the tuple used as its arguments.",279)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),unflatten)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','apply']};};
exports.$apply=$apply;
function every(values$835){
    var it$836 = values$835.iterator();
    var val$837;while ((val$837=it$836.next())!==getFinished()){
        if((!val$837)){
            return false;
        }
    }
    return true;
}
exports.every=every;
every.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'values',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Boolean$}}},$an:function(){return[];}}],$an:function(){return[doc(String$("Determines if every one of the given boolean values \n(usually a comprehension) is `true`.",89)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),any)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','every']};};
function first(values$838,$$$mptypes){
    var first$839;
    var next$840;
    if(!isOfType((next$840=values$838.iterator().next()),{t:Finished})){
        first$839=next$840;
    }else {
        first$839=null;
    }
    //assert at first.ceylon (12:4-12:34)
    var first$841;
    if (!(isOfType((first$841=first$839),{t:'u', l:[$$$mptypes.Absent,$$$mptypes.Value]}))) {throw wrapexc(AssertionException("Assertion failed: \'is Absent|Value first\' at first.ceylon (12:11-12:33)"),'12:4-12:34','first.ceylon'); }
    return first$841;
}
exports.first=first;
first.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Absent','Value']},$ps:[{$nm:'values',$mt:'prm',$t:{t:Iterable,a:{Absent:'Absent',Element:'Value'}},$an:function(){return[];}}],$tp:{Value:{},Absent:{'satisfies':[{t:Null}]}},$an:function(){return[doc(String$("The first of the given values (usually a comprehension),\nif any.",64)),shared()];},d:['ceylon.language','first']};};
var forItem=function (resulting$842,$$$mptypes){
    return function(entry$843){{
        return resulting$842(entry$843.item);
    }
}
}
;
forItem.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Result',$ps:[{$nm:'resulting',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[];}}],$tp:{Item:{'satisfies':[{t:Object$}]},Result:{}},$an:function(){return[doc(String$("A function that returns the result of the given `resulting()` function \non the item of a given `Entry`.",103)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),forKey)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','forItem']};};
exports.forItem=forItem;
var forKey=function (resulting$844,$$$mptypes){
    return function(entry$845){{
        return resulting$844(entry$845.key);
    }
}
}
;
forKey.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Result',$ps:[{$nm:'resulting',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[];}}],$tp:{Key:{'satisfies':[{t:Object$}]},Result:{}},$an:function(){return[doc(String$("A function that returns the result of the given `resulting()` function \non the key of a given `Entry`.",102)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),forItem)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','forKey']};};
exports.forKey=forKey;
var greaterThan=function (val$846,$$$mptypes){
    return function(element$847){{
        return element$847.compare(val$846).equals(getLarger());
    }
}
}
;
greaterThan.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'val',$mt:'prm',$t:'Element',$an:function(){return[];}}],$tp:{Element:{'satisfies':[{t:Comparable,a:{Other:'Element'}}]}},$an:function(){return[doc(String$("Returns a partial function that will compare an element\nto any other element and returns true if the compared\nelement is greater than its element.\nThis is useful in conjunction with methods that receive\na predicate function.",224)),shared()];},d:['ceylon.language','greaterThan']};};
exports.greaterThan=greaterThan;
var concatenate=function (iterables$848,$$$mptypes){
    if(iterables$848===undefined){iterables$848=getEmpty();}
    return Comprehension(function(){
        var it$849=iterables$848.iterator();
        var it$850=getFinished();
        var next$it$850=function(){
            if((it$850=it$849.next())!==getFinished()){
                it$851=it$850.iterator();
                next$val$852();
                return it$850;
            }
            return getFinished();
        }
        var it$851;
        var val$852=getFinished();
        var next$val$852=function(){return val$852=it$851.next();}
        next$it$850();
        return function(){
            do{
                if(val$852!==getFinished()){
                    var val$852$853=val$852;
                    var tmpvar$854=val$852$853;
                    next$val$852();
                    return tmpvar$854;
                }
            }while(next$it$850()!==getFinished());
            return getFinished();
        }
    },{Absent:{t:Null},Element:$$$mptypes.Element}).sequence;
};
concatenate.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$ps:[{$nm:'iterables',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}}}},$an:function(){return[doc("The iterable objects to concatenate.")];}}],$tp:{Element:{}},$an:function(){return[doc(String$("Given a list of iterable objects, return a new sequence \nof all elements of the all given objects. If there are\nno arguments, or if none of the arguments contains any\nelements, return the empty sequence.",203)),see([$init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),SequenceBuilder)].reifyCeylonType({Absent:{t:Null},Element:{t:ClassDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','concatenate']};};
exports.concatenate=concatenate;
var largest=function (x$855,y$856,$$$mptypes){
    return (opt$857=(x$855.compare(y$856).equals(getLarger())?x$855:null),opt$857!==null?opt$857:y$856);
};
largest.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Element',$ps:[{$nm:'x',$mt:'prm',$t:'Element',$an:function(){return[];}},{$nm:'y',$mt:'prm',$t:'Element',$an:function(){return[];}}],$tp:{Element:{'satisfies':[{t:Comparable,a:{Other:'Element'}}]}},$an:function(){return[doc(String$("Given two `Comparable` values, return largest of the\ntwo.",57)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Comparable),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),smallest),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),max)].reifyCeylonType({Absent:{t:Null},Element:{t:'u', l:[{t:InterfaceDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration}]}})),shared()];},d:['ceylon.language','largest']};};
exports.largest=largest;
var opt$857;
var lessThan=function (val$858,$$$mptypes){
    return function(element$859){{
        return element$859.compare(val$858).equals(getSmaller());
    }
}
}
;
lessThan.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'val',$mt:'prm',$t:'Element',$an:function(){return[];}}],$tp:{Element:{'satisfies':[{t:Comparable,a:{Other:'Element'}}]}},$an:function(){return[doc(String$("Returns a partial function that will compare an element\nto any other element and returns true if the compared\nelement is less than its element.\nThis is useful in conjunction with methods that receive\na predicate function.",221)),shared()];},d:['ceylon.language','lessThan']};};
exports.lessThan=lessThan;
function max(values$860,$$$mptypes){
    var first$861=values$860.first;
    var first$862;
    if((first$862=first$861)!==null){
        var max$863=first$862;
        function setMax$863(max$864){return max$863=max$864;};
        $prop$getMax$863={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Value',$an:function(){return[variable()];},d:['ceylon.language','max','$at','max']};}};
        $prop$getMax$863.get=function(){return max$863};
        $prop$getMax$863.set=setMax$863;
        if (setMax$863.$$metamodel$$===undefined)setMax$863.$$metamodel$$=$prop$getMax$863.$$metamodel$$;
        var it$865 = values$860.rest.iterator();
        var val$866;while ((val$866=it$865.next())!==getFinished()){
            if(val$866.compare(max$863).equals(getLarger())){
                max$863=val$866;
            }
        }
        return max$863;
    }else {
        return first$861;
    }
}
exports.max=max;
max.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Absent','Value']},$ps:[{$nm:'values',$mt:'prm',$t:{t:Iterable,a:{Absent:'Absent',Element:'Value'}},$an:function(){return[];}}],$tp:{Value:{'satisfies':[{t:Comparable,a:{Other:'Value'}}]},Absent:{'satisfies':[{t:Null}]}},$an:function(){return[doc(String$("Given a nonempty stream of `Comparable` values, \nreturn the largest value in the stream.",88)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Comparable),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),min),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),largest)].reifyCeylonType({Absent:{t:Null},Element:{t:'u', l:[{t:InterfaceDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration}]}})),shared()];},d:['ceylon.language','max']};};
function min(values$867,$$$mptypes){
    var first$868=values$867.first;
    var first$869;
    if((first$869=first$868)!==null){
        var min$870=first$869;
        function setMin$870(min$871){return min$870=min$871;};
        $prop$getMin$870={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Value',$an:function(){return[variable()];},d:['ceylon.language','min','$at','min']};}};
        $prop$getMin$870.get=function(){return min$870};
        $prop$getMin$870.set=setMin$870;
        if (setMin$870.$$metamodel$$===undefined)setMin$870.$$metamodel$$=$prop$getMin$870.$$metamodel$$;
        var it$872 = values$867.rest.iterator();
        var val$873;while ((val$873=it$872.next())!==getFinished()){
            if(val$873.compare(min$870).equals(getSmaller())){
                min$870=val$873;
            }
        }
        return min$870;
    }else {
        return first$868;
    }
}
exports.min=min;
min.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Absent','Value']},$ps:[{$nm:'values',$mt:'prm',$t:{t:Iterable,a:{Absent:'Absent',Element:'Value'}},$an:function(){return[];}}],$tp:{Value:{'satisfies':[{t:Comparable,a:{Other:'Value'}}]},Absent:{'satisfies':[{t:Null}]}},$an:function(){return[doc(String$("Given a nonempty stream of `Comparable` values, \nreturn the smallest value in the stream.",89)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Comparable),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),max),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),smallest)].reifyCeylonType({Absent:{t:Null},Element:{t:'u', l:[{t:InterfaceDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration}]}})),shared()];},d:['ceylon.language','min']};};
var smallest=function (x$874,y$875,$$$mptypes){
    return (opt$876=(x$874.compare(y$875).equals(getSmaller())?x$874:null),opt$876!==null?opt$876:y$875);
};
smallest.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Element',$ps:[{$nm:'x',$mt:'prm',$t:'Element',$an:function(){return[];}},{$nm:'y',$mt:'prm',$t:'Element',$an:function(){return[];}}],$tp:{Element:{'satisfies':[{t:Comparable,a:{Other:'Element'}}]}},$an:function(){return[doc(String$("Given two `Comparable` values, return smallest of the\ntwo.",58)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Comparable),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),largest),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),min)].reifyCeylonType({Absent:{t:Null},Element:{t:'u', l:[{t:InterfaceDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration}]}})),shared()];},d:['ceylon.language','smallest']};};
exports.smallest=smallest;
var opt$876;
function sum(values$877,$$$mptypes){
    var sum$878=values$877.first;
    function setSum$878(sum$879){return sum$878=sum$879;};
    var it$880 = values$877.rest.iterator();
    var val$881;while ((val$881=it$880.next())!==getFinished()){
        (sum$878=sum$878.plus(val$881));
    }
    return sum$878;
}
exports.sum=sum;
sum.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Value',$ps:[{$nm:'values',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Nothing},Element:'Value'}},$an:function(){return[];}}],$tp:{Value:{'satisfies':[{t:Summable,a:{Other:'Value'}}]}},$an:function(){return[doc(String$("Given a nonempty stream of `Summable` values, return \nthe sum of the values.",76)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),product)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','sum']};};
function product(values$882,$$$mptypes){
    var product$883=values$882.first;
    function setProduct$883(product$884){return product$883=product$884;};
    var it$885 = values$882.rest.iterator();
    var val$886;while ((val$886=it$885.next())!==getFinished()){
        (product$883=product$883.times(val$886));
    }
    return product$883;
}
exports.product=product;
product.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Value',$ps:[{$nm:'values',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Nothing},Element:'Value'}},$an:function(){return[];}}],$tp:{Value:{'satisfies':[{t:Numeric,a:{Other:'Value'}}]}},$an:function(){return[doc(String$("Given a nonempty stream of `Numeric` values, return \nthe product of the values.",79)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),sum)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','product']};};
var zipEntries=function (keys$887,items$888,$$$mptypes){
    return mapPairs($JsCallable(Entry,[],{Arguments:{t:'T', l:[$$$mptypes.Key,$$$mptypes.Item]},Return:{t:Entry,a:{Key:$$$mptypes.Key,Item:$$$mptypes.Item}}}),keys$887,items$888,{Result:{t:Entry,a:{Key:$$$mptypes.Key,Item:$$$mptypes.Item}},FirstArgument:$$$mptypes.Key,SecondArgument:$$$mptypes.Item});
};
zipEntries.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Entry,a:{Key:'Key',Item:'Item'}}}},$ps:[{$nm:'keys',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Key'}},$an:function(){return[];}},{$nm:'items',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Item'}},$an:function(){return[];}}],$tp:{Key:{'satisfies':[{t:Object$}]},Item:{'satisfies':[{t:Object$}]}},$an:function(){return[doc(String$("Given two streams, form a new stream consisting of\nall entries where, for any given index in the resulting\nstream, the key of the entry is the element occurring \nat the same index in the first stream, and the item is \nthe element occurring at the same index in the second \nstream. The length of the resulting stream is the \nlength of the shorter of the two given streams.\n\nThus:\n\n    zipEntries(keys,items)[i]==keys[i]->items[i]\n\nfor every `0<=i<min({keys.size,items.size})`.",475)),shared()];},d:['ceylon.language','zipEntries']};};
exports.zipEntries=zipEntries;
var zipPairs=function (firstElements$889,secondElements$890,$$$mptypes){
    return mapPairs($JsCallable((function (first$891,second$892){
        return Tuple(first$891,Tuple(second$892,getEmpty(),{Rest:{t:Empty},First:$$$mptypes.Second,Element:$$$mptypes.Second}),{Rest:{t:'T', l:[$$$mptypes.Second]},First:$$$mptypes.First,Element:{t:'u', l:[$$$mptypes.First,$$$mptypes.Second]}});
    }),[{$nm:'first',$mt:'prm',$t:'First',$an:function(){return[];}},{$nm:'second',$mt:'prm',$t:'Second',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$$mptypes.First,$$$mptypes.Second]},Return:{t:'T', l:[$$$mptypes.First,$$$mptypes.Second]}}),firstElements$889,secondElements$890,{Result:{t:'T', l:[$$$mptypes.First,$$$mptypes.Second]},FirstArgument:$$$mptypes.First,SecondArgument:$$$mptypes.Second});
};
zipPairs.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:'T',l:[{$t:'First'},{$t:'Second'}]}}},$ps:[{$nm:'firstElements',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'First'}},$an:function(){return[];}},{$nm:'secondElements',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Second'}},$an:function(){return[];}}],$tp:{First:{},Second:{}},$an:function(){return[doc(String$("Given two streams, form a new stream consisting of\nall pairs where, for any given index in the resulting\nstream, the first element of the pair is the element \noccurring at the same index in the first stream, and \nthe second element of the pair is the element occurring \nat the same index in the second stream. The length of \nthe resulting stream is the length of the shorter of the \ntwo given streams.\n\nThus:\n\n    zipPairs(xs,ys)[i]==[xs[i],ys[i]]\n\nfor every `0<=i<min({xs.size,ys.size})`.",489)),shared()];},d:['ceylon.language','zipPairs']};};
exports.zipPairs=zipPairs;
var zip=function (heads$893,tails$894,$$$mptypes){
    return mapPairs($JsCallable(Tuple,[],{Arguments:{t:'T', l:[$$$mptypes.Head,$$$mptypes.Tail]},Return:{t:'T', l:[$$$mptypes.Head]}}),heads$893,tails$894,{Result:{t:'T', l:[$$$mptypes.Head]},FirstArgument:$$$mptypes.Head,SecondArgument:$$$mptypes.Tail});
};
zip.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:'T',l:[{$t:'Head'}]}}},$ps:[{$nm:'heads',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Head'}},$an:function(){return[];}},{$nm:'tails',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Tail'}},$an:function(){return[];}}],$tp:{Element:{},Head:{},Tail:{'satisfies':[{t:Sequential,a:{Element:'Element'}}]}},$an:function(){return[doc(String$("Given a stream of values, and a stream of tuples, produce\na new stream of tuples formed by prepending the values in\nthe first stream to the tuples in the second stream. The \nlength of the resulting stream is the length of the shorter \nof the two given streams.\n\nThus:\n\n    zip(heads, tails)[i]==[heads[i],*tails[i]]\n\nfor every `0<=i<min({heads.size,tails.size})`.",363)),shared()];},d:['ceylon.language','zip']};};
exports.zip=zip;
var unzip=function (tuples$895,$$$mptypes){
    return Tuple(tuples$895.$map($JsCallable((function (tuple$896){
        return tuple$896.first;
    }),[{$nm:'tuple',$mt:'prm',$t:{t:'T',l:[{$t:'Head'}]},$an:function(){return[];}}],{Arguments:{t:'T', l:[{t:'T', l:[$$$mptypes.Head]}]},Return:$$$mptypes.Head}),{Result:$$$mptypes.Head}),Tuple(tuples$895.$map($JsCallable((function (tuple$897){
        return tuple$897.rest;
    }),[{$nm:'tuple',$mt:'prm',$t:{t:'T',l:[{$t:'Head'}]},$an:function(){return[];}}],{Arguments:{t:'T', l:[{t:'T', l:[$$$mptypes.Head]}]},Return:$$$mptypes.Tail}),{Result:$$$mptypes.Tail}),getEmpty(),{Rest:{t:Empty},First:{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Tail}},Element:{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Tail}}}),{Rest:{t:'T', l:[{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Tail}}]},First:{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Head}},Element:{t:'u', l:[{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Head}},{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Tail}}]}});
};
unzip.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'T',l:[{$t:{t:Iterable,a:{Absent:{t:Null},Element:'Head'}}},{$t:{t:Iterable,a:{Absent:{t:Null},Element:'Tail'}}}]},$ps:[{$nm:'tuples',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:'T',l:[{$t:'Head'}]}}},$an:function(){return[];}}],$tp:{Element:{},Head:{},Tail:{'satisfies':[{t:Sequential,a:{Element:'Element'}}]}},$an:function(){return[doc(String$("Given a stream of tuples, return two streams. The\nfirst stream produces the first elements of the\ngiven tuples, and the second stream produces the\nremaining elements of the given tuples.\n\nThus:\n\n    unzip(tuples)[i]==[tuples[i].first,*tuples[i].rest]",250)),shared()];},d:['ceylon.language','unzip']};};
exports.unzip=unzip;
var unzipPairs=function (pairs$898,$$$mptypes){
    return Tuple(pairs$898.$map($JsCallable((function (pair$899){
        return pair$899.$get((0));
    }),[{$nm:'pair',$mt:'prm',$t:{t:'T',l:[{$t:'First'},{$t:'Second'}]},$an:function(){return[];}}],{Arguments:{t:'T', l:[{t:'T', l:[$$$mptypes.First,$$$mptypes.Second]}]},Return:$$$mptypes.First}),{Result:$$$mptypes.First}),Tuple(pairs$898.$map($JsCallable((function (pair$900){
        return pair$900.$get((1));
    }),[{$nm:'pair',$mt:'prm',$t:{t:'T',l:[{$t:'First'},{$t:'Second'}]},$an:function(){return[];}}],{Arguments:{t:'T', l:[{t:'T', l:[$$$mptypes.First,$$$mptypes.Second]}]},Return:$$$mptypes.Second}),{Result:$$$mptypes.Second}),getEmpty(),{Rest:{t:Empty},First:{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Second}},Element:{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Second}}}),{Rest:{t:'T', l:[{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Second}}]},First:{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.First}},Element:{t:'u', l:[{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.First}},{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Second}}]}});
};
unzipPairs.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'T',l:[{$t:{t:Iterable,a:{Absent:{t:Null},Element:'First'}}},{$t:{t:Iterable,a:{Absent:{t:Null},Element:'Second'}}}]},$ps:[{$nm:'pairs',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:'T',l:[{$t:'First'},{$t:'Second'}]}}},$an:function(){return[];}}],$tp:{First:{},Second:{}},$an:function(){return[doc(String$("Given a stream of pairs, return two streams. The\nfirst stream produces the first elements of the\ngiven pairs, and the second stream produces the\nsecond elements of the given pairs.\n\nThus:\n\n    unzipPairs(pairs)[i]==[pairs[i][0],pairs[i][1]]",240)),shared()];},d:['ceylon.language','unzipPairs']};};
exports.unzipPairs=unzipPairs;
var unzipEntries=function (entries$901,$$$mptypes){
    return Tuple(entries$901.$map($JsCallable(function($O$) {return $O$.key;},[],{Arguments:{t:'T', l:[{t:Entry,a:{Key:$$$mptypes.Key,Item:$$$mptypes.Item}}]},Return:$$$mptypes.Key}),{Result:$$$mptypes.Key}),Tuple(entries$901.$map($JsCallable(function($O$) {return $O$.item;},[],{Arguments:{t:'T', l:[{t:Entry,a:{Key:$$$mptypes.Key,Item:$$$mptypes.Item}}]},Return:$$$mptypes.Item}),{Result:$$$mptypes.Item}),getEmpty(),{Rest:{t:Empty},First:{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Item}},Element:{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Item}}}),{Rest:{t:'T', l:[{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Item}}]},First:{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Key}},Element:{t:'u', l:[{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Key}},{t:Iterable,a:{Absent:{t:Null},Element:$$$mptypes.Item}}]}});
};
unzipEntries.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'T',l:[{$t:{t:Iterable,a:{Absent:{t:Null},Element:'Key'}}},{$t:{t:Iterable,a:{Absent:{t:Null},Element:'Item'}}}]},$ps:[{$nm:'entries',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Entry,a:{Key:'Key',Item:'Item'}}}},$an:function(){return[];}}],$tp:{Key:{'satisfies':[{t:Object$}]},Item:{'satisfies':[{t:Object$}]}},$an:function(){return[doc(String$("Given a stream of entries, return two streams. The\nfirst stream produces the keys of the given entries, \nand the second stream produces the items of the given \nentries.\n\nThus:\n\n    unzipEntries(entries)[i]==[entries[i].key,entries[i].item]",239)),shared()];},d:['ceylon.language','unzipEntries']};};
exports.unzipEntries=unzipEntries;
function mapPairs(collecting$902,firstArguments$903,secondArguments$904,$$$mptypes){
    function iterable$905($$targs$$){
        var $$iterable$905=new iterable$905.$$;
        $$iterable$905.$$targs$$=$$targs$$;
        Iterable({Absent:{t:Null},Element:$$$mptypes.Result},$$iterable$905);
        add_type_arg($$iterable$905,'Absent',{t:Null});
        return $$iterable$905;
    };iterable$905.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterable,a:{Absent:{t:Null},Element:'Result'}}],d:['ceylon.language','mapPairs','$o','iterable']};};
    function $init$iterable$905(){
        if (iterable$905.$$===undefined){
            initTypeProto(iterable$905,'ceylon.language::mapPairs.iterable',Basic,$init$Iterable());
            (function($$iterable$905){
                $$iterable$905.iterator=function iterator(){
                    var $$iterable$905=this;
                    var first$906=firstArguments$903.iterator();
                    var second$907=secondArguments$904.iterator();
                    function iterator$908($$targs$$){
                        var $$iterator$908=new iterator$908.$$;
                        $$iterator$908.$$targs$$=$$targs$$;
                        Iterator({Element:$$$mptypes.Result},$$iterator$908);
                        return $$iterator$908;
                    };iterator$908.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Iterator,a:{Element:'Result'}}],d:['ceylon.language','mapPairs','$o','iterable','$m','iterator','$o','iterator']};};
                    function $init$iterator$908(){
                        if (iterator$908.$$===undefined){
                            initTypeProto(iterator$908,'ceylon.language::mapPairs.iterable.iterator.iterator',Basic,$init$Iterator());
                            (function($$iterator$908){
                                $$iterator$908.next=function next(){
                                    var $$iterator$908=this;
                                    var firstArg$909;
                                    var secondArg$910;
                                    if(!isOfType((firstArg$909=first$906.next()),{t:Finished})&&!isOfType((secondArg$910=second$907.next()),{t:Finished})){
                                        return collecting$902(firstArg$909,secondArg$910);
                                    }else {
                                        return getFinished();
                                    }
                                };$$iterator$908.next.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:['Result',{t:Finished}]},$ps:[],$cont:iterator$908,$an:function(){return[shared(),actual()];},d:['ceylon.language','mapPairs','$o','iterable','$m','iterator','$o','iterator','$m','next']};};
                            })(iterator$908.$$.prototype);
                        }
                        return iterator$908;
                    }
                    $init$iterator$908();
                    var iterator$911;
                    function getIterator$911(){
                        if (iterator$911===undefined){iterator$911=$init$iterator$908()({Element:$$$mptypes.Result});iterator$911.$$metamodel$$=getIterator$911.$$metamodel$$;}
                        return iterator$911;
                    }
                    getIterator$911.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterator$908},d:['ceylon.language','mapPairs','$o','iterable','$m','iterator','$o','iterator']};};
                    $prop$getIterator$911={get:getIterator$911,$$metamodel$$:getIterator$911.$$metamodel$$};
                    return getIterator$911();
                };$$iterable$905.iterator.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:'Result'}},$ps:[],$cont:iterable$905,$an:function(){return[shared(),actual()];},d:['ceylon.language','mapPairs','$o','iterable','$m','iterator']};};
            })(iterable$905.$$.prototype);
        }
        return iterable$905;
    }
    $init$iterable$905();
    var iterable$912;
    function getIterable$912(){
        if (iterable$912===undefined){iterable$912=$init$iterable$905()({Absent:{t:Null},Element:$$$mptypes.Result});iterable$912.$$metamodel$$=getIterable$912.$$metamodel$$;}
        return iterable$912;
    }
    getIterable$912.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:iterable$905},d:['ceylon.language','mapPairs','$o','iterable']};};
    $prop$getIterable$912={get:getIterable$912,$$metamodel$$:getIterable$912.$$metamodel$$};
    return getIterable$912();
}
exports.mapPairs=mapPairs;
mapPairs.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:'Result'}},$ps:[{$nm:'collecting',$mt:'prm',$pt:'f',$t:'Result',$an:function(){return[];}},{$nm:'firstArguments',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'FirstArgument'}},$an:function(){return[];}},{$nm:'secondArguments',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'SecondArgument'}},$an:function(){return[];}}],$tp:{Result:{},FirstArgument:{},SecondArgument:{}},$an:function(){return[doc(String$("Given two streams, form a new stream by applying a \nfunction to the arguments in the given streams. The \nlength of the resulting stream is the length of \nthe shorter of the two given streams.\n\nThus:\n\n    mapPairs(xs,ys,fun)[i]==fun(xs[i],ys[i])\n\nfor every `0<=i<min({xs.size,ys.size})`.",286)),shared()];},d:['ceylon.language','mapPairs']};};
var print=function (val$913){
    return getProcess().writeLine(stringify(val$913));
};
print.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[{$nm:'val',$mt:'prm',$t:{t:Anything},$an:function(){return[];}}],$an:function(){return[doc(String$("Print a line to the standard output of the virtual machine \nprocess, printing the given value\'s `string`, or `<null>` \nif the value is `null`.\n\nThis method is a shortcut for:\n\n    process.writeLine(line?.string else \"<null>\")\n\nand is intended mainly for debugging purposes.",273)),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','print']};};
exports.print=print;
function printAll(values$914,separator$915){
    if(separator$915===undefined){separator$915=String$(", ",2);}
    var first$916;
    if((first$916=values$914.first)!==null){
        getProcess().write(stringify(first$916));
        var it$917 = values$914.rest.iterator();
        var val$918;while ((val$918=it$917.next())!==getFinished()){
            getProcess().write(separator$915);
            getProcess().write(stringify(val$918));
        }
    }
    getProcess().write(getOperatingSystem().newline);
}
exports.printAll=printAll;
printAll.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[{$nm:'values',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Anything}}},$an:function(){return[];}},{$nm:'separator',$mt:'prm',$def:1,$t:{t:String$},$an:function(){return[doc("A character sequence to use to separate the values")];}}],$an:function(){return[doc(String$("Print multiple values to the standard output of the virtual \nmachine process as a single line of text, separated by a\ngiven character sequence.",143)),by([String$("Gavin",5)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];},d:['ceylon.language','printAll']};};
var stringify=function (val$919){
    return (opt$920=(opt$921=val$919,opt$921!==null?opt$921.string:null),opt$920!==null?opt$920:String$("<null>",6));
};
stringify.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:String$},$ps:[{$nm:'val',$mt:'prm',$t:{t:Anything},$an:function(){return[];}}],d:['ceylon.language','stringify']};};
var opt$920,opt$921;
function getNothing(){
    throw wrapexc(Exception(),'4:25-4:30','ceylon/language/nothing.ceylon');
}
exports.getNothing=getNothing;
var $prop$getNothing={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Nothing},$an:function(){return[doc(String$("A value that is assignable to any type, but that \nresults in an exception when evaluated. This is most \nuseful for generating members in an IDE.",144)),shared()];},d:['ceylon.language','nothing']};}};
exports.$prop$getNothing=$prop$getNothing;
$prop$getNothing.get=getNothing;
getNothing.$$metamodel$$=$prop$getNothing.$$metamodel$$;
var identical=function (x$922,y$923){
    return (x$922===y$923);
};
identical.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'x',$mt:'prm',$t:{t:Identifiable},$an:function(){return[doc("An object with well-defined identity.")];}},{$nm:'y',$mt:'prm',$t:{t:Identifiable},$an:function(){return[doc("A second object with well-defined identity.")];}}],$an:function(){return[doc(String$("Determine if the arguments are identical. Equivalent to\n`x===y`. Only instances of `Identifiable` have \nwell-defined identity.",126)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),identityHash)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','identical']};};
exports.identical=identical;
var compose=function (x$924,y$925,$$$mptypes){
    return flatten($JsCallable((function (args$926){
        return x$924(unflatten($JsCallable(y$925,[],{Arguments:$$$mptypes.Args,Return:$$$mptypes.Y}),{Args:$$$mptypes.Args,Return:$$$mptypes.Y})(args$926,{Args:$$$mptypes.Args,Return:$$$mptypes.Y}));
    }),[{$nm:'args',$mt:'prm',$t:'Args',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$$mptypes.Args]},Return:$$$mptypes.X}),{Args:$$$mptypes.Args,Return:$$$mptypes.X});
};
compose.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Callable,a:{Arguments:'Args',Return:'X'}},$ps:[{$nm:'x',$mt:'prm',$t:{t:Callable,a:{Arguments:{t:'T',l:[{$t:'Y'}]},Return:'X'}},$an:function(){return[];}},{$nm:'y',$mt:'prm',$t:{t:Callable,a:{Arguments:'Args',Return:'Y'}},$an:function(){return[];}}],$tp:{X:{},Y:{},Args:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}]}},$an:function(){return[doc(String$("Given a function with return type `Y`, and a second \nfunction with a single parameter also of type `Y`, \nreturn the composition of the two functions. The\nfirst function may have any number of parameters.\n\nFor any such functions `f()` and `g()`,\n\n    compose(g,f)(*args)==g(f(*args))\n\nfor every possible argument tuple `args` of `f()`.",334)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),curry),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),uncurry)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','compose']};};
exports.compose=compose;
var shuffle=function (f$927,$$$mptypes){
    return flatten($JsCallable((function (secondArgs$928){
        return flatten($JsCallable((function (firstArgs$929){
            return unflatten($JsCallable(unflatten($JsCallable(f$927,[],{Arguments:$$$mptypes.FirstArgs,Return:{t:Callable,a:{Arguments:$$$mptypes.SecondArgs,Return:$$$mptypes.Result}}}),{Args:$$$mptypes.FirstArgs,Return:{t:Callable,a:{Arguments:$$$mptypes.SecondArgs,Return:$$$mptypes.Result}}})(firstArgs$929,{Args:$$$mptypes.FirstArgs,Return:{t:Callable,a:{Arguments:$$$mptypes.SecondArgs,Return:$$$mptypes.Result}}}),[],{Arguments:$$$mptypes.SecondArgs,Return:$$$mptypes.Result}),{Args:$$$mptypes.SecondArgs,Return:$$$mptypes.Result})(secondArgs$928,{Args:$$$mptypes.SecondArgs,Return:$$$mptypes.Result});
        }),[{$nm:'firstArgs',$mt:'prm',$t:'FirstArgs',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$$mptypes.FirstArgs]},Return:$$$mptypes.Result}),{Args:$$$mptypes.FirstArgs,Return:$$$mptypes.Result});
    }),[{$nm:'secondArgs',$mt:'prm',$t:'SecondArgs',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$$mptypes.SecondArgs]},Return:{t:Callable,a:{Arguments:$$$mptypes.FirstArgs,Return:$$$mptypes.Result}}}),{Args:$$$mptypes.SecondArgs,Return:{t:Callable,a:{Arguments:$$$mptypes.FirstArgs,Return:$$$mptypes.Result}}});
};
shuffle.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Callable,a:{Arguments:'SecondArgs',Return:{t:Callable,a:{Arguments:'FirstArgs',Return:'Result'}}}},$ps:[{$nm:'f',$mt:'prm',$t:{t:Callable,a:{Arguments:'FirstArgs',Return:{t:Callable,a:{Arguments:'SecondArgs',Return:'Result'}}}},$an:function(){return[];}}],$tp:{Result:{},FirstArgs:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}]},SecondArgs:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}]}},$an:function(){return[doc(String$("Given a function with two parameter lists, return\na function with the order of the argument lists \nreversed. The parameter lists may have any number\nof parameters.\n\nThat is, if `fun` has type `W(A,B)(X,Y,Z)` then \n`shuffle(fun)` has type `W(X,Y,Z)(A,B)`.\n\nThis function is often used in conjunction with\n`curry()`.",314)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),curry)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','shuffle']};};
exports.shuffle=shuffle;
var plus=function (x$930,y$931,$$$mptypes){
    return x$930.plus(y$931);
};
plus.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Value',$ps:[{$nm:'x',$mt:'prm',$t:'Value',$an:function(){return[];}},{$nm:'y',$mt:'prm',$t:'Value',$an:function(){return[];}}],$tp:{Value:{'satisfies':[{t:Summable,a:{Other:'Value'}}]}},$an:function(){return[doc(String$("Add the given `Summable` values.",32)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),times),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),sum)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','plus']};};
exports.plus=plus;
var times=function (x$932,y$933,$$$mptypes){
    return x$932.times(y$933);
};
times.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Value',$ps:[{$nm:'x',$mt:'prm',$t:'Value',$an:function(){return[];}},{$nm:'y',$mt:'prm',$t:'Value',$an:function(){return[];}}],$tp:{Value:{'satisfies':[{t:Numeric,a:{Other:'Value'}}]}},$an:function(){return[doc(String$("Multiply the given `Numeric` values.",36)),see([$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),plus),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),product)].reifyCeylonType({Absent:{t:Null},Element:{t:FunctionDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','times']};};
exports.times=times;
var sort=function (elements$934,$$$mptypes){
    return internalSort($JsCallable(byIncreasing($JsCallable((function (e$935){
        return e$935;
    }),[{$nm:'e',$mt:'prm',$t:'Element',$an:function(){return[];}}],{Arguments:{t:'T', l:[$$$mptypes.Element]},Return:$$$mptypes.Element}),{Value:$$$mptypes.Element,Element:$$$mptypes.Element}),[{$nm:'p2',$mt:'prm',$t:'Element'},{$nm:'p3',$mt:'prm',$t:'Element'}],{Arguments:{t:'T', l:[$$$mptypes.Element,$$$mptypes.Element]},Return:{t:Comparison}}),elements$934,{Element:$$$mptypes.Element});
};
sort.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Element'}},$ps:[{$nm:'elements',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$an:function(){return[];}}],$tp:{Element:{'satisfies':[{t:Comparable,a:{Other:'Element'}}]}},$an:function(){return[doc(String$("Sort the given elements, returning a new sequence.",50)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Comparable)].reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','sort']};};
exports.sort=sort;
function Array$(elems,$$targs$$) {
    var e=[];
    if (!(elems === null || elems === undefined)) {
        var iter=elems.iterator();
        var item;while((item=iter.next())!==getFinished()) {
            e.push(item);
        }
    }
    e.$$targs$$=$$targs$$;
    List({Element:$$targs$$.Element}, e);
    return e;
}
Array$.$$metamodel$$={$ps:[{$nm:'elements',$mt:'prm',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}}}],$an:function(){return[shared(),final(),native()];},mod:$$METAMODEL$$,d:['ceylon.language','Array'],
  'super':{t:Object$}, $tp:{Element:{}}, satisfies:[{t:List,a:{Element:'Element'}},{t:Cloneable,a:{Other:{t:Array$,a:{Element:'Element'}}}},
    {t:Ranged,a:{Index:{t:Integer},Span:{t:Array$,a:{Element:'Element'}}}}]};

initExistingType(Array$, Array, 'ceylon.language::Array', Object$,
        Cloneable, Ranged, $init$List());
var Array$proto = Array.prototype;
var origArrToString = Array$proto.toString;
inheritProto(Array$, Object$, Cloneable, Ranged, $init$List());
Array$proto.toString = origArrToString;
Array$proto.reifyCeylonType = function(typeParameters) {
    this.$$targs$$ = typeParameters;
    return this;
}
exports.Array=Array$;

function EmptyArray() {
    return [];
}
EmptyArray.$$metamodel$$=$init$Empty().$$metamodel$$;
initTypeProto(EmptyArray, 'ceylon.language::EmptyArray', Array$);
function ArrayList(items) {
    return items;
}
ArrayList.$$metamodel$$=Array$.$$metamodel$$;
initTypeProto(ArrayList, 'ceylon.language::ArrayList', Array$, $init$List());
function ArraySequence(/* js array */value, $$targs$$) {
    value.$seq = true;
    value.$$targs$$=$$targs$$;
    this.$$targs$$=$$targs$$;
    return value;
}
ArraySequence.$$metamodel$$=function(){return{mod:$$METAMODEL$$,d:['ceylon.language','ArraySequence'],$ps:[{$nm:'elements',$t:{t:Sequence,a:{Element:'Element'}}}],$tp:{Element:{'var':'out'}},satisfies:[{t:Sequence,a:{Element:'Element'}}]};};
initTypeProto(ArraySequence, 'ceylon.language::ArraySequence', $init$Basic(), $init$Sequence());
Array$proto.getT$name = function() {
    return (this.$seq ? ArraySequence : (this.length>0?ArrayList:EmptyArray)).$$.T$name;
}
Array$proto.getT$all = function() {
    return (this.$seq ? ArraySequence : (this.length>0?ArrayList:EmptyArray)).$$.T$all;
}

exports.EmptyArray=EmptyArray;

defineAttr(Array$proto, 'size', function(){ return this.length; },undefined,function(){return{mod:$$METAMODEL$$,d:['ceylon.language','Iterable','$at','size'],$cont:Array$proto,$t:{t:Integer}};});
defineAttr(Array$proto,'string',function(){
    return (opt$181=(this.empty?String$("[]",2):null),opt$181!==null?opt$181:StringBuilder().appendAll([String$("[",1),commaList(this).string,String$("]",1)]).string);
},undefined,function(){return{mod:$$METAMODEL$$,d:['ceylon.language','Object','$at','string'],$t:{t:String},$cont:Array$proto};});
Array$proto.set = function(idx,elem) {
    if (idx >= 0 && idx < this.length) {
        this[idx] = elem;
    }
}
Array$proto.set.$$metamodel$$=function(){return{mod:$$METAMODEL$$,d:['ceylon.language','Array','$m','set'],$t:{t:Anything},$ps:[{$nm:'index',$t:{t:Integer},$mt:'prm'},{$nm:'element',$mt:'prm',$t:'Element'}]};}
Array$proto.$get = function(idx) {
    var result = this[idx];
    return result!==undefined ? result:null;
}
Array$proto.$get.$$metamodel$$=function(){
  return{mod:$$METAMODEL$$,d:['ceylon.language','List','$m','get'],$t:{t:'u',l:[{t:Null},'Element']},$ps:[{$nm:'index',$t:{t:Integer},$mt:'prm'}]};
}
defineAttr(Array$proto, 'lastIndex', function() {
    return this.length>0 ? (this.length-1) : null;
},undefined,function(){return{mod:$$METAMODEL$$,d:['ceylon.language','List','$at','lastIndex'],$t:{t:'u',l:[{t:Null},{t:Integer}]}};});
defineAttr(Array$proto, 'reversed', function() {
    if (this.length === 0) { return this; }
    var arr = this.slice(0);
    arr.reverse();
    return this.$seq ? ArraySequence(arr,this.$$targs$$) : arr.reifyCeylonType(this.$$targs$$);
},undefined,function(){return{mod:$$METAMODEL$$,d:['ceylon.language','List','$at','reversed'],$t:{t:List,a:{Element:'Element'}}};});
Array$proto.chain = function(other, $$$mptypes) {
    if (this.length === 0) { return other; }
    return Iterable.$$.prototype.chain.call(this, other, $$$mptypes);
}
defineAttr(Array$proto, 'first', function(){ return this.length>0 ? this[0] : null; },
  undefined,function(){return{mod:$$METAMODEL$$,d:['ceylon.language','Iterable','$at','first'],$t:{t:'u',l:[{t:Null},'Element']}};});
defineAttr(Array$proto, 'last', function() { return this.length>0 ? this[this.length-1] : null; },
  undefined,function(){return{mod:$$METAMODEL$$,d:['ceylon.language','List','$at','last'],$t:{t:'u',l:[{t:Null},'Element']}};});
Array$proto.segment = function(from, len) {
    if (len <= 0) { return getEmpty(); }
    var stop = from + len;
    var seq = this.slice((from>=0)?from:0, (stop>=0)?stop:0);
    return (seq.length > 0) ? ArraySequence(seq,this.$$targs$$) : getEmpty();
}
Array$proto.span = function(from, to) {
    if (from > to) {
        var arr = this.segment(to, from-to+1);
        arr.reverse();
        return arr.reifyCeylonType(this.$$targs$$);
    }
    return this.segment(from, to-from+1);
}
Array$proto.spanTo = function(to) {
    return to < 0 ? getEmpty() : this.span(0, to);
}
Array$proto.spanFrom = function(from) {
    return this.span(from, 0x7fffffff);
}
defineAttr(Array$proto, 'rest', function() {
    return this.length<=1 ? getEmpty() : ArraySequence(this.slice(1),this.$$targs$$);
});
Array$proto.items = function(keys) {
    if (keys === undefined) return getEmpty();
    var seq = [];
    for (var i = 0; i < keys.size; i++) {
        var key = keys.$get(i);
        seq.push(this.$get(key));
    }
    return ArraySequence(seq,this.$$targs$$);
}
defineAttr(Array$proto, 'keys', function(){ return TypeCategory(this, {t:Integer}); });
Array$proto.contains = function(elem) {
    for (var i=0; i<this.length; i++) {
        if (elem.equals(this[i])) {
            return true;
        }
    }
    return false;
}
Array$proto.iterator = function() {
    var $$$index$$$ = 0;
    var $$$arr$$$ = this;
    return new ComprehensionIterator(function() {
        return ($$$index$$$ === $$$arr$$$.length) ? getFinished() : $$$arr$$$[$$$index$$$++];
    }, this.$$targs$$);
}
Array$proto.copyTo = function(other, srcpos, dstpos, length) {
    if (length === undefined) length = this.size;
    if (srcpos === undefined) srcpos = 0;
    if (dstpos === undefined) dstpos = 0;
    var endpos = srcpos+length;
    //TODO validate range?
    for (var i=srcpos; i<endpos; i++) {
        other[dstpos]=this[i];
        dstpos++;
    }
}
Array$proto.shorterThan = function(len) {
  return this.size < len;
}
Array$proto.shorterThan.$$metamodel$$={mod:$$METAMODEL$$,d:['ceylon.language','Iterable','$m','shorterThan']};
Array$proto.longerThan = function(len) {
  return this.size > len;
}
Array$proto.longerThan.$$metamodel$$={mod:$$METAMODEL$$,d:['ceylon.language','Iterable','$m','longerThan']};

exports.ArrayList=ArrayList;
exports.arrayOfSize=function(size, elem, $$$mptypes) {
    if (size > 0) {
        var elems = [];
        for (var i = 0; i < size; i++) {
            elems.push(elem);
        }
        elems.$$targs$$=$$$mptypes;
        return elems;
    } else return [];
}
exports.arrayOfSize.$$metamodel$$={$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','arrayOfSize']};

function TypeCategory(seq, type) {
    var that = new TypeCategory.$$;
    that.type = type;
    that.seq = seq;
    return that;
}
initTypeProto(TypeCategory, 'ceylon.language::TypeCategory', $init$Basic(), Category);
var TypeCategory$proto = TypeCategory.$$.prototype;
TypeCategory$proto.contains = function(k) {
    return isOfType(k, this.type) && this.seq.defines(k);
}

function SequenceBuilder($$targs$$) {
    var that = new SequenceBuilder.$$;
    that.seq = [];
    that.$$targs$$=$$targs$$;
    return that;
}
SequenceBuilder.$$metamodel$$={$ps:[],$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','SequenceBuilder']};

initTypeProto(SequenceBuilder, 'ceylon.language::SequenceBuilder', $init$Basic());
var SequenceBuilder$proto = SequenceBuilder.$$.prototype;
defineAttr(SequenceBuilder$proto, 'sequence', function() {
    return (this.seq.length > 0) ? ArraySequence(this.seq,this.$$targs$$) : getEmpty();
});
SequenceBuilder$proto.append=function(e){
  this.seq.push(e);
  return this;
}
SequenceBuilder$proto.appendAll = function(/*Iterable*/arr) {
    if (arr === undefined) return;
    var iter = arr.iterator();
    var e; while ((e = iter.next()) !== getFinished()) {
        this.seq.push(e);
    }
    return this;
}
defineAttr(SequenceBuilder$proto, 'size', function(){ return this.seq.length; });

function SequenceAppender(other, $$targs$$) {
    var that = new SequenceAppender.$$;
    that.seq = [];
    that.$$targs$$=$$targs$$;
    that.appendAll(other);
    return that;
}
SequenceAppender.$$metamodel$$={$ps:[],$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','SequenceAppender']};

initTypeProto(SequenceAppender, 'ceylon.language::SequenceAppender', SequenceBuilder);

exports.Sequence=Sequence;
exports.SequenceBuilder=SequenceBuilder;
exports.SequenceAppender=SequenceAppender;
exports.ArraySequence=ArraySequence;
function String$(/*{Character*}*/value,size) {
    if (value && value.getT$name && value.getT$name() == 'ceylon.language::String') {
        //if it's already a String just return it
        return value;
    }
    else if (typeof(value) === 'string') {
        var that = new String(value);
        that.codePoints = size;
        return that;
    }
    var _sb = StringBuilder();
    var _iter = value.iterator();
    var _c; while ((_c = _iter.next()) !== getFinished()) {
        _sb.appendCharacter(_c);
    }
    var that = _sb.string;
    if (size !== undefined) that.codePoints=size;
    return that;
}
String$.$$metamodel$$=function(){return{'super':{t:Object$},
  $ps:[{$nm:'characters',$t:{t:Iterable,a:{Element:{t:Character},Absent:{t:Null}}},$mt:'prm'}],
  'satisfies':[{t:List,a:{Element:{t:Character}}}, {t:Comparable,a:{Other:{t:String$}}},
    {t:Summable,a:{Other:{t:String$}}}, {t:Ranged,a:{Index:{t:Integer},Span:{t:String$}}},
    {t:Cloneable,a:{Clone:{t:String$}}}],
  $an:function(){return[shared(),native(),final()];},
  mod:$$METAMODEL$$,d:['ceylon.language','String']};};

initExistingType(String$, String, 'ceylon.language::String', Object$, Sequential, Comparable,
        Ranged, Summable, Cloneable);
var origStrToString = String.prototype.toString;
inheritProto(String$, Object$, Sequential, Comparable, Ranged, Summable,
        Cloneable);
var String$proto = String$.$$.prototype;
String$proto.$$targs$$={Element:{t:Character}, Absent:{t:Null}};
String$proto.getT$name = function() {
    return String$.$$.T$name;
}
String$proto.getT$all = function() {
    return String$.$$.T$all;
}
String$proto.toString = origStrToString;
defineAttr(String$proto, 'string', function(){ return this; },undefined,function(){return{mod:$$METAMODEL$$,
  $t:{t:String$},d:['ceylon.language','Object','$at','string']}});
String$proto.plus = function(other) {
    var size = this.codePoints + other.codePoints;
    return String$(this+other, isNaN(size)?undefined:size);
}
String$proto.plus.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','plus'],
  $ps:[{$nm:'other',$t:{t:String$},$mt:'prm'}]};}
String$proto.equals = function(other) {
    if (other.constructor===String) {
        return other.valueOf()===this.valueOf();
    } else if (isOfType(other, {t:Iterable, a:{Element:{t:Character}}})) {
        if (other.size===this.size) {
            for (var i=0;i<this.size;i++) {
                if (!this.$get(i).equals(other.$get(i))) return false;
            }
            return true;
        }
    }
    return false;
}
String$proto.equals.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','String','$m','equals'],
  $ps:[{$nm:'other',$t:{t:String$},$mt:'prm'}]};
String$proto.compare = function(other) {
    var cmp = this.localeCompare(other);
    return cmp===0 ? equal : (cmp<0 ? smaller:larger);
}
String$proto.compare.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:Comparison},d:['ceylon.language','String','$m','compare'],
  $ps:[{$nm:'other',$t:{t:String$}}]};
defineAttr(String$proto, 'uppercased', function(){ return String$(this.toUpperCase()); },undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$at','uppercased']}});
defineAttr(String$proto, 'lowercased', function(){ return String$(this.toLowerCase()); },undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$at','lowercased']}});
defineAttr(String$proto, 'size', function() {
  if (this.codePoints===undefined) {
    this.codePoints = countCodepoints(this);
  }
  return this.codePoints;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','Iterable','$at','size']}});
defineAttr(String$proto, 'lastIndex', function(){ return this.size.equals(0) ? null : this.size.predecessor; },undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','List','$at','lastIndex']}});
String$proto.span = function(from, to) {
    if (from > to) {
        return this.segment(to, from-to+1).reversed;
    }
    return this.segment(from, to-from+1);
}
String$proto.span.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','span'],
  $ps:[{$nm:'from',$t:{t:Integer}},{$nm:'to',$t:{t:Integer}}]};
String$proto.spanFrom = function(from) {
    return this.span(from, 0x7fffffff);
}
String$proto.spanFrom.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','spanFrom'],
  $ps:[{$nm:'from',$t:{t:Integer}}]};
String$proto.spanTo = function(to) {
    return to < 0 ? String$('', 0) : this.span(0, to);
}
String$proto.spanTo.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','spanTo'],
  $ps:[{$nm:'to',$t:{t:Integer}}]};
String$proto.segment = function(from, len) {
    var fromIndex = from;
    var maxCount = len + fromIndex;
    if (fromIndex < 0) {fromIndex = 0;}
    var i1 = 0;
    var count = 0;
    for (; i1<this.length && count<fromIndex; ++i1, ++count) {
        if ((this.charCodeAt(i1)&0xfc00) === 0xd800) {++i1}
    }
    var i2 = i1;
    for (; i2<this.length && count<maxCount; ++i2, ++count) {
        if ((this.charCodeAt(i2)&0xfc00) === 0xd800) {++i2}
    }
    if (i2 >= this.length) {
        this.codePoints = count;
        if (fromIndex === 0) {return this;}
    }
    return String$(this.substring(i1, i2), count-fromIndex);
}
String$proto.segment.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','segment'],
  $ps:[{$nm:'from',$t:{t:Integer}},{$nm:'length',$t:{t:Integer}}]};
defineAttr(String$proto, 'empty', function() {
    return this.length===0;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','Sequential','$at','empty']}});
String$proto.longerThan = function(length) {
    if (this.codePoints!==undefined) {return this.codePoints>length}
    if (this.length <= length) {return false}
    if (this.length<<1 > length) {return true}
    this.codePoints = countCodepoints(this);
    return this.codePoints>length;
}
String$proto.longerThan.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','String','$m','longerThan'],
  $ps:[{$nm:'length',$t:{t:Integer}}]};
String$proto.shorterThan = function(length) {
    if (this.codePoints!==undefined) {return this.codePoints<length}
    if (this.length < length) {return true}
    if (this.length<<1 >= length) {return false}
    this.codePoints = countCodepoints(this);
    return this.codePoints<length;
}
String$proto.shorterThan.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','String','$m','shorterThan'],
  $ps:[{$nm:'length',$t:{t:Integer}}]};
String$proto.iterator= function() {
	return this.length === 0 ? getEmptyIterator() : StringIterator(this);
}
String$proto.iterator.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:Iterator,a:{Element:{t:Character}}},d:['ceylon.language','String','$m','iterator']};
String$proto.$get = function(index) {
    if (index<0 || index>=this.length) {return null}
    var i = 0;
    for (var count=0; count<index; count++) {
        if ((this.charCodeAt(i)&0xfc00) === 0xd800) {++i}
        if (++i >= this.length) {return null}
    }
    return Character(codepointFromString(this, i));
}
String$proto.$get.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:'u',l:[{t:Null},{t:Character}]},d:['ceylon.language','String','$m','get'],
  $ps:[{$nm:'index',$t:{t:Integer}}]};
defineAttr(String$proto, 'trimmed', function() {
    // make use of the fact that all WS characters are single UTF-16 code units
    var from = 0;
    while (from<this.length && (this.charCodeAt(from) in $WS)) {++from}
    var to = this.length;
    if (from < to) {
        do {--to} while (from<to && (this.charCodeAt(to) in $WS));
        ++to;
    }
    if (from===0 && to===this.length) {return this;}
    var result = String$(this.substring(from, to));
    if (this.codePoints !== undefined) {
        result.codePoints = this.codePoints - from - this.length + to;
    }
    return result;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$at','trimmed']}});
String$proto.trim = function(/*Category*/chars) {
    var from = 0;
    while (from<this.length && chars(this.$get(from))) {++from}
    var to = this.length;
    if (from < to) {
        do {--to} while (from<to && chars(this.$get(to)));
        ++to;
    }
    if (from===0 && to===this.length) {return this;}
    var result = String$(this.substring(from, to));
    if (this.codePoints !== undefined) {
        result.codePoints = this.codePoints - from - this.length + to;
    }
    return result;
}
String$proto.trim.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','trim']};
String$proto.trimLeading = function(/*Category*/chars) {
    var from = 0;
    while (from<this.length && chars(this.$get(from))) {++from}
    if (from===0) {return this;}
    var result = String$(this.substring(from, this.length));
    if (this.codePoints !== undefined) {
        result.codePoints = this.codePoints - from;
    }
    return result;
}
String$proto.trimLeading.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','trimLeading']};
String$proto.trimTrailing = function(/*Category*/chars) {
    var to = this.length;
    if (to > 0) {
        do {--to} while (to>=0 && chars(this.$get(to)));
        ++to;
    }
    if (to===this.length) {return this;}
    else if (to===0) { return String$("",0); }
    var result = String$(this.substring(0, to));
    if (this.codePoints !== undefined) {
        result.codePoints = this.codePoints - this.length + to;
    }
    return result;
}
String$proto.trimTrailing.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','trimTrailing']};

String$proto.initial = function(length) {
    if (length >= this.codePoints) {return this}
    var count = 0;
    var i = 0;
    for (; i<this.length && count<length; ++i, ++count) {
        if ((this.charCodeAt(i)&0xfc00) === 0xd800) {++i}
    }
    if (i >= this.length) {
        this.codePoints = count;
        return this;
    }
    return String$(this.substr(0, i), count);
}
String$proto.initial.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','initial'],
  $ps:[{$nm:'length',$t:{t:Integer}}]};
String$proto.terminal = function(length) {
    if (length >= this.codePoints) {return this}
    var count = 0;
    var i = this.length;
    for (; i>0 && count<length; ++count) {
        if ((this.charCodeAt(--i)&0xfc00) === 0xdc00) {--i}
    }
    if (i <= 0) {
        this.codePoints = count;
        return this;
    }
    return String$(this.substr(i), count);
}
String$proto.terminal.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','terminal'],
  $ps:[{$nm:'length',$t:{t:Integer}}]};
defineAttr(String$proto, 'hash', function() {
    if (this._hash === undefined) {
        for (var i = 0; i < this.length; i++) {
          var c = this.charCodeAt(i);
          this._hash += c + (this._hash << 10);
          this._hash ^= this._hash >> 6;
    }

    this._hash += this._hash << 3;
    this._hash ^= this._hash >> 11;
    this._hash += this._hash << 15;
    this._hash = this._hash & ((1 << 29) - 1);
  }
  return this._hash;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','Object','$at','hash']}});

function cmpSubString(str, subStr, offset) {
    for (var i=0; i<subStr.length; ++i) {
        if (str.charCodeAt(offset+i)!==subStr.charCodeAt(i)) {return false}
    }
    return true;
}
String$proto.startsWith = function(str) {
    if (str.length > this.length) {return false}
    return cmpSubString(this, str, 0);
}
String$proto.startsWith.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','String','$m','startsWith'],
  $ps:[{$nm:'string',$t:{t:String$}}]};
String$proto.endsWith = function(str) {
    var start = this.length - str.length
    if (start < 0) {return false}
    return cmpSubString(this, str, start);
}
String$proto.endsWith.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','String','$m','endsWith'],
  $ps:[{$nm:'string',$t:{t:String$}}]};
String$proto.contains = function(sub) {
    var str;
    if (sub.constructor === String) {str = sub}
    else if (sub.constructor !== Character.$$) {return false}
    else {str = codepointToString(sub.value)}
    return this.indexOf(str) >= 0;
}
String$proto.contains.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','String','$m','contains'],
  $ps:[{$nm:'substring',$t:{t:String$}}]};
defineAttr(String$proto, 'normalized', function() {
    // make use of the fact that all WS characters are single UTF-16 code units
    var result = "";
    var len = 0;
    var first = true;
    var i1 = 0;
    while (i1 < this.length) {
        while (this.charCodeAt(i1) in $WS) {
            if (++i1 >= this.length) {return String$(result)}
        }
        var i2 = i1;
        var cc = this.charCodeAt(i2);
        do {
            ++i2;
            if ((cc&0xfc00) === 0xd800) {++i2}
            ++len;
            cc = this.charCodeAt(i2);
        } while (i2<this.length && !(cc in $WS));
        if (!first) {
            result += " ";
            ++len;
        }
        first = false;
        result += this.substring(i1, i2);
        i1 = i2+1;
    }
    return String$(result, len);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$at','normalized']}});
/*String$proto.firstOccurrence = function(sub) {
    if (sub.length == 0) {return 0}
    var bound = this.length - sub.length;
    for (var i=0, count=0; i<=bound; ++count) {
        if (cmpSubString(this, sub, i)) {return count}
        if ((this.charCodeAt(i++)&0xfc00) === 0xd800) {++i}
    }
    return null;
}
String$proto.firstOccurrence.$$metamodel$$={mod:$$METAMODEL$$,d:['ceylon.language','String','$m','firstOccurrence']};
String$proto.lastOccurrence = function(sub) {
    if (sub.length == 0) {return this.length>0 ? this.length-1 : 0}
    for (var i=this.length-sub.length; i>=0; --i) {
        if (cmpSubString(this, sub, i)) {
            for (var count=0; i>0; ++count) {
                if ((this.charCodeAt(--i)&0xfc00) === 0xdc00) {--i}
            }
            return count;
        }
    }
    return null;
}
String$proto.lastOccurrence.$$metamodel$$={mod:$$METAMODEL$$,d:['ceylon.language','String','$m','lastOccurrence']};
*/
String$proto.firstOccurrence = function(subc) {
    for (var i=0, count=0; i<this.length; count++) {
        var cp = this.charCodeAt(i++);
        if (((cp&0xfc00) === 0xd800) && i<this.length) {
            cp = (cp<<10) + this.charCodeAt(i++) - 0x35fdc00;
        }
        if (cp === subc.value) {return count;}
    }
    this.codePoints = count;
    return null;
}
String$proto.firstOccurrence.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:'u',l:[{t:Null},{t:Integer}]},d:['ceylon.language','String','$m','firstOccurrence']};
String$proto.lastOccurrence = function(subc) {
    for (var i=this.length-1, count=0; i>=0; count++) {
        var cp = this.charCodeAt(i--);
        if (((cp%0xfc00) === 0xdc00) && i>=0) {
           cp = (this.charCodeAt(i--)<<10) + cp - 0x35fdc00;
        }
        if (cp === subc.value) {
            if (this.codePoints === undefined) {this.codePoints = countCodepoints(this);}
            return this.codePoints - count - 1;
        }
    }
    this.codePoints = count;
    return null;
}
String$proto.lastOccurrence.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:'u',l:[{t:Null},{t:Integer}]},d:['ceylon.language','String','$m','lastOccurrence']};
defineAttr(String$proto, 'characters', function() {
    return this.size>0 ? this:getEmpty();
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Character}}},d:['ceylon.language','String','$at','characters']}});
defineAttr(String$proto, 'first', function() { return this.$get(0); },undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:'u',l:[{t:Null},{t:Character}]},d:['ceylon.language','Iterable','$at','first']}});
defineAttr(String$proto, 'last', function(){ return this.size>0?this.$get(this.size.predecessor):null; },undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:'u',l:[{t:Null},{t:Character}]},d:['ceylon.language','Iterable','$at','last']}});
defineAttr(String$proto, 'keys', function() {
    //TODO implement!!!
    return this.size > 0 ? Range(0, this.size.predecessor, {Element:{t:Integer}}) : getEmpty();
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Category},d:['ceylon.language','Category','$at','keys']}});
String$proto.join = function(strings) {
    var it = strings.iterator();
    var str = it.next();
    if (str === getFinished()) {return String$("", 0);}
    if (this.codePoints === undefined) {this.codePoints = countCodepoints(this)}
    var result = str;
    var len = str.codePoints;
    while ((str = it.next()) !== getFinished()) {
        result += this;
        result += str;
        len += this.codePoints + str.codePoints;
    }
    return String$(result, isNaN(len)?undefined:len);
}
String$proto.join.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','join'],
  $ps:[{$nm:'strings',$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:String$}}}}]};
function isWhitespace(c) { return c.value in $WS; }
String$proto.$split = function(sep, discard, group) {
    // shortcut for empty input
    if (this.length === 0) {return Singleton(this, {Element:{t:String$}}); }

    if (sep === undefined) {sep = isWhitespace}
    if (discard === undefined) {discard = true}
    if (group === undefined) {group = true}

    //TODO: return an iterable which determines the next token on demand
    var tokens = [];
    var tokenBegin = 0;
    var tokenBeginCount = 0;
    var count = 0;
    var value = this;
    var separator = true;

    function pushToken(tokenEnd) {
        tokens.push(String$(value.substring(tokenBegin, tokenEnd), count-tokenBeginCount));
    }
    if (isOfType(sep, {t:Iterable})) {
        var sepChars = {}
        var it = sep.iterator();
        var c; while ((c=it.next()) !== getFinished()) {sepChars[c.value] = true}
        for (var i=0; i<this.length;) {
            var j = i;
            var cp = this.charCodeAt(i++);
            if ((cp&0xfc00)===0xd800 && i<this.length) {
                cp = (cp<<10) + this.charCodeAt(i++) - 0x35fdc00;
            }
            if (cp in sepChars) {
                if (!group) {
                    // ungrouped separator: store preceding token
                    pushToken(j);
                    if (!discard) {
                        // store separator as token
                        tokens.push(String$(this.substring(j, i), 1));
                    }
                    // next token begins after this character
                    tokenBegin = i;
                    tokenBeginCount = count + 1;
                } else if (!separator || (j == 0)) {
                    // begin of grouped separator: store preceding token
                    pushToken(j);
                    // separator token begins at this character
                    tokenBegin = j;
                    tokenBeginCount = count;
                }
                separator = true;

            } else if (separator) {
                // first non-separator after separators or at beginning
                if (!discard && (tokenBegin != j)) {
                    // store preceding grouped separator (if group=false then tokenBegin=j)
                    pushToken(j);
                }
                // non-separator token begins at this character
                tokenBegin = j;
                tokenBeginCount = count;
                separator = false;
            }
        }
        if (tokenBegin != i) {
            pushToken(i);
        }
    } else {
        for (var i=0; i<this.length; ++count) {
            var j = i;
            var cp = this.charCodeAt(i++);
            if ((cp&0xfc00)===0xd800 && i<this.length) {
                cp = (cp<<10) + this.charCodeAt(i++) - 0x35fdc00;
            }

            if (sep(Character(cp))) {
                if (!group) {
                    // ungrouped separator: store preceding token
                    pushToken(j);
                    if (!discard) {
                        // store separator as token
                        tokens.push(String$(this.substring(j, i), 1));
                    }
                    // next token begins after this character
                    tokenBegin = i;
                    tokenBeginCount = count + 1;
                } else if (!separator || (j == 0)) {
                    // begin of grouped separator: store preceding token
                    pushToken(j);
                    // separator token begins at this character
                    tokenBegin = j;
                    tokenBeginCount = count;
                }
                separator = true;

            } else if (separator) {
                // first non-separator after separators or at beginning
                if (!discard && (tokenBegin != j)) {
                    // store preceding grouped separator (if group=false then tokenBegin=j)
                    pushToken(j);
                }
                // non-separator token begins at this character
                tokenBegin = j;
                tokenBeginCount = count;
                separator = false;
            }
        }

        if ((tokenBegin != i) && !(separator && discard)) {
            // store preceding token (may be a grouped separator)
            pushToken(i);
        }
        if (separator) {
            // if last character was a separator then there's another empty token
            tokens.push(String$("", 0));
        }
    }

    this.codePoints = count;
    return ArraySequence(tokens, {Element:{t:String$}});
}
String$proto.$split.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:String$}}},d:['ceylon.language','String','$m','split']};
defineAttr(String$proto, 'reversed', function() {
    var result = "";
    for (var i=this.length; i>0;) {
        var cc = this.charCodeAt(--i);
        if ((cc&0xfc00)!==0xdc00 || i===0) {
            result += this.charAt(i);
        } else {
            result += this.substr(--i, 2);
        }
    }
    return String$(result);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$at','reversed']}});
String$proto.$replace = function(sub, repl) {
    return String$(this.replace(new RegExp(sub, 'g'), repl));
}
String$proto.$replace.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','replace'],
  $ps:[{$nm:'substring',$t:{t:String$}},{$nm:'replacement',$t:{t:String$}}]};
String$proto.repeat = function(times) {
    var sb = StringBuilder();
    for (var i = 0; i < times; i++) {
        sb.append(this);
    }
    return sb.string;
}
String$proto.repeat.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','repeat'],
  $ps:[{$nm:'times',$t:{t:Integer}}]};
function isNewline(c) { return c.value===10; }
defineAttr(String$proto, 'lines', function() {
    return this.$split(isNewline, true);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:String$}}},d:['ceylon.language','String','$at','lines']}});
String$proto.occurrences = function(sub) {
    if (sub.length == 0) {return 0}
    var ocs = [];
    var bound = this.length - sub.length;
    for (var i=0, count=0; i<=bound; ++count) {
        if (cmpSubString(this, sub, i)) {
            ocs.push(count);
            i+=sub.length;
        } else if ((this.charCodeAt(i++)&0xfc00) === 0xd800) {++i;}
    }
    return ocs.length > 0 ? ocs : getEmpty();
}
String$proto.occurrences.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:Iterable,a:{Absent:{t:Null},Element:{t:Integer}}},d:['ceylon.language','List','$m','occurrences']};
String$proto.$filter = function(f) {
    var r = Iterable.$$.prototype.$filter.call(this, f);
    return String$(r);
}
String$proto.$filter.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','filter']};
String$proto.skipping = function(skip) {
    if (skip==0) return this;
    return this.segment(skip, this.size);
}
String$proto.skipping.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','skipping'],
  $ps:[{$nm:'skip',$t:{t:Integer}}]};
String$proto.taking = function(take) {
    if (take==0) return getEmpty();
    return this.segment(0, take);
}
String$proto.taking.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','taking'],
  $ps:[{$nm:'take',$t:{t:Integer}}]};
String$proto.by = function(step) {
    var r = Iterable.$$.prototype.by.call(this, step);
    return String$(r);
}
String$proto.by.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','by'],
  $ps:[{$nm:'step',$t:{t:Integer}}]};
String$proto.$sort = function(f) {
    var r = Iterable.$$.prototype.$sort.call(this, f);
    return String$(r);
}
String$proto.$sort.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$m','sort']};
defineAttr(String$proto, 'coalesced', function(){ return this; },undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','String','$at','coalesced']}});

function StringIterator(string) {
    var that = new StringIterator.$$;
    that.str = string;
    that.index = 0;
    return that;
}
StringIterator.$$metamodel$$=function(){return{$nm:'StringIterator',$mt:'cls',$ps:[{$nm:'string',$t:{t:String$}}],$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','Iterator']}};

initTypeProto(StringIterator, 'ceylon.language::StringIterator', $init$Basic(), Iterator);
var StringIterator$proto = StringIterator.$$.prototype;
StringIterator$proto.$$targs$$={Element:{t:Character}, Absent:{t:Null}};
StringIterator$proto.next = function() {
    if (this.index >= this.str.length) { return getFinished(); }
    var first = this.str.charCodeAt(this.index++);
    if ((first&0xfc00) !== 0xd800 || this.index >= this.str.length) {
        return Character(first);
    }
    return Character((first<<10) + this.str.charCodeAt(this.index++) - 0x35fdc00);
}

function countCodepoints(str) {
    var count = 0;
    for (var i=0; i<str.length; ++i) {
        ++count;
        if ((str.charCodeAt(i)&0xfc00) === 0xd800) {++i}
    }
    return count;
}
function codepointToString(cp) {
    if (cp <= 0xffff) {
        return String.fromCharCode(cp);
    }
    return String.fromCharCode((cp>>10)+0xd7c0, (cp&0x3ff)+0xdc00);
}
function codepointFromString(str, index) {
    var first = str.charCodeAt(index);
    if ((first&0xfc00) !== 0xd800) {return first}
    var second = str.charCodeAt(index+1);
    return isNaN(second) ? first : ((first<<10) + second - 0x35fdc00);
}
exports.codepointFromString=codepointFromString;

function Character(value) {
    if (value && value.getT$name && value.getT$name() === 'ceylon.language::Character') {
        return value;
    }
    var that = new Character.$$;
    that.value = value;
    return that;
}
Character.$$metamodel$$={'super':{t:Object$}, 'satisfies':[
    {t:Comparable,a:{Other:{t:Character}}}, {t:Enumerable,a:{Other:{t:Character}}}],
  $an:function(){return[shared(),native(),final()];},mod:$$METAMODEL$$,d:['ceylon.language','Character']};

initTypeProto(Character, 'ceylon.language::Character', Object$, Comparable, $init$Enumerable());
var Character$proto = Character.$$.prototype;
defineAttr(Character$proto, 'string', function(){ return String$(codepointToString(this.value)); },undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Character','$at','string']}});
Character$proto.equals = function(other) {
    return other.constructor===Character.$$ && other.value===this.value;
}
defineAttr(Character$proto, 'hash', function(){ return this.value; },undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','Character','$at','hash']}});
Character$proto.compare = function(other) {
    return this.value===other.value ? equal
                                    : (this.value<other.value ? smaller:larger);
}
defineAttr(Character$proto, 'uppercased', function() {
    var ucstr = codepointToString(this.value).toUpperCase();
    return Character(codepointFromString(ucstr, 0));
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Character},d:['ceylon.language','Character','$at','uppercased']}});
defineAttr(Character$proto, 'lowercased', function() {
    var lcstr = codepointToString(this.value).toLowerCase();
    return Character(codepointFromString(lcstr, 0));
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Character},d:['ceylon.language','Character','$at','lowercased']}});
defineAttr(Character$proto, 'titlecased', function() {
    var tc = $toTitlecase[this.value];
    return tc===undefined ? this.uppercased : Character(tc);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Character},d:['ceylon.language','Character','$at','titlecased']}});
var $WS={0x9:true, 0xa:true, 0xb:true, 0xc:true, 0xd:true, 0x20:true, 0x85:true,
    0x1680:true, 0x180e:true, 0x2028:true, 0x2029:true, 0x205f:true, 0x3000:true,
    0x1c:true, 0x1d:true, 0x1e:true, 0x1f:true};
for (var i=0x2000; i<0x2007; i++) { $WS[i]=true; }
for (var i=0x2008; i<=0x200a; i++) { $WS[i]=true; }
var $digit={0x30:true, 0x660:true, 0x6f0:true, 0x7c0:true, 0x966:true, 0x9e6:true, 0xa66:true,
    0xae6:true, 0xb66:true, 0xbe6:true, 0xc66:true, 0xce6:true, 0xd66:true, 0xe50:true,
    0xed0:true, 0xf20:true, 0x1040:true, 0x1090:true, 0x17e0:true, 0x1810:true, 0x1946:true,
    0x19d0:true, 0x1a80:true, 0x1a90:true, 0x1b50:true, 0x1bb0:true, 0x1c40:true, 0x1c50:true,
    0xa620:true, 0xa8d0:true, 0xa900:true, 0xa9d0:true, 0xaa50:true, 0xabf0:true, 0xff10:true,
    0x104a0:true, 0x11066:true, 0x110f0:true, 0x11136:true, 0x111d0:true, 0x116c0:true}
var $titlecase={
    0x1c5: [0x1c4, 0x1c6], 0x1c8: [0x1c7, 0x1c9], 0x1cb: [0x1ca, 0x1cc], 0x1f2: [0x1f1, 0x1f3],
    0x1f88: [undefined, 0x1f80], 0x1f89: [undefined, 0x1f81], 0x1f8a: [undefined, 0x1f82],
    0x1f8b: [undefined, 0x1f83], 0x1f8c: [undefined, 0x1f84], 0x1f8d: [undefined, 0x1f85],
    0x1f8e: [undefined, 0x1f86], 0x1f8f: [undefined, 0x1f87], 0x1f98: [undefined, 0x1f90],
    0x1f99: [undefined, 0x1f91], 0x1f9a: [undefined, 0x1f92], 0x1f9b: [undefined, 0x1f93],
    0x1f9c: [undefined, 0x1f94], 0x1f9d: [undefined, 0x1f95], 0x1f9e: [undefined, 0x1f96],
    0x1f9f: [undefined, 0x1f97], 0x1fa8: [undefined, 0x1fa0], 0x1fa9: [undefined, 0x1fa1],
    0x1faa: [undefined, 0x1fa2], 0x1fab: [undefined, 0x1fa3], 0x1fac: [undefined, 0x1fa4],
    0x1fad: [undefined, 0x1fa5], 0x1fae: [undefined, 0x1fa6], 0x1faf: [undefined, 0x1fa7],
    0x1fbc: [undefined, 0x1fb3], 0x1fcc: [undefined, 0x1fc3], 0x1ffc: [undefined, 0x1ff3]
}
var $toTitlecase={
    0x1c6:0x1c5, 0x1c7:0x1c8, 0x1ca:0x1cb, 0x1f1:0x1f2,
    0x1c4:0x1c5, 0x1c9:0x1c8, 0x1cc:0x1cb, 0x1f3:0x1f2, 0x1f80:0x1f88, 0x1f81:0x1f89, 0x1f82:0x1f8a,
    0x1f83:0x1f8b, 0x1f84:0x1f8c, 0x1f85:0x1f8d, 0x1f86:0x1f8e, 0x1f87:0x1f8f, 0x1f90:0x1f98,
    0x1f91:0x1f99, 0x1f92:0x1f9a, 0x1f93:0x1f9b, 0x1f94:0x1f9c, 0x1f95:0x1f9d, 0x1f96:0x1f9e,
    0x1f97:0x1f9f, 0x1fa0:0x1fa8, 0x1fa1:0x1fa9, 0x1fa2:0x1faa, 0x1fa3:0x1fab, 0x1fa4:0x1fac,
    0x1fa5:0x1fad, 0x1fa6:0x1fae, 0x1fa7:0x1faf, 0x1fb3:0x1fbc, 0x1fc3:0x1fcc, 0x1ff3:0x1ffc
}
defineAttr(Character$proto, 'whitespace', function(){ return this.value in $WS; },undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','Character','$at','whitespace']}});
defineAttr(Character$proto, 'control', function(){ return this.value<32 || this.value===127; },undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','Character','$at','control']}});
defineAttr(Character$proto, 'digit', function() {
    var check = this.value & 0xfffffff0;
    if (check in $digit) {
        return (this.value&0xf) <= 9;
    }
    if ((check|6) in $digit) {
        return (this.value&0xf) >= 6;
    }
    return this.value>=0x1d7ce && this.value<=0x1d7ff;
},undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','Character','$at','digit']}});
defineAttr(Character$proto, 'integerValue', function(){ return this.value; },undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','Enumerable','$at','integerValue']}});
defineAttr(Character$proto, 'integer',function(){ return this.value; },undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','Character','$at','integer']}});
defineAttr(Character$proto, 'uppercase', function() {
    var str = codepointToString(this.value);
    return str.toLowerCase()!==str && !(this.value in $titlecase);
},undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','Character','$at','uppercase']}});
defineAttr(Character$proto, 'lowercase', function() {
    var str = codepointToString(this.value);
    return str.toUpperCase()!==str && !(this.value in $titlecase);
},undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','Character','$at','lowercase']}});
defineAttr(Character$proto, 'titlecase', function(){ return this.value in $titlecase; },undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','Character','$at','titlecase']}});
defineAttr(Character$proto, 'letter', function() {
    //TODO: this captures only letters that have case
    var str = codepointToString(this.value);
    return str.toUpperCase()!==str || str.toLowerCase()!==str || (this.value in $titlecase);
},undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','Character','$at','letter']}});
defineAttr(Character$proto, 'successor', function() {
    var succ = this.value+1;
    if ((succ&0xf800) === 0xd800) {return Character(0xe000)}
    return Character((succ<=0x10ffff) ? succ:0);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Character},d:['ceylon.language','Ordinal','$at','successor']}});
defineAttr(Character$proto, 'predecessor', function() {
    var succ = this.value-1;
    if ((succ&0xf800) === 0xd800) {return Character(0xd7ff)}
    return Character((succ>=0) ? succ:0x10ffff);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Character},d:['ceylon.language','Ordinal','$at','predecessor']}});
Character$proto.distanceFrom = function(other) {
    return this.value - other.value;
}

function StringBuilder(/*String...*/comps) {
    var that = new StringBuilder.$$;
    that.value = "";
    if (comps !== undefined) {
        that.appendAll(comps);
    }
    return that;
}
StringBuilder.$$metamodel$$={'super':{t:Basic},$ps:[],$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','StringBuilder']};

initTypeProto(StringBuilder, 'ceylon.language::StringBuilder', $init$Basic());
var StringBuilder$proto = StringBuilder.$$.prototype;
defineAttr(StringBuilder$proto, 'string', function(){ return String$(this.value); },undefined,function(){return{
  mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','StringBuilder','$at','string']}});
StringBuilder$proto.append = function(s) {
    this.value = this.value + s;
    return this;
}
StringBuilder$proto.appendAll = function(strings) {
    var iter = strings.iterator();
    var _s; while ((_s = iter.next()) !== getFinished()) {
        this.value += _s?_s:"null";
    }
    return this;
}
StringBuilder$proto.appendCharacter = function(c) {
    this.append(c.string);
    return this;
}
StringBuilder$proto.appendNewline = function() {
    this.value = this.value + "\n";
    return this;
}
StringBuilder$proto.appendSpace = function() {
    this.value = this.value + " ";
    return this;
}
defineAttr(StringBuilder$proto, 'size', function() {
    return countCodepoints(this.value);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','StringBuilder','$at','size']}});
StringBuilder$proto.reset = function() {
    this.value = "";
    return this;
}
StringBuilder$proto.insert = function(pos, content) {
    if (pos <= 0) {
        this.value = content + this.value;
    } else if (pos >= this.size) {
        this.value = this.value + content;
    } else {
        this.value = this.value.slice(0, pos) + content + this.value.slice(pos);
    }
    return this;
}
StringBuilder$proto.insertCharacter = function(pos, c) {
    if (pos <= 0) {
        this.value = c.string + this.value;
    } else if (pos >= this.size) {
        this.value = this.value + c.string;
    } else {
        this.value = this.value.slice(0, pos) + c.string + this.value.slice(pos);
    }
    return this;
}
StringBuilder$proto.$delete = function(pos, count) {
    if (pos < 0) pos=0; else if (pos>this.size) return this;
    if (count > 0) {
        this.value = this.value.slice(0, pos) + this.value.slice(pos+count);
    }
    return this;
}

exports.String=String$;
exports.Character=Character;
exports.StringBuilder=StringBuilder;
var minRadix$936;function $valinit$minRadix$936(){if (minRadix$936===undefined)minRadix$936=(2);return minRadix$936;};$valinit$minRadix$936();
function getMinRadix(){return $valinit$minRadix$936();}
exports.getMinRadix=getMinRadix;
var $prop$getMinRadix={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','minRadix']};}};
exports.$prop$getMinRadix=$prop$getMinRadix;
$prop$getMinRadix.get=getMinRadix;
getMinRadix.$$metamodel$$=$prop$getMinRadix.$$metamodel$$;
var maxRadix$937;function $valinit$maxRadix$937(){if (maxRadix$937===undefined)maxRadix$937=(36);return maxRadix$937;};$valinit$maxRadix$937();
function getMaxRadix(){return $valinit$maxRadix$937();}
exports.getMaxRadix=getMaxRadix;
var $prop$getMaxRadix={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','maxRadix']};}};
exports.$prop$getMaxRadix=$prop$getMaxRadix;
$prop$getMaxRadix.get=getMaxRadix;
getMaxRadix.$$metamodel$$=$prop$getMaxRadix.$$metamodel$$;
function parseInteger(string$938,radix$939){
    if(radix$939===undefined){radix$939=(10);}
    //assert at parseInteger.ceylon (32:4-32:49)
    if (!((radix$939.compare(getMinRadix())!==getSmaller())&&(radix$939.compare(getMaxRadix())!==getLarger()))) {throw wrapexc(AssertionException("Assertion failed: \'radix >= minRadix, radix <= maxRadix\' at parseInteger.ceylon (32:11-32:48)"),'32:4-32:49','parseInteger.ceylon'); }
    var ii$940=(0);
    function setIi$940(ii$941){return ii$940=ii$941;};
    $prop$getIi$940={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','parseInteger','$at','ii']};}};
    $prop$getIi$940.get=function(){return ii$940};
    $prop$getIi$940.set=setIi$940;
    if (setIi$940.$$metamodel$$===undefined)setIi$940.$$metamodel$$=$prop$getIi$940.$$metamodel$$;
    var max$942=getRuntime().minIntegerValue.divided(radix$939);
    $prop$getMax$942={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','parseInteger','$at','max']};}};
    $prop$getMax$942.get=function(){return max$942};
    var negative$943;
    $prop$getNegative$943={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','parseInteger','$at','negative']};}};
    $prop$getNegative$943.get=function(){return negative$943};
    var char$944;
    if((char$944=string$938.$get(ii$940))!==null){
        if(char$944.equals(Character(45))){
            negative$943=true;
            (oldii$945=ii$940,ii$940=oldii$945.successor,oldii$945);
            var oldii$945;
        }else {
            if(char$944.equals(Character(43))){
                negative$943=false;
                (oldii$946=ii$940,ii$940=oldii$946.successor,oldii$946);
                var oldii$946;
            }else {
                negative$943=false;
            }
        }
    }else {
        return null;
    }
    var limit$947=(opt$948=(negative$943?getRuntime().minIntegerValue:null),opt$948!==null?opt$948:(-getRuntime().maxIntegerValue));
    $prop$getLimit$947={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','parseInteger','$at','limit']};}};
    $prop$getLimit$947.get=function(){return limit$947};
    var opt$948;
    var length$949=string$938.size;
    $prop$getLength$949={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','parseInteger','$at','length']};}};
    $prop$getLength$949.get=function(){return length$949};
    var result$950=(0);
    function setResult$950(result$951){return result$950=result$951;};
    $prop$getResult$950={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','parseInteger','$at','result']};}};
    $prop$getResult$950.get=function(){return result$950};
    $prop$getResult$950.set=setResult$950;
    if (setResult$950.$$metamodel$$===undefined)setResult$950.$$metamodel$$=$prop$getResult$950.$$metamodel$$;
    var sep$952=(-(1));
    function setSep$952(sep$953){return sep$952=sep$953;};
    $prop$getSep$952={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','parseInteger','$at','sep']};}};
    $prop$getSep$952.get=function(){return sep$952};
    $prop$getSep$952.set=setSep$952;
    if (setSep$952.$$metamodel$$===undefined)setSep$952.$$metamodel$$=$prop$getSep$952.$$metamodel$$;
    var digitIndex$954=(0);
    function setDigitIndex$954(digitIndex$955){return digitIndex$954=digitIndex$955;};
    $prop$getDigitIndex$954={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','parseInteger','$at','digitIndex']};}};
    $prop$getDigitIndex$954.get=function(){return digitIndex$954};
    $prop$getDigitIndex$954.set=setDigitIndex$954;
    if (setDigitIndex$954.$$metamodel$$===undefined)setDigitIndex$954.$$metamodel$$=$prop$getDigitIndex$954.$$metamodel$$;
    var groupingSize$956=(-(1));
    function setGroupingSize$956(groupingSize$957){return groupingSize$956=groupingSize$957;};
    $prop$getGroupingSize$956={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','parseInteger','$at','groupingSize']};}};
    $prop$getGroupingSize$956.get=function(){return groupingSize$956};
    $prop$getGroupingSize$956.set=setGroupingSize$956;
    if (setGroupingSize$956.$$metamodel$$===undefined)setGroupingSize$956.$$metamodel$$=$prop$getGroupingSize$956.$$metamodel$$;
    while(ii$940.compare(length$949).equals(getSmaller())){
        var ch$958;
        $prop$getCh$958={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Character},d:['ceylon.language','parseInteger','$at','ch']};}};
        $prop$getCh$958.get=function(){return ch$958};
        var char$959;
        if((char$959=string$938.$get(ii$940))!==null){
            ch$958=char$959;
        }else {
            return null;
        }
        if(ch$958.equals(Character(95))){
            if(sep$952.equals((-(1)))){
                var digitGroupSize$960;
                if((digitGroupSize$960=computeDigitGroupingSize(radix$939,digitIndex$954,string$938,ii$940))!==null&&(digitIndex$954.compare(digitGroupSize$960)!==getLarger())){
                    groupingSize$956=digitGroupSize$960;
                    sep$952=digitIndex$954;
                }else {
                    return null;
                }
            }else {
                if(digitIndex$954.minus(sep$952).equals(groupingSize$956)){
                    return null;
                }else {
                    sep$952=digitIndex$954;
                }
            }
        }else {
            if(((!sep$952.equals((-(1))))&&digitIndex$954.minus(sep$952).equals(groupingSize$956.plus((1))))){
                return null;
            }
            if(((ii$940.plus((1)).equals(length$949)&&radix$939.equals((10)))&&Tuple(Character(107),Tuple(Character(77),Tuple(Character(71),Tuple(Character(84),Tuple(Character(80),getEmpty(),{Rest:{t:Empty},First:{t:Character},Element:{t:Character}}),{Rest:{t:'T', l:[{t:Character}]},First:{t:Character},Element:{t:Character}}),{Rest:{t:'T', l:[{t:Character},{t:Character}]},First:{t:Character},Element:{t:Character}}),{Rest:{t:'T', l:[{t:Character},{t:Character},{t:Character}]},First:{t:Character},Element:{t:Character}}),{Rest:{t:'T', l:[{t:Character},{t:Character},{t:Character},{t:Character}]},First:{t:Character},Element:{t:Character}}).contains(ch$958))){
                var magnitude$961;
                if((magnitude$961=computeMagnitude(radix$939,string$938.$get((oldii$962=ii$940,ii$940=oldii$962.successor,oldii$962))))!==null){
                    if(limit$947.divided(magnitude$961).compare(result$950).equals(getSmaller())){
                        (result$950=result$950.times(magnitude$961));
                        break;
                    }else {
                        return null;
                    }
                }else {
                    return null;
                }
                var oldii$962;
            }else {
                var digit$963;
                if((digit$963=parseDigit(ch$958,radix$939))!==null){
                    if(result$950.compare(max$942).equals(getSmaller())){
                        return null;
                    }
                    (result$950=result$950.times(radix$939));
                    if(result$950.compare(limit$947.plus(digit$963)).equals(getSmaller())){
                        return null;
                    }
                    (result$950=result$950.minus(digit$963));
                }else {
                    return null;
                }
            }
        }
        (oldii$964=ii$940,ii$940=oldii$964.successor,oldii$964);
        var oldii$964;
        (olddigitIndex$965=digitIndex$954,digitIndex$954=olddigitIndex$965.successor,olddigitIndex$965);
        var olddigitIndex$965;
    }
    if(((!sep$952.equals((-(1))))&&(!digitIndex$954.minus(sep$952).equals(groupingSize$956.plus((1)))))){
        return null;
    }
    if(digitIndex$954.equals((0))){
        return null;
    }
    return (opt$966=(negative$943?result$950:null),opt$966!==null?opt$966:(-result$950));
    var opt$966;
}
exports.parseInteger=parseInteger;
parseInteger.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Integer}]},$ps:[{$nm:'string',$mt:'prm',$t:{t:String$},$an:function(){return[];}},{$nm:'radix',$mt:'prm',$def:1,$t:{t:Integer},$an:function(){return[];}}],$an:function(){return[doc(String$("The `Integer` value of the given string representation \nof an integer, or `null` if the string does not represent \nan integer or if the mathematical integer it represents \nis too large in magnitude to be represented by an \n`Integer`.\n\nThe syntax accepted by this function is the same as the \nsyntax for an `Integer` literal in the Ceylon language \nexcept that it may optionally begin with a sign \ncharacter (`+` or `-`).\n\nA radix can be given in input to specify what is the base\nto take in consideration for the parsing. radix has to be\nbetween `minRadix` and `maxRadix` included.\nThe list of available digits starts from `0` to `9` followed\nby `a` to `z`.\nWhen parsing in a specific base, the first `radix` digits\nfrom the available digits list can be used.\nThis function is not case sensitive; `a` and `A` both\ncorrespond to the `a` digit which decimal value is `10`.\n \n`_` character can be used to separate groups of digits\nfor bases 2, 10 and 16 as for `Integer` literal in the\nCeylon language. For any other bases, no grouping is\nsupported.",1046)),$throws($init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),AssertionException),String$("if `radix` is not between `minRadix` and `maxRadix`",51)),shared()];},d:['ceylon.language','parseInteger']};};
function computeDigitGroupingSize(radix$967,digitIndex$968,string$969,ii$970){
    var groupingSize$971;
    if(radix$967.equals((2))){
        groupingSize$971=(4);
    }else {
        if(radix$967.equals((10))){
            groupingSize$971=(3);
        }else {
            if(radix$967.equals((16))){
                var char$972;
                if((digitIndex$968.compare((2))!==getLarger())&&(char$972=string$969.$get(ii$970.plus((3))))!==null&&char$972.equals(Character(95))){
                    groupingSize$971=(2);
                }else {
                    groupingSize$971=(4);
                }
            }else {
                groupingSize$971=null;
            }
        }
    }
    return groupingSize$971;
};computeDigitGroupingSize.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Integer}]},$ps:[{$nm:'radix',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'digitIndex',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'string',$mt:'prm',$t:{t:String$},$an:function(){return[];}},{$nm:'ii',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],d:['ceylon.language','computeDigitGroupingSize']};};
function computeMagnitude(radix$973,char$974){
    var power$975;
    var char$976;
    if((char$976=char$974)!==null){
        if(char$976.equals(Character(80))){
            power$975=(15);
        }else {
            if(char$976.equals(Character(84))){
                power$975=(12);
            }else {
                if(char$976.equals(Character(71))){
                    power$975=(9);
                }else {
                    if(char$976.equals(Character(77))){
                        power$975=(6);
                    }else {
                        if(char$976.equals(Character(107))){
                            power$975=(3);
                        }else {
                            power$975=null;
                        }
                    }
                }
            }
        }
    }else {
        power$975=null;
    }
    var power$977;
    if((power$977=power$975)!==null){
        return radix$973.power(power$977);
    }
    return null;
};computeMagnitude.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Integer}]},$ps:[{$nm:'radix',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'char',$mt:'prm',$t:{t:'u', l:[{t:Null},{t:Character}]},$an:function(){return[];}}],d:['ceylon.language','computeMagnitude']};};
var aInt$978;function $valinit$aInt$978(){if (aInt$978===undefined)aInt$978=Character(97).integer;return aInt$978;};$valinit$aInt$978();
function getAInt(){return $valinit$aInt$978();}
exports.getAInt=getAInt;
var $prop$getAInt={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','aInt']};}};
exports.$prop$getAInt=$prop$getAInt;
$prop$getAInt.get=getAInt;
getAInt.$$metamodel$$=$prop$getAInt.$$metamodel$$;
var zeroInt$979;function $valinit$zeroInt$979(){if (zeroInt$979===undefined)zeroInt$979=Character(48).integer;return zeroInt$979;};$valinit$zeroInt$979();
function getZeroInt(){return $valinit$zeroInt$979();}
exports.getZeroInt=getZeroInt;
var $prop$getZeroInt={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','zeroInt']};}};
exports.$prop$getZeroInt=$prop$getZeroInt;
$prop$getZeroInt.get=getZeroInt;
getZeroInt.$$metamodel$$=$prop$getZeroInt.$$metamodel$$;
function parseDigit(digit$980,radix$981){
    var figure$982;
    var digitInt$983=digit$980.integer;
    if((tmpvar$984=digitInt$983.minus(getZeroInt()),tmpvar$984.compare((0))!==getSmaller()&&tmpvar$984.compare((10))===getSmaller())){
        figure$982=digitInt$983.minus(getZeroInt());
    }else {
        if((tmpvar$985=digitInt$983.minus(getAInt()),tmpvar$985.compare((0))!==getSmaller()&&tmpvar$985.compare((26))===getSmaller())){
            figure$982=digitInt$983.minus(getAInt()).plus((10));
        }else {
            return null;
        }
    }
    return (figure$982.compare(radix$981).equals(getSmaller())?figure$982:null);
};parseDigit.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Integer}]},$ps:[{$nm:'digit',$mt:'prm',$t:{t:Character},$an:function(){return[];}},{$nm:'radix',$mt:'prm',$t:{t:Integer},$an:function(){return[];}}],d:['ceylon.language','parseDigit']};};
function formatInteger(integer$986,radix$987){
    if(radix$987===undefined){radix$987=(10);}
    //assert at parseInteger.ceylon (195:4-195:49)
    if (!((radix$987.compare(getMinRadix())!==getSmaller())&&(radix$987.compare(getMaxRadix())!==getLarger()))) {throw wrapexc(AssertionException("Assertion failed: \'radix >= minRadix, radix <= maxRadix\' at parseInteger.ceylon (195:11-195:48)"),'195:4-195:49','parseInteger.ceylon'); }
    if(integer$986.equals((0))){
        return String$("0",1);
    }
    var digits$988=StringBuilder();
    $prop$getDigits$988={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:StringBuilder},d:['ceylon.language','formatInteger','$at','digits']};}};
    $prop$getDigits$988.get=function(){return digits$988};
    var insertIndex$989;
    $prop$getInsertIndex$989={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','formatInteger','$at','insertIndex']};}};
    $prop$getInsertIndex$989.get=function(){return insertIndex$989};
    var i$990;
    function setI$990(i$991){return i$990=i$991;};
    $prop$getI$990={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},$an:function(){return[variable()];},d:['ceylon.language','formatInteger','$at','i']};}};
    $prop$getI$990.get=function(){return i$990};
    $prop$getI$990.set=setI$990;
    if (setI$990.$$metamodel$$===undefined)setI$990.$$metamodel$$=$prop$getI$990.$$metamodel$$;
    if(integer$986.compare((0)).equals(getSmaller())){
        digits$988.append(String$("-",1));
        insertIndex$989=(1);
        i$990=integer$986;
    }else {
        insertIndex$989=(0);
        i$990=(-integer$986);
    }
    while((!i$990.equals((0)))){
        var d$992=(-i$990.remainder(radix$987));
        $prop$getD$992={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','formatInteger','$at','d']};}};
        $prop$getD$992.get=function(){return d$992};
        var c$993;
        $prop$getC$993={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Character},d:['ceylon.language','formatInteger','$at','c']};}};
        $prop$getC$993.get=function(){return c$993};
        if((tmpvar$994=d$992,tmpvar$994.compare((0))!==getSmaller()&&tmpvar$994.compare((10))===getSmaller())){
            c$993=d$992.plus(getZeroInt()).character;
        }else {
            if((tmpvar$995=d$992,tmpvar$995.compare((10))!==getSmaller()&&tmpvar$995.compare((36))===getSmaller())){
                c$993=d$992.minus((10)).plus(getAInt()).character;
            }else {
                //assert at parseInteger.ceylon (220:12-220:26)
                if (!(false)) {throw wrapexc(AssertionException("Assertion failed: \'false\' at parseInteger.ceylon (220:19-220:25)"),'220:12-220:26','parseInteger.ceylon'); }
            }
        }
        digits$988.insertCharacter(insertIndex$989,c$993);
        i$990=i$990.plus(d$992).divided(radix$987);
    }
    return digits$988.string;
}
exports.formatInteger=formatInteger;
formatInteger.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:String$},$ps:[{$nm:'integer',$mt:'prm',$t:{t:Integer},$an:function(){return[];}},{$nm:'radix',$mt:'prm',$def:1,$t:{t:Integer},$an:function(){return[];}}],$an:function(){return[doc(String$("The string representation of `integer` in the `radix` base.\n`radix` must be between `minRadix` and `maxRadix` included.\n\nIf `integer` is negative, returned string will start by character `-`",190)),$throws($init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),AssertionException),String$("if `radix` is not between `minRadix` and `maxRadix`",51)),shared()];},d:['ceylon.language','formatInteger']};};
function parseBoolean(string$996){
    
    var case$997=string$996;
    if (case$997.equals(String$("true",4))) {
        return true;
    }else if (case$997.equals(String$("false",5))) {
        return false;
    }else {
        return null;
    }
}
exports.parseBoolean=parseBoolean;
parseBoolean.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Boolean$}]},$ps:[{$nm:'string',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$an:function(){return[doc(String$("The `Boolean` value of the given string representation of a boolean value,\nor `null` if the string does not represent a boolean value.\n\nRecognized values are \"true\", \"false\".",174)),shared()];},d:['ceylon.language','parseBoolean']};};
function Annotated($$annotated){
}
Annotated.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$an:function(){return[doc(String$("A program element that can\nbe annotated.",40)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Annotation)].reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','Annotated']};};
exports.Annotated=Annotated;
function $init$Annotated(){
    if (Annotated.$$===undefined){
        initTypeProtoI(Annotated,'ceylon.language::Annotated');
    }
    return Annotated;
}
exports.$init$Annotated=$init$Annotated;
$init$Annotated();
function Annotation($$annotation){
}
Annotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,of:[{t:ConstrainedAnnotation,a:{Values:{t:Anything},Value:{t:Annotation},ProgramElement:{t:Nothing}}}],$an:function(){return[doc(String$("The supertype of all *annotation classes*. \n\n### Annotation classes\n\nAn *annotation class* must satisfy `Annotation`,\n[[OptionalAnnotation]],  or [[SequencedAnnotation]] and must be \nannotated `final annotation`. For example:\n\n    \"An annotation class.\"\n    final annotation class Example(shared String description) \n          satisfies Annotation {}\n\nAnnotation classes which satisfy `Annotation` directly may be applied \nto any program element that supports annotations (see [[Annotated]]). \nIn practice, annotation classes often satisfy [[OptionalAnnotation]] \nor [[SequencedAnnotation]] in order to prevent annotations being \napplied to inappropriate program elements.\n\nEach initializer parameter of an annotation class must have one of the \nfollowing types:\n\n* `Integer`, `Float`, `Character`, or `String`,\n* an enumerated type whose cases are all anonymous classes, \n  such as `Boolean`,\n* a subtype of [[ceylon.language.meta.declaration::Declaration]]\n* an annotation class,\n* `{T*}` or `[T*]` where `T` is a legal annotation parameter type, or\n* any tuple type whose element types are legal annotation parameter types.\n\nAn initializer parameter of an annotation class may be variadic \nor defaulted.\n\n### Annotation constructors\n\nAn *annotation constructor* is simply a top level function, annotated with \n`annotation` whose return type is an annotation class type. For example:\n\n    \"An annotation constructor.\"\n    annotation Example example(String description=\"\") \n        => Example(description);\n\nEach parameter of an annotation constructor must have one of the \nfollowing types:\n\n* `Integer`, `Float`, `Character`, or `String`,\n* an enumerated type whose cases are all anonymous classes, \n  such as `Boolean`,\n* a subtype of [[ceylon.language.meta.declaration::Declaration]],\n* an annotation type,\n* `{T*}` or `[T*]` where `T` is a legal annotation constructor parameter \n  type, or\n* any tuple type whose element types are legal annotation constructor \n  parameter types.\n\nA parameter of an annotation constructor may be variadic or defaulted.\n\nThe constructor must simply instantiate and return the annotation class, \nand there are strict rules about the arguments to the instantiation.\n\nAn annotation class can have multiple annotation constructors.\n",2266)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),OptionalAnnotation),$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),SequencedAnnotation),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language.meta'),annotations$meta),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language.meta'),optionalAnnotation$meta),$init$OpenFunction()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language.meta'),sequencedAnnotations$meta)].reifyCeylonType({Absent:{t:Null},Element:{t:'u', l:[{t:InterfaceDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration}]}})),shared()];},d:['ceylon.language','Annotation']};};
exports.Annotation=Annotation;
function $init$Annotation(){
    if (Annotation.$$===undefined){
        initTypeProtoI(Annotation,'ceylon.language::Annotation');
    }
    return Annotation;
}
exports.$init$Annotation=$init$Annotation;
$init$Annotation();
function ConstrainedAnnotation($$targs$$,$$constrainedAnnotation){
    Annotation($$constrainedAnnotation);
    set_type_args($$constrainedAnnotation,$$targs$$);
}
ConstrainedAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Value:{'var':'out','satisfies':[{t:Annotation}],'def':{t:Annotation}},Values:{'var':'out','def':{t:Anything}},ProgramElement:{'var':'in','satisfies':[{t:Annotated}],'def':{t:Nothing}}},satisfies:[{t:Annotation}],of:['Value'],$an:function(){return[doc(String$("An annotation constrained to appear only on certain \nprogram elements, and only with certain values. \n\nThis interface should not be satisfied directly. \nInstead either [[OptionalAnnotation]] or [[SequencedAnnotation]] \nshould be satisfied.",239)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Annotation)].reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','ConstrainedAnnotation']};};
exports.ConstrainedAnnotation=ConstrainedAnnotation;
function $init$ConstrainedAnnotation(){
    if (ConstrainedAnnotation.$$===undefined){
        initTypeProtoI(ConstrainedAnnotation,'ceylon.language::ConstrainedAnnotation',$init$Annotation());
        (function($$constrainedAnnotation){
            $$constrainedAnnotation.occurs=function (programElement$998){
                var $$constrainedAnnotation=this;
                return isOfType(programElement$998,$$constrainedAnnotation.$$targs$$.ProgramElement);
            };
            $$constrainedAnnotation.occurs.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'programElement',$mt:'prm',$t:{t:Annotated},$an:function(){return[];}}],$cont:ConstrainedAnnotation,$an:function(){return[doc(String$("Can this annotation can occur on the given program \nelement?",60)),shared()];},d:['ceylon.language','ConstrainedAnnotation','$m','occurs']};};
        })(ConstrainedAnnotation.$$.prototype);
    }
    return ConstrainedAnnotation;
}
exports.$init$ConstrainedAnnotation=$init$ConstrainedAnnotation;
$init$ConstrainedAnnotation();
function OptionalAnnotation($$targs$$,$$optionalAnnotation){
    ConstrainedAnnotation($$optionalAnnotation.$$targs$$===undefined?$$targs$$:{Values:{t:'u', l:[{t:Null},$$optionalAnnotation.$$targs$$.Value]},Value:$$optionalAnnotation.$$targs$$.Value,ProgramElement:$$optionalAnnotation.$$targs$$.ProgramElement},$$optionalAnnotation);
    set_type_args($$optionalAnnotation,$$targs$$);
}
OptionalAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Value:{'var':'out','satisfies':[{t:OptionalAnnotation,a:{Value:'Value',ProgramElement:'ProgramElement'}}]},ProgramElement:{'var':'in','satisfies':[{t:Annotated}],'def':{t:Annotated}}},satisfies:[{t:ConstrainedAnnotation,a:{Values:{t:'u', l:[{t:Null},'Value']},Value:'Value',ProgramElement:'ProgramElement'}}],of:['Value'],$an:function(){return[doc(String$("An annotation that may occur at most once at a single program element and \nonly on certain program elements.\n\nAn optional annotation is declared simply by having the annotation class\nsatisfy OptionalAnnotation instead of [[Annotation]]. For example \nthe following would only be allowed on `class` declarations:\n\n    final annotation class ExampleClass() \n            satisfies OptionalAnnotation<Example, ClassDeclaration> {}\n\nAt runtime a [[ceylon.language.meta.declaration::Declaration]] instance \ncan be queried for its `OptionalAnnotation`s of a certain type using \n[[ceylon.language.meta::annotations]] or [[ceylon.language.meta::optionalAnnotation]].\n",657)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Annotation)].reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','OptionalAnnotation']};};
exports.OptionalAnnotation=OptionalAnnotation;
function $init$OptionalAnnotation(){
    if (OptionalAnnotation.$$===undefined){
        initTypeProtoI(OptionalAnnotation,'ceylon.language::OptionalAnnotation',$init$ConstrainedAnnotation());
    }
    return OptionalAnnotation;
}
exports.$init$OptionalAnnotation=$init$OptionalAnnotation;
$init$OptionalAnnotation();
function SequencedAnnotation($$targs$$,$$sequencedAnnotation){
    ConstrainedAnnotation($$sequencedAnnotation.$$targs$$===undefined?$$targs$$:{Values:{t:Sequential,a:{Element:$$sequencedAnnotation.$$targs$$.Value}},Value:$$sequencedAnnotation.$$targs$$.Value,ProgramElement:$$sequencedAnnotation.$$targs$$.ProgramElement},$$sequencedAnnotation);
    add_type_arg($$sequencedAnnotation,'Values',{t:Sequential,a:{Element:$$sequencedAnnotation.$$targs$$.Value}});
    set_type_args($$sequencedAnnotation,$$targs$$);
}
SequencedAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Value:{'var':'out','satisfies':[{t:SequencedAnnotation,a:{Value:'Value',ProgramElement:'ProgramElement'}}]},ProgramElement:{'var':'in','satisfies':[{t:Annotated}],'def':{t:Annotated}}},satisfies:[{t:ConstrainedAnnotation,a:{Values:{t:Sequential,a:{Element:'Value'}},Value:'Value',ProgramElement:'ProgramElement'}}],of:['Value'],$an:function(){return[doc(String$("An annotation that may occur multiple times at a single program element, \nand only on certain program elemenets.\n\nA sequenced annotation is declared simply by having the annotation class\nsatisfy SequencedAnnotation instead of [[Annotation]]. For example \nthe following would only be allowed on `class` declarations, \nfunctions or methods:\n\n    alias ExecutableDeclaration \n           => ClassOrInterfaceDeclaration|FunctionDeclaration\n    \"Documents a pattern that the annotated element is particpating in\"\n    final annotation class Pattern(String name) \n            satisfies SequencedAnnotation<Pattern, ExecutableDeclaration> {\n    }\n\nAt runtime a [[ceylon.language.meta.declaration::Declaration]] instance \ncan be queried for its `SequencedAnnotation`s of a certain type using \n[[ceylon.language.meta::annotations]] or [[ceylon.language.meta::sequencedAnnotations]].\n",872)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Annotation)].reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceDeclaration$meta$declaration}})),shared()];},d:['ceylon.language','SequencedAnnotation']};};
exports.SequencedAnnotation=SequencedAnnotation;
function $init$SequencedAnnotation(){
    if (SequencedAnnotation.$$===undefined){
        initTypeProtoI(SequencedAnnotation,'ceylon.language::SequencedAnnotation',$init$ConstrainedAnnotation());
    }
    return SequencedAnnotation;
}
exports.$init$SequencedAnnotation=$init$SequencedAnnotation;
$init$SequencedAnnotation();
function optionalAnnotation$meta(annotationType$999,programElement$1000,$$$mptypes){
    return annotations$meta(annotationType$999,programElement$1000,{Values:{t:'u', l:[{t:Null},$$$mptypes.Value]},Value:$$$mptypes.Value,ProgramElement:$$$mptypes.ProgramElement});
}
exports.optionalAnnotation$meta=optionalAnnotation$meta;
optionalAnnotation$meta.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Value']},$ps:[{$nm:'annotationType',$mt:'prm',$t:{t:Class$meta$model,a:{Arguments:{t:Nothing},Type:{t:OptionalAnnotation,a:{Value:'Value',ProgramElement:'ProgramElement'}}}},$an:function(){return[];}},{$nm:'programElement',$mt:'prm',$t:'ProgramElement',$an:function(){return[];}}],$tp:{Value:{'satisfies':[{t:OptionalAnnotation,a:{Value:'Value',ProgramElement:'ProgramElement'}}]},ProgramElement:{'var':'in','satisfies':[{t:Annotated}]}},$an:function(){return[doc(String$("The value of given optional annotation type on the given program element, \nor null if the program element was not annotated with that annotation type.\nFor example:\n\n    // Does the process declaration have the Shared annotation?\n    value isShared = optionalAnnotation(`Shared`, `value process`) exists;\n",304)),shared()];},d:['ceylon.language.meta','optionalAnnotation']};};
function sequencedAnnotations$meta(annotationType$1001,programElement$1002,$$$mptypes){
    return annotations$meta(annotationType$1001,programElement$1002,{Values:{t:Sequential,a:{Element:$$$mptypes.Value}},Value:$$$mptypes.Value,ProgramElement:$$$mptypes.ProgramElement});
}
exports.sequencedAnnotations$meta=sequencedAnnotations$meta;
sequencedAnnotations$meta.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Value'}},$ps:[{$nm:'annotationType',$mt:'prm',$t:{t:Class$meta$model,a:{Arguments:{t:Nothing},Type:{t:SequencedAnnotation,a:{Value:'Value',ProgramElement:'ProgramElement'}}}},$an:function(){return[];}},{$nm:'programElement',$mt:'prm',$t:'ProgramElement',$an:function(){return[];}}],$tp:{Value:{'satisfies':[{t:SequencedAnnotation,a:{Value:'Value',ProgramElement:'ProgramElement'}}]},ProgramElement:{'var':'in','satisfies':[{t:Annotated}]}},$an:function(){return[doc(String$("The values of given sequenced annotation type on the given program element, \nor empty if the program element was not annotated with that annotation type.\nFor example:\n\n    // Does the sum declaration have any ThrownException annotations?\n    value throwsSomething = sequencedAnnotation(`ThrownException`, `function sum`) nonempty;\n\nThe annotations may be returned in any order.\n",378)),shared()];},d:['ceylon.language.meta','sequencedAnnotations']};};
function modules$1003$meta(){
    var $$modules=new modules$1003$meta.$$;
    $$modules.$prop$getList={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:Module$meta$declaration}}},$cont:modules$1003$meta,$an:function(){return[doc(String$("Returns the list of all currently loaded modules. This may include modules that\nwere not imported directly but your module, and multiple versions of the same\nmodule.",165)),shared(),$native()];},d:['ceylon.language.meta','modules','$at','list']};}};
    $$modules.$prop$getDefault={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Module$meta$declaration}]},$cont:modules$1003$meta,$an:function(){return[doc(String$("Returns the default module, if there is one. This is only the case when\nyou are running the default module.",107)),shared(),$native()];},d:['ceylon.language.meta','modules','$at','default']};}};
    return $$modules;
};modules$1003$meta.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$an:function(){return[doc("Represents the list of Ceylon modules currently loaded at runtime.\n\nNote that this contains all loaded modules, including those that are\nnot imported by your module.\n\nSince Ceylon supports module isolation at runtime, it is possible that\nthere are more than one version of a given module loaded at the same time.\n\n### Usage example\n\nHere\'s how you would iterate all the loaded modules and print their name and version:\n\n    import ceylon.language.meta { modules }\n\n    for(mod in modules.list){\n        print(\"Module: ``mod.name``/``mod.version``\");\n    }\n"),shared(),$native()];},d:['ceylon.language.meta','modules']};};
function $init$modules$1003$meta(){
    if (modules$1003$meta.$$===undefined){
        initTypeProto(modules$1003$meta,'ceylon.language.meta::modules',Basic);
        (function($$modules){
        })(modules$1003$meta.$$.prototype);
    }
    return modules$1003$meta;
}
exports.$init$modules$1003$meta=$init$modules$1003$meta;
$init$modules$1003$meta();
var modules$1004$meta;
function getModules$meta(){
    if (modules$1004$meta===undefined){modules$1004$meta=$init$modules$1003$meta()();modules$1004$meta.$$metamodel$$=getModules$meta.$$metamodel$$;}
    return modules$1004$meta;
}
exports.getModules$meta=getModules$meta;
getModules$meta.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:modules$1003$meta},$an:function(){return[doc(String$("Represents the list of Ceylon modules currently loaded at runtime.\n\nNote that this contains all loaded modules, including those that are\nnot imported by your module.\n\nSince Ceylon supports module isolation at runtime, it is possible that\nthere are more than one version of a given module loaded at the same time.\n\n### Usage example\n\nHere\'s how you would iterate all the loaded modules and print their name and version:\n\n    import ceylon.language.meta { modules }\n\n    for(mod in modules.list){\n        print(\"Module: ``mod.name``/``mod.version``\");\n    }\n",556)),shared(),$native()];},d:['ceylon.language.meta','modules']};};
$prop$getModules$meta={get:getModules$meta,$$metamodel$$:getModules$meta.$$metamodel$$};
exports.$prop$getModules$meta=$prop$getModules$meta;
function ValueModel$meta$model($$targs$$,$$valueModel){
    Model$meta$model($$valueModel);
    set_type_args($$valueModel,$$targs$$);
}
ValueModel$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Get:{'var':'out','def':{t:Anything}},Set:{'var':'in','def':{t:Nothing}}},satisfies:[{t:Model$meta$model}],$an:function(){return[doc(String$("A value model represents the model of a Ceylon value that you can inspect.\n\nA value model can be either a toplevel [[Value]] or a member [[Attribute]].\n",152)),shared()];},d:['ceylon.language.meta.model','ValueModel']};};
exports.ValueModel$meta$model=ValueModel$meta$model;
function $init$ValueModel$meta$model(){
    if (ValueModel$meta$model.$$===undefined){
        initTypeProtoI(ValueModel$meta$model,'ceylon.language.meta.model::ValueModel',$init$Model$meta$model());
        (function($$valueModel){
            $$valueModel.$prop$getDeclaration={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:ValueDeclaration$meta$declaration},$cont:ValueModel$meta$model,$an:function(){return[doc(String$("This value\'s declaration.",25)),shared(),formal(),actual()];},d:['ceylon.language.meta.model','ValueModel','$at','declaration']};}};
            $$valueModel.$prop$getType={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Type$meta$model,a:{Type:'Get'}},$cont:ValueModel$meta$model,$an:function(){return[doc(String$("This value\'s closed type.",25)),shared(),formal()];},d:['ceylon.language.meta.model','ValueModel','$at','type']};}};
        })(ValueModel$meta$model.$$.prototype);
    }
    return ValueModel$meta$model;
}
exports.$init$ValueModel$meta$model=$init$ValueModel$meta$model;
$init$ValueModel$meta$model();
function ClassOrInterface$meta$model($$targs$$,$$classOrInterface){
    Model$meta$model($$classOrInterface);
    Generic$meta$model($$classOrInterface);
    Type$meta$model($$classOrInterface.$$targs$$===undefined?$$targs$$:{Type:$$classOrInterface.$$targs$$.Type},$$classOrInterface);
    set_type_args($$classOrInterface,$$targs$$);
}
ClassOrInterface$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Type:{'var':'out','def':{t:Anything}}},satisfies:[{t:Model$meta$model},{t:Generic$meta$model},{t:Type$meta$model,a:{Type:'Type'}}],of:[{t:ClassModel$meta$model,a:{Arguments:{t:Nothing},Type:'Type'}},{t:InterfaceModel$meta$model,a:{Type:'Type'}}],$an:function(){return[doc(String$("Model of a class or interface that you can inspect.\n\nThe models of classes and interfaces are also closed types.",112)),shared()];},d:['ceylon.language.meta.model','ClassOrInterface']};};
exports.ClassOrInterface$meta$model=ClassOrInterface$meta$model;
function $init$ClassOrInterface$meta$model(){
    if (ClassOrInterface$meta$model.$$===undefined){
        initTypeProtoI(ClassOrInterface$meta$model,'ceylon.language.meta.model::ClassOrInterface',$init$Model$meta$model(),$init$Generic$meta$model(),$init$Type$meta$model());
        (function($$classOrInterface){
            $$classOrInterface.$prop$getDeclaration={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:ClassOrInterfaceDeclaration$meta$declaration},$cont:ClassOrInterface$meta$model,$an:function(){return[doc(String$("The declaration for this class or interface.",44)),shared(),formal(),actual()];},d:['ceylon.language.meta.model','ClassOrInterface','$at','declaration']};}};
            $$classOrInterface.$prop$getExtendedType={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:ClassModel$meta$model,a:{Arguments:{t:Nothing},Type:{t:Anything}}}]},$cont:ClassOrInterface$meta$model,$an:function(){return[doc(String$("The extended closed type for this class or interface. Note that the [[Anything|ceylon.language::Anything]] type\nhas no extended type since it is the top of the type hierarchy.",175)),shared(),formal()];},d:['ceylon.language.meta.model','ClassOrInterface','$at','extendedType']};}};
            $$classOrInterface.$prop$getSatisfiedTypes={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:InterfaceModel$meta$model,a:{Type:{t:Anything}}}}},$cont:ClassOrInterface$meta$model,$an:function(){return[doc(String$("The list of closed types that this class or interface satisfies.",64)),shared(),formal()];},d:['ceylon.language.meta.model','ClassOrInterface','$at','satisfiedTypes']};}};
            $$classOrInterface.getClassOrInterface={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Member$meta$model,a:{Container:'Container',Kind:'Kind'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}},{$nm:'types',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{'def':{t:Nothing}},Kind:{'satisfies':[{t:ClassOrInterface$meta$model,a:{Type:{t:Anything}}}],'def':{t:ClassOrInterface$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[doc("Gets a member class or interface by name. Returns `null` if not found."),$throws("IncompatibleTypeException","If the specified `Container` or `Kind` type arguments are not compatible with the actual result."),$throws("TypeApplicationException","If the specified closed type argument values are not compatible with the actual result\'s type parameters."),shared(),formal()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getClassOrInterface']};}};$$classOrInterface.getDeclaredClassOrInterface={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Member$meta$model,a:{Container:'Container',Kind:'Kind'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}},{$nm:'types',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{'def':{t:Nothing}},Kind:{'satisfies':[{t:ClassOrInterface$meta$model,a:{Type:{t:Anything}}}],'def':{t:ClassOrInterface$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[doc("Gets a member class or interface by name. Returns `null` if not found."),$throws("IncompatibleTypeException","If the specified `Container` or `Kind` type arguments are not compatible with the actual result."),$throws("TypeApplicationException","If the specified closed type argument values are not compatible with the actual result\'s type parameters."),shared(),formal()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getDeclaredClassOrInterface']};}};$$classOrInterface.getClass={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:MemberClass$meta$model,a:{Arguments:'Arguments',Type:'Type',Container:'Container'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}},{$nm:'types',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{'def':{t:Nothing}},Type:{'def':{t:Anything}},Arguments:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},$an:function(){return[doc("Gets a member class by name. Returns `null` if not found."),$throws("IncompatibleTypeException","If the specified `Container`, `Type` or `Arguments` type arguments are not compatible with the actual result, \nor if the corresponding member is not a `MemberClass`."),$throws("TypeApplicationException","If the specified closed type argument values are not compatible with the actual result\'s type parameters."),shared(),formal()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getClass']};}};$$classOrInterface.getDeclaredClass={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:MemberClass$meta$model,a:{Arguments:'Arguments',Type:'Type',Container:'Container'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}},{$nm:'types',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{'def':{t:Nothing}},Type:{'def':{t:Anything}},Arguments:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},$an:function(){return[doc("Gets a member class by name. Returns `null` if not found."),$throws("IncompatibleTypeException","If the specified `Container`, `Type` or `Arguments` type arguments are not compatible with the actual result, \nor if the corresponding member is not a `MemberClass`."),$throws("TypeApplicationException","If the specified closed type argument values are not compatible with the actual result\'s type parameters."),shared(),formal()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getDeclaredClass']};}};$$classOrInterface.getInterface={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:MemberInterface$meta$model,a:{Type:'Type',Container:'Container'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}},{$nm:'types',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{'def':{t:Nothing}},Type:{'def':{t:Anything}}},$an:function(){return[doc("Gets a member interface by name. Returns `null` if not found."),$throws("IncompatibleTypeException","If the specified `Container` or `Type` type arguments are not compatible with the actual result, \nor if the corresponding member is not a `MemberInterface`."),$throws("TypeApplicationException","If the specified closed type argument values are not compatible with the actual result\'s type parameters."),shared(),formal()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getInterface']};}};$$classOrInterface.getDeclaredInterface={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:MemberInterface$meta$model,a:{Type:'Type',Container:'Container'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}},{$nm:'types',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{'def':{t:Nothing}},Type:{'def':{t:Anything}}},$an:function(){return[doc("Gets a member interface by name. Returns `null` if not found."),$throws("IncompatibleTypeException","If the specified `Container` or `Type` type arguments are not compatible with the actual result, \nor if the corresponding member is not a `MemberInterface`."),$throws("TypeApplicationException","If the specified closed type argument values are not compatible with the actual result\'s type parameters."),shared(),formal()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getDeclaredInterface']};}};$$classOrInterface.getMethod={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Method$meta$model,a:{Arguments:'Arguments',Type:'Type',Container:'Container'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}},{$nm:'types',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{'def':{t:Nothing}},Type:{'def':{t:Anything}},Arguments:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},$an:function(){return[doc("Gets a method by name. Returns `null` if not found."),$throws("IncompatibleTypeException","If the specified `Container`, `Type` or `Arguments` type arguments are not compatible with the actual result."),$throws("TypeApplicationException","If the specified closed type argument values are not compatible with the actual result\'s type parameters."),shared(),formal()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getMethod']};}};$$classOrInterface.getDeclaredMethod={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Method$meta$model,a:{Arguments:'Arguments',Type:'Type',Container:'Container'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}},{$nm:'types',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{'def':{t:Nothing}},Type:{'def':{t:Anything}},Arguments:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},$an:function(){return[doc("Gets a method by name. Returns `null` if not found."),$throws("IncompatibleTypeException","If the specified `Container`, `Type` or `Arguments` type arguments are not compatible with the actual result."),$throws("TypeApplicationException","If the specified closed type argument values are not compatible with the actual result\'s type parameters."),shared(),formal()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getDeclaredMethod']};}};$$classOrInterface.getAttribute={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Attribute$meta$model,a:{Set:'Set',Get:'Get',Container:'Container'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{'def':{t:Nothing}},Get:{'def':{t:Anything}},Set:{'def':{t:Nothing}}},$an:function(){return[doc("Gets an attribute by name. Returns `null` if not found."),$throws("IncompatibleTypeException","If the specified `Container`, `Get` or `Set` type arguments are not compatible with the actual result."),shared(),formal()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getAttribute']};}};$$classOrInterface.getDeclaredAttribute={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Attribute$meta$model,a:{Set:'Set',Get:'Get',Container:'Container'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{'def':{t:Nothing}},Get:{'def':{t:Anything}},Set:{'def':{t:Nothing}}},$an:function(){return[doc("Gets an attribute by name. Returns `null` if not found."),$throws("IncompatibleTypeException","If the specified `Container`, `Get` or `Set` type arguments are not compatible with the actual result."),shared(),formal()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getDeclaredAttribute']};}};
        })(ClassOrInterface$meta$model.$$.prototype);
    }
    return ClassOrInterface$meta$model;
}
exports.$init$ClassOrInterface$meta$model=$init$ClassOrInterface$meta$model;
$init$ClassOrInterface$meta$model();
//Addendum to ClassOrInterface
defineAttr(ClassOrInterface$meta$model.$$.prototype,'satisfiedTypes',function(){
  var ints = this.tipo.$$metamodel$$['satisfies'];
  if (ints && ints.length) {
    var rv = [];
    function resolveTypeArguments(root,type) {
      if (type.a) {
        var t2 = {t:type.t, a:{}};
        for (var targ in type.a) {
          t2.a[targ]=typeof(type.a[targ])==='string' ?
            t2.a[targ]=root.$$targs$$.Type.a[type.a[targ]]
            : t2.a[targ]=type.a[targ];
          if (t2.a[targ] && t2.a[targ].a) {
            t2.a[targ]=resolveTypeArguments(root,t2.a[targ]);
          }
        }
        type=t2;
      }
      return type;
    }
    for (var i=0; i < ints.length; i++) {
      var ifc = resolveTypeArguments(this,ints[i]);
      var mm=ifc.t.$$metamodel$$;
      if (typeof(mm)==='function'){mm=mm();ifc.t.$$metamodel$$=mm;}
      rv.push((mm.$cont?AppliedMemberInterface:AppliedInterface)(ifc.t, {Type:ifc}));
    }
    return rv.reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceModel$meta$model,a:{Type:{t:Anything}}}});
  }
  return getEmpty();
},undefined,function(){
  return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:InterfaceModel$meta$model,a:{Type:{t:Anything}}}}},$cont:ClassOrInterface$meta$model,
  $an:function(){return[shared(),formal()];},d:['ceylon.language.meta.model','ClassOrInterface','$at','satisfiedTypes']};
});
ClassOrInterface$meta$model.$$.prototype.getMethod=function(name,types,$$$mptypes) {
  if (!extendsType($$$mptypes.Container,{t:this.tipo}))throw IncompatibleTypeException$meta$model("Incompatible Container type argument");
  var fun = this.tipo[name];
  if (!fun) fun = this.tipo.$$.prototype[name];
  if (!fun) return null;
  var mm=fun.$$metamodel$$;
  if (typeof(mm)==='function') {
    mm=mm();fun.$$metamodel$$=mm;
  }
  var _t=$$$mptypes.Type;
  var _a=$$$mptypes.Arguments;
  if (mm) {
    if (mm.$t){
      _t=mm.$t;
      if (typeof(_t)==='string') {
        var _ta;
        if (this.$targs && this.$targs[_t])_t=this.$targs[_t];
        else if ($$$mptypes.Container && $$$mptypes.Container.a && $$$mptypes.Container.a[_t])_t=$$$mptypes.Container.a[_t];
        else if (mm.$tp && mm.$tp[_t])_ta=mm.$tp[_t];
        else if (this.tipo.$$metamodel$$.$tp && this.tipo.$$metamodel$$.$tp[_t])_ta=this.tipo.$$metamodel$$.$tp[_t];
        if (_ta && _ta.satisfies)_t=_ta.satisfies.length===1?_ta.satisfies[0]:{t:'i',l:_ta.satisfies};
        if (typeof(_t)==='string')_t={t:Anything};
      }
      if (!extendsType(_t,$$$mptypes.Type))throw IncompatibleTypeException$meta$model("Incompatible Type argument");
    }
    validate$params(mm.$ps,_a,"Wrong number of Arguments for getMethod");
    _a=tupleize$params(mm.$ps);
  }
  return AppliedMethod(fun, types, {Container:{t:this.tipo},Type:_t,Arguments:_a});
}
ClassOrInterface$meta$model.$$.prototype.getMethod.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:Method$meta$model,a:{Arguments:'Arguments',Type:'Type',Container:'Container'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}},{$nm:'types',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{},Type:{},Arguments:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getMethod']};};
ClassOrInterface$meta$model.$$.prototype.getDeclaredMethod=function(name,types,$$$mptypes) {
  var rv=this.getMethod(name,types,$$$mptypes);
  if (rv && rv.tipo) {
    var mm=rv.tipo.$$metamodel$$;
    if (typeof(mm)==='function'){mm=mm();rv.tipo.$$metamodel$$=mm;}
    if (mm && mm.$cont!==this.tipo)return null;
  }
  return rv;
}
ClassOrInterface$meta$model.$$.prototype.getDeclaredMethod.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:Method$meta$model,a:{Arguments:'Arguments',Type:'Type',Container:'Container'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}},{$nm:'types',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{},Type:{},Arguments:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getDeclaredMethod']};};
ClassOrInterface$meta$model.$$.prototype.getAttribute=function getAttribute(name$15,$$$mptypes){
  if (!extendsType($$$mptypes.Container,{t:this.tipo}))throw IncompatibleTypeException$meta$model("Incompatible Container type argument");
  var nom = '$prop$get' + name$15[0].toUpperCase() + name$15.substring(1);
  var at = this.tipo.$$.prototype[nom];
  if (!at)return null;
  var mm=at.$$metamodel$$;
  if (typeof(mm)==='function') {
    mm=mm();at.$$metamodel$$=mm;
  }
  var _t=$$$mptypes.Get;
  if (mm && mm.$t) {
    if (!extendsType(mm.$t,_t))throw IncompatibleTypeException$meta$model("Incompatible Get type argument");
    if (!extendsType($$$mptypes.Set,at.set?mm.$t:{t:Nothing}))throw IncompatibleTypeException$meta$model("Incompatible Set type argument");
    _t=mm.$t;
  }
  var rv=AppliedAttribute(name$15, at, {Get:_t,Set:at.set?_t:{t:Nothing}, Container:{t:this.tipo}});
  if (this.$targs)rv.$$targs$$.Container.a=this.$targs;
  rv.$parent=this;
  return rv;
};
ClassOrInterface$meta$model.$$.prototype.getAttribute.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:Attribute$meta$model,a:{Get:'Get',Set:'Set',Container:'Container'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{},Type:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getAttribute']};};
ClassOrInterface$meta$model.$$.prototype.getDeclaredAttribute=function getDeclaredAttribute(name$15,$$$mptypes){
  var rv=this.getAttribute(name$15,$$$mptypes);
  if (rv && rv.tipo) {
    var mm=rv.tipo.$$metamodel$$;
    if (typeof(mm)==='function'){mm=mm();rv.tipo.$$metamodel$$=mm;}
    if (mm&&mm.$cont!==this.tipo)return null;
  }
  return rv;
};ClassOrInterface$meta$model.$$.prototype.getDeclaredAttribute.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:Attribute$meta$model,a:{Get:'Get',Set:'Set',Container:'Container'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{},Type:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getDeclaredAttribute']};};
defineAttr(ClassOrInterface$meta$model.$$.prototype,'container',function(){
  if (this.$parent)return this.$parent;
  var cont = this.tipo.$$metamodel$$.$cont;
  if (cont === undefined)return null;
  if (get_model(cont.$$metamodel$$).$mt === 'ifc')
    return AppliedInterface(cont,{Type:{t:cont}});
  return AppliedClass(cont,{Type:{t:cont},Arguments:{t:Sequential,a:{Element:{t:Anything}}}});
},undefined,function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:Type$meta$model,a:{Type:{t:Anything}}}]},$cont:ClassOrInterface$meta$model,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Member','$at','container']};});
ClassOrInterface$meta$model.$$.prototype.getClassOrInterface=function getClassOrInterface(name$2,types$3,$$$mptypes,noInherit){
  if (!extendsType($$$mptypes.Kind, {t:ClassOrInterface$meta$model}))throw IncompatibleTypeException$meta$model("Kind must be ClassOrInterface");
  if (!extendsType($$$mptypes.Container,{t:this.tipo}))throw IncompatibleTypeException$meta$model("Incompatible type specified in Container");
  var $$clase=this;
  if(types$3===undefined){types$3=getEmpty();}
  var mm = $$clase.tipo.$$metamodel$$;
  if (typeof(mm)==='function') {
    mm=mm(); $$clase.tipo.$$metamodel$$=mm;
  }
  var nom = name$2 + '$' + mm.d[mm.d.length-1];
  var ic = $$clase.tipo.$$.prototype[nom];
  if (!ic) {
    if (noInherit)return null;
    var pere=mm['super'];
    while (!ic && pere) {
      mm=pere.t.$$metamodel$$;
      if (typeof(mm)==='function'){mm=mm();pere.t.$$metamodel$$=mm;}
      nom=mm&&mm.d?name$2+'$'+mm.d[mm.d.length-1]:undefined;
      if (nom)ic=$$clase.tipo.$$.prototype[nom];
      if (!ic)pere=mm['super'];
    }
  }
  if (ic) {
    mm = ic.$$metamodel$$;
    if (typeof(mm)==='function') {
      mm=mm(); ic.$$metamodel$$=mm;
    }
    var md = get_model(mm);
    var rv;
    var ict={t:ic};
    var _cont={t:this.tipo};
    if (this.$targs)_cont.a=this.$targs;
    if (md.$mt==='ifc') {
      if (!extendsType({t:Interface$meta$model},{t:$$$mptypes.Kind.t}))throw IncompatibleTypeException$meta$model("Member " + name$2 + " is an interface");
      validate$typeparams(ict,ic.$$metamodel$$.$tp,types$3);
      rv=AppliedMemberInterface(ic, {Container:_cont,Type:ict});
    } else if (md.$mt==='cls'){
      if (!extendsType({t:Class$meta$model},{t:$$$mptypes.Kind.t}))throw IncompatibleTypeException$meta$model("Member " + name$2 + " is a class");
      validate$typeparams(ict,ic.$$metamodel$$.$tp,types$3);
      rv=AppliedMemberClass(ic, {Container:_cont,Type:ict, Arguments:$$$mptypes.Arguments});
    } else {
      throw IncompatibleTypeException$meta$model("Member " + name$2 + " is not a class or interface");
    }
    if (ict.a)rv.$targs=ict.a;
    rv.$parent=this;
    return rv;
  }
  return null;
};ClassOrInterface$meta$model.$$.prototype.getClassOrInterface.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:Member$meta$model,a:{Type:'Container',Kind:'Kind'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}},{$nm:'types',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{},Kind:{'satisfies':[{t:ClassOrInterface$meta$model,a:{Type:{t:Anything}}}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getClassOrInterface']};};
ClassOrInterface$meta$model.$$.prototype.getDeclaredClassOrInterface=function getDeclaredClassOrInterface(name$2,types$3,$$$mptypes){
  return this.getClassOrInterface(name$2,types$3,$$$mptypes,1);
};ClassOrInterface$meta$model.$$.prototype.getDeclaredClassOrInterface.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:Member$meta$model,a:{Type:'Container',Kind:'Kind'}}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}},{$nm:'types',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$tp:{Container:{},Kind:{'satisfies':[{t:ClassOrInterface$meta$model,a:{Type:{t:Anything}}}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','ClassOrInterface','$m','getDeclaredClassOrInterface']};};

ClassOrInterface$meta$model.$$.prototype.getClass=function getClass(name,types,$mptypes) {
  var rv=this.getClassOrInterface(name,types,{Container:$mptypes.Container, Kind:Class$meta$model});
  if (rv && !isOfType(rv, {t:AppliedMemberClass})) {
    throw IncompatibleTypeException$meta$model("Member " + name + " is not a class");
  }
  return rv;
};ClassOrInterface$meta$model.$$.prototype.getClass.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:MemberClass$meta$model},$ps:[],$cont:ClassOrInterface$meta$model,$tp:{Container:{},Type:{},Arguments:{satisfies:[{t:Sequential,a:{Element:{t:Anything}}}]}},d:['ceylon.language.meta.model','ClassOrInterface','$m','getClass']};};
ClassOrInterface$meta$model.$$.prototype.getDeclaredClass=function getClass(name,types,$mptypes) {
  var rv=this.getDeclaredClassOrInterface(name,types,{Container:$mptypes.Container, Kind:Class$meta$model});
  if (rv && !isOfType(rv, {t:AppliedMemberClass})) {
    throw IncompatibleTypeException$meta$model("Member " + name + " is not a class");
  }
  return rv;
};ClassOrInterface$meta$model.$$.prototype.getDeclaredClass.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:MemberClass$meta$model},$ps:[],$cont:ClassOrInterface$meta$model,$tp:{Container:{},Type:{},Arguments:{satisfies:[{t:Sequential,a:{Element:{t:Anything}}}]}},d:['ceylon.language.meta.model','ClassOrInterface','$m','getDeclaredClass']};};
ClassOrInterface$meta$model.$$.prototype.getInterface=function(name,types,$mptypes) {
  var rv=this.getClassOrInterface(name,types,{Container:$mptypes.Container, Kind:Interface$meta$model});
  if (rv && !isOfType(rv, {t:AppliedMemberInterface})) {
    throw IncompatibleTypeException$meta$model("Member " + name + " is not an interface");
  }
  return rv;
};ClassOrInterface$meta$model.$$.prototype.getInterface.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:MemberInterface$meta$model},$ps:[],$cont:ClassOrInterface$meta$model,$tp:{Container:{},Type:{},Arguments:{satisfies:[{t:Sequential,a:{Element:{t:Anything}}}]}},d:['ceylon.language.meta.model','ClassOrInterface','$m','getInterface']};};
ClassOrInterface$meta$model.$$.prototype.getDeclaredInterface=function(name,types,$mptypes) {
  var rv=this.getDeclaredClassOrInterface(name,types,{Container:$mptypes.Container, Kind:Interface$meta$model});
  if (rv && !isOfType(rv, {t:AppliedMemberInterface})) {
    throw IncompatibleTypeException$meta$model("Member " + name + " is not an interface");
  }
  return rv;
};ClassOrInterface$meta$model.$$.prototype.getDeclaredInterface.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:MemberInterface$meta$model},$ps:[],$cont:ClassOrInterface$meta$model,$tp:{Container:{},Type:{},Arguments:{satisfies:[{t:Sequential,a:{Element:{t:Anything}}}]}},d:['ceylon.language.meta.model','ClassOrInterface','$m','getDeclaredInterface']};};


ClassOrInterface$meta$model.$$.prototype.typeOf=function typeOf(instance$8){
  var _t={t:this.tipo};
  if (this.$targs)_t.a=this.$targs;
  return isOfType(instance$8,_t);
};
ClassOrInterface$meta$model.$$.prototype.typeOf.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'instance',$mt:'prm',$t:{t:Anything},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Type','$m','typeOf']};};
ClassOrInterface$meta$model.$$.prototype.supertypeOf=function supertypeOf(type$9){
  return extendsType({t:type$9.tipo}, {t:this.tipo});
};
ClassOrInterface$meta$model.$$.prototype.supertypeOf.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'type',$mt:'prm',$t:{t:Type$meta$model,a:{Type:{t:Anything}}},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Type','$m','supertypeOf']};};
ClassOrInterface$meta$model.$$.prototype.exactly=function exactly(type$10){
  return type$10.tipo && this.tipo === type$10.tipo;
};
ClassOrInterface$meta$model.$$.prototype.exactly.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'type',$mt:'prm',$t:{t:Type$meta$model,a:{Type:{t:Anything}}},$an:function(){return[];}}],$cont:ClassOrInterface$meta$model,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Type','$m','exactly']};};
defineAttr(ClassOrInterface$meta$model.$$.prototype,'typeArguments',function(){
  var mm = this.tipo.$$metamodel$$;
  if (typeof(mm)==='function') {
    mm=mm(); this.tipo.$$metamodel$$=mm;
  }
  if (mm) {
    if (mm.$tp) {
      var targs=[];
      for (var tp in mm.$tp) {
        var param = OpenTypeParam(this.tipo,tp);
        var targ;
        if (this.$$targs$$ && this.$$targs$$.Type && this.$$targs$$.Type.a && this.$$targs$$.Type.a[tp]) {
          var _targ=this.$$targs$$.Type.a[tp];
          if (typeof(_targ)==='string') {
            console.log("TODO buscar " + tp + "->" + _targ + " para " + this.declaration.qualifiedName);
            _targ={t:Anything};
          }
          targ=typeLiteral$meta({Type:_targ});
        } else {
          targ=typeLiteral$meta({Type:{t:Anything}});
        }
        targs.push(Entry(param,targ,{Key:{t:TypeParameter$meta$declaration},Item:{t:Type$meta$model,a:{Type:{t:Anything}}}}));
      }
      return LazyMap(targs.reifyCeylonType({Absent:{t:Null},Element:{t:Entry,a:{Key:{t:TypeParameter$meta$declaration},Item:{t:Type$meta$model,a:{Type:{t:Anything}}}}}}), {Key:{t:TypeParameter$meta$declaration},Item:{t:Type$meta$model,a:{Type:{t:Anything}}}});
    }
    return getEmpty();
  }
  throw Exception(String$("ClassOrInterface.typeArguments-we don't have a metamodel!"));
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:{t:TypeParameter$meta$declaration},Item:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$cont:ClassOrInterface$meta$model,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Generic','$at','typeArguments']};});
defineAttr(ClassOrInterface$meta$model.$$.prototype,'string',function(){
    var mm = this.tipo.$$metamodel$$;
    if (typeof(mm)==='function') {
      mm=mm();
      this.tipo.$$metamodel$$=mm;
    }
    var qn=$qname(mm);
    if (mm.$tp) {
      qn+="<";
      var first=true;
      for (var tp in mm.$tp) {
        var targ;
        if (this.$$targs$$ && this.$$targs$$.Type && this.$$targs$$.Type.a && this.$$targs$$.Type.a[tp]) {
          var _targ=this.$$targs$$.Type.a[tp];
          if (typeof(_targ)==='string') {
            console.log("TODO buscar " + tp + "->" + _targ + " para " + this.declaration.qualifiedName);
            _targ={t:Anything};
          }
          targ=typeLiteral$meta({Type:_targ});
        } else {
          targ=typeLiteral$meta({Type:{t:Anything}});
        }
        if (first)first=false; else qn+=",";
        if (targ.declaration) {
          qn+=targ.declaration.qualifiedName;
        } else {
          qn+=targ.string;
        }
      }
      qn+=">";
    }
    return String$(qn);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Object','$at','string']};});
defineAttr(ClassOrInterface$meta$model.$$.prototype,'hash',function(){
  var mm = this.tipo.$$metamodel$$;
  if (typeof(mm)==='function') {
    mm=mm();
    this.tipo.$$metamodel$$=mm;
  }
  var h=String$($qname(mm)).hash;
  if (mm.$tp) {
    for (var tp in mm.$tp) {
      var targ;
      if (this.$$targs$$ && this.$$targs$$.Type && this.$$targs$$.Type.a && this.$$targs$$.Type.a[tp]) {
        var _targ=this.$$targs$$.Type.a[tp];
        if (typeof(_targ)==='string') {
          console.log("TODO buscar " + tp + "->" + _targ + " para " + this.declaration.qualifiedName);
          _targ={t:Anything};
        }
        targ=typeLiteral$meta({Type:_targ});
      } else {
        targ=typeLiteral$meta({Type:{t:Anything}});
      }
      h+=targ.hash;
    }
  }
  if (this.$bound)h+=this.$bound.hash;
  return h;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','Object','$at','hash']};});
defineAttr(ClassOrInterface$meta$model.$$.prototype,'extendedType',function(){
  var sc = this.tipo.$$metamodel$$['super'];
  if (sc === undefined)return null;
  var mm = sc.t.$$metamodel$$;
  if (typeof(mm)==='function') {
    mm = mm();
    sc.t.$$metamodel$$=mm;
  }
  var ac=(mm.$cont?AppliedMemberClass:AppliedClass)(sc.t, {Type:sc,Arguments:{t:Sequential,a:{Element:{t:Anything}}}});
  if (sc.a)ac.$targs=sc.a;
  return ac;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:ClassModel$meta$model,a:{Arguments:{t:Nothing},Type:{t:Anything}}}]},$cont:AppliedClass,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Class','$at','extendedType']};});


function ClassModel$meta$model($$targs$$,$$classModel){
    ClassOrInterface$meta$model($$classModel.$$targs$$===undefined?$$targs$$:{Type:$$classModel.$$targs$$.Type},$$classModel);
    set_type_args($$classModel,$$targs$$);
}
ClassModel$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Type:{'var':'out','def':{t:Anything}},Arguments:{'var':'in','satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},satisfies:[{t:ClassOrInterface$meta$model,a:{Type:'Type'}}],$an:function(){return[doc(String$("A class model represents the model of a Ceylon class that you can inspect.\n\nA class model can be either a toplevel [[Class]] or a member [[MemberClass]].\n",154)),shared()];},d:['ceylon.language.meta.model','ClassModel']};};
exports.ClassModel$meta$model=ClassModel$meta$model;
function $init$ClassModel$meta$model(){
    if (ClassModel$meta$model.$$===undefined){
        initTypeProtoI(ClassModel$meta$model,'ceylon.language.meta.model::ClassModel',$init$ClassOrInterface$meta$model());
        (function($$classModel){
            $$classModel.$prop$getDeclaration={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:ClassDeclaration$meta$declaration},$cont:ClassModel$meta$model,$an:function(){return[shared(),formal(),actual()];},d:['ceylon.language.meta.model','ClassModel','$at','declaration']};}};
            $$classModel.$prop$getParameterTypes={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$cont:ClassModel$meta$model,$an:function(){return[doc(String$("This function\'s parameter closed types",38)),shared(),formal()];},d:['ceylon.language.meta.model','ClassModel','$at','parameterTypes']};}};
        })(ClassModel$meta$model.$$.prototype);
    }
    return ClassModel$meta$model;
}
exports.$init$ClassModel$meta$model=$init$ClassModel$meta$model;
$init$ClassModel$meta$model();
//Addendum to ClassModel
defineAttr(ClassModel$meta$model.$$.prototype,'parameterTypes',function(){
  var ps=this.tipo.$$metamodel$$.$ps;
  if (!ps || ps.length==0)return getEmpty();
  var r=[];
  for (var i=0; i < ps.length; i++) {
    var pt=ps[i].$t;
    if (typeof(pt)==='string'){
      if (!this.$targs)throw TypeApplicationException$meta$model(String$("This class model needs type parameters"));
      pt=this.$targs[pt];
      if (!pt)throw TypeApplicationException$meta$model(String$("Class model is missing type argument for <" + ps[i].$t + ">"));
    }
    r.push(typeLiteral$meta({Type:pt}));
  }
  return r.reifyCeylonType({Element:{t:Type$meta$model,a:{t:Anything}},Absent:{t:Null}});
},undefined,function(){return{mod:$$METAMODEL$$,$cont:ClassModel$meta$model,d:['ceylon.language.meta.model','ClassModel','$at','parameterTypes'],$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}},Absent:{t:Null}}}};});

defineAttr(ClassModel$meta$model.$$.prototype,'declaration',function(){
  var $$clase=this;
  if ($$clase._decl)return $$clase._decl;
  var mm = $$clase.tipo.$$metamodel$$;
  if (typeof(mm)==='function'){
    mm=mm();
    $$clase.tipo.$$metamodel$$=mm;
  }
  $$clase._decl = OpenClass(getModules$meta().find(mm.mod['$mod-name'],mm.mod['$mod-version']).findPackage(mm.d[0]), $$clase.tipo);
  return $$clase._decl;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:ClassDeclaration$meta$declaration},$cont:ClassModel$meta$model,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','ClassModel','$at','declaration']};});
ClassModel$meta$model.$$.prototype.equals=function(o){
return isOfType(o,{t:AppliedClass}) && o.tipo===this.tipo && this.typeArguments.equals(o.typeArguments);
};
ClassModel$meta$model.$$.prototype.equals.$$metamodel$$=function(){return{
  mod:$$METAMODEL$$,d:['ceylon.language','Object','$m','equals'],$t:{t:Boolean$},$ps:[{$nm:'other',$t:{t:Object$},$mt:'prm'}]
}};
function Class$meta$model($$targs$$,$$class){
    ClassModel$meta$model($$class.$$targs$$===undefined?$$targs$$:{Arguments:$$class.$$targs$$.Arguments,Type:$$class.$$targs$$.Type},$$class);
    Callable($$class.$$targs$$===undefined?$$targs$$:{Arguments:$$class.$$targs$$.Arguments,Return:$$class.$$targs$$.Type},$$class);
    set_type_args($$class,$$targs$$);
}
Class$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Type:{'var':'out','def':{t:Anything}},Arguments:{'var':'in','satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},satisfies:[{t:ClassModel$meta$model,a:{Arguments:'Arguments',Type:'Type'}},{t:Callable,a:{Arguments:'Arguments',Return:'Type'}}],$an:function(){return[doc(String$("A class model represents the model of a Ceylon class that you can instantiate and inspect.\n\nA class is a toplevel type, declared on a package.\n\nThis is a [[ClassModel]] that you can also invoke to instantiate new instances of the class:\n\n    shared class Foo(String name){\n        shared String hello => \"Hello \"+name;\n    }\n    \n    void test(){\n        Class<Foo,[String]> c = `Foo`;\n        // This will print: Hello Stef\n        print(c(\"Stef\").hello);\n    }\n",463)),shared()];},d:['ceylon.language.meta.model','Class']};};
exports.Class$meta$model=Class$meta$model;
function $init$Class$meta$model(){
    if (Class$meta$model.$$===undefined){
        initTypeProtoI(Class$meta$model,'ceylon.language.meta.model::Class',$init$ClassModel$meta$model(),$init$Callable());
        (function($$class){
            $$class.$apply={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Type',$ps:[{$nm:'arguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Anything}}},$an:function(){return[];}}],$cont:Class$meta$model,$an:function(){return[doc("Type-unsafe initialiser application, to be used when the argument types are unknown until runtime.\n\nThis has the same behaviour as invoking this `Class` directly, but exchanges compile-time type\nsafety with runtime checks."),$throws("IncompatibleTypeException","If any argument is not assignable to this initialiser\'s corresponding parameter"),$throws("InvocationException","If there are not enough or too many provided arguments"),shared(),formal()];},d:['ceylon.language.meta.model','Class','$m','apply']};}};
        })(Class$meta$model.$$.prototype);
    }
    return Class$meta$model;
}
exports.$init$Class$meta$model=$init$Class$meta$model;
$init$Class$meta$model();
function FunctionModel$meta$model($$targs$$,$$functionModel){
    Model$meta$model($$functionModel);
    Generic$meta$model($$functionModel);
    set_type_args($$functionModel,$$targs$$);
}
FunctionModel$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Type:{'var':'out','def':{t:Anything}},Arguments:{'var':'in','satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},satisfies:[{t:Model$meta$model},{t:Generic$meta$model}],$an:function(){return[doc(String$("A function model represents the model of a Ceylon function that you can inspect.\n\nA function model can be either a toplevel [[Function]] or a member [[Method]].\n",161)),shared()];},d:['ceylon.language.meta.model','FunctionModel']};};
exports.FunctionModel$meta$model=FunctionModel$meta$model;
function $init$FunctionModel$meta$model(){
    if (FunctionModel$meta$model.$$===undefined){
        initTypeProtoI(FunctionModel$meta$model,'ceylon.language.meta.model::FunctionModel',$init$Model$meta$model(),$init$Generic$meta$model());
        (function($$functionModel){
            $$functionModel.$prop$getDeclaration={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:FunctionDeclaration$meta$declaration},$cont:FunctionModel$meta$model,$an:function(){return[doc(String$("This function\'s declaration.",28)),shared(),formal(),actual()];},d:['ceylon.language.meta.model','FunctionModel','$at','declaration']};}};
            $$functionModel.$prop$getType={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Type$meta$model,a:{Type:'Type'}},$cont:FunctionModel$meta$model,$an:function(){return[doc(String$("This function\'s return closed type.",35)),shared(),formal()];},d:['ceylon.language.meta.model','FunctionModel','$at','type']};}};
            $$functionModel.$prop$getParameterTypes={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$cont:FunctionModel$meta$model,$an:function(){return[doc(String$("This function\'s parameter closed types",38)),shared(),formal()];},d:['ceylon.language.meta.model','FunctionModel','$at','parameterTypes']};}};
        })(FunctionModel$meta$model.$$.prototype);
    }
    return FunctionModel$meta$model;
}
exports.$init$FunctionModel$meta$model=$init$FunctionModel$meta$model;
$init$FunctionModel$meta$model();
defineAttr(FunctionModel$meta$model.$$.prototype,'parameterTypes',function(){
  var ps=this.tipo.$$metamodel$$.$ps;
  if (!ps || ps.length==0)return getEmpty();
  var r=[];
  for (var i=0; i < ps.length; i++) {
    var pt=ps[i].$t;
    if (typeof(pt)==='string'){
      if (!this.$targs)throw TypeApplicationException$meta$model(String$("This function model needs type parameters"));
      pt=this.$targs[pt];
      if (!pt)throw TypeApplicationException$meta$model(String$("Function model is missing type argument for <" + ps[i].$t + ">"));
    }
    r.push(typeLiteral$meta({Type:pt}));
  }
  return r.reifyCeylonType({Element:{t:Type$meta$model,a:{t:Anything}},Absent:{t:Null}});
},undefined,function(){return{mod:$$METAMODEL$$,$cont:FunctionModel$meta$model,d:['ceylon.language.meta.model','FunctionModel','$at','parameterTypes'],$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}},Absent:{t:Null}}}};});
defineAttr(FunctionModel$meta$model.$$.prototype,'typeArguments',function(){
  var mm = this.tipo.$$metamodel$$;
  if (mm) {
    if (mm.$tp) {
      if (this.$targs===undefined)throw TypeApplicationException$meta$model("Missing type arguments for "+this.string);
      var targs=[];
      for (var tp in mm.$tp) {
        var param = OpenTypeParam(this.tipo,tp);
        var targ = this.$targs[tp];
        if (targ) {
          targ=typeLiteral$meta({Type:targ});
        } else {
          targ=typeLiteral$meta({Type:{t:Anything}});
        }
        targs.push(Entry(param,targ,{Key:{t:TypeParameter$meta$declaration},Item:{t:Type$meta$model,a:{Type:{t:Anything}}}}));
      }
      return LazyMap(targs.reifyCeylonType({Absent:{t:Null},Element:{t:Entry,a:{Key:{t:TypeParameter$meta$declaration},Item:{t:Type$meta$model,a:{Type:{t:Anything}}}}}}), {Key:{t:TypeParameter$meta$declaration},Item:{t:Type$meta$model,a:{Type:{t:Anything}}}});
    }
    return getEmpty();
  }
  throw Exception(String$("FunctionModel.typeArguments-we don't have a metamodel!"));
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:{t:TypeParameter$meta$declaration},Item:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$cont:FunctionModel$meta$model,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Generic','$at','typeArguments']};});
defineAttr(FunctionModel$meta$model.$$.prototype,'string',function(){
  var mm=this.tipo.$$metamodel$$;
  var qn;
  if (mm.$cont) {
    qn=$qname(mm.$cont);
    if (mm.$cont.$$metamodel$$.$tp) {
      var cnt=this.$$targs$$&&this.$$targs$$.Container&&this.$$targs$$.Container.a;
      qn+="<";var first=true;
      for (var tp in mm.$cont.$$metamodel$$.$tp) {
        if (first)first=false;else qn+=",";
        var _ta=cnt&&cnt[tp];
        qn+=$qname(_ta||Anything);
      }
      qn+=">";
    }
    qn+="."+mm.d[mm.d.length-1];
  } else {
    qn=$qname(mm);
  }
  if (mm.$tp) {
    qn+="<";
    var first=true;
    for (var tp in mm.$tp) {
      if (first)first=false; else qn+=",";
      var targ=this.$targs[tp];
      if (targ.t) {
        if (typeof(targ.t.$$metamodel$$)==='function')targ.t.$$metamodel$$=targ.t.$$metamodel$$();
        qn+=$qname(targ.t.$$metamodel$$);
      } else {
        qn+=tp;
      }
    }
    qn+=">";
  }
  return String$(qn);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Object','$at','string'],$cont:FunctionModel$meta$model};});
function Function$meta$model($$targs$$,$$function){
    FunctionModel$meta$model($$function.$$targs$$===undefined?$$targs$$:{Arguments:$$function.$$targs$$.Arguments,Type:$$function.$$targs$$.Type},$$function);
    Callable($$function.$$targs$$===undefined?$$targs$$:{Arguments:$$function.$$targs$$.Arguments,Return:$$function.$$targs$$.Type},$$function);
    set_type_args($$function,$$targs$$);
}
Function$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Type:{'var':'out','def':{t:Anything}},Arguments:{'var':'in','satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},satisfies:[{t:FunctionModel$meta$model,a:{Arguments:'Arguments',Type:'Type'}},{t:Callable,a:{Arguments:'Arguments',Return:'Type'}}],$an:function(){return[doc(String$("A function model represents the model of a Ceylon function that you can invoke and inspect.\n\nA function is a toplevel binding, declared on a package.\n\nThis is a [[FunctionModel]] that you can also invoke:\n\n    shared String foo(String name) => \"Hello \"+name;\n    \n    void test(){\n        Function<String,[String]> f = `foo`;\n        // This will print: Hello Stef\n        print(f(\"Stef\"));\n    }\n",397)),shared()];},d:['ceylon.language.meta.model','Function']};};
exports.Function$meta$model=Function$meta$model;
function $init$Function$meta$model(){
    if (Function$meta$model.$$===undefined){
        initTypeProtoI(Function$meta$model,'ceylon.language.meta.model::Function',$init$FunctionModel$meta$model(),$init$Callable());
        (function($$function){
            $$function.$apply={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Type',$ps:[{$nm:'arguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Anything}}},$an:function(){return[];}}],$cont:Function$meta$model,$an:function(){return[doc("Type-unsafe function application, to be used when the argument types are unknown until runtime.\n\nThis has the same behaviour as invoking this `Function` directly, but exchanges compile-time type\nsafety with runtime checks."),$throws("IncompatibleTypeException","If any argument is not assignable to this function\'s corresponding parameter"),$throws("InvocationException","If there are not enough or too many provided arguments"),shared(),formal()];},d:['ceylon.language.meta.model','Function','$m','apply']};}};
        })(Function$meta$model.$$.prototype);
    }
    return Function$meta$model;
}
exports.$init$Function$meta$model=$init$Function$meta$model;
$init$Function$meta$model();
function Method$meta$model($$targs$$,$$method){
    FunctionModel$meta$model($$method.$$targs$$===undefined?$$targs$$:{Arguments:$$method.$$targs$$.Arguments,Type:$$method.$$targs$$.Type},$$method);
    Member$meta$model($$method.$$targs$$===undefined?$$targs$$:{Container:$$method.$$targs$$.Container,Kind:{t:Function$meta$model,a:{Arguments:$$method.$$targs$$.Arguments,Type:$$method.$$targs$$.Type}}},$$method);
    add_type_arg($$method,'Kind',{t:Function$meta$model,a:{Arguments:$$method.$$targs$$.Arguments,Type:$$method.$$targs$$.Type}});
    set_type_args($$method,$$targs$$);
}
Method$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Container:{'var':'in'},Type:{'var':'out','def':{t:Anything}},Arguments:{'var':'in','satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},satisfies:[{t:FunctionModel$meta$model,a:{Arguments:'Arguments',Type:'Type'}},{t:Member$meta$model,a:{Container:'Container',Kind:{t:Function$meta$model,a:{Arguments:'Arguments',Type:'Type'}}}}],$an:function(){return[doc(String$("A function model represents the model of a Ceylon function that you can invoke and inspect.\n\nA method is a member function: it is declared on classes or interfaces.\n\nThis is both a [[FunctionModel]] and a [[Member]]: you can invoke it with an instance value\nto bind it to that instance and obtain a [[Function]]:\n\n    class Outer(){\n        shared String foo(String name) => \"Hello \"+name;\n    }\n    \n    void test(){\n        Method<Outer,String,[String]> method = `Outer.foo`;\n        // Bind it to an instance value\n        Function<String,[String]> f = method(Outer());\n        // This will print: Hello Stef\n        print(f(\"Stef\"));\n    }\n",644)),shared()];},d:['ceylon.language.meta.model','Method']};};
exports.Method$meta$model=Method$meta$model;
function $init$Method$meta$model(){
    if (Method$meta$model.$$===undefined){
        initTypeProtoI(Method$meta$model,'ceylon.language.meta.model::Method',$init$FunctionModel$meta$model(),$init$Member$meta$model());
        (function($$method){
            $$method.$bind={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Function$meta$model,a:{Arguments:'Arguments',Type:'Type'}},$ps:[{$nm:'container',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Method$meta$model,$an:function(){return[shared(),actual(),formal()];},d:['ceylon.language.meta.model','Method','$m','bind']};}};
        })(Method$meta$model.$$.prototype);
    }
    return Method$meta$model;
}
exports.$init$Method$meta$model=$init$Method$meta$model;
$init$Method$meta$model();
function InterfaceModel$meta$model($$targs$$,$$interfaceModel){
    ClassOrInterface$meta$model($$interfaceModel.$$targs$$===undefined?$$targs$$:{Type:$$interfaceModel.$$targs$$.Type},$$interfaceModel);
    set_type_args($$interfaceModel,$$targs$$);
}
InterfaceModel$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Type:{'var':'out','def':{t:Anything}}},satisfies:[{t:ClassOrInterface$meta$model,a:{Type:'Type'}}],$an:function(){return[doc(String$("An interface model represents the model of a Ceylon interface that you can inspect.\n\nAn interface model can be either a toplevel [[Interface]] or a member [[MemberInterface]].\n",176)),shared()];},d:['ceylon.language.meta.model','InterfaceModel']};};
exports.InterfaceModel$meta$model=InterfaceModel$meta$model;
function $init$InterfaceModel$meta$model(){
    if (InterfaceModel$meta$model.$$===undefined){
        initTypeProtoI(InterfaceModel$meta$model,'ceylon.language.meta.model::InterfaceModel',$init$ClassOrInterface$meta$model());
        (function($$interfaceModel){
            $$interfaceModel.$prop$getDeclaration={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:InterfaceDeclaration$meta$declaration},$cont:InterfaceModel$meta$model,$an:function(){return[shared(),formal(),actual()];},d:['ceylon.language.meta.model','InterfaceModel','$at','declaration']};}};
        })(InterfaceModel$meta$model.$$.prototype);
    }
    return InterfaceModel$meta$model;
}
exports.$init$InterfaceModel$meta$model=$init$InterfaceModel$meta$model;
$init$InterfaceModel$meta$model();
defineAttr(InterfaceModel$meta$model.$$.prototype,'declaration',function(){
if (this._decl)return this._decl;
var mm = this.tipo.$$metamodel$$;
if (typeof(mm)==='function') {
  mm = mm();
  this.tipo.$$metamodel$$=mm;
}
this._decl = OpenInterface(getModules$meta().find(mm.mod['$mod-name'],mm.mod['$mod-version']).findPackage(mm.d[0]), this.tipo);
return this._decl;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:InterfaceDeclaration$meta$declaration},$cont:InterfaceModel$meta$model,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','InterfaceModel','$at','declaration']};});

InterfaceModel$meta$model.$$.prototype.equals=function(o){
return isOfType(o,{t:AppliedInterface}) && (o.tipo$2||o.tipo)==this.tipo && this.typeArguments.equals(o.typeArguments);
};
InterfaceModel$meta$model.$$.prototype.equals.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','Object','$m','equals'],$ps:[{$nm:'other',$t:{t:Object$}}],$cont:InterfaceModel$meta$model};}
function Interface$meta$model($$targs$$,$$interface){
    InterfaceModel$meta$model($$interface.$$targs$$===undefined?$$targs$$:{Type:$$interface.$$targs$$.Type},$$interface);
    set_type_args($$interface,$$targs$$);
}
Interface$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Type:{'var':'out','def':{t:Anything}}},satisfies:[{t:InterfaceModel$meta$model,a:{Type:'Type'}}],$an:function(){return[doc(String$("An interface model that you can inspect.",40)),shared()];},d:['ceylon.language.meta.model','Interface']};};
exports.Interface$meta$model=Interface$meta$model;
function $init$Interface$meta$model(){
    if (Interface$meta$model.$$===undefined){
        initTypeProtoI(Interface$meta$model,'ceylon.language.meta.model::Interface',$init$InterfaceModel$meta$model());
    }
    return Interface$meta$model;
}
exports.$init$Interface$meta$model=$init$Interface$meta$model;
$init$Interface$meta$model();
function IntersectionType$meta$model($$targs$$,$$intersectionType){
    Type$meta$model($$intersectionType.$$targs$$===undefined?$$targs$$:{Type:$$intersectionType.$$targs$$.Intersection},$$intersectionType);
    set_type_args($$intersectionType,$$targs$$);
}
IntersectionType$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Intersection:{'var':'out','def':{t:Anything}}},satisfies:[{t:Type$meta$model,a:{Type:'Intersection'}}],$an:function(){return[doc(String$("A closed intersection type.",27)),shared()];},d:['ceylon.language.meta.model','IntersectionType']};};
exports.IntersectionType$meta$model=IntersectionType$meta$model;
function $init$IntersectionType$meta$model(){
    if (IntersectionType$meta$model.$$===undefined){
        initTypeProtoI(IntersectionType$meta$model,'ceylon.language.meta.model::IntersectionType',$init$Type$meta$model());
        (function($$intersectionType){
            $$intersectionType.$prop$getSatisfiedTypes={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$cont:IntersectionType$meta$model,$an:function(){return[doc(String$("The list of closed satisfied types of this intersection.",56)),shared(),formal()];},d:['ceylon.language.meta.model','IntersectionType','$at','satisfiedTypes']};}};
        })(IntersectionType$meta$model.$$.prototype);
    }
    return IntersectionType$meta$model;
}
exports.$init$IntersectionType$meta$model=$init$IntersectionType$meta$model;
$init$IntersectionType$meta$model();
function Member$meta$model($$targs$$,$$member){
    Callable($$member.$$targs$$===undefined?$$targs$$:{Arguments:{t:'T', l:[$$member.$$targs$$.Container]},Return:$$member.$$targs$$.Kind},$$member);
    add_type_arg($$member,'Arguments',{t:'T', l:[$$member.$$targs$$.Container]});
    set_type_args($$member,$$targs$$);
}
Member$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Container:{'var':'in'},Kind:{'var':'out','satisfies':[{t:Model$meta$model}]}},satisfies:[{t:Callable,a:{Arguments:{t:'T',l:[{$t:'Container'}]},Return:'Kind'}}],$an:function(){return[doc(String$("Model for members that can be bound to a containing instance to turn them into toplevel models.\n\nYou can bind a member to an instance by invoking that member with the instance as parameter:\n\n    shared class Outer(String name){\n        shared class Inner(){\n            shared String hello => \"Hello \"+name;\n        }\n    }\n    \n    void test(){\n        Member<Outer,Class<Outer.Inner,[]>> memberClass = `Outer.Inner`;\n        Class<Outer.Inner,[]> c = memberClass(Outer(\"Stef\"));\n        // This will print: Hello Stef\n        print(c().hello);\n    }\n",552)),shared()];},d:['ceylon.language.meta.model','Member']};};
exports.Member$meta$model=Member$meta$model;
function $init$Member$meta$model(){
    if (Member$meta$model.$$===undefined){
        initTypeProtoI(Member$meta$model,'ceylon.language.meta.model::Member',$init$Callable());
        (function($$member){
            $$member.$prop$getDeclaringType={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Type$meta$model,a:{Type:{t:Anything}}},$cont:Member$meta$model,$an:function(){return[doc(String$("The declaring closed type. This is the type that declared this member.",70)),shared(),formal()];},d:['ceylon.language.meta.model','Member','$at','declaringType']};}};
            $$member.$bind={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Model$meta$model},$ps:[{$nm:'container',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Member$meta$model,$an:function(){return[doc("Type-unsafe container binding, to be used when the container type is unknown until runtime.\n\nThis has the same behaviour as invoking this `Member` directly, but exchanges compile-time type\nsafety with runtime checks."),$throws("IncompatibleTypeException","If the container is not assignable to this member\'s container"),shared(),formal()];},d:['ceylon.language.meta.model','Member','$m','bind']};}};
        })(Member$meta$model.$$.prototype);
    }
    return Member$meta$model;
}
exports.$init$Member$meta$model=$init$Member$meta$model;
$init$Member$meta$model();
defineAttr(Member$meta$model.$$.prototype,'declaringType',function(){
  var $$member=this;
  var mm = $$member.tipo.$$metamodel$$;
  if (typeof(mm)==='function') {
    mm = mm();
    $$member.tipo.$$metamodel$$=mm;
  }
  var m2 = get_model(mm);
  return (m2['$mt']==='cls'?OpenClass:OpenInterface)(getModules$meta().find(mm.mod['$mod-name'],mm.mod['$mod-version']).findPackage(mm.d[0]), $$member.tipo);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Member$meta$model,a:{Type:{t:Anything}}},$cont:Member$meta$model,$an:function(){return[shared(),formal()];},d:['ceylon.language.meta.model','Member','$at','declaringType']};});

defineAttr(Member$meta$model.$$.prototype,'container',function(){
    return this.declaringClassOrInterface;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:Type$meta$model,a:{Type:{t:Anything}}}]},$cont:Member$meta$model,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Member','$at','container']};});
function MemberClass$meta$model($$targs$$,$$memberClass){
    ClassModel$meta$model($$memberClass.$$targs$$===undefined?$$targs$$:{Arguments:$$memberClass.$$targs$$.Arguments,Type:$$memberClass.$$targs$$.Type},$$memberClass);
    Member$meta$model($$memberClass.$$targs$$===undefined?$$targs$$:{Container:$$memberClass.$$targs$$.Container,Kind:{t:Class$meta$model,a:{Arguments:$$memberClass.$$targs$$.Arguments,Type:$$memberClass.$$targs$$.Type}}},$$memberClass);
    add_type_arg($$memberClass,'Kind',{t:Class$meta$model,a:{Arguments:$$memberClass.$$targs$$.Arguments,Type:$$memberClass.$$targs$$.Type}});
    set_type_args($$memberClass,$$targs$$);
}
MemberClass$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Container:{'var':'in'},Type:{'var':'out','def':{t:Anything}},Arguments:{'var':'in','satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},satisfies:[{t:ClassModel$meta$model,a:{Arguments:'Arguments',Type:'Type'}},{t:Member$meta$model,a:{Container:'Container',Kind:{t:Class$meta$model,a:{Arguments:'Arguments',Type:'Type'}}}}],$an:function(){return[doc(String$("A class model represents the model of a Ceylon class that you can instantiate and inspect.\n\nA member class is is declared on classes or interfaces.\n\nThis is both a [[ClassModel]] and a [[Member]]: you can invoke it with an instance value\nto bind it to that instance and obtain a [[Class]]:\n\n    shared class Outer(String name){\n        shared class Inner(){\n            shared String hello => \"Hello \"+name;\n        }\n    }\n    \n    void test(){\n        MemberClass<Outer,Outer.Inner,[]> memberClass = `Outer.Inner`;\n        Class<Outer.Inner,[]> c = memberClass(Outer(\"Stef\"));\n        // This will print: Hello Stef\n        print(c().hello);\n    }\n",650)),shared()];},d:['ceylon.language.meta.model','MemberClass']};};
exports.MemberClass$meta$model=MemberClass$meta$model;
function $init$MemberClass$meta$model(){
    if (MemberClass$meta$model.$$===undefined){
        initTypeProtoI(MemberClass$meta$model,'ceylon.language.meta.model::MemberClass',$init$ClassModel$meta$model(),$init$Member$meta$model());
        (function($$memberClass){
            $$memberClass.$bind={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Class$meta$model,a:{Arguments:'Arguments',Type:'Type'}},$ps:[{$nm:'container',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:MemberClass$meta$model,$an:function(){return[shared(),actual(),formal()];},d:['ceylon.language.meta.model','MemberClass','$m','bind']};}};
        })(MemberClass$meta$model.$$.prototype);
    }
    return MemberClass$meta$model;
}
exports.$init$MemberClass$meta$model=$init$MemberClass$meta$model;
$init$MemberClass$meta$model();
function MemberInterface$meta$model($$targs$$,$$memberInterface){
    InterfaceModel$meta$model($$memberInterface.$$targs$$===undefined?$$targs$$:{Type:$$memberInterface.$$targs$$.Type},$$memberInterface);
    Member$meta$model($$memberInterface.$$targs$$===undefined?$$targs$$:{Container:$$memberInterface.$$targs$$.Container,Kind:{t:Interface$meta$model,a:{Type:$$memberInterface.$$targs$$.Type}}},$$memberInterface);
    add_type_arg($$memberInterface,'Kind',{t:Interface$meta$model,a:{Type:$$memberInterface.$$targs$$.Type}});
    set_type_args($$memberInterface,$$targs$$);
}
MemberInterface$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Container:{'var':'in'},Type:{'var':'out','def':{t:Anything}}},satisfies:[{t:InterfaceModel$meta$model,a:{Type:'Type'}},{t:Member$meta$model,a:{Container:'Container',Kind:{t:Interface$meta$model,a:{Type:'Type'}}}}],$an:function(){return[doc(String$("A member interface model that you can inspect.",46)),shared()];},d:['ceylon.language.meta.model','MemberInterface']};};
exports.MemberInterface$meta$model=MemberInterface$meta$model;
function $init$MemberInterface$meta$model(){
    if (MemberInterface$meta$model.$$===undefined){
        initTypeProtoI(MemberInterface$meta$model,'ceylon.language.meta.model::MemberInterface',$init$InterfaceModel$meta$model(),$init$Member$meta$model());
        (function($$memberInterface){
            $$memberInterface.$bind={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Interface$meta$model,a:{Type:'Type'}},$ps:[{$nm:'container',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:MemberInterface$meta$model,$an:function(){return[shared(),actual(),formal()];},d:['ceylon.language.meta.model','MemberInterface','$m','bind']};}};
        })(MemberInterface$meta$model.$$.prototype);
    }
    return MemberInterface$meta$model;
}
exports.$init$MemberInterface$meta$model=$init$MemberInterface$meta$model;
$init$MemberInterface$meta$model();
function Attribute$meta$model($$targs$$,$$attribute){
    ValueModel$meta$model($$attribute.$$targs$$===undefined?$$targs$$:{Set:$$attribute.$$targs$$.Set,Get:$$attribute.$$targs$$.Get},$$attribute);
    Member$meta$model($$attribute.$$targs$$===undefined?$$targs$$:{Container:$$attribute.$$targs$$.Container,Kind:{t:Value$meta$model,a:{Set:$$attribute.$$targs$$.Set,Get:$$attribute.$$targs$$.Get}}},$$attribute);
    add_type_arg($$attribute,'Kind',{t:Value$meta$model,a:{Set:$$attribute.$$targs$$.Set,Get:$$attribute.$$targs$$.Get}});
    set_type_args($$attribute,$$targs$$);
}
Attribute$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Container:{'var':'in'},Get:{'var':'out','def':{t:Anything}},Set:{'var':'in','def':{t:Nothing}}},satisfies:[{t:ValueModel$meta$model,a:{Set:'Set',Get:'Get'}},{t:Member$meta$model,a:{Container:'Container',Kind:{t:Value$meta$model,a:{Set:'Set',Get:'Get'}}}}],$an:function(){return[doc(String$("An attribute model represents the model of a Ceylon attribute that you can read and inspect.\n\nAn attribute is a member value: it is declared on classes or interfaces.\n\nThis is both a [[ValueModel]] and a [[Member]]: you can invoke it with an instance value\nto bind it to that instance and obtain a [[Value]]:\n\n    class Outer(){\n        shared String foo = \"Hello\";\n    }\n    \n    void test(){\n        Attribute<Outer,String> attribute = `Outer.foo`;\n        Value<String> boundAttribute = attribute(Outer());\n        // This will print: Hello\n        print(boundAttribute.get());\n    }\n",587)),shared()];},d:['ceylon.language.meta.model','Attribute']};};
exports.Attribute$meta$model=Attribute$meta$model;
function $init$Attribute$meta$model(){
    if (Attribute$meta$model.$$===undefined){
        initTypeProtoI(Attribute$meta$model,'ceylon.language.meta.model::Attribute',$init$ValueModel$meta$model(),$init$Member$meta$model());
        (function($$attribute){
            $$attribute.$bind={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Value$meta$model,a:{Set:'Set',Get:'Get'}},$ps:[{$nm:'container',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:Attribute$meta$model,$an:function(){return[shared(),actual(),formal()];},d:['ceylon.language.meta.model','Attribute','$m','bind']};}};
        })(Attribute$meta$model.$$.prototype);
    }
    return Attribute$meta$model;
}
exports.$init$Attribute$meta$model=$init$Attribute$meta$model;
$init$Attribute$meta$model();
function Model$meta$model($$model){
}
Model$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,of:[{t:ClassOrInterface$meta$model,a:{Type:{t:Anything}}},{t:FunctionModel$meta$model,a:{Arguments:{t:Nothing},Type:{t:Anything}}},{t:ValueModel$meta$model,a:{Set:{t:Nothing},Get:{t:Anything}}}],$an:function(){return[doc(String$("The root of all models. There are several types of models:\n\n- [[ClassOrInterface]]\n- [[FunctionModel]]\n- [[ValueModel]]\n",120)),shared()];},d:['ceylon.language.meta.model','Model']};};
exports.Model$meta$model=Model$meta$model;
function $init$Model$meta$model(){
    if (Model$meta$model.$$===undefined){
        initTypeProtoI(Model$meta$model,'ceylon.language.meta.model::Model');
        (function($$model){
            $$model.$prop$getContainer={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Type$meta$model,a:{Type:{t:Anything}}}]},$cont:Model$meta$model,$an:function(){return[doc(String$("The container type of this model, or `null` if this is a toplevel model.",72)),shared(),formal()];},d:['ceylon.language.meta.model','Model','$at','container']};}};
            $$model.$prop$getDeclaration={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:NestableDeclaration$meta$declaration},$cont:Model$meta$model,$an:function(){return[doc(String$("The declaration for this model.",31)),shared(),formal()];},d:['ceylon.language.meta.model','Model','$at','declaration']};}};
        })(Model$meta$model.$$.prototype);
    }
    return Model$meta$model;
}
exports.$init$Model$meta$model=$init$Model$meta$model;
$init$Model$meta$model();
function Type$meta$model($$targs$$,$$type){
    set_type_args($$type,$$targs$$);
}
Type$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Type:{'var':'out','def':{t:Anything}}},$an:function(){return[doc(String$("A closed type.\n\nA closed type is a type which is fully resolved and bound and contains no open type variables.\nAll instance types are closed at runtime.\n\nYou have only four sorts of types:\n\n- [[ClassOrInterface]]\n- [[UnionType]]\n- [[IntersectionType]]\n- [[nothingType]]",269)),shared()];},d:['ceylon.language.meta.model','Type']};};
exports.Type$meta$model=Type$meta$model;
function $init$Type$meta$model(){
    if (Type$meta$model.$$===undefined){
        initTypeProtoI(Type$meta$model,'ceylon.language.meta.model::Type');
        (function($$type){
            $$type.typeOf={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'instance',$mt:'prm',$t:{t:Anything},$an:function(){return[];}}],$cont:Type$meta$model,$an:function(){return[doc("True if the given instance is of this type, or is of a subtype of this type."),shared(),formal()];},d:['ceylon.language.meta.model','Type','$m','typeOf']};}};$$type.supertypeOf={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'type',$mt:'prm',$t:{t:Type$meta$model,a:{Type:{t:Anything}}},$an:function(){return[];}}],$cont:Type$meta$model,$an:function(){return[doc("True if the given type is a supertype of this type."),shared(),formal()];},d:['ceylon.language.meta.model','Type','$m','supertypeOf']};}};$$type.subtypeOf=function (type$1005){
                var $$type=this;
                return type$1005.supertypeOf($$type);
            };
            $$type.subtypeOf.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'type',$mt:'prm',$t:{t:Type$meta$model,a:{Type:{t:Anything}}},$an:function(){return[];}}],$cont:Type$meta$model,$an:function(){return[doc(String$("True if the given type is a subtype of this type.",49)),shared(),$default()];},d:['ceylon.language.meta.model','Type','$m','subtypeOf']};};
            $$type.exactly={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$ps:[{$nm:'type',$mt:'prm',$t:{t:Type$meta$model,a:{Type:{t:Anything}}},$an:function(){return[];}}],$cont:Type$meta$model,$an:function(){return[doc("True if the given type is a exactly this type."),shared(),formal()];},d:['ceylon.language.meta.model','Type','$m','exactly']};}};
        })(Type$meta$model.$$.prototype);
    }
    return Type$meta$model;
}
exports.$init$Type$meta$model=$init$Type$meta$model;
$init$Type$meta$model();
function UnionType$meta$model($$targs$$,$$unionType){
    Type$meta$model($$unionType.$$targs$$===undefined?$$targs$$:{Type:$$unionType.$$targs$$.Union},$$unionType);
    set_type_args($$unionType,$$targs$$);
}
UnionType$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Union:{'var':'out','def':{t:Anything}}},satisfies:[{t:Type$meta$model,a:{Type:'Union'}}],$an:function(){return[doc(String$("A closed union type.",20)),shared()];},d:['ceylon.language.meta.model','UnionType']};};
exports.UnionType$meta$model=UnionType$meta$model;
function $init$UnionType$meta$model(){
    if (UnionType$meta$model.$$===undefined){
        initTypeProtoI(UnionType$meta$model,'ceylon.language.meta.model::UnionType',$init$Type$meta$model());
        (function($$unionType){
            $$unionType.$prop$getCaseTypes={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:{t:Type$meta$model,a:{Type:'Union'}}}},$cont:UnionType$meta$model,$an:function(){return[doc(String$("The list of closed case types of this union.",44)),shared(),formal()];},d:['ceylon.language.meta.model','UnionType','$at','caseTypes']};}};
        })(UnionType$meta$model.$$.prototype);
    }
    return UnionType$meta$model;
}
exports.$init$UnionType$meta$model=$init$UnionType$meta$model;
$init$UnionType$meta$model();
function Value$meta$model($$targs$$,$$value){
    ValueModel$meta$model($$value.$$targs$$===undefined?$$targs$$:{Set:$$value.$$targs$$.Set,Get:$$value.$$targs$$.Get},$$value);
    set_type_args($$value,$$targs$$);
}
Value$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$tp:{Get:{'var':'out','def':{t:Anything}},Set:{'var':'in','def':{t:Nothing}}},satisfies:[{t:ValueModel$meta$model,a:{Set:'Set',Get:'Get'}}],$an:function(){return[doc(String$("A value model represents the model of a Ceylon value that you can read and inspect.\n\nA value is a toplevel binding, declared on a package.\n\nThis is a [[ValueModel]] that you can query for a value declaration\'s current value:\n\n    shared String foo = \"Hello\";\n    \n    void test(){\n        Value<String> val = `foo`;\n        // This will print: Hello\n        print(val.get());\n    }\n",382)),shared()];},d:['ceylon.language.meta.model','Value']};};
exports.Value$meta$model=Value$meta$model;
function $init$Value$meta$model(){
    if (Value$meta$model.$$===undefined){
        initTypeProtoI(Value$meta$model,'ceylon.language.meta.model::Value',$init$ValueModel$meta$model());
        (function($$value){
            $$value.$get={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:'Get',$ps:[],$cont:Value$meta$model,$an:function(){return[doc("Reads the current value for this value binding. Note that in the case of getter\nvalues, this can throw if the getter throws."),shared(),formal()];},d:['ceylon.language.meta.model','Value','$m','get']};}};$$value.set={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[{$nm:'newValue',$mt:'prm',$t:'Set',$an:function(){return[];}}],$cont:Value$meta$model,$an:function(){return[doc("Changes this variable\'s value to the given new value. Note that in the case of\nsetter attributes, this can throw if the setter throws."),shared(),formal()];},d:['ceylon.language.meta.model','Value','$m','set']};}};$$value.setIfAssignable={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[{$nm:'newValue',$mt:'prm',$t:{t:Anything},$an:function(){return[];}}],$cont:Value$meta$model,$an:function(){return[doc("Non type-safe equivalent to [[Value.set]], to be used when you don\'t know the \nvariable type at compile-time. This only works if the underlying value is \nvariable. Note that if the underlying variable is a setter, this can throw \nexceptions thrown in the setter block."),$throws("IncompatibleTypeException","If the specified new value is not of a subtype of this variable\'s type"),$throws("MutationException","If this value is not variable"),shared(),formal()];},d:['ceylon.language.meta.model','Value','$m','setIfAssignable']};}};
        })(Value$meta$model.$$.prototype);
    }
    return Value$meta$model;
}
exports.$init$Value$meta$model=$init$Value$meta$model;
$init$Value$meta$model();
function nothingType$1006$meta$model($$targs$$){
    var $$nothingType=new nothingType$1006$meta$model.$$;
    $$nothingType.$$targs$$=$$targs$$;
    Type$meta$model({Type:{t:Nothing}},$$nothingType);
    return $$nothingType;
};nothingType$1006$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Type$meta$model,a:{Type:{t:Nothing}}}],$an:function(){return[doc("The singleton closed type for [[Nothing|ceylon.language::nothing]]."),shared()];},d:['ceylon.language.meta.model','nothingType']};};
function $init$nothingType$1006$meta$model(){
    if (nothingType$1006$meta$model.$$===undefined){
        initTypeProto(nothingType$1006$meta$model,'ceylon.language.meta.model::nothingType',Basic,$init$Type$meta$model());
        (function($$nothingType){
            defineAttr($$nothingType,'string',function(){
                var $$nothingType=this;
                return String$("Nothing",7);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:nothingType$1006$meta$model,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','nothingType','$at','string']};});
            $$nothingType.typeOf=function (instance$1007){
                var $$nothingType=this;
                return false;
            };$$nothingType.supertypeOf=function (type$1008){
                var $$nothingType=this;
                return $$nothingType.exactly(type$1008);
            };$$nothingType.subtypeOf=function (type$1009){
                var $$nothingType=this;
                return true;
            };$$nothingType.exactly=function (type$1010){
                var $$nothingType=this;
                return type$1010.equals(getNothingType$meta$model());
            };
        })(nothingType$1006$meta$model.$$.prototype);
    }
    return nothingType$1006$meta$model;
}
exports.$init$nothingType$1006$meta$model=$init$nothingType$1006$meta$model;
$init$nothingType$1006$meta$model();
var nothingType$1011$meta$model;
function getNothingType$meta$model(){
    if (nothingType$1011$meta$model===undefined){nothingType$1011$meta$model=$init$nothingType$1006$meta$model()({Type:{t:Nothing}});nothingType$1011$meta$model.$$metamodel$$=getNothingType$meta$model.$$metamodel$$;}
    return nothingType$1011$meta$model;
}
exports.getNothingType$meta$model=getNothingType$meta$model;
getNothingType$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:nothingType$1006$meta$model},$an:function(){return[doc(String$("The singleton closed type for [[Nothing|ceylon.language::nothing]].",67)),shared()];},d:['ceylon.language.meta.model','nothingType']};};
$prop$getNothingType$meta$model={get:getNothingType$meta$model,$$metamodel$$:getNothingType$meta$model.$$metamodel$$};
exports.$prop$getNothingType$meta$model=$prop$getNothingType$meta$model;
function TypeApplicationException$meta$model(message$1012, $$typeApplicationException){
    $init$TypeApplicationException$meta$model();
    if ($$typeApplicationException===undefined)$$typeApplicationException=new TypeApplicationException$meta$model.$$;
    $$typeApplicationException.message$1012_=message$1012;
    Exception($$typeApplicationException.message$1012,undefined,$$typeApplicationException);
    return $$typeApplicationException;
}
TypeApplicationException$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Exception},$ps:[{$nm:'message',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$an:function(){return[doc(String$("Thrown when declarations are applied with invalid or incompatible type arguments.\n\nFor example if you try to apply `Foo` with `String`, hoping to get a `Foo<String>`\nbut the type parameter for `Foo` only accepts types that satisfy `Numeric`.\n",242)),shared()];},d:['ceylon.language.meta.model','TypeApplicationException']};};
exports.TypeApplicationException$meta$model=TypeApplicationException$meta$model;
function $init$TypeApplicationException$meta$model(){
    if (TypeApplicationException$meta$model.$$===undefined){
        initTypeProto(TypeApplicationException$meta$model,'ceylon.language.meta.model::TypeApplicationException',$init$Exception());
        (function($$typeApplicationException){
            defineAttr($$typeApplicationException,'message$1012',function(){return this.message$1012_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:TypeApplicationException$meta$model,d:['ceylon.language.meta.model','TypeApplicationException','$at','message']};});
        })(TypeApplicationException$meta$model.$$.prototype);
    }
    return TypeApplicationException$meta$model;
}
exports.$init$TypeApplicationException$meta$model=$init$TypeApplicationException$meta$model;
$init$TypeApplicationException$meta$model();
function InvocationException$meta$model(message$1013, $$invocationException){
    $init$InvocationException$meta$model();
    if ($$invocationException===undefined)$$invocationException=new InvocationException$meta$model.$$;
    $$invocationException.message$1013_=message$1013;
    Exception($$invocationException.message$1013,undefined,$$invocationException);
    return $$invocationException;
}
InvocationException$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Exception},$ps:[{$nm:'message',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$an:function(){return[doc(String$("Thrown when attempting to invoke something which can\'t be invoked, like abstract class\ninitialisers.",100)),shared()];},d:['ceylon.language.meta.model','InvocationException']};};
exports.InvocationException$meta$model=InvocationException$meta$model;
function $init$InvocationException$meta$model(){
    if (InvocationException$meta$model.$$===undefined){
        initTypeProto(InvocationException$meta$model,'ceylon.language.meta.model::InvocationException',$init$Exception());
        (function($$invocationException){
            defineAttr($$invocationException,'message$1013',function(){return this.message$1013_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:InvocationException$meta$model,d:['ceylon.language.meta.model','InvocationException','$at','message']};});
        })(InvocationException$meta$model.$$.prototype);
    }
    return InvocationException$meta$model;
}
exports.$init$InvocationException$meta$model=$init$InvocationException$meta$model;
$init$InvocationException$meta$model();
function MutationException$meta$model(message$1014, $$mutationException){
    $init$MutationException$meta$model();
    if ($$mutationException===undefined)$$mutationException=new MutationException$meta$model.$$;
    $$mutationException.message$1014_=message$1014;
    Exception($$mutationException.message$1014,undefined,$$mutationException);
    return $$mutationException;
}
MutationException$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Exception},$ps:[{$nm:'message',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$an:function(){return[doc(String$("Thrown when you try to change the value of a non-variable value",63)),shared()];},d:['ceylon.language.meta.model','MutationException']};};
exports.MutationException$meta$model=MutationException$meta$model;
function $init$MutationException$meta$model(){
    if (MutationException$meta$model.$$===undefined){
        initTypeProto(MutationException$meta$model,'ceylon.language.meta.model::MutationException',$init$Exception());
        (function($$mutationException){
            defineAttr($$mutationException,'message$1014',function(){return this.message$1014_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:MutationException$meta$model,d:['ceylon.language.meta.model','MutationException','$at','message']};});
        })(MutationException$meta$model.$$.prototype);
    }
    return MutationException$meta$model;
}
exports.$init$MutationException$meta$model=$init$MutationException$meta$model;
$init$MutationException$meta$model();
function IncompatibleTypeException$meta$model(message$1015, $$incompatibleTypeException){
    $init$IncompatibleTypeException$meta$model();
    if ($$incompatibleTypeException===undefined)$$incompatibleTypeException=new IncompatibleTypeException$meta$model.$$;
    $$incompatibleTypeException.message$1015_=message$1015;
    Exception($$incompatibleTypeException.message$1015,undefined,$$incompatibleTypeException);
    return $$incompatibleTypeException;
}
IncompatibleTypeException$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Exception},$ps:[{$nm:'message',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$an:function(){return[doc(String$("Thrown when you invoke metamodel methods with invalid or incompatible type arguments.\n\nFor example if you try to get an attribute from a class and expect an attribute of `String`\ntype but it is an attribute of `Integer` type.\n",226)),shared()];},d:['ceylon.language.meta.model','IncompatibleTypeException']};};
exports.IncompatibleTypeException$meta$model=IncompatibleTypeException$meta$model;
function $init$IncompatibleTypeException$meta$model(){
    if (IncompatibleTypeException$meta$model.$$===undefined){
        initTypeProto(IncompatibleTypeException$meta$model,'ceylon.language.meta.model::IncompatibleTypeException',$init$Exception());
        (function($$incompatibleTypeException){
            defineAttr($$incompatibleTypeException,'message$1015',function(){return this.message$1015_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:IncompatibleTypeException$meta$model,d:['ceylon.language.meta.model','IncompatibleTypeException','$at','message']};});
        })(IncompatibleTypeException$meta$model.$$.prototype);
    }
    return IncompatibleTypeException$meta$model;
}
exports.$init$IncompatibleTypeException$meta$model=$init$IncompatibleTypeException$meta$model;
$init$IncompatibleTypeException$meta$model();
function Generic$meta$model($$generic){
}
Generic$meta$model.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$an:function(){return[doc(String$("A generic model which has closed type arguments.",48)),shared()];},d:['ceylon.language.meta.model','Generic']};};
exports.Generic$meta$model=Generic$meta$model;
function $init$Generic$meta$model(){
    if (Generic$meta$model.$$===undefined){
        initTypeProtoI(Generic$meta$model,'ceylon.language.meta.model::Generic');
        (function($$generic){
            $$generic.$prop$getTypeArguments={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:{t:TypeParameter$meta$declaration},Item:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$cont:Generic$meta$model,$an:function(){return[doc(String$("The map of type parameter declaration to type arguments for this generic model.",79)),shared(),formal()];},d:['ceylon.language.meta.model','Generic','$at','typeArguments']};}};
        })(Generic$meta$model.$$.prototype);
    }
    return Generic$meta$model;
}
exports.$init$Generic$meta$model=$init$Generic$meta$model;
$init$Generic$meta$model();
function Declaration$meta$declaration($$declaration){
}
Declaration$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,of:[{t:AnnotatedDeclaration$meta$declaration},{t:TypeParameter$meta$declaration}],$an:function(){return[doc(String$("A declaration.\n\nThere are only two types of declarations:\n\n- [[AnnotatedDeclaration]]s such as modules, packages, classes or functions, and\n- [[TypeParameter]] declarations.",173)),shared()];},d:['ceylon.language.meta.declaration','Declaration']};};
exports.Declaration$meta$declaration=Declaration$meta$declaration;
function $init$Declaration$meta$declaration(){
    if (Declaration$meta$declaration.$$===undefined){
        initTypeProtoI(Declaration$meta$declaration,'ceylon.language.meta.declaration::Declaration');
        (function($$declaration){
            $$declaration.$prop$getName={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Declaration$meta$declaration,$an:function(){return[doc(String$("The name of this declaration. For example, the [[Declaration]] class is named \"Declaration\".",92)),shared(),formal()];},d:['ceylon.language.meta.declaration','Declaration','$at','name']};}};
            $$declaration.$prop$getQualifiedName={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Declaration$meta$declaration,$an:function(){return[doc(String$("The qualified name of this declaration. This includes the container qualified name. For\nexample, the [[Declaration]] class\' qualified name is \"ceylon.language.meta.declaration::Declaration\".",190)),shared(),formal()];},d:['ceylon.language.meta.declaration','Declaration','$at','qualifiedName']};}};
        })(Declaration$meta$declaration.$$.prototype);
    }
    return Declaration$meta$declaration;
}
exports.$init$Declaration$meta$declaration=$init$Declaration$meta$declaration;
$init$Declaration$meta$declaration();
function AnnotatedDeclaration$meta$declaration($$annotatedDeclaration){
    Declaration$meta$declaration($$annotatedDeclaration);
    Annotated($$annotatedDeclaration);
}
AnnotatedDeclaration$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:Declaration$meta$declaration},{t:Annotated}],of:[{t:NestableDeclaration$meta$declaration},{t:Module$meta$declaration},{t:Package$meta$declaration}],$an:function(){return[doc(String$("Declaration which can be annotated, such as:\n\n- [[NestableDeclaration]]\n- [[Module]]\n- [[Package]]\n\nYou can query annotations that are placed on a given annotated declaration with:\n\n",182)),shared()];},d:['ceylon.language.meta.declaration','AnnotatedDeclaration']};};
exports.AnnotatedDeclaration$meta$declaration=AnnotatedDeclaration$meta$declaration;
function $init$AnnotatedDeclaration$meta$declaration(){
    if (AnnotatedDeclaration$meta$declaration.$$===undefined){
        initTypeProtoI(AnnotatedDeclaration$meta$declaration,'ceylon.language.meta.declaration::AnnotatedDeclaration',$init$Declaration$meta$declaration(),$init$Annotated());
        (function($$annotatedDeclaration){
            $$annotatedDeclaration.annotations={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Annotation'}},$ps:[],$cont:AnnotatedDeclaration$meta$declaration,$tp:{Annotation:{'var':'out','satisfies':[{t:Annotation}]}},$an:function(){return[doc("The annotation instances of the given \nannotation type on this declaration.\n\nFor example, you can list all the [[See|ceylon.language::See]] \nannotations on [[List|ceylon.language::List]]\nwith the following code:\n\n    for(annot in `interface List`.annotations<See>()){\n        for(elems in annot.programElements){\n            print(\"See: ``elems``\");\n        }\n    }\n\nAlternatively, you can use the [[ceylon.language.meta::annotations]] \nfunction.\n"),shared(),formal()];},d:['ceylon.language.meta.declaration','AnnotatedDeclaration','$m','annotations']};}};
        })(AnnotatedDeclaration$meta$declaration.$$.prototype);
    }
    return AnnotatedDeclaration$meta$declaration;
}
exports.$init$AnnotatedDeclaration$meta$declaration=$init$AnnotatedDeclaration$meta$declaration;
$init$AnnotatedDeclaration$meta$declaration();
//Add-on to AnnotatedDeclaration
AnnotatedDeclaration$meta$declaration.$$.prototype.annotations=function ($$$mptypes) {
  var ans = [];
  var _mdl = this.tipo.$$metamodel$$;
  if (typeof(_mdl)==='function') {
    _mdl = _mdl();
    this.tipo.$$metamodel$$=_mdl;
  }
  var _ans = _mdl.$an;
  if (typeof(_ans)==='function') {
    _ans = _ans();
    _mdl.$an=_ans;
  }
  for (var i=0; i<_ans.length;i++) {
    if (isOfType(_ans[i], $$$mptypes.Annotation)) {
      ans.push(_ans[i]);
    }
  }
  return ans.length == 0 ? getEmpty() : ans.reifyCeylonType({Element:$$$mptypes.Annotation});
};
AnnotatedDeclaration$meta$declaration.$$.prototype.annotations.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Annotation'}},$ps:[],$cont:AnnotatedDeclaration$meta$declaration,$tp:{Annotation:{'var':'out','satisfies':[{t:Annotation,a:{Value:'Annotation'}}]}},$an:function(){return[shared(),formal()];},d:['ceylon.language.meta.declaration','AnnotatedDeclaration','$m','annotations']};};
function NestableDeclaration$meta$declaration($$nestableDeclaration){
    AnnotatedDeclaration$meta$declaration($$nestableDeclaration);
    TypedDeclaration$meta$declaration($$nestableDeclaration);
}
NestableDeclaration$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:AnnotatedDeclaration$meta$declaration},{t:TypedDeclaration$meta$declaration}],of:[{t:FunctionOrValueDeclaration$meta$declaration},{t:ClassOrInterfaceDeclaration$meta$declaration},{t:AliasDeclaration$meta$declaration}],$an:function(){return[doc(String$("A declaration which can be contained in a [[Package]] or in another [[NestableDeclaration]].\n\nFunctions, values, classes, interfaes and aliases are such declarations.",166)),shared()];},d:['ceylon.language.meta.declaration','NestableDeclaration']};};
exports.NestableDeclaration$meta$declaration=NestableDeclaration$meta$declaration;
function $init$NestableDeclaration$meta$declaration(){
    if (NestableDeclaration$meta$declaration.$$===undefined){
        initTypeProtoI(NestableDeclaration$meta$declaration,'ceylon.language.meta.declaration::NestableDeclaration',$init$AnnotatedDeclaration$meta$declaration(),$init$TypedDeclaration$meta$declaration());
        (function($$nestableDeclaration){
            $$nestableDeclaration.$prop$getActual={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:NestableDeclaration$meta$declaration,$an:function(){return[doc(String$("True if this declaration is annotated with [[actual|ceylon.language::actual]].",78)),shared(),formal()];},d:['ceylon.language.meta.declaration','NestableDeclaration','$at','actual']};}};
            $$nestableDeclaration.$prop$getFormal={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:NestableDeclaration$meta$declaration,$an:function(){return[doc(String$("True if this declaration is annotated with [[formal|ceylon.language::formal]].",78)),shared(),formal()];},d:['ceylon.language.meta.declaration','NestableDeclaration','$at','formal']};}};
            $$nestableDeclaration.$prop$getDefault={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:NestableDeclaration$meta$declaration,$an:function(){return[doc(String$("True if this declaration is annotated with [[default|ceylon.language::default]].",80)),shared(),formal()];},d:['ceylon.language.meta.declaration','NestableDeclaration','$at','default']};}};
            $$nestableDeclaration.$prop$getShared={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:NestableDeclaration$meta$declaration,$an:function(){return[doc(String$("True if this declaration is annotated with [[shared|ceylon.language::shared]].",78)),shared(),formal()];},d:['ceylon.language.meta.declaration','NestableDeclaration','$at','shared']};}};
            $$nestableDeclaration.$prop$getContainingPackage={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Package$meta$declaration},$cont:NestableDeclaration$meta$declaration,$an:function(){return[doc(String$("This declaration\'s package container.",37)),shared(),formal()];},d:['ceylon.language.meta.declaration','NestableDeclaration','$at','containingPackage']};}};
            $$nestableDeclaration.$prop$getContainingModule={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Module$meta$declaration},$cont:NestableDeclaration$meta$declaration,$an:function(){return[doc(String$("This declaration\'s module container.",36)),shared(),formal()];},d:['ceylon.language.meta.declaration','NestableDeclaration','$at','containingModule']};}};
            $$nestableDeclaration.$prop$getContainer={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:NestableDeclaration$meta$declaration},{t:Package$meta$declaration}]},$cont:NestableDeclaration$meta$declaration,$an:function(){return[doc(String$("This declaration\'s immediate container, which can be either a [[NestableDeclaration]]\nor a [[Package]].",103)),shared(),formal()];},d:['ceylon.language.meta.declaration','NestableDeclaration','$at','container']};}};
            $$nestableDeclaration.$prop$getToplevel={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:NestableDeclaration$meta$declaration,$an:function(){return[doc(String$("True if this declaration is a toplevel declaration.",51)),shared(),formal()];},d:['ceylon.language.meta.declaration','NestableDeclaration','$at','toplevel']};}};
        })(NestableDeclaration$meta$declaration.$$.prototype);
    }
    return NestableDeclaration$meta$declaration;
}
exports.$init$NestableDeclaration$meta$declaration=$init$NestableDeclaration$meta$declaration;
$init$NestableDeclaration$meta$declaration();
defineAttr(NestableDeclaration$meta$declaration.$$.prototype,'actual',function(){
  return $findAnnotation(this.tipo,ActualAnnotation)!==null;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:NestableDeclaration$meta$declaration,d:['ceylon.language.meta.declaration','NestableDeclaration','$at','actual']};});
defineAttr(NestableDeclaration$meta$declaration.$$.prototype,'formal',function(){
  return $findAnnotation(this.tipo,FormalAnnotation)!==null;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:NestableDeclaration$meta$declaration,d:['ceylon.language.meta.declaration','NestableDeclaration','$at','formal']};});
defineAttr(NestableDeclaration$meta$declaration.$$.prototype,'$default',function(){
  return $findAnnotation(this.tipo,DefaultAnnotation)!==null;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:NestableDeclaration$meta$declaration,d:['ceylon.language.meta.declaration','NestableDeclaration','$at','default']};});
defineAttr(NestableDeclaration$meta$declaration.$$.prototype,'shared',function(){
  return $findAnnotation(this.tipo,SharedAnnotation)!==null;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:NestableDeclaration$meta$declaration,d:['ceylon.language.meta.declaration','NestableDeclaration','$at','shared']};});

function GenericDeclaration$meta$declaration($$genericDeclaration){
}
GenericDeclaration$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$an:function(){return[doc(String$("A declaration that can have type parameters.",44)),shared()];},d:['ceylon.language.meta.declaration','GenericDeclaration']};};
exports.GenericDeclaration$meta$declaration=GenericDeclaration$meta$declaration;
function $init$GenericDeclaration$meta$declaration(){
    if (GenericDeclaration$meta$declaration.$$===undefined){
        initTypeProtoI(GenericDeclaration$meta$declaration,'ceylon.language.meta.declaration::GenericDeclaration');
        (function($$genericDeclaration){
            $$genericDeclaration.$prop$getTypeParameterDeclarations={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:TypeParameter$meta$declaration}}},$cont:GenericDeclaration$meta$declaration,$an:function(){return[doc(String$("The list of type parameters declared on this generic declaration.",65)),shared(),formal()];},d:['ceylon.language.meta.declaration','GenericDeclaration','$at','typeParameterDeclarations']};}};
            $$genericDeclaration.getTypeParameterDeclaration={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:TypeParameter$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:GenericDeclaration$meta$declaration,$an:function(){return[doc("Finds a type parameter by name. Returns `null` if not found."),shared(),formal()];},d:['ceylon.language.meta.declaration','GenericDeclaration','$m','getTypeParameterDeclaration']};}};
        })(GenericDeclaration$meta$declaration.$$.prototype);
    }
    return GenericDeclaration$meta$declaration;
}
exports.$init$GenericDeclaration$meta$declaration=$init$GenericDeclaration$meta$declaration;
$init$GenericDeclaration$meta$declaration();
//Addendum to GenericDeclaration
defineAttr(GenericDeclaration$meta$declaration.$$.prototype,'typeParameterDeclarations',function(){
  if (this.tipo) {
    var mm=this.tipo.$$metamodel$$;
    if (typeof(mm)==='function') {
      mm=mm(); this.tipo.$$metamodel$$=mm;
    }
    var tps=mm.$tp;
    if (tps) {
      var rv=[];
      for (var tp in tps) {
        rv.push(OpenTypeParam(this.tipo,tp));
      }
      return rv.reifyCeylonType({Absent:{t:Null},Element:{t:TypeParameter$meta$declaration}});
    }
    return getEmpty();
  }
  console.log("TODO GenericDeclaration.typeParameterDeclarations");
  return getEmpty();
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:TypeParameter$meta$declaration}}},$cont:GenericDeclaration,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','GenericDeclaration','$at','typeParameterDeclarations']};});
GenericDeclaration$meta$declaration.$$.prototype.getTypeParameterDeclaration=function (name$14){
  if (this.tipo) {
    var mm=this.tipo.$$metamodel$$;
    if (typeof(mm)==='function') {
      mm=mm(); this.tipo.$$metamodel$$=mm;
    }
    var tps=mm.$tp;
    if (tps) {
      for (var tp in tps) {
        if (name$14.equals(tp)) {
          return OpenTypeParam(this.tipo,tp);
        }
      }
    }
    return null;
  }
  console.log("TODO GenericDeclaration.getTypeParameterDeclaration(" + name$14 + ")");
  return null;
};
GenericDeclaration$meta$declaration.$$.prototype.getTypeParameterDeclaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:TypeParameter$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$}}],$cont:GenericDeclaration,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','GenericDeclaration','$m','getTypeParameterDeclaration']};};
 
function ClassOrInterfaceDeclaration$meta$declaration($$classOrInterfaceDeclaration){
    NestableDeclaration$meta$declaration($$classOrInterfaceDeclaration);
    GenericDeclaration$meta$declaration($$classOrInterfaceDeclaration);
}
ClassOrInterfaceDeclaration$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:NestableDeclaration$meta$declaration},{t:GenericDeclaration$meta$declaration}],of:[{t:ClassDeclaration$meta$declaration},{t:InterfaceDeclaration$meta$declaration}],$an:function(){return[doc(String$("A class or interface declaration.\n\n<a name=\"toplevel-sample\"></a>\n### Usage sample for toplevel classes\n\nBecause some classes have type parameters, getting a model requires applying type arguments to the\nclass declaration with [[apply]] in order to be able to instantiate that class. For example, here is how you would\nobtain a class or interface model that you can instantiate from a toplevel class declaration:\n\n    class Foo<T>() {\n        string => \"Hello, our T is: ``typeLiteral<T>()``\";\n    }\n    \n    void test(){\n        // We need to apply the Integer closed type to the Foo declaration in order to get the Foo<Integer> closed type\n        ClassOrInterface<Foo<Integer>> classOrInterfaceModel = `class Foo`.apply<Foo<Integer>>(`Integer`);\n        assert(is Class<Foo<Integer>,[]> classOrInterfaceModel);\n        // This will print: Hello, our T is: ceylon.language::Integer\n        print(classOrInterfaceModel());\n    }\n\nNote that there are more specialised versions of [[apply]] in [[ClassDeclaration.classApply]] and \n[[InterfaceDeclaration.interfaceApply]].\n\n<a name=\"member-sample\"></a>\n### Usage sample for member classes\n\nFor member classes or interfaces it is a bit longer, because member types need to be applied not only their type arguments but also\nthe containing type, so you should use [[memberApply]] and start by giving the containing closed type:\n\n    class Outer(){\n        shared class Inner(){\n            string => \"Hello\";\n        }\n    }\n\n    void test(){\n        // apply the containing closed type `Outer` to the member class declaration `Outer.Inner`\n        value memberClassModel = `class Outer.Inner`.memberApply<Outer,Outer.Inner>(`Outer`);\n        assert(is MemberClass<Outer,Outer.Inner,[]> memberClassModel);\n        // We now have a MemberClass, which needs to be applied to a containing instance in order to become an\n        // invokable class model:\n        Class<Outer.Inner,[]> boundMemberClassModel = memberClassModel(Outer());\n        // This will print: Hello\n        print(boundMemberClassModel());\n    }\n\nNote that there are more specialised versions of [[memberApply]] in [[ClassDeclaration.memberClassApply]] and \n[[InterfaceDeclaration.memberInterfaceApply]].\n",2216)),shared()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration']};};
exports.ClassOrInterfaceDeclaration$meta$declaration=ClassOrInterfaceDeclaration$meta$declaration;
function $init$ClassOrInterfaceDeclaration$meta$declaration(){
    if (ClassOrInterfaceDeclaration$meta$declaration.$$===undefined){
        initTypeProtoI(ClassOrInterfaceDeclaration$meta$declaration,'ceylon.language.meta.declaration::ClassOrInterfaceDeclaration',$init$NestableDeclaration$meta$declaration(),$init$GenericDeclaration$meta$declaration());
        (function($$classOrInterfaceDeclaration){
            $$classOrInterfaceDeclaration.$prop$getExtendedType={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:OpenClassType$meta$declaration}]},$cont:ClassOrInterfaceDeclaration$meta$declaration,$an:function(){return[doc(String$("This type\'s extended type, unless this is the class for [[Anything|ceylon.language::Anything]], which\nis the root of the type hierarchy and thus does not have any extended type.",177)),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$at','extendedType']};}};
            $$classOrInterfaceDeclaration.$prop$getSatisfiedTypes={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:OpenInterfaceType$meta$declaration}}},$cont:ClassOrInterfaceDeclaration$meta$declaration,$an:function(){return[doc(String$("The list of types satisfied by this type.",41)),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$at','satisfiedTypes']};}};
            $$classOrInterfaceDeclaration.$prop$getCaseTypes={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:OpenType$meta$declaration}}},$cont:ClassOrInterfaceDeclaration$meta$declaration,$an:function(){return[doc(String$("If this type has an `of` clause, this is the list of case types for the current type.",85)),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$at','caseTypes']};}};
            $$classOrInterfaceDeclaration.$prop$getIsAlias={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ClassOrInterfaceDeclaration$meta$declaration,$an:function(){return[doc(String$("True if this type is an alias type, in which case the [[extendedType]] will \ncontain the substituted type.",106)),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$at','isAlias']};}};
            $$classOrInterfaceDeclaration.memberDeclarations={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Kind'}},$ps:[],$cont:ClassOrInterfaceDeclaration$meta$declaration,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]}},$an:function(){return[doc("Returns the list of member declarations that satisfy the given `Kind` type argument."),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$m','memberDeclarations']};}};$$classOrInterfaceDeclaration.declaredMemberDeclarations={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Kind'}},$ps:[],$cont:ClassOrInterfaceDeclaration$meta$declaration,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]}},$an:function(){return[doc("Returns the list of member declarations that satisfy the given `Kind` type argument."),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$m','declaredMemberDeclarations']};}};$$classOrInterfaceDeclaration.annotatedMemberDeclarations={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Kind'}},$ps:[],$cont:ClassOrInterfaceDeclaration$meta$declaration,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]},Annotation:{}},$an:function(){return[doc("Returns the list of member declarations that satisfy the given `Kind` type argument and\nthat are annotated with the given `Annotation` type argument"),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$m','annotatedMemberDeclarations']};}};$$classOrInterfaceDeclaration.annotatedDeclaredMemberDeclarations={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Kind'}},$ps:[],$cont:ClassOrInterfaceDeclaration$meta$declaration,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]},Annotation:{}},$an:function(){return[doc("Returns the list of member declarations that satisfy the given `Kind` type argument and\nthat are annotated with the given `Annotation` type argument"),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$m','annotatedDeclaredMemberDeclarations']};}};$$classOrInterfaceDeclaration.getMemberDeclaration={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Kind']},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:ClassOrInterfaceDeclaration$meta$declaration,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]}},$an:function(){return[doc("Looks up a member declaration by name, provided it satisfies the given `Kind` type\nargument. Returns `null` if no such member matches."),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$m','getMemberDeclaration']};}};$$classOrInterfaceDeclaration.getDeclaredMemberDeclaration={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Kind']},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:ClassOrInterfaceDeclaration$meta$declaration,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]}},$an:function(){return[doc("Looks up a member declaration by name, provided it satisfies the given `Kind` type\nargument. Returns `null` if no such member matches."),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$m','getDeclaredMemberDeclaration']};}};$$classOrInterfaceDeclaration.$apply={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:ClassOrInterface$meta$model,a:{Type:'Type'}},$ps:[{$nm:'typeArguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassOrInterfaceDeclaration$meta$declaration,$tp:{Type:{'def':{t:Anything}}},$an:function(){return[doc("Applies the given closed type arguments to this toplevel class or interface declaration in order to obtain a class or interface model. \nSee [this code sample](#toplevel-sample) for an example on how to use this."),$throws("IncompatibleTypeException","If the specified `Type` type argument is not compatible with the actual result."),$throws("TypeApplicationException","If the specified closed type argument values are not compatible with the actual result\'s type parameters."),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$m','apply']};}};$$classOrInterfaceDeclaration.memberApply={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'i', l:[{t:Member$meta$model,a:{Container:'Container',Kind:{t:ClassOrInterface$meta$model,a:{Type:'Type'}}}},{t:ClassOrInterface$meta$model,a:{Type:'Type'}}]},$ps:[{$nm:'containerType',$mt:'prm',$t:{t:Type$meta$model,a:{Type:'Container'}},$an:function(){return[];}},{$nm:'typeArguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassOrInterfaceDeclaration$meta$declaration,$tp:{Container:{'def':{t:Nothing}},Type:{'def':{t:Anything}}},$an:function(){return[doc("Applies the given closed container type and type arguments to this member class or interface declaration in order to obtain a \nmember class or interface model. See [this code sample](#member-sample) for an example on how to use this."),$throws("IncompatibleTypeException","If the specified `Container` or `Type` type arguments are not compatible with the actual result."),$throws("TypeApplicationException","If the specified closed container type or type argument values are not compatible with the actual result\'s container type or type parameters."),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$m','memberApply']};}};
        })(ClassOrInterfaceDeclaration$meta$declaration.$$.prototype);
    }
    return ClassOrInterfaceDeclaration$meta$declaration;
}
exports.$init$ClassOrInterfaceDeclaration$meta$declaration=$init$ClassOrInterfaceDeclaration$meta$declaration;
$init$ClassOrInterfaceDeclaration$meta$declaration();
function FunctionalDeclaration$meta$declaration($$functionalDeclaration){
}
FunctionalDeclaration$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$an:function(){return[doc(String$("Declaration which can be invoked, and may have parameters. Classes\nand functions are functional declarations.\n\nNote that multiple-parameter lists are not reified at runtime, so if you\nhave a function declaration like this:\n\n    Integer add(Integer a)(Integer b) => a + b;\n\nIt will only have a single parameter list at runtime (the first), and its return\ntype will be `Callable<Integer,[Integer]>`.\n",398)),shared()];},d:['ceylon.language.meta.declaration','FunctionalDeclaration']};};
exports.FunctionalDeclaration$meta$declaration=FunctionalDeclaration$meta$declaration;
function $init$FunctionalDeclaration$meta$declaration(){
    if (FunctionalDeclaration$meta$declaration.$$===undefined){
        initTypeProtoI(FunctionalDeclaration$meta$declaration,'ceylon.language.meta.declaration::FunctionalDeclaration');
        (function($$functionalDeclaration){
            $$functionalDeclaration.$prop$getAnnotation={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunctionalDeclaration$meta$declaration,$an:function(){return[doc(String$("True if the current declaration is an annotation class or function.",67)),shared(),formal()];},d:['ceylon.language.meta.declaration','FunctionalDeclaration','$at','annotation']};}};
            $$functionalDeclaration.$prop$getParameterDeclarations={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:FunctionOrValueDeclaration$meta$declaration}}},$cont:FunctionalDeclaration$meta$declaration,$an:function(){return[doc(String$("The list of parameter declarations for this functional declaration.",67)),shared(),formal()];},d:['ceylon.language.meta.declaration','FunctionalDeclaration','$at','parameterDeclarations']};}};
            $$functionalDeclaration.getParameterDeclaration={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:FunctionOrValueDeclaration$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:FunctionalDeclaration$meta$declaration,$an:function(){return[doc("Gets a parameter declaration by name. Returns `null` if no such parameter exists."),shared(),formal()];},d:['ceylon.language.meta.declaration','FunctionalDeclaration','$m','getParameterDeclaration']};}};
        })(FunctionalDeclaration$meta$declaration.$$.prototype);
    }
    return FunctionalDeclaration$meta$declaration;
}
exports.$init$FunctionalDeclaration$meta$declaration=$init$FunctionalDeclaration$meta$declaration;
$init$FunctionalDeclaration$meta$declaration();
//Addendum to model.declaration.ClassOrInterfaceDeclaration
ClassOrInterfaceDeclaration$meta$declaration.$$.prototype.getMemberDeclaration=function(name$20,$$$mptypes,noInherit){
  var _m=undefined;
  if (extendsType($$$mptypes.Kind, {t:ValueDeclaration$meta$declaration})) {
    var _d = this.tipo.$$.prototype['$prop$get'+name$20[0].toUpperCase()+name$20.substring(1)];
    if (_d){
      if (noInherit) {
        var mm=_d.$$metamodel$$;
        if (typeof(mm)==='function'){mm=mm();_d.$$metamodel$$=mm;}
        if (mm.$cont!==this.tipo)return null;
      }
      _m=OpenValue(this.containingPackage, _d);
    }
  }
  if (!_m && extendsType($$$mptypes.Kind, {t:FunctionDeclaration$meta$declaration})) {
    var nom=name$20;
    if (this.tipo===String$ && ['split','replace','filter','every','map','sort'].indexOf(nom)>=0)nom='$'+nom;
    var _d = this.tipo.$$.prototype[nom];
    if(_d){
      if (noInherit) {
        var mm=_d.$$metamodel$$;
        if (typeof(mm)==='function'){mm=mm();_d.$$metamodel$$=mm;}
        if (mm.$cont!==this.tipo)return null;
      }
      _m=OpenFunction(this.containingPackage, _d);
    }
  }
  if (!_m && extendsType($$$mptypes.Kind, {t:ClassOrInterfaceDeclaration$meta$declaration})) {
    var nom=name$20+'$'+this.name;
    var _d = this.tipo.$$.prototype[nom];
    if (!_d) {
      if (noInherit)return null;
      var pere=this.tipo.$$metamodel$$['super'];
      while (!_d && pere) {
        var mm=pere.t.$$metamodel$$;
        if (typeof(mm)==='function'){mm=mm();pere.t.$$metamodel$$=mm;}
        nom=mm&&mm.d?name$20+'$'+mm.d[mm.d.length-1]:undefined;
        if(nom)_d=this.tipo.$$.prototype[nom];
        if (!_d)pere=mm['super'];
      }
    }
    if(_d){
      var wantsClass=extendsType($$$mptypes.Kind,{t:ClassDeclaration$meta$declaration});
      var wantsIface=extendsType($$$mptypes.Kind,{t:InterfaceDeclaration$meta$declaration});
      if (typeof(_d.$$metamodel$$)==='function')_d.$$metamodel$$=_d.$$metamodel$$();
      var _mdl=get_model(_d.$$metamodel$$);
      if ((wantsClass && _mdl.$mt!=='cls') || (wantsIface && _mdl.$mt!=='ifc'))return null;
      _m=(_mdl.$mt==='cls'?OpenClass:OpenInterface)(this.containingPackage, _d);
    }
  }
  if (_m) {
    _m.$parent=this;
    return _m;
  }
  return null;
};
ClassOrInterfaceDeclaration$meta$declaration.$$.prototype.getMemberDeclaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},'Kind']},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$}}],$cont:OpenClass,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$m','getMemberDeclaration']};};
ClassOrInterfaceDeclaration$meta$declaration.$$.prototype.getDeclaredMemberDeclaration=function(nm,$mptypes){
  return this.getMemberDeclaration(nm,$mptypes,1);
}
ClassOrInterfaceDeclaration$meta$declaration.$$.prototype.getDeclaredMemberDeclaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},'Kind']},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$}}],$cont:OpenClass,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$m','getDeclaredMemberDeclaration']};};
defineAttr(FunctionalDeclaration$meta$declaration.$$.prototype,'parameterDeclarations',function(){
  var that=this;
  var parms = that.tipo.$$metamodel$$.$ps;
  if (!parms || parms.length === 0)return getEmpty();
  var rv = [];
  for (var i=0; i<parms.length;i++) {
    var p = parms[i];
    if (p.$pt === 'f') {
      rv.push(FunParamDecl(this,p));
    } else {
      rv.push(ValParamDecl(this,p));
    }
  }
  return rv.reifyCeylonType({Element:{t:FunctionOrValueDeclaration$meta$declaration},Absent:{t:Null}});
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:FunctionOrValueDeclaration$meta$declaration}}},$cont:FunctionalDeclaration$meta$declaration,$an:function(){return[shared(),formal()];},d:['ceylon.language.meta.declaration','FunctionalDeclaration','$at','parameterDeclarations']};});
ClassOrInterfaceDeclaration$meta$declaration.$$.prototype.memberDeclarations=function($$$mptypes){
  var filter;
  var defs=[];
  if (extendsType({t:FunctionDeclaration$meta$declaration},$$$mptypes.Kind)) {
    for (var df in this.meta['$m']) {
      defs.push(this.meta['$m'][df]);
    }
  }
  if (extendsType({t:ValueDeclaration$meta$declaration},$$$mptypes.Kind)) {
    for (var df in this.meta['$at']) {
      defs.push(this.meta['$at'][df]);
    }
  }
  if (extendsType({t:InterfaceDeclaration$meta$declaration},$$$mptypes.Kind)) {
    for (var df in this.meta['$i']) {
      defs.push(this.meta['$i'][df]);
    }
  }
  if (extendsType({t:ClassDeclaration$meta$declaration},$$$mptypes.Kind)) {
    for (var df in this.meta['$c']) {
      defs.push(this.meta['$c'][df]);
    }
  }
  var pkg = this.containingPackage;
  var r=[];
  for (var i=0; i<defs.length; i++) {
    var m=defs[i];
    var mt = m['$mt'];
    var _d;
    if (mt === 'mthd') {
      _d=this.getMemberDeclaration(m.$nm, {Kind:{t:FunctionDeclaration$meta$declaration}});
    } else if (mt==='cls') {
      _d=this.getMemberDeclaration(m.$nm, {Kind:{t:ClassDeclaration$meta$declaration}});
    } else if (mt==='ifc') {
      _d=this.getMemberDeclaration(m.$nm, {Kind:{t:InterfaceDeclaration$meta$declaration}});
    } else if (mt==='attr'||mt==='gttr'||mt==='obj') {
      _d=this.getMemberDeclaration(m.$nm, {Kind:{t:ValueDeclaration$meta$declaration}});
    }
    if (_d) {
      _d.$parent=this;
      r.push(_d);
    }
  }
  return r.reifyCeylonType({Element:$$$mptypes.Kind});
};
ClassOrInterfaceDeclaration$meta$declaration.$$.prototype.memberDeclarations.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Kind'}},$ps:[],$cont:OpenInterface,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$m','memberDeclarations']};};
defineAttr(ClassOrInterfaceDeclaration$meta$declaration.$$.prototype,'caseTypes',function(){
  var casos = this.tipo.$$metamodel$$.of;
  if (casos && casos.length > 0) {
    var ct = [];
    for (var i=0; i < casos.length; i++) {
      if (typeof(casos[i])==='string') {
        ct.push(OpenTvar(OpenTypeParam(this, casos[i])));
      } else {
        ct.push(_openTypeFromTarg(casos[i]));
      }
    }
    return ct.reifyCeylonType({Element:{t:OpenType$meta$declaration}});
  }
  return getEmpty();
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:OpenType$meta$declaration}}},$cont:ClassOrInterfaceDeclaration$meta$declaration,$an:function(){return[shared(),formal()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$at','caseTypes']};});
ClassOrInterfaceDeclaration$meta$declaration.$$.prototype.$apply=function(types,$mptypes){
  var _t = {t:this.tipo};
  if (typeof(this.tipo.$$metamodel$$)==='function') {
    this.tipo.$$metamodel$$=this.tipo.$$metamodel$$();
  }
  validate$typeparams(_t,this.tipo.$$metamodel$$.$tp,types);
  if (!extendsType(_t, $mptypes.Type))
    throw IncompatibleTypeException$meta$model(String$("Type argument for 'Type' must be a supertype of " + this));
  var rv=this.meta.$mt==='ifc'?AppliedInterface(_t.t, $mptypes):AppliedClass(_t.t, $mptypes);
  if (_t.a)rv.$targs=_t.a;
  return rv;
}
ClassOrInterfaceDeclaration$meta$declaration.$$.prototype.$apply.$$metamodel$$=function(){return{mod:$$METAMODEL$$,d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$m','apply']};};
ClassOrInterfaceDeclaration$meta$declaration.$$.prototype.memberApply=function(cont, types,$mptypes) {
  var mm=this.tipo.$$metamodel$$;
  if (typeof(mm)==='function') {
    mm=mm(); this.tipo.$$metamodel$$=mm();
  }
  if (!extendsType({t:cont.tipo},{t:mm.$cont}))throw IncompatibleTypeException$meta$model("Incompatible Container type");
  var _t = {t:this.tipo};
  validate$typeparams(_t,mm.$tp,types);
  if (!extendsType(_t, $mptypes.Type))
    throw IncompatibleTypeException$meta$model(String$("Type argument for 'Type' must be a supertype of " + this));
  var rv=this.meta.$mt==='ifc'?AppliedMemberInterface(_t.t, {Container:$mptypes.Container, Type:_t})
    :AppliedMemberClass(_t.t, {Container:$mptypes.Container, Type:_t, Arguments:$mptypes.Arguments});
  if (_t.a)rv.$targs=_t.a;
  return rv;
};ClassOrInterfaceDeclaration$meta$declaration.$$.prototype.memberApply.$$metamodel$$=function(){return{mod:$$METAMODEL$$,d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$m','memberApply']};};
defineAttr(ClassOrInterfaceDeclaration$meta$declaration.$$.prototype,'container',function(){
  if (this.$parent)return this.$parent;
  var mm=this.tipo.$$metamodel$$;
  if (typeof(mm)==='function'){mm=mm();this.tipo.$$metamodel$$=mm;}
  if (mm.$cont) {
    return typeLiteral$meta({Type:mm.$cont});
  }
  return this.containingPackage;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u',l:[{t:NestableDeclaration$meta$declaration},{t:Package$meta$declaration}]},d:['ceylon.language.meta.declaration.NestableDeclaration','$at','container']};});
ClassOrInterfaceDeclaration$meta$declaration.$$.prototype.annotatedMemberDeclarations=function($$$mptypes,list){
  if (list===undefined)list=this.memberDeclarations({Kind:$$$mptypes.Kind});
  if (list.length) {
    var rv=[];
    for (var i=0; i < list.length; i++) {
      var mm = list[i].tipo.$$metamodel$$;
      if (typeof(mm)==='function'){mm=mm();list[i].tipo.$$metamodel$$=mm;}
      var anns = mm.$an;
      if (typeof(anns)==='function'){anns=anns();mm.$an=anns;}
      for (var j=0; j<anns.length; j++) {
        if (isOfType(anns[j],$$$mptypes.Annotation)) {
          rv.push(list[i]);
          break;
        }
      }
    }
    if (rv.length)return rv.reifyCeylonType({Element:$$$mptypes.Kind});
  }
  return getEmpty();
};
ClassOrInterfaceDeclaration$meta$declaration.$$.prototype.annotatedMemberDeclarations.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Kind'}},$ps:[],$cont:ClassOrInterfaceDeclaration$meta$declarationl,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]},Annotation:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$m','annotatedMemberDeclarations']};};
ClassOrInterfaceDeclaration$meta$declaration.$$.prototype.annotatedDeclaredMemberDeclarations=function ($$$mptypes){
  return this.annotatedMemberDeclarations($$$mptypes,this.memberDeclarations({Kind:$$$mptypes.Kind}));
};
ClassOrInterfaceDeclaration$meta$declaration.$$.prototype.annotatedDeclaredMemberDeclarations.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Kind'}},$ps:[],$cont:ClassOrInterfaceDeclaration$meta$declarationl,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]},Annotation:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassOrInterfaceDeclaration','$m','annotatedDeclaredMemberDeclarations']};};

function FunctionOrValueDeclaration$meta$declaration($$functionOrValueDeclaration){
    NestableDeclaration$meta$declaration($$functionOrValueDeclaration);
}
FunctionOrValueDeclaration$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:NestableDeclaration$meta$declaration}],of:[{t:FunctionDeclaration$meta$declaration},{t:ValueDeclaration$meta$declaration}],$an:function(){return[doc(String$("A function or value declaration.",32)),shared()];},d:['ceylon.language.meta.declaration','FunctionOrValueDeclaration']};};
exports.FunctionOrValueDeclaration$meta$declaration=FunctionOrValueDeclaration$meta$declaration;
function $init$FunctionOrValueDeclaration$meta$declaration(){
    if (FunctionOrValueDeclaration$meta$declaration.$$===undefined){
        initTypeProtoI(FunctionOrValueDeclaration$meta$declaration,'ceylon.language.meta.declaration::FunctionOrValueDeclaration',$init$NestableDeclaration$meta$declaration());
        (function($$functionOrValueDeclaration){
            $$functionOrValueDeclaration.$prop$getParameter={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunctionOrValueDeclaration$meta$declaration,$an:function(){return[doc(String$("True if this function or value is a parameter to a [[FunctionalDeclaration]].",77)),shared(),formal()];},d:['ceylon.language.meta.declaration','FunctionOrValueDeclaration','$at','parameter']};}};
            $$functionOrValueDeclaration.$prop$getDefaulted={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunctionOrValueDeclaration$meta$declaration,$an:function(){return[doc(String$("True if this function or value is a parameter and has a default value.",70)),shared(),formal()];},d:['ceylon.language.meta.declaration','FunctionOrValueDeclaration','$at','defaulted']};}};
            $$functionOrValueDeclaration.$prop$getVariadic={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunctionOrValueDeclaration$meta$declaration,$an:function(){return[doc(String$("True if this function or value is a parameter and is variadic (accepts a list of values).",89)),shared(),formal()];},d:['ceylon.language.meta.declaration','FunctionOrValueDeclaration','$at','variadic']};}};
        })(FunctionOrValueDeclaration$meta$declaration.$$.prototype);
    }
    return FunctionOrValueDeclaration$meta$declaration;
}
exports.$init$FunctionOrValueDeclaration$meta$declaration=$init$FunctionOrValueDeclaration$meta$declaration;
$init$FunctionOrValueDeclaration$meta$declaration();
function ValueDeclaration$meta$declaration($$valueDeclaration){
    FunctionOrValueDeclaration$meta$declaration($$valueDeclaration);
}
ValueDeclaration$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:FunctionOrValueDeclaration$meta$declaration}],$an:function(){return[doc(String$("A value declaration.\n\n<a name=\"toplevel-sample\"></a>\n### Usage sample for toplevel value\n\nGetting a model requires applying type arguments to the\nvalue declaration with [[apply]] in order to be able to read that value. For example, here is how you would\nobtain a value model that you can read from a toplevel attribute declaration:\n\n    String foo = \"Hello\";\n    \n    void test(){\n        // We need to apply the the foo declaration in order to get the foo value model\n        Value<String> valueModel = `value foo`.apply<String>();\n        // This will print: Hello\n        print(valueModel.get());\n    }\n\n<a name=\"member-sample\"></a>\n### Usage sample for attributes\n\nFor attributes it is a bit longer, because attributes need to be applied the containing type, so you should \nuse [[memberApply]] and start by giving the containing closed type:\n\n    class Outer(){\n        shared String foo => \"Hello\";\n    }\n\n    void test(){\n        // Apply the containing closed type `Outer` to the attribute declaration `Outer.foo`\n        Attribute<Outer,String> valueModel = `value Outer.foo`.memberApply<Outer,String>(`Outer`);\n        // We now have an Attribute, which needs to be applied to a containing instance in order to become a\n        // readable value:\n        Value<String> boundValueModel = valueModel(Outer());\n        // This will print: Hello\n        print(boundValueModel.get());\n    }\n",1395)),shared()];},d:['ceylon.language.meta.declaration','ValueDeclaration']};};
exports.ValueDeclaration$meta$declaration=ValueDeclaration$meta$declaration;
function $init$ValueDeclaration$meta$declaration(){
    if (ValueDeclaration$meta$declaration.$$===undefined){
        initTypeProtoI(ValueDeclaration$meta$declaration,'ceylon.language.meta.declaration::ValueDeclaration',$init$FunctionOrValueDeclaration$meta$declaration());
        (function($$valueDeclaration){
            $$valueDeclaration.$prop$getVariable={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ValueDeclaration$meta$declaration,$an:function(){return[doc(String$("True if this declaration is annotated with [[variable|ceylon.language::variable]].",82)),shared(),formal()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','variable']};}};
            $$valueDeclaration.$apply={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Value$meta$model,a:{Set:'Set',Get:'Get'}},$ps:[],$cont:ValueDeclaration$meta$declaration,$tp:{Get:{'def':{t:Anything}},Set:{'def':{t:Nothing}}},$an:function(){return[doc("Applies this value declaration in order to obtain a value model. \nSee [this code sample](#toplevel-sample) for an example on how to use this."),$throws("IncompatibleTypeException","If the specified `Get` or `Set` type arguments are not compatible with the actual result."),shared(),formal()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$m','apply']};}};$$valueDeclaration.memberApply={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Attribute$meta$model,a:{Set:'Set',Get:'Get',Container:'Container'}},$ps:[{$nm:'containerType',$mt:'prm',$t:{t:Type$meta$model,a:{Type:'Container'}},$an:function(){return[];}}],$cont:ValueDeclaration$meta$declaration,$tp:{Container:{'def':{t:Nothing}},Get:{'def':{t:Anything}},Set:{'def':{t:Nothing}}},$an:function(){return[doc("Applies the given closed container type to this attribute declaration in order to obtain an attribute model. \nSee [this code sample](#member-sample) for an example on how to use this."),$throws("IncompatibleTypeException","If the specified `Container`, `Get` or `Set` type arguments are not compatible with the actual result."),shared(),formal()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$m','memberApply']};}};$$valueDeclaration.$get=function (){
                var $$valueDeclaration=this;
                return $$valueDeclaration.$apply({Set:{t:Nothing},Get:{t:Anything}}).$get();
            };
            $$valueDeclaration.$get.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[],$cont:ValueDeclaration$meta$declaration,$an:function(){return[doc(String$("Reads the current value of this toplevel value.",47)),shared(),$default()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$m','get']};};
            $$valueDeclaration.memberGet=function (container$1016){
                var $$valueDeclaration=this;
                return $$valueDeclaration.memberApply(getNothingType$meta$model(),{Set:{t:Nothing},Get:{t:Anything},Container:{t:Nothing}}).$bind(container$1016).$get();
            };
            $$valueDeclaration.memberGet.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[{$nm:'container',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:ValueDeclaration$meta$declaration,$an:function(){return[doc(String$("Reads the current value of this attribute on the given container instance.",74)),$throws($init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language.meta.model'),IncompatibleTypeException$meta$model),String$("If the specified container is not compatible with this attribute.",65)),shared(),$default()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$m','memberGet']};};
            $$valueDeclaration.set=function (newValue$1017){
                var $$valueDeclaration=this;
                return $$valueDeclaration.$apply({Set:{t:Nothing},Get:{t:Anything}}).setIfAssignable(newValue$1017);
            };
            $$valueDeclaration.set.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[{$nm:'newValue',$mt:'prm',$t:{t:Anything},$an:function(){return[];}}],$cont:ValueDeclaration$meta$declaration,$an:function(){return[doc(String$("Sets the current value of this toplevel value.",46)),shared(),$default()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$m','set']};};
            $$valueDeclaration.memberSet={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[{$nm:'container',$mt:'prm',$t:{t:Object$},$an:function(){return[];}},{$nm:'newValue',$mt:'prm',$t:{t:Anything},$an:function(){return[];}}],$cont:ValueDeclaration$meta$declaration,$an:function(){return[doc("Sets the current value of this attribute on the given container instance."),$throws("IncompatibleTypeException","If the specified container or new value type is not compatible with this attribute."),shared(),formal()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$m','memberSet']};}};$$valueDeclaration.$prop$getSetter={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:SetterDeclaration$meta$declaration},$cont:ValueDeclaration$meta$declaration,$an:function(){return[doc(String$("Returns the setter declaration for this variable.\n\nFor modelling purposes `variable` reference \nvalues have a SetterDeclaration even though there is no \nsuch setter explicit in the source code.",193)),shared(),formal()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','setter']};}};
        })(ValueDeclaration$meta$declaration.$$.prototype);
    }
    return ValueDeclaration$meta$declaration;
}
exports.$init$ValueDeclaration$meta$declaration=$init$ValueDeclaration$meta$declaration;
$init$ValueDeclaration$meta$declaration();
function ClassDeclaration$meta$declaration($$classDeclaration){
    ClassOrInterfaceDeclaration$meta$declaration($$classDeclaration);
    FunctionalDeclaration$meta$declaration($$classDeclaration);
}
ClassDeclaration$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:ClassOrInterfaceDeclaration$meta$declaration},{t:FunctionalDeclaration$meta$declaration}],$an:function(){return[doc(String$("Class declaration.\n\n<a name=\"toplevel-sample\"></a>\n### Usage sample for toplevel classes\n\nBecause some classes have type parameters, getting a model requires applying type arguments to the\nclass declaration with [[classApply]] in order to be able to instantiate that class. For example, here is how you would\nobtain a class model that you can instantiate from a toplevel class declaration:\n\n    class Foo<T>(){\n        string => \"Hello, our T is: ``typeLiteral<T>()``\";\n    }\n    \n    void test(){\n        // We need to apply the Integer closed type to the Foo declaration in order to get the Foo<Integer> closed type\n        Class<Foo<Integer>,[]> classModel = `class Foo`.classApply<Foo<Integer>,[]>(`Integer`);\n        // This will print: Hello, our T is: ceylon.language::Integer\n        print(classModel());\n    }\n\n<a name=\"member-sample\"></a>\n### Usage sample for member classes\n\nFor member classes it is a bit longer, because member classes need to be applied not only their type arguments but also\nthe containing type, so you should use [[memberClassApply]] and start by giving the containing closed type:\n\n    class Outer(){\n        shared class Inner(){\n            string => \"Hello\";\n        }\n    }\n\n    void test(){\n        // apply the containing closed type `Outer` to the member class declaration `Outer.Inner`\n        MemberClass<Outer,Outer.Inner,[]> memberClassModel = `class Outer.Inner`.memberClassApply<Outer,Outer.Inner,[]>(`Outer`);\n        // We now have a MemberClass, which needs to be applied to a containing instance in order to become an\n        // invokable class model:\n        Class<Outer.Inner,[]> boundMemberClassModel = memberClassModel(Outer());\n        // This will print: Hello\n        print(boundMemberClassModel());\n    }\n",1763)),shared()];},d:['ceylon.language.meta.declaration','ClassDeclaration']};};
exports.ClassDeclaration$meta$declaration=ClassDeclaration$meta$declaration;
function $init$ClassDeclaration$meta$declaration(){
    if (ClassDeclaration$meta$declaration.$$===undefined){
        initTypeProtoI(ClassDeclaration$meta$declaration,'ceylon.language.meta.declaration::ClassDeclaration',$init$ClassOrInterfaceDeclaration$meta$declaration(),$init$FunctionalDeclaration$meta$declaration());
        (function($$classDeclaration){
            $$classDeclaration.$prop$getAbstract={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ClassDeclaration$meta$declaration,$an:function(){return[doc(String$("True if the class has an [[abstract|ceylon.language::abstract]] annotation.",75)),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$at','abstract']};}};
            $$classDeclaration.$prop$getAnonymous={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ClassDeclaration$meta$declaration,$an:function(){return[doc(String$("True if the class is an object class.",37)),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$at','anonymous']};}};
            $$classDeclaration.$prop$getFinal={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ClassDeclaration$meta$declaration,$an:function(){return[doc(String$("True if the class has a [[final|ceylon.language::final]] annotation.",68)),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$at','final']};}};
            $$classDeclaration.classApply={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Class$meta$model,a:{Arguments:'Arguments',Type:'Type'}},$ps:[{$nm:'typeArguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassDeclaration$meta$declaration,$tp:{Type:{'def':{t:Anything}},Arguments:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},$an:function(){return[doc("Applies the given closed type arguments to this toplevel class declaration in order to obtain a class model. \nSee [this code sample](#toplevel-sample) for an example on how to use this."),$throws("IncompatibleTypeException","If the specified `Type` or `Arguments` type arguments are not compatible with the actual result."),$throws("TypeApplicationException","If the specified closed type argument values are not compatible with the actual result\'s type parameters."),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$m','classApply']};}};$$classDeclaration.memberClassApply={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:MemberClass$meta$model,a:{Arguments:'Arguments',Type:'Type',Container:'Container'}},$ps:[{$nm:'containerType',$mt:'prm',$t:{t:Type$meta$model,a:{Type:'Container'}},$an:function(){return[];}},{$nm:'typeArguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:ClassDeclaration$meta$declaration,$tp:{Container:{'def':{t:Nothing}},Type:{'def':{t:Anything}},Arguments:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},$an:function(){return[doc("Applies the given closed container type and type arguments to this member class declaration in order to obtain a member class model. \nSee [this code sample](#member-sample) for an example on how to use this."),$throws("IncompatibleTypeException","If the specified `Container`, `Type` or `Arguments` type arguments are not compatible with the actual result."),$throws("TypeApplicationException","If the specified closed container type or type argument values are not compatible with the actual result\'s container type or type parameters."),shared(),formal()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$m','memberClassApply']};}};$$classDeclaration.instantiate$defs$typeArguments=function(typeArguments$1018,arguments$1019){var $$classDeclaration=this;
            return getEmpty();};
            $$classDeclaration.instantiate=function (typeArguments$1018,arguments$1019){
                var $$classDeclaration=this;
                if(typeArguments$1018===undefined){typeArguments$1018=$$classDeclaration.instantiate$defs$typeArguments(typeArguments$1018,arguments$1019);}
                if(arguments$1019===undefined){arguments$1019=getEmpty();}
                return $$classDeclaration.classApply(typeArguments$1018,{Arguments:{t:Nothing},Type:{t:Anything}}).$apply(arguments$1019);
            };
            $$classDeclaration.instantiate.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[{$nm:'typeArguments',$mt:'prm',$def:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}},{$nm:'arguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Anything}}},$an:function(){return[];}}],$cont:ClassDeclaration$meta$declaration,$an:function(){return[doc(String$("Creates a new instance of this toplevel class, by applying the specified type arguments and value arguments.",108)),$throws($init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language.meta.model'),IncompatibleTypeException$meta$model),String$("If the specified type or value arguments are not compatible with this toplevel class.",85)),shared(),$default()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$m','instantiate']};};
            $$classDeclaration.memberInstantiate$defs$typeArguments=function(container$1020,typeArguments$1021,arguments$1022){var $$classDeclaration=this;
            return getEmpty();};
            $$classDeclaration.memberInstantiate=function (container$1020,typeArguments$1021,arguments$1022){
                var $$classDeclaration=this;
                if(typeArguments$1021===undefined){typeArguments$1021=$$classDeclaration.memberInstantiate$defs$typeArguments(container$1020,typeArguments$1021,arguments$1022);}
                if(arguments$1022===undefined){arguments$1022=getEmpty();}
                return $$classDeclaration.memberClassApply(getNothingType$meta$model(),typeArguments$1021,{Arguments:{t:Nothing},Type:{t:Anything},Container:{t:Nothing}}).$bind(container$1020).$apply(arguments$1022);
            };
            $$classDeclaration.memberInstantiate.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[{$nm:'container',$mt:'prm',$t:{t:Object$},$an:function(){return[];}},{$nm:'typeArguments',$mt:'prm',$def:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}},{$nm:'arguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Anything}}},$an:function(){return[];}}],$cont:ClassDeclaration$meta$declaration,$an:function(){return[doc(String$("Creates a new instance of this member class, by applying the specified type arguments and value arguments.",106)),$throws($init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language.meta.model'),IncompatibleTypeException$meta$model),String$("If the specified container, type or value arguments are not compatible with this method.",88)),shared(),$default()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$m','memberInstantiate']};};
        })(ClassDeclaration$meta$declaration.$$.prototype);
    }
    return ClassDeclaration$meta$declaration;
}
exports.$init$ClassDeclaration$meta$declaration=$init$ClassDeclaration$meta$declaration;
$init$ClassDeclaration$meta$declaration();
function FunctionDeclaration$meta$declaration($$functionDeclaration){
    FunctionOrValueDeclaration$meta$declaration($$functionDeclaration);
    GenericDeclaration$meta$declaration($$functionDeclaration);
    FunctionalDeclaration$meta$declaration($$functionDeclaration);
}
FunctionDeclaration$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:FunctionOrValueDeclaration$meta$declaration},{t:GenericDeclaration$meta$declaration},{t:FunctionalDeclaration$meta$declaration}],$an:function(){return[doc(String$("A function declaration.\n\n<a name=\"toplevel-sample\"></a>\n### Usage sample for toplevel function\n\nBecause some functions have type parameters, getting a model requires applying type arguments to the\nfunction declaration with [[apply]] in order to be able to invoke that function. For example, here is how you would\nobtain a function model that you can invoke from a toplevel function declaration:\n\n    String foo<T>(){\n        return \"Hello, our T is: ``typeLiteral<T>()``\";\n    }\n    \n    void test(){\n        // We need to apply the Integer closed type to the foo declaration in order to get the foo<Integer> function model\n        Function<String,[]> functionModel = `function foo`.apply<String,[]>(`Integer`);\n        // This will print: Hello, our T is: ceylon.language::Integer\n        print(functionModel());\n    }\n\n<a name=\"member-sample\"></a>\n### Usage sample for methods\n\nFor methods it is a bit longer, because methods need to be applied not only their type arguments but also\nthe containing type, so you should use [[memberApply]] and start by giving the containing closed type:\n\n    class Outer(){\n        shared String hello() => \"Hello\";\n    }\n\n    void test(){\n        // apply the containing closed type `Outer` to the method declaration `Outer.hello`\n        Method<Outer,String,[]> methodModel = `function Outer.hello`.memberApply<Outer,String,[]>(`Outer`);\n        // We now have a Method, which needs to be applied to a containing instance in order to become an\n        // invokable function:\n        Function<String,[]> boundMethodModel = methodModel(Outer());\n        // This will print: Hello\n        print(boundMethodModel());\n    }\n",1656)),shared()];},d:['ceylon.language.meta.declaration','FunctionDeclaration']};};
exports.FunctionDeclaration$meta$declaration=FunctionDeclaration$meta$declaration;
function $init$FunctionDeclaration$meta$declaration(){
    if (FunctionDeclaration$meta$declaration.$$===undefined){
        initTypeProtoI(FunctionDeclaration$meta$declaration,'ceylon.language.meta.declaration::FunctionDeclaration',$init$FunctionOrValueDeclaration$meta$declaration(),$init$GenericDeclaration$meta$declaration(),$init$FunctionalDeclaration$meta$declaration());
        (function($$functionDeclaration){
            $$functionDeclaration.$apply={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Function$meta$model,a:{Arguments:'Arguments',Type:'Return'}},$ps:[{$nm:'typeArguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:FunctionDeclaration$meta$declaration,$tp:{Return:{'def':{t:Anything}},Arguments:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},$an:function(){return[doc("Applies the given closed type arguments to this function declaration in order to obtain a function model. \nSee [this code sample](#toplevel-sample) for an example on how to use this."),$throws("IncompatibleTypeException","If the specified `Return` or `Arguments` type arguments are not compatible with the actual result."),$throws("TypeApplicationException","If the specified closed type argument values are not compatible with the actual result\'s type parameters."),shared(),formal()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$m','apply']};}};$$functionDeclaration.memberApply={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Method$meta$model,a:{Arguments:'Arguments',Type:'Return',Container:'Container'}},$ps:[{$nm:'containerType',$mt:'prm',$t:{t:Type$meta$model,a:{Type:'Container'}},$an:function(){return[];}},{$nm:'typeArguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:FunctionDeclaration$meta$declaration,$tp:{Container:{'def':{t:Nothing}},Return:{'def':{t:Anything}},Arguments:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},$an:function(){return[doc("Applies the given closed container type and type arguments to this method declaration in order to obtain a method model. \nSee [this code sample](#member-sample) for an example on how to use this."),$throws("IncompatibleTypeException","If the specified `Container`, `Return` or `Arguments` type arguments are not compatible with the actual result."),$throws("TypeApplicationException","If the specified closed container type or type argument values are not compatible with the actual result\'s container type or type parameters."),shared(),formal()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$m','memberApply']};}};$$functionDeclaration.invoke$defs$typeArguments=function(typeArguments$1023,arguments$1024){var $$functionDeclaration=this;
            return getEmpty();};
            $$functionDeclaration.invoke=function (typeArguments$1023,arguments$1024){
                var $$functionDeclaration=this;
                if(typeArguments$1023===undefined){typeArguments$1023=$$functionDeclaration.invoke$defs$typeArguments(typeArguments$1023,arguments$1024);}
                if(arguments$1024===undefined){arguments$1024=getEmpty();}
                return $$functionDeclaration.$apply(typeArguments$1023,{Arguments:{t:Nothing},Return:{t:Anything}}).$apply(arguments$1024);
            };
            $$functionDeclaration.invoke.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[{$nm:'typeArguments',$mt:'prm',$def:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}},{$nm:'arguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Anything}}},$an:function(){return[];}}],$cont:FunctionDeclaration$meta$declaration,$an:function(){return[doc(String$("Invokes the underlying toplevel function, by applying the specified type arguments and value arguments.",103)),$throws($init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language.meta.model'),IncompatibleTypeException$meta$model),String$("If the specified type or value arguments are not compatible with this toplevel function.",88)),shared(),$default()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$m','invoke']};};
            $$functionDeclaration.memberInvoke$defs$typeArguments=function(container$1025,typeArguments$1026,arguments$1027){var $$functionDeclaration=this;
            return getEmpty();};
            $$functionDeclaration.memberInvoke=function (container$1025,typeArguments$1026,arguments$1027){
                var $$functionDeclaration=this;
                if(typeArguments$1026===undefined){typeArguments$1026=$$functionDeclaration.memberInvoke$defs$typeArguments(container$1025,typeArguments$1026,arguments$1027);}
                if(arguments$1027===undefined){arguments$1027=getEmpty();}
                return $$functionDeclaration.memberApply(getNothingType$meta$model(),typeArguments$1026,{Arguments:{t:Nothing},Return:{t:Anything},Container:{t:Nothing}}).$bind(container$1025).$apply(arguments$1027);
            };
            $$functionDeclaration.memberInvoke.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[{$nm:'container',$mt:'prm',$t:{t:Object$},$an:function(){return[];}},{$nm:'typeArguments',$mt:'prm',$def:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}},{$nm:'arguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Anything}}},$an:function(){return[];}}],$cont:FunctionDeclaration$meta$declaration,$an:function(){return[doc(String$("Invokes the underlying method, by applying the specified type arguments and value arguments.",92)),$throws($init$OpenClass()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language.meta.model'),IncompatibleTypeException$meta$model),String$("If the specified container, type or value arguments are not compatible with this method.",88)),shared(),$default()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$m','memberInvoke']};};
        })(FunctionDeclaration$meta$declaration.$$.prototype);
    }
    return FunctionDeclaration$meta$declaration;
}
exports.$init$FunctionDeclaration$meta$declaration=$init$FunctionDeclaration$meta$declaration;
$init$FunctionDeclaration$meta$declaration();
function InterfaceDeclaration$meta$declaration($$interfaceDeclaration){
    ClassOrInterfaceDeclaration$meta$declaration($$interfaceDeclaration);
}
InterfaceDeclaration$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:ClassOrInterfaceDeclaration$meta$declaration}],$an:function(){return[doc(String$("An interface declaration.\n\n<a name=\"toplevel-sample\"></a>\n### Usage sample for toplevel interfaces\n\nBecause some interfaces have type parameters, getting a model requires applying type arguments to the\ninterface declaration with [[interfaceApply]] in order to be able to get a closed type. For example, here is how you would\nobtain an interface model from a toplevel interface declaration:\n\n    interface Foo<T> satisfies List<T> {\n    }\n    \n    void test(){\n        // We need to apply the Integer closed type to the Foo declaration in order to get the Foo<Integer> closed type\n        Interface<Foo<Integer>> interfaceModel = `interface Foo`.interfaceApply<Foo<Integer>>(`Integer`);\n        // This will print: ceylon.language::List<ceylon.language::Integer>\n        for(satisfiedType in interfaceModel.satisfiedTypes){\n            print(satisfiedType);\n        }\n    }\n\n<a name=\"member-sample\"></a>\n### Usage sample for member interfaces\n\nFor member interfaces it is a bit longer, because member interfaces need to be applied not only their type arguments but also\nthe containing type, so you should use [[memberInterfaceApply]] and start by giving the containing closed type:\n\n    class Outer(){\n        shared interface Inner<T> satisfies List<T> {\n        }\n    }\n\n    void test(){\n        // apply the containing closed type `Outer` to the member class declaration `Outer.Inner`\n        MemberInterface<Outer,Outer.Inner<Integer>> memberInterfaceModel = `interface Outer.Inner`.memberInterfaceApply<Outer,Outer.Inner<Integer>>(`Outer`, `Integer`);\n        // This will print: ceylon.language::List<ceylon.language::Integer>\n        for(satisfiedType in memberInterfaceModel.satisfiedTypes){\n            print(satisfiedType);\n        }\n    }\n",1749)),shared()];},d:['ceylon.language.meta.declaration','InterfaceDeclaration']};};
exports.InterfaceDeclaration$meta$declaration=InterfaceDeclaration$meta$declaration;
function $init$InterfaceDeclaration$meta$declaration(){
    if (InterfaceDeclaration$meta$declaration.$$===undefined){
        initTypeProtoI(InterfaceDeclaration$meta$declaration,'ceylon.language.meta.declaration::InterfaceDeclaration',$init$ClassOrInterfaceDeclaration$meta$declaration());
        (function($$interfaceDeclaration){
            $$interfaceDeclaration.interfaceApply={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Interface$meta$model,a:{Type:'Type'}},$ps:[{$nm:'typeArguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:InterfaceDeclaration$meta$declaration,$tp:{Type:{'def':{t:Anything}}},$an:function(){return[doc("Applies the given closed type arguments to this toplevel interface declaration in order to obtain an interface model. \nSee [this code sample](#toplevel-sample) for an example on how to use this."),$throws("IncompatibleTypeException","If the specified `Type` type argument is not compatible with the actual result."),$throws("TypeApplicationException","If the specified closed type argument values are not compatible with the actual result\'s type parameters."),shared(),formal()];},d:['ceylon.language.meta.declaration','InterfaceDeclaration','$m','interfaceApply']};}};$$interfaceDeclaration.memberInterfaceApply={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:MemberInterface$meta$model,a:{Type:'Type',Container:'Container'}},$ps:[{$nm:'containerType',$mt:'prm',$t:{t:Type$meta$model,a:{Type:'Container'}},$an:function(){return[];}},{$nm:'typeArguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:InterfaceDeclaration$meta$declaration,$tp:{Container:{'def':{t:Nothing}},Type:{'def':{t:Anything}}},$an:function(){return[doc("Applies the given closed container type and type arguments to this member interface declaration in order to obtain a member interface model. \nSee [this code sample](#member-sample) for an example on how to use this."),$throws("IncompatibleTypeException","If the specified `Container` or `Type` type arguments are not compatible with the actual result."),$throws("TypeApplicationException","If the specified closed container type or type argument values are not compatible with the actual result\'s container type or type parameters."),shared(),formal()];},d:['ceylon.language.meta.declaration','InterfaceDeclaration','$m','memberInterfaceApply']};}};
        })(InterfaceDeclaration$meta$declaration.$$.prototype);
    }
    return InterfaceDeclaration$meta$declaration;
}
exports.$init$InterfaceDeclaration$meta$declaration=$init$InterfaceDeclaration$meta$declaration;
$init$InterfaceDeclaration$meta$declaration();
function Module$meta$declaration($$module){
    Identifiable($$module);
    AnnotatedDeclaration$meta$declaration($$module);
}
Module$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:Identifiable},{t:AnnotatedDeclaration$meta$declaration}],$an:function(){return[doc(String$("A `module` declaration\nfrom a `module.ceylon` compilation unit",62)),shared()];},d:['ceylon.language.meta.declaration','Module']};};
exports.Module$meta$declaration=Module$meta$declaration;
function $init$Module$meta$declaration(){
    if (Module$meta$declaration.$$===undefined){
        initTypeProtoI(Module$meta$declaration,'ceylon.language.meta.declaration::Module',$init$Identifiable(),$init$AnnotatedDeclaration$meta$declaration());
        (function($$module){
            $$module.$prop$getVersion={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Module$meta$declaration,$an:function(){return[doc(String$("The module version.",19)),shared(),formal()];},d:['ceylon.language.meta.declaration','Module','$at','version']};}};
            $$module.$prop$getMembers={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:Package$meta$declaration}}},$cont:Module$meta$declaration,$an:function(){return[doc(String$("The package members of the module.",34)),shared(),formal()];},d:['ceylon.language.meta.declaration','Module','$at','members']};}};
            $$module.$prop$getDependencies={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:Import$meta$declaration}}},$cont:Module$meta$declaration,$an:function(){return[doc(String$("The modules this module depends on.",35)),shared(),formal()];},d:['ceylon.language.meta.declaration','Module','$at','dependencies']};}};
            $$module.findPackage={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Package$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:Module$meta$declaration,$an:function(){return[doc("Finds a package by name. Returns `null` if not found."),shared(),formal()];},d:['ceylon.language.meta.declaration','Module','$m','findPackage']};}};$$module.findImportedPackage={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:Package$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:Module$meta$declaration,$an:function(){return[doc("Finds a package by name in this module or in its dependencies. Note that all transitive `shared`\ndependencies are searched. Returns `null` if not found."),shared(),formal()];},d:['ceylon.language.meta.declaration','Module','$m','findImportedPackage']};}};
        })(Module$meta$declaration.$$.prototype);
    }
    return Module$meta$declaration;
}
exports.$init$Module$meta$declaration=$init$Module$meta$declaration;
$init$Module$meta$declaration();
function Import$meta$declaration($$import){
    Identifiable($$import);
    Annotated($$import);
}
Import$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:Identifiable},{t:Annotated}],$an:function(){return[doc(String$("Model of an `import` declaration \nwithin a module declaration.",62)),shared()];},d:['ceylon.language.meta.declaration','Import']};};
exports.Import$meta$declaration=Import$meta$declaration;
function $init$Import$meta$declaration(){
    if (Import$meta$declaration.$$===undefined){
        initTypeProtoI(Import$meta$declaration,'ceylon.language.meta.declaration::Import',$init$Identifiable(),$init$Annotated());
        (function($$import){
            $$import.$prop$getName={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Import$meta$declaration,$an:function(){return[doc(String$("The name of the imported module.",32)),shared(),formal()];},d:['ceylon.language.meta.declaration','Import','$at','name']};}};
            $$import.$prop$getShared={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Import$meta$declaration,$an:function(){return[doc(String$("True if this imported module is shared.",39)),shared(),formal()];},d:['ceylon.language.meta.declaration','Import','$at','shared']};}};
            $$import.$prop$getOptional={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Import$meta$declaration,$an:function(){return[doc(String$("True if this imported module is optional.",41)),shared(),formal()];},d:['ceylon.language.meta.declaration','Import','$at','optional']};}};
            $$import.$prop$getContainer={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Module$meta$declaration},$cont:Import$meta$declaration,$an:function(){return[doc(String$("The containing module.",22)),shared(),formal()];},d:['ceylon.language.meta.declaration','Import','$at','container']};}};
        })(Import$meta$declaration.$$.prototype);
    }
    return Import$meta$declaration;
}
exports.$init$Import$meta$declaration=$init$Import$meta$declaration;
$init$Import$meta$declaration();
function Package$meta$declaration($$package){
    Identifiable($$package);
    AnnotatedDeclaration$meta$declaration($$package);
}
Package$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:Identifiable},{t:AnnotatedDeclaration$meta$declaration}],$an:function(){return[doc(String$("Model of a `package` declaration \nfrom a `package.ceylon` compilation unit",74)),shared()];},d:['ceylon.language.meta.declaration','Package']};};
exports.Package$meta$declaration=Package$meta$declaration;
function $init$Package$meta$declaration(){
    if (Package$meta$declaration.$$===undefined){
        initTypeProtoI(Package$meta$declaration,'ceylon.language.meta.declaration::Package',$init$Identifiable(),$init$AnnotatedDeclaration$meta$declaration());
        (function($$package){
            $$package.members={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Kind'}},$ps:[],$cont:Package$meta$declaration,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]}},$an:function(){return[doc("Returns the list of member declarations that satisfy the given `Kind` type argument."),shared(),formal()];},d:['ceylon.language.meta.declaration','Package','$m','members']};}};$$package.annotatedMembers={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Kind'}},$ps:[],$cont:Package$meta$declaration,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]},Annotation:{}},$an:function(){return[doc("Returns the list of member declarations that satisfy the given `Kind` type argument and\nthat are annotated with the given `Annotation` type argument"),shared(),formal()];},d:['ceylon.language.meta.declaration','Package','$m','annotatedMembers']};}};$$package.getMember={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},'Kind']},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:Package$meta$declaration,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]}},$an:function(){return[doc("Looks up a member declaration by name, provided it satisfies the given `Kind` type\nargument. Returns `null` if no such member matches."),shared(),formal()];},d:['ceylon.language.meta.declaration','Package','$m','getMember']};}};$$package.getValue={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:ValueDeclaration$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:Package$meta$declaration,$an:function(){return[doc("The value with the given name. Returns `null` if not found."),shared(),formal()];},d:['ceylon.language.meta.declaration','Package','$m','getValue']};}};$$package.getClassOrInterface={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:ClassOrInterfaceDeclaration$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:Package$meta$declaration,$an:function(){return[doc("The class or interface with the given name. Returns `null` if not found."),shared(),formal()];},d:['ceylon.language.meta.declaration','Package','$m','getClassOrInterface']};}};$$package.getFunction={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:FunctionDeclaration$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:Package$meta$declaration,$an:function(){return[doc("The function with the given name. Returns `null` if not found."),shared(),formal()];},d:['ceylon.language.meta.declaration','Package','$m','getFunction']};}};$$package.getAlias={$fml:1,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:AliasDeclaration$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:Package$meta$declaration,$an:function(){return[doc("The type alias with the given name. Returns `null` if not found."),shared(),formal()];},d:['ceylon.language.meta.declaration','Package','$m','getAlias']};}};
        })(Package$meta$declaration.$$.prototype);
    }
    return Package$meta$declaration;
}
exports.$init$Package$meta$declaration=$init$Package$meta$declaration;
$init$Package$meta$declaration();
function OpenIntersection$meta$declaration($$openIntersection){
    OpenType$meta$declaration($$openIntersection);
}
OpenIntersection$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:OpenType$meta$declaration}],$an:function(){return[doc(String$("An open intersection type.",26)),shared()];},d:['ceylon.language.meta.declaration','OpenIntersection']};};
exports.OpenIntersection$meta$declaration=OpenIntersection$meta$declaration;
function $init$OpenIntersection$meta$declaration(){
    if (OpenIntersection$meta$declaration.$$===undefined){
        initTypeProtoI(OpenIntersection$meta$declaration,'ceylon.language.meta.declaration::OpenIntersection',$init$OpenType$meta$declaration());
        (function($$openIntersection){
            $$openIntersection.$prop$getSatisfiedTypes={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:{t:OpenType$meta$declaration}}},$cont:OpenIntersection$meta$declaration,$an:function(){return[doc(String$("This intersection\'s list of satisfied open types.",49)),shared(),formal()];},d:['ceylon.language.meta.declaration','OpenIntersection','$at','satisfiedTypes']};}};
        })(OpenIntersection$meta$declaration.$$.prototype);
    }
    return OpenIntersection$meta$declaration;
}
exports.$init$OpenIntersection$meta$declaration=$init$OpenIntersection$meta$declaration;
$init$OpenIntersection$meta$declaration();
function OpenClassOrInterfaceType$meta$declaration($$openClassOrInterfaceType){
    OpenType$meta$declaration($$openClassOrInterfaceType);
}
OpenClassOrInterfaceType$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:OpenType$meta$declaration}],of:[{t:OpenClassType$meta$declaration},{t:OpenInterfaceType$meta$declaration}],$an:function(){return[doc(String$("An open class or interface, with open type arguments.\n\nFor example, `List<T>` is an open interface type, with a type argument which is the\n[[OpenTypeVariable]] `T`.",164)),shared()];},d:['ceylon.language.meta.declaration','OpenClassOrInterfaceType']};};
exports.OpenClassOrInterfaceType$meta$declaration=OpenClassOrInterfaceType$meta$declaration;
function $init$OpenClassOrInterfaceType$meta$declaration(){
    if (OpenClassOrInterfaceType$meta$declaration.$$===undefined){
        initTypeProtoI(OpenClassOrInterfaceType$meta$declaration,'ceylon.language.meta.declaration::OpenClassOrInterfaceType',$init$OpenType$meta$declaration());
        (function($$openClassOrInterfaceType){
            $$openClassOrInterfaceType.$prop$getDeclaration={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:ClassOrInterfaceDeclaration$meta$declaration},$cont:OpenClassOrInterfaceType$meta$declaration,$an:function(){return[doc(String$("The class or interface declaration for this open type.",54)),shared(),formal()];},d:['ceylon.language.meta.declaration','OpenClassOrInterfaceType','$at','declaration']};}};
            $$openClassOrInterfaceType.$prop$getExtendedType={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:OpenClassType$meta$declaration}]},$cont:OpenClassOrInterfaceType$meta$declaration,$an:function(){return[doc(String$("The extended type of this open type.",36)),shared(),formal()];},d:['ceylon.language.meta.declaration','OpenClassOrInterfaceType','$at','extendedType']};}};
            $$openClassOrInterfaceType.$prop$getSatisfiedTypes={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:OpenInterfaceType$meta$declaration}}},$cont:OpenClassOrInterfaceType$meta$declaration,$an:function(){return[doc(String$("The satisfied types of this open type.",38)),shared(),formal()];},d:['ceylon.language.meta.declaration','OpenClassOrInterfaceType','$at','satisfiedTypes']};}};
            $$openClassOrInterfaceType.$prop$getTypeArguments={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:{t:TypeParameter$meta$declaration},Item:{t:OpenType$meta$declaration}}},$cont:OpenClassOrInterfaceType$meta$declaration,$an:function(){return[doc(String$("The set of open type arguments.",31)),shared(),formal()];},d:['ceylon.language.meta.declaration','OpenClassOrInterfaceType','$at','typeArguments']};}};
        })(OpenClassOrInterfaceType$meta$declaration.$$.prototype);
    }
    return OpenClassOrInterfaceType$meta$declaration;
}
exports.$init$OpenClassOrInterfaceType$meta$declaration=$init$OpenClassOrInterfaceType$meta$declaration;
$init$OpenClassOrInterfaceType$meta$declaration();
defineAttr(OpenClassOrInterfaceType$meta$declaration.$$.prototype,'typeArguments',function(){
  var tps=this.declaration.tipo.$$metamodel$$.$tp;
  if (tps) {
    var rtps = this.declaration._targs;
    var targs=[];
    for (var tpn in tps) {
      var rtp=rtps&&rtps[tpn];
      var otp=OpenTypeParam(this.declaration.tipo,tpn);
      var targ;
      if (rtp===undefined) {
        targ = OpenTvar(otp);
      } else if (typeof(rtp)==='string') {
        targ = OpenTvar(OpenTypeParam(this.declaration.tipo,rtp));
      } else {
        if (rtp.t==='i'||rtp.t==='u') {
          //resolve case types
          var nrtp={t:rtp.t,l:[]};
          for (var i=0;i<rtp.l.length;i++) {
            var _ct=rtp.l[i];
            nrtp.l.push(typeof(_ct)==='string'?OpenTvar(OpenTypeParam(this.declaration.tipo,_ct)):_ct);
          }
          rtp=nrtp;
        }
        targ = _openTypeFromTarg(rtp);
      }
      targs.push(Entry(otp, targ, {Key:{t:TypeParameter$meta$declaration},Item:{t:OpenType$meta$declaration}}));
    }
    return LazyMap(targs.reifyCeylonType({Absent:{t:Null},Element:{t:Entry,a:{Key:{t:TypeParameter$meta$declaration},Item:{t:OpenType$meta$declaration}}}}),{Key:{t:TypeParameter$meta$declaration},Item:{t:OpenType$meta$declaration}});
  }
  return getEmpty();
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:{t:TypeParameter$meta$declaration},Item:{t:OpenType$meta$declaration}}},$cont:OpenClassOrInterfaceType,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','OpenClassOrInterfaceType','$at','typeArguments']};});
defineAttr(OpenClassOrInterfaceType$meta$declaration.$$.prototype,'extendedType',function(){
  return this.declaration.extendedType;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:OpenClassType$meta$declaration}]},$cont:OpenClassOrInterfaceType,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','OpenClassOrInterfaceType','$at','extendedType']};});
defineAttr(OpenClassOrInterfaceType$meta$declaration.$$.prototype,'declaration',function(){return this._decl;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:ClassDeclaration$meta$declaration},$cont:OpenClassOrInterfaceType,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','OpenClassOrInterfaceType','$at','declaration']};});
defineAttr(OpenClassOrInterfaceType$meta$declaration.$$.prototype,'satisfiedTypes',function(){
  return this.declaration.satisfiedTypes;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:OpenInterfaceType$meta$declaration}}},$cont:OpenClassOrInterfaceType$meta$declaration,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','OpenClassOrInterfaceType','$at','satisfiedTypes']};});
defineAttr(OpenClassOrInterfaceType$meta$declaration.$$.prototype,'string',function(){
  var s=this.declaration.string;
  var tps=this.declaration.tipo.$$metamodel$$.$tp;
  if (tps) {
    var rtps=this.declaration._targs;
    s+="<";
    var first=true;
    for (var t in tps) {
      var rtp=rtps&&rtps[t];
      if (first)first=false;else s+=",";
      if (rtp===undefined) {
        s+=t;
      } else {
        s+=_openTypeFromTarg(rtp).string;
      }
    }
    s+=">";
  }
  return s;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Object','$at','string']};});
function OpenClassType$meta$declaration($$openClassType){
    OpenClassOrInterfaceType$meta$declaration($$openClassType);
}
OpenClassType$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:OpenClassOrInterfaceType$meta$declaration}],$an:function(){return[doc(String$("An open class type.",19)),shared()];},d:['ceylon.language.meta.declaration','OpenClassType']};};
exports.OpenClassType$meta$declaration=OpenClassType$meta$declaration;
function $init$OpenClassType$meta$declaration(){
    if (OpenClassType$meta$declaration.$$===undefined){
        initTypeProtoI(OpenClassType$meta$declaration,'ceylon.language.meta.declaration::OpenClassType',$init$OpenClassOrInterfaceType$meta$declaration());
        (function($$openClassType){
            $$openClassType.$prop$getDeclaration={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:ClassDeclaration$meta$declaration},$cont:OpenClassType$meta$declaration,$an:function(){return[doc(String$("This class declaration.",23)),shared(),actual(),formal()];},d:['ceylon.language.meta.declaration','OpenClassType','$at','declaration']};}};
        })(OpenClassType$meta$declaration.$$.prototype);
    }
    return OpenClassType$meta$declaration;
}
exports.$init$OpenClassType$meta$declaration=$init$OpenClassType$meta$declaration;
$init$OpenClassType$meta$declaration();
function OpenInterfaceType$meta$declaration($$openInterfaceType){
    OpenClassOrInterfaceType$meta$declaration($$openInterfaceType);
}
OpenInterfaceType$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:OpenClassOrInterfaceType$meta$declaration}],$an:function(){return[doc(String$("An open interface type.",23)),shared()];},d:['ceylon.language.meta.declaration','OpenInterfaceType']};};
exports.OpenInterfaceType$meta$declaration=OpenInterfaceType$meta$declaration;
function $init$OpenInterfaceType$meta$declaration(){
    if (OpenInterfaceType$meta$declaration.$$===undefined){
        initTypeProtoI(OpenInterfaceType$meta$declaration,'ceylon.language.meta.declaration::OpenInterfaceType',$init$OpenClassOrInterfaceType$meta$declaration());
        (function($$openInterfaceType){
            $$openInterfaceType.$prop$getDeclaration={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:InterfaceDeclaration$meta$declaration},$cont:OpenInterfaceType$meta$declaration,$an:function(){return[doc(String$("This declaration\'s package container.",37)),shared(),actual(),formal()];},d:['ceylon.language.meta.declaration','OpenInterfaceType','$at','declaration']};}};
        })(OpenInterfaceType$meta$declaration.$$.prototype);
    }
    return OpenInterfaceType$meta$declaration;
}
exports.$init$OpenInterfaceType$meta$declaration=$init$OpenInterfaceType$meta$declaration;
$init$OpenInterfaceType$meta$declaration();
function OpenType$meta$declaration($$openType){
}
OpenType$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,of:[{t:nothingType$1028$meta$declaration},{t:OpenClassOrInterfaceType$meta$declaration},{t:OpenTypeVariable$meta$declaration},{t:OpenUnion$meta$declaration},{t:OpenIntersection$meta$declaration}],$an:function(){return[doc(String$("An open type.\n\nAn open type is a type which may contain unbound type variables, such as `List<T>`.",98)),shared()];},d:['ceylon.language.meta.declaration','OpenType']};};
exports.OpenType$meta$declaration=OpenType$meta$declaration;
function $init$OpenType$meta$declaration(){
    if (OpenType$meta$declaration.$$===undefined){
        initTypeProtoI(OpenType$meta$declaration,'ceylon.language.meta.declaration::OpenType');
    }
    return OpenType$meta$declaration;
}
exports.$init$OpenType$meta$declaration=$init$OpenType$meta$declaration;
$init$OpenType$meta$declaration();
function OpenTypeVariable$meta$declaration($$openTypeVariable){
    OpenType$meta$declaration($$openTypeVariable);
}
OpenTypeVariable$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:OpenType$meta$declaration}],$an:function(){return[doc(String$("An open type variable.",22)),shared()];},d:['ceylon.language.meta.declaration','OpenTypeVariable']};};
exports.OpenTypeVariable$meta$declaration=OpenTypeVariable$meta$declaration;
function $init$OpenTypeVariable$meta$declaration(){
    if (OpenTypeVariable$meta$declaration.$$===undefined){
        initTypeProtoI(OpenTypeVariable$meta$declaration,'ceylon.language.meta.declaration::OpenTypeVariable',$init$OpenType$meta$declaration());
        (function($$openTypeVariable){
            $$openTypeVariable.$prop$getDeclaration={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:TypeParameter$meta$declaration},$cont:OpenTypeVariable$meta$declaration,$an:function(){return[doc(String$("This type variable\'s type parameter declaration.",48)),shared(),formal()];},d:['ceylon.language.meta.declaration','OpenTypeVariable','$at','declaration']};}};
        })(OpenTypeVariable$meta$declaration.$$.prototype);
    }
    return OpenTypeVariable$meta$declaration;
}
exports.$init$OpenTypeVariable$meta$declaration=$init$OpenTypeVariable$meta$declaration;
$init$OpenTypeVariable$meta$declaration();
function OpenUnion$meta$declaration($$openUnion){
    OpenType$meta$declaration($$openUnion);
}
OpenUnion$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:OpenType$meta$declaration}],$an:function(){return[doc(String$("An open union type.",19)),shared()];},d:['ceylon.language.meta.declaration','OpenUnion']};};
exports.OpenUnion$meta$declaration=OpenUnion$meta$declaration;
function $init$OpenUnion$meta$declaration(){
    if (OpenUnion$meta$declaration.$$===undefined){
        initTypeProtoI(OpenUnion$meta$declaration,'ceylon.language.meta.declaration::OpenUnion',$init$OpenType$meta$declaration());
        (function($$openUnion){
            $$openUnion.$prop$getCaseTypes={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:{t:OpenType$meta$declaration}}},$cont:OpenUnion$meta$declaration,$an:function(){return[doc(String$("The list of case types for this open union type.",48)),shared(),formal()];},d:['ceylon.language.meta.declaration','OpenUnion','$at','caseTypes']};}};
        })(OpenUnion$meta$declaration.$$.prototype);
    }
    return OpenUnion$meta$declaration;
}
exports.$init$OpenUnion$meta$declaration=$init$OpenUnion$meta$declaration;
$init$OpenUnion$meta$declaration();
function SetterDeclaration$meta$declaration($$setterDeclaration){
    Annotated($$setterDeclaration);
}
SetterDeclaration$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:Annotated}],$an:function(){return[doc(String$("A setter declaration for a variable `ValueDeclaration`.",55)),shared()];},d:['ceylon.language.meta.declaration','SetterDeclaration']};};
exports.SetterDeclaration$meta$declaration=SetterDeclaration$meta$declaration;
function $init$SetterDeclaration$meta$declaration(){
    if (SetterDeclaration$meta$declaration.$$===undefined){
        initTypeProtoI(SetterDeclaration$meta$declaration,'ceylon.language.meta.declaration::SetterDeclaration',$init$Annotated());
        (function($$setterDeclaration){
            $$setterDeclaration.$prop$getVariable={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:ValueDeclaration$meta$declaration},$cont:SetterDeclaration$meta$declaration,$an:function(){return[doc(String$("The variable value this setter is for.",38)),shared(),formal()];},d:['ceylon.language.meta.declaration','SetterDeclaration','$at','variable']};}};
        })(SetterDeclaration$meta$declaration.$$.prototype);
    }
    return SetterDeclaration$meta$declaration;
}
exports.$init$SetterDeclaration$meta$declaration=$init$SetterDeclaration$meta$declaration;
$init$SetterDeclaration$meta$declaration();
function TypeParameter$meta$declaration($$typeParameter){
    Declaration$meta$declaration($$typeParameter);
}
TypeParameter$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:Declaration$meta$declaration}],$an:function(){return[doc(String$("A type parameter declaration.",29)),shared()];},d:['ceylon.language.meta.declaration','TypeParameter']};};
exports.TypeParameter$meta$declaration=TypeParameter$meta$declaration;
function $init$TypeParameter$meta$declaration(){
    if (TypeParameter$meta$declaration.$$===undefined){
        initTypeProtoI(TypeParameter$meta$declaration,'ceylon.language.meta.declaration::TypeParameter',$init$Declaration$meta$declaration());
        (function($$typeParameter){
            $$typeParameter.$prop$getContainer={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:NestableDeclaration$meta$declaration},$cont:TypeParameter$meta$declaration,$an:function(){return[doc(String$("The declaration that declared this type parameter. This is either a [[ClassOrInterfaceDeclaration]] or a\n[[FunctionDeclaration]].",129)),shared(),formal()];},d:['ceylon.language.meta.declaration','TypeParameter','$at','container']};}};
            $$typeParameter.$prop$getDefaulted={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:TypeParameter$meta$declaration,$an:function(){return[doc(String$("True if this type parameter has a default type argument and can be omitted.",75)),shared(),formal()];},d:['ceylon.language.meta.declaration','TypeParameter','$at','defaulted']};}};
            $$typeParameter.$prop$getDefaultTypeArgument={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:OpenType$meta$declaration}]},$cont:TypeParameter$meta$declaration,$an:function(){return[doc(String$("This type parameter\'s default type argument, if it has one.",59)),shared(),formal()];},d:['ceylon.language.meta.declaration','TypeParameter','$at','defaultTypeArgument']};}};
            $$typeParameter.$prop$getVariance={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Variance$meta$declaration},$cont:TypeParameter$meta$declaration,$an:function(){return[doc(String$("This type parameter\'s variance, as defined by `in` or `out` keywords.",69)),shared(),formal()];},d:['ceylon.language.meta.declaration','TypeParameter','$at','variance']};}};
            $$typeParameter.$prop$getSatisfiedTypes={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:OpenType$meta$declaration}}},$cont:TypeParameter$meta$declaration,$an:function(){return[doc(String$("The `satisfies` upper bounds for this type parameter.",53)),shared(),formal()];},d:['ceylon.language.meta.declaration','TypeParameter','$at','satisfiedTypes']};}};
            $$typeParameter.$prop$getCaseTypes={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:OpenType$meta$declaration}}},$cont:TypeParameter$meta$declaration,$an:function(){return[doc(String$("The `of` enumerated bounds for this type parameter.",51)),shared(),formal()];},d:['ceylon.language.meta.declaration','TypeParameter','$at','caseTypes']};}};
        })(TypeParameter$meta$declaration.$$.prototype);
    }
    return TypeParameter$meta$declaration;
}
exports.$init$TypeParameter$meta$declaration=$init$TypeParameter$meta$declaration;
$init$TypeParameter$meta$declaration();
function TypedDeclaration$meta$declaration($$typedDeclaration){
}
TypedDeclaration$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$an:function(){return[doc(String$("Declaration which has an open type.",35)),shared()];},d:['ceylon.language.meta.declaration','TypedDeclaration']};};
exports.TypedDeclaration$meta$declaration=TypedDeclaration$meta$declaration;
function $init$TypedDeclaration$meta$declaration(){
    if (TypedDeclaration$meta$declaration.$$===undefined){
        initTypeProtoI(TypedDeclaration$meta$declaration,'ceylon.language.meta.declaration::TypedDeclaration');
        (function($$typedDeclaration){
            $$typedDeclaration.$prop$getOpenType={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:OpenType$meta$declaration},$cont:TypedDeclaration$meta$declaration,$an:function(){return[doc(String$("The open type for this declaration. For example, the open type for `List<T> f<T>()` is `List<T>`.",97)),shared(),formal()];},d:['ceylon.language.meta.declaration','TypedDeclaration','$at','openType']};}};
        })(TypedDeclaration$meta$declaration.$$.prototype);
    }
    return TypedDeclaration$meta$declaration;
}
exports.$init$TypedDeclaration$meta$declaration=$init$TypedDeclaration$meta$declaration;
$init$TypedDeclaration$meta$declaration();
function nothingType$1028$meta$declaration(){
    var $$nothingType=new nothingType$1028$meta$declaration.$$;
    OpenType$meta$declaration($$nothingType);
    return $$nothingType;
};nothingType$1028$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:OpenType$meta$declaration}],$an:function(){return[doc("The singleton open type for [[Nothing|ceylon.language::nothing]]."),shared()];},d:['ceylon.language.meta.declaration','nothingType']};};
function $init$nothingType$1028$meta$declaration(){
    if (nothingType$1028$meta$declaration.$$===undefined){
        initTypeProto(nothingType$1028$meta$declaration,'ceylon.language.meta.declaration::nothingType',Basic,$init$OpenType$meta$declaration());
        (function($$nothingType){
            defineAttr($$nothingType,'string',function(){
                var $$nothingType=this;
                return String$("Nothing",7);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:nothingType$1028$meta$declaration,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','nothingType','$at','string']};});
        })(nothingType$1028$meta$declaration.$$.prototype);
    }
    return nothingType$1028$meta$declaration;
}
exports.$init$nothingType$1028$meta$declaration=$init$nothingType$1028$meta$declaration;
$init$nothingType$1028$meta$declaration();
var nothingType$1029$meta$declaration;
function getNothingType$meta$declaration(){
    if (nothingType$1029$meta$declaration===undefined){nothingType$1029$meta$declaration=$init$nothingType$1028$meta$declaration()();nothingType$1029$meta$declaration.$$metamodel$$=getNothingType$meta$declaration.$$metamodel$$;}
    return nothingType$1029$meta$declaration;
}
exports.getNothingType$meta$declaration=getNothingType$meta$declaration;
getNothingType$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:nothingType$1028$meta$declaration},$an:function(){return[doc(String$("The singleton open type for [[Nothing|ceylon.language::nothing]].",65)),shared()];},d:['ceylon.language.meta.declaration','nothingType']};};
$prop$getNothingType$meta$declaration={get:getNothingType$meta$declaration,$$metamodel$$:getNothingType$meta$declaration.$$metamodel$$};
exports.$prop$getNothingType$meta$declaration=$prop$getNothingType$meta$declaration;
function AliasDeclaration$meta$declaration($$aliasDeclaration){
    NestableDeclaration$meta$declaration($$aliasDeclaration);
    GenericDeclaration$meta$declaration($$aliasDeclaration);
}
AliasDeclaration$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,satisfies:[{t:NestableDeclaration$meta$declaration},{t:GenericDeclaration$meta$declaration}],$an:function(){return[doc(String$("Type alias declaration. While type aliases are erased (substituted for what they alias is a better term) from every \ndeclaration that uses them during compile-time, the declaration of the type alias is still visible at run-time.",228)),shared()];},d:['ceylon.language.meta.declaration','AliasDeclaration']};};
exports.AliasDeclaration$meta$declaration=AliasDeclaration$meta$declaration;
function $init$AliasDeclaration$meta$declaration(){
    if (AliasDeclaration$meta$declaration.$$===undefined){
        initTypeProtoI(AliasDeclaration$meta$declaration,'ceylon.language.meta.declaration::AliasDeclaration',$init$NestableDeclaration$meta$declaration(),$init$GenericDeclaration$meta$declaration());
        (function($$aliasDeclaration){
            $$aliasDeclaration.$prop$getExtendedType={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:OpenType$meta$declaration},$cont:AliasDeclaration$meta$declaration,$an:function(){return[doc(String$("The open type that is substituted by this type alias.",53)),shared(),formal()];},d:['ceylon.language.meta.declaration','AliasDeclaration','$at','extendedType']};}};
        })(AliasDeclaration$meta$declaration.$$.prototype);
    }
    return AliasDeclaration$meta$declaration;
}
exports.$init$AliasDeclaration$meta$declaration=$init$AliasDeclaration$meta$declaration;
$init$AliasDeclaration$meta$declaration();
function Variance$meta$declaration($$variance){
}
Variance$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,of:[{t:invariant$1030$meta$declaration},{t:covariant$1031$meta$declaration},{t:contravariant$1032$meta$declaration}],$an:function(){return[doc(String$("Variance information.",21)),shared()];},d:['ceylon.language.meta.declaration','Variance']};};
exports.Variance$meta$declaration=Variance$meta$declaration;
function $init$Variance$meta$declaration(){
    if (Variance$meta$declaration.$$===undefined){
        initTypeProtoI(Variance$meta$declaration,'ceylon.language.meta.declaration::Variance');
    }
    return Variance$meta$declaration;
}
exports.$init$Variance$meta$declaration=$init$Variance$meta$declaration;
$init$Variance$meta$declaration();
function invariant$1030$meta$declaration(){
    var $$invariant=new invariant$1030$meta$declaration.$$;
    Variance$meta$declaration($$invariant);
    return $$invariant;
};invariant$1030$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Variance$meta$declaration}],$an:function(){return[doc("Invariant means that neither subtype nor supertype can be accepted, the\ntype has to be exactly that which is declared."),shared()];},d:['ceylon.language.meta.declaration','invariant']};};
function $init$invariant$1030$meta$declaration(){
    if (invariant$1030$meta$declaration.$$===undefined){
        initTypeProto(invariant$1030$meta$declaration,'ceylon.language.meta.declaration::invariant',Basic,$init$Variance$meta$declaration());
        (function($$invariant){
            defineAttr($$invariant,'string',function(){
                var $$invariant=this;
                return String$("Invariant",9);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:invariant$1030$meta$declaration,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','invariant','$at','string']};});
        })(invariant$1030$meta$declaration.$$.prototype);
    }
    return invariant$1030$meta$declaration;
}
exports.$init$invariant$1030$meta$declaration=$init$invariant$1030$meta$declaration;
$init$invariant$1030$meta$declaration();
var invariant$1033$meta$declaration;
function getInvariant$meta$declaration(){
    if (invariant$1033$meta$declaration===undefined){invariant$1033$meta$declaration=$init$invariant$1030$meta$declaration()();invariant$1033$meta$declaration.$$metamodel$$=getInvariant$meta$declaration.$$metamodel$$;}
    return invariant$1033$meta$declaration;
}
exports.getInvariant$meta$declaration=getInvariant$meta$declaration;
getInvariant$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:invariant$1030$meta$declaration},$an:function(){return[doc(String$("Invariant means that neither subtype nor supertype can be accepted, the\ntype has to be exactly that which is declared.",118)),shared()];},d:['ceylon.language.meta.declaration','invariant']};};
$prop$getInvariant$meta$declaration={get:getInvariant$meta$declaration,$$metamodel$$:getInvariant$meta$declaration.$$metamodel$$};
exports.$prop$getInvariant$meta$declaration=$prop$getInvariant$meta$declaration;
function covariant$1031$meta$declaration(){
    var $$covariant=new covariant$1031$meta$declaration.$$;
    Variance$meta$declaration($$covariant);
    return $$covariant;
};covariant$1031$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Variance$meta$declaration}],$an:function(){return[doc("Covariant means that subtypes of the given type may be returned."),shared()];},d:['ceylon.language.meta.declaration','covariant']};};
function $init$covariant$1031$meta$declaration(){
    if (covariant$1031$meta$declaration.$$===undefined){
        initTypeProto(covariant$1031$meta$declaration,'ceylon.language.meta.declaration::covariant',Basic,$init$Variance$meta$declaration());
        (function($$covariant){
            defineAttr($$covariant,'string',function(){
                var $$covariant=this;
                return String$("Covariant",9);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:covariant$1031$meta$declaration,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','covariant','$at','string']};});
        })(covariant$1031$meta$declaration.$$.prototype);
    }
    return covariant$1031$meta$declaration;
}
exports.$init$covariant$1031$meta$declaration=$init$covariant$1031$meta$declaration;
$init$covariant$1031$meta$declaration();
var covariant$1034$meta$declaration;
function getCovariant$meta$declaration(){
    if (covariant$1034$meta$declaration===undefined){covariant$1034$meta$declaration=$init$covariant$1031$meta$declaration()();covariant$1034$meta$declaration.$$metamodel$$=getCovariant$meta$declaration.$$metamodel$$;}
    return covariant$1034$meta$declaration;
}
exports.getCovariant$meta$declaration=getCovariant$meta$declaration;
getCovariant$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:covariant$1031$meta$declaration},$an:function(){return[doc(String$("Covariant means that subtypes of the given type may be returned.",64)),shared()];},d:['ceylon.language.meta.declaration','covariant']};};
$prop$getCovariant$meta$declaration={get:getCovariant$meta$declaration,$$metamodel$$:getCovariant$meta$declaration.$$metamodel$$};
exports.$prop$getCovariant$meta$declaration=$prop$getCovariant$meta$declaration;
function contravariant$1032$meta$declaration(){
    var $$contravariant=new contravariant$1032$meta$declaration.$$;
    Variance$meta$declaration($$contravariant);
    return $$contravariant;
};contravariant$1032$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Variance$meta$declaration}],$an:function(){return[doc("Contravariant means that supertypes of the given type may be accepted."),shared()];},d:['ceylon.language.meta.declaration','contravariant']};};
function $init$contravariant$1032$meta$declaration(){
    if (contravariant$1032$meta$declaration.$$===undefined){
        initTypeProto(contravariant$1032$meta$declaration,'ceylon.language.meta.declaration::contravariant',Basic,$init$Variance$meta$declaration());
        (function($$contravariant){
            defineAttr($$contravariant,'string',function(){
                var $$contravariant=this;
                return String$("Contravariant",13);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:contravariant$1032$meta$declaration,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','contravariant','$at','string']};});
        })(contravariant$1032$meta$declaration.$$.prototype);
    }
    return contravariant$1032$meta$declaration;
}
exports.$init$contravariant$1032$meta$declaration=$init$contravariant$1032$meta$declaration;
$init$contravariant$1032$meta$declaration();
var contravariant$1035$meta$declaration;
function getContravariant$meta$declaration(){
    if (contravariant$1035$meta$declaration===undefined){contravariant$1035$meta$declaration=$init$contravariant$1032$meta$declaration()();contravariant$1035$meta$declaration.$$metamodel$$=getContravariant$meta$declaration.$$metamodel$$;}
    return contravariant$1035$meta$declaration;
}
exports.getContravariant$meta$declaration=getContravariant$meta$declaration;
getContravariant$meta$declaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:contravariant$1032$meta$declaration},$an:function(){return[doc(String$("Contravariant means that supertypes of the given type may be accepted.",70)),shared()];},d:['ceylon.language.meta.declaration','contravariant']};};
$prop$getContravariant$meta$declaration={get:getContravariant$meta$declaration,$$metamodel$$:getContravariant$meta$declaration.$$metamodel$$};
exports.$prop$getContravariant$meta$declaration=$prop$getContravariant$meta$declaration;
function AnnotationAnnotation($$annotationAnnotation){
    $init$AnnotationAnnotation();
    if ($$annotationAnnotation===undefined)$$annotationAnnotation=new AnnotationAnnotation.$$;
    $$annotationAnnotation.$$targs$$={Value:{t:AnnotationAnnotation},ProgramElement:{t:'u', l:[{t:ClassDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration}]}};
    OptionalAnnotation({Value:{t:AnnotationAnnotation},ProgramElement:{t:'u', l:[{t:ClassDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration}]}},$$annotationAnnotation);
    add_type_arg($$annotationAnnotation,'Value',{t:AnnotationAnnotation});
    return $$annotationAnnotation;
}
AnnotationAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],satisfies:[{t:OptionalAnnotation,a:{Value:{t:AnnotationAnnotation},ProgramElement:{t:'u', l:[{t:ClassDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration}]}}}],$an:function(){return[doc(String$("The annotation class for [[annotation]].",40)),shared(),$final(),annotation()];},d:['ceylon.language','AnnotationAnnotation']};};
exports.AnnotationAnnotation=AnnotationAnnotation;
function $init$AnnotationAnnotation(){
    if (AnnotationAnnotation.$$===undefined){
        initTypeProto(AnnotationAnnotation,'ceylon.language::AnnotationAnnotation',Basic,$init$OptionalAnnotation());
    }
    return AnnotationAnnotation;
}
exports.$init$AnnotationAnnotation=$init$AnnotationAnnotation;
$init$AnnotationAnnotation();
var annotation=function (){
    return AnnotationAnnotation();
};
annotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:AnnotationAnnotation},$ps:[],$an:function(){return[doc(String$("Annotation to mark a class as an *annotation class*, or a \ntop-level function as an *annotation constructor*.",109)),see([$init$OpenInterface()(getModules$meta().find('ceylon.language','1.0.0').findPackage('ceylon.language'),Annotation)].reifyCeylonType({Absent:{t:Null},Element:{t:InterfaceDeclaration$meta$declaration}})),shared(),annotation()];},d:['ceylon.language','annotation']};};
exports.annotation=annotation;
function SharedAnnotation($$sharedAnnotation){
    $init$SharedAnnotation();
    if ($$sharedAnnotation===undefined)$$sharedAnnotation=new SharedAnnotation.$$;
    $$sharedAnnotation.$$targs$$={Value:{t:SharedAnnotation},ProgramElement:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration},{t:ClassOrInterfaceDeclaration$meta$declaration},{t:Package$meta$declaration},{t:Import$meta$declaration}]}};
    OptionalAnnotation({Value:{t:SharedAnnotation},ProgramElement:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration},{t:ClassOrInterfaceDeclaration$meta$declaration},{t:Package$meta$declaration},{t:Import$meta$declaration}]}},$$sharedAnnotation);
    add_type_arg($$sharedAnnotation,'Value',{t:SharedAnnotation});
    return $$sharedAnnotation;
}
SharedAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],satisfies:[{t:OptionalAnnotation,a:{Value:{t:SharedAnnotation},ProgramElement:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration},{t:ClassOrInterfaceDeclaration$meta$declaration},{t:Package$meta$declaration},{t:Import$meta$declaration}]}}}],$an:function(){return[doc(String$("The annotation class for [[shared]].",36)),shared(),$final(),annotation()];},d:['ceylon.language','SharedAnnotation']};};
exports.SharedAnnotation=SharedAnnotation;
function $init$SharedAnnotation(){
    if (SharedAnnotation.$$===undefined){
        initTypeProto(SharedAnnotation,'ceylon.language::SharedAnnotation',Basic,$init$OptionalAnnotation());
    }
    return SharedAnnotation;
}
exports.$init$SharedAnnotation=$init$SharedAnnotation;
$init$SharedAnnotation();
var shared=function (){
    return SharedAnnotation();
};
shared.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:SharedAnnotation},$ps:[],$an:function(){return[doc(String$("Annotation to mark a type or member as shared. A `shared` \nmember is visible outside the block of code in which it is \ndeclared.",128)),shared(),annotation()];},d:['ceylon.language','shared']};};
exports.shared=shared;
function VariableAnnotation($$variableAnnotation){
    $init$VariableAnnotation();
    if ($$variableAnnotation===undefined)$$variableAnnotation=new VariableAnnotation.$$;
    $$variableAnnotation.$$targs$$={Value:{t:VariableAnnotation},ProgramElement:{t:ValueDeclaration$meta$declaration}};
    OptionalAnnotation({Value:{t:VariableAnnotation},ProgramElement:{t:ValueDeclaration$meta$declaration}},$$variableAnnotation);
    add_type_arg($$variableAnnotation,'Value',{t:VariableAnnotation});
    add_type_arg($$variableAnnotation,'ProgramElement',{t:ValueDeclaration$meta$declaration});
    return $$variableAnnotation;
}
VariableAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],satisfies:[{t:OptionalAnnotation,a:{Value:{t:VariableAnnotation},ProgramElement:{t:ValueDeclaration$meta$declaration}}}],$an:function(){return[doc(String$("The annotation class for [[variable]].",38)),shared(),$final(),annotation()];},d:['ceylon.language','VariableAnnotation']};};
exports.VariableAnnotation=VariableAnnotation;
function $init$VariableAnnotation(){
    if (VariableAnnotation.$$===undefined){
        initTypeProto(VariableAnnotation,'ceylon.language::VariableAnnotation',Basic,$init$OptionalAnnotation());
    }
    return VariableAnnotation;
}
exports.$init$VariableAnnotation=$init$VariableAnnotation;
$init$VariableAnnotation();
var variable=function (){
    return VariableAnnotation();
};
variable.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:VariableAnnotation},$ps:[],$an:function(){return[doc(String$("Annotation to mark an value as variable. A `variable` value \nmay be assigned multiple times.",92)),shared(),annotation()];},d:['ceylon.language','variable']};};
exports.variable=variable;
function AbstractAnnotation($$abstractAnnotation){
    $init$AbstractAnnotation();
    if ($$abstractAnnotation===undefined)$$abstractAnnotation=new AbstractAnnotation.$$;
    $$abstractAnnotation.$$targs$$={Value:{t:AbstractAnnotation},ProgramElement:{t:ClassDeclaration$meta$declaration}};
    OptionalAnnotation({Value:{t:AbstractAnnotation},ProgramElement:{t:ClassDeclaration$meta$declaration}},$$abstractAnnotation);
    add_type_arg($$abstractAnnotation,'Value',{t:AbstractAnnotation});
    add_type_arg($$abstractAnnotation,'ProgramElement',{t:ClassDeclaration$meta$declaration});
    return $$abstractAnnotation;
}
AbstractAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],satisfies:[{t:OptionalAnnotation,a:{Value:{t:AbstractAnnotation},ProgramElement:{t:ClassDeclaration$meta$declaration}}}],$an:function(){return[doc(String$("The annotation class for [[abstract]].",38)),shared(),$final(),annotation()];},d:['ceylon.language','AbstractAnnotation']};};
exports.AbstractAnnotation=AbstractAnnotation;
function $init$AbstractAnnotation(){
    if (AbstractAnnotation.$$===undefined){
        initTypeProto(AbstractAnnotation,'ceylon.language::AbstractAnnotation',Basic,$init$OptionalAnnotation());
    }
    return AbstractAnnotation;
}
exports.$init$AbstractAnnotation=$init$AbstractAnnotation;
$init$AbstractAnnotation();
var abstract=function (){
    return AbstractAnnotation();
};
abstract.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:AbstractAnnotation},$ps:[],$an:function(){return[doc(String$("Annotation to mark a class as abstract. An `abstract` class \nmay not be directly instantiated. An `abstract` class may \nhave enumerated cases.",142)),shared(),annotation()];},d:['ceylon.language','abstract']};};
exports.abstract=abstract;
function FinalAnnotation($$finalAnnotation){
    $init$FinalAnnotation();
    if ($$finalAnnotation===undefined)$$finalAnnotation=new FinalAnnotation.$$;
    $$finalAnnotation.$$targs$$={Value:{t:FinalAnnotation},ProgramElement:{t:ClassDeclaration$meta$declaration}};
    OptionalAnnotation({Value:{t:FinalAnnotation},ProgramElement:{t:ClassDeclaration$meta$declaration}},$$finalAnnotation);
    add_type_arg($$finalAnnotation,'Value',{t:FinalAnnotation});
    add_type_arg($$finalAnnotation,'ProgramElement',{t:ClassDeclaration$meta$declaration});
    return $$finalAnnotation;
}
FinalAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],satisfies:[{t:OptionalAnnotation,a:{Value:{t:FinalAnnotation},ProgramElement:{t:ClassDeclaration$meta$declaration}}}],$an:function(){return[doc(String$("The annotation class for [[final]].",35)),shared(),$final(),annotation()];},d:['ceylon.language','FinalAnnotation']};};
exports.FinalAnnotation=FinalAnnotation;
function $init$FinalAnnotation(){
    if (FinalAnnotation.$$===undefined){
        initTypeProto(FinalAnnotation,'ceylon.language::FinalAnnotation',Basic,$init$OptionalAnnotation());
    }
    return FinalAnnotation;
}
exports.$init$FinalAnnotation=$init$FinalAnnotation;
$init$FinalAnnotation();
var $final=function (){
    return FinalAnnotation();
};
$final.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:FinalAnnotation},$ps:[],$an:function(){return[doc(String$("Annotation to mark a class as final. A `final` class may \nnot be extended. Marking a class as final affects disjoint\ntype analysis.",131)),shared(),annotation()];},d:['ceylon.language','final']};};
exports.$final=$final;
function ActualAnnotation($$actualAnnotation){
    $init$ActualAnnotation();
    if ($$actualAnnotation===undefined)$$actualAnnotation=new ActualAnnotation.$$;
    $$actualAnnotation.$$targs$$={Value:{t:ActualAnnotation},ProgramElement:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration},{t:ClassOrInterfaceDeclaration$meta$declaration}]}};
    OptionalAnnotation({Value:{t:ActualAnnotation},ProgramElement:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration},{t:ClassOrInterfaceDeclaration$meta$declaration}]}},$$actualAnnotation);
    add_type_arg($$actualAnnotation,'Value',{t:ActualAnnotation});
    return $$actualAnnotation;
}
ActualAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],satisfies:[{t:OptionalAnnotation,a:{Value:{t:ActualAnnotation},ProgramElement:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration},{t:ClassOrInterfaceDeclaration$meta$declaration}]}}}],$an:function(){return[doc(String$("The annotation class for [[actual]].",36)),shared(),$final(),annotation()];},d:['ceylon.language','ActualAnnotation']};};
exports.ActualAnnotation=ActualAnnotation;
function $init$ActualAnnotation(){
    if (ActualAnnotation.$$===undefined){
        initTypeProto(ActualAnnotation,'ceylon.language::ActualAnnotation',Basic,$init$OptionalAnnotation());
    }
    return ActualAnnotation;
}
exports.$init$ActualAnnotation=$init$ActualAnnotation;
$init$ActualAnnotation();
var actual=function (){
    return ActualAnnotation();
};
actual.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:ActualAnnotation},$ps:[],$an:function(){return[doc(String$("Annotation to mark a member of a type as refining a member \nof a supertype.",75)),shared(),annotation()];},d:['ceylon.language','actual']};};
exports.actual=actual;
function FormalAnnotation($$formalAnnotation){
    $init$FormalAnnotation();
    if ($$formalAnnotation===undefined)$$formalAnnotation=new FormalAnnotation.$$;
    $$formalAnnotation.$$targs$$={Value:{t:FormalAnnotation},ProgramElement:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration},{t:ClassOrInterfaceDeclaration$meta$declaration}]}};
    OptionalAnnotation({Value:{t:FormalAnnotation},ProgramElement:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration},{t:ClassOrInterfaceDeclaration$meta$declaration}]}},$$formalAnnotation);
    add_type_arg($$formalAnnotation,'Value',{t:FormalAnnotation});
    return $$formalAnnotation;
}
FormalAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],satisfies:[{t:OptionalAnnotation,a:{Value:{t:FormalAnnotation},ProgramElement:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration},{t:ClassOrInterfaceDeclaration$meta$declaration}]}}}],$an:function(){return[doc(String$("The annotation class for [[formal]].",36)),shared(),$final(),annotation()];},d:['ceylon.language','FormalAnnotation']};};
exports.FormalAnnotation=FormalAnnotation;
function $init$FormalAnnotation(){
    if (FormalAnnotation.$$===undefined){
        initTypeProto(FormalAnnotation,'ceylon.language::FormalAnnotation',Basic,$init$OptionalAnnotation());
    }
    return FormalAnnotation;
}
exports.$init$FormalAnnotation=$init$FormalAnnotation;
$init$FormalAnnotation();
var formal=function (){
    return FormalAnnotation();
};
formal.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:FormalAnnotation},$ps:[],$an:function(){return[doc(String$("Annotation to mark a member whose implementation must be \nprovided by subtypes.",79)),shared(),annotation()];},d:['ceylon.language','formal']};};
exports.formal=formal;
function DefaultAnnotation($$defaultAnnotation){
    $init$DefaultAnnotation();
    if ($$defaultAnnotation===undefined)$$defaultAnnotation=new DefaultAnnotation.$$;
    $$defaultAnnotation.$$targs$$={Value:{t:DefaultAnnotation},ProgramElement:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration},{t:ClassOrInterfaceDeclaration$meta$declaration}]}};
    OptionalAnnotation({Value:{t:DefaultAnnotation},ProgramElement:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration},{t:ClassOrInterfaceDeclaration$meta$declaration}]}},$$defaultAnnotation);
    add_type_arg($$defaultAnnotation,'Value',{t:DefaultAnnotation});
    return $$defaultAnnotation;
}
DefaultAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],satisfies:[{t:OptionalAnnotation,a:{Value:{t:DefaultAnnotation},ProgramElement:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration},{t:ClassOrInterfaceDeclaration$meta$declaration}]}}}],$an:function(){return[doc(String$("The annotation class for [[default]].",37)),shared(),$final(),annotation()];},d:['ceylon.language','DefaultAnnotation']};};
exports.DefaultAnnotation=DefaultAnnotation;
function $init$DefaultAnnotation(){
    if (DefaultAnnotation.$$===undefined){
        initTypeProto(DefaultAnnotation,'ceylon.language::DefaultAnnotation',Basic,$init$OptionalAnnotation());
    }
    return DefaultAnnotation;
}
exports.$init$DefaultAnnotation=$init$DefaultAnnotation;
$init$DefaultAnnotation();
var $default=function (){
    return DefaultAnnotation();
};
$default.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:DefaultAnnotation},$ps:[],$an:function(){return[doc(String$("Annotation to mark a member whose implementation may be \nrefined by subtypes. Non-`default` declarations may not be \nrefined.",125)),shared(),annotation()];},d:['ceylon.language','default']};};
exports.$default=$default;
function LateAnnotation($$lateAnnotation){
    $init$LateAnnotation();
    if ($$lateAnnotation===undefined)$$lateAnnotation=new LateAnnotation.$$;
    $$lateAnnotation.$$targs$$={Value:{t:LateAnnotation},ProgramElement:{t:ValueDeclaration$meta$declaration}};
    OptionalAnnotation({Value:{t:LateAnnotation},ProgramElement:{t:ValueDeclaration$meta$declaration}},$$lateAnnotation);
    add_type_arg($$lateAnnotation,'Value',{t:LateAnnotation});
    add_type_arg($$lateAnnotation,'ProgramElement',{t:ValueDeclaration$meta$declaration});
    return $$lateAnnotation;
}
LateAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],satisfies:[{t:OptionalAnnotation,a:{Value:{t:LateAnnotation},ProgramElement:{t:ValueDeclaration$meta$declaration}}}],$an:function(){return[doc(String$("The annotation class for [[late]].",34)),shared(),$final(),annotation()];},d:['ceylon.language','LateAnnotation']};};
exports.LateAnnotation=LateAnnotation;
function $init$LateAnnotation(){
    if (LateAnnotation.$$===undefined){
        initTypeProto(LateAnnotation,'ceylon.language::LateAnnotation',Basic,$init$OptionalAnnotation());
    }
    return LateAnnotation;
}
exports.$init$LateAnnotation=$init$LateAnnotation;
$init$LateAnnotation();
var late=function (){
    return LateAnnotation();
};
late.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:LateAnnotation},$ps:[],$an:function(){return[doc(String$("Annotation to disable definite initialization analysis for \na reference.",72)),shared(),annotation()];},d:['ceylon.language','late']};};
exports.late=late;
function NativeAnnotation($$nativeAnnotation){
    $init$NativeAnnotation();
    if ($$nativeAnnotation===undefined)$$nativeAnnotation=new NativeAnnotation.$$;
    $$nativeAnnotation.$$targs$$={Value:{t:NativeAnnotation},ProgramElement:{t:Annotated}};
    OptionalAnnotation({Value:{t:NativeAnnotation},ProgramElement:{t:Annotated}},$$nativeAnnotation);
    add_type_arg($$nativeAnnotation,'Value',{t:NativeAnnotation});
    add_type_arg($$nativeAnnotation,'ProgramElement',{t:Annotated});
    return $$nativeAnnotation;
}
NativeAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],satisfies:[{t:OptionalAnnotation,a:{Value:{t:NativeAnnotation},ProgramElement:{t:Annotated}}}],$an:function(){return[doc(String$("The annotation class for [[native]].",36)),shared(),$final(),annotation()];},d:['ceylon.language','NativeAnnotation']};};
exports.NativeAnnotation=NativeAnnotation;
function $init$NativeAnnotation(){
    if (NativeAnnotation.$$===undefined){
        initTypeProto(NativeAnnotation,'ceylon.language::NativeAnnotation',Basic,$init$OptionalAnnotation());
    }
    return NativeAnnotation;
}
exports.$init$NativeAnnotation=$init$NativeAnnotation;
$init$NativeAnnotation();
var $native=function (){
    return NativeAnnotation();
};
$native.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:NativeAnnotation},$ps:[],$an:function(){return[doc(String$("Annotation to mark a member whose implementation is defined \nin platform-native code.",85)),shared(),annotation()];},d:['ceylon.language','native']};};
exports.$native=$native;
function DocAnnotation(description, $$docAnnotation){
    $init$DocAnnotation();
    if ($$docAnnotation===undefined)$$docAnnotation=new DocAnnotation.$$;
    $$docAnnotation.$$targs$$={Value:{t:DocAnnotation},ProgramElement:{t:Annotated}};
    $$docAnnotation.description_=description;
    OptionalAnnotation({Value:{t:DocAnnotation},ProgramElement:{t:Annotated}},$$docAnnotation);
    add_type_arg($$docAnnotation,'Value',{t:DocAnnotation});
    add_type_arg($$docAnnotation,'ProgramElement',{t:Annotated});
    return $$docAnnotation;
}
DocAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[{$nm:'description',$mt:'prm',$t:{t:String$},$an:function(){return[doc("Documentation, in Markdown syntax, about the annotated element"),shared()];}}],satisfies:[{t:OptionalAnnotation,a:{Value:{t:DocAnnotation},ProgramElement:{t:Annotated}}}],$an:function(){return[doc(String$("The annotation class for the [[doc]] annotation.",48)),shared(),$final(),annotation()];},d:['ceylon.language','DocAnnotation']};};
exports.DocAnnotation=DocAnnotation;
function $init$DocAnnotation(){
    if (DocAnnotation.$$===undefined){
        initTypeProto(DocAnnotation,'ceylon.language::DocAnnotation',Basic,$init$OptionalAnnotation());
        (function($$docAnnotation){
            defineAttr($$docAnnotation,'description',function(){return this.description_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:DocAnnotation,$an:function(){return[doc("Documentation, in Markdown syntax, about the annotated element"),shared()];},d:['ceylon.language','DocAnnotation','$at','description']};});
        })(DocAnnotation.$$.prototype);
    }
    return DocAnnotation;
}
exports.$init$DocAnnotation=$init$DocAnnotation;
$init$DocAnnotation();
var doc=function (description$1036){
    return DocAnnotation(description$1036);
};
doc.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:DocAnnotation},$ps:[{$nm:'description',$mt:'prm',$t:{t:String$},$an:function(){return[doc("Documentation, in Markdown syntax, about the annotated element")];}}],$an:function(){return[doc(String$("Annotation to specify API documentation of a program\nelement.",61)),shared(),annotation()];},d:['ceylon.language','doc']};};
exports.doc=doc;
function SeeAnnotation(programElements, $$seeAnnotation){
    $init$SeeAnnotation();
    if ($$seeAnnotation===undefined)$$seeAnnotation=new SeeAnnotation.$$;
    $$seeAnnotation.$$targs$$={Value:{t:SeeAnnotation},ProgramElement:{t:Annotated}};
    if(programElements===undefined){programElements=getEmpty();}
    $$seeAnnotation.programElements_=programElements;
    SequencedAnnotation({Value:{t:SeeAnnotation},ProgramElement:{t:Annotated}},$$seeAnnotation);
    add_type_arg($$seeAnnotation,'Value',{t:SeeAnnotation});
    add_type_arg($$seeAnnotation,'ProgramElement',{t:Annotated});
    return $$seeAnnotation;
}
SeeAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[{$nm:'programElements',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Declaration$meta$declaration}}},$an:function(){return[doc("The program elements being referred to."),shared()];}}],satisfies:[{t:SequencedAnnotation,a:{Value:{t:SeeAnnotation},ProgramElement:{t:Annotated}}}],$an:function(){return[doc(String$("The annotation class for [[see]].",33)),shared(),$final(),annotation()];},d:['ceylon.language','SeeAnnotation']};};
exports.SeeAnnotation=SeeAnnotation;
function $init$SeeAnnotation(){
    if (SeeAnnotation.$$===undefined){
        initTypeProto(SeeAnnotation,'ceylon.language::SeeAnnotation',Basic,$init$SequencedAnnotation());
        (function($$seeAnnotation){
            defineAttr($$seeAnnotation,'programElements',function(){return this.programElements_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:Declaration$meta$declaration}}},$cont:SeeAnnotation,$an:function(){return[doc("The program elements being referred to."),shared()];},d:['ceylon.language','SeeAnnotation','$at','programElements']};});
        })(SeeAnnotation.$$.prototype);
    }
    return SeeAnnotation;
}
exports.$init$SeeAnnotation=$init$SeeAnnotation;
$init$SeeAnnotation();
var see=function (programElements$1037){
    if(programElements$1037===undefined){programElements$1037=getEmpty();}
    return SeeAnnotation(programElements$1037);
};
see.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:SeeAnnotation},$ps:[{$nm:'programElements',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Declaration$meta$declaration}}},$an:function(){return[doc("The program elements being referred to.")];}}],$an:function(){return[doc(String$("Annotation to specify API references to other related \nprogram elements.",72)),shared(),annotation()];},d:['ceylon.language','see']};};
exports.see=see;
function AuthorsAnnotation(authors, $$authorsAnnotation){
    $init$AuthorsAnnotation();
    if ($$authorsAnnotation===undefined)$$authorsAnnotation=new AuthorsAnnotation.$$;
    $$authorsAnnotation.$$targs$$={Value:{t:AuthorsAnnotation},ProgramElement:{t:Annotated}};
    if(authors===undefined){authors=getEmpty();}
    $$authorsAnnotation.authors_=authors;
    OptionalAnnotation({Value:{t:AuthorsAnnotation},ProgramElement:{t:Annotated}},$$authorsAnnotation);
    add_type_arg($$authorsAnnotation,'Value',{t:AuthorsAnnotation});
    add_type_arg($$authorsAnnotation,'ProgramElement',{t:Annotated});
    return $$authorsAnnotation;
}
AuthorsAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[{$nm:'authors',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:String$}}},$an:function(){return[doc("The authors, in Markdown syntax, of the annotated element"),shared()];}}],satisfies:[{t:OptionalAnnotation,a:{Value:{t:AuthorsAnnotation},ProgramElement:{t:Annotated}}}],$an:function(){return[doc(String$("The annotation class for [[by]].",32)),shared(),$final(),annotation()];},d:['ceylon.language','AuthorsAnnotation']};};
exports.AuthorsAnnotation=AuthorsAnnotation;
function $init$AuthorsAnnotation(){
    if (AuthorsAnnotation.$$===undefined){
        initTypeProto(AuthorsAnnotation,'ceylon.language::AuthorsAnnotation',Basic,$init$OptionalAnnotation());
        (function($$authorsAnnotation){
            defineAttr($$authorsAnnotation,'authors',function(){return this.authors_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:String$}}},$cont:AuthorsAnnotation,$an:function(){return[doc("The authors, in Markdown syntax, of the annotated element"),shared()];},d:['ceylon.language','AuthorsAnnotation','$at','authors']};});
        })(AuthorsAnnotation.$$.prototype);
    }
    return AuthorsAnnotation;
}
exports.$init$AuthorsAnnotation=$init$AuthorsAnnotation;
$init$AuthorsAnnotation();
var by=function (authors$1038){
    if(authors$1038===undefined){authors$1038=getEmpty();}
    return AuthorsAnnotation(authors$1038);
};
by.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:AuthorsAnnotation},$ps:[{$nm:'authors',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:String$}}},$an:function(){return[doc("The authors, in Markdown syntax, of the annotated element")];}}],$an:function(){return[doc(String$("Annotation to specify API authors.",34)),shared(),annotation()];},d:['ceylon.language','by']};};
exports.by=by;
function ThrownExceptionAnnotation(type, when, $$thrownExceptionAnnotation){
    $init$ThrownExceptionAnnotation();
    if ($$thrownExceptionAnnotation===undefined)$$thrownExceptionAnnotation=new ThrownExceptionAnnotation.$$;
    $$thrownExceptionAnnotation.$$targs$$={Value:{t:ThrownExceptionAnnotation},ProgramElement:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration},{t:ClassDeclaration$meta$declaration}]}};
    $$thrownExceptionAnnotation.type_=type;
    $$thrownExceptionAnnotation.when_=when;
    SequencedAnnotation({Value:{t:ThrownExceptionAnnotation},ProgramElement:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration},{t:ClassDeclaration$meta$declaration}]}},$$thrownExceptionAnnotation);
    add_type_arg($$thrownExceptionAnnotation,'Value',{t:ThrownExceptionAnnotation});
    return $$thrownExceptionAnnotation;
}
ThrownExceptionAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[{$nm:'type',$mt:'prm',$t:{t:Declaration$meta$declaration},$an:function(){return[doc("The [[Exception]] type that this thrown."),shared()];}},{$nm:'when',$mt:'prm',$t:{t:String$},$an:function(){return[doc("A description, in Markdown syntax, of the circumstances that \ncause this exception to be thrown."),shared()];}}],satisfies:[{t:SequencedAnnotation,a:{Value:{t:ThrownExceptionAnnotation},ProgramElement:{t:'u', l:[{t:ValueDeclaration$meta$declaration},{t:FunctionDeclaration$meta$declaration},{t:ClassDeclaration$meta$declaration}]}}}],$an:function(){return[doc(String$("The annotation class for [[throws]].",36)),shared(),$final(),annotation()];},d:['ceylon.language','ThrownExceptionAnnotation']};};
exports.ThrownExceptionAnnotation=ThrownExceptionAnnotation;
function $init$ThrownExceptionAnnotation(){
    if (ThrownExceptionAnnotation.$$===undefined){
        initTypeProto(ThrownExceptionAnnotation,'ceylon.language::ThrownExceptionAnnotation',Basic,$init$SequencedAnnotation());
        (function($$thrownExceptionAnnotation){
            defineAttr($$thrownExceptionAnnotation,'type',function(){return this.type_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Declaration$meta$declaration},$cont:ThrownExceptionAnnotation,$an:function(){return[doc("The [[Exception]] type that this thrown."),shared()];},d:['ceylon.language','ThrownExceptionAnnotation','$at','type']};});
            defineAttr($$thrownExceptionAnnotation,'when',function(){return this.when_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:ThrownExceptionAnnotation,$an:function(){return[doc("A description, in Markdown syntax, of the circumstances that \ncause this exception to be thrown."),shared()];},d:['ceylon.language','ThrownExceptionAnnotation','$at','when']};});
        })(ThrownExceptionAnnotation.$$.prototype);
    }
    return ThrownExceptionAnnotation;
}
exports.$init$ThrownExceptionAnnotation=$init$ThrownExceptionAnnotation;
$init$ThrownExceptionAnnotation();
var $throws=function (type$1039,when$1040){
    if(when$1040===undefined){when$1040=String$("",0);}
    return ThrownExceptionAnnotation(type$1039,when$1040);
};
$throws.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:ThrownExceptionAnnotation},$ps:[{$nm:'type',$mt:'prm',$t:{t:Declaration$meta$declaration},$an:function(){return[doc("The [[Exception]] type that this thrown.")];}},{$nm:'when',$mt:'prm',$def:1,$t:{t:String$},$an:function(){return[doc("A description, in Markdown syntax, of the circumstances that \ncause this exception to be thrown.")];}}],$an:function(){return[doc(String$("Annotation to mark a program element that throws an \nexception.",63)),shared(),annotation()];},d:['ceylon.language','throws']};};
exports.$throws=$throws;
function DeprecationAnnotation(description, $$deprecationAnnotation){
    $init$DeprecationAnnotation();
    if ($$deprecationAnnotation===undefined)$$deprecationAnnotation=new DeprecationAnnotation.$$;
    $$deprecationAnnotation.$$targs$$={Value:{t:DeprecationAnnotation},ProgramElement:{t:Annotated}};
    $$deprecationAnnotation.description_=description;
    OptionalAnnotation({Value:{t:DeprecationAnnotation},ProgramElement:{t:Annotated}},$$deprecationAnnotation);
    add_type_arg($$deprecationAnnotation,'Value',{t:DeprecationAnnotation});
    add_type_arg($$deprecationAnnotation,'ProgramElement',{t:Annotated});
    return $$deprecationAnnotation;
}
DeprecationAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[{$nm:'description',$mt:'prm',$t:{t:String$},$an:function(){return[doc("A description, in Markdown syntax, of why the element is deprecated, \nand what replacements are available."),shared()];}}],satisfies:[{t:OptionalAnnotation,a:{Value:{t:DeprecationAnnotation},ProgramElement:{t:Annotated}}}],$an:function(){return[doc(String$("The annotation class for [[deprecated]].",40)),shared(),$final(),annotation()];},d:['ceylon.language','DeprecationAnnotation']};};
exports.DeprecationAnnotation=DeprecationAnnotation;
function $init$DeprecationAnnotation(){
    if (DeprecationAnnotation.$$===undefined){
        initTypeProto(DeprecationAnnotation,'ceylon.language::DeprecationAnnotation',Basic,$init$OptionalAnnotation());
        (function($$deprecationAnnotation){
            defineAttr($$deprecationAnnotation,'reason',function(){
                var $$deprecationAnnotation=this;
                if($$deprecationAnnotation.description.empty){
                    return null;
                }
                return $$deprecationAnnotation.description;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:String$}]},$cont:DeprecationAnnotation,$an:function(){return[doc(String$("A description, in Markdown syntax, of why the element is deprecated, \nand what replacements are available, or null.",115)),shared()];},d:['ceylon.language','DeprecationAnnotation','$at','reason']};});defineAttr($$deprecationAnnotation,'description',function(){return this.description_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:DeprecationAnnotation,$an:function(){return[doc("A description, in Markdown syntax, of why the element is deprecated, \nand what replacements are available."),shared()];},d:['ceylon.language','DeprecationAnnotation','$at','description']};});
        })(DeprecationAnnotation.$$.prototype);
    }
    return DeprecationAnnotation;
}
exports.$init$DeprecationAnnotation=$init$DeprecationAnnotation;
$init$DeprecationAnnotation();
var deprecated=function (reason$1041){
    if(reason$1041===undefined){reason$1041=String$("",0);}
    return DeprecationAnnotation(reason$1041);
};
deprecated.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:DeprecationAnnotation},$ps:[{$nm:'reason',$mt:'prm',$def:1,$t:{t:String$},$an:function(){return[doc("A description, in Markdown syntax, of why the element is deprecated, \nand what replacements are available.")];}}],$an:function(){return[doc(String$("Annotation to mark program elements which should not be \nused anymore.",70)),shared(),annotation()];},d:['ceylon.language','deprecated']};};
exports.deprecated=deprecated;
function TagsAnnotation(tags, $$tagsAnnotation){
    $init$TagsAnnotation();
    if ($$tagsAnnotation===undefined)$$tagsAnnotation=new TagsAnnotation.$$;
    $$tagsAnnotation.$$targs$$={Value:{t:TagsAnnotation},ProgramElement:{t:Annotated}};
    if(tags===undefined){tags=getEmpty();}
    $$tagsAnnotation.tags_=tags;
    OptionalAnnotation({Value:{t:TagsAnnotation},ProgramElement:{t:Annotated}},$$tagsAnnotation);
    add_type_arg($$tagsAnnotation,'Value',{t:TagsAnnotation});
    add_type_arg($$tagsAnnotation,'ProgramElement',{t:Annotated});
    return $$tagsAnnotation;
}
TagsAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[{$nm:'tags',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:String$}}},$an:function(){return[doc("The tags, in plain text."),shared()];}}],satisfies:[{t:OptionalAnnotation,a:{Value:{t:TagsAnnotation},ProgramElement:{t:Annotated}}}],$an:function(){return[doc(String$("The annotation class for [[tagged]].",36)),shared(),$final(),annotation()];},d:['ceylon.language','TagsAnnotation']};};
exports.TagsAnnotation=TagsAnnotation;
function $init$TagsAnnotation(){
    if (TagsAnnotation.$$===undefined){
        initTypeProto(TagsAnnotation,'ceylon.language::TagsAnnotation',Basic,$init$OptionalAnnotation());
        (function($$tagsAnnotation){
            defineAttr($$tagsAnnotation,'tags',function(){return this.tags_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:String$}}},$cont:TagsAnnotation,$an:function(){return[doc("The tags, in plain text."),shared()];},d:['ceylon.language','TagsAnnotation','$at','tags']};});
        })(TagsAnnotation.$$.prototype);
    }
    return TagsAnnotation;
}
exports.$init$TagsAnnotation=$init$TagsAnnotation;
$init$TagsAnnotation();
var tagged=function (tags$1042){
    if(tags$1042===undefined){tags$1042=getEmpty();}
    return TagsAnnotation(tags$1042);
};
tagged.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:TagsAnnotation},$ps:[{$nm:'tags',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:String$}}},$an:function(){return[doc("The tags, in plain text.")];}}],$an:function(){return[doc(String$("Annotation to categorize the API by tag.",40)),shared(),annotation()];},d:['ceylon.language','tagged']};};
exports.tagged=tagged;
function LicenseAnnotation(description, $$licenseAnnotation){
    $init$LicenseAnnotation();
    if ($$licenseAnnotation===undefined)$$licenseAnnotation=new LicenseAnnotation.$$;
    $$licenseAnnotation.$$targs$$={Value:{t:LicenseAnnotation},ProgramElement:{t:Module$meta$declaration}};
    $$licenseAnnotation.description_=description;
    OptionalAnnotation({Value:{t:LicenseAnnotation},ProgramElement:{t:Module$meta$declaration}},$$licenseAnnotation);
    add_type_arg($$licenseAnnotation,'Value',{t:LicenseAnnotation});
    add_type_arg($$licenseAnnotation,'ProgramElement',{t:Module$meta$declaration});
    return $$licenseAnnotation;
}
LicenseAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[{$nm:'description',$mt:'prm',$t:{t:String$},$an:function(){return[doc("The name, text, or URL of the license."),shared()];}}],satisfies:[{t:OptionalAnnotation,a:{Value:{t:LicenseAnnotation},ProgramElement:{t:Module$meta$declaration}}}],$an:function(){return[doc(String$("The annotation class for [[license]].",37)),shared(),$final(),annotation()];},d:['ceylon.language','LicenseAnnotation']};};
exports.LicenseAnnotation=LicenseAnnotation;
function $init$LicenseAnnotation(){
    if (LicenseAnnotation.$$===undefined){
        initTypeProto(LicenseAnnotation,'ceylon.language::LicenseAnnotation',Basic,$init$OptionalAnnotation());
        (function($$licenseAnnotation){
            defineAttr($$licenseAnnotation,'description',function(){return this.description_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:LicenseAnnotation,$an:function(){return[doc("The name, text, or URL of the license."),shared()];},d:['ceylon.language','LicenseAnnotation','$at','description']};});
        })(LicenseAnnotation.$$.prototype);
    }
    return LicenseAnnotation;
}
exports.$init$LicenseAnnotation=$init$LicenseAnnotation;
$init$LicenseAnnotation();
var license=function (description$1043){
    return LicenseAnnotation(description$1043);
};
license.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:LicenseAnnotation},$ps:[{$nm:'description',$mt:'prm',$t:{t:String$},$an:function(){return[doc("The name, text, or URL of the license.")];}}],$an:function(){return[doc(String$("Annotation to specify the URL of the license of a module or \npackage.",69)),shared(),annotation()];},d:['ceylon.language','license']};};
exports.license=license;
function OptionalImportAnnotation($$optionalImportAnnotation){
    $init$OptionalImportAnnotation();
    if ($$optionalImportAnnotation===undefined)$$optionalImportAnnotation=new OptionalImportAnnotation.$$;
    $$optionalImportAnnotation.$$targs$$={Value:{t:OptionalImportAnnotation},ProgramElement:{t:Import$meta$declaration}};
    OptionalAnnotation({Value:{t:OptionalImportAnnotation},ProgramElement:{t:Import$meta$declaration}},$$optionalImportAnnotation);
    add_type_arg($$optionalImportAnnotation,'Value',{t:OptionalImportAnnotation});
    add_type_arg($$optionalImportAnnotation,'ProgramElement',{t:Import$meta$declaration});
    return $$optionalImportAnnotation;
}
OptionalImportAnnotation.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],satisfies:[{t:OptionalAnnotation,a:{Value:{t:OptionalImportAnnotation},ProgramElement:{t:Import$meta$declaration}}}],$an:function(){return[doc(String$("The annotation class for [[optional]].",38)),shared(),$final(),annotation()];},d:['ceylon.language','OptionalImportAnnotation']};};
exports.OptionalImportAnnotation=OptionalImportAnnotation;
function $init$OptionalImportAnnotation(){
    if (OptionalImportAnnotation.$$===undefined){
        initTypeProto(OptionalImportAnnotation,'ceylon.language::OptionalImportAnnotation',Basic,$init$OptionalAnnotation());
    }
    return OptionalImportAnnotation;
}
exports.$init$OptionalImportAnnotation=$init$OptionalImportAnnotation;
$init$OptionalImportAnnotation();
var optional=function (){
    return OptionalImportAnnotation();
};
optional.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:OptionalImportAnnotation},$ps:[],$an:function(){return[doc(String$("Annotation to specify that a module can be executed even if \nthe annotated dependency is not available.",103)),shared(),annotation()];},d:['ceylon.language','optional']};};
exports.optional=optional;
function Number$(wat) {
    return wat;
}
initType(Number$, 'ceylon.language::Number');
Number$.$$metamodel$$=function(){return{$an:function(){return[shared()]},mod:$$METAMODEL$$,d:['ceylon.language','Number']};}
exports.Number=Number$;
function $init$Number$() {
    if (Number$.$$===undefined) {
        initType(Number$, 'ceylon.language::Number');
    }
    return Number$;
}

var toInt = function(float) {
    return (float >= 0) ? Math.floor(float) : Math.ceil(float);
}

function JSNumber(value) { return Number(value); }
initExistingType(JSNumber, Number, 'ceylon.language::JSNumber');
JSNumber.$$metamodel$$=function(){return{$nm:'JSNumber',$mt:'cls',$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','Number']};}

var origNumToString = Number.prototype.toString;
inheritProto(JSNumber, Object$, Scalar, $init$Integral(), Exponentiable);

function Integer(value) {
    if (value && value.getT$name && value.getT$name() === 'ceylon.language::Integer') {
        return value;
    }
    return Number(value);
}
initTypeProto(Integer, 'ceylon.language::Integer', Object$, Scalar, 
        $init$Integral(), Exponentiable, Binary);
Integer.$$metamodel$$=function(){return{$an:function(){return[shared(),native(),final()];},mod:$$METAMODEL$$,d:['ceylon.language','Integer']};}

function Float(value) {
    if (value && value.getT$name && value.getT$name() === 'ceylon.language::Float') {
        return value;
    }
    var that = new Number(value);
    that.float$ = true;
    return that;
}
initTypeProto(Float, 'ceylon.language::Float', Object$, Scalar, Exponentiable);
Float.$$metamodel$$=function(){return{$an:function(){return[shared(),native(),final()];},mod:$$METAMODEL$$,d:['ceylon.language','Float']};}

var JSNum$proto = Number.prototype;
JSNum$proto.getT$all = function() {
    return (this.float$ ? Float : Integer).$$.T$all;
}
JSNum$proto.getT$name = function() {
    return (this.float$ ? Float : Integer).$$.T$name;
}
JSNum$proto.toString = origNumToString;
defineAttr(JSNum$proto, 'string', function(){ return String$(this.toString()); },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Object$,d:['ceylon.language','Object','$at','string']};});
JSNum$proto.plus = function(other) {
    return (this.float$||other.float$) ? Float(this+other) : (this+other);
}
JSNum$proto.minus = function(other) {
    return (this.float$||other.float$) ? Float(this-other) : (this-other);
}
JSNum$proto.times = function(other) {
    return (this.float$||other.float$) ? Float(this*other) : (this*other);
}
JSNum$proto.divided = function(other) {
    if (this.float$||other.float$) { return Float(this/other); }
    if (other == 0) {
        throw Exception(String$("Division by Zero"));
    }
    return toInt(this/other);
}
JSNum$proto.remainder = function(other) { return this%other; }
JSNum$proto.power = function(exp) {
    if (this.float$||exp.float$) { return Float(Math.pow(this, exp)); }
    if (exp<0 && this!=1 && this!=-1) {
        throw Exception(String$("Negative exponent"));
    }
    return toInt(Math.pow(this, exp));
}
defineAttr(JSNum$proto, 'negativeValue', function() {
    return this.float$ ? Float(-this) : -this;
},undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Invertable,d:['ceylon.language','Invertable','$at','negativeValue']};});
defineAttr(JSNum$proto, 'positiveValue', function() {
    return this.float$ ? this : this.valueOf();
},undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Invertable,d:['ceylon.language','Invertable','$at','positiveValue']};});
defineAttr(JSNum$proto, 'negative', function(){
  return this.float$ ? this < 0.0 : this.valueOf() < 0;
},undefined,function(){return{$t:{t:Boolean$},$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Number$,d:['ceylon.language','Number','$at','negative']};});
defineAttr(JSNum$proto, 'positive', function(){
  return this.float$ ? this > 0.0 : this.valueOf() > 0;
},undefined,function(){return{$t:{t:Boolean$},$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Number$,d:['ceylon.language','Number','$at','positive']};});
JSNum$proto.equals = function(other) { return (typeof(other)==='number' || other.constructor===Number) && other==this.valueOf(); }
JSNum$proto.compare = function(other) {
    var value = this.valueOf();
    return value==other ? equal : (value<other ? smaller:larger);
}
defineAttr(JSNum$proto, '$float', function(){ return Float(this.valueOf()); },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Number$,d:['ceylon.language','Number','$at','float']};});
defineAttr(JSNum$proto, 'integer', function(){ return toInt(this); },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Number$,d:['ceylon.language','Number','$at','integer']};});
defineAttr(JSNum$proto, 'integerValue', function(){ return toInt(this); },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Ordinal,d:['ceylon.language','Ordinal','$at','integerValue']};});
defineAttr(JSNum$proto, 'character', function(){ return Character(this.valueOf()); },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Integer,d:['ceylon.language','Integer','$at','character']};});
defineAttr(JSNum$proto, 'successor', function(){ return this+1; },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Ordinal,d:['ceylon.language','Ordinal','$at','successor']};});
defineAttr(JSNum$proto, 'predecessor', function(){ return this-1; },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Ordinal,d:['ceylon.language','Ordinal','$at','predecessor']};});
defineAttr(JSNum$proto, 'unit', function(){ return this == 1; },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Integral,d:['ceylon.language','Integral','$at','unit']};});
defineAttr(JSNum$proto, 'zero', function(){ return this == 0; },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Integral,d:['ceylon.language','Integral','$at','zero']};});
defineAttr(JSNum$proto, 'fractionalPart', function() {
    if (!this.float$) { return 0; }
    return Float(this - (this>=0 ? Math.floor(this) : Math.ceil(this)));
},undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Number$,d:['ceylon.language','Number','$at','fractionalPart']};});
defineAttr(JSNum$proto, 'wholePart', function() {
    if (!this.float$) { return this.valueOf(); }
    return Float(this>=0 ? Math.floor(this) : Math.ceil(this));
},undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Number$,d:['ceylon.language','Number','$at','wholePart']};});
defineAttr(JSNum$proto, 'sign', function(){ return this > 0 ? 1 : this < 0 ? -1 : 0; },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Number$,d:['ceylon.language','Number','$at','sign']};});
defineAttr(JSNum$proto, 'hash', function() {
    return this.float$ ? String$(this.toPrecision()).hash : this.valueOf();
},undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Object$,d:['ceylon.language','Object','$at','hash']};});
JSNum$proto.distanceFrom = function(other) {
    return (this.float$ ? this.wholePart : this) - other;
}
//Binary interface
defineAttr(JSNum$proto, 'not', function(){ return ~this; },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Binary,d:['ceylon.language','Binary','$at','not']};});
JSNum$proto.leftLogicalShift = function(i) { return this << i; }
JSNum$proto.rightLogicalShift = function(i) { return this >> i; }
JSNum$proto.rightArithmeticShift = function(i) { return this >>> i; }
JSNum$proto.and = function(x) { return this & x; }
JSNum$proto.or = function(x) { return this | x; }
JSNum$proto.xor = function(x) { return this ^ x; }
JSNum$proto.$get = function(idx) {
    var mask = 1 << idx;
    return (this & mask) != 0 ? $true : $false;
}
JSNum$proto.set = function(idx,bit) {
    if (bit === undefined) { bit = $true; }
        var mask = idx > 1 ? 1 << idx : 1;
    return (bit === $true) ? this | mask : this & ~mask;
}
JSNum$proto.flip = function(idx) {
    var mask = 1 << idx;
    return this ^ mask;
}
JSNum$proto.clear = function(index) {
    return this.set(index, false);
}
defineAttr(JSNum$proto, 'size', function(){ return 53; },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Binary,d:['ceylon.language','Binary','$at','size']};});
defineAttr(JSNum$proto, 'magnitude', function(){ return Math.abs(this); },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Number$,d:['ceylon.language','Number','$at','magnitude']};});

function $parseFloat(s) { return Float(parseFloat(s)); }
$parseFloat.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u',l:[{t:Null},{t:Float}]},$ps:[{$nm:'string',$t:{t:String$}}],d:['ceylon.language','parseFloat']};}

defineAttr(JSNum$proto, 'undefined', function(){ return isNaN(this); },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Float,d:['ceylon.language','Float','$at','undefined']};});
defineAttr(JSNum$proto, 'finite', function(){ return this!=Infinity && this!=-Infinity && !isNaN(this); },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Float,d:['ceylon.language','Float','$at','finite']};});
defineAttr(JSNum$proto, 'infinite', function(){ return this==Infinity || this==-Infinity; },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Float,d:['ceylon.language','Float','$at','infinite']};});
defineAttr(JSNum$proto, 'strictlyPositive', function(){ return this>0 || (this==0 && (1/this==Infinity)); },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Float,d:['ceylon.language','Float','$at','strictlyPositive']};});
defineAttr(JSNum$proto, 'strictlyNegative', function() { return this<0 || (this==0 && (1/this==-Infinity)); },
  undefined,function(){return{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,$cont:Float,d:['ceylon.language','Float','$at','strictlyNegative']};});

var $infinity = Float(Infinity);
function getInfinity() { return $infinity; }
exports.$prop$getInfinity={get:getInfinity,$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Float},d:['ceylon.language','infinity']};}};

exports.Integer=Integer;
exports.Float=Float;
exports.getInfinity=getInfinity;
exports.parseFloat=$parseFloat;
function getNull() { return null }
exports.$prop$getNull={get:getNull,$$metamodel$$:function(){return{mod:$$METAMODEL$$,d:['ceylon.language','null'],$t:{t:Null}};}};
function Boolean$(value) {return Boolean(value)}
initExistingTypeProto(Boolean$, Boolean, 'ceylon.language::Boolean');
Boolean$.$$metamodel$$={$ps:[],$an:function(){return[shared(),abstract()]},mod:$$METAMODEL$$,d:['ceylon.language','Boolean']};
function trueClass() {}
initType(trueClass, "ceylon.language::true", Boolean$);
function falseClass() {}
initType(falseClass, "ceylon.language::false", Boolean$);
Boolean.prototype.getT$name = function() {
    return (this.valueOf()?trueClass:falseClass).$$.T$name;
}
Boolean.prototype.getT$all = function() {
    return (this.valueOf()?trueClass:falseClass).$$.T$all;
}
Boolean.prototype.equals = function(other) {return other.constructor===Boolean && other==this;}
defineAttr(Boolean.prototype, 'hash', function(){ return this.valueOf()?1:0; },
  undefined,{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','Object','$at','hash']});
var trueString = String$("true", 4);
var falseString = String$("false", 5);
defineAttr(Boolean.prototype, 'string', function(){ return this.valueOf()?trueString:falseString; },
  undefined,{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','Object','$at','string']});
function getTrue() {return true;}
function getFalse() {return false;}
exports.$prop$getTrue={get:getTrue,$$metamodel$$:function(){return{mod:$$METAMODEL$$,d:['ceylon.language','true'],$t:{t:Boolean$}};}};
exports.$prop$getFalse={get:getFalse,$$metamodel$$:function(){return{mod:$$METAMODEL$$,d:['ceylon.language','false'],$t:{t:Boolean$}};}};
var $true = true;
var $false = false;

function Comparison(name) {
    var that = new Comparison.$$;
    that.name = String$(name);
    return that;
}
initTypeProto(Comparison, 'ceylon.language::Comparison', $init$Basic());
Comparison.$$metamodel$$={$ps:[{t:String$}],$an:function(){return[shared(),abstract()]},mod:$$METAMODEL$$,d:['ceylon.language','Comparison']};
var Comparison$proto = Comparison.$$.prototype;
defineAttr(Comparison$proto, 'string', function(){ return this.name; },
  undefined,{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','Object','$at','string']});
var larger = Comparison("larger");
function getLarger() { return larger }
var smaller = Comparison("smaller");
function getSmaller() { return smaller }
var equal = Comparison("equal");
function getEqual() { return equal }

exports.getLarger=getLarger;
exports.getSmaller=getSmaller;
exports.getEqual=getEqual;
exports.$prop$getLarger={get:getLarger,$$metamodel$$:function(){return{mod:$$METAMODEL$$,d:['ceylon.language','larger'],$t:{t:Comparison}};}};
exports.$prop$getSmaller={get:getSmaller,$$metamodel$$:function(){return{mod:$$METAMODEL$$,d:['ceylon.language','smaller'],$t:{t:Comparison}};}};
exports.$prop$getEqual={get:getEqual,$$metamodel$$:function(){return{mod:$$METAMODEL$$,d:['ceylon.language','equal'],$t:{t:Comparison}};}};

//These are operators for handling nulls
function exists(value) {
  return value !== null && value !== undefined;
}
function nonempty(value) {
  return value !== null && value !== undefined && !value.empty;
}

function isOfType(obj, type) {
  if (type && type.t) {
    if (type.t==='i' || type.t==='u') {
      return isOfTypes(obj, type);
    } else if (type.t==='T') {
      type=$retuple(type);
    }
    if (obj===null || obj===undefined) {
      return type.t===Null || type.t===Anything;
    }
    if (obj.getT$all === undefined) {
      if (obj.$$metamodel$$) {
        var _mm = obj.$$metamodel$$;
        if (typeof(_mm)==='function') {
          _mm=_mm();
          obj.$$metamodel$$=_mm;
        }
        //We can navigate the metamodel
        if (_mm.d['$mt'] === 'mthd') {
          if (type.t === Callable) { //It's a callable reference
            if (type.a && type.a.Return && _mm['$t']) {
              //Check if return type matches
              if (extendsType(_mm['$t'], type.a.Return)) {
                if (type.a.Arguments && _mm['$ps'] !== undefined) {
                  var metaparams = _mm['$ps'];
                  if (metaparams.length == 0) {
                    return type.a.Arguments.t === Empty;
                  } else {
                    //check if arguments match
                    var comptype = type.a.Arguments;
                    for (var i=0; i < metaparams.length; i++) {
                      if (comptype.t !== Tuple || !extendsType(metaparams[i]['$t'], comptype.a.First)) {
                        return false;
                      }
                      comptype = comptype.a.Rest;
                    }
                  }
                }
                return true;
              }
            }
          }
        }
      }
      return false;
    }
    if (type.t.$$.T$name in obj.getT$all()) {
      if (type.a && obj.$$targs$$) {
        for (var i in type.a) {
          var cmptype = type.a[i];
          var tmpobj = obj;
          var iance = null;
          var _mm = type.t.$$metamodel$$;
          if (typeof(_mm)==='function') {
            _mm = _mm();
            type.t.$$metamodel$$=_mm;
          }
          if (_mm && _mm.$tp && _mm.$tp[i]) iance=_mm.$tp[i]['var'];
          if (iance===null) {//null means no i in _mm.$tp
            //Type parameter may be in the outer type
            while (iance===null && tmpobj.$$outer !== undefined) {
              tmpobj=tmpobj.$$outer;
              var _tmpf = tmpobj.constructor.T$all[tmpobj.constructor.T$name];
              var _mmf = typeof(_tmpf.$$metamodel$$)==='function'?_tmpf.$$metamodel$$():_tmpf.$$metamodel$$;
              if (_mmf && _mmf.$tp && _mmf.$tp[i]) {
                iance=_mmf.$tp[i]['var'];
              }
            }
          }
          if (iance === 'out') {
            if (!extendsType(tmpobj.$$targs$$[i], cmptype)) {
              return false;
            }
          } else if (iance === 'in') {
            if (!extendsType(cmptype, tmpobj.$$targs$$[i])) {
              return false;
            }
          } else if (iance === undefined) {
            var _targ=tmpobj.$$targs$$[i];
            if (!(_targ && _targ.t && (_targ.t.$$ || _targ.t==='i' || _targ.t==='u')))return false;
            if (_targ.t.$$) {
              if (cmptype && cmptype.t && cmptype.t.$$) {
                if (!(cmptype.t.$$.T$name && _targ.t.$$.T$name === cmptype.t.$$.T$name))return false;
              } else if (cmptype && cmptype.t && cmptype.t==='i') {
                //_targ must satisfy all types in cmptype
                console.log("FIXME! Comparing type argument vs intersection type parameter");
                if (cmptype.t!==_targ.t || !cmptype.l || cmptype.l.length!==_targ.l.length)return false;
                for (var i=0; i<_targ.l.length;i++) {
                  if (!extendsType(_targ.l[i],cmptype))return false;
                }
              } else if (cmptype && cmptype.t && cmptype.t==='u') {
                //_targ must satisfy at least one type in cmptype
                console.log("FIXME! Comparing type argument vs union type parameter");
                if (cmptype.t!==_targ.t || !cmptype.l || cmptype.l.length!==_targ.l.length)return false;
                for (var i=0; i<_targ.l.length;i++) {
                  if (!extendsType(_targ.l[i],cmptype))return false;
                }
              }
            } else {
              if (cmptype.t!==_targ.t || !cmptype.l || cmptype.l.length!==_targ.l.length)return false;
              for (var i=0; i<_targ.l.length;i++) {
                if (!extendsType(_targ.l[i],cmptype))return false;
              }
            }
          } else if (iance === null) {
            console.log("Possible missing metamodel for " + type.t.$$.T$name + "<" + i + ">");
          } else {
            console.log("Don't know what to do about variance '" + iance + "'");
          }
        }
      }
      return true;
    }
  }
  return false;
}
function isOfTypes(obj, types) {
  if (obj===null) {
    for (var i=0; i < types.l.length; i++) {
      if(types.l[i].t===Null || types.l[i].t===Anything) return true;
      else if (types.l[i].t==='u') {
        if (isOfTypes(null, types.l[i])) return true;
      }
    }
    return false;
  }
  if (obj === undefined || obj.getT$all === undefined) { return false; }
  var unions = false;
  var inters = true;
  var _ints=false;
  var objTypes = obj.getT$all();
  for (var i = 0; i < types.l.length; i++) {
    var t = types.l[i];
    var partial = isOfType(obj, t);
    if (types.t==='u') {
      unions = partial || unions;
    } else {
      inters = partial && inters;
      _ints=true;
    }
  }
  return _ints ? inters||unions : unions;
}
function extendsType(t1, t2) { //true if t1 is subtype of t2
    if (t1 === undefined || t1.t === undefined || t1.t === Nothing || t2 === undefined || t2.t === undefined) {
      return true;//t2 === undefined;
    } else if (t2 && t2.t === Anything) {
      return true;
    } else if (t1 === null) {
      return t2.t === Null || t2.t === Anything;
    }
    if (t1.t === 'u' || t1.t === 'i') {
        if (t1.t==='i')removeSupertypes(t1.l);
        var unions = false;
        var inters = true;
        var _ints = false;
        for (var i = 0; i < t1.l.length; i++) {
            var partial = extendsType(t1.l[i], t2);
            if (t1.t==='i') {
                unions = partial||unions;
            } else {
                inters = partial&&inters;
                _ints=true;
            }
        }
        return _ints ? inters||unions : unions;
    }
    if (t2.t === 'u' || t2.t === 'i') {
        if (t2.t==='i')removeSupertypes(t2.l);
        var unions = false;
        var inters = true;
        var _ints = false;
        for (var i = 0; i < t2.l.length; i++) {
            var partial = extendsType(t1, t2.l[i]);
            if (t2.t==='u') {
                unions = partial||unions;
            } else {
                inters = partial&&inters;
                _ints=true;
            }
        }
        return _ints ? inters||unions : unions;
    }
    if (t1.t==='T') {
      if (t2.t==='T') {
        if (t1.l.length>=t2.l.length) {
          for (var i=0; i < t2.l.length;i++) {
            if (!extendsType(t1.l[i],t2.l[i]))return false;
          }
          return true;
        } else return false;
      } else {
        t1=$retuple(t1);
      }
    } else if (t2.t==='T') {
      t2=$retuple(t2);
    }
    for (t in t1.t.$$.T$all) {
        if (t === t2.t.$$.T$name || t === 'ceylon.language::Nothing') {
            if (t1.a && t2.a) {
                //Compare type arguments
                for (ta in t1.a) {
                    if (!extendsType(t1.a[ta], t2.a[ta])) return false;
                }
            }
            return true;
        }
    }
    return false;
}
function removeSupertypes(list) {
    for (var i=0; i < list.length; i++) {
        for (var j=i; i < list.length; i++) {
            if (i!==j) {
                if (extendsType(list[i],list[j])) {
                    list[j]=list[i];
                } else if (extendsType(list[j],list[i])) {
                    list[i]=list[j];
                }
            }
        }
    }
}

function className(obj) {
    function _typename(t) {
        if (t.t==='i' || t.t==='u') {
            var _sep = t.t==='i'?'&':'|';
            var ct = '';
            for (var i=0; i < t.l.length; i++) {
                if (i>0) { ct+=_sep; }
                ct += _typename(t.l[i]);
            }
            return String$(ct);
        } else {
            var tn = t.t.$$.T$name;
            if (t.a) {
                tn += '<';
                for (var i = 0; i < t.a.length; i++) {
                    if (i>0) { tn += ','; }
                    tn += _typename(t.a[i]);
                }
                tn += '>';
            }
            return tn;
        }
    }
    if (obj === null) return String$('ceylon.language::Null');
    if (obj === undefined) return String$("JavaScript UNDEFINED");
    var tn = obj.getT$name === undefined ? 'UNKNOWN' : obj.getT$name();
    if (tn === 'UNKNOWN') {
        if (typeof obj === 'function') {
            tn = 'ceylon.language::Callable';
        }
    }
    else if (obj.$$targs$$) {
        /*tn += '<';
        for (var i=0; i < obj.$$targs$$.length; i++) {
            if (i>0) { tn += ','; }
            tn += _typename(obj.$$targs$$[i]);
        }
        tn += '>';*/
    }
    return String$(tn);
}
className.$$metamodel$$={$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','className']};

function identityHash(obj) {
    return obj.BasicID;
}
identityHash.$$metamodel$$={$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','identityHash']};

function set_type_args(obj, targs) {
    if (obj===undefined)return;
    if (obj.$$targs$$ === undefined) {
        obj.$$targs$$=targs;
    } else {
        for (x in targs) {
            obj.$$targs$$[x] = targs[x];
        }
    }
}
function add_type_arg(obj, name, type) {
    if (obj.$$targs$$ === undefined) {
        obj.$$targs$$={};
    }
    obj.$$targs$$[name]=type;
}
function wrapexc(e,loc,file) {
  if (loc !== undefined) e.$loc=loc;
  if (file !== undefined) e.$file=file;
  return e;
}
function throwexc(e,loc,file) {
  if (loc !== undefined) e.$loc=loc;
  if (file !== undefined) e.$file=file;
  throw e;
}
exports.set_type_args=set_type_args;
exports.add_type_arg=add_type_arg;
exports.exists=exists;
exports.nonempty=nonempty;
exports.isOfType=isOfType;
exports.className=className;
exports.identityHash=identityHash;
exports.throwexc=throwexc;
exports.wrapexc=wrapexc;
function internalSort(comp, elems, $$$mptypes) {
    if (elems===undefined) {return getEmpty();}
    var arr = [];
    var it = elems.iterator();
    var e;
    while ((e=it.next()) !== getFinished()) {arr.push(e);}
    if (arr.length === 0) {return getEmpty();}
    arr.sort(function(a, b) {
        var cmp = comp(a,b);
        return (cmp===larger) ? 1 : ((cmp===smaller) ? -1 : 0);
    });
    return ArraySequence(arr, $$$mptypes);
}
internalSort.$$metamodel$$=function(){return{
  $an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','internalSort'],
  $ps:[{$nm:'comparing',$t:{t:Callable,a:{Return:{t:Comparison},Arguments:{t:'T',l:['Element','Element']}}},$mt:'prm'},{$nm:'elements',$t:{t:Iterable,a:{Absent:{t:Null},Element:'Element'}},$mt:'prm'}],
  $tp:{Element:{}}, $t:{t:Sequential,a:{Absent:{t:Null},Element:'Element'}}
}};

function flatten(tf, $$$mptypes) {
  function rf() {
    var t = getEmpty();
    var e = null;
    var argc = arguments.length;
    var last = argc>0 ? arguments[argc-1] : undefined;
    if (typeof(last) === 'object' && typeof(last.Args) === 'object' && (last.Args.t==='T'||typeof(last.Args.t) === 'function')) {
      argc--;
    }
    for (var i=argc-1; i>=0; i--) {
      var c = arguments[i]===null ? Null :
        arguments[i] === undefined ? Empty :
        arguments[i].getT$all ? arguments[i].getT$all() :
        Anything;
      if (e === null) {
        e = c;
      } else if (e.t === 'u' && e.l.length > 0) {
        var l = [c];
        for (var j=0; j < e.l.length; j++) {
          l[j+1] = e.l[j];
        }
      } else {
        e = {t:'u', l:[e, c]};
      }
      var rest;
      if (t === getEmpty()) {
        rest={t:Empty};
      } else {
        rest={t:Tuple, a:t.$$targs$$};
      }
      t = Tuple(arguments[i], t, {First:c, Element:e, Rest:rest});
    }
    return tf(t, t.$$targs$$);
  };
  rf.$$targs$$={Return:$$$mptypes.Return,Arguments:$$$mptypes.Args};
  return rf;
}
flatten.$$metamodel$$=function(){return{
  $an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','flatten'],
  $tp:{Return:{},Args:{'satisfies':[{t:Sequential,a:{Absent:{t:Null},Element:{t:Anything}}}]}},
  $t:{t:Callable,a:{Return:'Return',Arguments:{t:Sequential,a:{Absent:{t:Null},Element:{t:Anything}}}}},
  $p:[{$nm:'tupleFunction',$t:{t:Callable,a:{Return:'Return',Arguments:{t:'T',l:[{t:Sequential,a:{Absent:{t:Null},Element:{t:Anything}}}]}}},$mt:'prm'}]
}};

function unflatten(ff, $$$mptypes) {
  if (typeof(ff.$$metamodel$$)==='function')ff.$$metamodel$$=ff.$$metamodel$$();
  if (ff.$$metamodel$$ && ff.$$metamodel$$.$ps) {
    var ru=function ru(seq,$mptypes) {
      if (seq===undefined || seq.size === 0) { return ff(); }
      var pmeta = ff.$$metamodel$$.$ps;
      var _lim=Math.max(pmeta.length,seq.size);
      var a = [];
      for (var i = 0; i < _lim; i++) {
        if (pmeta[i]&&pmeta[i]['seq']) {
          a.push(seq.skipping(i).sequence);
          break;//we're done
        } else if (seq.size > i) {
          a.push(seq.$get(i));
        }
      }
      if ($mptypes && ff.$$metamodel$$.$tp)a.push($mptypes);
      return ff.apply(ru, a);
    }
  } else {
    var ru=function ru(seq) {
      if (seq===undefined || seq.size === 0) { return ff(); }
      var a = [];
      for (var i = 0; i < seq.size; i++) {
        a[i] = seq.$get(i);
      }
      a[i]=ru.$$targs$$;
      return ff.apply(ru, a);
    }
  }
  ru.$$targs$$={Return:$$$mptypes.Return,Arguments:{t:'T',l:[$$$mptypes.Args]}};
  return ru;
}
unflatten.$$metamodel$$=function(){return{
  $an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','unflatten'],
  $tp:{Return:{},Args:{'satisfies':[{t:Sequential,a:{Absent:{t:Null},Element:{t:Anything}}}]}},
  $ps:[{$nm:'flatFunction',$t:{t:Callable,a:{Return:'Return',Arguments:{t:Sequential,a:{Absent:{t:Null},Element:{t:Anything}}}}},$mt:'prm'}],
  $t:{t:Callable,a:{Return:'Return',Arguments:{t:'T',l:[{t:Sequential,a:{Absent:{t:Null},Element:{t:Anything}}}]}}}
}};
exports.flatten=flatten;
exports.unflatten=unflatten;

//internal
function toTuple(iterable) {
  var seq = iterable.sequence;
  return Tuple(seq.first, seq.rest.sequence,
    {First:seq.$$targs$$.Element, Element:seq.$$targs$$.Element, Rest:{t:Sequential, a:seq.$$targs$$}});
}
exports.toTuple=toTuple;

function integerRangeByIterable(range, step, $$$mptypes) {
    return Comprehension(function(){
        var a = range.first;
        var b = range.last;
        if (a>b) {
            a += step;
            return function() {
                a -= step;
                return a<b ? getFinished() : a;
            }
        }
        a-=step;
        return function() {
            a += step;
            return a>b ? getFinished() : a;
        }
    }, {Element:range.$$targs$$.Element, Absent:range.$$targs$$.Absent});
}
integerRangeByIterable.$$metamodel$$=function(){return{
  $an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','integerRangeByIterable'],
  $tp:{Element:{'satisfies':[{t:Ordinal,a:{Other:'Element'}},{t:Comparable,a:{Other:'Element'}}]}},
  $t:{t:Iterable,a:{Absent:{t:Nothing},Element:'Element'}},
  $ps:[{$nm:'range',$t:{t:Range,a:{Element:'Element'}},$mt:'prm'},{$nm:'step',$t:{t:Integer},$mt:'prm'}]
}};
exports.integerRangeByIterable=integerRangeByIterable;
// implementation of object "process" in ceylon.language
function languageClass() {
    var lang = new languageClass.$$;
    Basic(lang);
    return lang;
}
languageClass.$$metamodel$$={$nm:'languageClass',$mt:'cls',$ps:[],$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','language']};
initTypeProto(languageClass, "ceylon.language::language", $init$Basic());
var lang$proto=languageClass.$$.prototype;
defineAttr(lang$proto, 'version', function() {
    return String$("1.0.0",3);
},undefined,{$t:{t:String$}, $cont:lang$proto, $an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','language','$at','version']});
defineAttr(lang$proto, 'majorVersion', function(){ return 1; },undefined,
  {$t:{t:Integer}, $cont:lang$proto, $an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','language','$at','majorVersion']});
defineAttr(lang$proto, 'minorVersion', function(){ return 0; },undefined,
  {$t:{t:Integer}, $cont:lang$proto, $an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','language','$at','minorVersion']});
defineAttr(lang$proto, 'releaseVersion', function(){ return 0; },undefined,
  {$t:{t:Integer}, $cont:lang$proto, $an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','language','$at','releaseVersion']});
defineAttr(lang$proto, 'versionName', function(){ return String$("No More Mr Nice Guy",19); },undefined,
  {$t:{t:String$}, $cont:lang$proto, $an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','language','$at','versionName']});
defineAttr(lang$proto, 'majorVersionBinary', function(){ return 6; },undefined,
  {$t:{t:Integer}, $cont:lang$proto, $an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','language','$at','majorVersionBinary']});
defineAttr(lang$proto, 'minorVersionBinary', function(){ return 0; },undefined,
  {$t:{t:Integer}, $cont:lang$proto, $an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','language','$at','minorVersionBinary']});
var languageString = String$("language", 8);
defineAttr(lang$proto, 'string', function() {
    return languageString;
},undefined,{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','Object','$at','string']});

var language$ = languageClass();
function getLanguage() { return language$; }
exports.getLanguage=getLanguage;
exports.$prop$getLanguage={get:getLanguage,$$metamodel$$:function(){
  return {mod:$$METAMODEL$$,d:['ceylon.language','language'],$t:{t:languageClass}};
}};
function processClass() {
    var proc = new processClass.$$;
    Basic(proc);
    return proc;
}
processClass.$$metamodel$$={$nm:'processClass',$mt:'cls',$ps:[],$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','process']};
initTypeProto(processClass, "ceylon.language::process", $init$Basic());
var process$proto = processClass.$$.prototype;

var argv = getEmpty();
var namedArgs = {};
if ((typeof process !== "undefined") && (process.argv !== undefined)) {
    // parse command line arguments
    if (process.argv.length > 1) {
        var args = process.argv.slice(1);
        for (var i=0; i<args.length; ++i) {
            var arg = args[i];
            if (arg.charAt(0) == '-') {
                var pos = 1;
                if (arg.charAt(1) == '-') { pos = 2; }
                arg = arg.substr(pos);
                pos = arg.indexOf('=');
                if (pos >= 0) {
                    namedArgs[arg.substr(0, pos)] = String$(arg.substr(pos+1));
                } else {
                    var value = args[i+1];
                    if ((value !== undefined) && (value.charAt(0) != '-')) {
                        namedArgs[arg] = String$(value);
                        ++i;
                    } else {
                        namedArgs[arg] = null;
                    }
                }
            }
            args[i] = String$(args[i]);
        }
        argv = ArraySequence(args, {Element:{t:String$}});
    }
} else if (typeof window !== "undefined") {
    // parse URL parameters
    var parts = window.location.search.substr(1).replace('+', ' ').split('&');
    if ((parts.length > 1) || ((parts.length > 0) && (parts[0].length > 0))) {
        var argStrings = new Array(parts.length);
        //can't do "for (i in parts)" anymore because of the added stuff to arrays
        var i;
        for (i=0; i<parts.length; i++) { argStrings[i] = String$(parts[i]); }
        argv = ArraySequence(argStrings, {Element:{t:String$}});
        
        for (i=0; i < parts.length; i++) {
            var part = parts[i];
            var pos = part.indexOf('=');
            if (pos >= 0) {
                var value = decodeURIComponent(part.substr(pos+1));
                namedArgs[part.substr(0, pos)] = String$(value);
            } else {
                namedArgs[part] = null;
            }
        }
    }
}
defineAttr(process$proto, 'arguments', function(){ return argv; },undefined,
  {$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','process','$at','arguments']});
process$proto.namedArgumentPresent = function(name) {
    return (name in namedArgs);
}
process$proto.namedArgumentValue = function(name) {
    var value = namedArgs[name];
    return (value !== undefined) ? value : null;
}

var properties = {};
if (typeof navigator !== "undefined") {
    if (navigator.language !== undefined) {
        properties["user.language"] = String$(navigator.language);
    }
    if (navigator.platform !== undefined) {
        properties["os.name"] = String$(navigator.platform);
    }
    if (navigator.userLanguage||navigator.browserLanguage||navigator.language) {
        properties["user.locale"]=String$(navigator.userLanguage||navigator.browserLanguage||navigator.language);
    }
}
if (typeof process !== "undefined") {
    if (process.platform !== undefined) {
        properties["os.name"] = String$(process.platform);
    }
    if (process.arch !== undefined) {
        properties["os.arch"] = String$(process.arch);
    }
}
if (typeof document !== "undefined") {
    if (document.defaultCharset !== undefined) {
        properties["file.encoding"] = String$(document.defaultCharset);
    }
}

var linesep = String$('\n', 1);
var filesep = String$('/', 1);
var pathsep = String$(':', 1);
var osname = properties["os.name"];
if ((osname !== undefined) && (osname.search(/windows/i) >= 0)) {
    linesep = String$("\r\n", 2);
    filesep = String$('\\', 1);
    pathsep = String$(';', 1);
}
properties["line.separator"] = linesep;
properties["file.separator"] = filesep;
properties["path.separator"] = pathsep;

process$proto.propertyValue = function(name) {
    var value = properties[name];
    return (value !== undefined) ? value : null;
}

if ((typeof process !== "undefined") && (process.stdout !== undefined)) {
    process$proto.write = function(string) {
        if(string)process.stdout.write(string.valueOf());
    }
    process$proto.writeLine = function(line) {
        if(line)process$proto.write(line.valueOf());
        process$proto.write(linesep.valueOf());
    }
} else if ((typeof console !== "undefined") && (console.log !== undefined)) {
    process$proto.writeLine = function(line) {
        console.log(line?line.valueOf():'');
    }
    process$proto.write = process$proto.writeLine;
} else {
    process$proto.write = function() {};
    process$proto.writeLine = function() {};    
}

if ((typeof process !== "undefined") && (process.stderr !== undefined)) {
    process$proto.writeError = function(string) {
        if(string)process.stderr.write(string.valueOf());
    }
    process$proto.writeErrorLine = function(line) {
        if(line)process$proto.writeError(line.valueOf());
        process$proto.writeError(linesep.valueOf());
    }
} else if ((typeof console !== "undefined") && (console.error !== undefined)) {
    process$proto.writeErrorLine = function(line) {
        console.error(line?line.valueOf():'');
    }
    process$proto.writeError = process$proto.writeErrorLine;
} else {
    process$proto.writeError = process$proto.write;
    process$proto.writeErrorLine = process$proto.writeLine;    
}

process$proto.flush = function(){}
process$proto.flushError=function(){}
process$proto.readLine = function() {
    return String$("", 0);//TODO
}

if ((typeof process !== "undefined") && (process.exit !== undefined)) {
    process$proto.exit = function(code) {
        process.exit(code);
    }
} else {
    process$proto.exit = function() {}
}

var processString = String$("process", 7);
defineAttr(process$proto, 'string', function() {
    return processString;
},undefined,{$t:{t:String$},$cont:process$proto,$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','Object','$at','string']});


var process$ = processClass();
function getProcess() { return process$; }
exports.getProcess=getProcess;
exports.$prop$getProcess={get:getProcess,$$metamodel$$:function(){return{mod:$$METAMODEL$$,d:['ceylon.language','process'],$t:{t:processClass}
}}};
// system

function systemClass() {
    var proc = new systemClass.$$;
    Basic(proc);
    return proc;
}
systemClass.$$metamodel$$={$nm:'systemClass',$mt:'cls',$ps:[],$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','system']};
initTypeProto(systemClass, "ceylon.language::system", $init$Basic());
var system$proto = systemClass.$$.prototype;

defineAttr(system$proto, 'milliseconds', function() {
    return Date.now();
},undefined,{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','system','$at','milliseconds']});
defineAttr(system$proto, 'nanoseconds', function() {
    return Date.now()*1000000;
},undefined,{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','system','$at','nanoseconds']});
defineAttr(system$proto, 'timezoneOffset', function(){
  return new Date().getTimezoneOffset()*60000;
},undefined,{$t:{t:Integer}, $cont:system$proto, $an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','system','$at','timezoneOffset']});
defineAttr(system$proto, 'locale', function(){
  return properties["user.locale"] || String$("Unknown",7);
},undefined,{$t:{t:String$}, $cont:system$proto, $an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','system','$at','locale']});
var systemString = String$("system", 7);
defineAttr(system$proto, 'string', function() {
    return systemString;
},undefined,{$t:{t:String$},$cont:system$proto,$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','Object','$at','string']});

var system$ = systemClass();
function getSystem() { return system$; }
exports.getSystem=getSystem;
exports.$prop$getSystem={get:getSystem,$$metamodel$$:function(){return{
  mod:$$METAMODEL$$,d:['ceylon.language','system'],$t:{t:systemClass}
};}};
// runtime

function runtimeClass() {
    var proc = new runtimeClass.$$;
    Basic(proc);
    return proc;
}
runtimeClass.$$metamodel$$={$nm:'runtimeClass',$mt:'cls',$ps:[],$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','runtime']};
initTypeProto(runtimeClass, "ceylon.language::runtime", $init$Basic());
var runtime$proto = runtimeClass.$$.prototype;

defineAttr(runtime$proto, 'name', function() {
    if (typeof process !== "undefined" && process.execPath && process.execPath.match(/node(js)?(\.exe)?$/)) {
        return String$("node.js", 7);
    } else if (typeof window === 'object') {
        return String$("Browser", 7);
    }
    return String$("Unknown JavaScript environment", 30);
},undefined,{$t:{t:String$},$cont:runtime$proto,$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','runtime','$at','name']});
defineAttr(runtime$proto, 'version', function() {
    if (typeof process !== "undefined" && typeof process.version === 'string') {
        return String$(process.version);
    }
    return String$("Unknown");
},undefined,{$t:{t:String$},$cont:runtime$proto,$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','runtime','$at','version']});
defineAttr(runtime$proto, 'integerSize', function() {
    return 53;
},undefined,{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','runtime','$at','integerSize']});
var $minIntegerValue = Integer(-9007199254740991); //-(2^53-1)
defineAttr(runtime$proto, 'minIntegerValue', function() {
    return $minIntegerValue;
},undefined,{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','runtime','$at','minIntegerValue']});
var $maxIntegerValue = Integer(9007199254740989); //(2^53-3) => ((2^53)-2 is NaN)
defineAttr(runtime$proto, 'maxIntegerValue', function() {
    return $maxIntegerValue;
},undefined,{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','runtime','$at','maxIntegerValue']});
var runtimeString = String$("runtime", 7);
defineAttr(runtime$proto, 'string', function() {
    return runtimeString;
},undefined,{$t:{t:String$},$cont:runtime$proto,$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','Object','$at','string']});

var runtime$ = runtimeClass();
function getRuntime() { return runtime$; }
exports.getRuntime=getRuntime;
exports.$prop$getRuntime={get:getRuntime,$$metamodel$$:function(){
  return{mod:$$METAMODEL$$,d:['ceylon.language','runtime'],$t:{t:runtimeClass}};}};
// operatingSystem

function operatingSystemClass() {
    var proc = new operatingSystemClass.$$;
    Basic(proc);
    return proc;
}
operatingSystemClass.$$metamodel$$={$nm:'operatingSystemClass',$mt:'cls',$ps:[],$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','operatingSystem']};
initTypeProto(operatingSystemClass, "ceylon.language::operatingSystem", $init$Basic());
var operatingSystem$proto = operatingSystemClass.$$.prototype;

defineAttr(operatingSystem$proto, 'name',function() {
    if (typeof process !== "undefined" && typeof process.platform === 'string') {
        return String$(process.platform);
    }
    return String$("Unknown");
},undefined,{$t:{t:String$},$cont:operatingSystem$proto,$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','operatingSystem','$at','name']});
defineAttr(operatingSystem$proto, 'version', function() {
    return String$("Unknown");
},undefined,{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','operatingSystem','$at','version']});
defineAttr(operatingSystem$proto, 'newline', function(){ return linesep; },undefined,
  {$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','operatingSystem','$at','newline']});
defineAttr(operatingSystem$proto, 'fileSeparator', function(){ return filesep; },undefined,
  {$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','operatingSystem','$at','fileSeparator']});
defineAttr(operatingSystem$proto, 'pathSeparator', function(){ return pathsep; },undefined,
  {$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','operatingSystem','$at','pathSeparator']});
var operatingSystemString = String$("operatingSystem", 7);
defineAttr(operatingSystem$proto, 'string', function() {
    return operatingSystemString;
},undefined,{$t:{t:String$},$cont:operatingSystem$proto,$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','Object','$at','string']});

var operatingSystem$ = operatingSystemClass();
function getOperatingSystem() { return operatingSystem$; }
exports.getOperatingSystem=getOperatingSystem;
exports.$prop$getOperatingSystem={get:getOperatingSystem,$$metamodel$$:function(){
  return {mod:$$METAMODEL$$,d:['ceylon.language','operatingSystem'],$t:{t:operatingSystemClass}};
}};
function addSuppressedException(/*Exception*/sup,/*Exception*/e) {
    if (e.$sups$===undefined) {
        e.$sups$=[];
    }
    if (sup.getT$name === undefined) sup = NativeException(sup);
    e.$sups$.push(sup);
}
exports.addSuppressedException=addSuppressedException;
function suppressedExceptions(/*Exception*/e) {
    return e.$sups$===undefined?getEmpty():e.$sups$;
}
suppressedExceptions.$$metamodel$$=function(){
  return {mod:$$METAMODEL$$,d:['ceylon.language','suppressedExceptions'],$t:{t:Sequential,a:{Absent:{t:Null},Element:{t:Exception}}},$ps:[{$nm:'exception',$mt:'prm',$t:{t:Exception}}]};
}
exports.suppressedExceptions=suppressedExceptions;

function $retuple(t) { //receives {t:'T',l:[...]}
  if (t.t!=='T')return t;
  var e;
  var r={t:Empty};
  for (var i=t.l.length-1;i>=0;i--){
    var f=$retuple(t.l[i]);
    var e=(r.a&&r.a.Element)||f;
    if (r.a&&r.a.Element) {
      if (e.l) {
        var l2=[];for(var j=0;j<e.l.length;j++)l2.push(e.l[j]);
        l2.unshift(f);
        e={t:'u',l:l2};
      } else {
        e = {t:'u',l:[f,e]};
      }
    }
    r={t:Tuple,a:{First:f,Element:e,Rest:r}};
  }
  return r;
}
function validate$params(ps,t,msg) {
  if (t.t===Nothing)return;
  if (!ps || ps.length==0) {
    if (t.t===Empty)return;
  } else if (t.t==='T') {
    if (ps.length==t.l.length) {
      //TODO check each parameter
      for (var i=0;i<ps.length;i++)
        if (!extendsType(t.l[i],ps[i].$t))throw IncompatibleTypeException$meta$model(msg);
      return;
    }
  } else { //it's already a tuple, navigate it
    console.log("TODO!!!! validate$params with Tuple type");
  }
  throw IncompatibleTypeException$meta$model(msg);
}
function validate$typeparams(t,tparms,types) {
  if (tparms) {
    if (types===undefined||types.size<1)
      throw TypeApplicationException$meta$model(String$("Missing type arguments"));
    var i=0;
    t.a={};
    for (var tp in tparms) {
      var _type=types.$get(i);
      if (_type===undefined)
        throw TypeApplicationException$meta$model(String$("Missing type argument for " + tp));
      var _tp = tparms[tp];
      var _ta = _type.tipo;
      t.a[tp]= _ta.t ? _ta : {t:_type.tipo};
      if ((_tp.satisfies && _tp.satisfies.length>0) || (_tp.of && _tp.of.length > 0)) {
        var restraints=(_tp.satisfies && _tp.satisfies.length>0)?_tp.satisfies:_tp.of;
        for (var j=0; j<restraints.length;j++) {
          if (!extendsType(t.a[tp],restraints[j]))
            throw TypeApplicationException$meta$model(String$("Type argument for " + tp + " violates type parameter constraints"));
        }
      }
      i++;
    }
  }
}
function tupleize$params(ps,aux) {
  if (!ps || ps.length==0)return {t:Empty};
  var tupa={t:'T',l:[]};
  for (var i=ps.length-1; i>=ps.length;i--) {
    var e=ps[i].$t;
    if (typeof(e)==='string'&&aux&&aux[e])e=aux[e];
    if (tupa.t==='T') {//tuple
      tupa.l.unshift(e);
    } else { //union
      tupa={t:'T',l:[e,tupa]};
    }
    if (ps[i].$def) {
      tupa={t:'u',l:[{t:Empty},tupa]};
    }
  }
  return tupa;
}
function $qname(mm) {
  if (mm.t) {
    mm=mm.t;
  }
  if (typeof(mm.$$metamodel$$)==='function')mm.$$metamodel$$=mm.$$metamodel();
  if (mm.$$metamodel$$)mm=mm.$$metamodel$$;
  if (!mm.d)return "[unnamed type]";
  var qn=mm.d[0];
  for (var i=1; i<mm.d.length; i++)if(mm.d[i][0]!=='$')qn+=(i==1?"::":".")+mm.d[i];
  return qn;
}
function resolve$typearg(ta,mm) {
  var r=mm.$tp?mm.$tp[ta]:undefined;
  while (!r && mm.$cont) {
    mm=mm.$cont;
    if (mm.$tp)r=mm.$tp[ta];
  }
  if (r) {
    if (r.satisfies)
      return r.satisfies.length==1?r.satisfies[0]:{t:'i',l:r.satisfies};
    return {t:Anything};
  }
  console.log("MISSING definition of type argument " + ta + " in " + $qname(mm));
  return {t:Anything};
}

function convert$params(mm,a) {
  var ps=mm.$ps;
  if (ps===undefined || ps.length===0){
    if (a && a.size>0)
      throw InvocationException$meta$model(String$("Passing parameters to no-args callable"));
    return [];
  }
  if (a===undefined)a=[];
  var fa=[];
  var sarg;
  for (var i=0; i<ps.length;i++) { //check def/seq params
    var p=ps[i];
    var val_t=sarg?sarg.$$targs$$.a.Element:p.$t,mm;
    if (typeof(val_t)==='string')val_t=resolve$typearg(val_t,mm);
    if (a[i]===undefined) {
      if (p.$def||p.seq)fa.push(undefined);
      else {
        throw InvocationException$meta$model(String$("Wrong number of arguments (should be " + ps.length + ")"));
      }
    } else if (sarg) {
      sarg.push(a[i]);
    } else if (p.seq) {
      sarg=[].reifyCeylonType(p.$t); fa.push(sarg);
      val_t=sarg.$$targs$$.a.Element;
      if (typeof(val_t)==='string')val_t=resolve$typearg(val_t,mm);
      for (var j=i; j<a.size;j++){
        if (!isOfType(a[j],val_t))throw IncompatibleTypeException$meta$model("Wrong type for argument " + j + ", expected " + typeLiteral$meta({Type:val_t}).string + " got " + className(a[j]));
        sarg.push(a[j]);
      }
      i=j;
    } else {
      fa.push(a[i]);
    }
    if (a[i]!==undefined && !isOfType(a[i],val_t))throw IncompatibleTypeException$meta$model("Wrong type for argument " + i + ", expected " + typeLiteral$meta({Type:val_t}).string + " got " + className(a[i]));
  }
  if (a.size>i)throw InvocationException$meta$model("Too many arguments");
  a = fa;
  return a;
}
/*Native Implementation of annotations() */
function annotations$meta(anntype, progelem, $$$mptypes) {
  if (progelem.tipo)progelem=progelem.tipo;
  var mm = progelem.$$metamodel$$;
  if (progelem.$anns)mm={$an:typeof(progelem.$anns)==='function'?progelem.$anns():progelem.$anns};
  if (typeof(mm) === 'function') {
    mm = mm();
  }
  if (mm && mm.$an) {
    var anns=mm.$an;
    if (typeof(anns) === 'function') {
      anns=anns();
      mm.$an=anns;
    }
    if (anntype.tipo.$$.T$all['ceylon.language::OptionalAnnotation'] !== undefined) {
      //find the first one and return it
      for (var i=0; i < anns.length; i++) {
        if (isOfType(anns[i], {t:anntype.tipo}))return anns[i];
      }
      return null;
    }
    //gather all annotations of the required type and return them
    var r=[];
    for (var i=0; i < anns.length; i++) {
      if (isOfType(anns[i], {t:anntype.tipo}))r.push(anns[i]);
    }
    return r.length==0?getEmpty():r.reifyCeylonType({Absent:{t:Null},Element:{t:ConstrainedAnnotation,
      a:{Value:$$$mptypes.Value,Values:$$$mptypes.Values,ProgramElement:$$$mptypes.ProgramElement}}});
  }
  return null;
}
annotations$meta.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Values',$ps:[
  {$nm:'annotationType',$mt:'prm',$t:{t:Class$meta$model,a:{Type:{t:ConstrainedAnnotation,a:{Values:'Values',Value:'Value',ProgramElement:'ProgramElement'}}}}},{$nm:'programElement',$mt:'prm',$t:'ProgramElement'}],
  $tp:{Value:{'satisfies':[{t:ConstrainedAnnotation$meta$model,a:{Values:'Values',Value:'Value',ProgramElement:'ProgramElement'}}]},Values:{},ProgramElement:{'var':'in','satisfies':[{t:Annotated$meta$model}]}},
  $an:function(){return[shared(),$native()];},d:['ceylon.language.meta','annotations']};};
exports.annotations$meta=annotations$meta;
/* Metamodel module and package objects */
var $loadedModules$={};
exports.$loadedModules$=$loadedModules$;
function $addmod$(mod, modname) {
  $loadedModules$[modname] = mod;
}
exports.$addmod$=$addmod$;
function modules$2(){
    var $$modules=new modules$2.$$;
    defineAttr($$modules,'list',function(){
        var mods=[];
        for (var m in $loadedModules$) {
          var slashPos = m.lastIndexOf('/');
          mods.push(this.find(m.substring(0,slashPos), m.substring(slashPos+1)));
        }
        return mods.reifyCeylonType({Element:{t:Module$meta$declaration}});
    },undefined,{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:Module$meta$declaration}}},$cont:modules$2,$an:function(){return[shared()];},d:['ceylon.language.meta','modules','$at','list']});
    function find(name,version){
        var modname = name + "/" + (version?version:"unversioned");
        var lm = $loadedModules$[modname];
        if (!lm) {
          var mpath;
          if (name === 'default' && version=='unversioned') {
            mpath = name + "/" + name;
          } else {
            mpath = name.replace(/\./g,'/') + '/' + version + "/" + name + "-" + version;
          }
          try {lm = require(mpath);}catch(e){return null;}
        }
        if (lm && lm.$$METAMODEL$$) {
          lm = Modulo(lm);
          $loadedModules$[modname] = lm;
        }
        return lm === undefined ? null : lm;
    }
    $$modules.find=find;
    find.$$metamodel$$={mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:Module$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$}},{$nm:'version',$mt:'prm',$t:{t:String$}}],$cont:modules$2,$an:function(){return[shared()];},d:['ceylon.language.meta','modules','$m','find']};
    defineAttr($$modules,'$default',function(){
        return find('default',"unversioned");
    },undefined,{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:Module$meta$declaration}]},$cont:modules$2,$an:function(){return[shared()];},d:['ceylon.language.meta','modules','$at','default']});
    return $$modules;
}
function $init$modules$meta(){
    if (modules$2.$$===undefined){
        initTypeProto(modules$2,'ceylon.language.meta::modules',Basic);
    }
    return modules$2;
}
exports.$init$modules$meta=$init$modules$meta;
$init$modules$meta();
var modules$meta=modules$2();
var getModules$meta=function(){
    return modules$meta;
}
exports.getModules$meta=getModules$meta;

function Modulo(meta, $$modulo){
  $init$Modulo();
  if ($$modulo===undefined)$$modulo=new Modulo.$$;
  Module$meta$declaration($$modulo);
  $$modulo.meta=meta;
  $$modulo.$anns=meta.$mod$ans$;
  var mm = meta.$$METAMODEL$$;
  if (typeof(mm)==='function') {
    mm=mm();meta.$$METAMODEL$$=mm;
  }
  var name=String$(mm['$mod-name']);
  defineAttr($$modulo,'name',function(){return name;},undefined,{mod:$$METAMODEL$$,$t:{t:String$},$cont:Modulo,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Module','$at','name']});
  defineAttr($$modulo,'qualifiedName',function(){return name;},undefined,{mod:$$METAMODEL$$,$t:{t:String$},$cont:Modulo,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Module','$at','qualifiedName']});
  var version=String$(mm['$mod-version']);
  defineAttr($$modulo,'version',function(){return version;},undefined,{mod:$$METAMODEL$$,$t:{t:String$},$cont:Modulo,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Module','$at','version']});
  defineAttr($$modulo,'members',function(){
    if (mm['$pks$'] === undefined) {
      mm['$pks$'] = {};
      for (mem in this.meta.$$METAMODEL$$) {
        if (typeof(mem) === 'string' && mem[0]!=='$') {
          mm['$pks$'][mem] = Paquete(mem, this, mm[mem]);
        }
      }
    }
    var m = [];
    for (mem in mm['$pks$']) {
      if (typeof(mem) === 'string') {
        m.push(mm['$pks$'][mem]);
      }
    }
    return m.reifyCeylonType({Element:{t:Package$meta$declaration}});
  },undefined,{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:Package$meta$declaration}}},$cont:Modulo,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Module','$at','members']});
  defineAttr($$modulo,'dependencies',function(){
    if (typeof(meta.$mod$imps)==='function')meta.$mod$imps=meta.$mod$imps();
    var deps=mm['$mod-deps'];
    if (typeof(deps[0]) === 'string') {
      var _d=[];
      for (var d in meta.$mod$imps) {
        var spos = d.lastIndexOf('/');
        _d.push(Importa(String$(d.substring(0,spos)), String$(d.substring(spos+1)),this,meta.$mod$imps[d]));
      }
      deps = _d.reifyCeylonType({Element:{t:Import$meta$declaration}});
      mm['$mod-deps'] = deps;
    }
    return deps;
  },undefined,{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:Import$meta$declaration}}},$cont:Modulo,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Module','$at','dependencies']});
  function findPackage(pknm){
    if (mm['$pks$'] === undefined) this.members;
    var pk = mm['$pks$'][pknm];
    return pk===undefined ? null : pk;
  }
  $$modulo.findPackage=findPackage;
  findPackage.$$metamodel$$={mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:Package$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$}}],$cont:Modulo,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Module','$m','findPackage']};
  function findImportedPackage(pknm){
    var pk = this.findPackage(pknm);
    if (pk) return pk;
    var deps=this.dependencies;
    if (pknm.match('^ceylon\\.language')) {
      if (deps===getEmpty())deps=[];
      deps.push(Importa('ceylon.language', $$METAMODEL$$['$mod-version']),this);
    }
    for (var i=0; i < deps.length; i++) {
      pk = deps[i].container.findImportedPackage(pknm);
      if (pk)return pk;
    }
    return null;
  }
  $$modulo.findImportedPackage=findImportedPackage;
  findImportedPackage.$$metamodel$$={mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:Package$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$}}],$cont:Modulo,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Module','$m','findImportedPackage']};
  function annotations($$$mptypes){
    var anns = this.meta.$mod$ans$;
    if (typeof(anns) === 'function') {
      anns = anns();
      this.meta.$mod$ans$=anns;
    } else if (anns === undefined) {
      anns = [];
    }
    var r = [];
    for (var i=0; i < anns.length; i++) {
      var an = anns[i];
      if (isOfType(an, $$$mptypes.Annotation)) r.push(an);
    }
    return r.reifyCeylonType({Element:$$$mptypes.Annotation});
  }
  $$modulo.annotations=annotations;
  defineAttr($$modulo,'string',function(){return String$("module " + this.name+"/" + this.version);},undefined,{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','Object','$at','string']});

    annotations.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Annotation'}},$ps:[],$cont:Modulo,$tp:{Annotation:{'var':'out','satisfies':[{t:Annotation,a:{Value:'Annotation'}}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Module','$m','annotations']};
    return $$modulo;
}
Modulo.$$metamodel$$={mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Module$meta$declaration}],$an:function(){return[shared()];},d:['ceylon.language.meta.declaration','Module']};
exports.Modulo=Modulo;
function $init$Modulo(){
    if (Modulo.$$===undefined){
        initTypeProto(Modulo,'Modulo',Basic,Module$meta$declaration);
    }
    return Modulo;
}
exports.$init$Modulo=$init$Modulo;
$init$Modulo();
function Importa(name,version,mod,anns,$$importa){
  $init$Importa();
  if ($$importa===undefined)$$importa=new Importa.$$;
  Import$meta$declaration($$importa);
  $$importa.name=name;
  $$importa.version=version;
  $$importa._cont=mod;
  $$importa.$anns=anns;
  defineAttr($$importa,'name',function(){return name;},undefined,{mod:$$METAMODEL$$,$t:{t:String$},$cont:Importa,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Import','$at','name']});
  defineAttr($$importa,'version',function(){return version;},undefined,{mod:$$METAMODEL$$,$t:{t:String$},$cont:Importa,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Import','$at','version']});
  defineAttr($$importa,'shared',function(){
    if (typeof(this.$anns)==='function')this.$anns=this.anns();
    if (this.$anns)for (var i=0;i<this.$anns.length;i++) {
      if (this.$anns[i]===shared)return true;
    }
return false;},undefined,{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Importa,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Import','$at','shared']});
    defineAttr($$importa,'optional',function(){
    if (typeof(this.$anns)==='function')this.$anns=this.$anns();
    if (this.$anns)for (var i=0;i<this.$anns.length;i++) {
      if (this.$anns[i]===optional)return true;
    }
return version;},undefined,{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:Importa,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Import','$at','optional']});
    defineAttr($$importa,'container',function(){
      if (this._cont===undefined) {
          this._cont = getModules$meta().find(this.name,this.version);
      }
      return this._cont;
    },undefined,{mod:$$METAMODEL$$,$t:{t:Module$meta$declaration},$cont:Importa,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Import','$at','container']});
  defineAttr($$importa,'string',function(){
    return String$("import " + name + "/" + version);
  },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:Importa,d:['ceylon.language','Object','$at','string']};});
    return $$importa;
}
Importa.$$metamodel$$={mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Import$meta$declaration}],$an:function(){return[shared()];},d:['ceylon.language.meta.declaration','Import']};
exports.Importa=Importa;
function $init$Importa(){
    if (Importa.$$===undefined){
        initTypeProto(Importa,'Importa',Basic,Import$meta$declaration);
    }
    return Importa;
}
exports.$init$Importa=$init$Importa;
$init$Importa();
function Paquete(name, container, pkg, $$paquete){
    $init$Paquete();
    if ($$paquete===undefined)$$paquete=new Paquete.$$;
    Package$meta$declaration($$paquete);
    $$paquete.pkg=pkg;
    var name=name;
    //determine suffix for declarations
    var suffix = '';
    if (name!==container.name) {
      var _s = name.substring(container.name.length);
      suffix = _s.replace(/\./g, '$');
    }
    $$paquete.suffix=suffix;
    defineAttr($$paquete,'name',function(){return name;},undefined,{mod:$$METAMODEL$$,$t:{t:String$},$cont:Paquete,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Package','$at','name']});
    defineAttr($$paquete,'qualifiedName',function(){return name;},undefined,{mod:$$METAMODEL$$,$t:{t:String$},$cont:Paquete,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Package','$at','qualifiedName']});
    var container=container;
    defineAttr($$paquete,'container',function(){return container;},undefined,{mod:$$METAMODEL$$,$t:{t:Module$meta$declaration},$cont:Paquete,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Package','$at','container']});
    function members($$$mptypes){
      var filter=[];
      if (extendsType({t:FunctionDeclaration$meta$declaration},$$$mptypes.Kind))filter.push('mthd');
      if (extendsType({t:ValueDeclaration$meta$declaration},$$$mptypes.Kind))filter.push('attr','gttr','obj');
      if (extendsType({t:ClassDeclaration$meta$declaration},$$$mptypes.Kind))filter.push('cls');
      if (extendsType({t:InterfaceDeclaration$meta$declaration},$$$mptypes.Kind))filter.push('ifc');
      if (extendsType({t:AliasDeclaration$meta$declaration},$$$mptypes.Kind))filter.push('als');
      var r=[];
      for (var mn in this.pkg) {
        var m = this.pkg[mn];
        var mt = m['$mt'];
        if (filter.indexOf(mt)>=0 && m['$an'] && m['$an']['shared']) {
          if (mt === 'mthd') {
            r.push(OpenFunction(this, m));
          } else if (mt==='cls') {
            r.push(OpenClass(this, m));
          } else if (mt==='ifc') {
            r.push(OpenInterface(this, m));
          } else if (mt==='attr'||mt==='gttr'||mt==='obj') {
            r.push(OpenValue(this, m));
          } else if (mt==='als') {
            r.push(OpenAlias(_findTypeFromModel(this,m)));
          }
        }
      }
      return r.reifyCeylonType({Element:$$$mptypes.Kind});
    }
    $$paquete.members=members;
    members.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Kind'}},$ps:[],$cont:Paquete,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Package','$m','members']};
  function annotatedMembers($$$mptypes){
    var ms=this.members({Kind:$$$mptypes.Kind});
    if (ms.length>0) {
      var rv=[];
      for (var i=0; i < ms.length; i++) {
        if (ms[i].tipo && ms[i].tipo.$$metamodel$$) {
          var mm=ms[i].tipo.$$metamodel$$;
          if (typeof(mm)==='function'){mm=mm();ms[i].tipo.$$metamodel$$=mm;}
          var ans=mm.$an;
          if (typeof(ans)==='function'){ans=ans();mm.$an=ans;}
          if (ans) for (var j=0; j<ans.length;j++) {
            if (isOfType(ans[j],$$$mptypes.Annotation)) {
              rv.push(ms[i]);
              break;
            }
          }
        }
      }
      return rv.reifyCeylonType({Element:$$$mptypes.Kind});
    }
    return getEmpty();
  }
  $$paquete.annotatedMembers=annotatedMembers;
  annotatedMembers.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Kind'}},$ps:[],$cont:Paquete,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]},Annotation:{}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Package','$m','annotatedMembers']};
    function getMember(name$3,$$$mptypes){
      var m = this.pkg[name$3];
      if (m) {
        var mt = m['$mt'];
        //There's a member alright, but check its type
        if (extendsType({t:ValueDeclaration$meta$declaration}, $$$mptypes.Kind)) {
          if (mt==='attr'||m==='gttr'||m==='obj') {
            return OpenValue(this, m);
          }
        } else if (extendsType({t:FunctionDeclaration$meta$declaration}, $$$mptypes.Kind)) {
          if (mt==='mthd') {
            return OpenFunction(this, m);
          }
        } else if (extendsType({t:FunctionOrValueDeclaration$meta$declaration}, $$$mptypes.Kind)) {
          if (mt==='attr'||m==='gttr'||m==='obj') {
            return OpenValue(this, m);
          } else if (mt==='mthd') {
            return OpenFunction(this, m);
          }
        } else if (extendsType({t:ClassDeclaration$meta$declaration}, $$$mptypes.Kind)) {
          if (mt==='cls') {
            return OpenClass(this, m);
          }
        } else if (extendsType({t:InterfaceDeclaration$meta$declaration}, $$$mptypes.Kind)) {
          if (mt==='ifc') {
            return OpenInterface(this, m);
          }
        } else if (extendsType({t:ClassOrInterfaceDeclaration$meta$declaration}, $$$mptypes.Kind)) {
          if (mt==='ifc') {
            return OpenInterface(this, m);
          } else if (mt==='cls') {
            return OpenClass(this, m);
          }
        } else if (extendsType({t:AliasDeclaration$meta$declaration}, $$$mptypes.Kind)) {
          if (mt==='als')
          return OpenAlias(_findTypeFromModel(this,m));
        } else {
console.log("WTF do I do with this " + name$3 + " Kind " + className($$$mptypes.Kind));
        }
      }
      return null;
    }
    $$paquete.getMember=getMember;
    getMember.$$metamodel$$={mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},'Kind']},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$}}],$cont:Paquete,$tp:{Kind:{'satisfies':[{t:NestableDeclaration$meta$declaration}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Package','$m','getMember']};
    function getValue(name$4) {
      var m = this.pkg[name$4];
      if (m && (m['$mt']==='attr' || m['$mt']==='gttr' || m['$mt'] === 'obj')) {
        return OpenValue(this, m);
      }
      return null;
    }
    $$paquete.getValue=getValue;
    getValue.$$metamodel$$={mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:ValueDeclaration$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$}}],$cont:Paquete,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Package','$m','getValue']};
    function getClassOrInterface(name$5){
      var ci = this.pkg[name$5];
      if (ci && ci['$mt']==='cls') {
        return OpenClass(this, ci);
      } else if (ci && ci['$mt']==='ifc') {
        return OpenInterface(this, ci);
      }
      return null;
    }
    $$paquete.getClassOrInterface=getClassOrInterface;
    getClassOrInterface.$$metamodel$$={mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:ClassOrInterfaceDeclaration$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$}}],$cont:Paquete,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Package','$m','getClassOrInterface']};
  function getAlias(an) {
    var al=this.pkg[an];
    if (al && al.$mt==='als') {
      var rta = _findTypeFromModel(this, al);
      return OpenAlias(rta);
    }
    return null;
  }
  $$paquete.getAlias=getAlias;
  getAlias.$$metamodel$$=function(){return{mod:$$METAMODEL$$,d:['ceylon.language.meta.declaration','Package','$m','getAlias']};};
    function getFunction(name$6){
      var f = this.pkg[name$6];
      if (f && f['$mt']==='mthd') {
        return OpenFunction(this, f);
      }
      return null;
    }
    $$paquete.getFunction=getFunction;
    getFunction.$$metamodel$$={mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:FunctionDeclaration$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$}}],$cont:Paquete,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Package','$m','getFunction']};
    function annotations($$$mptypes){
      var _k = '$pkg$ans$' + this.name.replace(/\./g,'$');
      var anns = this.container.meta[_k];
      if (typeof(anns) === 'function') {
        anns = anns();
        this.container.meta[_k]=anns;
      } else if (anns === undefined) {
        anns = [];
      }
      var r = [];
      for (var i=0; i < anns.length; i++) {
        var an = anns[i];
        if (isOfType(an, $$$mptypes.Annotation)) r.push(an);
      }
      return r.reifyCeylonType({Element:$$$mptypes.Annotation});
    }
    $$paquete.annotations=annotations;
    annotations.$$metamodel$$={mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:'Annotation'}},$ps:[],$cont:Paquete,$tp:{Annotation:{'var':'out','satisfies':[{t:Annotation,a:{Value:'Annotation'}}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Package','$m','annotations']};
  defineAttr($$paquete,'string',function(){return String$("package " + this.name);},undefined,{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','Object','$at','string']});
    return $$paquete;
}
Paquete.$$metamodel$$={mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:Package$meta$declaration}],$an:function(){return[shared()];},d:['ceylon.language.meta.declaration','Package']};
exports.Paquete=Paquete;
function $init$Paquete(){
    if (Paquete.$$===undefined){
        initTypeProto(Paquete,'Paquete',Basic,Package$meta$declaration);
    }
    return Paquete;
}
exports.$init$Paquete=$init$Paquete;
$init$Paquete();

function AppliedClass(tipo,$$targs$$,that){
  $init$AppliedClass();
  if (that===undefined){
    var mm = tipo.$$metamodel$$;
    if (typeof(mm)==='function') {
      mm=mm(); tipo.$$metamodel$$=mm;
    }
    if (mm && mm.$cont) {
      that=function(x){/*Class*/
        if (that.$targs) {
          var _a=[];
          for (var i=0;i<arguments.length;i++)_a.push(arguments[i]);
          _a.push(that.$targs);
          return tipo.apply(x,_a);
        }
        return tipo.apply(x,arguments);
      }
    } else {
      that=function(){
        return tipo.apply(undefined,arguments);
      }
    }
    that.$$metamodel$$=mm;
    var dummy = new AppliedClass.$$;
    that.$$=AppliedClass.$$;
    that.getT$all=function(){return dummy.getT$all();};
    that.getT$name=function(){return dummy.getT$name();};
    that.equals=function(o){
      var eq=isOfType(o,{t:AppliedClass}) && o.tipo===tipo;
      return eq;
    };
    that.$apply=function(x){return AppliedClass.$$.prototype.$apply.call(that,x);};
    that.$apply.$$metamodel$$=AppliedClass.$$.prototype.$apply.$$metamodel$$;
    defineAttr(that,'satisfiedTypes',function(){
      return ClassOrInterface$meta$model.$$.prototype.$prop$getSatisfiedTypes.get.call(that);
    },undefined,ClassOrInterface$meta$model.$$.prototype.$prop$getExtendedType.$$metamodel$$);
    defineAttr(that,'container',function(){
      return ClassOrInterface$meta$model.$$.prototype.$prop$getContainer.get.call(that);
    },undefined,ClassOrInterface$meta$model.$$.prototype.$prop$getContainer.$$metamodel$$);
    defineAttr(that,'string',function(){
      return ClassOrInterface$meta$model.$$.prototype.$prop$getString.get.call(that);
    },undefined,ClassOrInterface$meta$model.$$.prototype.$prop$getString.$$metamodel$$);
    defineAttr(that,'hash',function(){
      return ClassOrInterface$meta$model.$$.prototype.$prop$getHash.get.call(that);
    },undefined,ClassOrInterface$meta$model.$$.prototype.$prop$getHash.$$metamodel$$);
    defineAttr(that,'typeArguments',function(){
      return ClassOrInterface$meta$model.$$.prototype.$prop$getTypeArguments.get.call(that);
    },undefined,ClassOrInterface$meta$model.$$.prototype.$prop$getTypeArguments.$$metamodel$$);
    defineAttr(that,'extendedType',function(){
      return ClassOrInterface$meta$model.$$.prototype.$prop$getExtendedType.get.call(that);
    },undefined,ClassOrInterface$meta$model.$$.prototype.$prop$getExtendedType.$$metamodel$$);
    defineAttr(that,'declaration',function(){
      return ClassModel$meta$model.$$.prototype.$prop$getDeclaration.get.call(that);
    },undefined,ClassModel$meta$model.$$.prototype.$prop$getDeclaration.$$metamodel$$);
    defineAttr(that,'parameterTypes',function(){
      return ClassModel$meta$model.$$.prototype.$prop$getParameterTypes.get.call(that);
    },undefined,ClassModel$meta$model.$$.prototype.$prop$getParameterTypes.$$metamodel$$);
    defineAttr(that,'declaration',function(){
      return ClassModel$meta$model.$$.prototype.$prop$getDeclaration.get.call(that);
    },undefined,ClassModel$meta$model.$$.prototype.$prop$getDeclaration.$$metamodel$$);
    that.getMethod=ClassOrInterface$meta$model.$$.prototype.getMethod;
    that.getDeclaredMethod=ClassOrInterface$meta$model.$$.prototype.getDeclaredMethod;
    that.getAttribute=ClassOrInterface$meta$model.$$.prototype.getAttribute;
    that.getDeclaredAttribute=ClassOrInterface$meta$model.$$.prototype.getDeclaredAttribute;
    that.getClassOrInterface=ClassOrInterface$meta$model.$$.prototype.getClassOrInterface;
    that.getDeclaredClassOrInterface=ClassOrInterface$meta$model.$$.prototype.getDeclaredClassOrInterface;
    that.getClass=ClassOrInterface$meta$model.$$.prototype.getClass;
    that.getDeclaredClass=ClassOrInterface$meta$model.$$.prototype.getDeclaredClass;
    that.getInterface=ClassOrInterface$meta$model.$$.prototype.getInterface;
    that.getDeclaredInterface=ClassOrInterface$meta$model.$$.prototype.getDeclaredInterface;
    that.equals=ClassModel$meta$model.$$.prototype.equals;
    that.typeOf=ClassOrInterface$meta$model.$$.prototype.typeOf;
    that.supertypeOf=ClassOrInterface$meta$model.$$.prototype.supertypeOf;
    that.subtypeOf=ClassOrInterface$meta$model.$$.prototype.subtypeOf;
    that.exactly=ClassOrInterface$meta$model.$$.prototype.exactly;
  }
  set_type_args(that,$$targs$$);
  Class$meta$model(that.$$targs$$===undefined?$$targs$$:{Arguments:that.$$targs$$.Arguments,Type:that.$$targs$$.Type},that);
  that.tipo=tipo;
  return that;
}
AppliedClass.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$tp:{Type:{'var':'out','def':{t:Anything}},Arguments:{'var':'in','satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},satisfies:[{t:Class$meta$model,a:{Arguments:'Arguments',Type:'Type'}}],$an:function(){return[shared()];},d:['ceylon.language.meta.model','Class']};};
function $init$AppliedClass(){
  if (AppliedClass.$$===undefined){
    initTypeProto(AppliedClass,'ceylon.language.meta.model::AppliedClass',Basic,Class$meta$model);
    (function($$clase){

      $$clase.$apply=function(a){
        var mdl=get_model(this.tipo.$$metamodel$$);
        if (mdl&&mdl.$mt==='obj')throw InvocationException$meta$model("Cannot instantiate anonymous class");
        a=convert$params(this.tipo.$$metamodel$$,a);
        if (this.$targs)a.push(this.$targs);
        return this.tipo.apply(undefined,a);
      };$$clase.$apply.$$metamodel$$=function(){return{mod:$$METAMODEL$$,d:['ceylon.language.meta.model','Class','$m','apply'],$t:'Type'};};

    })(AppliedClass.$$.prototype);
  }
  return AppliedClass;
}
exports.$init$AppliedClass$meta$model=$init$AppliedClass;
$init$AppliedClass();

function AppliedMemberClass(tipo,$$targs$$,that){
  $init$AppliedMemberClass();
  if (that===undefined) {
    var mm = tipo.$$metamodel$$;
    if (typeof(mm)==='function') {
      mm=mm(); tipo.$$metamodel$$=mm;
    }
    if (mm && mm.$cont) {
      that=function(x){
        var rv=tipo.bind(x);
        rv.$$metamodel$$=tipo.$$metamodel$$;
        var nt={t:tipo};
        if (x.$$targs$$) {
          nt.a={};
          for (var nta in x.$$targs$$)nt.a[nta]=x.$$targs$$[nta];
        }
        if (that.$targs) {
          if (!nt.a)nt.a={};
          for (var nta in that.$targs)nt.a[nta]=that.$targs[nta];
        }
        rv=AppliedClass(rv,{Type:nt,Arguments:{t:Sequential,a:{Element:{t:Anything},Absent:{t:Null}}}});//TODO generate metamodel for Arguments
        if (nt.a)rv.$targs=nt.a;
        rv.$bound=x;
        return rv;
      }
      var dummy = new AppliedMemberClass.$$;
      that.$$=AppliedMemberClass.$$;
      that.getT$all=function(){return dummy.getT$all();};
      that.getT$name=function(){return dummy.getT$name();};
      that.equals=function(o){
        var eq=isOfType(o,{t:AppliedMemberClass}) && o.tipo===tipo;
        if (that.$bound)eq=eq && o.$bound && o.$bound.equals(that.$bound);else eq=eq && o.$bound===undefined;
        return eq;
      };
      defineAttr(that,'parameterTypes',function(){
        return ClassModel$meta$model.$$.prototype.$prop$getParameterTypes.get.call(that);
      },undefined,ClassModel$meta$model.$$.prototype.$prop$getParameterTypes.$$metamodel$$);
      defineAttr(that,'extendedType',function(){
        return ClassOrInterface$meta$model.$$.prototype.$prop$getExtendedType.get.call(that);
      },undefined,ClassOrInterface$meta$model.$$.prototype.$prop$getExtendedType.$$metamodel$$);
      defineAttr(that,'satisfiedTypes',function(){
        return ClassOrInterface$meta$model.$$.prototype.$prop$getSatisfiedTypes.get.call(that);
      },undefined,ClassOrInterface$meta$model.$$.prototype.$prop$getExtendedType.$$metamodel$$);
      defineAttr(that,'declaration',function(){
        return ClassModel$meta$model.$$.prototype.$prop$getDeclaration.get.call(that);
      },undefined,ClassModel$meta$model.$$.prototype.$prop$getDeclaration.$$metamodel$$);
      that.$bind=function(){return AppliedMemberClass.$$.prototype.$bind.apply(that,arguments);}
      defineAttr(that,'string',function(){
        return String$($qname(mm));
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Object','$at','string']};});
    } else {
      throw IncompatibleTypeException("Invalid metamodel data for MemberClass");
    }
  }
  set_type_args(that,$$targs$$);
  MemberClass$meta$model(that.$$targs$$===undefined?$$targs$$:{Arguments:that.$$targs$$.Arguments,Type:that.$$targs$$.Type,Container:that.$$targs$$.Container},that);
  that.tipo=tipo;
  return that;
}
AppliedMemberClass.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],$tp:{Container:{'var':'in'},Type:{'var':'out','def':{t:Anything}},Arguments:{'var':'in','satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},satisfies:[{t:MemberClass$meta$model,a:{Arguments:'Arguments',Type:'Type',Container:'Container'}}],$an:function(){return[shared(),abstract()];},d:['','AppliedMemberClass']};};
exports.AppliedMemberClass=AppliedMemberClass;
function $init$AppliedMemberClass(){
  if (AppliedMemberClass.$$===undefined){
    initTypeProto(AppliedMemberClass,'ceylon.language.meta.model::AppliedMemberClass',Basic,MemberClass$meta$model);
    (function($$amc){
      
      //MethodDef bind at caca.ceylon (5:4-5:107)
      $$amc.$bind=function $bind(cont){
        var ot=cont.getT$name ? cont.getT$all()[cont.getT$name()]:throwexc(IncompatibleTypeException$meta$model("Container does not appear to be a Ceylon object"));
        if (!ot)throw IncompatibleTypeException$meta$model("Incompatible Container (has no metamodel information");
        var omm=ot.$$metamodel$$;
        if (typeof(omm)==='function'){omm=omm();ot.$$metamodel$$=omm;}
        var mm=this.tipo.$$metamodel$$;
        if (typeof(mm)==='function'){mm=mm();this.tipo.$$metamodel$$=mm;}
        if (!extendsType({t:ot},{t:mm.$cont}))throw IncompatibleTypeException$meta$model("Incompatible container type");
        return this(cont);
      };$$amc.$bind.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Class$meta$model,a:{Arguments:'Arguments',Type:'Type'}},$ps:[{$nm:'container',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:MemberClass$meta$model,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','MemberClass','$m','bind']};};
    })(AppliedMemberClass.$$.prototype);
  }
  return AppliedMemberClass;
}
exports.$init$AppliedMemberClass$meta$model=$init$AppliedMemberClass;
$init$AppliedMemberClass();

function AppliedInterface(tipo,$$targs$$,that) {
  $init$AppliedInterface();
  if (that===undefined){
    var mm = tipo.$$metamodel$$;
    if (typeof(mm)==='function') {
      mm=mm(); tipo.$$metamodel$$=mm;
    }
    if (mm && mm.$cont) {
      that=function(x){
        that.tipo=function(){return tipo.apply(x,arguments);};
        that.$bound=x;
        return that;
      }
      that.tipo$2=tipo;
      var dummy = new AppliedInterface.$$;
      that.$$=AppliedInterface.$$;
      that.getT$all=function(){return dummy.getT$all();};
      that.getT$name=function(){return dummy.getT$name();};
      that.equals=function(o){
        var eq=isOfType(o,{t:AppliedInterface}) && (o.tipo$2||o.tipo)==tipo;
        if (that.$bound)eq=eq && o.$bound && o.$bound.equals(that.$bound);else eq=eq && o.$bound===undefined;
        return eq;
      };
      defineAttr(that,'string',function(){
        return String$($qname(mm));
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Object','$at','string']};});
      defineAttr(that,'declaration',function(){
        return InterfaceModel$meta$model.$$.prototype.$prop$getDeclaration.get.call(that);
      },undefined,InterfaceModel$meta$model.$$.prototype.$prop$getDeclaration.$$metamodel$$);
    } else {
      that=new AppliedInterface.$$;
    }
  }
  set_type_args(that,$$targs$$);
  Interface$meta$model($$targs$$,that);
  that.tipo=tipo;
  return that;
}
AppliedInterface.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$tp:{Type:{'var':'out','def':{t:Anything}}},satisfies:[{t:Interface$meta$model,a:{Type:'Type'}}],$an:function(){return[shared()];},d:['ceylon.language.meta.model','Interface']};};
exports.AppliedInterface=AppliedInterface;

function $init$AppliedInterface(){
  if (AppliedInterface.$$===undefined){
    initTypeProto(AppliedInterface,'ceylon.language.meta.model::AppliedInterface',Basic,Interface$meta$model);
    (function($$appliedInterface){

        })(AppliedInterface.$$.prototype);
    }
    return AppliedInterface;
}
exports.$init$AppliedInterface$meta$model=$init$AppliedInterface;
$init$AppliedInterface();

function AppliedMemberInterface(tipo,$$targs$$,that){
  $init$AppliedMemberInterface();
  if (that===undefined){
    var mm = tipo.$$metamodel$$;
    if (typeof(mm)==='function') {
      mm=mm(); tipo.$$metamodel$$=mm;
    }
    if (mm && mm.$cont) {
      that=function(x){
        var rv=tipo.bind(x);
        rv.$$metamodel$$=tipo.$$metamodel$$;
        var nt={t:tipo};
        if (x.$$targs$$) {
          nt.a={};
          for (var nta in x.$$targs$$)nt.a[nta]=x.$$targs$$[nta];
        }
        if (that.$targs) {
          if (!nt.a)nt.a={};
          for (var nta in that.$targs)nt.a[nta]=that.$targs[nta];
        }
        rv=AppliedInterface(rv,{Type:nt});
        if (nt.a)rv.$targs=nt.a;
        rv.$bound=x;
        return rv;
      }
      that.tipo$2=tipo;
      var dummy = new AppliedMemberInterface.$$;
      that.$$=AppliedMemberInterface.$$;
      that.getT$all=function(){return dummy.getT$all();};
      that.getT$name=function(){return dummy.getT$name();};
      that.equals=function(o){
        var eq=isOfType(o,{t:AppliedMemberInterface}) && (o.tipo$2||o.tipo)==tipo;
        if (that.$bound)eq=eq && o.$bound && o.$bound.equals(that.$bound);else eq=eq && o.$bound===undefined;
        return eq;
      };
      defineAttr(that,'string',function(){
        return String$($qname(mm));
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Object','$at','string']};});
      defineAttr(that,'declaration',function(){
        return InterfaceModel$meta$model.$$.prototype.$prop$getDeclaration.get.call(that);
      },undefined,InterfaceModel$meta$model.$$.prototype.$prop$getDeclaration.$$metamodel$$);
      that.$bind=function(x){return AppliedMemberInterface.$$.prototype.$bind.call(that,x);}
    } else {
      that=new AppliedMemberInterface.$$;
    }
  }
  set_type_args(that,$$targs$$);
  MemberInterface$meta$model(that.$$targs$$===undefined?$$targs$$:{Type:that.$$targs$$.Type,Container:that.$$targs$$.Container},that);
  that.tipo=tipo;
  return that;
}
AppliedMemberInterface.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],$tp:{Container:{'var':'in'},Type:{'var':'out','def':{t:Anything}}},satisfies:[{t:MemberInterface$meta$model,a:{Type:'Type',Container:'Container'}}],$an:function(){return[shared(),abstract()];},d:['ceylon.language.meta.model','MemberInterface']};};
exports.AppliedMemberInterface=AppliedMemberInterface;
function $init$AppliedMemberInterface(){
  if (AppliedMemberInterface.$$===undefined){
    initTypeProto(AppliedMemberInterface,'ceylon.language.meta.model::AppliedMemberInterface',Basic,MemberInterface$meta$model);
    (function($$appliedMemberInterface){
      $$appliedMemberInterface.$bind=function $bind(container$2){
        var $$appliedMemberInterface=this;
        throw Exception(String$("IMPL MemberInterface.bind"));
      };$$appliedMemberInterface.$bind.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Interface$meta$model,a:{Type:'Type'}},$ps:[{$nm:'container',$mt:'prm',$t:{t:Object$},$an:function(){return[];}}],$cont:MemberInterface,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','MemberInterface','$m','bind']};};
    })(AppliedMemberInterface.$$.prototype);
  }
  return AppliedMemberInterface;
}
exports.$init$AppliedMemberInterface$meta$model=$init$AppliedMemberInterface;
$init$AppliedMemberInterface();
    

function AppliedUnionType(tipo,types$2, $$targs$$, that) {
    $init$AppliedUnionType();
    if (that===undefined)that=new AppliedUnionType.$$;
    set_type_args(that,$$targs$$);
    UnionType$meta$model(that.$$targs$$===undefined?$$targs$$:{Union:that.$$targs$$.Union},that);
    that.tipo=tipo;
    that._types=types$2;
    return that;
}
AppliedUnionType.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$tp:{Union:{'var':'out','def':{t:Anything}}},satisfies:[{t:UnionType$meta$model,a:{Union:'Union'}}],$an:function(){return[shared()];},d:['ceylon.language.meta.model','UnionType']};};
function $init$AppliedUnionType(){
  if (AppliedUnionType.$$===undefined){
    initTypeProto(AppliedUnionType,'ceylon.language.meta.model::AppliedUnionType',Basic,UnionType$meta$model);
    (function($$appliedUnionType){

defineAttr($$appliedUnionType,'string',function(){
  var qn="";
  var first=true;
  for (var i=0;i<this._types.length;i++) {
    if (first)first=false;else qn+="|";
    qn+=this._types[i].string;
  }
  return String$(qn);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Object','$at','string']};});
defineAttr($$appliedUnionType,'hash',function(){
  var h=this._types.length;
  for (var i=0; i<this._types.length;i++) {
    h+=this._types[i].hash;
  }
  return h;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','Object','$at','hash']};});

      $$appliedUnionType.equals=function(u) {
        if(isOfType(u,{t:AppliedUnionType})) {
          var mine=this._types;
          var his=u.caseTypes;
          if (mine.size==his.size) {
            for (var i=0;i<mine.length;i++) {
              if (!his.contains(mine[i]))return false;
            }
            return true;
          }
        }
        return false;
      }
            
            defineAttr($$appliedUnionType,'caseTypes',function(){
                var $$appliedUnionType=this;
                return $$appliedUnionType._types; //TODO type
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:{t:Type$meta$model,a:{Type:'Union'}}}},$cont:AppliedUnionType,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','UnionType','$at','caseTypes']};});

      $$appliedUnionType.typeOf=function typeOf(instance$20){
        var tipos=[];
        for (var i=0; i < this._types.length;i++) {
          var _t = this._types[i];
          if (_t.tipo) {
            _t={t:_t.tipo};
          } else if (_t.t===undefined) {
          _t={t:_t};
          }
          tipos.push(_t);
        }
        return isOfType(instance$20,{t:'u',l:tipos});
      };$$appliedUnionType.typeOf.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean},$ps:[{$nm:'instance',$mt:'prm',$t:{t:Anything},$an:function(){return[];}}],$cont:AppliedUnionType,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','UnionType','$m','typeOf']};};

            $$appliedUnionType.supertypeOf=function supertypeOf(type$21){
                var $$appliedUnionType=this;
                throw Exception(String$("IMPL AppliedUnionType.supertypeOf"));
            };$$appliedUnionType.supertypeOf.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean},$ps:[{$nm:'type',$mt:'prm',$t:{t:Type$meta$model,a:{Type:{t:Anything}}},$an:function(){return[];}}],$cont:AppliedUnionType,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','UnionType','$m','supertypeOf']};};

      $$appliedUnionType.exactly=function exactly(type$22){
        if (isOfType(type$25, {t:AppliedUnionType})) {
          for (var i=0; i<this._types.length;i++) {
            var myt = this._types[i];
            var was=false;
            for (var j=0; j<type$25._types.length;j++) {
              was |= myt.exactly(type$25._types[j]);
            }
            if (!was)return false;
          }
          //Now the other way around
          for (var i=0; i<type$25._types.length;i++) {
            var myt = type$25._types[i];
            var was=false;
            for (var j=0; j<this._types.length;j++) {
              was |= myt.exactly(this._types[j]);
            }
            if (!was)return false;
          }
          return true;
        }
        return false;
      };$$appliedUnionType.exactly.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean},$ps:[{$nm:'type',$mt:'prm',$t:{t:Type$meta$model,a:{Type:{t:Anything}}},$an:function(){return[];}}],$cont:AppliedUnionType,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','UnionType','$m','exactly']};};

    })(AppliedUnionType.$$.prototype);
  }
  return AppliedUnionType;
}
exports.$init$AppliedUnionType$meta$model=$init$AppliedUnionType;
$init$AppliedUnionType();

function AppliedIntersectionType(tipo,types$3, $$targs$$, that) {
    $init$AppliedIntersectionType();
    if (that===undefined)that=new AppliedIntersectionType.$$;
    set_type_args(that,$$targs$$);
    that._types=types$3;
    IntersectionType$meta$model(that.$$targs$$===undefined?$$targs$$:{Intersection:that.$$targs$$.Union},that);
    that.tipo=tipo;
    return that;
}
AppliedIntersectionType.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$tp:{Union:{'var':'out','def':{t:Anything}}},satisfies:[{t:IntersectionType$meta$model,a:{Intersection:'Union'}}],$an:function(){return[shared()];},d:['ceylon.language.meta.model','IntersectionType']};};
function $init$AppliedIntersectionType(){
  if (AppliedIntersectionType.$$===undefined){
    initTypeProto(AppliedIntersectionType,'ceylon.language.meta.model::AppliedIntersectionType',Basic,IntersectionType$meta$model);
    (function($$appliedIntersectionType){

defineAttr($$appliedIntersectionType,'string',function(){
  var qn="";
  var first=true;
  for (var i=0;i<this._types.length;i++) {
    if (first)first=false;else qn+="&";
    qn+=this._types[i].string;
  }
  return String$(qn);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Object','$at','string']};});
defineAttr($$appliedIntersectionType,'hash',function(){
  var h=this._types.length;
  for (var i=0; i<this._types.length;i++) {
    h+=this._types[i].hash;
  }
  return h;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','Object','$at','hash']};});
      $$appliedIntersectionType.equals=function(u) {
        if(isOfType(u,{t:AppliedIntersectionType})) {
          var mine=this._types;
          var his=u.satisfiedTypes;
          if (mine.size==his.size) {
            for (var i=0;i<mine.length;i++) {
              if (!his.contains(mine[i]))return false;
            }
            return true;
          }
        }
        return false;
      }
 
            defineAttr($$appliedIntersectionType,'satisfiedTypes',function(){
                var $$appliedIntersectionType=this;
                return $$appliedIntersectionType._types;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:{t:Type$meta$model,a:{Type:'Union'}}}},$cont:AppliedIntersectionType,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','IntersectionType','$at','satisfiedTypes']};});

      $$appliedIntersectionType.typeOf=function typeOf(instance$23){
        var tipos=[];
        for (var i=0; i < this._types.length;i++) {
          var _t = this._types[i];
          if (_t.tipo) {
            _t={t:_t.tipo};
          } else if (_t.t===undefined) {
          _t={t:_t};
          }
          tipos.push(_t);
        }
        return isOfType(instance$23,{t:'i',l:tipos});
      };$$appliedIntersectionType.typeOf.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean},$ps:[{$nm:'instance',$mt:'prm',$t:{t:Anything},$an:function(){return[];}}],$cont:AppliedIntersectionType,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','IntersectionType','$m','typeOf']};};

            $$appliedIntersectionType.supertypeOf=function supertypeOf(type$24){
                var $$appliedIntersectionType=this;
                throw Exception(String$("IMPL AppliedIntersectionType.supertypeOf"));
            };$$appliedIntersectionType.supertypeOf.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean},$ps:[{$nm:'type',$mt:'prm',$t:{t:Type$meta$model,a:{Type:{t:Anything}}},$an:function(){return[];}}],$cont:AppliedIntersectionType,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','IntersectionType','$m','supertypeOf']};};

      $$appliedIntersectionType.exactly=function exactly(type$25){
        if (isOfType(type$25, {t:AppliedIntersectionType})) {
          for (var i=0; i<this._types.length;i++) {
            var myt = this._types[i];
            var was=false;
            for (var j=0; j<type$25._types.length;j++) {
              was |= myt.exactly(type$25._types[j]);
            }
            if (!was)return false;
          }
          //Now the other way around
          for (var i=0; i<type$25._types.length;i++) {
            var myt = type$25._types[i];
            var was=false;
            for (var j=0; j<this._types.length;j++) {
              was |= myt.exactly(this._types[j]);
            }
            if (!was)return false;
          }
          return true;
        }
        return false;
      };$$appliedIntersectionType.exactly.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean},$ps:[{$nm:'type',$mt:'prm',$t:{t:Type$meta$model,a:{Type:{t:Anything}}},$an:function(){return[];}}],$cont:AppliedIntersectionType,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','IntersectionType','$m','exactly']};};

    })(AppliedIntersectionType.$$.prototype);
  }
  return AppliedIntersectionType;
}
exports.$init$AppliedIntersectionType$meta$model=$init$AppliedIntersectionType;
$init$AppliedIntersectionType();

function AppliedFunction(m,$$targs$$,o,mptypes) {
  var mm=m.$$metamodel$$;
  if (typeof(mm)==='function') {mm=mm();m.$$metamodel$$=mm;}
  var ttargs;
  if (mm.$tp) {
    if (!mptypes || mptypes.size<1)throw TypeApplicationException$meta$model("Missing type arguments for AppliedFunction");
    var i=0;ttargs={};
    for (var tp in mm.$tp) {
      var _ta=mptypes.$get?mptypes.$get(i):mptypes[i];
      if(_ta&&_ta.tipo)ttargs[tp]={t:_ta.tipo};
      else if (_ta) console.log("TODO assign type arg " + _ta + " to " + tp);
      else if (mptypes[tp])ttargs[tp]=mptypes[tp];
      else throw Error("TODO no more type arguments in AppliedFunction");
      i++;
    }
  }
  var f = o===undefined&&mm.$cont?function(x){
    return AppliedFunction(m,$$targs$$,x,mptypes);
  }:function(){
    var _fu=(o&&o[mm.d[mm.d.length-1]])||m;//Get the object's method if possible
    if (mm.$tp) {
      var _a=[];
      for (var i=0;i<arguments.length;i++)_a.push(arguments[i]);
      _a.push(ttargs);
      return _fu.apply(o,_a);
    }
    return _fu.apply(o,arguments);
  }
  f.$$metamodel$$={mod:$$METAMODEL$$,d:['ceylon.language.model','Function'],$t:mm.$t,$ps:mm.$ps,$an:mm.$an};
  var dummy=new AppliedFunction.$$;
  f.getT$all=function(){return dummy.getT$all();}
  f.getT$name=function(){return dummy.getT$name();}
  if ($$targs$$===undefined) {
    throw TypeApplicationException$meta$model("Missing type arguments for AppliedFunction");
  }
  Function$meta$model($$targs$$,f);
  f.tipo=m;
  f.$targs=ttargs;
  if (o)f.$bound=o;
  defineAttr(f,'typeArguments',function(){
    return FunctionModel$meta$model.$$.prototype.$prop$getTypeArguments.get.call(f);
  },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:{t:TypeParameter$meta$declaration},Item:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$cont:AppliedFunction,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Generic','$at','typeArguments']};});
  f.equals=function(oo){
    return isOfType(oo,{t:AppliedFunction}) && oo.tipo===m && oo.typeArguments.equals(this.typeArguments) && (o?o.equals(oo.$bound):oo.$bound===o);
  }
  defineAttr(f,'string',function(){
    return FunctionModel$meta$model.$$.prototype.$prop$getString.get.call(f);
  },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Object','$at','string'],$cont:AppliedFunction};});
  defineAttr(f,'parameterTypes',function(){
    return FunctionModel$meta$model.$$.prototype.$prop$getParameterTypes.get.call(f);
  },undefined,FunctionModel$meta$model.$$.prototype.$prop$getParameterTypes.$$metamodel$$);
defineAttr(f,'declaration',function(){
  if (f._decl)return f._decl;
  f._decl = OpenFunction(getModules$meta().find(mm.mod['$mod-name'],mm.mod['$mod-version']).findPackage(mm.d[0]), m);
  return f._decl;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:FunctionDeclaration$meta$declaration},d:['ceylon.language.meta.model','FunctionModel','$at','declaration']};});
  f.$apply=function(a){
    a=convert$params(mm,a);
    if (ttargs) {
      var _a=[];
      for (var i=0;i<a.size;i++)_a.push(a.$get(i));
      _a.push(ttargs);
      a=_a;
    }
    return m.apply(o,a);
  }
  return f;
}
AppliedFunction.$$metamodel$$=function(){return{mod:$$METAMODEL$$,d:['ceylon.language.meta.model','Function'],satisfies:{t:Function$meta$model,a:{Type:'Type',Arguments:'Arguments'}},$an:function(){return [shared(),actual()];}};};
exports.AppliedFunction$meta$model=AppliedFunction;
initTypeProto(AppliedFunction,'ceylon.language.meta.model::AppliedFunction',Basic,Function$meta$model);

function AppliedValue(obj,attr,$$targs$$,$$appliedValue){
  var mm = attr.$$metamodel$$;
  if (typeof(mm)==='function'){
    mm=mm();
    attr.$$metamodel$$=mm;
  }
  $init$AppliedValue();
  if ($$appliedValue===undefined){
    if (obj||mm.$cont===undefined)$$appliedValue=new AppliedValue.$$;
    else {
      $$appliedValue=function(x){return AppliedValue(x,attr,$$targs$$);};
      $$appliedValue.$$=AppliedValue.$$;
      var dummy=new AppliedValue.$$;
      $$appliedValue.getT$all=function(){return dummy.getT$all();};
      $$appliedValue.getT$name=function(){return dummy.getT$name();};
defineAttr($$appliedValue,'string',function(){
  var qn;
  if ($$targs$$ && $$targs$$.Container) {
    qn = typeLiteral$meta({Type:$$targs$$.Container}).string + "." + mm.d[mm.d.length-1];
  } else if (mm.$cont) {
    qn = typeLiteral$meta({Type:{t:mm.$cont}}).string + "." + mm.d[mm.d.length-1];
  } else {
    qn=$qname(mm);
  }
  return String$(qn);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Object','$at','string']};});
    }
  }
  set_type_args($$appliedValue,$$targs$$);
  Value$meta$model($$appliedValue.$$targs$$===undefined?$$targs$$:{Get:$$appliedValue.$$targs$$.Get,Set:$$appliedValue.$$targs$$.Set},$$appliedValue);
  if($$targs$$.Container)Attribute$meta$model($$targs$$,$$appliedValue);
  $$appliedValue.obj=obj;
  $$appliedValue.tipo=attr;
  return $$appliedValue;
}
AppliedValue.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$tp:{Get:{'var':'out'},Set:{'var':'in'}},
  satisfies:[{t:Value$meta$model,a:{Get:'Get',Set:'Set'}}],$an:function(){return[shared()];},d:['ceylon.language.meta.model','Value']};};
exports.AppliedValue$meta$model=AppliedValue;
function $init$AppliedValue(){
  if (AppliedValue.$$===undefined){
    initTypeProto(AppliedValue,'ceylon.language.meta.model::AppliedValue',Basic,Value$meta$model);
    (function($$appliedValue){
defineAttr($$appliedValue,'string',function(){
  return String$($qname(this.tipo));
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Object','$at','string']};});
      defineAttr($$appliedValue,'declaration',function(){
        var $$av=this;
        var mm = $$av.tipo.$$metamodel$$;
        var _pkg = getModules$meta().find(mm.mod['$mod-name'],mm.mod['$mod-version']).findPackage(mm.d[0]);
        return OpenValue(_pkg, $$av.tipo);
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:ValueDeclaration$meta$declaration},$cont:AppliedValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Value','$at','declaration']};});

      $$appliedValue.$get=function $get(){
        if (this.obj) {
          var mm=this.tipo.$$metamodel$$;
          return (mm&&mm.d&&this.obj[mm.d[mm.d.length-1]])||this.tipo.get.call(this.obj);
        }
        return this.tipo.get();
      };$$appliedValue.$get.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:'Get',$ps:[],$cont:AppliedValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Value','$m','get']};};
      $$appliedValue.set=function set(newValue$26){
        if (!this.tipo.set)throw MutationException$meta$model("Value is not writable");
        return this.obj?this.tipo.set.call(this.obj,newValue$26):this.tipo.set(newValue$26);
      };$$appliedValue.set.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Anything},$ps:[{$nm:'newValue',$mt:'prm',$t:'Set',$an:function(){return[];}}],$cont:AppliedValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Value','$m','set']};};
 
$$appliedValue.setIfAssignable=function(v) {
  var mm = this.tipo.$$metamodel$$;
  if (!isOfType(v,mm.$t))throw IncompatibleTypeException$meta$model("The specified value has the wrong type");
  var mdl=get_model(mm);
  if (!(mdl &&mdl['var']))throw MutationException$meta$model("Attempt to modify a value that is not variable");
  this.obj?this.tipo.set.call(this.obj,v):this.tipo.set(v);
};$$appliedValue.setIfAssignable.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$ps:[],$cont:AppliedValue,d:['ceylon.language.meta.model','Value','$m','setIfAssignable']};};

      defineAttr($$appliedValue,'type',function(){
          var $$atr=this;
          var t = $$atr.tipo.$$metamodel$$;
          return typeLiteral$meta({Type:t.$t});
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Type$meta$model,a:{Type:'Get'}},$cont:AppliedValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Value','$at','type']};});

      defineAttr($$appliedValue,'container',function(){
          if (this.$$targs$$.Container) {
            return typeLiteral$meta({Type:this.$$targs$$.Container});
          }
          var mm=this.tipo.$$metamodel$$;
          if (mm.$cont) {
            return typeLiteral$meta({Type:{t:mm.$cont}});
          }
          return null;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:Type$meta$model,a:{Type:{t:Anything}}}]},$cont:AppliedValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Value','$at','container']};});

    })(AppliedValue.$$.prototype);
  }
  return AppliedValue;
}
exports.$init$AppliedValue$meta$model=$init$AppliedValue;
$init$AppliedValue();

//ClassDefinition AppliedMethod at X (10:0-21:0)
function AppliedMethod(tipo,typeArgs,$$targs$$,$$appliedMethod){
  $init$AppliedMethod();
  var mm = tipo.$$metamodel$$;
  if (typeof(mm)==='function') {
    mm = mm();
    tipo.$$metamodel$$=mm;
  }
  if (mm.$tp) {
    if (typeArgs===undefined || typeArgs.size<1)
      throw TypeApplicationException$meta$model(String$("Missing type arguments in call to FunctionDeclaration.apply"));
    var _ta={}; var i=0;
    for (var tp in mm.$tp) {
      if (typeArgs.$get(i)===undefined)
        throw TypeApplicationException$meta$model(String$("Missing type argument for "+tp));
      var _tp = mm.$tp[tp];
      var _t = typeArgs.$get(i).tipo;
      _ta[tp]={t:_t};
      if ((_tp.satisfies && _tp.satisfies.length>0) || (_tp.of && _tp.of.length > 0)) {
        var restraints=(_tp.satisfies && _tp.satisfies.length>0)?_tp.satisfies:_tp.of;
        for (var j=0; j<restraints.length;j++) {
          if (!extendsType(_ta[tp],restraints[j]))
            throw TypeApplicationException$meta$model(String$("Type argument for " + tp + " violates type parameter constraints"));
        }
      }
      i++;
    }
  }
  if ($$appliedMethod===undefined){
    $$appliedMethod=function(x){
      return AppliedFunction(tipo,$$targs$$,x,typeArgs);
    }
    var dummy=new AppliedMethod.$$;
    $$appliedMethod.getT$all=function(){return dummy.getT$all();};
    $$appliedMethod.getT$name=function(){return dummy.getT$name();};
  }
  if (_ta)$$appliedMethod.$targs=_ta;
  set_type_args($$appliedMethod,$$targs$$);
  Method$meta$model($$appliedMethod.$$targs$$===undefined?$$targs$$:{Arguments:$$appliedMethod.$$targs$$.Arguments,Type:$$appliedMethod.$$targs$$.Type,Container:$$appliedMethod.$$targs$$.Container},$$appliedMethod);
  $$appliedMethod.tipo=tipo;

//This was copied from prototype style
  defineAttr($$appliedMethod,'declaration',function(){
    var _pkg = getModules$meta().find(mm.mod['$mod-name'],mm.mod['$mod-version']).findPackage(mm.d[0]);
    return OpenFunction(_pkg, $$appliedMethod.tipo);
  },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:FunctionDeclaration$meta$declaration},$cont:AppliedMethod,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Method','$at','declaration']};});

  defineAttr($$appliedMethod,'type',function(){
    return typeLiteral$meta({Type:mm.$t});
  },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Type$meta$model,a:{Type:'Type'}},$cont:AppliedMethod,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Method','$at','type']};});

  defineAttr($$appliedMethod,'typeArguments',function(){
    return FunctionModel$meta$model.$$.prototype.$prop$getTypeArguments.get.call($$appliedMethod);
  },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Map,a:{Key:{t:TypeParameter$meta$declaration},Item:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$cont:AppliedMethod,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Generic','$at','typeArguments']};});
  defineAttr($$appliedMethod,'parameterTypes',function(){
    return FunctionModel$meta$model.$$.prototype.$prop$getParameterTypes.get.call($$appliedMethod);
  },undefined,FunctionModel$meta$model.$$.prototype.$prop$getParameterTypes.$$metamodel$$);

  $$appliedMethod.equals=function(o){
    return isOfType(o,{t:AppliedMethod}) && o.tipo===tipo && o.typeArguments.equals(this.typeArguments);
  }
  $$appliedMethod.$bind=function(o){
    if (!isOfType(o,{t:mm.$cont}))throw IncompatibleTypeException$meta$model("Cannot bind " + $$appliedMethod.string + " to "+o);
    return $$appliedMethod(o);
  }
  defineAttr($$appliedMethod,'string',function(){
    return FunctionModel$meta$model.$$.prototype.$prop$getString.get.call($$appliedMethod);
  },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Object','$at','string'],$cont:AppliedMethod};});
  return $$appliedMethod;
}
AppliedMethod.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$tp:{Container:{'var':'in'},Type:{'var':'out','def':{t:Anything}},Arguments:{'var':'in','satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},satisfies:[{t:Method$meta$model,a:{Arguments:'Arguments',Type:'Type',Container:'Container'}}],$an:function(){return[shared()];},d:['ceylon.language.meta.model','Method']};};
exports.AppliedMethod$meta$model=AppliedMethod;
function $init$AppliedMethod(){
    if (AppliedMethod.$$===undefined){
        initTypeProto(AppliedMethod,'ceylon.language.meta.model::AppliedMethod',Basic,Method$meta$model);
        (function($$appliedMethod){
//this area was moved inside AppliedMethod()            
        })(AppliedMethod.$$.prototype);
    }
    return AppliedMethod;
}
exports.$init$AppliedMethod$meta$model=$init$AppliedMethod;
$init$AppliedMethod();

//ClassDefinition AppliedAttribute at X (96:0-101:0)
function AppliedAttribute(pname, atr,$$targs$$,$$appliedAttribute){
  $init$AppliedAttribute();
  if ($$appliedAttribute===undefined) {
    $$appliedAttribute=function(x){return AppliedValue(x,atr, $$targs$$);};
    $$appliedAttribute.$$=AppliedAttribute.$$;
    var dummy=new AppliedAttribute.$$;
    $$appliedAttribute.getT$all=function(){return dummy.getT$all();};
    $$appliedAttribute.getT$name=function(){return dummy.getT$name();};
  }
  set_type_args($$appliedAttribute,$$targs$$);
  Attribute$meta$model($$appliedAttribute.$$targs$$===undefined?$$targs$$:{Get:$$appliedAttribute.$$targs$$.Get,Set:$$appliedAttribute.$$targs$$.Set,Container:$$appliedAttribute.$$targs$$.Container},$$appliedAttribute);
  $$appliedAttribute.tipo=atr;
  $$appliedAttribute.pname=pname;
  defineAttr($$appliedAttribute,'type',function(){
    var t = atr.$$metamodel$$;
    if (typeof(t)==='function'){
      t=t();
      atr.$$metamodel$$=t;
    }
    t=t.$t;
    return typeLiteral$meta({Type:t});
  },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Type$meta$model,a:{Type:'Get'}},$cont:AppliedAttribute,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Attribute','$at','type']};});
  //AttributeGetterDefinition declaration at X (100:4-100:83)
  defineAttr($$appliedAttribute,'declaration',function(){
    var mm = atr.$$metamodel$$;
    if (typeof(mm)==='function') {
      mm=mm();
      atr.$$metamodel$$=mm;
    }
    var pkg = getModules$meta().find(mm.mod['$mod-name'],mm.mod['$mod-version']).findPackage(mm.d[0]);
    return OpenValue(pkg, atr);
  },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:ValueDeclaration$meta$declaration},$cont:AppliedAttribute,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.model','Attribute','$at','declaration']};});
  $$appliedAttribute.$bind=function(cont){
    return AppliedValue(cont,atr,{Get:$$targs$$.Get,Set:$$targs$$.Set});
  }
  defineAttr($$appliedAttribute,'string',function(){
    if (typeof(atr.$$metamodel$$)==='function')atr.$$metamodel$$=atr.$$metamodel$$();
    var c=atr.$$metamodel$$.$cont;
    if (typeof(c.$$metamodel$$)==='function')c.$$metamodel$$=c.$$metamodel$$();
    if (!c)return String$($qname(atr));
    c=c.$$metamodel$$;
    var qn=$qname(c);
    if (c.$tp) {
      qn+="<"; var first=true;
      var cnt=$$targs$$&&$$targs$$.Container&&$$targs$$.Container.a;
      for (var tp in c.$tp) {
        if (first)first=false;else qn+=",";
        var _ta=cnt&&cnt[tp];
        if (_ta) {
          qn+=$qname(_ta);
        } else qn+=$qname(Anything);
      }
      qn+=">";
    }
    qn+="."+pname;
    return String$(qn);
  },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Object','$at','string']};});
  $$appliedAttribute.equals=function(o) {
    return isOfType(o,{t:AppliedAttribute}) && o.tipo===atr;
  }
  return $$appliedAttribute;
}
AppliedAttribute.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$tp:{Get:{'var':'out','def':{t:Anything}},Set:{'var':'in','def':{t:Nothing}},Container:{'var':'in'}},satisfies:[{t:Attribute$meta$model,a:{Get:'Get',Set:'Set',Container:'Container'}}],$an:function(){return[shared()];},d:['ceylon.language.meta.model','Attribute']};};
exports.AppliedAttribute=AppliedAttribute;
function $init$AppliedAttribute(){
    if (AppliedAttribute.$$===undefined){
        initTypeProto(AppliedAttribute,'ceylon.language.meta.model::AppliedAttribute',Basic,Attribute$meta$model);
        (function($$appliedAttribute){
//moved to initializer            
        })(AppliedAttribute.$$.prototype);
    }
    return AppliedAttribute;
}
exports.$init$AppliedAttribute$meta$model=$init$AppliedAttribute;
$init$AppliedAttribute();

function $findAnnotation(cont,ant) {
  if (typeof(cont.$$metamodel$$)==='function')cont.$$metamodel$$=cont.$$metamodel$$();
  if (typeof(cont.$$metamodel$$.$an)==='function')cont.$$metamodel$$.$an=cont.$$metamodel$$.$an();
  if (!cont.$$metamodel$$.$an)return null;
  for (var i=0; i < cont.$$metamodel$$.$an.length; i++) {
    if (isOfType(cont.$$metamodel$$.$an[i],{t:ant}))return cont.$$metamodel$$.$an[i];
  }
  return null;
}
//Find the real declaration of something from its model definition
function _findTypeFromModel(pkg,mdl,cont) {
  var mod = pkg.container;
  //TODO this is very primitive needs a lot of rules replicated from the JsIdentifierNames
  var nm = mdl.$nm;
  var mt = mdl['$mt'];
  if (mt === 'attr' || mt === 'gttr' || mt === 'obj') {
    nm = '$prop$get' + nm[0].toUpperCase() + nm.substring(1);
  }
  if (cont) {
    var imm=cont.$$metamodel$$;
    if (typeof(imm)==='function'){imm=imm();cont.$$metamodel$$=imm;}
    if (mt==='cls'||mt==='ifc')nm=nm+'$'+imm.d[imm.d.length-1];
  }else {
    nm+=pkg.suffix;
  }
  var out=cont?cont.$$.prototype:mod.meta;
  var rv=out[nm];
  if (rv===undefined)rv=out['$'+nm];
  if (rv===undefined)rv=out['$init$'+nm]();
  return rv;
}
//Pass a {t:Bla} and get a FreeClass,FreeInterface,etc (OpenType).
function _openTypeFromTarg(targ) {
  if (targ.t==='u' || targ.t==='i') {
    var tl=[];
    for (var i=0; i < targ.l.length; i++) {
      var _ct=targ.l[i];
      tl.push(_ct.t?_openTypeFromTarg(_ct):_ct);
    }
    return (targ.t==='u'?FreeUnion:FreeIntersection)(tl.reifyCeylonType({Element:{t:OpenType$meta$declaration}}));
  } else if (targ.t==='T') {
    targ=$retuple(targ);
  }
  var mm=targ.t.$$metamodel$$;
  if (typeof(mm)==='function') {
    mm=mm(); targ.t.$$metamodel$$=mm;
  }
  var lit = typeLiteral$meta({Type:targ.t});
  if (targ.a && lit)lit._targs=targ.a;
  var mdl = get_model(mm);
  if (mdl.$mt==='ifc') {
    return FreeInterface(lit);
  } else if (mdl.$mt==='cls' || mdl.$mt==='obj') {
    return FreeClass(lit);
  }
  console.log("Don't know WTF to return for " + lit + " metatype " + mdl.$mt);
}

//ClassDefinition FreeClass at X (161:0-168:0)
function FreeClass(declaration, $$freeClass){
  $init$FreeClass();
  if ($$freeClass===undefined)$$freeClass=new FreeClass.$$;
  OpenClassType$meta$declaration($$freeClass);
  $$freeClass._decl=declaration;
  $$freeClass.$prop$getDeclaration={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:ClassDeclaration$meta$declaration},$cont:FreeClass,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','OpenClassType','$at','declaration']};}};
  $$freeClass.$prop$getDeclaration.get=function(){return declaration};
  return $$freeClass;
}
FreeClass.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:OpenClassType$meta$declaration}],d:['ceylon.language.meta.declaration','OpenClassType']};};
function $init$FreeClass(){
  if (FreeClass.$$===undefined){
   initTypeProto(FreeClass,'ceylon.language.meta.declaration::FreeClass',Basic,OpenClassType$meta$declaration);
   (function($$freeClass){
    $$freeClass.equals=function(other) {
      return isOfType(other,{t:FreeClass}) && other.declaration.equals(this.declaration) && this.typeArguments.equals(other.typeArguments);
    }
   })(FreeClass.$$.prototype);
  }
  return FreeClass;
}
exports.$init$FreeClass=$init$FreeClass;
$init$FreeClass();

//ClassDefinition FreeInterface at X (170:0-177:0)
function FreeInterface(declaration, $$freeInterface){
    $init$FreeInterface();
    if ($$freeInterface===undefined)$$freeInterface=new FreeInterface.$$;
    OpenInterfaceType$meta$declaration($$freeInterface);
    
    //AttributeDeclaration declaration at X (173:4-173:50)
    $$freeInterface._decl=declaration;
    $$freeInterface.$prop$getDeclaration.get=function(){return declaration};
    return $$freeInterface;
}
FreeInterface.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:OpenInterfaceType$meta$declaration}],d:['ceylon.language.meta.declaration','OpenInterfaceType']};};
function $init$FreeInterface(){
  if (FreeInterface.$$===undefined){
    initTypeProto(FreeInterface,'ceylon.language.meta.declaration::FreeInterface',Basic,OpenInterfaceType$meta$declaration);
    (function($$freeInterface){
    $$freeInterface.equals=function(other) {
      return isOfType(other,{t:FreeInterface}) && other.declaration.equals(this.declaration) && this.typeArguments.equals(other.typeArguments);
    }
            
    })(FreeInterface.$$.prototype);
  }
  return FreeInterface;
}
exports.$init$FreeInterface=$init$FreeInterface;
$init$FreeInterface();

//ClassDefinition OpenFunction at X (18:0-36:0)
function OpenFunction(pkg, meta, that){
    $init$OpenFunction();
    if (that===undefined)that=new OpenFunction.$$;
    that._pkg=pkg;
    var _mm=meta.$$metamodel$$;
    if (_mm === undefined) {
      //it's a metamodel
      that.meta=meta;
      that.tipo=_findTypeFromModel(pkg,meta);
      _mm=that.tipo.$$metamodel$$;
      if (typeof(_mm)==='function') {
        _mm=_mm();
        that.tipo.$$metamodel$$=_mm;
      }
    } else {
      //it's a type
      that.tipo = meta;
      if (typeof(_mm)==='function') {
        _mm=_mm();
        meta.$$metamodel$$=_mm;
      }
      that.meta = get_model(_mm);
    }
    that.name_=_mm.d[_mm.d.length-1];
    that.toplevel_=_mm.$cont===undefined;
    FunctionDeclaration$meta$declaration(that);
    return that;
}
OpenFunction.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:FunctionDeclaration$meta$declaration}],d:['ceylon.language.meta.declaration','FunctionDeclaration']};};
function $init$OpenFunction(){
  if (OpenFunction.$$===undefined){
    initTypeProto(OpenFunction,'ceylon.language.meta.declaration::OpenFunction',Basic,FunctionDeclaration$meta$declaration);
    (function($$openFunction){
$$openFunction.equals=function(o) {
  if (isOfType(o,{t:OpenFunction})) {
    return o.tipo === this.tipo;
  }
  return false;
}
$$openFunction.equals.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},d:['ceylon.language','Object','$m','equals']};}
defineAttr($$openFunction,'container',function(){
  if (this.$parent)return this.$parent;
  if (this.toplevel)return this.containingPackage;
  return typeLiteral$meta({Type:this.tipo.$$metamodel$$.$cont});
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u',l:[{t:NestableDeclaration$meta$declaration},{t:Package$meta$declaration}]},d:['ceylon.language.meta.declaration','NestableDeclaration','$at','container']};});
defineAttr($$openFunction,'annotation',function(){
  return $findAnnotation(this.tipo,AnnotationAnnotation)!==null;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:OpenFunction,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionalDeclaration','$at','annotation']};});

      $$openFunction.$apply=function $apply(types,$mptypes){
        var mm=this.tipo.$$metamodel$$;
        var ta={t:this.tipo};
        validate$typeparams(ta,mm.$tp,types);
        validate$params(mm.$ps,$mptypes.Arguments,"Wrong number of arguments when applying function");
        return ta.a?AppliedFunction(this.tipo,{Type:mm.$t,Arguments:tupleize$params(mm.$ps,ta.a)},undefined,ta.a):
          AppliedFunction(this.tipo,{Type:mm.$t,Arguments:tupleize$params(mm.$ps)});
      };$$openFunction.$apply.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Function$meta$model,a:{Arguments:{t:Nothing},Type:{t:Anything}}},$ps:[{$nm:'types',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model}}}}],$cont:OpenFunction,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$m','apply']};};

      $$openFunction.memberApply=function memberApply(cont,types,$mptypes){
        var mm=this.tipo.$$metamodel$$;
        if (!(cont.tipo && extendsType({t:cont.tipo},{t:mm.$cont}))&&cont!==getNothingType$meta$model())
          throw IncompatibleTypeException$meta$model("Incompatible Container type argument");
        if (!extendsType(mm.$t,$mptypes.Return))throw IncompatibleTypeException$meta$model("Incompatible Return type argument");
        validate$params(mm.$ps,$mptypes.Arguments,"Wrong number of Arguments for memberApply");
        var ta={t:this.tipo};
        validate$typeparams(ta,mm.$tp,types);
        return AppliedMethod(this.tipo,types,{Container:$mptypes.Container,Type:mm.$t,Arguments:tupleize$params(mm.$ps,ta.a)});
      };$$openFunction.memberApply.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Method$meta$model,a:{Arguments:'Arguments',Type:'MethodType',Container:'Container'}},$ps:[{$nm:'types',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model}}}}],$cont:OpenFunction,$tp:{Container:{},MethodType:{},Arguments:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}]}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$m','memberApply']};};
            
            //AttributeDeclaration defaulted at X (25:4-25:44)
            defineAttr($$openFunction,'defaulted',function(){
                return false;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:OpenFunction,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','defaulted']};});
            
            //AttributeDeclaration variadic at X (26:4-26:43)
            defineAttr($$openFunction,'variadic',function(){
                var $$openFunction=this;
                return false;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:OpenFunction,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','variadic']};});
    $$openFunction.getParameterDeclaration=function (name$6){
      var pd=this.parameterDeclarations;
      for (var i=0; i < pd.length; i++) {
        if (name$6.equals(pd[i].name))return pd[i];
      }
      return null;
    };
    $$openFunction.getParameterDeclaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:FunctionOrValueDeclaration$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$}}],$cont:OpenFunction,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$m','getParameterDeclaration']};};
            
            //AttributeGetterDefinition openType at X (33:2-33:43)
    defineAttr($$openFunction,'openType',function(){
      var t = this.tipo.$$metamodel$$.$t;
      if (typeof(t)==='string')return OpenTvar(OpenTypeParam(this.tipo,t));
      return _openTypeFromTarg(t);
    },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:OpenType$meta$declaration},$cont:OpenFunction,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','openType']};});
            defineAttr($$openFunction,'name',function(){return this.name_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenFunction,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','name']};});
            defineAttr($$openFunction,'containingPackage',function(){return this._pkg;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Package$meta$declaration},$cont:OpenFunction,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','containingPackage']};});
            defineAttr($$openFunction,'containingModule',function(){return this._pkg.container;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Package$meta$declaration},$cont:OpenFunction,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','containingPackage']};});
            defineAttr($$openFunction,'toplevel',function(){return this.toplevel_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:OpenFunction,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','toplevel']};});

    defineAttr($$openFunction,'string',function(){return String$("function " + this.qualifiedName);},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenFunction,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Declaration','$at','string']};});
    defineAttr($$openFunction,'qualifiedName',function(){
       return String$($qname(this.tipo));
    },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenFunction,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Declaration','$at','qualifiedName']};});
    })(OpenFunction.$$.prototype);
  }
  return OpenFunction;
}
exports.$init$OpenFunction=$init$OpenFunction;
$init$OpenFunction();

//ClassDefinition OpenValue at X (38:0-45:0)
function OpenValue(pkg, meta, that){
  $init$OpenValue();
  if (that===undefined)that=new OpenValue.$$;
  that._pkg = pkg;
  var _mm=meta.$$metamodel$$;
  if (_mm === undefined) {
    //it's a metamodel
    that.meta=meta;
    if (meta['$mt']==='prm') {
      that.tipo={$$metamodel$$:meta};
      //TODO I think we need to do something else here
    } else {
      that.tipo=_findTypeFromModel(pkg,meta);
    }
    _mm = that.tipo.$$metamodel$$;
    if (typeof(_mm)==='function') {
      _mm=_mm();
      that.tipo.$$metamodel$$=_mm;
    }
  } else {
    //it's a type
    that.tipo = meta;
    if (typeof(_mm)==='function') {
      _mm=_mm();
      meta.$$metamodel$$=_mm;
    }
    that.meta = get_model(_mm);
  }
  that.name_=_mm.d===undefined?_mm['$nm']:_mm.d[_mm.d.length-1];
  that.toplevel_=_mm.$cont === undefined;
  ValueDeclaration$meta$declaration(that);
  return that;
}
OpenValue.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:ValueDeclaration$meta$declaration}],d:['ceylon.language.meta.declaration','ValueDeclaration']};};
function $init$OpenValue(){
  if (OpenValue.$$===undefined){
    initTypeProto(OpenValue,'ceylon.language.meta.declaration::OpenValue',Basic,ValueDeclaration$meta$declaration);
    (function($$openValue){

defineAttr($$openValue,'container',function(){
  if (this.$parent)return this.$parent;
  if (this.toplevel)return this.containingPackage;
  return typeLiteral$meta({Type:this.tipo.$$metamodel$$.$cont});
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u',l:[{t:NestableDeclaration$meta$declaration},{t:Package$meta$declaration}]},d:['ceylon.language.meta.declaration','NestableDeclaration','$at','container']};});
            
            //MethodDefinition apply at X (39:4-39:68)
      $$openValue.$apply=function $apply($$$mptypes){
        var mm=this.tipo.$$metamodel$$;
        if (typeof(mm)==='function'){mm=mm();this.tipo.$$metamodel$$=mm;}
        if (!extendsType(mm.$t,$$$mptypes.Get))throw IncompatibleTypeException$meta$model("Incompatible Get type argument");
        if (!extendsType($$$mptypes.Set,this.tipo.set?mm.$t:{t:Nothing}))throw IncompatibleTypeException$meta$model("Incompatible Set type argument");
        return AppliedValue(undefined,this.tipo,$$$mptypes);
      };$$openValue.$apply.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Value$meta$model,a:{Type:{t:Anything}}},$ps:[{$nm:'instance',$mt:'prm',$def:1,$t:{t:Anything}}],$cont:OpenValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$m','apply']};};

      $$openValue.memberApply=function memberApply(cont,$mptypes) {
        var mm=this.tipo.$$metamodel$$;
        if (typeof(mm)==='function'){
          mm=mm(); this.tipo.$$metamodel$$=mm;
        }
        if (!(cont.tipo && extendsType({t:cont.tipo},{t:mm.$cont}))&&cont!==getNothingType$meta$model())
          throw IncompatibleTypeException$meta$model("Incompatible Container type argument");
        if (!extendsType(mm.$t,$mptypes.Get))throw IncompatibleTypeException$meta$model("Incompatible Get type argument");
        if (!extendsType($mptypes.Set,this.tipo.set?mm.$t:{t:Nothing}))throw IncompatibleTypeException$meta$model("Incompatible Set type argument");
        return AppliedAttribute(this.meta.$nm,this.tipo,$mptypes);
      };$$openValue.memberApply.$$metamodel$$=function(){return{mod:$$METAMODEL$$,d:['ceylon.language.meta.declaration','ValueDeclaration','$m','memberApply']};};
      defineAttr($$openValue,'defaulted',function(){
        return false;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:OpenValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','defaulted']};});
      defineAttr($$openValue,'variadic',function(){
        return false;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:OpenValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','variadic']};});
      defineAttr($$openValue,'variable',function(){
        return $findAnnotation(this.tipo,VariableAnnotation)!==null;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:OpenValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','variadic']};});
            
  defineAttr($$openValue,'openType',function(){
    if (this.tipo) {
      var mm = this.tipo.$$metamodel$$;
      if (typeof(mm)==='function'){
        mm=mm(); this.tipo.$$metamodel$$=mm;
      }
      if (typeof(mm.$t)==='string') {
        return OpenTypeParam(mm.$cont,mm.$t);
      }
      return _openTypeFromTarg(mm.$t);
    }
    throw Error("OpenValue.openType-we don't have a metamodel!");
  },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:OpenType$meta$declaration},$cont:OpenValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','openType']};});

defineAttr($$openValue,'name',function(){return this.name_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','name']};});
defineAttr($$openValue,'containingPackage',function(){return this._pkg;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Package$meta$declaration},$cont:OpenValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','containingPackage']};});
defineAttr($$openValue,'containingModule',function(){return this._pkg.container;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Module$meta$declaration},$cont:OpenValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','containingModule']};});
defineAttr($$openValue,'toplevel',function(){return this.toplevel_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:OpenValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','toplevel']};});

  $$openValue.equals=function(other) {
    if (isOfType(other, {t:OpenValue}) && other.name.equals(this.name) && other.toplevel===this.toplevel && other.containingPackage.equals(this.containingPackage)) {
      return other.meta==this.meta;
    }
    return false;
  }
  defineAttr($$openValue,'string',function(){return String$("value " + this.qualifiedName);},undefined,{$an:function(){return[shared(),actual()]},mod:$$METAMODEL$$,d:['ceylon.language','Object','$at','string']});

    defineAttr($$openValue,'qualifiedName',function(){
      return String$($qname(this.tipo));
    },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Declaration','$at','qualifiedName']};});
    $$openValue.memberSet=function(c,v) {
      if (!isOfType(c,{t:this.tipo.$$metamodel$$.$cont}))throw IncompatibleTypeException$meta$model("Incompatible container type");
      if (!isOfType(v,this.tipo.$$metamodel$$.$t))throw IncompatibleTypeException$meta$model("Incompatible value type");
      if (!this.tipo.set)throw MutationException$meta$model($qname(this.tipo.$$metamodel$$)+" is not writable");
      c[this.name]=v;
    };
    defineAttr($$openValue,'setter',function(){
      return OpenSetter(this);
    },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:SetterDeclaration$meta$declaration},$cont:OpenValue,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','setter']};});

    })(OpenValue.$$.prototype);
  }
  return OpenValue;
}
exports.$init$OpenValue=$init$OpenValue;
$init$OpenValue();

//ClassDefinition OpenSetter at opentypes.ceylon (63:0-63:90)
function OpenSetter(v, $$openSetter){
  $init$OpenSetter();
  if ($$openSetter===undefined)$$openSetter=new OpenSetter.$$;
  $$openSetter.variable_=v;
  SetterDeclaration$meta$declaration($$openSetter);
  $$openSetter.tipo=v.tipo.set;
  if (v.tipo.set && v.tipo.set.setter$anns) {
    var mm={};
    var omm=v.tipo.set.$$metamodel$$;
    if (typeof(omm)==='function')omm=omm();
    for (var k in omm)mm[k]=omm[k];
    mm.$an=v.tipo.set.setter$anns;
    v.tipo.set.$$metamodel$$=mm;
  }
  return $$openSetter;
}
OpenSetter.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:SetterDeclaration$meta$declaration}],d:['ceylon.language.meta.declaration','SetterDeclaration']};};
function $init$OpenSetter(){
    if (OpenSetter.$$===undefined){
        initTypeProto(OpenSetter,'ceylon.language.meta.declaration::OpenSetter',Basic,SetterDeclaration$meta$declaration);
        (function($$openSetter){
            defineAttr($$openSetter,'variable',function(){return this.variable_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:ValueDeclaration$meta$declaration},$cont:OpenSetter,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','SetterDeclaration','$at','variable']};});
        })(OpenSetter.$$.prototype);
    }
    return OpenSetter;
}
exports.$init$OpenSetter=$init$OpenSetter;
$init$OpenSetter();

//ClassDefinition OpenClass at X (47:0-70:0)
function OpenClass(pkg, meta, that){
    $init$OpenClass();
    if (that===undefined)that=new OpenClass.$$;
    that._pkg = pkg;
    var _mm=meta.$$metamodel$$;
    if (_mm === undefined) {
      //it's a metamodel
      that.meta=meta;
      that.tipo=_findTypeFromModel(pkg,meta);
      _mm = that.tipo.$$metamodel$$;
      if (typeof(_mm)==='function') {
        _mm=_mm();
        that.tipo.$$metamodel$$=_mm;
      }
    } else {
      //it's a type
      that.tipo = meta;
      if (typeof(_mm)==='function') {
        _mm=_mm();
        meta.$$metamodel$$=_mm;
      }
      that.meta = get_model(_mm);
    }
    that.name_=_mm.d[_mm.d.length-1];
    that.toplevel_=_mm.$cont===undefined;
    ClassDeclaration$meta$declaration(that);
    return that;
}
OpenClass.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:ClassDeclaration$meta$declaration}],d:['ceylon.language.meta.declaration','ClassDeclaration']};};
function $init$OpenClass(){
  if (OpenClass.$$===undefined){
    initTypeProto(OpenClass,'ceylon.language.meta.declaration::OpenClass',Basic,ClassDeclaration$meta$declaration);
    (function($$openClass){

$$openClass.classApply=function(targs,$mptypes) {
  var mm=this.tipo.$$metamodel$$;
  if (mm.$tp) {
    if (!targs)throw TypeApplicationException$meta$model("This class requires type arguments");
    //TODO generate targs
  }
  validate$params(mm.$ps,$mptypes.Arguments,"Wrong number of Arguments for classApply");
  return this.$apply(targs,$mptypes);//TODO tupleize
}
$$openClass.memberClassApply=function(cont,targs,$mptypes){
  var mm=this.tipo.$$metamodel$$;
  if (cont!==getNothingType$meta$model() && !extendsType({t:cont.tipo},{t:mm.$cont}))
    throw IncompatibleTypeException$meta$model("Incompatible Container specified");
  if (!extendsType({t:this.tipo},$mptypes.Type))
    throw IncompatibleTypeException$meta$model("Incompatible Type specified");
  var _t={t:this.tipo};
  validate$typeparams(_t,mm.$tp,targs);
  validate$params(mm.$ps,$mptypes.Arguments,"Wrong number of Arguments for classApply");
  var rv=AppliedMemberClass(this.tipo,{Container:{t:mm.$cont},Type:_t,Arguments:tupleize$params(mm.$ps)});
  if (_t.a)rv.$targs=_t.a;
  return rv;
}

      defineAttr($$openClass,'string',function(){
        return String$("class " + this.qualifiedName);
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenClass,$an:function(){return[shared(),actual()];},d:['ceylon.language','Object']};}); 
      defineAttr($$openClass,'anonymous',function(){
        return this.meta.$mt==='obj';
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:OpenClass,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$at','anonymous']};});
      defineAttr($$openClass,'abstract',function(){
        return $findAnnotation(this.tipo,AbstractAnnotation)!==null;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:OpenClass,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$at','abstract']};});
      defineAttr($$openClass,'$final',function(){
        return $findAnnotation(this.tipo,FinalAnnotation)!==null;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:OpenClass,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$at','final']};});
      defineAttr($$openClass,'annotation',function(){
        return $findAnnotation(this.tipo,AnnotationAnnotation)!==null;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:OpenClass,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionalDeclaration','$at','annotation']};});
           
            //AttributeGetterDefinition openType at X (61:2-61:43)
            defineAttr($$openClass,'openType',function(){
              return FreeClass(this);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:OpenType$meta$declaration},$cont:OpenClass,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$at','openType']};});
            
            $$openClass.getParameterDeclaration=function (name$15){
      var pd=this.parameterDeclarations;
      for (var i=0; i < pd.length; i++) {
        if (name$6.equals(pd[i].name))return pd[i];
      }
      return null;
            };
            $$openClass.getParameterDeclaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:FunctionOrValueDeclaration$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$}}],$cont:OpenClass,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$m','getParameterDeclaration']};};
            
            //AttributeDeclaration superclassDeclaration at X (68:2-68:86)
            defineAttr($$openClass,'extendedType',function(){
              var sc = this.tipo.$$metamodel$$['super'];
              if (sc === undefined)return null;
              var mm = sc.t.$$metamodel$$;
              if (typeof(mm)==='function') {
                mm = mm();
                sc.t.$$metamodel$$=mm;
              }
              var fc=FreeClass(OpenClass(getModules$meta().find(mm.mod['$mod-name'],mm.mod['$mod-version']).findPackage(mm.d[0]), sc.t));
              if (sc.a)fc.declaration._targs=sc.a;
              return fc;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:OpenClassType$meta$declaration}]},$cont:OpenClass,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$at','extendedType']};});
            
            //AttributeDeclaration interfaceDeclarations at X (69:2-69:89)
            defineAttr($$openClass,'satisfiedTypes',function(){
              var ints = this.tipo.$$metamodel$$['satisfies'];
              if (ints && ints.length) {
                var rv = [];
                for (var i=0; i < ints.length; i++) {
                  var ifc = ints[i];
                  var mm = ifc.t.$$metamodel$$;
                  if (typeof(mm)==='function') {
                    mm = mm();
                    ifc.t.$$metamodel$$=mm;
                  }
                  var fi=FreeInterface(OpenInterface(getModules$meta().find(mm.mod['$mod-name'],mm.mod['$mod-version']).findPackage(mm.d[0]), ifc.t));
                  if (ifc.a)fi.declaration._targs=ifc.a;
                  rv.push(fi);
                }
                return rv.reifyCeylonType({Absent:{t:Null},Element:{t:OpenInterfaceType$meta$declaration}});
              }
              return getEmpty();
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:OpenInterfaceType$meta$declaration}}},$cont:OpenClass,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$at','satisfiedTypes']};});
            defineAttr($$openClass,'name',function(){return this.name_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenClass,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$at','name']};});
            defineAttr($$openClass,'containingPackage',function(){return this._pkg;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Package$meta$declaration},$cont:OpenClass,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$at','containingPackage']};});
            defineAttr($$openClass,'containingModule',function(){return this._pkg.container;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Module$meta$declaration},$cont:OpenClass,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$at','containingModule']};});
            defineAttr($$openClass,'toplevel',function(){return this.toplevel_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:OpenClass,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ClassDeclaration','$at','toplevel']};});

    defineAttr($$openClass,'qualifiedName',function(){
      return String$($qname(this.tipo));
    },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenClass,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Declaration','$at','qualifiedName']};});

      $$openClass.equals=function(other) {
        return isOfType(other, {t:OpenClass}) && other.tipo===this.tipo;
      }
    })(OpenClass.$$.prototype);
  }
  return OpenClass;
}
exports.$init$OpenClass=$init$OpenClass;
$init$OpenClass();

//ClassDefinition OpenInterface at X (72:0-92:0)
function OpenInterface(pkg, meta, that) {
    $init$OpenInterface();
    if (that===undefined)that=new OpenInterface.$$;
    that._pkg = pkg;
    var _mm=meta.$$metamodel$$;
    if (_mm === undefined) {
      //it's a metamodel
      that.meta=meta;
      that.tipo=_findTypeFromModel(pkg,meta);
      _mm = that.tipo.$$metamodel$$;
      if (typeof(_mm)==='function') {
        _mm=_mm();
        that.tipo.$$metamodel$$=_mm;
      }
    } else {
      //it's a type
      that.tipo = meta;
      if (typeof(_mm)==='function') {
        _mm=_mm();
        meta.$$metamodel$$=_mm;
      }
      that.meta = get_model(_mm);
    }
    that.name_=_mm.d[_mm.d.length-1];
    that.toplevel_=_mm.$cont === undefined;
    InterfaceDeclaration$meta$declaration(that);
    return that;
}
OpenInterface.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:InterfaceDeclaration$meta$declaration}],d:['ceylon.language.meta.declaration','InterfaceDeclaration']};};
function $init$OpenInterface(){
  if (OpenInterface.$$===undefined){
    initTypeProto(OpenInterface,'ceylon.language.meta.declaration::OpenInterface',Basic,InterfaceDeclaration$meta$declaration);
    (function($$openInterface){
      $$openInterface.equals=function(other) {
        return isOfType(other, {t:OpenInterface}) && other.tipo==this.tipo;
      }
$$openInterface.memberInterfaceApply=function(cont,targs,$mptypes){
  var mm=this.tipo.$$metamodel$$;
  if (cont!==getNothingType$meta$model() && !extendsType({t:cont.tipo},{t:mm.$cont}))
    throw IncompatibleTypeException$meta$model("Incompatible Container specified");
  var _t={t:this.tipo};
  validate$typeparams(_t,mm.$tp,targs);
  var rv=AppliedMemberInterface(this.tipo,{Container:{t:mm.$cont},Type:_t});
  if (_t.a)rv.$targs=_t.a;
  return rv;
}
$$openInterface.interfaceApply=function(targs,$mptypes) {
  return this.$apply(targs,$mptypes);
}
            
defineAttr($$openInterface,'string',function(){
  return String$("interface " + this.qualifiedName);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenInterface,$an:function(){return[shared(),actual()];},d:['ceylon.language','Object']};}); 
           
            defineAttr($$openInterface,'openType',function(){
              return FreeInterface(this);
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:OpenType$meta$declaration},$cont:OpenInterface,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','InterfaceDeclaration','$at','openType']};});
            defineAttr($$openInterface,'extendedType',function(){
              var sc = this.tipo.$$metamodel$$['super'];
              if (sc === undefined)return null;
              var mm = sc.t.$$metamodel$$;
              if (typeof(mm)==='function') {
                mm = mm();
                sc.t.$$metamodel$$=mm;
              }
              return FreeClass(OpenClass(getModules$meta().find(mm.mod['$mod-name'],mm.mod['$mod-version']).findPackage(mm.d[0]), sc.t));
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:OpenClasType$meta$declaration}]},$cont:OpenInterface,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','InterfaceDeclaration','$at','extendedType']};});
            
            //AttributeDeclaration interfaceDeclarations at X (91:2-91:89)
            defineAttr($$openInterface,'satisfiedTypes',function(){
              var ints = this.tipo.$$metamodel$$['satisfies'];
              if (ints && ints.length) {
                var rv = [];
                for (var i=0; i < ints.length; i++) {
                  var ifc = ints[i].t;
                  var mm = ifc.$$metamodel$$;
                  if (typeof(mm)==='function') {
                    mm = mm();
                    ifc.$$metamodel$$=mm;
                  }
                  rv.push(FreeInterface(OpenInterface(getModules$meta().find(mm.mod['$mod-name'],mm.mod['$mod-version']).findPackage(mm.d[0]), ifc)));
                }
                return rv.reifyCeylonType({Absent:{t:Null},Element:{t:OpenInterfaceType$meta$declaration}});
              }
              return getEmpty();
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:OpenInterfaceType$meta$declaration}}},$cont:OpenInterface,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','InterfaceDeclaration','$at','satisfiedTypes']};});
            defineAttr($$openInterface,'name',function(){return this.name_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenInterface,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','InterfaceDeclaration','$at','name']};});
            defineAttr($$openInterface,'containingPackage',function(){return this._pkg;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Package$meta$declaration},$cont:OpenInterface,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','InterfaceDeclaration','$at','containingPackage']};});
            defineAttr($$openInterface,'containingModule',function(){return this._pkg.container;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Module$meta$declaration},$cont:OpenInterface,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','InterfaceDeclaration','$at','containingModule']};});
            defineAttr($$openInterface,'toplevel',function(){return this.toplevel_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:OpenInterface,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','InterfaceDeclaration','$at','toplevel']};});

    defineAttr($$openInterface,'qualifiedName',function(){
      return String$($qname(this.tipo));
    },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenInterface,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Declaration','$at','qualifiedName']};});
        })(OpenInterface.$$.prototype);
    }
    return OpenInterface;
}
exports.$init$OpenInterface=$init$OpenInterface;
$init$OpenInterface();

function OpenAlias(alias, $$openAlias){
  $init$OpenAlias();
  if ($$openAlias===undefined)$$openAlias=new OpenAlias.$$;
  if (typeof(alias)==='function')alias=alias();
  $$openAlias._alias = alias;
  //Get model from path
  var mm=alias.$$metamodel$$;
  if (typeof(mm)==='function'){
    mm=mm(); alias.$$metamodel$$=mm;
  }
  $$openAlias.meta=get_model(mm);
  AliasDeclaration$meta$declaration($$openAlias);
  return $$openAlias;
}
OpenAlias.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:AliasDeclaration$meta$declaration}],d:['ceylon.language.meta.declaration','OpenAlias']};};
function $init$OpenAlias(){
  if (OpenAlias.$$===undefined){
    initTypeProto(OpenAlias,'OpenAlias',Basic,AliasDeclaration$meta$declaration);
    (function($$openAlias){

      defineAttr($$openAlias,'extendedType',function(){
        return _openTypeFromTarg(this._alias);
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:OpenType$meta$declaration},$cont:OpenAlias,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','AliasDeclaration','$at','extendedType']};});
      defineAttr($$openAlias,'qualifiedName',function(){
        return String$($qname(this._alias.$$metamodel$$));
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenAlias,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','AliasDeclaration','$at','qualifiedName']};});
      defineAttr($$openAlias,'toplevel',function(){
        return this._alias.$cont===undefined;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean},$cont:OpenAlias,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','AliasDeclaration','$at','toplevel']};});
      defineAttr($$openAlias,'containingPackage',function(){
        throw Error("IMPL OpenAlias.containingPackage");
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Package$meta$declaration},$cont:OpenAlias,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','AliasDeclaration','$at','containingPackage']};});
      defineAttr($$openAlias,'containingModule',function(){
        throw Exception(String$("IMPL OpenAlias.containingModule"));
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Module$meta$declaration},$cont:OpenAlias,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','AliasDeclaration','$at','containingModule']};});
      defineAttr($$openAlias,'container',function(){
        var cont=this.$$targs$$.Container;
        if (cont===undefined) {
          cont=this._alias.$$metamodel$$.$cont;
          if (cont)cont={t:cont};
        }
        if (cont) {
          return typeLiteral$meta({Type:cont});
        }
        return null;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:NestableDeclaration$meta$declaration},{t:Package$meta$declaration}]},$cont:OpenAlias,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','AliasDeclaration','$at','container']};});
      defineAttr($$openAlias,'openType',function(){
        return this.extendedType;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:OpenType$meta$declaration},$cont:OpenAlias,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','AliasDeclaration','$at','openType']};});
      defineAttr($$openAlias,'typeParameterDeclarations',function(){
        var tps=this._alias.$$metamodel$$.$tp;
        if (tps) {
          var rv=[];
          for (var tp in tps) {
            rv.push(OpenTypeParam(this._alias, tp));
          }
          return rv.reifyCeylonType({Element:{t:TypeParameter$meta$declaration},Absent:{t:Null}});
        }
        return getEmpty();
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:TypeParameter$meta$declaration}}},$cont:OpenAlias,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','AliasDeclaration','$at','typeParameterDeclarations']};});
      $$openAlias.getTypeParameterDeclaration=function getTypeParameterDeclaration(name$2){
        var tp=this._alias.$$metamodel$$;
        tp=tp.$tp ? tp.$tp[name$2] : null;
        return tp ? OpenTypeParam(this._alias, name$2) : null;
      };$$openAlias.getTypeParameterDeclaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:TypeParameter$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:OpenAlias,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','AliasDeclaration','$m','getTypeParameterDeclaration']};};
      defineAttr($$openAlias,'name',function(){
        return String$(this._alias.$$metamodel$$.d[this._alias.$$metamodel$$.d.length-1]);
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenAlias,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','AliasDeclaration','$at','name']};});
      defineAttr($$openAlias,'string',function(){return StringBuilder().append(String$("alias ")).append(this.qualifiedName).string;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenAlias,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','AliasDeclaration','$at','string']};});
    })(OpenAlias.$$.prototype);
  }
  return OpenAlias;
}
exports.$init$OpenAlias=$init$OpenAlias;
$init$OpenAlias();

function OpenTypeParam(cont, nom, that){
  $init$OpenTypeParam();
  if (that===undefined)that=new OpenTypeParam.$$;
  that._cont=cont;
  that._name=nom;
  TypeParameter$meta$declaration(that);
  return that;
}
OpenTypeParam.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:TypeParameter$meta$declaration}],$an:function(){return[shared()];},d:['ceylon.language.meta.declaration','TypeParameter']};};
exports.OpenTypeParam=OpenTypeParam;
function $init$OpenTypeParam(){
  if (OpenTypeParam.$$===undefined){
    initTypeProto(OpenTypeParam,'ceylon.language.meta.declaration::OpenTypeParam',Basic,TypeParameter$meta$declaration);
    (function($$openTypeParam){
$$openTypeParam.equals=function(o) {
  return isOfType(o,{t:OpenTypeParam}) && this._name==o._name && this._cont==o._cont;
}
      //AttributeGetterDefinition container at caca.ceylon (7:4-7:94)
      defineAttr($$openTypeParam,'container',function(){return this._cont;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:NestableDeclaration$meta$declaration},$cont:OpenTypeParam,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','TypeParameter','$at','container']};});
      //AttributeGetterDefinition defaulted at caca.ceylon (8:4-8:82)
      defineAttr($$openTypeParam,'defaulted',function(){
        var tp=this._cont.$$metamodel$$.$tp[this._name];
        if (tp) {
          return tp['def'] !== undefined;
        }
        throw wrapexc(Exception(String$("TypeParameter.defaulted",23)),'8:38-8:80','caca.ceylon');
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean},$cont:OpenTypeParam,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','TypeParameter','$at','defaulted']};});
      //AttributeGetterDefinition defaultTypeArgument at caca.ceylon (9:4-9:104)
      defineAttr($$openTypeParam,'defaultTypeArgument',function(){
        var tp=this._cont.$$metamodel$$.$tp[this._name];
        if (typeof(tp.def)==='string') {
          return OpenTvar(OpenTypeParam(this._cont, tp.def));
        }
        return tp.def?_openTypeFromTarg(tp.def):null;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{ t:'u', l:[{t:Null},{t:OpenType$meta$declaration}]},$cont:OpenTypeParam,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','TypeParameter','$at','defaultTypeArgument']};});
      //AttributeGetterDefinition variance at caca.ceylon (10:4-10:81)
      defineAttr($$openTypeParam,'variance',function(){
        var tp=this._cont.$$metamodel$$.$tp[this._name];
        if (tp) {
          if (tp['var']==='out')return getCovariant$meta$declaration();
          if (tp['var']=== 'in')return getContravariant$meta$declaration();
          return getInvariant$meta$declaration();
        }
        throw wrapexc(Exception(String$("TypeParameter.variance",22)),'10:38-10:79','caca.ceylon');
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Variance$meta$declaration},$cont:OpenTypeParam,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','TypeParameter','$at','variance']};});
      //AttributeGetterDefinition satisfiedTypes at caca.ceylon (11:4-11:95)
      defineAttr($$openTypeParam,'satisfiedTypes',function(){
        var tp=this._cont.$$metamodel$$.$tp[this._name];
        if (tp.satisfies) {
          var a=[];
          for (var i=0;i<tp.satisfies.length;i++) {
            a.push(_openTypeFromTarg(tp.satisfies[i]));
          }
          return a.reifyCeylonType({Absent:{t:Null},Element:{t:OpenType$meta$declaration}});
        }
        return getEmpty();
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:OpenType$meta$declaration}}},$cont:OpenTypeParam,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','TypeParameter','$at','satisfiedTypes']};});
      //AttributeGetterDefinition caseTypes at caca.ceylon (12:4-12:85)
      defineAttr($$openTypeParam,'caseTypes',function(){
        var tp=this._cont.$$metamodel$$.$tp[this._name];
        if (tp.of) {
          var a=[];
          for (var i=0;i<tp.of.length;i++) {
            a.push(_openTypeFromTarg(tp.of[i]));
          }
          return a.reifyCeylonType({Absent:{t:Null},Element:{t:OpenType$meta$declaration}});
        }
        return getEmpty();
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Sequential,a:{Element:{t:OpenType$meta$declaration}}},$cont:OpenTypeParam,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','TypeParameter','$at','caseTypes']};});
      //AttributeGetterDefinition name at caca.ceylon (14:4-14:71)
      defineAttr($$openTypeParam,'name',function(){return String$(this._name);},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenTypeParam,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Declaration','$at','name']};});
      //AttributeGetterDefinition qualifiedName at caca.ceylon (15:4-15:81)
      defineAttr($$openTypeParam,'qualifiedName',function(){
        return String$($qname(this._cont)+"."+this._name);
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenTypeParam,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Declaration','$at','qualifiedName']};});
defineAttr($$openTypeParam,'hash',function(){return this.string.hash;},undefined,function(){return {mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','Object','$at','hash']};});
      defineAttr($$openTypeParam,'string',function(){return String$("given " + this.qualifiedName);},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenTypeParam,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','Declaration','$at','string']};});
      $$openTypeParam.equals=function(o) {
        return isOfType(o,{t:OpenTypeParam}) && o._cont==this._cont && o._name==this._name;
      }
    })(OpenTypeParam.$$.prototype);
  }
  return OpenTypeParam;
}
exports.$init$OpenTypeParam=$init$OpenTypeParam;
$init$OpenTypeParam();

function OpenTvar(p$2, $$openTvar){
    $init$OpenTvar();
    if ($$openTvar===undefined)$$openTvar=new OpenTvar.$$;
    $$openTvar.p$2=p$2;
    OpenTypeVariable$meta$declaration($$openTvar);
    $$openTvar.$prop$getDeclaration={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:TypeParameter$meta$declaration},$cont:OpenTvar,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','OpenTvar','$at','declaration']};}};
    $$openTvar.$prop$getDeclaration.get=function(){return declaration};
    return $$openTvar;
}
OpenTvar.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:OpenTypeVariable$meta$declaration}],$an:function(){return[shared()];},d:['ceylon.language.meta.declaration','OpenTvar']};};
exports.OpenTvar=OpenTvar;
function $init$OpenTvar(){
  if (OpenTvar.$$===undefined){
    initTypeProto(OpenTvar,'ceylon.language.meta.declaration::OpenTvar',Basic,$init$OpenTypeVariable$meta$declaration());
    (function($$openTvar){
      defineAttr($$openTvar,'string',function(){return this.p$2.qualifiedName;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:OpenTvar,$an:function(){return[shared(),actual()];},d:['ceylon.language','Object','$at','string']};});
            defineAttr($$openTvar,'declaration',function(){
                return this.p$2;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:TypeParameter$meta$declaration},$cont:OpenTvar,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','OpenTypeVariable','$at','declaration']};});
$$openTvar.equals=function(o) {
  return isOfType(o, {t:OpenTvar}) && this.p$2.equals(o.p$2);
}
        })(OpenTvar.$$.prototype);
    }
    return OpenTvar;
}
exports.$init$OpenTvar=$init$OpenTvar;
$init$OpenTvar();

function FreeUnion(ts$2, $$freeUnion){
    $init$FreeUnion();
    if ($$freeUnion===undefined)$$freeUnion=new FreeUnion.$$;
    $$freeUnion.ts$2_=ts$2;
    OpenUnion$meta$declaration($$freeUnion);
    $$freeUnion.$prop$getCaseTypes={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:{t:OpenType$meta$declaration}}},$cont:FreeUnion,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','OpenUnion','$at','caseTypes']};}};
    $$freeUnion.$prop$getCaseTypes.get=function(){return caseTypes};
    return $$freeUnion;
}
FreeUnion.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:OpenUnion$meta$declaration}],$an:function(){return[shared()];},d:['ceylon.language.meta.declaration','OpenUnion']};};
exports.FreeUnion=FreeUnion;
function $init$FreeUnion(){
  if (FreeUnion.$$===undefined){
    initTypeProto(FreeUnion,'ceylon.language.meta.declaration::FreeUnion',Basic,OpenUnion$meta$declaration);
    (function($$freeUnion){
      $$freeUnion.equals=function(u) {
        if(isOfType(u,{t:FreeUnion})) {
          var mine=this.caseTypes;
          var his=u.caseTypes;
          if (mine.size==his.size) {
            for (var i=0;i<mine.length;i++) {
              if (!his.contains(mine[i]))return false;
            }
            return true;
          }
        }
        return false;
      }
defineAttr($$freeUnion,'string',function(){
  var s="";
  var first=true;
  for (var i=0;i<this.ts$2.size;i++) {
    if (first)first=false;else s+="|";
    s+=this.ts$2.$get(i).string;
  }
  return String$(s);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Object','$at','string']};});
defineAttr($$freeUnion,'hash',function(){
  var s=this.ts$2.size;
  for (var i=0;i<this.ts$2.size;i++) {
    s+=this.ts$2.$get(i).string.hash;
  }
  return s;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','Object','$at','hash']};});
            defineAttr($$freeUnion,'caseTypes',function(){
                var $$freeUnion=this;
                return $$freeUnion.ts$2;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:{t:OpenType$meta$declaration}}},$cont:FreeUnion,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','OpenUnion','$at','caseTypes']};});
            defineAttr($$freeUnion,'ts$2',function(){return this.ts$2_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:{t:OpenType$meta$declaration}}},$cont:FreeUnion,d:['ceylon.language.meta.declaration','OpenUnion','$at','ts']};});
        })(FreeUnion.$$.prototype);
    }
    return FreeUnion;
}
exports.$init$FreeUnion=$init$FreeUnion;
$init$FreeUnion();
function FreeIntersection(ts$3, $$freeIntersection){
    $init$FreeIntersection();
    if ($$freeIntersection===undefined)$$freeIntersection=new FreeIntersection.$$;
    $$freeIntersection.ts$3_=ts$3;
    OpenIntersection$meta$declaration($$freeIntersection);
    $$freeIntersection.$prop$getSatisfiedTypes={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:{t:OpenType$meta$declaration}}},$cont:FreeIntersection,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','OpenIntersection','$at','satisfiedTypes']};}};
    $$freeIntersection.$prop$getSatisfiedTypes.get=function(){return satisfiedTypes};
    return $$freeIntersection;
}
FreeIntersection.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},satisfies:[{t:OpenIntersection$meta$declaration}],$an:function(){return[shared()];},d:['ceylon.language.meta.declaration','OpenIntersection']};};
exports.FreeIntersection=FreeIntersection;
function $init$FreeIntersection(){
  if (FreeIntersection.$$===undefined){
    initTypeProto(FreeIntersection,'ceylon.language.meta.declaration::FreeIntersection',Basic,OpenIntersection$meta$declaration);
    (function($$freeIntersection){

$$freeIntersection.equals=function(u) {
  if(isOfType(u,{t:FreeIntersection})) {
    var mine=this.satisfiedTypes;
    var his=u.satisfiedTypes;
    if (mine.size==his.size) {
      for (var i=0;i<mine.length;i++) {
        if (!his.contains(mine[i])){
return false;
}
      }
return true;
    }
  }
return false;
}
defineAttr($$freeIntersection,'string',function(){
  var s="";
  var first=true;
  for (var i=0;i<this.ts$3.size;i++) {
    if (first)first=false;else s+="&";
    s+=this.ts$3.$get(i).string;
  }
  return String$(s);
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},d:['ceylon.language','Object','$at','string']};});
defineAttr($$freeIntersection,'hash',function(){
  var s=this.ts$3.size;
  for (var i=0;i<this.ts$3.size;i++) {
    s+=this.ts$3.$get(i).string.hash;
  }
  return s;
},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Integer},d:['ceylon.language','Object','$at','hash']};});

            defineAttr($$freeIntersection,'satisfiedTypes',function(){
                var $$freeIntersection=this;
                return $$freeIntersection.ts$3;
            },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:{t:OpenType$meta$declaration}}},$cont:FreeIntersection,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','OpenIntersection','$at','satisfiedTypes']};});
            defineAttr($$freeIntersection,'ts$3',function(){return this.ts$3_;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:List,a:{Element:{t:OpenType$meta$declaration}}},$cont:FreeIntersection,d:['ceylon.language.meta.declaration','OpenIntersection','$at','ts']};});
        })(FreeIntersection.$$.prototype);
    }
    return FreeIntersection;
}
exports.$init$FreeIntersection=$init$FreeIntersection;
$init$FreeIntersection();

function FunParamDecl(cont,param,$$funParamDecl){
  $init$FunParamDecl();
  if ($$funParamDecl===undefined)$$funParamDecl=new FunParamDecl.$$;
  FunctionDeclaration$meta$declaration($$funParamDecl);
  $$funParamDecl.cont=cont;
  $$funParamDecl.param=param;
  $$funParamDecl.tipo={$$metamodel$$:{$cont:cont.tipo,$t:param.$t,$ps:param.$ps,$mt:'prm',d:cont.tipo.$$metamodel$$.d,$an:param.$an}};

  $$funParamDecl.$prop$getParameter={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','parameter']};}};
  $$funParamDecl.$prop$getParameter.get=function(){return true;};
  $$funParamDecl.$prop$getAnnotation={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','annotation']};}};
  $$funParamDecl.$prop$getAnnotation.get=function(){return false;};
  $$funParamDecl.$prop$getShared={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','shared']};}};
  $$funParamDecl.$prop$getShared.get=function(){return false;};
  $$funParamDecl.$prop$getToplevel={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','toplevel']};}};
  $$funParamDecl.$prop$getToplevel.get=function(){return false;};
  $$funParamDecl.$prop$getFormal={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','formal']};}};
  $$funParamDecl.$prop$getFormal.get=function(){return false;};
  $$funParamDecl.$prop$getDefault={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','default']};}};
  $$funParamDecl.$prop$getDefault.get=function(){return false};
  $$funParamDecl.$prop$getActual={$$metamodel$$:function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','actual']};}};
  $$funParamDecl.$prop$getActual.get=function(){return false;};
  return $$funParamDecl;
}
FunParamDecl.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],satisfies:[{t:FunctionDeclaration$meta$declaration}],d:['ceylon.language.meta.declaration','FunParamDecl']};};
function $init$FunParamDecl(){
  if (FunParamDecl.$$===undefined){
    initTypeProto(FunParamDecl,'ceylon.language.meta.declaration::FunParamDecl',Basic,FunctionDeclaration$meta$declaration);
    (function($$funParamDecl){

      defineAttr($$funParamDecl,'parameter',function(){return true;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','parameter']};});
      
      //AttributeGetterDef defaulted at caca.ceylon (8:2-8:71)
      defineAttr($$funParamDecl,'defaulted',function(){
        return this.param.$def!==undefined;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','defaulted']};});
      //AttributeGetterDef variadic at caca.ceylon (9:2-9:69)
      defineAttr($$funParamDecl,'variadic',function(){
        return this.param.seq!==undefined;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','variadic']};});
      //AttributeGetterDef container at caca.ceylon (11:2-11:91)
      defineAttr($$funParamDecl,'container',function(){
        return this.cont;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Package$meta$declaration},{t:NestableDeclaration$meta$declaration}]},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','container']};});
      //AttributeGetterDef containingPackage at caca.ceylon (12:2-12:87)
      defineAttr($$funParamDecl,'containingPackage',function(){
        return this.cont.containingPackage;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Package$meta$declaration},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','containingPackage']};});
      //AttributeGetterDef containingModule at caca.ceylon (13:2-13:84)
      defineAttr($$funParamDecl,'containingModule',function(){
        return this.cont.containingModule;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Module$meta$declaration},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','containingModule']};});
      //AttributeGetterDef openType at caca.ceylon (14:2-14:70)
      defineAttr($$funParamDecl,'openType',function(){
        var t = this.param.$t;
        if (typeof(t)==='string')return OpenTvar(OpenTypeParam(this.cont,t));
        return _openTypeFromTarg(t);
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:OpenType$meta$declaration},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','openType']};});
      //AttributeDecl annotation at caca.ceylon (15:2-15:40)
      defineAttr($$funParamDecl,'annotation',function(){return false;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','annotation']};});
      defineAttr($$funParamDecl,'shared',function(){return false;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','shared']};});
      defineAttr($$funParamDecl,'toplevel',function(){return false;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','toplevel']};});
      defineAttr($$funParamDecl,'formal',function(){return false;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','formal']};});
      defineAttr($$funParamDecl,'$default',function(){return false;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','default']};});
      defineAttr($$funParamDecl,'actual',function(){return false;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','actual']};});
      defineAttr($$funParamDecl,'qualifiedName',function(){
        return String$($qname(cont.tipo.$$metamodel$$)+"."+this.param.$nm);
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','qualifiedName']};});
      defineAttr($$funParamDecl,'name',function(){
        return String$(this.param.$nm);
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$at','name']};});
      $$funParamDecl.getParameterDeclaration=function getParameterDeclaration(name$10){
      var pd=this.parameterDeclarations;
      for (var i=0; i < pd.length; i++) {
        if (name$6.equals(pd[i].name))return pd[i];
      }
      return null;
      };$$funParamDecl.getParameterDeclaration.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Null},{t:FunctionOrValueDeclaration$meta$declaration}]},$ps:[{$nm:'name',$mt:'prm',$t:{t:String$},$an:function(){return[];}}],$cont:FunParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$m','getParameterDeclaration']};};
      
      //MethodDef apply at caca.ceylon (31:2-32:74)
      $$funParamDecl.$apply=function $apply(typeArguments$11,$$$mptypes){
          if(typeArguments$11===undefined){typeArguments$11=getEmpty();}
          throw Exception(String$("IMPL FunParamDecl.apply"));
      };$$funParamDecl.$apply.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Function$meta$model,a:{Arguments:'Arguments',Type:'Return'}},$ps:[{$nm:'typeArguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:FunParamDecl,$tp:{Return:{'def':{t:Anything}},Arguments:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$m','apply']};};
      
      //MethodDef memberApply at caca.ceylon (33:2-34:80)
      $$funParamDecl.memberApply=function memberApply(containerType$12,typeArguments$13,$$$mptypes){
          if(typeArguments$13===undefined){typeArguments$13=getEmpty();}
          throw Exception(String$("IMPL FunParamDecl.memberApply"));
      };$$funParamDecl.memberApply.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Method$meta$model,a:{Arguments:'Arguments',Type:'Return',Container:'Container'}},$ps:[{$nm:'containerType',$mt:'prm',$t:{t:Type$meta$model,a:{Type:'Container'}},$an:function(){return[];}},{$nm:'typeArguments',$mt:'prm',seq:1,$t:{t:Sequential,a:{Element:{t:Type$meta$model,a:{Type:{t:Anything}}}}},$an:function(){return[];}}],$cont:FunParamDecl,$tp:{Container:{'def':{t:Nothing}},Return:{'def':{t:Anything}},Arguments:{'satisfies':[{t:Sequential,a:{Element:{t:Anything}}}],'def':{t:Nothing}}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','FunctionDeclaration','$m','memberApply']};};
    })(FunParamDecl.$$.prototype);
  }
  return FunParamDecl;
}
exports.$init$FunParamDecl=$init$FunParamDecl;
$init$FunParamDecl();

function ValParamDecl(cont,param,$$valParamDecl){
  $init$ValParamDecl();
  if ($$valParamDecl===undefined)$$valParamDecl=new ValParamDecl.$$;
  ValueDeclaration$meta$declaration($$valParamDecl);
  $$valParamDecl.cont=cont;
  $$valParamDecl.param=param;
  $$valParamDecl.tipo={$$metamodel$$:{$cont:cont.tipo,$t:param.$t,$mt:'prm',d:cont.tipo.$$metamodel$$.d,$an:param.$an}};

  $$valParamDecl.$prop$getParameter.get=function(){return true;};
  $$valParamDecl.$prop$getShared.get=function(){return false;};
  $$valParamDecl.$prop$getToplevel.get=function(){return false;};
  $$valParamDecl.$prop$getFormal.get=function(){return false;};
  $$valParamDecl.$prop$getDefault.get=function(){return false;};
  $$valParamDecl.$prop$getActual.get=function(){return false;};
  return $$valParamDecl;
}
ValParamDecl.$$metamodel$$=function(){return{mod:$$METAMODEL$$,'super':{t:Basic},$ps:[],satisfies:[{t:ValueDeclaration$meta$declaration}],d:['ceylon.language.meta.declaration','ValParamDecl']};};
function $init$ValParamDecl(){
  if (ValParamDecl.$$===undefined){
    initTypeProto(ValParamDecl,'ceylon.language.meta.declaration::ValParamDecl',Basic,ValueDeclaration$meta$declaration);
    (function($$valParamDecl){

      defineAttr($$valParamDecl,'parameter',function(){return true;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ValParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','parameter']};});
      defineAttr($$valParamDecl,'defaulted',function(){
        return this.param.$def!==undefined;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ValParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','defaulted']};});
      defineAttr($$valParamDecl,'variadic',function(){
        return this.param.seq!==undefined;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ValParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','variadic']};});
      defineAttr($$valParamDecl,'variable',function(){
        return $findAnnotation(this.param,VariableAnnotation)!==null;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ValParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','variable']};});
      defineAttr($$valParamDecl,'container',function(){
        return this.cont;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:'u', l:[{t:Package$meta$declaration},{t:NestableDeclaration$meta$declaration}]},$cont:ValParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','container']};});
      defineAttr($$valParamDecl,'containingPackage',function(){
        return this.cont.containingPackage;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Package$meta$declaration},$cont:ValParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','containingPackage']};});
      defineAttr($$valParamDecl,'containingModule',function(){
        return this.cont.containingModule;
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Module$meta$declaration},$cont:ValParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','containingModule']};});
      defineAttr($$valParamDecl,'openType',function(){
        var t = this.param.$t;
        if (typeof(t)==='string')return OpenTvar(OpenTypeParam(this.cont,t));
        return _openTypeFromTarg(t);
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:OpenType$meta$declaration},$cont:ValParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','openType']};});
      defineAttr($$valParamDecl,'shared',function(){return false;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ValParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','shared']};});
      defineAttr($$valParamDecl,'toplevel',function(){return false;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ValParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','toplevel']};});
      defineAttr($$valParamDecl,'formal',function(){return false;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ValParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','formal']};});
      defineAttr($$valParamDecl,'$default',function(){return false;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ValParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','default']};});
      defineAttr($$valParamDecl,'actual',function(){return false;},undefined,function(){return{mod:$$METAMODEL$$,$t:{t:Boolean$},$cont:ValParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','actual']};});
      defineAttr($$valParamDecl,'qualifiedName',function(){
        return String$($qname(this.cont.tipo.$$metamodel$$)+"."+this.param.$nm);
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:ValParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','qualifiedName']};});
      defineAttr($$valParamDecl,'name',function(){
        return String$(this.param.$nm);
      },undefined,function(){return{mod:$$METAMODEL$$,$t:{t:String$},$cont:ValParamDecl,$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$at','name']};});
      //MethodDef apply at caca.ceylon (57:2-57:84)
      $$valParamDecl.$apply=function $apply($$$mptypes){
          var $$valParamDecl=this;
          throw Exception(String$("IMPL ValParamDecl.apply"));
      };$$valParamDecl.$apply.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Value$meta$model,a:{Type:'Type'}},$ps:[],$cont:ValParamDecl,$tp:{Type:{'def':{t:Anything}}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$m','apply']};};
      //MethodDef memberApply at caca.ceylon (58:2-58:166)
      $$valParamDecl.memberApply=function memberApply(containerType$20,$$$mptypes){
          var $$valParamDecl=this;
          throw Exception(String$("IMPL ValParamDecl.memberApply"));
      };$$valParamDecl.memberApply.$$metamodel$$=function(){return{mod:$$METAMODEL$$,$t:{t:Attribute$meta$model,a:{Type:'Type',Container:'Container'}},$ps:[{$nm:'containerType',$mt:'prm',$t:{t:Type$meta$model,a:{Type:'Container'}},$an:function(){return[];}}],$cont:ValParamDecl,$tp:{Container:{'def':{t:Nothing}},Type:{'def':{t:Anything}}},$an:function(){return[shared(),actual()];},d:['ceylon.language.meta.declaration','ValueDeclaration','$m','memberApply']};};
    })(ValParamDecl.$$.prototype);
  }
  return ValParamDecl;
}
exports.$init$ValParamDecl=$init$ValParamDecl;
$init$ValParamDecl();
//From a runtime metamodel, get the model definition by following the path into the module's model.
function get_model(mm) {
  var map=mm.mod;
  var path=mm.d;
  for (var i=0; i < path.length; i++) {
    map = map[path[i]];
  }
  return map;
}

function type$meta(x,$$targs$$) {
  if (x === null || $$targs$$.Type.t===Nothing) {
    return getNothingType$meta$model();
  }
  var mm=x.$$metamodel$$;
  if (typeof(mm)==='function') {
    mm=mm(); x.$$metamodel$$=mm;
  }
  var _t=$$targs$$.Type.t;
  if (mm===undefined) {
    if (x.getT$name && x.getT$all) {
      var mmm=x.getT$all()[x.getT$name()];
      if (mmm){mm=mmm.$$metamodel$$;_t=mmm;}
      if (typeof(mm)==='function') {
        mm=mm(); mmm.$$metamodel$$=mm;
      }
    }
  }
  if (mm===undefined&&x.reifyCeylonType)mm=Array$.$$metamodel$$;
  if (mm===undefined)throw Error("Cannot retrieve metamodel for " + x);
  if (mm.$t) { //it's a value
    if (typeof(x)==='function') { //It's a callable
      if (mm.$cont) {
        return AppliedMethod(x,undefined,{Type:mm.$t,Arguments:{t:Nothing}});
      }
      return AppliedFunction(x,{Type:mm.$t,Arguments:{t:Nothing}});
    }
    return AppliedClass(mm.$t.t, {Type:mm.$t,Arguments:{t:Nothing}});
  }
  var c;
  if ($$targs$$.Type.t==='T') {
    var rt=$retuple($$targs$$.Type);
    c=AppliedClass(Tuple,{Type:$$targs$$.Type, Arguments:{t:'T',l:[$$targs$$.Type.l[0],rt.Rest]}});
  } else {
    var _ta={Type:{t:x.getT$all()[x.getT$name()]}, Arguments:{t:Sequential,a:{Element:{t:Anything}}}};
    if (x.$$targs$$)_ta.Type.a=x.$$targs$$;
    if (x.$$outer) {
      _ta.Container={t:x.$$outer.getT$all()[x.$$outer.getT$name()]};
      if (x.$$outer.$$targs$$)_ta.Container.a=x.$$outer.$$targs$$;
    }
    c=(mm.$cont?AppliedMemberClass:AppliedClass)(_t, _ta);
  }
  if ($$targs$$.Type.a)c.$targs=$$targs$$.Type.a;
  return c;
}
type$meta.$$metamodel$$={$ps:[{t:Anything}],$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language.meta','type']};
exports.type$meta=type$meta;

function typeLiteral$meta($$targs$$) {
  if ($$targs$$ === undefined || $$targs$$.Type === undefined) {
    throw Exception("Missing type argument 'Type' " + /*require('util').inspect(*/$$targs$$);
  } else if ($$targs$$.Type.$$metamodel$$ == undefined) {
    //closed type
    var t = $$targs$$.Type.t
    if (t === undefined) {
      throw Exception("'Type' argument should be an open or closed type");
    } else if (t === 'u' || t === 'i') {
      return t === 'u' ? applyUnionType($$targs$$.Type) : applyIntersectionType($$targs$$.Type);
    } else if (t === 'T') {
      //TODO arguments
      var _tt=$retuple($$targs$$.Type);
      return AppliedClass(Tuple,{Type:$$targs$$.Type,Arguments:{t:'T',l:[_tt.a.First,_tt.a.Rest]}});
    } else if (t.$$metamodel$$ === undefined) {
      throw Exception("JS Interop not supported / incomplete metamodel for " + /*require('util').inspect(*/t);
    } else {
      var mm = t.$$metamodel$$;
      if (typeof(mm)==='function') {
        mm=mm();
        t.$$metamodel$$=mm;
      }
      var mdl = get_model(mm);
      if (mdl['$mt'] === 'cls') {
        //TODO tupleize Arguments
        var r=AppliedClass(t,{Type:$$targs$$.Type,Arguments:{t:Sequential,a:{Element:{t:Anything}}}});
        if ($$targs$$.Type.a)r.$targs=$$targs$$.Type.a;
        return r;
      } else if (mdl['$mt'] === 'ifc') {
        var r=AppliedInterface(t,$$targs$$);
        if ($$targs$$.Type.a)r.$targs=$$targs$$.Type.a;
        return r;
      } else if (mdl['$mt'] === 'mthd') {
        return AppliedFunction(t,{Type:$$targs$$.Type,Arguments:{t:Sequential,a:{Element:{t:Anything}}}});
      } else if (mdl['$mt'] === 'attr' || mdl['$mt'] === 'gttr' || mdl['$mt'] === 'obj') {
        return AppliedValue(undefined,t,{Container:{t:mm.$cont},Get:mm.$t,Set:mdl['var']?mm.$t:{t:Nothing}});
      } else {
        console.log("WTF is a metatype " + mdl['$mt'] + " on a closed type???????");
      }
      console.log("typeLiteral<" + t.getT$name() + "> (closed type)");
    }
  } else {
    //open type
    var t = $$targs$$.Type;
    var mm = t.$$metamodel$$;
    if (typeof(mm)==='function') {
      mm=mm();
      t.$$metamodel$$=mm;
    }
    var mdl = get_model(mm);
    //We need the module
    var _mod = getModules$meta().find(mm.mod['$mod-name'],mm.mod['$mod-version']);
    var _pkg = _mod.findPackage(mm.d[0]);
    if (mdl.$mt==='cls' || mdl.$mt==='obj') {
      return OpenClass(_pkg, t);
    } else if (mdl['$mt'] === 'ifc') {
      return OpenInterface(_pkg, t);
    } else if (mdl['$mt'] === 'mthd') {
      return OpenFunction(_pkg, t);
    } else if (mdl['$mt'] === 'attr' || mdl['$mt'] === 'gttr') {
      return OpenValue(_pkg, t);
    } else {
      console.log("WTF is a metatype " + mdl['$mt'] + " on an open type???????");
    }
    console.log("typeLiteral<" + t.getT$name() + "> (open type)");
  }
  throw Exception("typeLiteral UNIMPLEMENTED for " + /*require('util').inspect(*/$$targs$$);
}
typeLiteral$meta.$$metamodel$$={$ps:[],$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language.meta','typeLiteral']};
exports.typeLiteral$meta=typeLiteral$meta;

function pushTypes(list, types) {
  for (var i=0; i<types.length; i++) {
    var t = types[i];
    if (t.t === 'u') {
      list.push(applyUnionType(t, t.l));
    } else if (t.t === 'i') {
      list.push(applyIntersectionType(t, t.l));
    } else {
      list.push(typeLiteral$meta({Type:t}));
    }
  }
  return list;
}

function applyUnionType(ut) { //return AppliedUnionType
  var cases = [];
  pushTypes(cases, ut.l);
  return AppliedUnionType(ut, cases.reifyCeylonType({Absent:{t:Null},Element:{t:Type$meta$model}}), {Union:{t:Anything}});
}
function applyIntersectionType(it) { //return AppliedIntersectionType
  var sats = [];
  pushTypes(sats, it.l);
  return AppliedIntersectionType(it, sats.reifyCeylonType({Absent:{t:Null},Element:{t:Type$meta$model}}), {Union:{t:Anything}});
}
exports.$mod$ans$=function(){return[doc(String$("The Ceylon language module containing the core types \nreferred to in the language specification.",96)),by([String$("Gavin King",10),String$("Tom Bentley",11),String$("Tako Schotanus",14),String$("Stephane Epardaud",17),String$("Enrique Zamudio",15)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),license(String$("http://www.apache.org/licenses/LICENSE-2.0.html",47))];};
exports.$pkg$ans$ceylon$language=function(){return[doc(String$("The Ceylon language package.",28)),by([String$("Gavin King",10),String$("Tom Bentley",11),String$("Tako Schotanus",14),String$("Stephane Epardaud",17),String$("Enrique Zamudio",15)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];};
exports.$pkg$ans$ceylon$language$meta=function(){return[doc(String$("The Ceylon metamodel base package.\n\nThe Ceylon metamodel allows you to: \n\n* dynamically inspect modules, packages, functions, values and types, \n* invoke functions and class initialisers, or read and write values, and\n* inspect the annotations on program elements.\n\n### A little bit of terminology\n\nThere are a few concepts and terms in the Ceylon metamodel API that you should be familiar with:\n\n- A _declaration_ is the definition of a Ceylon construct, such as a module, package, value, function\n  or class. Declarations are singletons: there is only a single instance of a given class declaration,\n  for example. You can inspect declarations to get information about how they were defined by their\n  author. You cannot directly invoke function or class declarations, but you can _apply_ them to get\n  a _model_ that you can invoke.\n- A _model_ is a Ceylon definition that represents a declaration where all the type variables have\n  been bound to _closed type_ values. You can query models for their member models and you can directly\n  invoke models.\n- A _closed type_ is a type which does not contain any unbound type variables.\n- An _open type_ is a type which may contain unbound type variables.\n\nFor example, given the following Ceylon program:\n\n    shared abstract class MyList<T>() satisfies List<T>{}\n\nThe declaration of `MyList` represents the class declaration and contains the information that it is\n`abstract` and that it satisfies the `List<T>` open type. That type is open because it contains an\nunbound type variable `T`, which is not bound when we inspect the `MyList` class declaration.\n\nGiven an particular instance of `MyList`, we can query its (closed) type with the [[type]] function,\nand we obtain a closed type representing (for example) `MyList<Integer>`. Object instances necessarily\nhave a closed type at runtime, since in order to instantiate an object, all type arguments must be\nprovided and known during instantiation, so the type of an object instance at runtime is necessarily\na closed type: they cannot contain unbound type variables.\n\nClosed types that represent class or interfaces are also models. For example, the closed type of our\n`MyList<Integer>` instance is both a closed type and a class model: you can query its satisfied types\nand find that it satisfies `List<Integer>` closed type and model (as opposed to the class declaration\nof `MyList` which satisfies the `List<T>` open type). You can also invoke that model to obtain a new\ninstance of `MyList<Integer>`.\n\n### Model and declaration literals\n\nCeylon supports getting declaration values using either the declaration API or using declaration\nliterals:\n\n- <code>\\`module ceylon.file\\`</code> returns the [[Module|ceylon.language.meta.declaration::Module]] \n  declaration which corresponds to the `ceylon.file` module you imported in your module descriptor.\n- <code>\\`package ceylon.language.meta\\`</code> returns the [[Package|ceylon.language.meta.declaration::Package]]\n  declaration from your current module imports.\n- <code>\\`interface List\\`</code> returns the [[InterfaceDeclaration|ceylon.language.meta.declaration::InterfaceDeclaration]] \n  for the [[List|ceylon.language::List]] type.\n- <code>\\`class Integer\\`</code> returns the [[ClassDeclaration|ceylon.language.meta.declaration::ClassDeclaration]] \n  for the [[Integer|ceylon.language::Integer]] type.\n- <code>\\`function type\\`</code> returns the [[FunctionDeclaration|ceylon.language.meta.declaration::FunctionDeclaration]] \n  for the [[type]] function. Similarly <code>\\`function List.shorterThan\\`</code> for methods.\n- <code>\\`value modules\\`</code> returns the [[ValueDeclaration|ceylon.language.meta.declaration::ValueDeclaration]] \n  for the [[modules]] value. Similarly <code>\\`function List.size\\`</code> for attributes.\n- <code>\\`alias AliasName\\`</code> returns the [[AliasDeclaration|ceylon.language.meta.declaration::AliasDeclaration]]\n  for the `AliasName` type alias. \n- <code>\\`given T\\`</code> returns the [[TypeParameter|ceylon.language.meta.declaration::TypeParameter]] \n  for the `T` type parameter.\n\nNote that declaration literals cannot have type arguments specified on types or methods, as declarations are not types.\n\nYou can also get access to closed types and model using either the model API or using literals: \n\n- <code>\\`List&lt;Integer>\\`</code> returns the [[Interface|ceylon.language.meta.model::Interface]] model and \n  closed type for the [[List|ceylon.language::List]] type applied with the [[Integer|ceylon.language::Integer]] type argument.\n- <code>\\`Integer\\`</code> returns the [[Class|ceylon.language.meta.model::Class]] model and closed type \n  for the [[Integer|ceylon.language::Integer]] type.\n- <code>\\`type&lt;Integer>\\`</code> returns the [[Function|ceylon.language.meta.model::Function]] model \n  for the [[type]] function applied with the [[Integer|ceylon.language::Integer]] type argument.\n  Similarly <code>\\`List&lt;Integer>.shorterThan\\`</code> for method models.\n- <code>\\`modules\\`</code> returns the [[Value|ceylon.language.meta.model::Value]] model \n  for the [[modules]] value. Similarly <code>\\`List&lt;Integer>.size\\`</code> for attribute models.\n- <code>\\`A & B\\`</code> returns a [[IntersectionType|ceylon.language.meta.model::IntersectionType]]\n  for the `A & B` intersection type.\n- <code>\\`A | B\\`</code> returns a [[UnionType|ceylon.language.meta.model::UnionType]]\n  for the `A | B` union type.\n- <code>\\`T\\`</code> returns a [[Type|ceylon.language.meta.model::Type]] representing the runtime type \n  argument value for the `T` type parameter.\n\nNotice that all model and close type literals must be applied with all required type arguments.\n\n### Accessing the metamodel using the API\n\nAside from declaration and model literals there are several ways you can start using the metamodel API:\n\n- The [[modules]] object contains a list of all currently loaded [[Module|ceylon.language.meta.declaration::Module]]\n  declarations. Note that these contain even modules you did not import as it contains all transitive\n  dependencies, and may contain multiple different versions of the same module.\n- The [[type]] function will return the closed type of the given instance, which can only be a\n  [[ClassModel|ceylon.language.meta.model::ClassModel]] since only classes can be instantiated.\n- The [[typeLiteral]] function is the functional equivalent to closed type literals: it turns a type argument\n  value into a metamodel closed type.\n- The [declaration](declaration/index.html) package contains all the declaration and open types.\n- The [model](model/index.html) package contains all the model and closed types.\n\n### Inspecting annotations\n\nConstrained annotations can be inspected using the [[annotations]] \nfunction, like this:\n\n    // Does the process declaration have the Shared annotation?\n    value isShared = annotations(`Shared`, `value process`) exists;\n\nor the related [[optionalAnnotation]] and [[sequencedAnnotations]] functions.\n\nNote that annotations are queried for via their \n[[ceylon.language::Annotation]] type, \nnot by the annotation constructor which was used to annotate \nthe program element.\n",7137)),by([String$("Gavin King",10),String$("Stephane Epardaud",17)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];};
exports.$pkg$ans$ceylon$language$meta$model=function(){return[doc(String$("The Ceylon metamodel closed type and model package.\n\nAs described in the [ceylon.language.meta](../index.html) documentation, this package contains all\nthe types that represent Ceylon closed types and models.\n\n### Usage example\n\nThe following code will list all the value declarations in the `ceylon.language` package and print their\ncurrent value:\n\n    Package languagePackage = `package ceylon.language`;\n    ValueDeclaration[] valueDeclarations = languagePackage.members<ValueDeclaration>();\n    Value<Anything>[] valueModels = valueDeclarations*.apply<Anything>();\n    for(val in valueModels){\n        // skip the nothing value which cannot be read\n        if(val.type != `Nothing`){\n            print(val.get());\n        }\n    }\n\nThe following code will iterate all the class declarations in the `ceylon.language` package that\nare not abstract, anonymous or annotations, and that have no type parameters nor initialiser\nparameters. For each matching class, we will apply it to get a class model which we can then\nuse to instantiate the class and display its instance:\n\n    for(decl in `package ceylon.language`.members<ClassDeclaration>()){\n        if(!decl.abstract \n                && !decl.anonymous \n                && !decl.annotation\n                && decl.parameterDeclarations.empty\n                && decl.typeParameterDeclarations.empty){\n            Class<Object,[]> classModel = decl.classApply<Object,[]>();\n            Object instance = classModel();\n            print(\"Instance of ``decl.name`` is: ``instance``\");\n        }\n    }\n",1552)),by([String$("Gavin King",10),String$("Stephane Epardaud",17)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];};
exports.$pkg$ans$ceylon$language$meta$declaration=function(){return[doc(String$("The Ceylon metamodel open type and declaration package.\n\nAs described in the [ceylon.language.meta](../index.html) documentation, this package contains all\nthe types that represent Ceylon declarations and open types.\n\n### Usage example\n\nThe following code will list all the classes in the `ceylon.language` package and print their\nextended type:\n\n    for(decl in `package ceylon.language`.members<ClassDeclaration>()){\n        if(exists extendedType = decl.extendedType){\n            print(\"Class ``decl.name`` extends: ``extendedType``\");\n        }else{\n            print(\"Class ``decl.name`` does not extend anything\");\n        }\n    }\n\nThe following code will iterate all the class declarations in the `ceylon.language` package that\nare not abstract, anonymous or annotations, and that have no type parameters nor initialiser\nparameters. For each matching class, we will apply it to get a class model which we can then\nuse to instantiate the class and display its instance:\n\n    for(decl in `package ceylon.language`.members<ClassDeclaration>()){\n        if(!decl.abstract \n                && !decl.anonymous \n                && !decl.annotation\n                && decl.parameterDeclarations.empty\n                && decl.typeParameterDeclarations.empty){\n            Class<Object,[]> classModel = decl.classApply<Object,[]>();\n            Object instance = classModel();\n            print(\"Instance of ``decl.name`` is: ``instance``\");\n        }\n    }\n",1456)),by([String$("Gavin King",10),String$("Stephane Epardaud",17)].reifyCeylonType({Absent:{t:Null},Element:{t:String$}})),shared()];};
//Ends compiled from Ceylon sources
function NativeException(e) {
var that = new NativeException.$$;
var msg;
if (typeof e === 'string') {
msg = String$(e);
} else if (e) {
msg = String$(e.toString());
} else {
msg = String$("Native JavaScript Exception",27);
}
Exception(msg,null,that);
return that;
}
initTypeProto(NativeException, 'ceylon.language::NativeException', $init$Exception());
NativeException.$$metamodel$$=function(){return{$nm:'NativeException',$mt:'cls',$ps:[{t:Exception}],$an:function(){return[shared()];},mod:$$METAMODEL$$,d:['ceylon.language','Exception']};}
exports.Identifiable=Identifiable;
exports.identityHash=$identityHash;
exports.Object=Object$;
exports.Anything=Anything;
exports.Null=Null;
exports.Nothing=Nothing;
exports.Boolean=Boolean$;
exports.Comparison=Comparison;
exports.getNull=getNull;
exports.getTrue=getTrue;
exports.getFalse=getFalse;
exports.NativeException=NativeException;
});
}(typeof define==='function' && define.amd ?
define : function (factory) {
if (typeof exports!=='undefined') {
factory(require, exports, module);
} else {
throw "no module loader";
}
}));
